﻿// JScript File
var gmapsApiLoaded = false;
function beginLoadGMapsAPI(callback) {
	gmapsApiLoaded = true;
	google.load("maps", "2", { "callback": callback });
}

function afterLoadMapsAPI() {
	gmapsApiLoaded = true;

	baseIcon = new GIcon();
	baseIcon.shadow = "http://www.google.com/mapfiles/shadow50.png";
	baseIcon.iconSize = new GSize(20, 34);
	baseIcon.shadowSize = new GSize(37, 34);
	baseIcon.iconAnchor = new GPoint(9, 34);
	baseIcon.infoWindowAnchor = new GPoint(9, 2);
	baseIcon.infoShadowAnchor = new GPoint(18, 25);


	base1Icon = new GIcon();
	base1Icon.shadow = "http://www.google.com/mapfiles/shadow50.png";
	base1Icon.iconSize = new GSize(40, 40);
	base1Icon.shadowSize = new GSize(65, 40);
	base1Icon.iconAnchor = new GPoint(20, 40);
	base1Icon.infoWindowAnchor = new GPoint(9, 2);
	base1Icon.infoShadowAnchor = new GPoint(18, 25);



	simpleIcon = new GIcon();
	simpleIcon.iconAnchor = new GPoint(9, 34);
	simpleIcon.infoWindowAnchor = new GPoint(9, 2);
	simpleIcon.infoShadowAnchor = new GPoint(18, 25);

	simple2020Icon = new GIcon();
	simple2020Icon.iconSize = new GSize(20, 20);
	simple2020Icon.iconAnchor = new GPoint(10, 20);
	simple2020Icon.infoWindowAnchor = new GPoint(9, 2);
	simple2020Icon.infoShadowAnchor = new GPoint(18, 25);

	Rectangle.prototype = new GOverlay();


	// Creates the DIV representing this rectangle.
	Rectangle.prototype.initialize = function (map) {
		// Create the DIV representing our rectangle
		var div = document.createElement("div");
		div.style.border = this.weight_ + "px solid " + this.color_;
		div.style.position = "absolute";

		// Our rectangle is flat against the map, so we add our selves to the
		// MAP_PANE pane, which is at the same z-index as the map itself (i.e.,
		// below the marker shadows)
		map.getPane(G_MAP_MAP_PANE).appendChild(div);

		this.map_ = map;
		this.div_ = div;
	}

	// Remove the main DIV from the map pane
	Rectangle.prototype.remove = function () {
		this.div_.parentNode.removeChild(this.div_);
	}

	// Copy our data to a new Rectangle
	Rectangle.prototype.copy = function () {
		return new Rectangle(this.bounds_, this.weight_, this.color_,
                           this.backgroundColor_, this.opacity_);
	}

	// Redraw the rectangle based on the current projection and zoom level
	Rectangle.prototype.redraw = function (force) {
		// We only need to redraw if the coordinate system has changed
		if (!force) return;

		// Calculate the DIV coordinates of two opposite corners of our bounds to
		// get the size and position of our rectangle
		var c1 = this.map_.fromLatLngToDivPixel(this.bounds_.getSouthWest());
		var c2 = this.map_.fromLatLngToDivPixel(this.bounds_.getNorthEast());

		// Now position our DIV based on the DIV coordinates of our bounds
		this.div_.style.width = Math.abs(c2.x - c1.x) + "px";
		this.div_.style.height = Math.abs(c2.y - c1.y) + "px";
		this.div_.style.left = (Math.min(c2.x, c1.x) - this.weight_) + "px";
		this.div_.style.top = (Math.min(c2.y, c1.y) - this.weight_) + "px";
	}
}

function GoogleMaps_PrepareMap(ctrlId) {
	
	if( window.travelMap != null && window.travelMap.getContainer() == document.getElementById(ctrlId) )
	{
		return window.travelMap;
	}
	
	var map = new GMap2(document.getElementById(ctrlId));
	var bigMap = document.getElementById(ctrlId).offsetWidth >= 300;

	if (bigMap)
		map.addControl(new GScaleControl());
	
	if( window.zoomCtrlOnly )
		map.addControl(new GSmallZoomControl());
	else if( bigMap )
		map.addControl(new GLargeMapControl());
	else map.addControl(new GSmallMapControl());
	
	if( window.hideMapTypeCtrl != true)
	{
		if( bigMap )
			map.addControl(new GMapTypeControl());
		else
			map.addControl(new GMenuMapTypeControl());
	}
	window.travelMap = map;
	
	map.addMapType(G_PHYSICAL_MAP);
	
	if( window.show3DGMap )
		map.addMapType(G_SATELLITE_3D_MAP);

if (gadsEnabled) {
    var publisher_id = "pub-9185914040428909";
    var adsManagerOptions = {
        maxAdsOnMap: 1, style: 'adunit'
    };
    adsManager = new GAdsManager(window.travelMap, publisher_id, adsManagerOptions);
    adsManager.enable();
}
	enableTopo();
	return map;
}
//GLog.write(latlng);


function GoogleMaps_LoadKml(ctrlId, lon, lat, zoom, gmaptype, kmlUrl, moveMode  ) {
    
      if (GBrowserIsCompatible()) {
        geoXml = new GGeoXml(kmlUrl);
        GEvent.addListener(geoXml, "load", 
        function ()
		{
			if( moveMode == 2 )
			{
				geoXml.gotoDefaultViewport(window.travelMap);
				if( window.travelMap.getZoom() > 16 ) window.travelMap.setZoom(10);
			}
			else if( moveMode == 1 )
				window.travelMap.setCenter( geoXml.getDefaultCenter() );
		}
        
         );
		
		var map;
        if( window.travelMap == null )
        {
			map = GoogleMaps_PrepareMap(ctrlId);
//			map.getEarthInstance(getEarthInstanceCB);
			if( lon != 0 || lat != 0 )
				map.setCenter( new GLatLng(55.4419, 24.1419), 4 );
			else 
				map.setCenter( new GLatLng(lat, lon), 4 );
			//if( window.onGoogleLoaded != null )
			//	window.onGoogleLoaded();
		}
		else map = window.travelMap;

		map.addOverlay(geoXml);		
		
		
		if(gmaptype)
			map.setMapType( map.getMapTypes()[gmaptype] );
			
		return geoXml;
      }
      
      
	return null;
}	
	
	
//    var ge;
//    function getEarthInstanceCB(object) {
//      ge = object;
//		var networkLink = ge.createNetworkLink("");
//		networkLink.setDescription("NetworkLink open to fetched content");
//		networkLink.setName("Open NetworkLink");
//		networkLink.setFlyToView(true);  
//		var link = ge.createLink("");
//		link.setHref("http://www.marshruty.ru/Google/Kml.ashx?TravelID=60b57d72-a379-42eb-a0f4-29320574402b");
//		networkLink.setLink(link);
//		ge.getFeatures().appendChild(networkLink);

//    }

   
var mainMarker = null;

function GoogleMaps_LoadSquare(ctrlId, minLon, minLat, maxLon, maxLat, gmaptype ){
	map = GoogleMaps_PrepareMap(ctrlId);
	
	var sw = new GLatLng(minLat, minLon);
	var ne = new GLatLng( maxLat, maxLon );
	var gBounds = new GLatLngBounds(sw, ne);
	

	if(gBounds!=null){
		ptCenter = gBounds.getCenter();
		zoomLevel = map.getBoundsZoomLevel(gBounds);
		if( zoomLevel > 16 ) zoomLevel = 10;
		map.setCenter( ptCenter, zoomLevel);
	}
	
	if( gmaptype )
		map.setMapType( map.getMapTypes()[gmaptype] );
	
	if( window.onGoogleLoaded != null )
		window.onGoogleLoaded();
}

function GoogleMaps_LoadPosition(ctrlId, lon, lat, zoomLevel, gmaptype, showmarker, draggable ){
	map = GoogleMaps_PrepareMap(ctrlId);
	

	var point = new GLatLng(lat,lon);
	map.setCenter(point, zoomLevel );
	
	if( showmarker )
	{
		var markerOptions = {};
		if(draggable)
			 markerOptions.draggable = true;
		if( window.draggableIconType )
			markerOptions.icon = getIconType(window.draggableIconType);
			
		mainMarker = new GMarker(point, markerOptions );
		
		map.addOverlay(mainMarker);
	}
    
    if( gmaptype )
		map.setMapType( map.getMapTypes()[gmaptype] );
	
	if( window.onGoogleLoaded != null )
		window.onGoogleLoaded();
}



function GoogleMaps_DownloadGoogleMap( ctrlId, dataUrl, reload ){
	map = GoogleMaps_PrepareMap(ctrlId);
	GDownloadUrl(dataUrl, populateDownloadedData );
}

function GoogleMaps_PopulateGoogleMapXml( ctrlId, data, notMoveMap ){
	map = GoogleMaps_PrepareMap(ctrlId);
	if( data.substr( 0, 4  ) == '<!--' )
		data = data.substring( data.indexOf('<marker'), data.length - "-->".length );
	
	var xml = GXml.parse(data);

	if( xml.documentElement == null ) return;
	populateXmlData(xml, notMoveMap);
}

function clearMarkers() {
		for (var c = 0; c < GMarkersArr.length; c++) {
			map.removeOverlay(GMarkersArr[c]);
		}
		GMarkersArr = [];

	}
	
	function clearPolylines() {
		for (var c = 0; c < GPolylines.length; c++) {
			map.removeOverlay(GPolylines[c]);
		}
		GPolylines = [];

	}

function populateDownloadedData(data, responseCode ) {
	
	if (data.substr(0, 4) == '<!--')
		data = data.substring(data.indexOf('<marker'), data.length - "-->".length);
	
	var xml = GXml.parse(data);
	if (xml.documentElement == null) return;
		
	populateXmlData(xml, true);
	
		
	if( window.onGoogleLoaded != null )
		window.onGoogleLoaded();
}


var GMarkers = {};
var GPolylines = [];
var elemsByName = {};
var GMarkersArr = [];
var defaultW = 3;
var defaultO = 0.6;

function populateXmlData(xml, notMoveMap){
	var map = window.travelMap;
	
	var minLat = 0;
	var maxLat = 0;
	var minLon = 0;
	var maxLon = 0;

	var markers = [];

	
	var travelLatLngSet = false;
	
	var polylines = xml.documentElement.getElementsByTagName("polyline");
	for (var i = 0; i < polylines.length; i++)
	{
		if( polylines[i].firstChild == null )continue;
		
		var polylineStr = polylines[i].firstChild.nodeValue;
		var pointsStr = polylineStr.replace(/(\s*$)/g, "");//trimming
		
		var name = polylines[i].getAttribute('name');
		var geodesic = polylines[i].getAttribute('geodesic') != null;
		

		var color = (polylines[i].getAttribute('color') != null) ? polylines[i].getAttribute('color') : "#ff0000";
		var width = (polylines[i].getAttribute('w') != null) ? parseInt(polylines[i].getAttribute('w')) : defaultW;
		var opacity = (polylines[i].getAttribute('o') != null) ? parseFloat(polylines[i].getAttribute('o')) : defaultO;
			
		var coords = [];
		var firstLon = null;
		var firstLat = null;
		var encoded = polylines[i].getAttribute('enc') != null;


		var polyline = null;
		if (encoded) {

			var edata = pointsStr.split(" ");
			
			polyline = new GPolyline.fromEncoded({
				color: color,
				weight: width,
				points: edata[0],
				levels: edata[1],
				zoomFactor: 16,
				numLevels: 4
			});
	
		}
		else {
			var points = pointsStr.split(" ");
			for (var d = 0; d < points.length; d++) {
				var pointStrs = points[d].replace('\n', '').split(',');
				var lat = parseFloat(pointStrs[1]);
				var lon = parseFloat(pointStrs[0]);
				if (minLat == 0 || minLat > lat) minLat = lat;
				if (maxLat == 0 || maxLat < lat) maxLat = lat;
				if (minLon == 0 || minLon > lon) minLon = lon;
				if (maxLon == 0 || maxLon < lon) maxLon = lon;
				if (d == 0) {
					firstLon = pointStrs[0];
					firstLat = pointStrs[1];

				}
				coords.push(new GLatLng(pointStrs[1], pointStrs[0]));

			}
			var opts = { geodesic: geodesic };
			polyline = new GPolyline(coords, color, width, opacity, opts);
		}
		//var opts = new GPolylineOptions(geodesic:true;)


		polyline.PlacemarkId = name;
		polyline.name = name;
		GPolylines.push(polyline);
	}
	
	var ptCenter = null;
	var zoomLevel = 2;

		
	if( !notMoveMap )
		map.setCenter( new GLatLng(55.4419, 24.1419) );

	var points = xml.documentElement.getElementsByTagName("point");
	for( var c = 0; c < points.length; c++ )
	{
		var name = points[c].getAttribute('name');
		var markerID = points[c].getAttribute('ID');
		var iconType = points[c].getAttribute('iconType');
		var dlgSize = points[c].getAttribute('dlgSize');

		var descrElem = points[c].getElementsByTagName("description")[0];
		var descr = (descrElem!=null && descrElem.firstChild != null)?descrElem.firstChild.nodeValue : "";

		
		var pointStrs = points[c].getElementsByTagName('coordinates')[0].firstChild.nodeValue.split(',');

		var lat = parseFloat( pointStrs[1] );
		var lon = parseFloat( pointStrs[0] );

		if( minLat == 0 || minLat > lat ) minLat = lat;
		if( maxLat == 0 || maxLat < lat ) maxLat = lat;
		if( minLon == 0 || minLon > lon ) minLon = lon;
		if( maxLon == 0 || maxLon < lon ) maxLon = lon;



		var point = new GLatLng(lat, lon);
		
		var marker = createMarker(point, name, descr, iconType, dlgSize);
		if( markerID != null )
		{
			GMarkers[markerID] = marker;
			var aShow = document.getElementById('show' + markerID);
			if( aShow != null ) aShow.style.display = "";
		}
		elemsByName[name] = marker;
		marker.PlacemarkId = name;
		marker.name = name;
		markers.push(marker);
		GMarkersArr.push(marker);
	
		if( ptCenter == null ){
			ptCenter = point;
			
		}
	}
	
	var gBounds = null;

	if( minLat != 0 && maxLat != 0 && minLon != 0 && maxLon != 0 )
	{
		var sw = new GLatLng(minLat, minLon);
		var ne = new GLatLng( maxLat, maxLon );
		//var dist = sw.distanceFrom( ne )/1000;
		gBounds = new GLatLngBounds(sw, ne);
		ptCenter = gBounds.getCenter();
	}
	
	if(gBounds!=null){
		zoomLevel = map.getBoundsZoomLevel(gBounds);
	}
	if (zoomLevel > 14) zoomLevel = 10;
	
	if( !notMoveMap && ptCenter != null ){
		map.setCenter( ptCenter, zoomLevel);
	}

	for (var c = 0; c < GPolylines.length; c++)
	{
		map.addOverlay(GPolylines[c]);
	}


	for (var c = 0; c < markers.length; c++)
	{
		map.addOverlay(markers[c]);
	}


	/*	
	var mmgrOptions = { borderPadding: 50, trackMarkers: false };
	var mmgr = new MarkerManager(map, mmgrOptions);
	mmgr.addMarkers(markers,1);
	mmgr.refresh();
	*/
	

	

	if( window.arrowElems != null ){
		/*if( window.navigator.appVersion.indexOf('MSIE') > 0 )
		{
			InitMapHandlers();
			setTimeout( "DrawTravelArrows()", 700 );
		}*/
	}


}



function createMarker(point, name, descr, iconType, dlgSize ) {
	
	var markerOptions = {};
	if( iconType )
	{
		var markerIcon = getIconType(iconType);
		markerOptions = { icon:markerIcon, title:name };
	}
		
		
	var width = 250;
	var height = 130;
	if(dlgSize)
	{	var strs = dlgSize.split(',');
		width = parseInt(strs[0]);
		height = parseInt(strs[1]);
	}

  var marker = new GMarker(point, markerOptions);
  if( name )
	{
		var iwHtml = "<div style='width:"+ width + "px;height:"+ height + "px;overflow:auto;text-align:left;'><h4 style='color:black;font-weight:bold;'>"
			+name+"</h4><div style='font-size:small;'>" + descr+"</div></div>";
		//marker.iwHtml = iwHtml;
	  GEvent.addListener(marker, "click", function() {
		marker.openInfoWindowHtml(iwHtml);
	  });
	}	
  return marker;
}

function createRect(minLat, minLon, maxLat, maxLon )
{
		var coords = [];
		
		coords.push( new GLatLng(minLat, minLon) );
		coords.push( new GLatLng(maxLat, minLon) );
		coords.push( new GLatLng(maxLat, maxLon) );
		coords.push( new GLatLng(minLat, maxLon) );
		coords.push( new GLatLng(minLat, minLon) );
		

		var rect = new GPolyline(coords, "#ff0000", 3, 1);
		
		return rect;
}


function getIconType(iconType) {
	if (iconType == 'station_s') {
		var icon = new GIcon(simple2020Icon); icon.image = "/i/station_s.png";
		return icon;
	}
	if (iconType == 'airport_s') {
		var icon = new GIcon(simple2020Icon); icon.image = "/i/airport_s.png";
		return icon;
	}
	if (iconType == 'port_s') {
		var icon = new GIcon(simple2020Icon); icon.image = "/i/port_s.png";
		return icon;
	}
	if (iconType == 'train') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "http://maps.google.com/mapfiles/kml/shapes/rail_maps.png";
		return trainIcon;
	}
	if (iconType == 'bus') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "http://maps.google.com/mapfiles/kml/shapes/bus.png";
		trainIcon.iconSize = new GSize(25, 24);
		return trainIcon;
	}
	if (iconType == 'tiny') {
		var tinyIcon = new GIcon(); tinyIcon.image = "http://labs.google.com/ridefinder/images/mm_20_red.png"; tinyIcon.shadow = "http://labs.google.com/ridefinder/images/mm_20_shadow.png"; tinyIcon.iconSize = new GSize(12, 20); tinyIcon.shadowSize = new GSize(22, 20); tinyIcon.iconAnchor = new GPoint(6, 20); tinyIcon.infoWindowAnchor = new GPoint(5, 1);
		return tinyIcon;
	}
	if (iconType == 'tinyblue') {
		var tinyIcon = new GIcon(); tinyIcon.image = "http://labs.google.com/ridefinder/images/mm_20_blue.png"; tinyIcon.shadow = "http://labs.google.com/ridefinder/images/mm_20_shadow.png"; tinyIcon.iconSize = new GSize(12, 20); tinyIcon.shadowSize = new GSize(22, 20); tinyIcon.iconAnchor = new GPoint(6, 20); tinyIcon.infoWindowAnchor = new GPoint(5, 1);
		return tinyIcon;
	}
	if (iconType == 'tinygreen') {
		var tinyIcon = new GIcon(); tinyIcon.image = "http://labs.google.com/ridefinder/images/mm_20_green.png"; tinyIcon.shadow = "http://labs.google.com/ridefinder/images/mm_20_shadow.png"; tinyIcon.iconSize = new GSize(12, 20); tinyIcon.shadowSize = new GSize(22, 20); tinyIcon.iconAnchor = new GPoint(6, 20); tinyIcon.infoWindowAnchor = new GPoint(5, 1);
		return tinyIcon;
	}
	if (iconType == 'tinyred') {
		var tinyIcon = new GIcon(); tinyIcon.image = "http://labs.google.com/ridefinder/images/mm_20_red.png"; tinyIcon.shadow = "http://labs.google.com/ridefinder/images/mm_20_shadow.png"; tinyIcon.iconSize = new GSize(12, 20); tinyIcon.shadowSize = new GSize(22, 20); tinyIcon.iconAnchor = new GPoint(6, 20); tinyIcon.infoWindowAnchor = new GPoint(5, 1);
		return tinyIcon;
	}
	if (iconType == 'tinyyellow') {
		var tinyIcon = new GIcon(); tinyIcon.image = "http://labs.google.com/ridefinder/images/mm_20_yellow.png"; tinyIcon.shadow = "http://labs.google.com/ridefinder/images/mm_20_shadow.png"; tinyIcon.iconSize = new GSize(12, 20); tinyIcon.shadowSize = new GSize(22, 20); tinyIcon.iconAnchor = new GPoint(6, 20); tinyIcon.infoWindowAnchor = new GPoint(5, 1);
		return tinyIcon;
	}
	if (iconType == 'start') {
		var startIcon = new GIcon(baseIcon); startIcon.image = "http://www.google.com/mapfiles/markerA.png";
		return startIcon;
	}
	if (iconType == 'finish') {
		var finishIcon = new GIcon(baseIcon); finishIcon.image = "http://www.google.com/mapfiles/markerB.png";
		return finishIcon;
	}
	if (iconType == 'home') {
		var finishIcon = new GIcon(baseIcon); finishIcon.image = "http://maps.google.com/mapfiles/kml/paddle/blu-blank.png";
		markerOptions = { icon: finishIcon };
	}
	if (iconType == 'border') {
		var borderIcon = new GIcon(baseIcon); borderIcon.image = "/New/images/gran2.png";
		return borderIcon;
	}
	if (iconType == 'lodging') {
		var icon = new GIcon(baseIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/lodging.png";
		return icon;
	}
	if (iconType == 'photo') {
		var photoIcon = new GIcon(baseIcon); photoIcon.image = "http://maps.google.com/mapfiles/kml/shapes/camera.png";
		return photoIcon;
	}
	if (iconType == 'msn_grocery') {
		var icon = new GIcon(baseIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/grocery.png";
		return icon;
	}
	if (iconType == 'sailing') {
		var icon = new GIcon(baseIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/sailing.png";
		return icon;
	}
	if (iconType == 'mountain') {
		var icon = new GIcon(baseIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/volcano.png";
		return icon;
	}
	if (iconType == 'river') {
		var icon = new GIcon(baseIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/swimming.png";
		return icon;
	}
	if (iconType == 'x') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/X.png";

		return icon;
	}
	if (iconType == 'grnstars') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/grn-stars.png";

		return icon;
	}


	if (iconType == 'n1') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/1.png";

		return icon;
	}
	if (iconType == 'n2') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/2.png";

		return icon;
	}
	if (iconType == 'n3') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/3.png";
		return icon;
	}
	if (iconType == 'n4') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/4.png";
		return icon;
	}
	if (iconType == 'n5') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/5.png";
		return icon;
	}
	if (iconType == 'n6') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/6.png";
		return icon;
	}
	if (iconType == 'n7') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/7.png";
		return icon;
	}
	if (iconType == 'n8') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/8.png";
		return icon;
	}
	if (iconType == 'n9') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/9.png";
		return icon;
	}
	if (iconType == 'n10') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/10.png";
		return icon;
	}

	if (iconType == 'north') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/N.png";
		return icon;
	}
	if (iconType == 'south') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/S.png";
		return icon;
	}
	if (iconType == 'east') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/E.png";
		return icon;
	}
	if (iconType == 'west') {
		var icon = new GIcon(base1Icon); icon.image = "http://maps.google.com/mapfiles/kml/paddle/W.png";
		return icon;
	}
	if (iconType == 'airport') {
		var icon = new GIcon(simpleIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/airports.png";
		icon.iconSize = new GSize(30, 34);
		return icon;
	}
	if (iconType == 'port') {
		var icon = new GIcon(simpleIcon); icon.image = "http://maps.google.com/mapfiles/kml/shapes/ferry.png";
		icon.iconSize = new GSize(30, 34);
		return icon;
	}

	if (iconType == 'trainnorth') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainnorth.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}

	if (iconType == 'trainsouth') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainsouth.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}
	if (iconType == 'trainwest') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainwest.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}
	if (iconType == 'traineast') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/traineast.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}
	if (iconType == 'trainne') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainne.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}

	if (iconType == 'trainnw') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainnw.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}
	if (iconType == 'trainsw') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainsw.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}
	if (iconType == 'trainse') {
		var trainIcon = new GIcon(simpleIcon); trainIcon.image = "/i/trainse.png";
		trainIcon.iconSize = new GSize(16, 16);
		return trainIcon;
	}

	if (iconType == 'bestw') {
		var tinyIcon = new GIcon(); tinyIcon.image = "/New/images/bestw.png"; tinyIcon.iconSize = new GSize(30, 30); tinyIcon.iconAnchor = new GPoint(15, 15); tinyIcon.infoWindowAnchor = new GPoint(15, 15);
		return tinyIcon;
	}
	if (iconType == 'normalw') {
		var tinyIcon = new GIcon(); tinyIcon.image = "/New/images/normalw.png"; tinyIcon.iconSize = new GSize(30, 30); tinyIcon.iconAnchor = new GPoint(15, 15); tinyIcon.infoWindowAnchor = new GPoint(15, 15);
		return tinyIcon;
	}
	if (iconType == 'badw') {
		var tinyIcon = new GIcon(); tinyIcon.image = "/New/images/badw.png"; tinyIcon.iconSize = new GSize(30, 30); tinyIcon.iconAnchor = new GPoint(15, 15); tinyIcon.infoWindowAnchor = new GPoint(15, 15);
		return tinyIcon;
	}
}


var arrowElems = {};

function drawGArrow(elem, fromCtrl ){
	if( window.travelMap == null ) return;
	
	var travelID = elem.objectID;
	var descr = (fromCtrl != null) ? fromCtrl : $(elem.ctrlId);
	
	if( elem.arrow != null )
	{
		elem.arrow.parentNode.removeChild(elem.arrow);
		elem.arrow = null;
	}

	
	var parentObj = $("cTravelArrows");
	var color = elem.color;
	
	var fromCoords = Position.positionedOffset(descr);

	if (elem.descrPos == "right") {
	    fromCoords[1] = fromCoords[1] + descr.offsetHeight / 2;
	    
	}
	else if (elem.descrPos == "top") fromCoords[0] = fromCoords[0] + descr.offsetWidth / 2;
	else if (elem.descrPos == "bottom") {
	    fromCoords[0] = fromCoords[0] + descr.offsetWidth / 2;
	    fromCoords[1] = fromCoords[1] + descr.offsetHeight;
	}
	else if (elem.descrPos == "left") {
	fromCoords[1] = fromCoords[1] + descr.offsetHeight / 2;
	fromCoords[0] = fromCoords[0] + descr.offsetWidth;
	}
	else{
	    fromCoords[1] = fromCoords[1] + descr.offsetHeight / 2;
	    fromCoords[0] = fromCoords[0] + descr.offsetWidth / 2;
	}
	

	
	var obj = document.createElement( "v:line" );
	obj.style.zIndex = 8;
	obj.style.position = "absolute";
	obj.filled = false;
	obj.style.textAlign = "center";
	obj.parentObject = parentObj;
	
	var fromPt = fromCoords;
	obj.from = fromPt;
	

	var toCoords = Position.positionedOffset(window.travelMap.getContainer());

	var gPoint = travelMap.fromLatLngToContainerPixel(new GLatLng(elem.lat, elem.lon));
	
	if( gPoint.x < 0 || gPoint.y < 0 || gPoint.x > travelMap.getSize().width || gPoint.y > travelMap.getSize().height )
		//obj.to = "0,0";
		return;	
	else{
		toCoords[0] += gPoint.x;
		toCoords[1] += gPoint.y;

		var toPt = toCoords[0] + "," + toCoords[1];
		obj.to = toPt;
	}
		
	obj.style.left = 0;
	obj.style.top = 0;

	var stroke = obj.appendChild( document.createElement("v:stroke") );
	stroke.endarrow = "Classic";
	stroke.dashstyle = "Dash";
	stroke.weight = "2pt";
	if( color != null )
		stroke.color = color;
	else stroke.color = "Red";
	stroke.style.position = "absolute";

	parentObj.appendChild( obj );
	//obj.style.display = "none";
	elem.arrow = obj;
}

function showGArrow(id, fromCtrl) {
    if( arrowElems[id] != null )
    {
		drawGArrow(arrowElems[id], fromCtrl);
	}
}

function hideGArrow(id){
	var elem = arrowElems[id];
    if( elem != null && elem.arrow != null )
    {
		elem.arrow.parentNode.removeChild(elem.arrow);
		elem.arrow = null;
    }
}

function enableTopo() {
	if (GBrowserIsCompatible()) {

		var currentProjection = G_NORMAL_MAP.getProjection();

		var tilelayer = new GTileLayer(new GCopyrightCollection(""));
		tilelayer.getTileUrl = function (tile, zoom) {

			if (zoom < 8) return "/i/nomapaddzoom.png";
			if (zoom > 12) return "/i/nomapsubzoom.png";


			return "http://maps2.marshruty.ru/ml.ashx?x=" + tile.x + "&y=" + tile.y + "&z=" + zoom + "&i=1&ss=" + window.ucg_ss;


		};
		tilelayer.isPng = function () { return true; };
		tilelayer.minResolution = function () { return 8; };
		tilelayer.maxResolution = function () { return 12; };


		tilelayer.getCopyright = function (a, b) {
			return { prefix: "Marshruty.Ru", copyrightTexts: [""] };
		}
		tilelayer.getOpacity = function () {
			return 1;
		}

		//	var myTileLayer = new GTileLayerOverlay(tilelayer);
		//map.addOverlay(myTileLayer);

		var hybridLayer = [tilelayer];
		hybrid = new GMapType(hybridLayer, G_SATELLITE_MAP.getProjection(), "Топо-карта", { maxResolution: 12, minResolution: 8, errorMessage: "Нет карт этого района" });

		travelMap.addMapType(hybrid);

	}

	if( window.initializeMapDetect)
		window.initializeMapDetect();
}


function pad(num, count) {
	var lenDiff = count - String(num).length;
	var padding = "";

	if (lenDiff > 0)
		while (lenDiff--)
			padding += "0";

	return padding + num;
}



// A Rectangle is a simple overlay that outlines a lat/lng bounds on the
// map. It has a border of the given weight and color and can optionally
// have a semi-transparent background color.
function Rectangle(bounds, opt_weight, opt_color) {
	this.bounds_ = bounds;
	this.weight_ = opt_weight || 2;
	this.color_ = opt_color || "#888888";
}




function renderPolyline(epoints, elevels) {

	var encodedPolyline = new GPolyline.fromEncoded({
		color: "#FF0000",
		weight: 1,
		points: epoints,
		levels: elevels,
		zoomFactor: 16,
		numLevels: 4
	});


	window.travelMap.addOverlay(encodedPolyline);
}


function renderPolygon(epoints, elevels) {

	var polygon = new GPolygon.fromEncoded({
		polylines: [{
			color: "#0000ff",
			weight: 1,
			opacity: 0.3,
			points: epoints,
			levels: elevels,
			zoomFactor: 16,
			numLevels: 4
		}],
		color: "#0000ff",
		opacity: 0.3,
		fill: true,
		outline: true
	});

	window.travelMap.addOverlay(polygon);
}

var mainmultigon = null;
function renderMultigon(data) {
	var polies = [];

	for (var c = 0; c < data.length; c++) {
		var poly = {
			color: "#0000ff",
			weight: 1,
			opacity: 0.3,
			points: data[c].epoints,
			levels: data[c].elevels,
			zoomFactor: 16,
			numLevels: 4
		}
		polies.push(poly);
	}

	var polygon = new GPolygon.fromEncoded({
		polylines: polies,
		color: "#0000ff",
		opacity: 0.3,
		fill: true,
		outline: true
	});

	window.travelMap.addOverlay(polygon);
	mainmultigon = polygon;
}
function hideMultigon() {
	if (mainmultigon != null)
		window.travelMap.removeOverlay(mainmultigon);
}
function showMultigon(show) {
	if (typeof (show) == 'undefined') show = true;

	if (mainmultigon != null) {
		if (show)
			window.travelMap.addOverlay(mainmultigon);
		else window.travelMap.removeOverlay(mainmultigon);
	}
}