var keepAliveTimer = null;
var windowtimeout  = null;

function getElement( id)
{
  if( document.getElementById( id)) {
    return document.getElementById( id);
  }

  return null;
}

function show( x)
{
  var obj = getElement( x);
  if( obj) {
    obj.style.display = 'block';
  }
}

function hide( x)
{
  var obj = getElement( x);
  if( obj) {
    obj.style.display = 'none';
  }
}

function zeroIFNAN( x)
{
  if( isNaN( x) || x == '')
    return 0.0;

  return parseFloat( x);
}

function inputWithPrefilledText( id, active)
{
  if( active) {
    hide( id+'2');
    show( id);
    getElement( id).focus();
  } else if( getElement( id).value == '') {
    show( id+'2');
    hide( id);
  }
}

function sessionTimeout()
{
  var timeout_window = window.open( 'timeout.fly?p=AUA','sessiontimeout','scrollbars=no,menubar=no,status=yes,resizable=no,width=355,height=350');
  timeout_window.focus();
}

window.onload = function() {
  // check if we can do something after loading the page
  if( self.onLoad) {
    onLoad();
  }
}

window.onunload = function() {
  // reset doubleclick
  submit = false;

  // check if we can do something after unloading the page
  if( self.onUnLoad) {
    onUnLoad();
  }
}

var submit = false;
function do_submit()
{
  if( submit) { return false; }
  submit = true;
  return true;
}

function handleonmouseup( event)
{
  if( !event) {
    event = window.event;
  }

  posX = event.screenX;
  posY = event.screenY;
}

var posX;
var posY;
document.onmouseup = handleonmouseup;

function calendarweek( datum)
{
  var jh = datum.getFullYear();

  jh++;

  var calwo = caldiff( datum, jh);
  while( calwo < 1) {
    jh--;
    calwo = caldiff( datum, jh);
  }

  return calwo;
}

function caldiff( datum, jahr)
{
  var d4j = new Date( jahr, 0, 4);
  var wt4j = (d4j.getDay()+6)%7;
  return Math.floor(1.05+(datum.getTime()-d4j.getTime())/6048e5+wt4j/7);
}

function stopEvent( event)
{
  if( event.preventDefault) {
    event.preventDefault();
    event.stopPropagation();
  } else {
    event.returnValue = false;
  }
}

function getXPosition( e)
{
  var x = parseInt( e.offsetLeft);

  if( e.offsetParent) {
    return x + getXPosition( e.offsetParent);
  }

  return x;
}

function getHTTP()
{
  var http;

  if( window.ActiveXObject) {
    http = new ActiveXObject( 'Microsoft.XMLHTTP');
  } else if( window.XMLHttpRequest) {
    http = new XMLHttpRequest();
  }

  if( !http) {
    alert( 'Sorry, no Ajax support!');
    return null;
  }

  return http;
}

function isOKHTTP( http)
{
  if( http.readyState != 4) {
    return false; // not ready
  }

  if( http.status != 200) {
    return false; // request failed
  }

  return true;
}

function startKeepAlive()
{
  if( keepAliveTimer) {
    window.clearTimeout( keepAliveTimer);
  }

  keepAliveTimer = window.setTimeout( keepAlive, 1000*60*10);
}

function keepAlive()
{
  // AJAX keepalive request
  var http = getHTTP();
  if( !http) {
    return;
  }

  // request the offers
  http.open( 'post', 'ka.fly');
  http.onreadystatechange = function() { keepAliveDone( http); };
  http.send( null);
}

function keepAliveDone( http)
{
  if( !isOKHTTP( http)) {
    return;
  }

  startKeepAlive();
}
