/*
 * Simple JavaScript Inheritance
 * http://ejohn.org/blog/simple-javascript-inheritance/
 *
 * Copyright 2008, John Resig
 * Licensed under the MIT.
 *
 * Inspired by base2 and Prototype
 */
(function(scope){var initializing=false,fnTest=/xyz/.test(function(){xyz})?/\b_super\b/:/.*/;scope.Class=function(){};scope.Class.extend=function(prop){var _super=this.prototype;initializing=true;var prototype=new this();initializing=false;for(var name in prop){prototype[name]=typeof prop[name]=="function"&&typeof _super[name]=="function"&&fnTest.test(prop[name])?(function(name,fn){return function(){var tmp=this._super;this._super=_super[name];var ret=fn.apply(this,arguments);this._super=tmp;return ret}})(name,prop[name]):prop[name]}function Class(){if(!initializing&&this.init){this.init.apply(this,arguments)}}Class.prototype=prototype;Class.constructor=Class;Class.extend=arguments.callee;return Class}})(RM);
/*
 * Simple JavaScript Templating
 * John Resig - http://ejohn.org/ - MIT Licensed
 * 
 */
(function(scope){var cache={};scope.tmpl=function tmpl(str,data){var fn=!/\W/.test(str)?cache[str]=cache[str]||tmpl(document.getElementById(str).innerHTML):new Function("obj","var p=[],print=function(){p.push.apply(p,arguments);};with(obj){p.push('"+str.replace(/[\r\t\n]/g," ").split("<?").join("\t").replace(/((^|\?>)[^\t]*)'/g,"$1\r").replace(/\t=(.*?)\?>/g,"',$1,'").split("\t").join("');").split("?>").join("p.push('").split("\r").join("\\'")+"');}return p.join('');");return data?fn(data):fn}})(RM);RM.Debug={log:function(){if(typeof console=="undefined"||typeof console.log=="undefined"){return}console.log.apply(console,arguments)},warn:function(){if(typeof console=="undefined"||typeof console.warn=="undefined"){return}console.warn.apply(console,arguments)},error:function(){if(typeof console=="undefined"||typeof console.error=="undefined"){return}console.error.apply(console,arguments)},trace:function(){if(typeof console=="undefined"||typeof console.trace=="undefined"){return}console.trace.apply(console,arguments)},profile:function(){if(typeof console=="undefined"||typeof console.profile=="undefined"){return}console.profile.apply(console,arguments)},profileEnd:function(){if(typeof console=="undefined"||typeof console.profileEnd=="undefined"){return}console.profileEnd.apply(console,arguments)},time:function(){if(typeof console=="undefined"||typeof console.time=="undefined"){return}console.time.apply(console,arguments)},timeEnd:function(){if(typeof console=="undefined"||typeof console.timeEnd=="undefined"){return}console.timeEnd.apply(console,arguments)},deprecated:function(message){this.warn("DEPRECATED"+(message?": "+message:""));this.trace()}};var Class=RM.Class;var tmpl=RM.tmpl;var RM_Language=RM.Class.extend({add:function(key,value,force){if(!RM.StaticData.languageLabels[key]||(RM.StaticData.languageLabels[key]&&force)){RM.StaticData.languageLabels[key]=value}},get:function(languageLabel,data){if(!RM.StaticData.languageLabels[languageLabel]){throw"Unknown language label: "+languageLabel}var result=RM.StaticData.languageLabels[languageLabel];if(data){for(var i in data){result=result.replace("%"+i+"%",data[i])}}return result},getList:function(langCode){var list={};var regexp=new RegExp("^"+langCode+".(.+)$");for(label in RM.StaticData.languageLabels){if(match=regexp.exec(label)){list[match[1]]=RM.StaticData.languageLabels[label]}}return list}});RM.Language=new RM_Language();RM.L=RM.Language.get;lang=RM.Language;L=function(languageLabel,data){RM.Debug.deprecated("Use RM.L instead of L");RM.L(languageLabel,data)};var RM_Url=RM.Class.extend({_staticDomain:null,F_URL:0,F_HANDLER:1,F_SUBDOMAIN:2,F_PROTOCOL:3,_getRegExp:function(regExp){return new RegExp(regExp.substring(1,regExp.length-1),"i")},isCurrentMainDomain:function(){var host=RM.StaticData.urlConfig.host;var cuttedHost=host.replace(this._getRegExp(RM.StaticData.urlConfig["domain-regex"]),"");return(cuttedHost=="www"||cuttedHost=="")},_getProtocol:function(urlCode){var protocol=this._getProtocolFromConfig(urlCode);if(!protocol){protocol="http"}else{if(protocol=="current"){protocol=RM.StaticData.urlConfig.https?"https":"http"}}return protocol+"://"},_getProtocolFromConfig:function(urlCode){if(RM.StaticData.urlConfig.https_only){return"https"}else{return typeof(RM.StaticData.urlLabels[urlCode][this.F_PROTOCOL])=="string"?RM.StaticData.urlLabels[urlCode][this.F_PROTOCOL].toLowerCase():""}},_needChangeProtocol:function(urlCode){var urlProtocol=this._getProtocolFromConfig(urlCode);if(urlProtocol=="current"){return false}var configProtocol=(urlProtocol=="https"?"https":"http");var currentProtocol=RM.StaticData.urlConfig.https?"https":"http";return configProtocol!=currentProtocol},getDomainUrl:function(urlCode){var domain=typeof(RM.StaticData.urlLabels[urlCode][this.F_SUBDOMAIN])=="string"?RM.StaticData.urlLabels[urlCode][this.F_SUBDOMAIN]:"www";var host=RM.StaticData.urlConfig.host;if(domain=="_current_"){return host}return host.replace(this._getRegExp(RM.StaticData.urlConfig["domain-regex"]),domain+".$2")
},needUseDomain:function(urlCode){var w1=this.getDomainUrl(urlCode);var c1=RM.StaticData.urlConfig.host;var w2="www."+w1;var c2="www."+c1;return !(w1==c1||w1==c2||w2==c1||w2==c2)},get:function(urlCode,data,args,fullUrl){if(!RM.StaticData.urlLabels[urlCode]){throw"Unknown URL "+urlCode}var url=RM.StaticData.urlLabels[urlCode][this.F_URL];if(data){for(var param in data){url=url.replace("$"+param,data[param])}}if(args){url=this._addQueryArgsToUrl(url,args)}if(url.indexOf("://")==-1){if(!url||url.substring(0,1)!="/"){url="/"+url}if(this.needUseDomain(urlCode)||this._needChangeProtocol(urlCode)||fullUrl){url=this.getDomainUrl(urlCode)+url;url=this._getProtocol(urlCode)+url}}return url},getImageUrl:function(format,file){var objectfsDepth=3;return this.get(format,{id:file.id,fid:file.file_device_id,file:file.file_device_path.substring(objectfsDepth*2),name:file.name})},setStaticDomain:function(url){var domain=RM.StaticData.urlConfig["static-domain"];var regexp=RM.StaticData.urlConfig["static-domain-regexp"];if(domain&&regexp){var skip=RM.StaticData.urlConfig["static-domain-regexp-skip"];if(skip){if(new RegExp(skip.replace(/#/ig,"")).test(url)){return url}}url=url.replace(new RegExp(regexp.replace(/#/ig,"")),domain)}return url},S:function(image){if(!this._staticDomain){this._staticDomain=this.setStaticDomain(this.get("static",null,null,"abs")).replace(/\/?$/,"")}return this._staticDomain+image},go:function(urlCode,data,args){window.location.href=this.get(urlCode,data,args)},url:function(args,extra,url){if(!url){url=document.location.href}if(args){url=this._addQueryArgsToUrl(url,args)}return url},_parseUrl:function(url){var parseData={};var tempUrl=url;if(tempUrl.indexOf("://")>=0){parseData.scheme=tempUrl.substring(0,tempUrl.indexOf("://"));tempUrl=tempUrl.substring(tempUrl.indexOf("://")+3)}if(tempUrl.indexOf("#")>=0){parseData.fragment=tempUrl.substring(tempUrl.indexOf("#")+1);tempUrl=tempUrl.substring(0,tempUrl.indexOf("#"))}if(tempUrl.indexOf("?")>=0){parseData.query=tempUrl.substring(tempUrl.indexOf("?")+1);tempUrl=tempUrl.substring(0,tempUrl.indexOf("?"))}if(tempUrl.indexOf("/")>=0){parseData.path=tempUrl.substring(tempUrl.indexOf("/"));tempUrl=tempUrl.substring(0,tempUrl.indexOf("/"))}if(tempUrl){parseData.host=tempUrl}return parseData},_buildUrl:function(data){var url="";if(data.scheme){url+=data.scheme+"://"}if(data.host){url+=data.host}if(data.path){url+=data.path}if(data.query){url+="?"+data.query}if(data.fragment){url+="#"+data.fragment}return url},_addQueryArgsToUrl:function(url,args){var urlData=this._parseUrl(url);var queryArgs=urlData.query?this._getQueryArgsFromQueryString(urlData.query):{};$.extend(queryArgs,args);urlData.query=this._buildQueryStringByQueryArgs(queryArgs);return this._buildUrl(urlData)},_getQueryArgsFromQueryString:function(queryString){var args={};var queryParts=queryString.split("&");for(var key in queryParts){var data=queryParts[key].split("=");if(data[0].substring(data.length-2)=="[]"){var argName=data[0].substring(0,data.length-2);if(!args[argName]){args[argName]=[]}args[argName][args[argName].length]=data[1]}else{args[data[0]]=data[1]}}return args},_buildQueryStringByQueryArgs:function(args){var queryString="";for(var argsKey in args){if($.isArray(args[argsKey])){for(var key in args[argsKey]){if(new String(args[argsKey][key])!="null"){queryString+=(queryString?"&":"")+encodeURIComponent(argsKey)+"["+encodeURIComponent(key)+"]="+encodeURIComponent(args[argsKey][key])}}}else{if(args[argsKey]!=null){queryString+=(queryString?"&":"")+encodeURIComponent(argsKey)+"="+encodeURIComponent(args[argsKey])}}}return queryString}});RM.Url=new RM_Url();url=RM.Url;RM.StaticData.languageLabels={"user.train.blank":"Билет на бланке","user.train.eticket":"Электронный билет","user.train.msk_time_in_schedule":"в расписании указано<br />московское время","user.train.brand_train":"фирменный поезд","user.train.out":"из","user.train.to":"в","user.train.payment_method":"Способ оплаты","user.train.from":"от","user.train.year_from":"года","user.train.print_order_form_ereg":"Распечатать<br />посадочный купон","user.train.print_order_form":"Распечатать<br />контрольный купон","user.train.print":"Распечатать","user.train.timetable_stops":"расписание остановок","user.train.order_status":"Статус заказа","user.train.on_the_way":"В пути","user.train.pass_eregestration":"Пройти электронную регистрацию","user.train.cancel_eregestration":"Отменить электронную регистрацию","user.train.eregestration_unavail":"Электронная регистрация на данный поезд невозможна.","user.train.eregestration_info":"Что такое электронная регистрация?","user.train.passangers_and_cost":"Пассажиры и стоимость","user.train.vagon":"вагон","user.train.place":"место","user.train.order_cost":"Общая стоимость заказа","user.train.pre_cost":"Предварительная стоимость заказа","user.train.sex_male":"мужское","user.train.sex_female":"женское","user.train.sex_mixed":"смешанное","user.train.order_contacts":"Контактная информация","user.train.name_and_lastname":"Имя и фамилия","user.train.phone":"Телефон","user.train.email":"Email","user.train.data_from_order":"Эти данные вы&nbsp;указали при&nbsp;оформлении заказа.<br /><br />Операторы будут связываться с&nbsp;вами именно по&nbsp;указанным телефонному номеру и&nbsp;адресу эл.&nbsp;почты.","user.train.ticket_receiving":"Как получить билет","user.train.ticket_payment":"Как оплатить билет","user.train.partner_office":"Офис партнера","user.train.partner_office_address":"Адрес","user.train.partner_office_name":"Название","user.train.partner_office_map":"Посмотреть на карте","user.train.partner_office_phone_vipservice_moscow":"(495)&nbsp;626-41-42, круглосуточно","user.train.partner_office_address_vipservice_moscow":"г. Москва, Переведеновский пер., д.17, кор. 1","user.train.partner_office_name_vipservice_moscow":"ЗАО «V.I.P. Сервис»","user.train.partner_office_email_vipservice_moscow":'<a href="mailto:info@tutu.ru">info@tutu.ru</a>',"user.train.partner_office_phone_vipservice_spb":"(812)&nbsp;380-56-00, с понедельника по пятницу с 10:00 до 19:00, суббота-воскресенье с 10:00 до 16:30","user.train.partner_office_address_vipservice_spb":"г. Санкт-Петербург, ул. Киевская, дом 6","user.train.partner_office_name_vipservice_spb":"ООО «ВИП Сервис Корпорейтед»","user.train.partner_office_email_vipservice_spb":'<a href="mailto:info@tutu.ru">info@tutu.ru</a>',"user.train.partner_office_phone_davs_spb":"(812)&nbsp;493-59-60, круглосуточно","user.train.partner_office_address_davs_spb":"г. Санкт-Петербург, 9-я Линия В.О., д. 34, офис 101","user.train.partner_office_name_davs_spb":"ЗАО «Агентство ДАВС»","user.train.partner_office_email_davs_spb":'<a href="mailto:info@tutu.ru">info@tutu.ru</a>',"user.train.partner_office_phone_travelmart":"(495)&nbsp;787-01-05 (с 9:00 до 21:00)","user.train.partner_office_address_travelmart":"","user.train.partner_office_name_travelmart":"ООО &laquo;Стар Трэвел&raquo;","user.train.partner_office_email_travelmart":'<a href="mailto:info@tutu.ru">info@tutu.ru</a>',"user.train.partner_office_title_ufs":"Обратная связь","user.train.partner_office_phone_ufs":"(495)&nbsp;787-01-05 (с 9:00 до 21:00)","user.train.partner_office_address_ufs":"","user.train.partner_office_name_ufs":"","user.train.partner_office_email_ufs":'<a href="mailto:info@tutu.ru">info@tutu.ru</a>',"user.train.info_blank":"Вы заказали билет на&nbsp;бланке, в&nbsp;этом&nbsp;случае места в&nbsp;поезде не&nbsp;бронируются, но&nbsp;учитываются оператором как&nbsp;пожелание.","user.train.info_blank_second":"Уточнение стоимости и&nbsp;оформление билета происходит только после разговора с&nbsp;оператором.","train.using_ufs":"","train.schedule_title":"Расписание поездов","train.schedule_title_sapsan":"Расписание движения поездов Сапсан по маршруту","train.schedule_title_choose":"Выберите поезд, чтобы заказать билеты онлайн","train.schedule_title_choose_buy":"Выберите поезд, чтобы купить билеты онлайн","train.schedule_title_choose_sapsan":"Выберите поезд, чтобы купить билеты на Сапсан онлайн","train.schedule_title_choose_buy_sapsan":"Выберите поезд, чтобы купить билеты на Сапсан онлайн","train.schedule_return_back":"Перейти обратно в расписание поездов","train.buy_tickets_to":"Купить ж/д билеты в %city%","train.moscow_time":"Московское время","train.local_time":"Местное время","train.from_title":"Откуда","train.to_title":"Куда","train.direction":"Чаще всего в %city% покупают ж/д билеты по этим направлениям","train.common_comment":"Текст отзыва","train.invalid_captcha":"Неверный код каптчи","train.time_message_moscow":"Время по станциям указано московское","train.time_message_moscow_time":"Московское время","train.time_message_local":"Местное время","train.time_message_custom":"<p>По правилам РЖД в&nbsp;расписании и&nbsp;билетах для&nbsp;станций внутри России указано московское время.</p><p>Для станций вне&nbsp;России указано местное время.</p>","train.time_message_msk_local":"Отправление <b>по&nbsp;московскому</b>,<br />прибытие <b>по&nbsp;местному</b> времени","train.time_message_local_msk":"Отправление <b>по&nbsp;местному</b>,<br />прибытие <b>по&nbsp;московскому</b> времени","train.time_message_msk_only":"Отправление и&nbsp;прибытие<br /><b>по&nbsp;московскому</b> времени","train.time_message_local_only":"Отправление и&nbsp;прибытие<br /><b>по&nbsp;местному</b> времени","train.review_no_auth":"Для добавления отзыва вам необходимо зарегистрироваться или войти в систему","train.review_no_records":"Пока нет ни одного одобренного отзыва","train.popup_title":"Заказ","train.railwaylist_msk":"Вокзалы Москвы","train.railwaylist_spb":"Вокзалы Санкт-Петербурга","train.mail_from":'"Tutu.ru | ж/д билеты"',"train.mail_from_remind":'"Tutu.ru | Есть билеты!"',"train.error_blank_station":"Пожалуйста, укажите название станции","train.error_blank_train":"Пожалуйста, укажите номер или название поезда","train.error_blank_stations":"Пожалуйста, укажите станции отправления и прибытия","train.auth_title":'Пожалуйста, введите указанный вами при оформлении заказа адрес электронной почты или номер сотового телефона <span class="gray small-text nowrap">(в формате 8-ххх-ххх-хх-хх или name@email.com)</span>',"train.auth_message":'Для просмотра заказа <div class="standart_text">введите указанный в заказе номер телефона<br /> или адрес электронной почты</div>',"train.auth_message_or":"или","train.auth_message_or_text":"войдите под своим паролем","train.auth_format":"В формате: 8-123-456-78-90 или name@email.com","train.auth_error":"Пожалуйста, укажите данные, по которым был оформлен этот заказ.","train.wrong_user":"Этот заказ относится к другому личному кабинету.","train.show_order_blank":"Посмотреть бланк заказа","train.show_order_ereg":"Распечатать посадочный купон","train.show_order":"Распечатать контрольный купон","train.ufs_used":"Используется веб-система ООО&nbsp;«УФС»","train.info_order":"Информация о заказе","train.info_order_text_blank":"Для удобства вы можете посмотреть и&nbsp;распечатать данные заказа.","train.info_order_text_ereg":"При посадке в поезд с пройденной электронной регистрацией желательно иметь с собой распечатанный посадочный купон.","train.info_order_text":"Контрольный купон поможет вам при получении билета в кассе или терминале.","train.info_docs":"Отчетные документы","train.info_docs_text":'Для получения отчетных документов на&nbsp;сервисный сбор, пожалуйста, напишите нам на&nbsp;электронную почту <a href="mailto:documents@tutu.ru">documents@tutu.ru</a>.\n\t\t\t\t\t\t\t\t\t\t\tВаше письмо будет обработано в&nbsp;течение 5&nbsp;дней.',"train.info_docs_text_1":'Копии отчетных документов можно сохранить <a class="%fileLinkClassName%" href="%docsUrl%">на&nbsp;компьютер</a> уже сейчас или получить их&nbsp;на&nbsp;<a href="javascript:void(0)" class="%emailLinkClassName%">электронную почту</a>.',"train.info_docs_text_2":'Также мы&nbsp;можем отправить вам <a href="javascript:void(0)" class="%requestLinkClassName%">оригиналы</a>.',"train.login_to_view_docs":'Для получения отчетных&nbsp;документов зайдите в&nbsp;«Мои&nbsp;заказы» <a target="_blank" href="%url%">в личном кабинете</a>. В качестве логина укажите эл. почту, указанную при оформлении этого заказа.',"train.buy_tickets_fast":"Билеты на поезд за 5 минут","train.buy_tickets_search":"Укажите маршрут и дату поездки в форме поиска.","train.buy_tickets_choose":"Выберите подходящий вам поезд и места.","train.buy_tickets_pay_sv":'Оплатите билеты <a href="%link%">банковской картой или наличными</a>.',"train.buy_tickets_pay":'Оплатите билеты <a href="%link%">банковской картой, наличными, электронными деньгами</a>.',"train.buy_tickets_get":'Получите билеты <a href="%link%">выбранным вами способом</a>.',"train.why_love_us_title":"Туту.ру&nbsp;&mdash; самый популярный у&nbsp;россиян туристический сайт","train.why_love_us_data":'по&nbsp;данным comScore и&nbsp;газеты <a href="http://www.kommersant.ru/doc/1869944" target="_blank">&laquo;Коммерсант&raquo;</a>.',"train.why_love_us_maintext":"Нас любят, потому что множество продуманных мелочей делают покупку билетов удобной и&nbsp;быстрой:<br />\n\t\t\t\t\t\t\t\t\t\t\t&mdash;&nbsp;выбор мест на&nbsp;схеме вагона;<br />\n\t\t\t\t\t\t\t\t\t\t\t&mdash;&nbsp;заказ уведомлений, если нужных билетов нет в&nbsp;наличии&nbsp;&mdash; когда они появятся, мы&nbsp;пришлем sms;<br />\n\t\t\t\t\t\t\t\t\t\t\t&mdash;&nbsp;свой контакт-центр&nbsp;&mdash; ни&nbsp;один звонок или письмо не&nbsp;останется без ответа.","train.why_love_us_maintext2":"Нас любят, потому что множество продуманных мелочей\n\t\t\t\t\t\t\t\t\t\t\tделают покупку билетов на&nbsp;Туту.ру удобной и&nbsp;быстрой:\n\t\t\t\t\t\t\t\t\t\t\t<br />&mdash;&nbsp;выбор места на&nbsp;схеме вагона;\n\t\t\t\t\t\t\t\t\t\t\t<br />&mdash;&nbsp;маршрут поезда на&nbsp;карте;\n\t\t\t\t\t\t\t\t\t\t\t<br />&mdash;&nbsp;заказ уведомления, если билетов нет &mdash;&nbsp;когда они появятся мы пришлем СМС;\n\t\t\t\t\t\t\t\t\t\t\t<br />&mdash;&nbsp;свой контакт-центр &mdash;&nbsp;ни&nbsp;один звонок или письмо не&nbsp;останется без&nbsp;ответа.","train.why_love_us_buyers":"Мы&nbsp;продали более 500&nbsp;000&nbsp;ж/д билетов. Каждый второй покупатель становится нашим постоянным клиентом.","train.right_sale_title":"Продажа ж/д билетов онлайн:","train.right_sale_text":"<p>&mdash;&nbsp;выбор мест на&nbsp;схеме вагона;</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>&mdash;&nbsp;заказ уведомлений, если нужных билетов нет&nbsp;&mdash; когда они появятся, мы&nbsp;пришлем смс;</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>&mdash;&nbsp;скидки и&nbsp;спецтарифы РЖД;</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>&mdash;&nbsp;свой контакт-центр&nbsp;&mdash; ни&nbsp;один звонок или письмо не&nbsp;остается без ответа.</p>","train.right_sale_tickets":"Мы&nbsp;продали более 500&nbsp;000&nbsp;билетов.","train.right_sale_clients":"Каждый второй покупатель становится нашим постоянным клиентом.","train.support_phone":"+7&nbsp;(495)&nbsp;787-01-05","train.support_phone_number":"787-01-05","train.sapsans":"Сапсаны","train.sapsan":"Сапсан","train.not_available_price":"Цена неизвестна","metro.title":"Карта метро","metro.caption":"Метро","metro.show":"Полная схема","metro.title_show":"Карта метро г.%city%. Схема метрополитена: %city%.","metro.region":"Регион","metro.information":"Информация","metro.img_min":"маленькая схема:","metro.img":"полная схема:","metro.click":"Нажмите для просмотра полной схемы","metro.order_air":"Заказать авиабилеты","metro.order_hotel":"Забронировать отель","metro.airports":"Аэропорты города","metro.menu_title":"Схемы метро","metro.active":"пункт включен","metro.big":"Крупный город","metro.city":"Город","metro.country":"Страна","metro.rus":"Россия","metro.sng":"СНГ","metro.eur":"Европа","metro.asi":"Азия","metro.afr":"Африка","metro.ame":"Америка","metro.aus":"Австралия","metro.alias":"Алиас для создания ссылки<br>относительно /metro/","metro.info_line":"Телефон Горячей линии","metro.meta_title":"Карта метро городов мира","metro.meta_keywords":"карта метро","metro.meta_description":"Карта метро основных стран и городов мира.","etrain_common.meta_title":"Заказ авиабилетов и расписание авиарейсов. Бронируйте авиабилеты online. Расписание поездов, заказ ж/д билетов, расписание электричек (2009 гг.) Москва и Санкт-Петербург, заказ электронных жд билетов","etrain_common.meta_keywords":"Заказ, авиабилетов, расписание, авиарейсов, авиабилеты, online, Заказ ж/д билетов, Расписание поездов, дальнего, следования, Расписание, электричек, электропоездов, Москвы, Санкт-Петербург, пригородных,поездов,Московской,области,вокзалов,заказ электронных жд билетов","etrain_common.meta_description":"Заказ авиабилетов и расписание авиарейсов. Бронируйте авиабилеты online. Заказ ж/д билетов. Расписание электричек всех вокзалов Москвы и Санкт-Петербурга. Расписание поездов. Расписание электропоездов Москвы. Заказ электронных жд билетов","etrain_common.license":"На&nbsp;сайте использованы данные, полученные из&nbsp;официально опубликованных расписаний авиарейсов, расписания поездов и&nbsp;электричек. Заказы авиабилетов и&nbsp;жд&nbsp;билетов, включая электронные жд&nbsp;билеты, оформляются партнерами Туту.ру.","etrain_common.about_order":"<p><b>Бронирование авиабилетов online.</b> Заказывая авиабилеты на&nbsp;Tutu.ru, воспользуйтесь и&nbsp;другими online-сервисами&nbsp;&#8212; расписанием аэроэкспрессов &nbsp;онлайн-табло. Оформляя авиабилет, вы&nbsp;пользуетесь международной системой бронирования авиабилетов.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p><b>Доставка забронированных авиабилетов.</b> Заказанные на&nbsp;Tutu.ru авиабилеты доставляются в&nbsp;офисы по&nbsp;Москве в&nbsp;пределах МКАД. Также авиабилеты можно забрать самостоятельно.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p><b>Выбор подходящего авиабилета.</b> При бронировании авиабилетов вы&nbsp;можете отсортировать варианты по&nbsp;стоимости авиабилета, по&nbsp;времени вылета, по&nbsp;продолжительности полета и&nbsp;т.п.</p>","etrain_common.point_from":"Откуда","etrain_common.point_from_tips":"Для бронирования авиабилетов необходимо<br />ввести город вылета на&nbsp;русском языке.","etrain_common.city_name":"Название города","etrain_common.searching":"Поиск...","etrain_common.reset":"Сброс","etrain_common.clean_and_close":"Очистить и закрыть","etrain_common.close":"Закрыть","etrain_common.choose":"Выбрать","etrain_common.cancel":"Отменить","etrain_common.show":"Показать","etrain_common.start_typing":"Начните ввод названия...","etrain_common.point_to":"Куда","etrain_common.point_to_tips":"Для бронирования авиабилетов необходимо<br />ввести город прилета на&nbsp;русском языке.","etrain_common.date":"Дата","etrain_common.date_from":"Дата вылета","etrain_common.date_from2":"Дата заезда","etrain_common.date_to":"Дата возврата","etrain_common.date_to2":"Дата отъезда","etrain_common.date_format":"ДД.ММ.ГГГГ","etrain_common.details":"Подробнее","etrain_common.one_way":"В одну сторону","etrain_common.two_ways":"Туда и обратно","etrain_common.adds":"Дополнительно","etrain_common.passengers_count":"Количество пассажиров","etrain_common.adults":"Взрослые","etrain_common.childs":"Дети (2-10 лет)","etrain_common.babies":"Маленькие дети (до 2 лет)","etrain_common.class":"Класс","etrain_common.econom":"Экономический","etrain_common.business":"Бизнес","etrain_common.first":"Первый","etrain_common.any":"Любой","etrain_common.please_wait":"Пожалуйста, подождите. Выполнение запроса занимает до 30 секунд.","etrain_common.no_result":"Ничего не найдено","etrain_common.maximaze":"развернуть","etrain_common.choose_country":"Выберите страну","etrain_common.choose_city":"Выберите город","etrain_common.found":"Найдено","etrain_common.only_first":"Показаны первые <count> записей (<all>)","etrain_common.show_all":"показать все","etrain_common.level_up":"На уровень выше","etrain_common.choose_variant":"Выберите один из вариантов или продолжите набор","etrain_common.other_cities":"Другие&nbsp;города","etrain_common.other_cities_world":"Другие города мира","etrain_common.avia_order_online":"Заказывайте авиабилеты онлайн","etrain_common.before_avia_order":"Перед заказом авиабилетов","etrain_common.read_rules":"ознакомьтесь с правилами","etrain_common.try_later":"Пожалуйста, попробуйте позже","etrain_common.loading":"Загрузка...","etrain_common.saving":"Сохранение...","etrain_common.deleting":"Удаление...","etrain_common.you_order_and_get_ticket":"Вы заказываете и получаете билеты","etrain_common.msk":"Москва","etrain_common.spb":"Санкт-Петербург","etrain_common.in_msk":"в Москве","etrain_common.in_spb":"в Санкт-Петербурге","etrain_common.not_necessarily":"не обязательно","etrain_common.station_name":"Название станции","etrain_common.belgorod":"Белгород","etrain_common.voronezh":"Воронеж","etrain_common.irkutsk":"Иркутск","etrain_common.lipetsk":"Липецк","etrain_common.tambov":"Тамбов","etrain_common.project":"Проект компании","etrain_common.main":"Главная","etrain_common.feedback":"Обратная связь","etrain_common.surprise":"Партнерская программа","etrain_common.advert_at":"Реклама на","etrain_common.city_and_country":"Город или страна","etrain_common.alert_date_from":"Необходимо указать дату заезда в формате ДД.ММ.ГГГГ","etrain_common.alert_date_to":"Необходимо указать дату отъезда в формате ДД.ММ.ГГГГ","etrain_common.volgograd":"Волгоград","etrain_common.ekaterinburg":"Екатеринбург","etrain_common.kazan":"Казань","etrain_common.nizhny_novgorod":"Нижний Новгород","etrain_common.novosibirsk":"Новосибирск","etrain_common.samara":"Самара","etrain_common.russian":"РОССИЯ","etrain_common.sng":"СНГ","etrain_common.all_countries":"Все страны","etrain_common.country":"Страна","etrain_common.country_small":"страна","etrain_common.city":"Город","etrain_common.city_small":"город","etrain_common.forward":"Туда","etrain_common.forward_small":"туда","etrain_common.back":"Обратно","etrain_common.back_small":"обратно","etrain_common.total":"Итого","etrain_common.order":"Заказать","etrain_common.date_of_return_depends":"Дата возврата зависит от даты вылета. Выберите подходящую дату вылета.","etrain_common.h":"ч.","etrain_common.i":"мин.","etrain_common.this_price_is_min":"Указанная цена является минимальной","etrain_common.at_this_pair_no_offers":"На данную пару дат предложений нет","etrain_common.date_of_return_depends2":"Дата возврата зависит от даты вылета.<br>Выберите подходящие даты чартера и кликните, чтобы просмотреть детали.","etrain_common.unknown":"Неизвестно","etrain_common.departure":"Вылет","etrain_common.departure_small":"вылет","etrain_common.arrival":"Прилет","etrain_common.in_flight":"В полете","etrain_common.flights":"Рейс","etrain_common.price_the_ticket":"Стоимость одного билета от","etrain_common.special_for_charters":"Спецпредложения и выгодные цены на чартеры","etrain_common.price_description_for_charters":"Цены и наличие авиабилетов на чартеры указаны на момент публикации. Расписание чартеров обновляется регулярно.","etrain_common.price_description_for_charters2":'Чартерные авиарейсы — нерегулярные рейсы авиакомпаний, выполняемые для определенного заказчика. Авиабилеты на чартеры как правило стоят дешевле авибилетов на обычные рейсы. Так происходит из-за того, что авиакомпания продает все билеты на авиарейс без остатка. <a href="/2read/catalog/avia_faq/item/avia_cost/" target="_blank">Подробнее про стоимость авиабилетов</a>',"etrain_common.order_passenger_notice":"<p>Заполните, пожалуйста, форму заказа авиабилета на&nbsp;чартерный рейс.</p><p>Обратите внимание, что&nbsp;цены на&nbsp;чартерные авиарейсы могут  измениться. Наш&nbsp;оператор обязательно позвонит вам и&nbsp;сообщит самую оперативную информацию о&nbsp;ценах и&nbsp;наличии мест.</p>","etrain_common.passengers_info":"Информация о пассажирах","etrain_common.contacts_info":"Информация для связи","etrain_common.congratulation_for_success_order":"Поздравляем с успешным заказом!","etrain_common.your_order_success_send":"<p>Ваш заказ принят. Наш сотрудник свяжется с&nbsp;вами в&nbsp;ближайшее время для подтверждения заказа и&nbsp;уточнения деталей оформления.</p><p>Наши операторы работают с&nbsp;понедельника по&nbsp;пятницу с&nbsp;10&nbsp;до&nbsp;19 часов. Заявки на&nbsp;сайте принимаются круглосуточно.</p>","etrain_common.number_your_order":"Номер вашего заказа","etrain_common.save_him":"сохраните его","etrain_common.order_success_notice":'<p align="left">Если в&nbsp;течение 1-2&nbsp;часов вам не&nbsp;перезвонили, то&nbsp;для уточнения вашей заявки можно позвонить по&nbsp;телефону (495) 788-53-83&nbsp;(наш партнер, компания TTS Group).</p><p align="left">При этом <strong>сообщите номер заказа</strong>, а&nbsp;также что вы&nbsp;делали <strong>заказ чартерных авиабилетов</strong> на&nbsp;сайте ТУТУ.РУ&nbsp;&#8212; это поможет быстрее найти вашу заявку.</p><p align="left">&nbsp;</p><p align="left"><strong>Адрес нашего офиса</strong> для получения билетов: выход из&nbsp;метро &laquo;Тульская&raquo; (последний вагон из&nbsp;центра). Идете в&nbsp;противоположную сторону от&nbsp;ТЦ&nbsp;&laquo;Ереван Плаза&raquo;, проходите мимо часовни и&nbsp;идете направо вдоль улицы Даниловский Вал и&nbsp;Свято-Данилова монастыря.</p><p align="left">Дом &#8470;&nbsp;71&nbsp;легко заметить благодаря высокой башенке фитнес-клуба &laquo;World Gym&raquo;, расположенного в&nbsp;этом&nbsp;же здании.</p>',"etrain_common.order_success_notice2":'<p align="left">Проход на&nbsp;территорию офисного центра осуществляется через здание охраны справа от&nbsp;шлагбаума.</p><p align="left"> За&nbsp;проходной сразу слева вход в&nbsp;здание. Второй этаж, офис 201. Дверь с&nbsp;вывеской &laquo;TTS Group&raquo;.</p><p align="left">&nbsp;</p><p align="left"> Благодарим вас за&nbsp;то,&nbsp;что вы&nbsp;воспользовались нашей услугой заказа билетов.</p><p align="left">&nbsp;</p><p align="left"><strong>Мы&nbsp;всегда рады видеть вас в&nbsp;числе клиентов  Туту.ру.</strong></p>',"etrain_common.see_big_map":"Просмотреть увеличенную карту","etrain_common.contact":"Контактное лицо","etrain_common.phone":"Телефон","etrain_common.phone2":"Второй телефон","etrain_common.advanced":"Дополнительно","etrain_common.email":"Адрес эл. почты","etrain_common.fio":"ФИО","etrain_common.how_in_original_foreign_passport":"латиницей как в загранпаспорте","etrain_common.foreign_passport":"Загранпаспорт","etrain_common.birthday":"Дата рождения","etrain_common.show_dates":"Показать даты","etrain_common.price_from":"Цена от","etrain_common.special_offer":"Специальное предложение","etrain_common.loading2":"Идёт загрузка...","etrain_common.flights_info":"Информация о рейсе","etrain_common.go_to_begin":"В начало","etrain_common.info":"Информация","etrain_common.order_taxi_to_airport":"Заказ такси в аэропорт","etrain_common.":"","etrain_common.submit":"Отправить","etrain_common.edit":"Редактировать","etrain_common.save":"Сохранить","etrain_common.select":"-- Выбрать --","etrain_common.reply":"Ответить","etrain_common.searchengine":"Поисковик","etrain_common.limit_exceeded":"Превышено допустимое количество обращений этого типа, подождите некоторое время","etrain_common.bottom_mail_address":"Тел. +7 (499) 125-03-51","etrain_common.in":"в","etrain_common.price":"Стоимость","etrain_common.rub":"руб","etrain_common.learn_price":"Узнать стоимость","etrain_common.learn_full_price":"Узнать полную стоимость","etrain_common.next":"Далее","etrain_common.choose2":"выберите","etrain_common.by_day":"днем","etrain_common.by_night":"ночью, по выходным и праздникам","etrain_common.footer_adt":"<!-- -->","etrain_common.daySymbol":'<span class="miniNbsp">&nbsp;</span>д',"etrain_common.hourSymbol":'<span class="miniNbsp">&nbsp;</span>ч',"etrain_common.minuteSymbol":'<span class="miniNbsp">&nbsp;</span>м',"etrain_common.kmSymbol":'<span class="miniNbsp">&nbsp;</span>км',"etrain_common.avia":"Авиабилеты","etrain_common.trains":"Ж/д билеты","etrain_common.etrains":"Электрички","etrain_common.hotels":'<span class="item-name" >Заказ гостиниц</span>',"etrain_common.more":"Еще","etrain_common.footer_menu_feedback":"Обратная связь","etrain_common.footer_menu_faq":"Справочная","etrain_common.footer_menu_advert":"Реклама на Туту.ру","etrain_common.footer_menu_informer":"Информер Туту.ру","etrain_common.taxi":"Такси","etrain_common.metro":"Метро","etrain_common.example_plugin":"Например:","etrain_common.example_plugin_or":"или","etrain_common.example_clean_date":"убрать дату","etrain_common.captcha":"Код проверки","etrain_common.captcha_hint":"C вашего адреса поступает очень много запросов к Tutu.ru. Эти запрос похожи на автоматические, отправляемые роботами.<br>\nЕсли вы не робот, пожалуйста, заполните форму с цифрами.<br>\nЕсли вы не делали большое количество запросов, возможно, это было сделано без вашего ведома. Пожалуйста, проверьте ваш компьютер антивирусом.","etrain_common.no_flood":"C вашего адреса поступает очень много запросов к Tutu.ru. Эти запрос похожи на автоматические, отправляемые роботами.<br>\nЕсли вы не делали большое количество запросов, возможно, это было сделано без вашего ведома. Пожалуйста, проверьте ваш компьютер антивирусом.","etrain_common.ip_denied":"Для вашего IP адреса закрыт доступ на сайт. Возможно, это связано с большим количеством запросов, поступавшим с вашего адреса.<br>\nЕсли вы не делали большое количество запросов, возможно, это было сделано без вашего ведома. Пожалуйста, проверьте ваш компьютер антивирусом.","etrain_common.title_captcha":"Страница проверки - заполните форму с цифрами.","etrain_common.wrong_imagecaptcha_code":"Вы неправильно ввели код.","etrain_common.title_flood_denied":"Для вашего IP адреса закрыт доступ на сайт.","etrain_common.title_no_flood":"С вашего IP адреса поступает очень много запросов","etrain_common.cost_short":"&nbsp;р.","etrain_common.sector_link_avia":"Авиабилеты","etrain_common.sector_link_avia_text":"расписание самолетов, аэропорты, авиакомпании","etrain_common.calendar":"Календарь","hotel.city_hotels":"Гостиницы %city_gen%","hotel.city_hotels_foreign":"Отели %city_gen%","hotel.city_hotels_foreign_text":'<table class="hotels_text"><tr><td class="htext">Отели %city_gen%&nbsp;</td></tr></table>',"hotel.city_hotels_foreign_text2":'<table class="hotels_text"><tr><td class="htext"><a href="%city_url%">Отели %city_gen%</a>&nbsp;</td></tr></table>',"hotel.city_all_hotels":"Все гостиницы %city_gen%","hotel.city_all_hotels_by_case":"Все %count% %hotel% %city_gen%","hotel.city_map_all_hotels":"Гостиницы %city_gen% на карте","hotel.country_hotels":"Гостиницы %country_gen%","hotel.country_hotels_map":"Гостиницы %country_gen% на карте","hotel.country_hotels_map_foreign":"Отели %country_gen% на карте","hotel.country_hotels_photo":"Фото гостиниц %country_gen%","hotel.country_hotels_photo_foreign":"Фото отелей %country_gen%","hotel.eng":"Анг.","hotel.rus":"Рус.","hotel.title_payment":"Оплата заказа/бронирования","hotel.specify_payment_type":"Выберите способ оплаты.","hotel.payment_type_not_specified":"Не выбран способ оплаты.","hotel.please_login_to_complete":"Для завершения заказа необходимо авторизоваться на сайте.","hotel.pay":"Оплатить заказ","hotel.go_to_confirmation":"Перейти к завершению","hotel.print_receipt":"Распечатать квитанцию","hotel.print_voucher":"Распечатать ваучер","hotel.prepare_payment":"На страницу оплаты","hotel.check_paid":"Проверить состояние","hotel.thanks_for_order":"Спасибо за заказ!","hotel.city":"Город","hotel.where":"Куда","hotel.city_or_country":"Город или страна","hotel.country_or_city_or_hotel":"Введите название города или отеля","hotel.country_or_city_or_hotel_label":"Страна, город или отель","hotel.found_countries":"Страны","hotel.found_cities":"Города","hotel.reserve_in_cities":"Бронирование гостиниц в городах %country_gen%","hotel.found_hotels":"Отели","hotel.not_found":"По вашему запросу ничего не найдено. Попробуйте поменять условия поиска.","hotel.hotels_not_found":"Нет гостиниц, удовлетворяющих критериям поиска","hotel.search_result":"Результат поиска по запросу &laquo;%search%&raquo;","hotel.search_string_mustbe_longer":"Искомая строка должна быть не менее 2 символов.","hotel.view_all_search_result":"Посмотреть все результаты поиска &laquo;%search%&raquo; (%count%)","hotel.others":"Другие","hotel.order_in_russia":"Бронирование гостиниц в&nbsp;России и&nbsp;СНГ","hotel.order_in_russia_and_abroad":"Бронирование гостиниц в&nbsp;России и&nbsp;за&nbsp;рубежом","hotel.abroad":"Отели за&nbsp;рубежом","hotel.additional":"Дополнительные опции","hotel.address":"Адрес","hotel.voucher_address":"Адрес","hotel.contacts":"Контакты","hotel.hotel_voucher":"Ваучер на размещение в гостинице","hotel.vouvher_vitusbering_director":'Генеральный директор ООО "Витус Беринг"',"hotel.vouvher_vitusbering_address":"г.Москва, Рязанский проспект, дом 8 А, стр. 1, этаж 5, офис 520","hotel.vouvher_vitusbering_directorname":"Кулюкин О.В.","hotel.promo":"<p>Самостоятельное бронирование отелей позволяет сэкономить на&nbsp;услугах турагентств и&nbsp;туроператоров.</p>\n\t\t\t\t\t\t\t<p>С&nbsp;Tutu.ru можно забронировать отель как для отдыха, так и&nbsp;для деловой поездки&nbsp;&#8212; удобно расположенный, современный, с&nbsp;подходящими условиями.</p>\n\t\t\t\t\t\t\t<p>Выбрав отель, вы&nbsp;можете сразу заказать подходящие ж/д или авиабилеты.</p>\n\t\t\t\t\t\t\t<p>Надежное бронирование&nbsp;&#8212; это простые и&nbsp;понятные действия. Это Tutu.ru.</p>","hotel.popular":"Популярные направления","hotel.buy_train_tickets":"Купить ж/д билеты","hotel.buy_avia_tickets":"Купить авиабилеты","hotel.cheap_tickets":"Дешевые авиабилеты&nbsp;&mdash; правда и вымысел","hotel.cost_tickets":"Стомость авиабилетов&nbsp;&mdash; секреты и советы","hotel.stages_booking":"Этапы бронирования гостиницы:","hotel.hotels_russia_sng":"Гостиницы в России и СНГ","hotel.hotels_russia_and_abroad":"Гостиницы в России и&nbsp;за&nbsp;рубежом","hotel.all_countries_cities":"Все города и страны","hotel.return_to_fullcitylist":"Вернуться к полному списку городов","hotel.all_cities_by_letter":"все города","hotel.change_city":"Поменять город","hotel.":"","hotel.contact_name":"ФИО","hotel.specify_contact_name":"Укажите ФИО.","hotel.contact_phone":"Телефон для связи","hotel.contact_phone2":"Запасной контактный телефон","hotel.specify_contact_phone":"Укажите контактный телефон.","hotel.specify_contact_phone2":"Укажите запасной контактный телефон.","hotel.contact_email":"Электронная почта","hotel.specify_contact_email":"Укажите контактный E-mail.","hotel.order_comment":"Дополнительная информация","hotel.distribution":"Размещение","hotel.extra_distribution":"Доп. размещение","hotel.extra_distributions":"Дополнительные размещения","hotel.contact_info":"Контактная информация","hotel.specify_contact_info":"Оставьте контактную информацию","hotel.persons":"Гости","hotel.persons_count":"Количество гостей","hotel.person_num":"Гость %num%","hotel.of_adults":"Взрослых","hotel.of_childs":"Детей","hotel.adults":"Взрослые","hotel.childs":"Дети","hotel.specify_adults_count":"Укажите количество взрослых.","hotel.specify_adults_count_as_number":"Количество гостей указано неправильно.","hotel.persons_count_too_large":"Указанное количество гостей превышает возможное для выбранных комнат.","hotel.specify_persons_hint":"В форме ниже укажите имя и фамилию хотя бы одного гостя.","hotel.guests_info":"Информация о гостях","hotel.specify_persons":"Укажите имена, фамилии и гражданство всех гостей.","hotel.specify_adults":"Укажите данные (имя/фамилия) для всех взрослых.","hotel.specify_childs":"Укажите данные (имя/фамилия) для всех детей.","hotel.specify_childs_age":"Укажите возраст для всех детей.","hotel.specify_childs_birthday":"Укажите дату рождения.","hotel.specify_last_name":"Укажите фамилию","hotel.specify_first_name":"Укажите имя","hotel.specify_citizenship":"Укажите гражданство","hotel.payment_type":"Способ оплаты","hotel.date_begin":"Заезд","hotel.date_end":"Отъезд","hotel.sort_by":"Сортировать по:","hotel.ctg":"Категория","hotel.order_detalization":"Детализация стоимости","hotel.by_the_day_detalization":"Посуточная детализация","hotel.person_last_name":"Фамилия","hotel.person_first_name":"Имя","hotel.person_middle_name":"Отчество","hotel.person_citizenship":"Гражданство","hotel.person_age":"Возраст","hotel.room":"Номер","hotel.hotel":"Гостиница","hotel.hoteleng":"Отель","hotel.order_dates":"Заезд - отъезд","hotel.order_rooms_distributions":"Номера (размещение)","hotel.order_status":"Статус бронирования","hotel.order_number":"Номер бронирования","hotel.order_number_page":"Номер вашего заказа %number%","hotel.extra_distribution_propolsal":"%title% %number_of_persons% чел. (%sum%)","hotel.no_offers":"На указанные вами даты предложений нет.","hotel.title_index":"Гостиницы","hotel.title_index_page":"Бронирование отелей и гостиниц по всему миру. Онлайн бронирование номеров на hotels.tutu.ru","hotel.title_index_foreign":"Отели","hotel.title_index_description":"Вы хотите поехать в путешествие и забронировать гостиницу или отель заранее? Предлагаем воспользоваться поиском и бронированием гостиниц. Вы сможете узнать цены и забронировать гостиницу онлайн online.","hotel.title_index_keywords":"гостиницы, города, отель, отели, город, цены, цена, бронирование, забронировать, online, онлайн","hotel.title_city":"Гостиницы %city_gen%. Цены онлайн на гостиницы и отели города %city_nom%, online бронирование гостиниц в %city_loc%.","hotel.title_city_foreign":"Отели %city_gen%. Цены онлайн на гостиницы города %city_nom%, online бронирование отелей в %city_loc%.","hotel.title_city_nav":"Гостиницы в %city_loc%","hotel.title_city_nav_foreign":"Отели в %city_loc%","hotel.title_city_nav_bottom":"Забронировать гостиницу в %city_loc%","hotel.title_city_nav_bottom_foreign":"Забронировать отель в %city_loc%","hotel.title_city_heading":"Гостиницы %city_gen%","hotel.title_city_heading_foreign":"Отели %city_gen%","hotel.title_city_description":"Вы хотите поехать в город %city_nom% и забронировать гостиницу или отель заранее? Предлагаем список гостиниц %city_gen%, есть возможность онлайн узнать цены и забронировать гостиницу в %city_loc% online.","hotel.title_city_keywords":"гостиницы, %city_gen%, города, отель, отели, город, %city_nom%, цены, цена, бронирование, забронировать, online, онлайн, в %city_loc%","hotel.category_title_city":"Гостиницы %city_gen% %categoryCount% %categoryCountText%. Цены онлайн на %categoryCountAdjText% гостиницы и отели в %city_loc%, online бронирование гостиниц - %city_nom%.","hotel.category_title_city_foreign":"Отели %city_gen% %categoryCount% %categoryCountText%. Цены онлайн на %categoryCountAdjText% отели города %city_nom%, online бронирование гостиниц в %city_loc%.","hotel.category_keywords_city":"гостиницы и отели %city_gen% %categoryCount% %categoryCountText%, цены на гостиницы в %city_loc%, цена отеля в городе %city_loc%, бронирование, забронировать, online, онлайн","hotel.category_keywords_city_foreign":"гостиницы и отели %city_gen% %categoryCount% %categoryCountText%, цены на %categoryCountAdjText% отели %city_gen%, забронировать гостиницу в %city_loc% онлайн","hotel.category_description_city":"Вы хотите поехать в %city_acc% и забронировать гостиницу или отель %categoryCount% %categoryCountText% заранее? Предлагаем список %categoryCountAdjGenText% гостиниц %city_gen%, есть возможность онлайн узнать цены и забронировать гостиницу в %city_loc% online.","hotel.category_description_city_foreign":"Вы хотите поехать в город %city_nom% и забронировать гостиницу или отель %categoryCount% %categoryCountText% заранее? Предлагаем список %categoryCountAdjGenText% отелей %city_gen%, есть возможность онлайн узнать цены и забронировать гостиницу в %city_loc% online.","hotel.category_heading_city":"Гостиницы %city_gen% %categoryCount% %categoryCountText%","hotel.category_heading_city_foreign":"Отели %city_gen% %categoryCount% %categoryCountText%","hotel.category_popular_hotels_country":"Все гостиницы %city_gen%, %categoryCount% %categoryCountText%","hotel.category_popular_hotels_country_foreign":"Все отели %city_gen%, %categoryCount% %categoryCountText%","hotel.category_nav_city":"Отели %city_gen% %categoryCount% %categoryCountText%","hotel.category_nav_city_foreign":"Гостиницы в %city_loc% %categoryCount% %categoryCountText%","hotel.category_nav_city_bottom":"Забронировать %categoryCountAdjText% отель в %city_loc%","hotel.category_nav_city_bottom_foreign":"Забронировать %categoryCountAdjText% отель в %city_loc%","hotel.category_nav_simple_city":"Все гостиницы в %city_loc%","hotel.category_nav_simple_city_foreign":"Все отели %city_gen%","hotel.category_nav_simple_city_bottom":"Все отели в %city_loc%","hotel.category_nav_simple_city_bottom_foreign":"Все гостиницы %city_gen%","hotel.title_country":"Гостиницы %country_gen%, бронирование отелей %preposition% %country_loc% онлайн","hotel.title_country_foreign":"Отели %country_gen%, бронирование гостиниц %preposition% %country_loc% онлайн","hotel.title_country_heading":"Гостиницы %country_gen%","hotel.title_country_heading_foreign":"Отели %country_gen%","hotel.title_russia_country":"Гостиницы России","hotel.title_country_description":"Вы хотите поехать в %country_acc% и забронировать гостиницу или отель заранее? Предлагаем список городов и гостиниц %country_gen%, есть возможность онлайн узнать цены и забронировать гостиницу в %country_loc% online.","hotel.title_country_keywords":"гостиницы, %country_gen%, страна, страны, города, отель, отели, город, %country_nom%, цены, цена, бронирование, забронировать, online, онлайн, в %country_loc%","hotel.title_room_booking":"Бронирование номера","hotel.title_hotel_booking":"Бронирование гостиницы &laquo;%name%&raquo;","hotel.title_hotel_booking_foreign":"Бронирование отеля &laquo;%name%&raquo;","hotel.title_hotel_orders":"Ваши заказы на бронирование гостиниц","hotel.title_hotel_order":"Заказ № %number%","hotel.title_hotel_order_prepare":"Подготовить заказ № %number% к оплате","hotel.title_hotel_order_voucher":"Распечатать ваучер заказа № %number%","hotel.title_processing_order":"Обработка заказа № %number%","hotel.title_hotel":"Гостиница &laquo;%name%&raquo; (%city_name%), стоимость проживания, бронирование номера онлайн, отель &laquo;%name%&raquo; - адрес, описание, порядок проживания","hotel.title_hotel_no_title":"&laquo;%name%&raquo; (%city_name%), стоимость проживания, бронирование номера онлайн, отель &laquo;%name%&raquo; - адрес, описание, порядок проживания","hotel.title_hotel_foreign":"Отель &laquo;%name%&raquo; (%city_name%), стоимость проживания, бронирование номера онлайн, гостиница &laquo;%name%&raquo; - адрес, описание, порядок проживания","hotel.title_hotel_nav":"Гостиница &laquo;%name%&raquo;","hotel.title_hotel_nav_no_title":"&laquo;%name%&raquo;","hotel.title_hotel_nav_foreign":"Отель &laquo;%name%&raquo;","hotel.title_hotel_description":"Подробное описание гостиницы %name% (%city_name%), просмотр стоимости проживания на выбранную дату, возможность online бронирования номера","hotel.title_hotel_keywords":"гостиница, %name%, %city_name%, стоимость, проживание, бронирование, номера, описание, отель, online, заказ, размещение","hotel.title_cities_by_letter":"Города на букву &laquo;%letter%&raquo;","hotel.no_such_order":"Нет такого заказа.","hotel.cannot_create_order":"Ошибка бронирования. Невозможно создать заказ.","hotel.no_user_orders":"Нет заказов.","hotel.no_such_room":"Неправильно указан гостиничный номер.","hotel.no_such_distribution":"Неправильно указано размещение в номере гостиницы.","hotel.specify_user":"Укажите пользователя.","hotel.specify_hotel":"Укажите гостиницу.","hotel.no_such_hotel":"Неправильно указана гостиница.","hotel.specify_room_ids":"Выберите номер и размещение.","hotel.specify_one_room":"Для данного отеля допускается выбрать только один номер.","hotel.room_already_occupied":"Выбранный вами номер на данный момент недоступен для бронирования. Пожалуйста, выберите другой номер.","hotel.room_enter_date_begin":"Введите даты заезда и отъезда","hotel.specify_date_begin":"Укажите дату заезда.","hotel.specify_date_end":"Укажите дату отъезда.","hotel.wrong_date_begin":"Неправильная дата заезда.","hotel.wrong_date_end":"Неправильная дата отъезда.","hotel.wrong_order_range":"Между выбранными датами заезда и отъезда должно быть не более 30 дней. Пожалуйста, введите другие даты и попробуйте снова.","hotel.wrong_order_range_dates":"Неправильные даты заезда и отъезда. Пожалуйста, введите другие даты и попробуйте снова.","hotel.wrong_order_range_limit":"Даты заезда/отъезда должны быть в пределах 360-ти дней от сегодняшнего числа. Пожалуйста, введите другие даты и попробуйте снова.","hotel.wrong_order_range_begin":"Нельзя бронировать отель на сегодня.","hotel.specify_dates":"Пожалуйста, уточните даты, чтобы мы смогли проверить наличие мест.<br/>Если даты неизвестны, поставьте галочку напротив этого пункта.","hotel.status_is":'Заказ № %number% имеет статус: "%status%".',"hotel.cannot_request":"Невозможно забронировать номер.","hotel.cannot_confirm":"Невозможно подтвердить заказ.","hotel.cannot_prepare":"Невозможно создать платежный документ.","hotel.cannot_cancel":"Невозможно отменить заказ.","hotel.cannot_pay":"Невозможно отметить заказ как оплаченный. Система бронирования не подтверждает оплату.","hotel.cannot_completed":"Невозможно завершить заказ. Система бронирования не подтверждает оплату.","hotel.need_confirmation_to_pay":"Невозможно перейти к оплате. Неправильный статус заказа.","hotel.foreign_system_error":"Ошибка системы бронирования. Попробуйте позднее.","hotel.are_you_sure_cancel":"Вы уверены, что хотите отменить это бронирование?","hotel.order_was_cancelled":"Вы отменили заказ на бронирование гостиницы.","hotel.specify_city_id":"Укажите город.","hotel.specify_country":"Укажите страну.","hotel.specify_country_city_hotel":"Укажите страну, город или отель.","hotel.wrong_city":"Неправильно указан город.","hotel.specify_action":"Укажите правильно действие, которое нужно выполнить с заказом.","hotel.cannot_change_status":'Невозможно изменить статус бронирования с "%current_status%" на "%new_status%".',"hotel.status_changed":'Статус бронирования успешно изменен на "%status%".',"hotel.status_already_changed":'Статус бронирования уже установлен как "%status%".',"hotel.wrong_status_cannot_process":'Бронирование имеет статус "%status%". Нельзя изменить данные этого шага.',"hotel.wrong_status_cannot_pay":"Неправильный статус бронирования. Невозможно перейти к оплате.","hotel.status_already_paid":"Заказ уже оплачен.","hotel.wrong_status_cannot_print_voucher":"Неправильный статус бронирования. Невозможно распечатать ваучер.","hotel.wrong_url_cannot_print_voucher":"Неправильная ссылка. Невозможно распечатать ваучер.","hotel.need_search_dates":"Сортировка по цене возможна только при указании дат заезда и отъезда.","hotel.system_response_error":"Ошибка соединения с системой бронирования. Попробуйте еще раз.","hotel.no_such_sort":"Указана неправильная сортировка.","hotel.cannot_make_payment":"Платежная система не принимает оплату.","hotel.pay_in_bank_currency":"Оплата в валюте (%cur%)","hotel.pay_in_bank_currency_tip":"Необходимая сумма будет списана с карточки по курсу вашего банка.","hotel.rack_rate_tip":"Цена на стойке","hotel.need_dates_to_see_price":"<noindex>Пожалуйста, укажите период проживания, чтобы узнать</noindex> точные цены.","hotel.full_hotel_info":"Полная информация о&nbsp;гостинице","hotel.money_format":"%sum% %cur%","hotel.money_format_short":"%sum%%cur%","hotel.money_format_from":"от %sum% %cur%","hotel.period_sum":"Стоимость","hotel.sum":"Стоимость","hotel.date":"Дата","hotel.day_price":"Цена за сутки","hotel.min_day_price":"Минимальные<br/>цены за сутки","hotel.min_day_price_tip":"<p>Эта минимальная цена может отличаться от цены за конкретный период.</p><p>Чтобы узнать точную стоимость проживания, пожалуйста, укажите даты поездки.</p>","hotel.night_price":"%price% за ночь","hotel.night_price_from":"От %price% за ночь","hotel.hotel_country_popular":"От %price% &mdash; %city_name%","hotel.hotel_country_popular_sv":'От <a href="%url%">%price%</a> — %city_name%',"hotel.hotel_country_service":"От %price% — %stars%%city_name%","hotel.hotel_night_price":'<p class="hotel-price-number">Точная стоимость зависит от периода проживания.<br/>Примерная стоимость &mdash; <span class="red">%price%</span> за ночь.</p>',"hotel.period_price":"Стоимость за период","hotel.price":"Цена","hotel.reserve_price":"Сумма, взимаемая гостиницей за услугу предварительного бронирования (включена в итоговую стоимость)","hotel.reserve_percent":"Процент, взимаемый гостиницей за услугу предварительного бронирования (включен в итоговую стоимость)","hotel.total":"Итого","hotel.total_to_pay":"Сумма к оплате","hotel.date_range":"с %date_begin% по %date_end%","hotel.breakfast_price":"Включить завтрак в стоимость (+ %price% %cur% с человека)","hotel.breakfast_for_person":"Завтрак + %price% %cur% с человека","hotel.possible_breakfast":"как дополнительная услуга %price% %cur%.","hotel.need_confirmation":"по&nbsp;запросу","hotel.need_confirmation_cap":"По&nbsp;запросу","hotel.need_confirmation_tip":"Гостиница подтвердит это размещение после того,<br />как вы отправите нам заявку","hotel.online":"онлайн","hotel.online_cap":"Онлайн","hotel.online_tip":"Гостиница подтверждает, что этот номер свободен","hotel.online_or_confirmation":"По&nbsp;запросу/<br />онлайн","hotel.view_all_distribution":"показать все варианты размещения","hotel.view_all_rooms":"все номера","hotel.period":"Длительность пребывания","hotel.periods":"Периоды","hotel.period_in_days":"%days% суток","hotel.service_type_hotel":"Услуги в гостинице","hotel.service_type_hotel_foreign":"Услуги в отеле","hotel.service_type_living":"Порядок проживания","hotel.average_note":"Средняя оценка","hotel.coord_short":"коорд","hotel.hotels_in_world":"Отели в мире","hotel.services_rules":"Правила сервиса","hotel.payment_methods":"Способы оплаты","hotel.choose_this_payment_type":"Выбрать этот способ оплаты","hotel.get_path_to":"Как проехать","hotel.get_path_to_by_description":"Схема проезда. Описание","hotel.get_path_to_by_scheme":"Схема проезда. Карта Google/Яndex","hotel.get_path_to_by_maps":"Схема проезда. Карты и схемы","hotel.comments_qty":"Отзывов","hotel.comments":"Отзывы","hotel.information":"Информация о гостинице и бронирование","hotel.reservation_and_accomodation_cost":"Стоимость проживания и бронирование","hotel.number_of_rooms":"Количество номеров","hotel.breakfast":"Завтрак","hotel.breakfast_sum":"Стоимость завтрака","hotel.breakfast_included":"Завтрак включен в стоимость номера","hotel.order":"Заказать","hotel.reserve":"Бронировать","hotel.foreign_comment":"Примечания","hotel.surrounding":"Ближайшие","hotel.km":"км","hotel.distance_to_metro":"Ближайшие станции метро","hotel.distance_to_railway":"Ближайшие жд станции","hotel.distance_to_airport":"Ближайшие аэропорты","hotel.distance_to_seaport":"Ближайшие морские/речные порты","hotel.distance_to_hotel":"Ближайшие гостиницы","hotel.distance_to_city_center":"До центра города","hotel.i_agreee_with_service_conditions":'Я согласен с <a href="#" onclick="%onclick%">правилами использования сервиса</a>',"hotel.specify_confirmation":"Укажите, что согласны с правилами использования сервиса.","hotel.view_big_map":"Посмотреть увеличенную карту","hotel.world_hotels":"Бронирование отелей по всему миру","hotel.hotel_auth_tip":'<p style="padding-bottom:13px;">Для бронирования гостиницы необходима авторизация. Введите в форму свою электронную почту и пароль.</p>',"hotel.hotel_reg_tip":'<p style="padding-bottom:13px;">Если вы еще не зарегистрированы, то достаточно указать только электронную почту и поставить галочку автоматической регистрации.</p><p style="padding-bottom:13px;">После регистрации вы сможете отслеживать статус заказа в личном кабинете.</p>',"hotel.location_map":"Схема проезда","hotel.hotel_gallery":"Фотографии гостиницы","hotel.hotel_gallery_around":"Фотографии округи","hotel.photos":"Фотографии","hotel.reviews":"Отзывы","hotel.username":"Имя пользователя","hotel.email":"Email","hotel.comment":"Текст жалобы","hotel.captcha":"Каптча","hotel.invalid_captcha":"Неверный код каптчи","hotel.at_list_one_item":"Вы должны проголосовать хотя бы за один критерий.","hotel.traveler_type_id":"Тип путешественника","hotel.travel_date":"Дата посещения гостиницы","hotel.average_hotel":"Средняя оценка по гостинице","hotel.add_review":"Оставить свой отзыв","hotel.average":"Средняя оценка","hotel.visited":"Посетил гостиницу в","hotel.as":"как","hotel.feedback_on":"Отзыв оставлен","hotel.complain":"Пожаловаться","hotel.back_to_reviews":"Вернуться к списку отзывов","hotel.type_traveler":"Тип путешественника","hotel.select_type_traveler":"Выберите тип путешественника","hotel.date_visit":"Дата посещения гостиницы","hotel.plus":"Положительные стороны","hotel.minus":"Отрицательные стороны","hotel.general_review":"Общий отзыв","hotel.survey":"Голосуем","hotel.capthca":"Капча","hotel.details":"загрузка данных...","hotel.hotel_rules":"Порядок проживания в гостинице","hotel.hotel_rules_foreign":"Порядок проживания в отеле","hotel.room_text":"","hotel.facilities":"Услуги в номере","hotel.policy_title":"Policy title","hotel.policies":"Порядок проживания","hotel.policies_and_anrules":"Порядок проживания и правила аннуляции","hotel.policy_summary_included":"В стоимость включено","hotel.policy_summary_excluded":"В стоимость НЕ входит","hotel.policy_hotel_pets":"Домашние животные","hotel.policy_children":"Размещение детей","hotel.policy_cancellation":"Аннуляция заказа","hotel.policy_cancellation_mark":"Правила отмены бронирования зависят от типа номера. Пожалуйста, ознакомьтесь с условиями бронирования номера при выборе номера из показанных выше.","hotel.policy_hotel_internet":"Интернет","hotel.policy_hotel_extracharges":"Доп. сборы","hotel.policy_prepay":"Депозит","hotel.policy_prepay_mark":"Правила предоплаты зависят от типа номера. Пожалуйста, ознакомьтесь с условиями бронирования номера при выборе номера из показанных выше.","hotel.policy_hotel_mealplan":"Завтрак","hotel.policy_hotel_parking":"Парковка","hotel.policy_preauthorize":"Предварительное блокирование средств на счету","hotel.policy_hotel_groups":"Коллективное бронирование","hotel.policy_pay_mark":"Оплата производится в отеле в местной валюте по курсу обмена валют на день оплаты. Курс валют может изменяться.","hotel.accept_creadit_cards":"Принимаемые кредитные карты","hotel.num_hotels":"%count% гостиниц","hotel.score":"Оценка","hotel.score_by_num_reviews":"по %number% %reviews%","hotel.reviews_1":"отзыву","hotel.reviews_2":"отзывам","hotel.reviews_3":"отзывам","hotel.available":"Доступно","hotel.facilities_short":"Услуги","hotel.sort_offers":"Сортировать","hotel.prange_all":"все","hotel.prange":"%from%&mdash;%to% р.","hotel.prange_0_1000":"до 1000 р.","hotel.prange_1000_3000":"1000&mdash;3000 р.","hotel.prange_3000_10000":"3000&mdash;10000 р.","hotel.prange_10000_20000":"10000&mdash;20000 р.","hotel.category":"Звездность","hotel.any_category":"любые","hotel.add_to_favorites":"Добавить в избранное","hotel.paste_in_blog":"Вставить описание отеля в блог","hotel.print_description":"Напечатать описание","hotel.to_reserve":"Забронировать","hotel.search_on_map":"Поиск на карте","hotel.hotels_in_all_world":"Гостиницы и отели по всему миру","hotel.countries":"Страны","hotel.sort_alphabet":"по алфавиту","hotel.sort_popular":"по популярности","hotel.sort_continent":"по континентам","hotel.count_info":"%hotels% %hotelText% в %cities% %cityText% в %countries% %countryText%","hotel.count_info_country":"%hotels% %hotelText% в %cities% %cityText%","hotel.direction":"Направление","hotel.arrival_day":"День заезда","hotel.departure_day":"День отъезда","hotel.extended_search":"Расширенный поиск","hotel.show_hotels":"Показать гостиницы и отели","hotel.cities":"Города","hotel.all_countries":"Все страны","hotel.nearby_cities":"Города рядом","hotel.airports":"Аэропорты","hotel.stations":"Железнодорожные станции","hotel.metro_link":"Метро в городе %name%","hotel.poezda_link":"Расписание поездов дальнего следования в городе %name%","hotel.taxi_link":"Такси в городе %name%","hotel.see_also":"Смотрите также","hotel.open_hotels":"Показать","hotel.return_to_city":"Вернуться к гостиницам %name%","hotel.rooms_available_date":"Номера %date%","hotel.rooms_available":"Номера","hotel.change_date":"Изменить дату","hotel.to_blog":"Вставить описание номера в блог","hotel.services_remark":"Данные правила проживания в отеле являются общими и могут варьироваться в зависимости от типа номера. Пожалуйста, проверьте описание вашего номера.","hotel.reserve_room":"Забронировать номер","hotel.nearby_hotels":"Ближайшие гостиницы","hotel.nearby_hotels_foreign":"Ближайшие отели","hotel.select_facilities":"Выбрать услуги ...","hotel.period_summary":"Стоимость указана за номер за %n% %night%.","hotel.period_summary_short":"Стоимость указана за %n% %night%.","hotel.nights":"%n% %night%","hotel.night_1":"ночь","hotel.night_2":"ночи","hotel.night_3":"ночей","hotel.distance_measure_big_unit":"км.","hotel.distance_measure_unit":"м.","hotel.return_to_hotel":"Вернуться к выбору мест","hotel.popular_hotels_cities":"Популярные города и отели","hotel.popular_hotels_country":"Популярные гостиницы %country_gen%","hotel.popular_hotels_country_foreign":"Популярные отели %country_gen%","hotel.popular_hotels_children":"Отели для отдыха с детьми","hotel.popular_hotels_children_foreign":"Отели для отдыха с детьми","hotel.popular_hotels_aqua":"Лучшие гостиницы с аквапарками","hotel.popular_hotels_aqua_foreign":"Лучшие отели с аквапарками","hotel.checkin_info":"Регистрация","hotel.checkin":"Регистрация заезда с %time% часов.","hotel.checkout":"Регистрация отъезда до %time% часов.","hotel.available_dates":"%dates_range% %avail_noun% %separator% %hotels_num% %hotel_noun% в %city_loc%.","hotel.available_wo_dates":"%avail_noun% %separator% %hotels_num% %hotel_noun% в %city_loc%.","hotel.noun_hotel_1":"гостиница","hotel.noun_hotel_2":"гостиницы","hotel.noun_hotel_3":"гостиниц","hotel.noun_avail_1":"доступна","hotel.noun_avail_2":"доступно","hotel.noun_avail_3":"доступно","hotel.noun_avail_1_man":"доступен","hotel.noun_avail_1_cap":"Доступна","hotel.noun_avail_2_cap":"Доступно","hotel.noun_avail_3_cap":"Доступно","hotel.noun_avail_1_cap_man":"Доступен","hotel.category_available_dates":"%dates_range% %avail_noun% %separator% %hotels_num% %categoryCountAdjGenText% %hotel_noun% в %city_loc%.","hotel.category_available_wo_dates":"%avail_noun% %separator% %hotels_num% %categoryCountAdjGenText% %hotel_noun% в %city_loc%.","hotel.dont_know_dates":"Точные даты поездки пока неизвестны ","hotel.https_protocol_used":"Все данные передаются по защищенному каналу.","hotel.show_on_map":"Показать на карте","hotel.on_map":"На карте","hotel.title_from_avia":"Гостиницы и отели","hotel.mini_descr":"Бронирование отелей за рубежом и гостиниц в России и СНГ","hotel.no_hotels_in_country":"К сожалению, сейчас нам не удалось найти гостиницы в государстве %country%.","hotel.wizard_next":"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Далее&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;","hotel.wizard_expired":'Бронирование с указанным result_id устарело. Вернитесь на <a href="%url%">главную страницу</a> и выберите гостиницу.',"hotel.one_of_a_million_baby":"Лучшие из %count% отелей","hotel.mail_from":"Tutu.ru | отели","hotel.all_rooms_deposit_required":"Все номера<br/>по предоплате","hotel.part_rooms_deposit_required":"Часть номеров<br/>по предоплате","hotel.deposit_required_tip":"Проживание в этом отеле нужно оплатить на сайте заранее.<br/>Оплата производится банковской картой.","hotel.category_min_prices":"Минимальные цены в отелях %city_gen%","hotel.avia_tickets":"Авиабилеты","hotel.avia_tiser":"Регулярные и чартерные рейсы в Россию и за рубеж на Tutu.ru","hotel.interesting_places":"Интересные места","hotel.contacts_text":'\n\t\t<h1>Время работы сервиса</h1>\n\t\t<p>Сервис по бронированию отелей работает круглосуточно и без выходных. Заявки принимаются в режиме 7/24/365.</p>\n\t\t<br />\n\t\t<h2>Сведения об организации</h2>\n\t\t<p>ООО "Майнд Бридж Груп"</p>\n\t\t<p>ОГРН: 1027723001305</p>\n\t\t<p>Почтовый адрес: Россия, Москва, 1-й Нагатинский проезд, дом 2, строение 7, оф. 310</p>\n\t\t<p>Индекс: 117105</p>\n\t',"hotel.message_no_hotel":"Отелей/гостиниц по выбранным параметрам не найдено!","hotel.message_category_no_hotel":"Отелей/гостиниц по выбранным параметрам (%categoryCount% %categoryCountText%) не найдено!","hotel.single":"одноместный","hotel.hotel_properties":"Особенности отелей %city_gen%","hotel.hotel_properties_foreign":"Особенности отелей %city_gen%","hotel.hotel_toavia":"Как добраться по воздуху","hotel.hotel_toavia_text":"Авиабилеты в %city%","hotel.city_toptext":"Удобный выбор и&nbsp;онлайн бронирование гостиниц %city%.\n\t\t\t\t\t\t\t\tФотографии и&nbsp;описания номеров помогут выбрать подходящую гостиницу.\n\t\t\t\t\t\t\t\tПоиск вариантов на&nbsp;любой вкус и&nbsp;кошелек.","hotel.city_no_hotels_with_links":'К&nbsp;сожалению, сейчас %categoryCountAdjText% отели %city% недоступны.<br />\n\t\t\t\t\t\t\t\t\tВы&nbsp;можете посмотреть гостиницы города\n\t\t\t\t\t\t\t\t\t<ul class="list">%links%</ul>\n\t\t\t\t\t\t\t\t\tили сразу <a href="%allUrl%">все отели в %incity%</a>',"hotel.city_no_hotels":'К&nbsp;сожалению, сейчас %categoryCountAdjText% отели %city% недоступны.<br />\n\t\t\t\t\t\t\t\t\tВы можете посмотреть <a href="%allUrl%">все отели в %incity%</a>',"main.about_title":"Жд билеты с Туту.ру","main.about_title2":"Авиабилеты на Туту.ру","main.about_part_1":'\n\n\t\t<p>\n\t\tВсе больше людей осуществляют заказ жд билетов через интернет. Также растет число выбравших заказ <noindex>авиабилетов</noindex> онлайн. О&nbsp;большом количестве людей, покупающих ж/д&nbsp;билеты <noindex>и&nbsp;авиабилеты</noindex> в Сети, можно судить, к&nbsp;примеру, по&nbsp;популярности Tutu.ru. Количество посетителей сайта постоянно увеличивается за счет добавления новых и&nbsp;сохранения старых пользователей.\n\t\t</p>\n\t\t<p>Чтобы перевезти всех посетителей сайта Tutu.ru, которые пришли на&nbsp;соответствующие разделы сайта, каждый день будет необходимо 45&nbsp;поездов дальнего следования и&nbsp;19&nbsp;самолетов Airbus&nbsp;A380. Заметим, что Airbus&nbsp;А380 — самый большой на&nbsp;сегодняшний день пассажирский самолет, который вмещает более пятисот человек. Заказ жд&nbsp;билетов традиционно пользуется заметно большим спросом,\n\t\t<noindex>чем&nbsp;заказ авиабилетов. Как&nbsp;правило, поезда более доступный и&nbsp;распространенный транспорт.\n\t\t</noindex></p>\n\t\t<p>Сегодня заказать жд билеты можно на&nbsp;многих сайтах, также немало интернет-ресурсов оказывают услуги по&nbsp;заказу <noindex>авиабилетов</noindex>. Как&nbsp;же выбрать лучшее предложение и&nbsp;стоит&nbsp;ли вообще заказывать железнодорожные билеты через&nbsp;интернет?\n\t\t</p>\n\t\t<h2 style="font-size: 9pt;">Преимущества заказа ж/д билетов через интернет</h2>\n\t\t<ul class="simple-list">\n\t\t<li class="item">&mdash;&nbsp;Через интернет можно быстро узнать наличие железнодорожных билетов на&nbsp;различные места (от&nbsp;сидячих до&nbsp;мест повышенной комфортности), также быстро доступна и&nbsp;стоимость билетов.</li>\n\t\t<li class="item">&mdash;&nbsp;Покупка ж/д билетов онлайн на&nbsp;Tutu.ru&nbsp;&mdash; это экономия нескольких часов. Вам не&nbsp;нужно ехать на&nbsp;вокзал и&nbsp;стоять там в&nbsp;очередях.</li>\n\t\t<li class="item">&mdash;&nbsp;Вы&nbsp;можете выбрать подходящий поезд, варьируя даты и&nbsp;стоимость. Можно даже заранее определить место в&nbsp;вагоне, вплоть до&nbsp;конкретной полки, на&nbsp;которую вы&nbsp;заказываете \n\t\t<nobr><a href="http://www.tutu.ru/poezda/e-zakaz/">электронный ж/д билет.</a></nobr></li>\n\t\t<li class="item">&mdash;&nbsp;Для большинства поездов доступна электронная регистрация, при которой вам не&nbsp;нужно получать билет на&nbsp;бумажном бланке.</li>\n\t\t<li class="item">&mdash;&nbsp;Купить железнодорожные билеты на&nbsp;поезд <!--банковской картой--> можно в&nbsp;любой точке мира, где есть подключение к&nbsp;интернету. Кроме электронных способов (включая оплату банковской картой), вы&nbsp;можете воспользоваться еще несколькими вариантами: через терминалы, оплатой курьеру и&nbsp;в&nbsp;офисе, либо в&nbsp;салонах Евросети.</li>\n\t\t</ul>\n\t\n\t',"main.about_part_2":'\n\t\t<p>\n\t\t\tНаш сайт предоставляет <a href="http://avia.tutu.ru/">удобный сервис по&nbsp;поиску авиабилетов и&nbsp;рейсов</a> на&nbsp;любые направления в&nbsp;40&nbsp;000 городов более чем 240&nbsp;стран мира.\n\t\t\tКроме сервисов поиска <noindex>и&nbsp;заказа авиабилетов</noindex>, на&nbsp;нашем сайте расположена справочная информация по&nbsp;<a href="http://avia.tutu.ru/airport/">аэропортам России и&nbsp;мира</a>,\n\t\t\tпо&nbsp;<a href="http://avia.tutu.ru/airline/">авиакомпаниям</a>, а&nbsp;также <a href="http://avia.tutu.ru/plane/">самолетам</a>.\n\t\t</p>\n\t\t<p>\n\t\t\t<noindex>Заказывая билет у&nbsp;нас, вы&nbsp;пользуетесь международными системами бронирования, а&nbsp;настройки поиска позволяют упорядочить варианты перелета по&nbsp;стоимости авиабилета, по&nbsp;классу обслуживания, по&nbsp;наличию пересадок.</noindex>\n\t\t</p>\n\t\t<noindex>\n\t\t<h2 style="font-size: 9pt;">Оплата и&nbsp;получение авиабилетов</h2>\n\t\t<p style="margin-bottom: 5px; padding-bottom: 0;">\n\t\tВы&nbsp;можете оплатить авиабилет следующими способами:\n\t\t</p>\n\t\t<ul class="simple-list">\n\t\t\t<li class="item">&mdash;&nbsp;банковской картой,</li>\n\t\t\t<li class="item">&mdash;&nbsp;наличными (курьеру, либо в&nbsp;офисе агентства),</li>\n\t\t\t<li class="item">&mdash;&nbsp;наличными в&nbsp;платежных терминалах Qiwi,</li>\n\t\t\t<li class="item">&mdash;&nbsp;электронными деньгами (с&nbsp;помощью сервиса Яндекс.Деньги).</li>\n\t\t</ul>\n\t\t<p>\n\t\t\tПолучение авиабилета происходит либо по электронной почте (при оплате банковской картой), либо в&nbsp;офисе Туту.ру, либо у&nbsp;курьера.\n\t\t\tВыбор способа доставки авиабилета происходит в&nbsp;процессе заказа.\n\t\t</p>\n\t\t</noindex>\n\t\t<h3 style="font-size: 9pt;">Информация о&nbsp;стоимости и&nbsp;наличии мест</h3>\n\t\t<p>\n\t\t\tУже сейчас на&nbsp;Tutu.ru очень легко узнать стоимость и&nbsp;наличие мест&nbsp;&mdash; как в&nbsp;самолетах, так и&nbsp;в&nbsp;поездах. А&nbsp;чтобы купить ж/д билет <noindex>или авиабилет</noindex> на&nbsp;нашем сайте, нужно потратить не&nbsp;больше 5&nbsp;минут: достаточно выбрать нужный рейс и&nbsp;цену, ввести данные пассажиров и&nbsp;выбрать способ оплаты.\n\t\t</p>',"main.form_avia":"Авиабилеты","main.form_dtrain":"Ж/д билеты","main.form_dtrain_noresult":'По вашему запросу ж/д станций не найдено, если вы ищете авиабилет, переключите тип поиска или пройдите по&nbsp;<a href="%url%">ссылке</a>.',"main.form_hotels":"Гостиницы","main.aeroexpress_sheremetevo":"Шереметьево","main.aeroexpress_domodedovo":"Домодедово","main.aeroexpress_vnukovo":"Внуково","main.train_benefits":"Бумажный или электронный билет, что выбрать","main.train_instruction":"Как купить электронный билет","main.train_payment":"Способы оплаты ж/д билета","main.train_cheap_train":"Как найти дешевый ж/д билет?","main.for_press":"Для прессы","main.press_to_exchange":"Нажмите, чтобы поменять местами города","main.commersant_text":"самый популярный<br /> туристический сайт<br /> в России","main.commersant_small_text":"Газета &laquo;Коммерсант&raquo;,<br />&#8470;&nbsp;24 (4809)","bad_client.user_message":"В настоящий момент происходит переиндексация базы данных. \n\t\tМы прилагаем все усилия, чтобы завершить этот процесс быстрее. Приносим свои извинения.","bad_client.type_railway_order":"ЖД","taxi.taxi":"Такси","taxi.title":"Такси в аэропорт","taxi.mini_descr":"Заказ такси в любой аэропорт к вашему авиарейсу","taxi.price_min":"от %price% р.","taxi.from_station_other_destination":"Мне в другой район","taxi.to_station_other_destination":"Другой район","taxi.from_moscow_station":"Такси с %station_gen% в Москве","taxi.to_moscow_station":"Такси на %station_nom% в Москве","taxi.from_sheremetievo_to_station":"Из аэропорта Шереметьево","taxi.from_domodedovo_to_station":"Из аэропорта Домодедово","taxi.from_shel4ok_to_station":"От Щелковской","taxi.from_marino_to_station":"Из Марьино","taxi.from_altufievo_to_station":"Из Алтуфьево","taxi.from_station_to_sheremetievo":"В аэропорт Шереметьево","taxi.from_station_to_domodedovo":"В аэропорт Домодедово","taxi.from_station_to_shel4ok":"До Щелковской","taxi.from_station_to_marino":"До Марьино","taxi.from_station_to_altufievo":"До Алтуфьево","carrier.menu_world":"Все страны","carrier.menu_gus":"СНГ","carrier.carrier_title":"Авиакомпании","carrier.carrier_title_country":"Авиакомпании %country%","carrier.carrier_single":"Авиакомпания","carrier.carrier_single_title":"Авиакомпания %name%: расписание рейсов, заказ авиабилетов, тарифы, продажа авиабилетов, цены на билеты,доставка, описание компании %name_rus%","carrier.common":"Общая информация","carrier.comment_meta_title":"Авиакомпания %airportTitle%: %commentTitle%","carrier.title":"Название","carrier.iata":"IATA","carrier.gsga":"Внутренний код","carrier.site":"Сайт","carrier.site2":"Сайт 2","carrier.ikao":"ICAO","carrier.ikao_r":"ICAO рус","carrier.base":"Аэропорт базирования","carrier.name_rus":"Название рус.","carrier.name":"Название англ","carrier.tipe":"Виды перевозок","carrier.info_services":"Справочные службы","carrier.info":"Справочные службы","carrier.country":"Страна","carrier.add_info":"Дополнительно","carrier.description":"Описание","carrier.regular":"Регулярные","carrier.chart":"Чартерные","carrier.busines":"Бизнес","carrier.low_cost":"Low-cost","carrier.avia_taxi":"Авиатакси","carrier.gruz":"Грузовые","carrier.spetial":"Специальные","carrier.logo":"Логотип","carrier.our_fleet":"Самолетный парк","carrier.codes":"Кодировки","carrier.base_airport":"Базовый аэропорт","carrier.off_site":"Официальный сайт","carrier.operated_cities":"В какие города предлагает рейсы авиакомпания","carrier.all_operated_cities_1":"Все %number% город","carrier.all_operated_cities_2":"Все %number% города","carrier.all_operated_cities_3":"Все %number% городов","carrier.close_operated_cities":"Свернуть","print.headerSlogan":"Электронный ж/д билет на <b><i>Tutu.ru</i></b> &ndash; удобная оплата, быстрая покупка","print.bootomSeoText":'Электронный ж/д билет на Tutu.ru - удобная оплата, быстрая покупка<br/><br/>В любой точке мира\n\t\t\t\t\t\t\t\t\t\t\tвы можете оплатить электронный ж/д билет кредитной картой, электронными деньгами, а в России -\n\t\t\t\t\t\t\t\t\t\t\tи наличными деньгами (через Евросеть, платежные терминалы).<br/><br/>\n\t\t\t\t\t\t\t\t\t\t\tСразу после оплаты вы получите SMS с 14-значным кодом билета. Перед отправлением поезда подойдите в кассу\n\t\t\t\t\t\t\t\t\t\t\tРЖД на вокзале (только на территории России) с кодом билета и паспортом - получите бланк для посадки в поезд.\n\t\t\t\t\t\t\t\t\t\t\tПодробнее про электронный билет смотрите на <a href="http://tutu.ru">Tutu.ru</a>',"contacts.train_schedule_phone_moscow":"Билеты в Москве","contacts.train_schedule_phone_digital":"Электронные билеты","contacts.train_schedule_phone_tutu":"Помощь при покупке билетов","contacts.train_schedule_phone_contact":"Контакт-центр:","contacts.tutu_contacts_advert":'По  вопросам размещения рекламы на  <a href="%url%">Tutu.ru</a> обращайтесь в <a href="http://www.mindbridge.ru/" target=_blank>интернет-агентство MindBridge Group</a>.',"contacts.tutu_contacts_phone":"Тел.: <strong>+7 (495) 787-52-05</strong>","contacts.tutu_contacts_email":"Электронная почта:","contacts.tutu_contacts_icq":"ICQ: 168178287","contacts.tutu_contacts_time":"Ежедневно с&nbsp;9:00 до&nbsp;21:00&nbsp;&mdash; помощь при покупке билетов","wizard.no_such_wizard":"Указанный пошаговый интерфейс не существует.","wizard.wizard_expired":"Пошаговый интерфейс с указанным result_id устарел.","wizard.no_result_id":"Не указан result_id для пошагового интерфейса.","wizard.no_such_step":"Отсутствует обработчик для указанного шага.","wizard.no_steps":'Для интерфейса "%name%" на заданы пошаговые инструкции.',"wizard.next":"Далее &raquo;","wizard.previous":"&laquo; Назад","wizard.finish":"Завершить","wizard.return_step":"Вернуться на шаг &laquo;%name%&raquo;","wizard.error_identification":"Для защиты персональных данных вам нужно продолжить заказ на том же компьютере и в том же браузере, где он был начат. Браузер должен принимать cookies.","flight_order.cancelation_rule_title_default":"Стандартный","flight_order.cancelation_rule_text_default":"Возврат авиабилетов осуществляется по правилам авиакомпании. Напишите нам на info@tutu.ru для получения подробной информации.","flight_order.cancelation_rule_title_nochange_norefund":"Нет возврата и обмена","flight_order.cancelation_rule_text_nochange_norefund":"По правилам авиакомпании %carrier% этот авиабилет не подлежит обмену и возврату.","flight_order.cancelation_rule_title_nochange_refund":"Нет возврата, обмен есть","flight_order.cancelation_rule_text_nochange_refund":"По правилам авиакомпании %carrier% этот авиабилет не подлежит возврату. Обмен авиабилета возможен только до вылета. Условия обмена уточняйте в авиакомпании %carrier% или в справочной службе Туту.ру по телефону +7 (495) 987-21-05.","flight_order.cancelation_rule_title_change_refund":"Возможен обмен и возврат","flight_order.cancelation_rule_text_change_refund":"По правилам авиакомпании %carrier% этот билет можно вернуть или обменять до вылета. Условия обмена или возврата уточняйте в авиакомпании %carrier% или в справочной службе Туту.ру по телефону +7 (495) 987-21-05.","flight_order.cancelation_rule_title_strict_change_refund":"Возможен обмен и возврат более чем за сутки до вылета","flight_order.cancelation_rule_text_strict_change_refund":"По правилам авиакомпании %carrier% этот билет можно вернуть или обменять при обращении пассажира более чем за сутки до вылета самолета. Условия обмена или возврата уточняйте в авиакомпании %carrier% или в справочной службе Туту.ру по телефону +7 (495) 987-21-05.","etrain.msk.region":"Москва","etrain.msk.region2":"Москвы и Московской области","etrain.msk.main_meta_title":"Расписание электричек Москва %year%. Маршруты электропоездов со всех вокзалов, расписание движения пригородных поездов Москвы","etrain.msk.main_meta_keywords":"Расписание,электричек, электропоездов, Москвы, Санкт-Петербург %year%, пригородных,поездов,и,Московской,области,вокзалов,направлений","etrain.msk.main_meta_description":"Расписание электричек всех вокзалов Москвы и Санкт-Петербурга %year%. Расписание пригородных поездов. Расписание электропоездов Москвы.","etrain.msk.sms_schedule2_without_link":'<div class="schedule-sms_request-example">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_left"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_center">%smsText%</div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_right"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_number-black">SMS на номер <strong>%phone%</strong></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</div>Вы можете уточнить расписание перед поездкой по SMS',"etrain.msk.city":"Москвы","etrain.msk.phones":'<p class="phone">8 (800) 775-00-00 (круглосуточно, звонок бесплатный)</p>',"etrain.msk.city2":"Москва","etrain.msk.toCity":"на Москву","etrain.msk.scheme_meta_title":"%year% - Расписание электричек %railwayName% вокзала. Схема движения электропоездов %directionName% направления: %stationList%.","etrain.msk.news_meta_title":"Расписание пригородных поездов Москва %year% : все вокзалы, все направлени","etrain.msk.news_meta_keywords":"Расписание пригородных поездов всех вокзалов Москвы %year%","etrain.msk.news_meta_description":"Расписание,пригородных,поездов,электричек,Москвы,и,Московской,области,всех,вокзалов,всех,направлений,%year%","etrain.msk.":"","etrain.sms.metaTitle":"Tutu.ru - расписание электричек на мобильном телефоне с помощью SMS","etrain.sms.metaKeywords":"Tutu.ru - расписание электричек на мобильном телефоне: SMS-услуги","etrain.sms.metaDescription":"Tutu.ru - расписание электричек на мобильном телефоне с помощью SMS","etrain.sms.title":"2320 и «%prefix%» – %title%!","etrain.sms.description_title":"Расписание электричек по SMS","etrain.sms.description":"C помощью этого сервиса вы можете узнать, в какое время электрички идут от одной станции до другой,\n\t\tкакие электрички пройдут после указанного времени или когда электричка проходит определенную станцию.","etrain.sms.description2":'Чтобы узнать расписание ближайших электричек,<br />\n\t\tотправьте текст <i>«<span class="red">%prefix%</span>»</i> с названиями станций<br />\n\t\tи временем на номер <b class="red"><i>2320</i></b>.',"etrain.sms.description3":'Актуальное расписание электричек по %cityAndRegion3% в вашем телефоне.\n\t\tSMS-расписание Tutu.ru учитывает сезонные и временные изменения<span class="red" >*</span>.',"etrain.sms.description4":"Правила транслитерации","etrain.sms.description5":"Названия станций можно писать как латиницей, так и кириллицей — но на всякий случай мы даем таблицу\n\t\tтранслитерации. Регистр букв значения не имеет.","etrain.sms.example_title":'Варианты текстовых сообщений на номер <b class="red" >2320</b>',"etrain.sms.example_number":"На номер <b>2320</b>","etrain.sms.example":"Электрички в ближайшее время","etrain.sms.example2":"Из %city2% в область","etrain.sms.example3":"Так вы узнаете время отправления 5-ти электричек,\n\t\tидущих %fromCityToRegionAnswer% в ближайшее после отправки SMS время.","etrain.sms.example4":"Из Области в %city4%","etrain.sms.example5":"Так вы узнаете время отправления 5-ти электричек,\n\t\tидущих %fromRegionToCityAnswer% в ближайшее после отправки SMS время.","etrain.sms.example6":"От станции в сторону %city2%","etrain.sms.example7":"Так вы узнаете время отправления от этой станции 3-х ближайших\n\t\tк времени отправки SMS электричек в сторону %city2%.","etrain.sms.example8":"Станции с длинными названиями","etrain.sms.example9":"Вы можете отправить часть названия для станций с длинными именами.","etrain.sms.example10":"Электрички в строго определенное время","etrain.sms.example11":"От станции до станции <br />в строго определенное время","etrain.sms.example12":"Так вы узнаете время отправления первых 5-ти электричек после 18:30,\n\t\tидущих %timeAnswer%.","etrain.sms.example13":"От станции в сторону %city2%<br />в определенное время","etrain.sms.example14":"Так вы узнаете время отправления от этой станции\n\t\tпервых 3-х электричек после 23:45 в сторону %city2%.","etrain.sms.operator":"Стоимость одного СМС для абонентов Билайн, МТС,\n\t\tМегаФон, Tele2, БайкалВестКом, ЕТК, Мотив, НСС, НТК, Скай Линк, СМАРТС,\n\t\tУльяновск-GSM – 10 рублей с учетом НДС.","etrain.sms.operator2":"<b>Для абонентов МТС</b>","etrain.sms.operator3":"Стоимость доступа к услугам контент-провайдера устанавливается Вашим оператором.\n\t\tПодробную информацию можно узнать в разделе «Услуги по коротким номерам» на сайте www.mts.ru\n\t\tили обратившись в контактный центр по телефону 8 800 333 0890 (0890 для абонентов МТС).","etrain.sms.operator4":'<a href="http://num.smsonline.ru/?2320" target="_blank">\n\t\tСтоимость одного СМС для абонентов других операторов</a>',"etrain.sms.operator5":"В присылаемом пользователю SMS-сообщении учитываются все временные изменения,\n\t\tзанесенные в базу данных. Создание временных изменений не зависит от Tutu.ru, следовательно, полнота базы данных временных изменений\n\t\tне гарантируется. В случае отсутствия в базе данных временных изменений абоненту возвращается базовое расписание.","etrain.scheme.kam":"в Камешково...","etrain.scheme.ale":"в Александров...","etrain.scheme.ore":"на Орехово-Зуево...","etrain.scheme.mur":"в Муром...","etrain.scheme.reajs":"в Ряжск...","etrain.scheme.kusta":"в Кустаревку...","etrain.scheme.belor":"Белорусское направление...","etrain.scheme.rijsk":"Рижское направление...","etrain.scheme.pavel":"на Павелецкое напр. ...","etrain.scheme.kievs":"на Киевское напр. ...","etrain.scheme.orel":"в Орёл...","etrain.scheme.iksha":"в Икшу...","etrain.scheme.rijsk2":"Рижское напр. ...","etrain.scheme.vasil":"на Васильевский Мох...","etrain.scheme.torjo":"в Торжок и Бологое...","etrain.scheme.kubin":"на Кубинку...","etrain.scheme.voskr":"на Воскресенск...","etrain.scheme.uzlov":"на Узловую...","etrain.scheme.pavel2":"на Павелец и Скопин...","etrain.scheme.ribno":"на Рыбное и Рязань...","etrain.scheme.belor2":"на Белорусское напр. ...","etrain.scheme.jaros":"на Ярославское напр. ...","etrain.scheme.gorki":"Горьковское напр. ...","etrain.scheme.jahro":"Яхрома, Дмитров","etrain.scheme.ivano":"в Иваново...","etrain.scheme.kursk":"на Курское напр. ...","etrain.scheme.bekas":"на Бекасово...","etrain.scheme.savel":"на Савеловское напр. ...","etrain.scheme.monin":"на Монино...","etrain.scheme.kurov":"на Куровскую...","etrain.scheme.suhin":"на Сухиничи...","etrain.scheme.detko":"на Детково...","etrain.scheme.aleks":"на Алексин...","etrain.scheme.veazm":"на Вязьму...","etrain.scheme.mihne":"на Михнево...","etrain.scheme.jaros2":"на Ярославль...","etrain.scheme.kirja":"на Киржач...","etrain.scheme.jilev":"на Жилево...","etrain.scheme.scheme_name_viborg":"Выборгское и Сестрорецкое направления","etrain.scheme.scheme_name_prioz":"Приозерское и Ладожское направления","etrain.scheme.scheme_name_sveto":"Выборг - Светогорск, Выборг - Элисенваара","etrain.xml.error.invalid_crc":"Неверная эл. цифровая подпись","etrain.xml.error.invalid_crc_code":"101","etrain.xml.error.invalid_params":"Неверные параметры запроса","etrain.xml.error.invalid_params_code":"102","etrain.schedule.station.seo.1":'<h2>Как доехать до&nbsp;<span class="nowrap">%station%</span> на&nbsp;электричке</h2>',"etrain.schedule.station.seo.2":'<p>Электропоезда до&nbsp;<span class="nowrap">%station%</span> следуют по&nbsp;%direction%.</p>',"etrain.schedule.station.seo.3":'<p>Вы&nbsp;можете %seeMorphology% расписание пригородных поездов, на&nbsp;которых можно добраться до&nbsp;<span class="nowrap">%station%</span>, и&nbsp;выбрать наиболее удобный маршрут.</p>',"etrain.schedule.station.seo.4":'<p>Обозначив пункт %depAndArrMorphology% (например, <a href="%fromRailwayUrl%">%fromRailwayLinkTitle%</a> или <a href="%toRailwayUrl%">%toRailwayLinkTitle%</a>), вы&nbsp;%knowMorphology% цену билета до&nbsp;<span class="nowrap">%station%</span> и&nbsp;время в&nbsp;пути.</p>',"etrain.schedule.station.seo.5":"<p>По&nbsp;некоторым %routeMorphology% %followMorphology% %blueAndGreenTrainMorphology%. Стоимость билетов на&nbsp;них выше, чем на&nbsp;%simpleTrainMorphology%.</p>","etrain.schedule.seo.1":"<h2>Движение пригородных поездов <nobr>%departureStation%</nobr> — <nobr>%arrivalStation%</nobr></h2>","etrain.schedule.seo.2":"<p>Электрички следуют по&nbsp;%direction%.</p>","etrain.schedule.seo.3":"<p>Расстояние между %stationsText% <nobr>%departureStation%</nobr> и <nobr>%arrivalStation%</nobr> %milage%&nbsp;%milageText%. %averageText% время в&nbsp;пути  %travelTime%.</p>","etrain.schedule.seo.41":"<p>Цена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr> равна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>.</p>","etrain.schedule.seo.42":"<p>\n\t\tЦена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr>\n\t\tравна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>. Также есть возможность приобрести абонементы на&nbsp;10, 20, 60 и&nbsp;90 поездок.\n\t\tЦена абонемента на&nbsp;10 поездок (на&nbsp;30 дней) равна <nobr>%price10Trips%&nbsp;%currencyText10Trips%</nobr>.\n\t</p>","etrain.schedule.seo.43":'<p>\n\t\tЦена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr>\n\t\tравна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>. Также есть возможность приобрести абонементы на&nbsp;10, 20, 60 и&nbsp;90 поездок.\n\t\tЦена абонемента на&nbsp;10 поездок (на&nbsp;30 дней) равна <nobr>%price10Trips%&nbsp;%currencyText10Trips%</nobr>.\n\t\tПо&nbsp;данному направлению действует абонемент <a href="%url%">"Большая&nbsp;Москва"</a>\n\t</p>',"etrain.schedule.seo.44":'<p>\n\t\tЦена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr>\n\t\tравна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>. По&nbsp;данному направлению действует абонемент <a href="%url%">"Большая&nbsp;Москва"</a>\n\t</p>',"etrain.schedule.seo.45":"<p>\n\t\tЦена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr>\n\t\tравна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>.\n\t\tПри&nbsp;покупке билета в&nbsp;кассе предоставляется скидка, стоимость с&nbsp;учётом скидки равна <nobr>%priceBiletVKasse%&nbsp;%currencyTextBiletVKasse%</nobr>.\n\t</p>","etrain.schedule.seo.46":"<p>\n\t\tЦена билета на&nbsp;электричку от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr>\n\t\tравна <nobr>%priceOnce%&nbsp;%currencyText%</nobr>.\n\t\tПри&nbsp;покупке билета в&nbsp;кассе предоставляется скидка, стоимость с&nbsp;учётом скидки равна <nobr>%priceBiletVKasse%&nbsp;%currencyTextBiletVKasse%</nobr>.\n\t\tТакже есть возможность приобрести абонементы на&nbsp;10, 20, 60 и&nbsp;90 поездок.\n\t\tЦена абонемента на&nbsp;10 поездок (на&nbsp;30 дней) равна <nobr>%price10Trips%&nbsp;%currencyText10Trips%</nobr>.\n\t</p>","etrain.schedule.seo.51":"<p>Стоимость ежедневного абонемента на&nbsp;электропоезд на&nbsp;5&nbsp;дней составляет <nobr>%price5Days%&nbsp;%currencyText5Days%</nobr>, на&nbsp;10&nbsp;дней — <nobr>%price10Days%&nbsp;%currencyText10Days%</nobr>.</p>","etrain.schedule.seo.52":"<p>Стоимость ежедневного абонемента на&nbsp;электропоезд на&nbsp;5&nbsp;дней составляет <nobr>%price5Days%&nbsp;%currencyText5Days%</nobr>.</p>","etrain.schedule.seo.61":"<p>Абонемент на&nbsp;месяц стоит <nobr>%price30Days%&nbsp;%currencyText30Days%</nobr>, также есть возможность приобрести месячный абонемент на&nbsp;электричку, для&nbsp;поездок только по&nbsp;%workText% дням. Его цена %isText% <nobr>%priceWorkDays%&nbsp;%currencyTextWorkDays%</nobr>.</p>","etrain.schedule.seo.62":"<p>Также есть возможность приобрести месячный абонемент на&nbsp;электричку, для&nbsp;поездок только по&nbsp;%workText% дням. Его цена %isText% <nobr>%priceWorkDays%&nbsp;%currencyTextWorkDays%</nobr>.</p>","etrain.schedule.seo.63":"<p>Абонемент на&nbsp;месяц стоит <nobr>%price30Days%&nbsp;%currencyText30Days%</nobr>.</p>","etrain.schedule.seo.7":"<p>Самая первая электричка от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr> отправляется в&nbsp;%minDepartureTime%, а&nbsp;самый поздний рейс приходится на&nbsp;%maxDepartureTime%.</p>","etrain.schedule.seo.8":"<p><b>Спутники</b></p>","etrain.schedule.seo.9":"<p>%priceText% билетов на&nbsp;спутники и&nbsp;экспрессы выше, чем на&nbsp;%usualText%.</p>","etrain.schedule.seo.10":"<p>Цена билета на&nbsp;спутник от&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr> равна [кол-во] рублей.</p>","etrain.schedule.seo.11":"<p>Стоимость льготного билета по&nbsp;этому маршруту составляет [кол-во] &nbsp;рублей, а&nbsp;детский вам обойдется в&nbsp; [кол-во] &nbsp;рублей.</p>","etrain.schedule.seo.12":"<p>Есть возможность купить абонемент на концепты и спутники на&nbsp;срок от&nbsp;%fiveText% дней до&nbsp;%twelveText% месяцев.</p>","etrain.schedule.seo.13":"<p><b>Экспрессы</b></p>","etrain.schedule.seo.14":"<p>Стоимость билетов на&nbsp;экспрессы %changeText% в&nbsp;зависимости от&nbsp;класса обслуживания.</p>","etrain.schedule.seo.15":"<p>От&nbsp;<nobr>%departureStation%</nobr> до&nbsp;<nobr>%arrivalStation%</nobr> доехать первым классом можно за&nbsp; [кол-во] &nbsp;рублей, вторым — за&nbsp; [кол-во] &nbsp;рублей, а&nbsp;чтобы добраться третьим классом, нужно заплатить&nbsp; [кол-во] &nbsp;рублей.</p>","etrain.schedule.seo.16":"<h2>Поезда дальнего следования</h2>","etrain.schedule.seo.17":'<p>%fromTo% можно доехать на поезде. Наш сервис позволяет <a href="%linkSt1St2%">купить билет на поезд из %departureStation% до %arrivalStation%</a> или от <a href="%linkSt2St1%">%arrivalStation% до %departureStation%</a>.</p>',"etrain.common.title":"Расписание электричек","etrain.common.title_sms":"SMS-версия","etrain.common.menu_belgorod":"Белгород","etrain.common.menu_bryansk":"Брянск","etrain.common.menu_voronezh":"Воронеж","etrain.common.menu_kazan":"Казань","etrain.common.menu_kaluga":"Калуга","etrain.common.menu_kursk":"Курск","etrain.common.menu_irkutsk":"Иркутск","etrain.common.menu_lipetsk":"Липецк","etrain.common.menu_orel":"Орел","etrain.common.menu_ryazan":"Рязань","etrain.common.menu_smolensk":"Смоленск","etrain.common.menu_tambov":"Тамбов","etrain.common.menu_tula":"Тула","etrain.common.banner_title":"СМС-тренажер","etrain.common.banner_subtitle":"Научись получать<br />расписание на&nbsp;мобильный","etrain.common.banner_incoming":"Входящее сообщение","etrain.common.banner_send_to":"СМС на номер:","etrain.common.banner_default_message_msk":"ту москва тверь 19:25","etrain.common.banner_default_message_spb":"спб спб тосно 19:15","etrain.common.banner_submit":"Отправить","etrain.common.banner_reset":"Попробовать еще раз","etrain.common.banner_send":"Отправка СМС","etrain.common.banner_prefix_msk":"ту","etrain.common.banner_prefix_msk_translit":"tu","etrain.common.banner_prefix_spb":"спб","etrain.common.banner_prefix_spb_translit":"spb","etrain.common.from":"Откуда","etrain.common.where":"Куда","etrain.common.example":"например","etrain.common.without_date":"без даты","etrain.common.tutu":"Туту!","etrain.common.show_schedule":"Показать расписание","etrain.common.etrains":"Электрички","etrain.common.blue_etrains":"Ускоренные","etrain.common.green_etrains":"Экспрессы","etrain.common.red_etrains":"Аэроэкспрессы","etrain.common.moscow":"Москва","etrain.common.moscow_region":"Москва и Московская область","etrain.common.schedule":"Расписание электричек","etrain.common.schedule2":"Расписание","etrain.common.schedule3":"Расписание электропоездов","etrain.common.schedule4":"Расписание электропоезда","etrain.common.schedule_station":"Расписание электричек","etrain.common.sms_schedule":'\n\t\t<div class="round roundGold">\n\t\t\t<div class="schedule-sms_request-example">\n\t\t\t\t<h3>Получите расписание ближайших электричек на телефон!</h3>\n\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t<div class="shedule-sms-left">\n\t\t\t\t\t<p>SMS на номер <nobr><strong>%phone%</strong>&nbsp;&mdash;</nobr> <nobr><strong>%smsText%</strong></nobr></p>\n\n\t\t\t\t</div>\n\t\t\t\t<div class="shedule-sms-cost">Стоимость&nbsp;&mdash; 10&nbsp;руб.</div>\n\t\t\t\t<div class="shedule-sms-right"><a href="%url%" target="_blank">Как это работает</a></div>\n\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t</div>\n\t\t</div>\n\t',"etrain.common.sms_schedule_station":'\n\t\t<div class="round roundGold">\n\t\t\t<div class="schedule-sms_request-example">\n\t\t\t\t<h3>Получите расписание ближайших электричек на телефон!</h3>\n\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t<div class="shedule-sms-left">\n\t\t\t\t\t<p>SMS на номер <nobr><strong>%phone%</strong>&nbsp;&mdash;</nobr> <nobr><strong>%smsText%</strong></nobr></p>\n\n\t\t\t\t</div>\n\t\t\t\t<div class="shedule-sms-cost">Стоимость&nbsp;&mdash; 10&nbsp;руб.</div>\n\t\t\t\t<div class="shedule-sms-right"><a href="%url%" target="_blank">Как это работает</a></div>\n\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t</div>\n\t\t</div>\n\t',"etrain.common.sms_schedule_without_link":'<div class="schedule-sms_request-example">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_left"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_center">%smsText%</div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_right"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_number-black">SMS на номер <strong>%phone%</strong></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</div>Вы можете уточнить расписание перед поездкой по SMS',"etrain.common.sms_schedule_short":'<div class="schedule-sms_request-example">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_left"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_center">%smsText%</div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_right"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_number">SMS на <b>%phone%</b></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</div><a href="%url%">Вы можете уточнить расписание перед поездкой по SMS</a>',"etrain.common.sms_schedule_short_nolink":'<div class="schedule-sms_request-example">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_left"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_center">%smsText%</div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_right"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_number">SMS на <b>%phone%</b></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</div>',"etrain.common.insert_schedule_in_blog":"Вставить на сайт","etrain.common.print_schedule":"Напечатать расписание","etrain.common.reverse_route":"Обратный маршрут","etrain.common.showing_local_time":"В таблице указано местное время","etrain.common.train_route":"Маршрут электрички","etrain.common.train_schedule":"Режим движения","etrain.common.departure":"Отправление","etrain.common.arrival":"Прибытие","etrain.common.travel_time":"В&nbsp;пути","etrain.common.no_blue_trains":"Спутников по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_green_trains":"Экспрессов по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_trains":"Обычных электричек по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_blue_and_green_trains":"Экспрессов и спутников по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_trains_and_green_trains":"Обычных электричек и экспрессов по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_trains_and_blue_trains":"Обычных электричек и спутников по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.search_by_all":'Попробуйте поискать <a href="%url%">среди всех электропоездов</a>.',"etrain.common.no_trains2":"Сообщения по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.no_trains3":"Электричек по выбранному маршруту <!--noindex-->не<!--/noindex--> найдено.","etrain.common.taken_temporary_changes":"Учтены временные изменения на %date%. Кликните на время отправления и узнайте, что именно поменялось.","etrain.common.schedule_change_second_taken_changes":"Учтены временные изменения на %date%. Кликните на время прибытия и узнайте, что именно поменялось.","etrain.common.aeroexpress_taken_temporary_changes":"Учтены временные изменения на %date%. Кликните на восклицательный знак и узнайте, что именно поменялось.","etrain.common.is_temporary_changes":"Есть изменения %dates%. Уточните дату поездки. Кликните на время отправления и узнайте, что именно поменялось.","etrain.common.is_temporary_changes2":"Есть изменения %dates%. Кликните на время отправления и узнайте, что именно поменялось.","etrain.common.schedule_station_is_temporary_changes":"Есть изменения %dates%. Кликните на маршрут электрички и узнайте, что именно поменялось.","etrain.common.aeroexpress_is_temporary_changes":"Есть изменения %dates%. Уточните дату поездки. Кликните на восклицательный знак и узнайте, что именно поменялось.","etrain.common.schedule_taken_temporary_changes":"В расписании уже учтены изменения на %date%","etrain.common.train_is_canceled_in_select_day":"Эта электричка в выбранный день не ходит","etrain.common.schedule_is_temporary_changes":'Есть временные изменения. Уточните <a href="javascript: void(0)" rel="calendarTrigger%calendarId%" class="pseudoBlue">дату поездки</a>!%additional%',"etrain.common.schedule_is_temporary_changes2":"Есть временные изменения.","etrain.common.calendar":"Календарь","etrain.common.ticket_price":"Цена билета","etrain.common.etrain":"Электричка","etrain.common.abonement_month":"абонемент на месяц","etrain.common.price_details":"подробнее о цене билетов","etrain.common.and":"и","etrain.common.aeroexpress":"Аэроэкспресс","etrain.common.main_price_decimal_part":'<span class="main_part">%number%</span>&nbsp;<span class="units">%currency%</span>',"etrain.common.main_price_fractional_part":'&nbsp;<span class="cents">%number% к.</span>',"etrain.common.price_decimal_part":"%number% р.","etrain.common.price_fractional_part":'<span class="ticket_cents">%number% к.</span>',"etrain.common.price_fractional_part_zero":'<span class="ticket_cents zero">%number% к.</span>',"etrain.common.ticket_and_abonement":"Билеты и абонементы","etrain.common.all_regions":"Все регионы","etrain.common.sms_schedule3":"СМС-расписание","etrain.common.schedule_in_your_phone":"Актуальное расписание электричек на&nbsp;вашем телефоне круглосуточно","etrain.common.main_meta_title":"Расписание электричек %year%, расписание движения электропоездов, маршруты пригородных дизель-поездов","etrain.common.main_meta_keywords":"Расписание,электричек, электропоездов, пригородных,%year%,поездов,и,области,вокзалов,направлений, расписание, поездов, дальнего, следования","etrain.common.main_meta_description":"Расписание электричек на %year% год. Расписание дизель-поездов, электропоездов.","etrain.common.search_meta_title":"Расписание электричек %year%: расписание электропоездов, пригородных дизель-поездов","etrain.common.search_meta_keywords":"Расписание,электричек, электропоездов, пригородных,поездов,и,области,вокзалов,направлений, расписание, поездов, дальнего, следования","etrain.common.search_meta_description":"Расписание электричек. Расписание дизель-поездов, электропоездов.","etrain.common.schedule_meta_title":"Расписание электричек %departureStationName% - %arrivalStationName%. Стоимость проезда. Цена билетов на электропоезда.","etrain.common.schedule_meta_keywords":"Расписание,электричек,между,станциями,%departureStationName%,и,%arrivalStationName%,расписание,пригордных,электропоездов,стоимость,билетов,стоимость билета,цена билетов","etrain.common.schedule_meta_description":"Расписание электричек между станциями %departureStationName% и %arrivalStationName%. Стоимость проезда на электропоезда.","etrain.common.schedule_station_meta_title":"Расписание электричек %stationName%. Маршруты пригородных поездов %stationName%","etrain.common.schedule_station_meta_title_green_and_blue_postfix":". Расписание спутник, экспресс %stationName%","etrain.common.schedule_station_meta_title_green_postfix":". Расписание экспресс %stationName%","etrain.common.schedule_station_meta_title_blue_postfix":". Расписание спутник %stationName%","etrain.common.schedule_station_meta_keywords":"Расписание электричек, %stationName%","etrain.common.schedule_station_meta_description":"Расписание электричек: %stationName%","etrain.common.route_meta_title":"Расписание электричек: %departureStationName% - %arrivalStationName% %stationList%.","etrain.common.route_meta_keywords":"Расписание электричек, %stationList%","etrain.common.route_meta_description":"Расписание электричек: %departureStationName% - %arrivalStationName% %stationList%.","etrain.common.no_way_taken_temporary_changes":"Прямого сообщения %departureStationUrl% → %arrivalStationUrl% нет. Расписание дано с одной пересадкой. В расписании учтены изменения <nobr>на %date%</nobr>.","etrain.common.change":"Пересадка","etrain.common.time_to_change":"Время на&nbsp;пересадку","etrain.common.wait_at_station":"ожидание на станции","etrain.common.concepts":"Концепты","etrain.common.expresses":"Экспрессы","etrain.common.sputniks":"Спутники","etrain.common.schedule_and_price":"Расписание и стоимость билетов:","etrain.common.hotels":"Гостиницы","etrain.common.make_hotel_orders":"Бронирование отелей за&nbsp;рубежом и&nbsp;гостиниц в&nbsp;России и&nbsp;СНГ","etrain.common.trains":"Поезда","etrain.common.make_train_orders":"Расписание и&nbsp;заказ билетов на&nbsp;поезда дальнего следования","etrain.common.planes":"Самолеты","etrain.common.make_avia_orders":"Расписание аэропортов, заказ авиабилетов на&nbsp;авиарейсы","etrain.common.schedule_print_sms":"В расписании пригородных поездов могут быть учтены не все временные изменения.<br />Стоимость одной SMS — 10 рублей с НДС. Точная стоимость зависит от Вашего оператора.","etrain.common.today":"сегодня","etrain.common.tomorrow":"завтра","etrain.common.day_after_tomorrow":"послезавтра","etrain.common.departure_station":"Станция<br />отправления","etrain.common.arrival_station":"Станция<br />прибытия","etrain.common.enter_station_name":"Пожалуйста, укажите название станции","etrain.common.nounTrain1":"поезд","etrain.common.nounTrain2":"поезда","etrain.common.nounTrain5":"поездов","etrain.common.nounTrainGenitive1":"поезда","etrain.common.nounTrainGenitive2":"поездов","etrain.common.nounCancel1":"отменен","etrain.common.nounCancel2":"отменено","etrain.common.nounChange1":"изменение","etrain.common.nounChange2":"изменения","etrain.common.nounChange5":"изменений","etrain.common.allDirections":"Все направления","etrain.common.allRailways":"Все вокзалы","etrain.common.news":"Новости","etrain.common.showScheduleWithChangeTo":"Показать варианты проезда с пересадкой на","etrain.common.showScheduleWithChange":"Варианты проезда по этому же маршруту, но с пересадкой...","etrain.common.disable_station":"Остановка на %station% %period%","etrain.common.disable_stations":"Остановка на %departureStation% и %arrivalStation% %period%","etrain.common.disable_station_name":"платформе","etrain.common.disable_stations_name":"платформах","etrain.common.smm_title":"Размести здесь<br> фото станции %station%!","etrain.common.smm_serv_title":"","etrain.common.smm_serv_title-sv":"Опубликовать:","etrain.common.smm_expand_text":"Как это сделать","etrain.common.smm_about":"Опубликуй фотографию станции %station% в&nbsp;своем блоге и&nbsp;ее&nbsp;увидят миллионы посетителей Туту.ру","etrain.common.smm_about_expand":"<p>1) Сфотографируй станцию %station% и&nbsp;опубликуй фото в&nbsp;своем блоге.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>2) Поставь ссылку на&nbsp;эту страницу Туту.ру.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>3) При желании добавь пояснения или&nbsp;интересный комментарий.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tВсе хорошие фото появятся здесь со&nbsp;ссылкой на&nbsp;блог автора!","etrain.common.smm_station_example":'\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Сфоткал станцию Матищи...</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="lj_ico"></span>arbatova_usersha</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Береги железнодородника с молоду железнодородника с молоду железнодородника с молоду...</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="bl_ico"></span>doktor_kurpatov</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Елки-палки лес густой...</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="ya_ico"></span>arbatova_usersha</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Е железнодородника с молоду...</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="li_ico"></span>doktor_kurpatov</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Эге гей!</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="di_ico"></span>doktor_kurpatov</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>',"etrain.common.smm_station_55008_example":'\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="http://im8-tub-ru.yandex.net/i?id=121293562-58-72" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Сфоткал станцию Мытищи...</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="lj_ico"></span>arbatova_usersha</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="http://im6-tub-ru.yandex.net/i?id=22642828-44-72" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Ура!</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="di_ico"></span>doktor_kurpatov</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>',"etrain.common.smm_station_29404":'\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li class="link_item">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="http://alexeizuzin.livejournal.com/30487.html" target="_blank" class="out_link">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img src="%url%/29404_1.jpg" alt="" class="link_cover"/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="link_description">Станция Долгопрудная</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<span class="serv_user"><span class="lj_ico"></span>alexeizuzin</span>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</li>',"etrain.xml2.error.invalid_crc":"Неверная эл. цифровая подпись","etrain.xml2.error.invalid_crc_code":"801","etrain.xml2.error.invalid_crc_http_code":"801 Invalid CRC","etrain.xml2.error.invalid_params":"Неверные параметры запроса","etrain.xml2.error.invalid_params_code":"802","etrain.xml2.error.invalid_params_http_code":"802 Invalid Params","etrain.spb.region":"Санкт-Петербург","etrain.spb.region2":"Санкт-Петербурга и Ленинградской области","etrain.spb.main_meta_title":"Расписание электричек Санкт-Петербург %year%. Расписание движения пригородных поездов, маршруты электропоездов со всех вокзалов Санкт-Петербурга","etrain.spb.main_meta_keywords":"Расписание,электричек,электропоездов,Санкт-Петербург,пригородных,поездов,и,Ленинградской,области,всех,вокзалов,всех,направлений %year%","etrain.spb.main_meta_description":"Расписание электричек всех вокзалов Санкт-Петербурга и Ленинградской области, расписание электропоездов Санкт-Петербург %year%","etrain.spb.sms_schedule2_without_link":'<div class="schedule-sms_request-example">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_left"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_center">%smsText%</div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_right"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="sms_request_number-black">SMS на номер <strong>%phone%</strong></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<div class="clear"><!--  --></div>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</div>Вы можете уточнить расписание перед поездкой по SMS',"etrain.spb.city":"Санкт-Петербурга","etrain.spb.phones":'<p class="phone">8 (800) 775-00-00 (круглосуточно, звонок бесплатный)</p>',"etrain.spb.city2":"Санкт-Петербург","etrain.spb.toCity":"на Санкт-Петербург","etrain.spb.scheme_meta_title":"%year% - Расписание электричек %railwayName% вокзала. Схема движения электропоездов %railwayName% направления %year%.","etrain.spb.news_meta_title":"Расписание пригородных поездов Санкт-Петербург %year% : все вокзалы, все направлени","etrain.spb.news_meta_keywords":"Расписание пригородных поездов всех вокзалов Санкт-Петербурга %year%","etrain.spb.news_meta_description":"Расписание,пригородных,поездов,электричек,Санкт-Петербург,и,Ленинградской,области,всех,вокзалов,всех,направлений,%year%","etrain.spb.":"","etrain.msk.sms.prefix":"ТУ","etrain.msk.sms.city":"Москва","etrain.msk.sms.city2":"Москвы","etrain.msk.sms.city4":"Москву","etrain.msk.sms.title":"Московский сервис Туту","etrain.msk.sms.cityAndRegion":"Москва и Московская область","etrain.msk.sms.cityAndRegion3":"Москве и Московской области","etrain.msk.sms.menu":"Москва и Московская область","etrain.msk.sms.fromCityToRegionRequest":"ТУ москва икша","etrain.msk.sms.fromCityToRegionAnswer":"из Москвы в Икшу","etrain.msk.sms.fromRegionToCityRequest":"ТУ быково москва","etrain.msk.sms.fromRegionToCityAnswer":"из Быково в Москву","etrain.msk.sms.fromStationToCityRequest":"ТУ клин","etrain.msk.sms.longRequest":"ТУ подсол москва кур","etrain.msk.sms.timeRequest":"ТУ клин тверь","etrain.msk.sms.timeAnswer":"из Клина до Твери","etrain.msk.sms.":"","etrain.list.date.timeday.позавчера":"-3d","etrain.list.date.timeday.вчера":"-2d","etrain.list.date.timeday.сегодня":"-1d","etrain.list.date.timeday.завтра":"0d","etrain.list.date.timeday.послезавтра":"+1d","etrain.list.date.timeday.today":"-1d","etrain.list.date.timeday.tomorrow":"0d","etrain.list.date.timeday.day_after_tomorrow":"+1d","etrain.spb.sms.prefix":"СПБ","etrain.spb.sms.city":"Санкт-Петербург","etrain.spb.sms.city2":"Санкт-Петербурга","etrain.spb.sms.city4":"Санкт-Петербург","etrain.spb.sms.title":"Электрички города на Неве","etrain.spb.sms.cityAndRegion":"Санкт-Петербург и Ленинградская область","etrain.spb.sms.cityAndRegion3":"Санкт-Петербургу и Ленинградской области","etrain.spb.sms.menu":"Санкт-Петербург","etrain.spb.sms.fromCityToRegionRequest":"СПБ спб выборг","etrain.spb.sms.fromCityToRegionAnswer":"из Санкт-Петербурга в Выборг","etrain.spb.sms.fromRegionToCityRequest":"СПБ парголово спб","etrain.spb.sms.fromRegionToCityAnswer":"из Парголово в Санкт-Петербург","etrain.spb.sms.fromStationToCityRequest":"СПБ тосно","etrain.spb.sms.longRequest":"СПБ спб куол","etrain.spb.sms.timeRequest":"СПБ спб 63 км","etrain.spb.sms.timeAnswer":"из Санкт-Петербурга до 63 км","etrain.spb.sms.":"","tips.metro.title":"Метро","tips.metro.title_small":"метро","tips.metro.main_order_text":"Схемы метро мира.","tips.surprise.webmaster":"Вебмастер!","tips.surprise.install":'Установи на&nbsp;свой сайт <a href="http://www.tutu.ru/surprise.php">форму поиска по&nbsp;расписанию самолетов</a>!',"tips.surprise.avia":"авиа","tips.surprise.d_train":"поезда","tips.surprise.e_train":"электрички","tips.surprise.schedule_avia_alt":"tutu.ru&nbsp;&#8212; Расписание авиарейсов, наличие мест и цены online, заказ авиабилетов","tips.surprise.city_from":"Город вылета","tips.surprise.city_to":"Город прилета","tips.surprise.search":"Поиск","tips.surprise.schedule_avia":"расписание авиарейсов","tips.surprise.order_avia":"авиабилеты","tips.surprise.schedule_d_train_alt":"tutu.ru&nbsp;&#8212; расписание поездов по&nbsp;Москве, России, СНГ","tips.surprise.departure_from":"Станция отправления","tips.surprise.departure_to":"Станция прибытия","tips.surprise.schedule_d_train":"расписание поездов","tips.surprise.tickets":"электронные жд билеты","tips.surprise.schedule_e_train_alt":"tutu.ru&nbsp;&#8212; расписание электричек","tips.surprise.schedule_e_train":"расписание электричек","tips.surprise.metro_map":"карта метрополитена","tips.surprise.width":"Ширина","tips.surprise.height":"Высота","tips.surprise.recommended_size":"(Рекомендуем 700 на 800 пикселей)","tips.taxi.day_home_price_descr":"500 руб. (с 6:00 до 22:00, при поездке до 40 минут,<br>далее 1 мин. — 10 руб.)","tips.taxi.night_home_price_descr":"500 руб. с 22:00 до 6:00, а также круглосуточно по праздникам и&nbsp;выходным (при&nbsp;поездке до 30 минут, далее 1 мин. — 10 руб.)","tips.taxi.day_home_railway_price_descr":"500 руб. (с 6:00 до 22:00, при поездке до 40 минут,<br>далее 1 мин. — 10 руб.)","tips.taxi.night_home_railway_price_descr":"500 руб. с 22:00 до 6:00, а также круглосуточно по праздникам и&nbsp;выходным (при&nbsp;поездке до 30 минут, далее 1 мин. — 10 руб.)","tips.taxi.order_taxi":'<p style="margin-top:8px;">На&nbsp;Tutu.ru можно заказать удобное <a href="/taxi/?point_to_type=home">такси в&nbsp;любой район Москвы</a> и&nbsp;области.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Выгодные тарифы на&nbsp;такси в аэропорты <a href="/taxi/?point_to_type=airport&amp;point_to_id=14">Домодедово</a>,\n\t\t\t\t\t\t\t\t\t\t\t\t<a href="/taxi/?point_to_type=airport&amp;point_to_id=925">Шереметьево</a>, <a href="/taxi/?point_to_type=airport&amp;point_to_id=12">Внуково</a>.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p style="margin:0;">Отличные цены на&nbsp;<a href="/taxi/?point_to_type=railway">такси до&nbsp;вокзалов Москвы</a>.</p>',"tips.taxi.meta_title":"Заказ такси в Москве (любая станция метро), калькулятор стоимости, такси в аэропорт, из аэропорта: Шереметьево, Домодедово, Внуково.","tips.taxi.meta_keywords":"Заказ такси в Москве, калькулятор стоимости, такси в аэропорт Домодедово, такси в аэропорт Шереметьево, такси в аэропорт Внуково.","tips.taxi.meta_description":"Заказ такси в Москве, калькулятор стоимости от станции метро, заказа такси в аэропорты Москвы: Домодедово, Шереметьево, Внуково, встречи в аэропорту.","tips.taxi.title":"Такси","tips.taxi.title_small":"заказ такси в&nbsp;Москве","tips.taxi.choose_airport":"выберите аэропорт","tips.taxi.choose_railway":"выберите ж/д вокзал","tips.taxi.choose_home":"выберите станцию метро/район","tips.taxi.additional_services":"Дополнительные услуги","tips.taxi.wait_with_table_on_railway":"Встреча с табличкой на вокзале (у вагона)","tips.taxi.paid_parking":"+ оплата парковки","tips.taxi.wait_with_table_on_airport":"Встреча с табличкой в аэропорту","tips.taxi.econom":"Заказ автомобиля эконом-класса","tips.taxi.universal":"Заказ а/м универсал","tips.taxi.miniven":"Заказ а/м минивэн","tips.taxi.business":"Заказ автомобиля бизнес-класса","tips.taxi.choose_auto":"выберите машину","tips.taxi.microbus":"Заказ микроавтобуса (до 9 пассажиров)","tips.taxi.luggage":"Багаж в салоне автомобиля","tips.taxi.child_seat":"Детское кресло (с года до трех лет)","tips.taxi.child_booster":"Детское сиденье (от трех лет)","tips.taxi.operator_say":"Сообщит оператор","tips.taxi.not_important":"не важно","tips.taxi.comment_airport":"Включен 1 час ожидания, далее 8 руб./мин.","tips.taxi.comment_railway":"Включено 10 минут ожидания  после прибытия поезда, далее 8 руб./мин.","tips.taxi.comment_home":"Включено 5 минут ожидания , далее 8 руб./мин.","tips.taxi.contact_name":"Фамилия, Имя","tips.taxi.contact_email":"E-mail","tips.taxi.contact_phone":"Телефон для связи","tips.taxi.contact_phone2":"Второй номер телефона","tips.taxi.phone_connect":"Мой телефон будет включен","tips.taxi.flights_number":"Номер рейса, откуда","tips.taxi.train_number":"Номер поезда, откуда","tips.taxi.address":"Адрес подачи автомобиля","tips.taxi.date":"Дата подачи автомобиля","tips.taxi.time":"Время","tips.taxi.descr":"Дополнительные пожелания","tips.taxi.error_not_empty_contact_name":"Укажите вашу фамилию и имя.","tips.taxi.error_not_empty_contact_email":"Укажите адрес эл. почты.","tips.taxi.error_not_empty_contact_phone":"Укажите телефон для связи.","tips.taxi.error_not_empty_address":"Укажите адрес подачи автомобиля.","tips.taxi.error_email_contact_email":"Укажите правильный адрес эл. почты.","tips.taxi.error_phone_light_contact_phone":"Телефон для связи слишком короткий.","tips.taxi.error_date_date":"Дата подачи автомобиля неверного формата. Допустимый формат ДД.ММ.ГГГГ.","tips.taxi.error_taxi_date_date":"К сожалению, мы не сможем подать машину так быстро. Пожалуйста, сделайте заказ на более позднее время. Минимальный срок подачи машины - полтора часа с момента заказа.","tips.taxi.your_order_has_been_got":"Ваш заказ на такси принят. Наш диспетчер свяжется с вами в ближайшее  время для подтверждения заказа и уточнения маршрута.","tips.taxi.our_operator_work_round_the_clock":"Наши операторы работают круглосуточно.","tips.taxi.if_not_ring":"Если в течение 30 минут вам не перезвонили, то для уточнения вашей заявки можно позвонить по телефону +7 (495) 661-63-15 (наш партнер, компания «К самолету»).","tips.taxi.say_your_number":"При этом сообщите номер заказа, а также что вы делали заказ такси на сайте ТУТУ.РУ — это поможет быстрее найти вашу заявку.","tips.taxi.thanks":"Благодарим вас за то, что вы воспользовались нашей услугой заказа билетов.","tips.taxi.glad_to_see":"Мы всегда рады видеть вас в числе клиентов Туту.ру.","tips.taxi.tarif":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tПодача такси за МКАД (Жулебино, Кожухово, Новокосино, Люберцы, Реутов, Бутово, Митино)\n\t\t\t\t\t\t\t\t\t\t\t\t\tпроизводится без дополнительной оплаты.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tКурьерские услуги: тариф + 150 рублей за каждый адрес.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>","tips.taxi.mkad_driving":"<p>Движение за МКАД: 15 руб. за 1 км.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Движение по МКАД:  5 руб. за 1 км.</p>","tips.taxi.our_response":"<p>Наши диспетчеры свяжутся с вами для подтверждения заказа в течение 30 минут.</p>","tips.taxi.day_additional_price":" (при поездке до 1 часа, далее 1 мин. — 10 руб.) ","tips.taxi.night_additional_price":", а также круглосуточно по праздникам и выходным (при поездке до 30 километров, далее 1 км. — 20 руб.)","tips.taxi.day_time":"(6:00-22:00)","tips.taxi.night_time":"(22:00-6:00)","tips.taxi.car_class":"Вид автомобиля","tips.taxi.total_price":"Стоимость","tips.taxi.choose_point_departure":"Выберите пункт отправления","tips.taxi.specify_point_departure":"Уточните пункт отправления","tips.taxi.choose_a_destination":"Выберите пункт назначения","tips.taxi.specify_a_destination":"Уточните пункт назначения","tips.taxi.enter_your_contact_information_and_details":"Введите контактную информацию и уточните детали поездки","tips.taxi.taxi_is":"Такси Tutu.ru это","tips.taxi.taxi_is_cars":"машины эконом- и&nbsp;бизнес-класса, универсалы, минивэны","tips.taxi.taxi_is_child_seats":"детские кресла в&nbsp;такси (с года до 3-х лет)","tips.taxi.taxi_is_child_seat":"детские сиденья в&nbsp;такси (с 3-х лет)","tips.taxi.taxi_is_arrival_and_departure":"встречи и проводы в&nbsp;аэропортах, на&nbsp;вокзалах","tips.taxi.autopark":"Автопарк","tips.taxi.standart_class":"Стандартный класс","tips.taxi.universal_class":"Универсал","tips.taxi.business_class":"Бизнес-класс","tips.taxi.miniven_class":"Минивэн","tips.taxi.microbus_class":"Микроавтобусы","tips.taxi.standart_cars":"Ford Focus<br />Renault Logan<br />","tips.taxi.universal_cars":"Ford Focus Universal<br />Chevrolet Lacetti Universal<br />","tips.taxi.miniven_cars":"Opel Zafira<br />Mazda MPV<br />","tips.taxi.microbus_cars":"Volkswagen Transporter<br />","tips.taxi.description":"Сервис заказа такси на Tutu.ru временно приостановлен. Приносим свои извинения.","tips.taxi.main_order_text":"Заказ такси в аэропорт и на вокзал.","tips.taxi.taxi_airport":"Такси в аэропорт","tips.taxi.taxi_airport_text":"Заказ такси к авиарейсу, встреча в аэропортах, вокзалах, гостиницах","tips.taxi.":"","tips.advert.title":"Реклама на Tutu.ru","tips.advert.title_requirement_teh":"Технические требования к рекламным материалам","tips.advert.title_requirement_com":"Общие требования к рекламным материалам ","tips.advert.title_clients":"Наши любимые клиенты","tips.advert.meta_title":"Реклама на Tutu.ru","tips.advert.meta_keywords":"Реклама, Tutu.ru, авиакомпании, билеты, клиенты, пассажиры, поезда, аэропорты","tips.advert.meta_description":"Реклама на Tutu.ru. Реклама для авиакомпаний, пассажиров, аэропортов","tips.news.title":"Новости","tips.news.title_main":"Tutu.ru:&nbsp;Новости","tips.survey.title":"Опросы","tips.survey.archive":"Архив опросов","tips.survey.results":"Результаты опросов","tips.survey.other":"Другие опросы Tutu.ru","tips.survey.site_surveys":"Опросы на сайте","tips.survey.back_to_all_surveys":"Назад ко всем опросам","tips.survey.vote_ok":"Благодарим за&nbsp;участие в&nbsp;опросе, ваш голос учтен!","tips.survey.empty_list":"Нет ни одного завершенного опроса","tips.survey.vote_list":"Вы можете посмотреть результаты предыдущих опросов","tips.survey.vote_here":"Узнать результаты предыдущих опросов","tips.survey.vote_human1":"ответили %num% человек","tips.survey.vote_human2":"ответили %num% человека","tips.survey.vote_human3":"ответили %num% человек","tips.survey.year":"&nbsp;г.","tips.survey.show_description":"Результаты опроса «%question%»","tips.survey.keywords":"опросы, туту.ру, tutu.ru, голосовать, мнения","tips.no_js.title_avia_order_rules":"<b>Правила заказа авиабилетов</b><br /><br />","tips.no_js.avia_order_rules":'<table class="tipsAvia blockCenter" cellspacing="0" cellpadding="0">\n\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<b>1. Авиабилеты - заказ и бронирование</b>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оформление и доставка авиабилетов осуществляется в Москве;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>авиабилеты бронируются на рейсы, вылетающие через 3 и более суток от текущей даты (в пятницу вы можете забронировать авиабилеты на вторник);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>на указанный при бронировании адрес электронной почты высылается информационное письмо с номером созданной брони;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>если авиабилеты не будут выкуплены до указанного в информационном письме времени, бронирование автоматически аннулируется;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>стоимость авиабилетов на сайте и в информационном письме указана на момент создания брони, с учетом всех сборов;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для уточнения способа оплаты и получения авиабилета оператор связывается по указанному при бронировании номеру телефона в течение 4 часов с 10:00 до 18:00.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<b>2. Документы, необходимые для оформления авиабилета</b>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\tЗаказ на авиабилеты принимается при наличии следующих документов, удостоверяющих личность пассажира:\n\t\t\t\t\t\t\t\t\t\t\t\t<ul style="padding-top:10px;">\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для граждан России - паспорт РФ (загранпаспорт);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>свидетельство о рождении ребенка (при выписке детского авиа билета);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для иностранных граждан - национальный паспорт.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<b>3. Оплата</b>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оплатить авиабилеты при получении в офисе агентства (1-й Волконский пер., д.15., м. Цветной бульвар) - можно наличными деньгами или кредитными картами Visa и MasterCard;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>при доставке курьером авиабилеты оплачиваются только наличными деньгами.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<b>4. Получение авиабилетов</b>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>доставка осуществляется только в офисы; стоимость доставки — 250-300 рублей, в зависимости от агентства-партнера;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>авиабилеты доставляются по Москве (в пределах МКАД) в будние дни с 10:00 до 19:00;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оформление и доставку авиабилетов осуществляют партнеры Tutu.ru, компания SI Tours&amp;Travel. Тел.: 7 (495) 921-01-17.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t</table>',"tips.no_js.title_d_ticket_rules":"<b>ЖД билет: электронный или бумажный?</b><br /><br />","tips.no_js.d_ticket_rules":'<table class="tipsDTrains blockCenter" cellspacing="0" cellpadding="0">\n\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t<td>&nbsp;</td>\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Электронный жд билет<br /></b></td>\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Билет на бланке РЖД<br /></b></td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Получение</b></td>\n\t\t\t\t\t\t\t\t\t\t\t<td><p>На&nbsp;вокзале в&nbsp;любом городе РФ.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t<td><p>В&nbsp;Москве и&nbsp;Санкт-Петербурге.</p></td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Доставка</b></td>\n\t\t\t\t\t\t\t\t\t\t\t<td>&mdash;</td>\n\t\t\t\t\t\t\t\t\t\t\t<td><p>Курьером или получение в&nbsp;офисе компании.</p></td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Цена</b></td>\n\t\t\t\t\t\t\t\t\t\t\t<td><p>Возможность купить ж/д билет с&nbsp;минимальной комиссией.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t<td><p>К&nbsp;цене жд билета прибавляется сервисный сбор в&nbsp;зависимости от&nbsp;города покупки.</p></td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t<td><b>Оплата</b></td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t- Кредитные карты; &nbsp;&nbsp;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- со счета мобильного телефона "Билайн";<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Webmoney;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Яндекс.Деньги;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Мобильный кошелек;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Money Mail;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t<b>- Наличные в&nbsp;платежных терминалах, киосках и&nbsp;салонах Евросети.</b>\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t- Наличные деньги в&nbsp;офисе;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t- Наличные деньги курьеру;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t- Оплата кредитной картой.\n\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t</table>',"tips.d_trains.trains":"Поезда","tips.d_trains.title":"Поезда дальнего следования","tips.d_trains.sapsan_title":"Сапсаны","tips.d_trains.title_small":"поезда дальнего следования","tips.d_trains.schedule":"<noindex>Расписание поездов</noindex>","tips.d_trains.e_ticket_order":"Заказ электронных жд билетов","tips.d_trains.ticket_order":"Заказ жд билетов на бланках РЖД","tips.d_trains.ticket_order2":"Заказ ж/д билетов","tips.d_trains.rules":'<table class="tipsDTrains" cellspacing="0" cellpadding="0">\n\t\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t\t<td>&nbsp;</td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Электронный жд билет<br /></b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Билет на бланке РЖД<br /></b></td>\n\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Получение</b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><p>На&nbsp;вокзале в&nbsp;любом городе РФ.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><p>В&nbsp;Москве и&nbsp;Санкт-Петербурге.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Доставка</b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td>&mdash;</td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><p>Курьером или получение в&nbsp;офисе компании.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Цена</b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><p>Возможность купить ж/д билет с&nbsp;минимальной комиссией.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td><p>К&nbsp;цене жд билета прибавляется сервисный сбор в&nbsp;зависимости от&nbsp;города покупки.</p></td>\n\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t\t<td><b>Оплата</b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t- Кредитные карты; &nbsp;&nbsp;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- со счета мобильного телефона "Билайн";<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Webmoney;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Яндекс.Деньги;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Мобильный кошелек;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t- Money Mail;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>- Наличные в&nbsp;платежных терминалах, киосках и&nbsp;салонах Евросети.</b>\n\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t- Наличные деньги в&nbsp;офисе;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t- Наличные деньги курьеру;<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t- Оплата кредитной картой.\n\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t</table>',"tips.d_trains.e_ticket_or_ticket":"ЖД билеты: электронные или бумажные?","tips.d_trains.for":"Для","tips.d_trains.main_order_text":"Билет на&nbsp;&laquo;Сапсан&raquo; за&nbsp;4&nbsp;минуты","tips.d_trains.for_ticket_order":"заказа ж/д билетов","tips.d_trains.need_for_ticker_order":"необходимо выбрать маршрут следования, дату и поезд.","tips.d_trains.payment-method-tip-cash":'<p>Обратите внимание, что через 15 минут бронь снимется.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Система запомнит данные заказа на 3 часа и совершит новое бронирование, когда вы начнете оплату.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Если билетов на выбранные места не будет, вы не сможете оплатить заказ и покупка не удастся.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Этот способ оплаты лучше выбирать, когда билетов на поезд много.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Или нужно успеть оплатить за 15 минут.</p>\n\t\t\t\t\t\t\t\t\t\t<p><a href="%url%" target="_blank">Подробнее про оплату</a></p>',"tips.d_trains.payment-method-tip-rjd-moscow":"<p>При заказе билета на бланке через интернет места в поезде не бронируются, но учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Билет оформляется только после разговора с оператором.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Он свяжется с вами в течение 1 часа после оформления заказа на сайте.</p>","tips.d_trains.payment-method-tip-rjd-spb":"<p>При заказе билета на бланке через интернет места в поезде не бронируются, но учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Билет оформляется только после разговора с оператором.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Он свяжется с вами в течение часа после оформления заказа на сайте.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Операторы работают с 10.00 до 19.00 по рабочим дням, с 10:00 до 16:30 по выходным.</p>","tips.d_trains.payment-method-tip-rjd-moscow-VipService":"<p>При заказе билета на бланке через интернет места в поезде не бронируются, но учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Билет оформляется только после разговора с оператором.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Он свяжется с вами в течение 1 часа после оформления заказа на сайте.</p>","tips.d_trains.payment-method-tip-rjd-spb-VipService":"<p>При заказе билета на бланке через интернет места в поезде не бронируются, но учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Билет оформляется только после разговора с оператором.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Он свяжется с вами в течение часа после оформления заказа на сайте.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Операторы работают с 10.00 до 19.00 по рабочим дням, с 10:00 до 16:30 по выходным.</p>","tips.d_trains.payment-method-tip-rjd-spb-Davs":"<p>При заказе билета на бланке через интернет места в поезде не бронируются, но учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Билет оформляется только после разговора с оператором.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Он свяжется с вами в течение часа после оформления заказа на сайте.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Операторы работают с 9:00 до 20:00, без выходных.</p>","tips.d_trains.iframeCode":'<iframe width="%width%" height="%height%" frameborder="0" marginheight="0" marginwidth="0" src="%src%"></iframe><br /><small style="font-family:Arial; display:block; margin-top:5px;"><b><a href="%sectionUrl%">Расписание поездов</a> предоставлено сайтом <a href="%mainUrl%">Tutu.ru</a></b></small>',"tips.d_trains.iframeTitle":"Код i-frame для экспорта расписания поездов дальнего следования","tips.aeroexpress.title":"Аэроэкспресс","tips.aeroexpress.main_order_text":'Расписание аэроэкспресса до аэропортов <a href="http://www.tutu.ru/aeroexpress/schedule/">Шереметьево</a>, <a href="http://www.tutu.ru/aeroexpress/schedule/2/">Домодедово</a>, <a href="http://www.tutu.ru/aeroexpress/schedule/1/">Внуково</a>.',"tips.avia.title":"Авиабилеты","tips.avia.title_small":"авиабилеты","tips.avia.meta_title":"Авиа Tutu.ru: авиабилеты и расписание самолетов%cities%. Стоимость авиабилетов%cities%, цены на %year% год. Дешевые авиабилеты онлайн - заказ и бронирование. Билеты на самолет и расписание авиарейсов – Москва и вся Россия","tips.avia.meta_keywords":"Авиабилеты, авиабилеты дешево, расписание самолетов, стоимость авиабилетов, расписание авиарейсов, авиабилеты цены, авиабилеты онлайн, авиабилеты купить, билеты онлайн, заказ авиабилетов, бронирование авиабилетов, авиакассы, авиабилеты спецпредложения.","tips.avia.meta_description":"Актуальное расписание авиарейсов позволяет быстро узнать стоимость авиабилетов как по России, так и в другие страны мира. Ознакомившись с расписанем самолетов, вы сможете забронировать в режиме онлайн и заказать авиа билеты с доставкой в офис. Подробное описание аэропортов, авиакомпаний, и самолетов.","tips.avia.schedule":"Расписание","tips.avia.schedule_small":"расписание","tips.avia.schedule2":"Расписание авиарейсов","tips.avia.schedule3":"Расписание самолетов","tips.avia.pay":"Оплата авиабилета","tips.avia.order":"Заказ авиабилетов","tips.avia.order2":"Бронирование авиабилетов","tips.avia.order3":"Бронирование","tips.avia.order_small":"заказ авиабилетов","tips.avia.order_and_schedule":"Заказ авиабилетов и расписание","tips.avia.airlines":"Авиакомпании","tips.avia.planes":"Самолеты","tips.avia.airports":"Аэропорты","tips.avia.charters":"Чартеры","tips.avia.beta":"Бета-версия","tips.avia.rules":'<table class="tipsAvia" cellspacing="0" cellpadding="0">\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td style="text-align:center;" colspan="2"><b>Правила заказа авиабилетов</b></td>\n\t\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<b>1. Авиабилеты - заказ и бронирование</b>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оформление и доставка авиабилетов осуществляется в Москве и Санкт-Петербурге;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>авиабилеты бронируются на рейсы, вылетающие через 3 и более суток от текущей даты (в пятницу вы можете забронировать авиабилеты на вторник);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>на указанный при бронировании адрес электронной почты высылается информационное письмо с номером созданной брони;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>если авиабилеты не будут выкуплены до указанного в информационном письме времени, бронирование автоматически аннулируется;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>стоимость авиабилетов на сайте и в информационном письме указана на момент создания брони, с учетом всех сборов;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для уточнения способа оплаты и получения авиабилета оператор связывается по указанному при бронировании номеру телефона в течение 4 часов с 10:00 до 18:00.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<b>2. Документы, необходимые для оформления авиабилета</b>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tЗаказ на авиабилеты принимается при наличии следующих документов, удостоверяющих личность пассажира:\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<ul style="padding-top:10px;">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для граждан России - паспорт РФ (загранпаспорт);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>свидетельство о рождении ребенка (при выписке детского авиа билета);</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>для иностранных граждан - национальный паспорт.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<tr class="dark">\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<b>3. Оплата</b>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оплатить авиабилеты при получении в офисе агентства (1-й Волконский пер., д.15., м. Цветной бульвар) - можно наличными деньгами или кредитными картами Visa и MasterCard;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>при доставке курьером авиабилеты оплачиваются только наличными деньгами.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<b>4. Получение авиабилетов</b>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>доставка осуществляется только в офисы; стоимость доставки — 250-300 рублей, в зависимости от агентства-партнера;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>авиабилеты доставляются по Москве (в пределах МКАД) в будние дни с 10:00 до 19:00;</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<li>оформление и доставку авиабилетов осуществляют партнеры Tutu.ru, компания SI Tours&amp;Travel. Тел.: 7 (495) 921-01-17.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t\t\t\t\t</table>',"tips.avia.sheremetyevo":"Шереметьево","tips.avia.domodedovo":"Домодедово","tips.avia.vnukovo":"Внуково","tips.avia.bykovo":"Быково","tips.avia.pulkovo":"Пулково","tips.avia.rzhevka":"Ржевка","tips.avia.airlines_and_reises":"Авиакомпании и&nbsp;рейсы","tips.avia.from":"Отбытие","tips.avia.to":"Прибытие","tips.avia.plane":"Лайнер","tips.avia.order_ticket":"Заказать билет","tips.avia.airport":"Аэропорт","tips.avia.time":"Время","tips.avia.time_in_way":"Время в полете","tips.avia.schedule_from_amadeus":"Расписание предоставлено компанией «Амадеус Россия»","tips.avia.pop_up_form_message":'Для запроса наличия мест и цены необходимо выбрать тип поездки "туда или туда и обратно", даты вылетов, количество пассажиров и класс бронирования.',"tips.avia.pop_up_form_message2":"Поиск будет осуществлен по всем авиакомпаниям для данного направления.","tips.avia.this_date_no_result":"На данную дату по этому направлению прямых рейсов не найдено.","tips.avia.found_some_result":"Найдено несколько городов, удовлетворяющих Вашему запросу.","tips.avia.please_select_city":"Пожалуйста, выберите нужный город.","tips.avia.select_one_of_cities":"Выберите один из городов","tips.avia.no_result_check_city":"Не найдено ни одного соответствия. Проверьте правильность названия города.","tips.avia.enter_city_name":"Введите название города.","tips.avia.charters_small":"чартерные рейсы","tips.avia.charters_h1":"Чартерные рейсы","tips.avia.charter":"Чартер","tips.avia.charter_order":"Заказ авиабилетов на чартер","tips.avia.go_to_charter_schedule":"Перейти к расписанию чартеров","tips.avia.charters_schedule":"Расписание чартеров","tips.avia.flights_info":"Информация о рейсе","tips.avia.charter_meta_title":"Чартерные рейсы. Расписание чартерных рейсов%cities%, стоимость авиабилетов%cities%, расписание чартерных авиарейсов, заказ авиа билетов и продажа авиабилетов, бронирование и доставка по Москве","tips.avia.common_description":'<div class="common" style="padding:20px 10px 30px 10px; width:90%">\n\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t<b>Большие возможности</b>.\n\t\t\t\t\t\t\t\t\t\t\tСайт&nbsp;tutu.ru продает авиабилеты по&nbsp;России и&nbsp;за&nbsp;рубеж в&nbsp;партнерстве с&nbsp;ведущими агентствами и&nbsp;мировыми системами бронирования.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t<b>Удобство выбора</b>.\n\t\t\t\t\t\t\t\t\t\t\tВсе варианты перелета упорядочены по&nbsp;цене и&nbsp;времени вылета. Вы&nbsp;можете также уточнить нужный вам класс бронирования (бизнес или&nbsp;эконом).\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t<b>Выбор авиакомпании</b>.\n\t\t\t\t\t\t\t\t\t\t\tЧтобы облегчить поиск билетов, вы&nbsp;можете указать конкретную авиакомпанию, включив соответствующий фильтр.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t<b>Актуальные сервисы</b>.\n\t\t\t\t\t\t\t\t\t\t\tВы можете посмотреть точное расписание авиарейсов, онлайн-табло аэропортов и&nbsp;расписание аэроэкспрессов в&nbsp;режиме онлайн.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t<b>Стоимость авиабилетов</b>\n\t\t\t\t\t\t\t\t\t\t\tв&nbsp;расписании авиарейсов указана на&nbsp;момент создания брони, с&nbsp;учетом всех сборов. В&nbsp;случае изменения даты стоимость может измениться.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t</div>',"tips.avia.airport_city_country":"Аэропорт, город или страна","tips.avia.carrier_country":"Авиакомпания или страна","tips.avia.plane_producter_country":"Самолет, производитель или страна","tips.avia.extracharge":"Дополнительная оплата","tips.e_trains.schedule":"Расписание электричек","tips.e_trains.schedule_small":"расписание электричек","tips.e_trains.belarus":"Белорусское","tips.e_trains.gorky":"Горьковское","tips.e_trains.kazan":"Казанское","tips.e_trains.kiev":"Киевское","tips.e_trains.kursk":"Курское","tips.e_trains.leningradskoye":"Ленинградское","tips.e_trains.paveletskaya":"Павелецкое","tips.e_trains.riga":"Рижское","tips.e_trains.savelovskaya":"Савеловское","tips.e_trains.yaroslavskoye":"Ярославское","tips.e_trains.ring":"Кольцевое","tips.e_trains.baltic":"Балтийский","tips.e_trains.vitebsky":"Витебский","tips.e_trains.ladoga":"Ладожский","tips.e_trains.moscow":"Московский","tips.e_trains.finnish":"Финляндский","tips.e_trains.searching":"Поиск расписания электричек на&nbsp;лето&nbsp;%year%&nbsp;г.&nbsp;c&nbsp;изменениями","tips.e_trains.need_to_view":"<noindex>Выберите направление или регион, чтобы посмотреть расписание электропоездов.</noindex>","tips.e_trains.schedule_on":'<noindex><span style="white-space:nowrap;">Актуальное расписание: лето&nbsp;2010</span></noindex>',"tips.e_trains.partners_form_header":"Сделай свой сайт лучше!","tips.e_trains.partners_form_text":'<noindex>Мы предлагаем Вам уникальную услугу&nbsp;&#151; размещение формы поиска\n\t\t\t\t\t\t\t\t\tпо расписанию на <b>Вашем сайте</b>. Все, что Вам нужно&nbsp;&#151; разместить\n\t\t\t\t\t\t\t\t\tу себя на сайте небольшой html-код, и Ваши посетители будут всегда в\n\t\t\t\t\t\t\t\t\tкурсе последних изменений в расписании электричек!\n\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\tВы можете разместить у себя форму поиска по\n\t\t\t\t\t\t\t\t\t<a href="/surprise.php">расписанию электричек, поездов и самолетов</a>!</noindex>',"tips.e_trains.directions":"Направления электропоездов","tips.e_trains.widget":"Виджет «Моя станция»","tips.e_trains.sms":"СМС-расписание","tips.e_trains.sms_about":"Расписание электричек на&nbsp;мобильном 24&nbsp;часа в&nbsp;сутки","tips.e_trains.next_trains":"Ближайшие электрички","tips.e_trains.iframeCode":'<iframe width="%width%" height="%height%" frameborder="0" marginheight="0" marginwidth="0" src="%src%"></iframe><br /><small style="font-family:Arial; display:block; margin-top:5px;"><b><a href="%sectionUrl%">Расписание электричек</a> предоставлено сайтом <a href="%mainUrl%">Tutu.ru</a></b></small>',"tips.e_trains.iframeTitle":"Код i-frame для экспорта расписания электричек","tips.e_trains.sezon":"Зима 2012","tips.e_trains.reverse":"туда <span>и обратно</span>","tips.feedback.title":"Обратная связь","tips.feedback.title_small":"обратная связь","tips.feedback.top_text":'<p class="p">Пожалуйста, сообщайте нам об&nbsp;ошибках в&nbsp;расписании и&nbsp;о&nbsp;временных изменениях. Или просто поделитесь своим мнением, сделайте критическое замечание, задайте вопрос.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p class="p">Обратите внимание, что&nbsp;<a href="/">Tutu.ru</a> не&nbsp;является официальным сайтом ни&nbsp;Московской, ни&nbsp;Октябрьской железной дороги &mdash; мы&nbsp;никак не&nbsp;можем влиять на&nbsp;работу сотрудников РЖД (МЖД, ОЖД или других подразделений), равно как и&nbsp;на&nbsp;формирование расписания и&nbsp;стоимости проезда.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p class="p">Благодарим вас за понимание.</p>',"tips.feedback.bottom_text":'<p class="p" style="padding-top: 1em;">Мы постараемся ответить на&nbsp;ваше письмо в&nbsp;текущий или&nbsp;следующий рабочий день.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p class="p">Телефоны офисов по продаже ж/д и авиабилетов вы можете найти в <a href="/2read/">справочной</a>.</p>',"tips.feedback.about_temporary_edits":"<b>Узнали о временных изменениях?</b>\n\t\t\t\t\t\t\t\t\t\t\t\t<br>Пожалуйста - сообщайте нам, по возможности, любую информацию о временых (и постоянных)\n\t\t\t\t\t\t\t\t\t\t\t\tизменениях. Стоите в ожидании электрички на платформе? Перепишите или сфотографируйте\n\t\t\t\t\t\t\t\t\t\t\t\tвременные изменения - пришлите нам (фотографии можно присылать сюда:\n\t\t\t\t\t\t\t\t\t\t\t\t<script type=\"text/javascript\">document.write('<a href=\"mai'+'lto:in'+'fo&'+'#6'+'4;tu'+'tu'+'.ru\">');document.write('in'+'fo&'+'#6'+'4;tu'+'tu'+'.ru</a>');<\/script>).\n\t\t\t\t\t\t\t\t\t\t\t\tМы их оперативно внесем в расписание, и множество людей будут Вам благодарны! Более того, Вам не придется\n\t\t\t\t\t\t\t\t\t\t\t\tзапоминать все эти изменения и постоянно держать в голове - Туту.ру сделает это за Вас!\n\n\t\t\t\t\t\t\t\t\t\t\t\t<p><b>Если вы заметили ошибку:</b>\n\t\t\t\t\t\t\t\t\t\t\t\t<br>\n\t\t\t\t\t\t\t\t\t\t\t\tПри сообщении об ошибках в расписании, просьба указывать конкретные ошибки -\n\t\t\t\t\t\t\t\t\t\t\t\tт.е. что есть на сайте, и что есть на самом деле. Мы не можем адекватно\n\t\t\t\t\t\t\t\t\t\t\t\tобрабатывать сообщения \"у вас все расписание неверное!!!\"\n\t\t\t\t\t\t\t\t\t\t\t\tили \"по Ленинградскому вокзалу куча ошибок!\" Просьба сообщать максимально подробно,\n\t\t\t\t\t\t\t\t\t\t\t\tнапример:\n\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\"По Савеловскому направлению электричка в 18:12 от станции Тимирязевская\n\t\t\t\t\t\t\t\t\t\t\t\tна Дубну указана ежедневно, на самом же деле только по рабочим\".\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\n\t\t\t\t\t\t\t\t\t\t\t\tИли: \"указанная электричка с платформы Солнечная до Киевского вокзала в 16:12 с 12 января отменена\",\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tили: \"По Курскому направлению электричка Москва - Серпухов отправляется по данным\n\t\t\t\t\t\t\t\t\t\t\t\tвашего сайта в 16:34, на самом же деле она отправляется в 16:25\". Чем точнее\n\t\t\t\t\t\t\t\t\t\t\t\tВы опишите ошибку, тем меньше времени нам потребуется на уточнение информации\n\t\t\t\t\t\t\t\t\t\t\t\t(мы стараемся, по возможности, проверять данные) и тем быстрее она будет исправлена -\n\t\t\t\t\t\t\t\t\t\t\t\tВам будут благодарны все пользователи сайта!\n\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Просьба указывать свой электронный адрес, если он есть - так как иногда\n\t\t\t\t\t\t\t\t\t\t\t\tпользователи путают колонку \"на Москву\" и \"от Москвы\", или не замечают строчку\n\t\t\t\t\t\t\t\t\t\t\t\t<<В колонке \"время\" указано время прохождения поезда через ст. такую-то>>...\n\t\t\t\t\t\t\t\t\t\t\t\tДа всякое бывает - когда хочется связаться с автором сообщения.\n\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Иногда на просторах Интернета - в форумах - встречаются сообщения типа\n\t\t\t\t\t\t\t\t\t\t\t\t\"уже второй месяц (третий раз, постоянно и т.д.)\n\t\t\t\t\t\t\t\t\t\t\t\tзахожу на Туту.ру и каждый раз натыкаюсь на ошибку, что электричка\n\t\t\t\t\t\t\t\t\t\t\t\tтакая-то ходит так-то вместо так-то...\"  Мы призываем не подражать такому\n\t\t\t\t\t\t\t\t\t\t\t\tповедению: увидели ошибку - сразу сообщите нам\n\t\t\t\t\t\t\t\t\t\t\t\t- мы ее исправим в максимально короткие сроки.","tips.feedback.choose_topic":"Выберите тему сообщения","tips.feedback.section1":"Вопрос по <b>заказу авиа или ж/д билетов</b>","tips.feedback.section2":"Вопрос на другую тему","tips.feedback.topic_value_1":"Заказ авиабилетов в Москве","tips.feedback.topic_value_2":"Заказ электронных ж/д билетов","tips.feedback.topic_value_3":"Заказ ж/д билетов на бланке РЖД в Москве","tips.feedback.topic_value_4":"Перезвоните мне (Мск)","tips.feedback.topic_value_5":"Заказ ж/д билетов на бланке РЖД в Санкт-Петербурге","tips.feedback.topic_value_6":"Перезвоните мне (СПб)","tips.feedback.topic_value_7":"Сообщение об ошибке","tips.feedback.topic_value_8":"Сообщение об изменениях в расписании","tips.feedback.topic_value_9":"Пожелания и предложения","tips.feedback.topic_value_10":"Другое","tips.feedback.topic_value_12":"Заказ такси","tips.feedback.topic_value_13":"Поругаться","tips.feedback.topic_value_14":"Сказать спасибо","tips.feedback.topic_title_1":"Вопрос по заказу авиабилетов в Москве","tips.feedback.topic_title_2":"Вопрос по заказу <b>электронных</b> ж/д билетов","tips.feedback.topic_title_3":"Вопрос по заказу ж/д билетов на бланке РЖД в Москве","tips.feedback.topic_title_4":"Заказ обратного звонка (ж/д билеты на бланке РЖД в Москве)","tips.feedback.topic_title_5":"Вопрос по заказу ж/д билетов на бланке РЖД <b>в Санкт-Петербурге</b>","tips.feedback.topic_title_6":"Заказ обратного звонка (ж/д билеты на бланке РЖД в Санкт-Петербурге)","tips.feedback.topic_title_7":"Сообщение об ошибке","tips.feedback.topic_title_8":"Сообщение о временных изменениях","tips.feedback.topic_title_9":"Пожелания и предложения","tips.feedback.topic_title_10":"Другое","tips.feedback.topic_title_12":"Вопрос по заказу такси","tips.feedback.topic_title_13":"Поругаться","tips.feedback.topic_title_14":"Сказать спасибо!","tips.feedback.ready_message1":"Мною оформлен заказ ж/д билетов на бланке РЖД в Москве. Мне нужно кое-что уточнить у вашего менеджера, но я не могу дозвониться до вас. Перезвоните мне пожалуйста. Номер моего заказа: TUTU-****-****** (укажите номер). Номер моего телефона: ","tips.feedback.ready_message2":"Мною оформлен заказ ж/д билетов на бланке РЖД в Санкт-Петербурге. Мне нужно кое-что уточнить у вашего менеджера, но я не могу дозвониться до вас. Перезвоните мне пожалуйста. Номер моего заказа: TUTU-SPB-****-****** (укажите номер). Номер моего телефона: ","tips.feedback.section_comment":'<b>узнать цены</b> и оформить заказ можно в разделе <a href="/poezda/zakaz/">заказ ж/д билетов</a>',"tips.feedback.email_comment":"Помните, мы не сможем ответить Вам, если Вы не укажете адрес своей электронной почты.","tips.feedback.email":"Ваша электронная почта","tips.feedback.send":"Отправить","tips.feedback.error_topic":"Пожалуйста, выберите тему сообщения!","tips.feedback.error_email":"Пожалуйста, укажите правильный адрес эл. почты!","tips.feedback.error_message":"Вы отправляете пустое сообщение? Вам нечего нам сказать?","tips.feedback.error_message_long":"Ваше сообщение слишком большое! Сообщение не принято.","tips.feedback.success":"Ваше сообщение успешно отправлено! Спасибо!","tips.feedback.not_email":'К сожалению, <font color="red">Вы не указали свой электронный адрес</font> - и мы не сможем ответить на Ваше сообщение лично. Вы можете сообщить свой адрес, отправив еще одно сообщение.',"tips.feedback.":"","tips.charter.field_contact_name":"Контактное лицо","tips.charter.field_contact_email":"Адрес эл. почты","tips.charter.field_contact_phone":"Телефон","tips.charter.field_contact_phone2":"Второй телефон","tips.charter.field_passenger_name":"ФИО пассажира","tips.charter.field_passenger_passport":"Загранпаспорт","tips.charter.field_passenger_birthday":"Дата рождения","tips.charter.agreement":'Заказав билет или нажав кнопку "Заказать", Вы соглашаетесь с <a href="#" onclick="charter.parent.switcher( \'agreement\' ); return false;">условиями использования сервиса</a>.',"tips.charter.rules_for_order":"Правила заказа билетов","tips.charter.rules_for_order_small":"правила заказа билетов","tips.charter.rules_content_for_textarea":"Заказ чартерных авиабилетов через Tutu.ru возможен только при согласии с Условиями использования сервиса, выраженного путем совершения конклюдентных действий.\n\nЕсли Вы не принимаете в полном объеме Условия использования сервиса, заказ чартерных авиабилетов через Tutu.ru не допускается.\n\n\n\nУсловия использования сервиса по заказу чартерных авиабилетов через Tutu.ru\n\n\n1. ОБЯЗАННОСТИ КЛИЕНТОВ TUTU.RU\n\n1.1. Клиент Tutu.ru обязан:\n\n1.1.1. самостоятельно ознакомиться с правилами и инструкциями по заказу чартерных авиабилетов на сайте www.tutu.ru;\n\n1.1.2. соблюдать все правила и инструкции Tutu.ru и партнеров, в том числе, но не ограничиваясь этим, правила партнеров (http://www.cheaptickets.ru/gettext.asp?code=roles);\n\n\n\n\n2. ПРАВА TUTU.RU\n\n2.1. Tutu.ru имеет право:\n\n2.1.1. в одностороннем порядке отказать Клиенту в заказе чартерных авиабилетов через сайт www.tutu.ru, в том числе в случае нарушения Клиентом правил и инструкций по заказу чартерных авиабилетов, но не ограничиваясь этим;\n\n2.2. изменять условия использования сервиса без предварительного уведомления.\n\n\n3. КОНФИДЕНЦИАЛЬНОСТЬ ЛИЧНЫХ ДАННЫХ\n\n3.1. Tutu.ru обязуется заботиться о конфиденциальности личной информации, предоставленной пользователем при заказе.\n\n3.2. Факт пользования услугами Tutu.ru подтверждает согласие Клиента на использование адреса его электронной почты в сети Интернет (E-mail) для направления ему информации, признаваемой Tutu.ru ценной для Клиента.\n\n3.3. За предоставление Клиентом неверных номеров телефонов и личных данных Tutu.ru ответственности не несет.\n\n\n\n4. ОТВЕТСТВЕННОСТЬ\n\n4.1. Tutu.ru  не несет ответственности за надлежащее функционирование и доступность отдельных сегментов сети Интернет в ходе заказа чартерных авиабилетов.\n\n5.2. Tutu.ru не несет ответственности за надлежащую работу компаний-партнеров.\n\n5.3. Клиент принимает на себя полную ответственность и риски, связанные с заказом чартерных авиабилетов.\n\n5.4. Tutu.ru не несет ответственности за любые убытки и моральный вред, понесенные Клиентом в результате ошибочного понимания или непонимания Клиентом информации о порядке заказа чартерных авиабилетов.","tips.charter.rules_content_for_page":'<center><h1 style="margin-left: 0;">Правила заказа билетов на чартерные рейсы</h1></center>\n<br />\n<ul class="charterRules">\n\t<li>\n<h3><span class="serif" style="border-bottom: 2px solid rgb(102, 153, 153);">Общие условия заказа чартерных авиабилетов</span></h3>\n<ol>\n\t<li>Для заказа чартерных авиабилетов необходимо выбрать маршрут следования и дату следования по маршруту.</li>\n\t<li>Заказ чартерных авиабилетов не считается завершенным без окончательного подтверждения условий и тарифов оператором.</li>\n\t<li>Выписка чартерных авиабилетов осуществляется не позднее,  чем за 12 часов до вылета рейса.</li>\n</ol>\n\t</li>\n\t<li>\n<h3><span class="serif" style="border-bottom: 2px solid rgb(102, 153, 153);">Данные, необходимые для заказа билетов на чартерные авиарейсы</span></h3>\n<ol>\n\t<li>При бронировании авиабилетов на чартер пассажир должен сообщить свое ФИО, данные заграничного паспорта, дату рождения.</li>\n</ol>\n\t</li>\n\t<li>\n<h3><span class="serif" style="border-bottom: 2px solid rgb(102, 153, 153);">Оплата авиабилетов на чартерные рейсы и условия возврата</span></h3>\n<ol>\n\t<li>Стоимость чартерных авиабилетов, указанная на сайте,  носит информационный характер и не является публичной офертой.</li>\n\t<li>Оплата забронированных авиабилетов производится в течение 24 часов после подтверждения оператором. В случае неоплаты билета заказ снимается.</li>\n\t<li>Оплату можно произвести как наличными деньгами, так и кредитной картой в офисе агентства. Подробности можно уточнить у  оператора при подтверждении заказа.</li>\n\t<li>При оплате в офисе агентства заключается договор. Выписка билетов может быть произведена  не позднее,  чем за 12 часов до вылета рейса.</li>\n</ol>\n\t</li>\n\t<li>\n<h3><span class="serif" style="border-bottom: 2px solid rgb(102, 153, 153);">Билеты для детей</span></h3>\n<ol>\n\t<li>Детские тарифы на чартерных авиарейсах не предусмотрены.</li>\n</ol>\n\t</li>\n\t<li>\n<h3><span class="serif" style="border-bottom: 2px solid rgb(102, 153, 153);">Возврат билета, утерянные или испорченные билеты</span></h3>\n<ol>\n\t<li>Оплаченные авиабилеты обмену и возврату не подлежат.</li>\n\t<li>При утрате, порче авиабилета пассажир к полету не допускается, стоимость билета не возвращается, дубликат не выдается, претензии не принимаются.</li>\n</ol>\n\t</li>\n</ul>',"tips.charter.county_select":"Выберите страну прилета","tips.charter.city_select":"Выберите город","tips.charter.click_departure_date":"Кликните на возможную дату вылета.","tips.charter.feature_charterparties":"Особенность чартеров — дата возврата зависит от даты вылета «туда».","tips.charter.see_all_charters":'Чтобы увидеть все чартерные рейсы, включая те, на которые нельзя купить билет, перейдите к <a href="%link%">расписанию чартеров %from% - %to%</a>',"tips.charter.charter_tips":"Затем вы увидите чартеры на выбранную дату с возможной датой возврата.","tips.charter.select_flights_or_change_date":"Выберите рейс или поменяйте дату","tips.charter.business_class":"бизнес-класс","tips.charter.first_class":"первый класс","tips.charter.in_one_way":"В одну сторону","tips.charter.rub":"руб.","tips.charter.":"","tips.menu.dtrains":"Ж/д билеты","tips.menu.etrains":"Электрички","tips.menu.hotels":'<span class="item-name" >Заказ гостиниц</span>',"tips.menu.avia":"Авиабилеты","tips.menu.more":"Еще","tips.menu.2read":"Справочная","tips.menu.aeroxpress":"Аэроэкспресс","tips.hotels.title":"Отели","tips.hotels.hotels":"Гостиницы и отели","tips.hotels.hotels_small":"гостиницы и отели","tips.hotels.order":"Бронирование отелей","tips.hotels.need_for_order":"Для бронирования отеля выберите город или&nbsp;страну.","common.meta_title":"Tutu.ru: Авиа и ЖД билеты. Стоимость железнодорожных билетов и расписание, цены на %year% год, заказ ж/д билетов и авиабилетов. Расписание электричек %year% г. с изменениями - Москва","common.meta_title_404":"Ошибка 404","common.meta_keywords":"жд, билеты, стоимость, железнодорожных, билетов, заказ ж/д билетов, расписание, электричек, электропоездов, Москвы, Санкт-Петербург, пригородных, поездов, Московской, области, вокзалов, изменения, %year%, билеты на поезд РЖД","common.meta_description":"Заказ жд билетов. Стоимость и расписание. Расписание электричек на %year% год с изменениями для всех вокзалов Москвы и Санкт-Петербурга. Расписание электропоездов Москвы. Заказ жд билетов на поезда РЖД","common.license":"Данные, использованные на&nbsp;сайте, включая стоимость билетов, а&nbsp;также расписание самолетов, поездов и&nbsp;электропоездов, взяты из&nbsp;официальных источников. Заказы ж/д билетов и&nbsp;авиабилетов, включая электронные ж/д&nbsp;билеты, оформляются партнерами Туту.ру.","common.license_main":"Данные, использованные на&nbsp;сайте, включая стоимость билетов, а&nbsp;также расписание самолетов, поездов и&nbsp;электропоездов, взяты из&nbsp;официальных источников. Заказы авиа и&nbsp;ж/д&nbsp;билетов, включая электронные жд&nbsp;билеты, оформляются партнерами Туту.ру.","common.license_hotel":"Бронирование гостиниц %preposition% %country_loc% осуществляется партнерами Tutu.ru.","common.license_hotel_foreign":"Бронирование отелей %preposition% %country_loc% осуществляется партнерами Tutu.ru.","common.license_mainpage":'Расписание электричек на лето %year%&nbsp;г. c&nbsp;изменениями, получено на основании официально опубликованных расписаний электричек. Заказы авиабилетов и&nbsp;жд&nbsp;билетов, включая <a href="/poezda/e-zakaz/">электронные жд билеты</a>, оформляются партнерами Туту.ру.',"common.when":"Когда","common.point_from":"Откуда","common.on":"на","common.point_from_tips":"Для бронирования авиабилетов необходимо<br />ввести город вылета на&nbsp;русском языке.","common.point_from_hint":"Город вылета","common.city_name":"Название города","common.searching":"Поиск...","common.reset":"Сброс","common.clean_and_close":"Очистить и закрыть","common.close":"Закрыть","common.choose":"Выбрать","common.cancel_order":"Отменить заказ","common.cancel":"Отменить","common.show":"Показать","common.show_full":"Показать расписание и билеты","common.show_price":"Узнать цены","common.show_train":"Найти ж/д билеты","common.start_typing":"Начните ввод названия...","common.point_to":"Куда","common.point_to_tips":"Для бронирования авиабилетов необходимо<br />ввести город прилета на&nbsp;русском языке.","common.point_to_hint":"Город прилета","common.date":"Дата","common.date_from":"Дата вылета","common.date_from2":"Дата заезда","common.date_to":"Дата возврата","common.date_to2":"Дата отъезда","common.date_format":"Дата","common.details":"Подробнее","common.one_way":"В одну сторону","common.two_ways":"Туда и обратно","common.adds":"Дополнительно","common.passengers_count":"Количество пассажиров","common.adults":"Взрослые","common.childs":"Дети (2-11 лет)","common.children":"Дети (2-11 лет)","common.babies":"Маленькие дети (до 2 лет)","common.class":"Класс","common.econom":"Экономический","common.business":"Бизнес","common.first":"Первый","common.any":"Любой","common.please_wait":"Пожалуйста, подождите. Выполнение запроса занимает до 30 секунд.","common.no_result":"Ничего не найдено","common.maximaze":"развернуть","common.choose_country":"Выберите страну","common.choose_city":"Выберите город","common.found":"Найдено","common.only_first":"Показаны первые <count> записей (<all>)","common.show_all":"показать все","common.level_up":"На уровень выше","common.choose_variant":"Выберите один из вариантов или продолжите набор","common.other_cities":"Другие&nbsp;города","common.other_cities_world":"Другие города мира","common.avia_order_online":"Заказывайте авиабилеты онлайн","common.before_avia_order":"Перед заказом авиабилетов","common.read_rules":"ознакомьтесь с правилами","common.try_later":"Пожалуйста, попробуйте позже","common.loading":"Загрузка...","common.saving":"Сохранение...","common.deleting":"Удаление...","common.you_order_and_get_ticket":"Вы заказываете и получаете билеты","common.msk":"Москва","common.spb":"Санкт-Петербург","common.in_msk":"в Москве","common.in_spb":"в Санкт-Петербурге","common.not_necessarily":"не обязательно","common.station_name":"Название станции","common.belgorod":"Белгород","common.bryansk":"Брянск","common.voronezh":"Воронеж","common.irkutsk":"Иркутск","common.kaluga":"Калуга","common.kursk":"Курск","common.lipetsk":"Липецк","common.orel":"Орел","common.ryazan":"Рязань","common.smolensk":"Смоленск","common.sochi":"Сочи","common.tambov":"Тамбов","common.tula":"Тула","common.project":"Проект компании","common.main":"Главная","common.feedback":"Обратная связь","common.feedback_line":"Онлайн консультант","common.feedback_line_rev":"консультант online","common.feedback_line_off":"консультант offline","common.feedback_ask":"Задать вопрос","common.surprise":"Партнерская программа","common.advert_at":"Реклама на","common.city_and_country":"Город или страна","common.enter_city_and_country":"Введите название города или страны","common.alert_date_from":"Необходимо указать дату заезда в формате ДД.ММ.ГГГГ","common.alert_date_to":"Необходимо указать дату отъезда в формате ДД.ММ.ГГГГ","common.volgograd":"Волгоград","common.krasnoyarsk":"Красноярск","common.ekaterinburg":"Екатеринбург","common.kazan":"Казань","common.nizhny_novgorod":"Нижний Новгород","common.novosibirsk":"Новосибирск","common.samara":"Самара","common.london":"Лондон","common.paris":"Париж","common.newyork":"Нью-Йорк","common.tunis":"Тунис","common.prague":"Прага","common.tokyo":"Токио","common.rome":"Рим","common.haifa":"Хайфа","common.russian":"РОССИЯ","common.sng":"СНГ","common.all_countries":"Все страны","common.country":"Страна","common.country_small":"страна","common.city":"Город","common.city_small":"город","common.forward":"Туда","common.forward_small":"туда","common.back":"Обратно","common.back_small":"обратно","common.total":"Итого","common.order":"Заказать","common.date_of_return_depends":"Дата возврата зависит от даты вылета. Выберите подходящую дату вылета.","common.h":"ч.","common.i":"мин.","common.this_price_is_min":"Указанная цена является минимальной","common.at_this_pair_no_offers":"На данную пару дат предложений нет","common.date_of_return_depends2":"Дата возврата зависит от даты вылета.<br>Выберите подходящие даты чартера и кликните, чтобы просмотреть детали.","common.unknown":"Неизвестно","common.departure":"Вылет","common.departure_small":"вылет","common.arrival":"Прилет","common.in_flight":"В полете","common.flights":"Рейс","common.price_the_ticket":"Стоимость одного билета от","common.special_for_charters":"специальные предложения","common.price_description_for_charters":"Цены и наличие авиабилетов на чартеры указаны на момент публикации. Расписание чартерных рейсов обновляется регулярно.","common.price_description_for_charters2":'Чартерные авиарейсы — нерегулярные рейсы авиакомпаний, выполняемые для определенного заказчика. Авиабилеты на чартерные рейсы как правило стоят дешевле авибилетов на обычные рейсы. Так происходит из-за того, что авиакомпания продает все билеты на авиарейс без остатка.\n\t<p>Не секрет, что билеты на чартерные рейсы могут быть дешевле авиабилетов на регулярные рейсы авиакомпаний. Порой цена на билеты чартерных рейсов отличается в 2-3 раза, в меньшую сторону. В добавок, на ряд популярных «отпускных» направлений регулярных рейсов вовсе нет, как следствие, нет и авиабилетов.\n\tВ данной ситуации заказ чартера может быть единственным выходом. Основным недостатком является вероятность изменения расписания чартерных рейсов, то есть переноса времени вылета и прилета (важно для стыковочных маршрутов).\n\t<p>Чартерные рейсы выполняются вне штатного расписания по графику, который утверждает гос.служба гражданской авиации (ГСГА).\n\t<p><a href="/2read/catalog/avia_faq/item/avia_cost/" target="_blank">Подробнее про стоимость авиабилетов</a>\n\t',"common.order_passenger_notice":"<p>Заполните, пожалуйста, форму заказа авиабилета на&nbsp;чартерный рейс.</p><p>Обратите внимание, что&nbsp;цены на&nbsp;чартерные авиарейсы могут  измениться. Наш&nbsp;оператор обязательно позвонит вам и&nbsp;сообщит самую оперативную информацию о&nbsp;ценах и&nbsp;наличии мест.</p>","common.passengers_info":"Информация о пассажирах","common.contacts_info":"Информация для связи","common.congratulation_for_success_order":"Поздравляем с успешным заказом!","common.your_order_success_send":"<p>Ваш заказ принят. Наш сотрудник свяжется с&nbsp;вами в&nbsp;ближайшее время для подтверждения заказа и&nbsp;уточнения деталей оформления.</p><p>Наши операторы работают с&nbsp;понедельника по&nbsp;пятницу с&nbsp;10&nbsp;до&nbsp;19 часов. Заявки на&nbsp;сайте принимаются круглосуточно.</p>","common.number_your_order":"Номер вашего заказа","common.save_him":"сохраните его","common.order_success_notice":'<p align="left">Если в&nbsp;течение 1-2&nbsp;часов вам не&nbsp;перезвонили, то&nbsp;для уточнения вашей заявки можно позвонить по&nbsp;телефону (495) 788-53-83&nbsp;(наш партнер, компания "Билет-он-лайн").</p><p align="left">При этом <strong>сообщите номер заказа</strong>, а&nbsp;также что вы&nbsp;делали <strong>заказ чартерных авиабилетов</strong> на&nbsp;сайте ТУТУ.РУ&nbsp;&#8212; это поможет быстрее найти вашу заявку.</p><p align="left">&nbsp;</p><p align="left">',"common.charter_office_address":"Адрес нашего офиса для получения билетов: м. Беговая, Хорошевское шоссе, дом 32а, 3 подъезд, 3 этаж, офис 312.","common.charter_office_path":'От м. "Беговая" (первый вагон из центра, в подземном переходе направо, по лестнице - налево) идете чуть по диагонали правее в сторону дворов.\n\tПроходите мимо яркой и заметной желтой вывески "Стоматология" на стене дома и попадаете на неширокую улочку, которая упирается в красный дом с зеленой крышей.\n\tЕго прекрасно видно. Перед тем как попасть на территорию офисного центра необходимо миновать проходную со шлагбаумом, предъявив там паспорт и сказав, что идете в компанию "Билет Онлайн".\n\tПодъезд 3 находится правее от проходной.',"common.order_success_notice2":'<p align="left"> Благодарим вас за&nbsp;то,&nbsp;что вы&nbsp;воспользовались нашей услугой заказа билетов.</p><p align="left">&nbsp;</p><p align="left"><strong>Мы&nbsp;всегда рады видеть вас в&nbsp;числе клиентов  Туту.ру.</strong></p>',"common.see_big_map":"Просмотреть увеличенную карту","common.contact":"Контактное лицо","common.phone":"Телефон","common.phone2":"Второй телефон","common.advanced":"Дополнительно","common.email":"Адрес эл. почты","common.fio":"ФИО","common.how_in_original_foreign_passport":"латиницей как в загранпаспорте","common.foreign_passport":"Загранпаспорт","common.birthday":"Дата рождения","common.show_dates":"Показать даты","common.price_from":"Цена от","common.price_to":"Цена до","common.special_offer":"Специальное предложение","common.loading2":"Идет загрузка...","common.flights_info":"Информация о рейсе","common.go_to_begin":"В начало","common.info":"Информация","common.link_ksamoletu":"Заказ такси в аэропорт","common.link_pointers":"Таможенное оформление грузов","common.submit":"Отправить","common.edit":"Редактировать","common.save":"Сохранить","common.select":"-- Выбрать --","common.delete":"Удалить","common.searchengine":"Поисковик","common.limit_exceeded":"Превышено допустимое количество обращений этого типа, подождите некоторое время","common.bottom_mail_address":"","common.in":"в","common.price":"Стоимость","common.rub":"руб","common.cost_short":"&nbsp;р.","common.learn_price":"Узнать стоимость","common.learn_full_price":"Узнать полную стоимость","common.next":"Далее","common.choose2":"выберите","common.by_day":"днем","common.by_night":"ночью","common.by_weekend":", по выходным и праздникам","common.footer_adt":"","common.no":"нет","common.and":"и","common.captcha":"Введите цифры с картинки","common.captcha_hint":"Робот не сможет ввести символы с картинки, а вы сможете.","common.captcha_alert":"C вашего адреса поступает очень много запросов к Tutu.ru. Эти запрос похожи на автоматические, отправляемые роботами.<br>\nЕсли вы не робот, пожалуйста, заполните форму с цифрами.","common.no_flood":"C вашего адреса поступает очень много запросов к Tutu.ru. Эти запрос похожи на автоматические, отправляемые роботами.<br>\nЕсли вы не делали большое количество запросов, возможно, это было сделано без вашего ведома. Пожалуйста, проверьте ваш компьютер антивирусом.","common.ip_denied":"Для вашего IP адреса закрыт доступ на сайт. Возможно, это связано с большим количеством запросов, поступавшим с вашего адреса.<br>\nЕсли вы не делали большое количество запросов, возможно, это было сделано без вашего ведома. Пожалуйста, проверьте ваш компьютер антивирусом.","common.title_captcha":"Страница проверки - заполните форму с цифрами.","common.wrong_imagecaptcha_code":"Вы неправильно ввели код.","common.title_flood_denied":"Для вашего IP адреса закрыт доступ на сайт.","common.title_no_flood":"С вашего IP адреса поступает очень много запросов","common.view_map_coords":"на карте","common.coordinates":"Координаты","common.feedback_about_bugs":'<noindex>Уважаемые посетители, мы стараемся поддерживать информацию на нашем сайте в\n\t\t\t\t\t\t\t\t\t\t\tактуальном состоянии. Если Вы заметили неточность, или располагаете информацией, которую можно добавить на данную страницу, напишите нам об этом <a href="/feedback_site.php">через форму на сайте</a>\n\t\t\t\t\t\t\t\t\t\t\tлибо на электронный адрес <a href="mailto:info@tutu.ru">info@tutu.ru</a></noindex>',"common.vacancy":"Вакансии","common.daySymbol":'<span class="miniNbsp">&nbsp;</span>д',"common.hourSymbol":'<span class="miniNbsp">&nbsp;</span>ч',"common.minuteSymbol":'<span class="miniNbsp">&nbsp;</span>м',"common.minuteSymbolLong":'<span class="miniNbsp">&nbsp;</span>мин',"common.kmSymbol":'<span class="miniNbsp">&nbsp;</span>км',"common.pic":"Изображение","common.of":"из","common.tutu_blog":"Туту-блог","common.information_service":"Справочная","common.tutu":"Туту!","common.date_range_humane":"С %start% по %end%","common.calendar":"Календарь","common.example":"Например","common.faq":"Все вопросы и ответы","common.feedback_about":'Предложения, пожелания, указание ошибок и&nbsp;неточностей в&nbsp;расписаниях электричек, поездов или авиарейсов присылайте через <a href="%url%">форму обратной связи</a>.',"common.surprise_me":"Удиви меня","common.popular_directions":"Популярные направления","common.europe":"Европа","common.extended_search":"Расширенный поиск","common.not_found":"По вашему запросу ничего не найдено. Попробуйте поменять условия поиска.","common.search_result":'Результат поиска по запросу "%search%"',"common.search_string_mustbe_longer":"Искомая строка должна быть не менее 3 символов.","common.reply":"Ответить","common.example_plugin":"Например:","common.example_plugin_or":"или","common.example_clean_date":"убрать дату","common.male":"Мужской","common.female":"Женский","common.print_now":"Напечатать расписание","common.print_back":"Расписание поездов","common.basket":"Корзина","common.same_publications":"Схожие статьи","common.ask_for_questions":"Tutu.ru отвечает на самые частые вопросы пассажиров — ","common.train_stations":"Вокзалы","common.all":"все","common.boeing":"Боинг","common.ticket_cost":"Стоимость билета","common.search_phrase":"Фраза для поиска","common.today":"сегодня","common.tomorrow":"завтра","common.dayaftertomorrow":"послезавтра","common.survey_archive":"Архив опросов","common.buy_button":"Купить билеты","common.buy_total":"Купить","common.timezone":"Часовой пояс","common.currency":"Валюта","common.language":"Язык","common.phone_code":"Телефонный код","common.visa":"Виза","common.russian_embassy":"Российское посольство","common.russian_embassy_addr":"расположено по адресу","common.embassy_in_russia":"Посольство в России","common.capital":"Столица","common.flag":"Государственный флаг","common.info_check_and_modify":"Информация проверена и изменена %date%","common.visa1":"Посольства","common.visa2":"<br />и визовый режим","common.nokia_ovi_menu":"Бесплатная навигация для Nokia","common.nokia_ovi_download_0":'Карты городов с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.nokia_ovi_download_1":'Карту <strong>%name1%</strong> с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.nokia_ovi_download_2":'Карты <strong>%name1%</strong> и <strong>%name2%</strong> с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.nokia_ovi_service":"Перейти на страницу сервиса","common.email_nokia_ovi_download_0":'Карты городов с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.email_nokia_ovi_download_1":'Карту <strong>%name1%</strong> с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.email_nokia_ovi_download_2":'Карты <strong>%name1%</strong> и <strong>%name2%</strong> с бесплатной автомобильной и пешеходной навигацией для телефонов Nokia вы можете <a href="http://ad-emea.doubleclick.net/clk;237719055;61064756;n" target="_blank">скачать здесь</a>.',"common.currency_course":"%sum1% %currency1% за %sum2% %currency2%","common.data_successfully_changed":"Данные успешно изменены","common.cannot_change_data":"Ошибка изменения данных","common.nojs_title":"Включите JavaScript, чтобы продолжить работу с&nbsp;сайтом.","common.nojs_text":"В&nbsp;настройках браузера выберите вкладку <strong>&laquo;Безопасность&raquo;</strong><br/> и&nbsp;поставьте галочку напротив пункта <strong>&laquo;Включить JavaScript&raquo;</strong>","error.service_temporarily_unavailable":"Сервис временно недоступен. Попробуйте повторить позднее.","error.critical":"Произошла внутренняя ошибка. Обратитесь к администратору.","error.date_from":"Выберите дату вылета.","error.city_to":"Выберите город прибытия.","error.not_empty":"Заполните поле %field_name%.","error.email":"Неверный адрес эл. почты.","error.phone_light":"Проверьте введенный телефон. Образец ввода: +7(47931)12345 18","error.at_list_one_passenger":"Введите данные хотя бы одного пассажира.","error.latin":"%field_name% должно заполнено только латиницей.","error.agree":"Перед заказом билета вы обязательно должны согласиться с условиями использования сервиса.","error.date":"%field_name% неверного формата.","error.time":"%field_name% неверного формата.","error.date_exist":"%field_name% еще не наступила.","error.invalid_doc_num":"%field_name% содержат номер неверного формата.","error.doc_valid_period_expired":"Срок действия документа истек.","error.invalid_document":"Неверный номер документа","error.invalid_phone":"Неверный номер телефона. Пример: 7 916 0000000","error.invalid_birthday":"Неверная дата рождения","error.empty_field":"Это поле необходимо заполнить.","error.empty_avia_search_by_airport_city_country":"Пожалуйста, введите название аэропорта, города или страны","error.empty_avia_search_by_carrier_country":"Пожалуйста, введите название авиакомпании или страны","error.empty_avia_search_by_plane_productor_country":"Пожалуйста, введите название самолета, производителя или страны","error.empty_plane_list":"Не удалось найти самолетов, соответствующих критериям поиска.","error.empty_carrier_list":"Не удалось найти авиакомпаний, соответствующих критериям поиска.","error.empty_country_list":"Не удалось найти стран, соответствующих критериям поиска.","error.empty_airport_list":"Не удалось найти аэропортов, соответствующих критериям поиска.","error.invalid_date_format":"Задан некорректный формат даты","error.":"","train.train.schedule":"Расписание поездов","train.train.common_bottom_navy_title":"жд билеты %departure% - %arrival%","train.train.route_top_navy_title":"Маршрут поезда %departure% - %arrival%","train.train.schedule_top_navy_title":"Годовой график поезда %departure% - %arrival%","train.train.schedule_navy_title":"Маршрут поезда %from%","train.train.schedule_meta_title":"Расписание движения поездов %departureStationName% - %arrivalStationName%","train.train.schedule_meta_keywords":"Расписание движения поездов, %departureStationName% - %arrivalStationName%, %departureStationName2% - %arrivalStationName2%","train.train.schedule_meta_description":"Расписание движения поездов: %departureStationName% - %arrivalStationName% : %departureStationName2% - %arrivalStationName2%","train.train.route_meta_title":"Расписание поездов %departureStationName% - %arrivalStationName% : заказ жд билетов %departureStationName% - %arrivalStationName% %stationList%","train.train.route_meta_keywords":"Расписание поездов: %departureStationName% - %arrivalStationName% : заказ жд билетов %departureStationName% - %arrivalStationName%, %stationList%","train.train.route_meta_description":"Расписание поездов %departureStationName% - %arrivalStationName% , заказ жд билетов %departureStationName% - %arrivalStationName% %stationList%","train.train.order_link":"Заказ жд билетов на поезд %departure% - %arrival%","train.order.5years_baby_link":"Если с вами едет ребенок до 5 лет без занятия отдельного места, ознакомьтесь с инструкцией","train.order.low_free_seats_popup_all":'<p>Обратите внимание, что в %category% осталось всего %number% %title%.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Вам нужно будет оплатить заказ как можно раньше.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Для этого лучше выбрать оплату электронного билета онлайн.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Если вы хотите купить билет на бланке, пожалуйста, позвоните нам сразу после заказа.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p><a href="%url%" target="_blank">Телефоны наших офисов</a></p>',"train.order.low_free_seats_popup":'<p>Обратите внимание, что в %category% осталось всего %number% %title%.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Вам нужно будет оплатить заказ как можно раньше.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Пожалуйста, позвоните нам сразу после заказа на сайте.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p><a href="%url%" target="_blank">Телефоны наших офисов</a></p>',"train.order.timeout_error":"Время, выделенное на оформление заказа, истекло!","train.order.acmdNotAvaluable":"В выбранный вагон нельзя приобрести ","train.order.seats_number":"Количество мест","train.order.seats_numbers":"Размещение","train.order.sex_type_male":"Мужские","train.order.sex_type_female":"Женские","train.order.sex_type_mixed":"Смешанные","train.order.sex_postfix":"места","train.order.sex_type_male_lower":"мужские","train.order.sex_type_female_lower":"женские","train.order.sex_type_mixed_lower":"смешанные","train.order.coupe":"купе","train.order.sex_type_male_single":"Мужское","train.order.sex_type_female_single":"Женское","train.order.sex_type_mixed_single":"Смешанное","train.order.error_missing_params":"Неверный набор параметров","train.order.error_in_generation":"Ошибка при обработке шаблона","train.order.plazcard_only_message":"Только для плацкарта","train.order.laundry_message":"Билет с постельным бельем нельзя заказать в сидячие и общие вагоны.\n\t\t\t\t\t\t\t\t\t\t\tДля вагонов класса люкс (мягкий) или купе стоимость белья уже включена в билет","train.order.invalid_seats":"В данный момент места для инвалидов заказать нельзя","train.order.no_seats_map":"Выбор на схеме недоступен","train.order.car_toggle_number":"Вагон: ","train.order.any_acmd":"Любое","train.order.sex_coupe_type":"Тип купе","train.order.choose_coupe_type":"Укажите нужный тип купе","train.order.solid_change":"Т.к. в это купе еще не продано ни одного билета, вам нужно определить тип купе самостоятельно:","train.order.solid_details":'<a style="text-decoration:underline" href="%url%" target="_blank">Подробнее</a>',"train.order.solid_unknown":"Укажите нужный тип купе","train.order.solid_must_select":"Если вы хотите ехать именно в этом вагоне, вам нужно обязательно выбрать место в купе — мужском/женском или смешанном.","train.order.hidden_toggler_title":"Купе","train.order.different_sex_category":"Тип купе (мужское/женское/смешанное) может быть выбран только в соответствующем отмеченном вагоне.<br/>Пожалуйста, отметьте соответствующий вагон или не отмечайте тип купе.","train.order.route":"Маршрут","train.order.departure":"Отправление","train.order.departure_departure":"отправление","train.order.arrival":"Прибытие","train.order.travelTime":"время в пути","train.order.train":"Поезд","train.order.step1_title":"Выбор вагона и мест","train.order.step1_title2":"Выберите вагон и места на схеме","train.order.step1_closest_dates":"Ближайшие даты<br/>отправления","train.order.step1_show_schedule_form":"Выбрать другой поезд или маршрут","train.order.passengers":"Пассажиров","train.order.ticket_number_alert":'Заказ на <span id="pnumber"></span>&nbsp;пассажиров доступен только <b>при покупке <a href="%ticket_url%" target="_blank">билетов на бланке РЖД</a></b>.',"train.order.tip_more":"Подробно","train.order.tip_less":"Кратко","train.order.error_popup_title":"Вы ошиблись при заполнении данных пассажиров","train.order.ticket_tip_moreinfo":"В одном заказе электронных билетов не может быть больше 4 пассажиров, включая взрослых и детей.","train.order.ticket_number_alert_nojs":"В одном заказе может быть оформлено не более 4 электронных билетов или 9 билетов на бланке","train.order.car_type":"Тип вагона","train.order.ticket_price":"Стоимость<br />билета,&nbsp;р.","train.order.ticket_price_discount":"Стоимость<br /> верхних мест<br />с&nbsp;учетом&nbsp;скидки,&nbsp;р.","train.order.seats":"Мест","train.order.seats_all":"всего","train.order.seats_top":"верх","train.order.seats_bottom":"низ","train.order.car":"Вагон","train.order.car_car":"вагон","train.order.car_car_important":"Вагон:","train.order.seats_left_label":"Места","train.order.show_schema":"Выбрать вагон и места на схеме","train.order.hide_schema":"Убрать схему","train.order.msk_time":' по <a class="msk" href="javascript:void(0);">Московскому</a> времени',"train.order.ticket_form1":"билет","train.order.ticket_form2":"билета","train.order.ticket_form3":"билетов","train.order.child_ticket_only":"Только для детского билета","train.order.and":"и","train.order.or":"или","train.order.in":"в","train.order.date_with_time":"<b>%date%</b> в <b>%time%</b>","train.order.accommodation_one":"одно","train.order.accommodation_plazsection":"в одном отсеке плацкарта","train.order.accommodation_plazcoupe":"не боковые","train.order.accommodation_coupe":"в одном купе","train.order.accommodation_not_near_wc":"не у туалета","train.order.accommodation_any":"любое расположение","train.order.accommodation_with_laundry":"с бельем","train.order.accommodation_plus_laundry":"+ постельное белье","train.order.accommodation_no_laundry":"без постельного белья","train.order.accommodation_near_wc":"места у туалета","train.order.always_with_laundry":"(включено в цену билета)","train.order.top_links_faq":"Справочная","train.order.top_links_instruction":"Инструкция по приобретению билетов","train.order.top_links_payways":"Способы оплаты","train.order.top_links_rules":"Правила работы сервиса","train.order.top_links_sng_documents":"Какие документы нужны для поездок в СНГ","train.order.top_block_car":"Вагон:","train.order.car_number":"Номер вагона","train.order.accomodation":"Расположение","train.order.car_with_number":"%number% вагон","train.order.with_laundry":"C бельем","train.order.yes":"Да","train.order.no":"Нет","train.order.seat_types":"Тип мест","train.order.seat_accomodation":"Размещение","train.order.preffered_seats":"Предпочитаемые места","train.order.from":"С","train.order.to":"по","train.order.doc_type_inner":"Паспорт РФ","train.order.doc_type_birth":"Свидетельство о рождении","train.order.doc_type_foreign":"Иностранный документ","train.order.doc_type_outer":"Заграничный паспорт РФ","train.order.doc_type_military":"Военный билет","train.order.doc_type_sailor":"Паспорт моряка","train.order.ticket_type_full":"Взрослый","train.order.ticket_type_child":"Детский","train.order.ticket_type_baby":"Детский для ребенка до 5 лет","train.order.ticket_type_benefit":"Льготный","train.order.ticket_child_reduction":"Детский льготный тариф. Скидка будет учтена при оплате. Если ребенку исполнится 10&nbsp;лет на&nbsp;момент отправления поезда, необходимо покупать билет для взрослых.","train.order.step2_title":"Заполните данные пассажиров","train.order.fio":"ФИО","train.order.fio_fi":"Фамилия, имя","train.order.doc":"Документ","train.order.citizen":"Гражданство","train.order.sex":"Пол","train.order.birthdate":"Дата рождения","train.order.ticket_title":"<b>Билет %number%</b>","train.order.example_fname":"Имя","train.order.example_fname_eng":"Name","train.order.example_mname":"Отчество","train.order.example_lname":"Фамилия","train.order.example_lname_eng":"Lastname","train.order.advice_text":"Введите корректное значение номера документа по примеру: <span>%example%</span>","train.order.sex_male_error":"В этом купе могут ехать только мужчины. Выберите, пожалуйста, женское или смешанное купе.","train.order.sex_female_error":"В этом купе могут ехать только женщины. Выберите, пожалуйста, мужское или смешанное купе.","train.order.sex_warning_male1":"Внимание! Выбрано место в купе для мужчин","train.order.sex_warning_male2":"Внимание! Выбраны места в купе для мужчин","train.order.sex_warning_female1":"Внимание! Выбрано место в купе для женщин","train.order.sex_warning_female2":"Внимание! Выбраны места в купе для женщин","train.order.sex_warning_mixed1":"Внимание! Выбрано место в смешанном купе","train.order.sex_warning_mixed2":"Внимание! Выбраны места в смешанном купе","train.order.fio_eng_info":"Как в&nbsp;загранпаспорте","train.order.need_foreign_docs":"Проезд %countryName% по&nbsp;внутрироссийскому документу невозможен.","train.order.need_visa":"Также нужна виза.","train.order.embassy_contacts":'<a href="%url%#contact" target="_blank">Телефон и адрес посольства</a>',"train.order.sng_entry_docs":'<a href="%url%" target="_blank">Список документов для&nbsp;въезда в&nbsp;страны СНГ</a>',"train.order.baby_ticket_title":"<b>Билет для ребенка до&nbsp;5&nbsp;лет (без места)</b>","train.order.baby_switcher_on":"Я еду с ребенком до 5 лет","train.order.baby_switcher_off":"Я еду без ребенка до 5 лет","train.order.baby_number":"Детей","train.order.baby_ticket_description":"Билет «без места»,<br/>ребенок едет на одной полке с вами","train.order.baby_paysumm":"~%price% р. <small>(в зависимости от способа оплаты)</small>","train.order.baby_restriction":'К сожалению, в&nbsp;связи с&nbsp;особенностью системы бронирования, на&nbsp;поезда из&nbsp;Украины невозможно оформить билет без&nbsp;места для&nbsp;детей&nbsp;до&nbsp;5&nbsp;лет.\n\t\t\t\t\t\t\t\t\t\t\t<br /><br />Вы&nbsp;можете оформить только обычный детский билет.\n\t\t\t\t\t\t\t\t\t\t\tДля&nbsp;этого нужно вернуться <a href="%url%">на&nbsp;предыдущий шаг</a> и&nbsp;добавить еще&nbsp;одного пассажира в&nbsp;заказ.',"train.order.step3_title":"Выберите тип билета и способ оплаты","train.order.step3_new_title":"Уточните, как вы будете платить и кому выслать электронный билет","train.order.step3_blank_only_title":"Выберите способ оплаты","train.order.step3_contacts_title":"Выберите способ оплаты","train.order.eticket_ticket_title":"Электронный билет","train.order.eticket_ticket_description":"Выдается на вокзалах в кассах РЖД в любом городе РФ.","train.order.paywayList":"Оплачивается:","train.order.blank_ticket_title":"Билет на бланке РЖД","train.order.blank_ticket_location":"Вы заказываете и получаете билеты в ","train.order.blank_ticket_description":'Оформление и продажа осуществляется <span style="color:#c00;">только в Москве и Санкт-Петербурге</span>. Оплачивается:',"train.order.blank_ticket_description_spb":'Оформление билетов <span style="color:#c00;">в Санкт-Петербурге</span>',"train.order.blank_comment":"Доставка курьером по Москве и Санкт-Петербургу на дом и в офис, либо самовывоз из офиса Туту.ру.","train.order.blank_comment_spb":"Доставка курьером по Санкт-Петербургу на дом и в офис, либо самовывоз из офиса Туту.ру.","train.order.payway_summ":"Итого:","train.order.pay_word":"Оплата","train.order.ticket_how2pay":"как оплатить?","train.order.blank_ticket_location_moscow":'Вы заказываете и получаете билеты в <span style="color:#c00;">Москве</span>',"train.order.blank_ticket_location_spb":'Вы заказываете и получаете билеты в <span style="color:#c00;">Санкт-Петербурге</span>',"train.order.city_moscow":"Москва","train.order.city_spb":"Санкт-Петербург","train.order.blank_moscow_warning":'В связи с изменением условий заказа оплатить билет необходимо <nobr><span style="color:#c00;">до 9 октября включительно.</span></nobr>',"train.order.seats_ukrain_warning":"К сожалению, для поездов из Украины функция выбора мест на схеме поезда недоступна.","train.order.ticket_genetive_form1":"билета","train.order.ticket_genetive_form2":"билетов","train.order.ticket_genetive_form3":"билетов","train.order.price_currency":"%number% руб.","train.order.kopeks":"коп.","train.order.rubles":"руб.","train.order.number":"№","train.order.step4_title":"Оставьте контактную информацию","train.order.form_surname":"Фамилия","train.order.form_name":"Имя","train.order.form_email":"Электронная почта","train.order.form_mobile":"Мобильный телефон","train.order.form_calltime":"Удобное время звонка","train.order.step4_confirm_title":"Подтвердите заказ","train.order.step4_confirm_title_new":"Проверьте данные и подтвердите заказ","train.order.order_info_head":"Информация о заказе","train.order.form_train":"Поезд","train.order.form_ticket":"Билет","train.order.form_pay":"Оплата","train.order.form_city":"Город покупки билета","train.order.form_delivery_address":"Адрес доставки","train.order.form_address_metro":"Станция метро","train.order.form_address_street":"Улица","train.order.form_address_home":"Дом","train.order.form_address_block":"Блок","train.order.form_address_app":"Квартира","train.order.form_address_office":"Офис","train.order.form_comment":"Комментарий к заказу","train.order.form_seat":"Место","train.order.form_seats":"Места","train.order.form_passenger":"Пассажир","train.order.form_passengers":"Пассажиры","train.order.summ_label":"Сумма к оплате","train.order.summ_label_total":"Итого к оплате","train.order.summ_price_seat_top":"Верх","train.order.summ_price_seat_bottom":"Низ","train.order.summ_price_seat_side":"Бок","train.order.summ_price":"Цена","train.order.summ_price_up":"увеличилась на","train.order.summ_price_less":"уменьшилась на","train.order.summ_price_changed":"изменилась на","train.order.summ_price_diff_cause":"при контрольном пересчете в&nbsp;момент резервирования","train.order.service_conditions":"Условия использования сервиса Туту.ру","train.order.service_conditions_ufs":"Условия использования веб-системы Туту.ру","train.order.conditions_confirm":'Я соглашаюсь с условиями использования сервиса Туту.ру,\n\t\t\t\t\t\t\t\t\t\t\t<br /><span style="font-size: 12px; margin-left: 2em; line-height: 18px;">\n\t\t\t\t\t\t\t\t\t\t\tо сервисном сборе в размере %serviceFee% предупрежден и согласен с ним.</span>',"train.order.field_error":"Ошибка в поле ","train.order.fields_error":"Ошибки в полях: ","train.order.booked_place":", %place% место","train.order.booked_place_numbers":"%place%,","train.order.redirect":"Переход к процессингу заказа","train.order.temporary_disabled":"Временно недоступно, попробуйте через час","train.order.temporary_disabled_text":"Оплата данным способом временно недоступна. Пожалуйста, попробуйте оплатить через час, либо воспользуйтесь другим способом оплаты.","train.order.temporary_disabled_short":"Временно недоступно","train.order.train_is_sent":"В эту дату выбранный поезд не отправляется","train.order.success_title":"Ваш заказ успешно завершен","train.order.success_text":"Ваш заказ успешно завершен, на ваш адрес отправлено письмо","train.order.cancel_title":"Заказ отменен","train.order.cancel_text":'Повторное резервирование с теми же параметрами невозможно в течение 60 минут (с момента первого заказа), либо до осуществления возврата на этот заказ<br/>\n\t\t\t\t\t\t\t\t\t\t\tЕсли оплатить сделанный ранее заказ не представляется возможным, то можно попробовать оформить <a href="%orderUrl%">новую заявку в другой вагон</a>.',"train.order.step1_meta_title":"Tutu.ru - Выбор мест","train.order.step1_meta_keywords":"Заказ жд билетов (электронные и на бланке РЖД). Шаг 2: выбор мест","train.order.step1_meta_description":"Заказ жд билетов (электронные и на бланке РЖД). Шаг 2: выбор мест","train.order.step1_tooltip_childs_link":"Как купить билет ребенку","train.order.step1_tooltip_childs_old":'<p>Если ребенок поедет на одной полке с вами, не нужно указывать его в числе пассажиров на этой странице.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Достаточно указать данные ребенка на следующем шаге, при вводе данных пассажиров.</p>\n\t\t\t\t\t\t\t\t\t\t\t<b><a href="%url%" target="_blank">Ознакомиться с инструкцией</a></b>',"train.order.step1_tooltip_childs":'<p>\n\t\t\t\t\t\t\t\t\t\t\t\tВозраст ребенка определяется на день отправления поезда\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t<strong>Ребенок младше 5&nbsp;лет</strong></p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tЕсли ребенок поедет на&nbsp;одном месте с&nbsp;вами, не&nbsp;указывайте его в&nbsp;числе пассажиров на&nbsp;этой странице. Сделайте это на&nbsp;следующем шаге.\n\t\t\t\t\t\t\t\t\t\t\t\tЧтобы купить отдельное место по&nbsp;цене детского билета, укажите здесь количество мест с учетом ребенка. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t<strong>Ребенок от&nbsp;5 до&nbsp;10 лет</strong>\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tУкажите здесь количество мест с&nbsp;учетом места для&nbsp;ребенка. Стоимость детского билета составляет в&nbsp;среднем 35%&nbsp;&mdash;&nbsp;50% от&nbsp;стоимости полного билета. Точная стоимость зависит от&nbsp;типа вагона (с&nbsp;услугами или&nbsp;без и&nbsp;т.п.)\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t<strong>Ребенку уже исполнилось 10&nbsp;лет</strong>\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tВ&nbsp;этом случае нужно покупать обычный &laquo;взрослый&raquo; билет.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t<b><a href="%url%" target="_blank">Подробнее о&nbsp;покупке детских билетов</a></b>\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.order.step2_meta_title":"Tutu.ru - Данные пассажиров","train.order.step2_meta_keywords":"Шаг 3: данные пассажиров","train.order.step2_meta_description":"Шаг 3: данные пассажиров","train.order.step3_meta_title":"Tutu.ru - Способ оплаты","train.order.step3_meta_keywords":"Шаг 4: способ оплаты","train.order.step3_meta_description":"Шаг 4: способ оплаты","train.order.blank_fields_notice":"Только для билета на бланке РЖД","train.order.courier_fields_notice":"Только для билета на бланке РЖД с оплатой курьеру","train.order.full_price":"Полная стоимость","train.order.full_payway_price":"Полная стоимость c комиссией платежной системы","train.order.original_price":"Стоимость билета","train.order.fee":"Сервисный сбор","train.order.blank_office_common":"Офис находится в районе&nbsp;","train.order.blank_office_moscow":'<a href="%url%" target="_blank">метро Бауманская</a>',"train.order.blank_office_spb":'<a href="%url%" target="_blank">метро Василеостровская</a>',"train.order.blank_office_moscow_VipService":'<a href="%url%" target="_blank">метро Бауманская</a>',"train.order.blank_office_spb_VipService":'<a href="%url%" target="_blank">метро Василеостровская</a>',"train.order.blank_office_spb_Davs":'<a href="%url%" target="_blank">метро Василеостровская</a>',"train.order.blank_office_spb_nocourier":'Билет можно оформить только в офисе (<a href="%url%" target="_blank">метро Василеостровская</a>). Присутствие клиента обязательно.',"train.order.blank_office_spb_nocourier_VipService":'Билет можно оформить только в офисе (<a href="%url%" target="_blank">метро Василеостровская</a>). Присутствие клиента обязательно.',"train.order.blank_office_spb_nocourier_Davs":'Билет можно оформить только в офисе (<a href="%url%" target="_blank">метро Василеостровская</a>). Присутствие клиента обязательно.',"train.order.address_phone_error":'Номер необходимо писать в международном формате без "+" в начале. Например, 7 916 0000000. Указывайте верный номер телефона!',"train.order.eticket_get_rules_title":"Билеты можно получить только в России","train.order.eticket_get_rules_no_ereg":"<p>По правилам РЖД, получение электронных билетов возможно в любой кассе на вокзале, <b>но только на территории России.</b></p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Электронная регистрация на&nbsp;данный поезд невозможна.</p>","train.order.eticket_get_rules_with_ereg":"<p>По правилам РЖД, получение электронных билетов возможно в любой кассе на вокзале, <b>но только на территории России.</b></p>\n\t\t\t\t\t\t\t\t\t\t\t<p>На&nbsp;данный поезд возможна электронная регистрация.</p>","train.order.step4_message":"На этой странице, пожалуйста, проверьте информацию о билетах и введенные личные данные. <nobr>Затем подтвердите ваш заказ.</nobr>","train.order.step4_meta_title":"Tutu.ru - Завершение заказа","train.order.step4_meta_keywords":"Шаг 5: завершение заказа","train.order.step4_meta_description":"Шаг 5: завершение заказа","train.order.step4_topphrase":'Электронный билет легче оплатить и получить. Билет на бланке можно получить только в Москве и Санкт-Петербурге.\n\t\t\t\t\t\t\t\t\t\t\t<a href="%url%" target="_blank">Подробнее...</a>',"train.order.step5_meta_title":"Tutu.ru - Переход к процессингу заказа","train.order.step5_meta_keywords":"Переход к процессингу заказа","train.order.step5_meta_description":"Переход к процессингу заказа","train.order.redirect_nojs":"Пожалуйста, нажмите на кнопку для завершения заказа.","train.order.redirect_js":"Происходит резервирование билетов и перенаправление на сервис оплаты.<br/>\n\t\t\t\t\t\t\t\t\t\t\tЭто может занять 1-2 минуты.","train.order.enter_passenger":"Ввести данные пассажиров","train.order.pay_type":"Перейти к выбору способа оплаты","train.order.go_to_finished":"Перейти к завершению","train.order.pay_tickets":"Оплатить билеты","train.order.pay_tickets_new":"Подтвердить заказ, все данные указаны верно","train.order.order_tickets":"Заказать билеты","train.order.taxi_from_railway":"Заказать такси с вокзала","train.order.taxi_to_railway":"Заказать такси на вокзал","train.order.no_price_vipservice_warning":"<b>Точную стоимость билета вам сообщит оператор</b><br/><br/>","train.order.no_price_vipservice":"Неизвестно","train.order.deliveryBlankPriceLabel":"Cтоимость доставки","train.order.trains800_warning":"Данный поезд может обслуживаться составом электропоезда или&nbsp;дизель-поезда с&nbsp;жесткими сиденьями","train.order.checking_wait_text":"Проверяем наличие мест","train.order.checking_wait_text_lp":"Проверяется наличие мест","train.order.no_smoking":"Курить запрещено. Предварительный досмотр.","train.order.whole_coupe_only":"продается только целое&nbsp;купе","train.order.two_seats":"(2 места)","train.order.for_whole_coupe":"за целое купе","train.order.only_whole_coupe":"Только целым купе","train.order.side_places_top":"Из них боковых %count%","train.order.side_places_bottom":"Из них боковых %count%","train.order.car_carrier_name":"Эти вагоны обслуживаются компанией","train.order.sapsan_city_msk":"Москва","train.order.sapsan_city_spb":"Санкт-Петербург","train.order.sapsan_city_nvg":"Нижний Новгород","train.order.reminder_block_reserve_timeout":"Резерв снят.","train.order.reminder_block_try":"Попробуйте еще раз","train.order.reminder_block_or_new":"или сделайте новый заказ.","train.order.reminder_block_rzd_requirements":"По требованиям РЖД резерв действует","train.order.reminder_block_timeout":"еще %minutes% %label%","train.order.reminder_block_minutes":"минуту|минуты|минут","train.order.reminder_block_tooltip":"<p>В&nbsp;течение этого времени никто другой не&nbsp;сможет&nbsp;купить зарезервированные места.</p>\n\t\t\t\t\t<p>Затем резерв автоматически аннулируется.</p>\n\t\t\t\t\t<p>Места станут доступны другим покупателям.</p>\n\t\t\t\t\t<p>Пожалуйста, поторопитесь с&nbsp;проверкой данных и&nbsp;переходом к&nbsp;оплате.</p>","train.order.insurance_1":"Эта информация будет указана в&nbsp;билете для идентификации пассажира","train.order.insurance_2":"Данные будут использованы исключительно для оформления билета","train.order.latin_characters":"латинскими буквами","train.order.no_rus_doc":'<img class="no_rus_doc" src="%url%" />\n\t\t\t\t\t\t\t\t\t\t\t<p class="finl_rext">Проезд в&nbsp;Финляндию по&nbsp;внутрироссийскому паспорту невозможен</p>\n\t\t\t\t\t\t\t\t\t\t\t<p class="finl_rext">Также <i>нужна виза</i>.\n\t\t\t\t\t\t\t\t\t\t\t <br /><a href="%url2%" target="_blank">Телефон и&nbsp;адрес посольства</a></p>',"train.order.translit_sms_notify_noprint_noereg":"Do otpravleniya poezda ostalos %period% chasa. Ne zabudte poluchit' bilet v kasse! Kod zakaza %number%. Poezd %trainNumber%, vagon %carNumber%, mest%seats%, otpravlenie %routeDate% v %routeTime%%station% Schastlivogo puti!","train.order.translit_sms_notify_noprint_noeregstate":"Do otpravleniya poezda ostalos %period% chasa. Ne zabudte poluchit' bilet v kasse ili proidite e-registratsiyu na tutu.ru! Kod zakaza %number%. Poezd %trainNumber%, vagon %carNumber%, mest%seats%, otpravlenie %routeDate% v %routeTime%%station% Schastlivogo puti!","train.order.translit_sms_notify_noprint_eregstate":"Do otpravleniya poezda ostalos %period% chasa. Ne zabudte vzyat udostovereniye lichnosti dlya posadki v poezd! Vash poezd %trainNumber%, vagon %carNumber%, mest%seats%, otpravlenie %routeDate% v %routeTime%%station% Schastlivogo puti!","train.order.translit_sms_notify_print":"Do otpravleniya poezda ostalos %period% chasa. Ne zabudte vash bilet i udostovereniye lichnosti dlya posadki v poezd. Vash poezd %trainNumber%, vagon %carNumber%, mest%seats%, otpravlenie %routeDate% v %routeTime%%station% Schastlivogo puti!","train.order.translit_sms_notify_return":"Ne zabudte poluchit obratnyi bilet na blanke do ot'ezda is Rossii! Za granitsei nelzya budet raspechatat' bilet ili proyti e-registratsiyu. Tel. +7(495)787-01-05.","train.order.translit_sms_notify_foreign":"Dlya posadki v poezd %city% poluchite vash bilet V ROSSII. Za predelami Rossii nelzya raspechatat' bilet ili proyti elektronnuyu registratsiyu. Tel. +7(495)787-01-05.","train.order.translit_sms_notify_foreign_in_city":"v","train.order.translit_sms_notify_foreign_in_station":"na stancii","train.station.station_field_title":"Станция","train.station.title":"Станция <b>%station%</b>","train.station.trainlist_title":"Расписание поездов: <b>%station%</b>","train.station.trainlist_title_sapsan":"Расписание движения поездов Сапсан: <b>%station%</b>","train.station.station_information":"Справочная вокзала: <span>%phone%</span>","train.station.station_information_address":"Адрес вокзала: <span>%address%</span>","train.station.coordinates":"Координаты %latitude% %longitude%","train.station.th_route":"Маршрут","train.station.th_schedule_name":"<span>График</span><br /><span>движения</span>","train.station.th_arrival":"Прибытие","train.station.th_stop_time":"Стоянка","train.station.th_departure":"Отправление","train.station.th_order":"Заказ<br />билетов","train.station.th_stay":"Стоянка","train.station.tab_trainlist_title":"Расписание","train.station.tab_map_title":"На карте","train.station.tab_review_title":"Отзывы пассажиров","train.station.route":"Маршрут","train.station.schedule":"Годовой график","train.station.order":"Купить","train.station.no_train":"Не найдено ни одного поезда до станции %station%","train.station.no_train_sapsan":"Не найдено ни одного поезда «Сапсан» до станции %station%","train.station.nothing_found":"Ничего не найдено","train.station.title_map":"Станция %station% на карте","train.station.region":"Область/Край","train.station.timezone":"Временная зона","train.station.railway":"Железная дорога","train.station.title_map2":"Станция %station% - месторасположение на карте","train.station.neighbour_stations_and_cities":"Вы можете ознакомиться с расписанием поездов ближайших станций и городов.","train.station.neighbour_stations":"Вы можете ознакомиться с расписанием поездов ближайших станций.","train.station.neighbour_cities":"Вы можете ознакомиться с расписанием поездов ближайших городов.","train.station.stations":"Станции","train.station.cities":"Городов","train.station.navy_title2":"Расписание поездов и жд билет из %station2%","train.station.navy_title2_sapsan":"Расписание поездов Сапсан %station%","train.station.navy_title3":"ЖД билеты %station%","train.station.navy_title3_sapsan":"Билеты на поезд Сапсан %station%","train.scheme.06.address":'<b>Адрес:</b> Комсомольская пл., 3 (<a href="%url%">м. «Комсомольская»</a>).',"train.scheme.06.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна северо-запад России, в&nbsp;Эстонию и&nbsp;Финляндию.","train.scheme.06.phones":"<!--<b>Телефон справочной службы:</b> (495)&nbsp;262-91-43 (круглосуточно)<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (495)&nbsp;262-98-76<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Зал официальных делегаций:</b> (495)&nbsp;975-43-15<br />-->","train.scheme.06.railway_name":"Ленинградского вокзала","train.scheme.06.direction_name":"Ленинградское направление","train.scheme.06.from_railway_name":"Расписание поездов с Ленинградского вокзала","train.scheme.06.railway_name3":"Ленинградский","train.scheme.06.railway_name2":"Ленинградского","train.scheme.06.direction_name2":"Ленинградское","train.scheme.06.":"","train.scheme.03.address":'<b>Адрес:</b> Комсомольская пл., 2 (<a href="%url%">м. «Комсомольская»</a>).',"train.scheme.03.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна юг, восток и юго-восток России, на&nbsp;Урал и&nbsp;Алтай, Кубань и&nbsp;Северный Кавказ, в&nbsp;Татарстан, Башкортостан, Чувашию, Мордовию, в&nbsp;Казахстан и&nbsp;Среднюю Азию.","train.scheme.03.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;266-23-00 (многоканальный), (499)&nbsp;264-66-56<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;266-28-48<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол забытых вещей:</b> (499)&nbsp;266-35-94<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;266-21-09, (499)&nbsp;266-21-84<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажная касса:</b> (499)&nbsp;266-21-49<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Камера хранения:</b> (499)&nbsp;266-25-20, (499)&nbsp;266-35-94<br />-->","train.scheme.03.railway_name":"Казанского вокзала","train.scheme.03.direction_name":"Казанское направление","train.scheme.03.from_railway_name":"Расписание поездов с Казанского вокзала","train.scheme.03.railway_name3":"Казанский","train.scheme.03.railway_name2":"Казанского","train.scheme.03.direction_name2":"Казанское","train.scheme.03.":"","train.scheme.21.address":'<b>Адрес:</b> наб. Обводного канала, 120 (<a href="%url%">м. «Балтийская«</a>).',"train.scheme.21.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tВ пригородном сообщении с Балтийского вокзала пассажиры отправляются в&nbsp;населенные пункты Гатчина, Петергоф, Кингисепп, Лебяжье, Калище&nbsp;и&nbsp;др.","train.scheme.21.phones":"<!--<b>Телефон справочной службы:</b> (812)&nbsp;457-28-59,-->","train.scheme.21.railway_name":"Балтийского вокзала","train.scheme.21.direction_name":"Балтийское направление","train.scheme.21.from_railway_name":"Расписание поездов с Балтийского вокзала","train.scheme.21.railway_name3":"Балтийский","train.scheme.21.railway_name2":"Балтийского","train.scheme.21.direction_name2":"Балтийское","train.scheme.21.":"","train.scheme.23.address":"<b>Адрес:</b> Заневский проспект, 73.","train.scheme.23.where":"","train.scheme.23.phones":"<!--<b>Телефон справочной службы:</b> (812)&nbsp;436-53-10<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по  вокзалу:</b> (812)&nbsp;436-53-04<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Справочное бюро вокзала:</b> (812)&nbsp;436-53-10<br />-->","train.scheme.23.railway_name":"Ладожского вокзала","train.scheme.23.direction_name":"Ладожское направление","train.scheme.23.from_railway_name":"Расписание поездов с Ладожского вокзала","train.scheme.23.railway_name3":"Ладожский","train.scheme.23.railway_name2":"Ладожского","train.scheme.23.direction_name2":"Ладожское","train.scheme.23.":"","train.scheme.10.address":'<b>Адрес:</b> Комсомольская пл., 5 (<a href="%url%">м. «Комсомольская»</a>).',"train.scheme.10.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна север и северо-восток России, в&nbsp;Сибирь и&nbsp;на&nbsp;Дальний Восток, в&nbsp;Китай и&nbsp;Монголию.","train.scheme.10.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;266-63-00 (круглосуточно), (495)&nbsp;621-08-17, (495)&nbsp;621-59-14<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;266-93-20<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;266-61-23, (499)&nbsp; 266-61-77<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол находок:</b> (499)&nbsp;266-83-10<br />-->","train.scheme.10.railway_name":"Ярославского вокзала","train.scheme.10.direction_name":"Ярославское направление","train.scheme.10.from_railway_name":"Расписание поездов с Ярославского вокзала","train.scheme.10.railway_name3":"Ярославский","train.scheme.10.railway_name2":"Ярославского","train.scheme.10.direction_name2":"Ярославское","train.scheme.10.":"","train.scheme.25.address":"<b>Адрес:</b> Площадь Ленина, 6.","train.scheme.25.where":"","train.scheme.25.phones":"<!--<b>Телефон справочной службы:</b> (812)&nbsp;436-67-46<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по  вокзалу:</b> (812)&nbsp;768-76-87<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Линейный отдел милиции:</b> (812)&nbsp;768-74-32<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Справочная служба:</b> (812)&nbsp;768-79-00<br />-->","train.scheme.25.railway_name":"Финляндского вокзала","train.scheme.25.direction_name":"Финляндское направление","train.scheme.25.from_railway_name":"Расписание поездов с Финляндского вокзала","train.scheme.25.railway_name3":"Финляндский","train.scheme.25.railway_name2":"Финляндского","train.scheme.25.direction_name2":"Финляндское","train.scheme.25.":"","train.scheme.24.address":"<b>Адрес:</b> Невский проспект, 85.","train.scheme.24.where":"","train.scheme.24.phones":"<!--<b>Телефон справочной службы:</b> (812)&nbsp;457-44-28<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по  вокзалу:</b> (812)&nbsp;768-88-13<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Пункт милиции на вокзале:</b> (812) 768-44-30, (812) 768-44-17<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное  отделение на  вокзале:</b> (812) 768-54-22<br />-->","train.scheme.24.railway_name":"Московского вокзала","train.scheme.24.direction_name":"Московское направление","train.scheme.24.from_railway_name":"Расписание поездов с Московского вокзала","train.scheme.24.railway_name3":"Московский","train.scheme.24.railway_name2":"Московского","train.scheme.24.direction_name2":"Московское","train.scheme.24.":"","train.scheme.04.address":'<b>Адрес:</b> пл. Киевского Вокзала, 2 (<a href="%url%">м. «Киевская»</a>).',"train.scheme.04.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна  запад и&nbsp;юго-запад России, на&nbsp;Украину и&nbsp;в&nbsp;Молдавию, в&nbsp;Болгарию и&nbsp;Грецию.","train.scheme.04.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;240-70-71 (круглосуточно), (499)&nbsp;240-04-15, (499)&nbsp;240-11-15<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;240-73-39<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;240-75-42<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Камера хранения:</b> (499)&nbsp;240-79-85<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол находок:</b> (499)&nbsp;240-79-85<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Зал официальных делегаций:</b> (499)&nbsp;240-70-01<br />-->","train.scheme.04.railway_name":"Киевского вокзала","train.scheme.04.direction_name":"Киевское направление","train.scheme.04.from_railway_name":"Расписание поездов с Киевского вокзала","train.scheme.04.railway_name3":"Киевский","train.scheme.04.railway_name2":"Киевского","train.scheme.04.direction_name2":"Киевское","train.scheme.04.":"","train.scheme.common.directoryTitle":"<b>Справочная информация %station%</b>","train.scheme.common.schemeTitle":"Расписание поездов %station%","train.scheme.01.address":'<b>Адрес:</b> пл. Тверская Застава, 7 (<a href="%url%">м. «Белорусская»</a>).',"train.scheme.01.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна запад и юго-запад России, в&nbsp;Белоруссию, Германию, Польшу, Литву, Чехию, Словакию, Австрию, Венгрию.","train.scheme.01.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;266-03-00 (круглосуточно), (495)&nbsp;251-60-93, (499)&nbsp;973-81-91<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;973-85-57<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;973-84-94<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажная касса:</b> (499)&nbsp;973-89-36<br />-->","train.scheme.01.railway_name":"Белорусского вокзала","train.scheme.01.direction_name":"Белорусское направление","train.scheme.01.from_railway_name":"Расписание поездов с Белорусского вокзала","train.scheme.01.railway_name3":"Белорусский","train.scheme.01.railway_name2":"Белорусского","train.scheme.01.direction_name2":"Белорусское","train.scheme.01.":"","train.scheme.22.address":"<b>Адрес:</b> Загородный пр., 52.","train.scheme.22.where":"","train.scheme.22.phones":"<!--<b>Телефон справочной службы:</b> (812)&nbsp;457-59-39<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по  вокзалу:</b> (812)&nbsp;768-59-39<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Пункт милиции на вокзале:</b> (812)&nbsp;768-53-42<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное  отделение  на вокзале:</b> (812)&nbsp;768-57-93<br />-->","train.scheme.22.railway_name":"Витебского вокзала","train.scheme.22.direction_name":"Витебское направление","train.scheme.22.from_railway_name":"Расписание поездов с Витебского вокзала","train.scheme.22.railway_name3":"Витебский","train.scheme.22.railway_name2":"Витебского","train.scheme.22.direction_name2":"Витебское","train.scheme.22.":"","train.scheme.07.address":'<b>Адрес:</b> Павелецкая пл., 1 (<a href="%url%">м. «Павелецкая»</a>).',"train.scheme.07.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tв центральную и южную части России, в&nbsp;Казахстан и&nbsp;Поволжье, на&nbsp;Северный Кавказ и&nbsp;в&nbsp;Азербайджан.","train.scheme.07.phones":"<!--<b>Телефон справочной службы:</b> (495)&nbsp;950-37-00 (круглосуточно)<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (495)&nbsp;235-12-14<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол находок:</b> (495)&nbsp;235-69-19<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (495)&nbsp;235-91-05<br />-->","train.scheme.07.railway_name":"Павелецкого вокзала","train.scheme.07.direction_name":"Павелецкое направление","train.scheme.07.from_railway_name":"Расписание поездов с Павелецкого вокзала","train.scheme.07.railway_name3":"Павелецкий","train.scheme.07.railway_name2":"Павелецкого","train.scheme.07.direction_name2":"Павелецкое","train.scheme.07.":"","train.scheme.08.address":'<b>Адрес:</b> пл. Рижского Вокзала, 2 (<a href="%url%">м. «Рижская»</a>).',"train.scheme.08.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tна запад России и&nbsp;в&nbsp;Латвию.","train.scheme.08.phones":"<!--<b>Телефоны справочной службы:</b> (495)&nbsp;631-15-88, (499)&nbsp;266-85-12 (круглосуточно), (499)&nbsp;266-85-00<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;266-81-72<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;266-81-30<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Контейнерные перевозки:</b> (495)&nbsp;631-06-51 (по рабочим), (499)&nbsp;266-85-88 (по выходным)<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Камера хранения:</b> (499)&nbsp;266-62-30<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол находок:</b> (499)&nbsp;266-62-30<br />-->","train.scheme.08.railway_name":"Рижского вокзала","train.scheme.08.direction_name":"Рижское направление","train.scheme.08.from_railway_name":"Расписание поездов с Рижского вокзала","train.scheme.08.railway_name3":"Рижский","train.scheme.08.railway_name2":"Рижского","train.scheme.08.direction_name2":"Рижское","train.scheme.08.":"","train.scheme.09.address":'<b>Адрес:</b> пл. Савеловского Вокзала, 2 (<a href="%url%">м. «Савеловская»</a>).',"train.scheme.09.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tСейчас с вокзала отправляются только пригородные электропоезда до&nbsp;Лобни, Дмитрова, Дубны, Савелово, а&nbsp;также&nbsp;аэроэкспрессы до&nbsp;аэропорта Шереметьево.","train.scheme.09.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;973-84-82, (499)&nbsp;266-89-61<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (495)&nbsp;685-90-00<br />-->","train.scheme.09.railway_name":"Савеловского вокзала","train.scheme.09.direction_name":"Савеловское направление","train.scheme.09.from_railway_name":"Расписание поездов с Савеловского вокзала","train.scheme.09.railway_name3":"Савеловский","train.scheme.09.railway_name2":"Савеловского","train.scheme.09.direction_name2":"Савеловское","train.scheme.09.":"","train.scheme.05.address":'<b>Адрес:</b> ул. Земляной Вал, 29 (<a href="%url%">м. «Курская»</a>).',"train.scheme.05.where":"<b>Куда можно уехать поездами дальнего следования:</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tв центральную и&nbsp;южную часть России, юго-восточную часть Украины, в&nbsp;Крым и&nbsp;на&nbsp;Кавказ.","train.scheme.05.phones":"<!--<b>Телефоны справочной службы:</b> (499)&nbsp;266-53-10 (круглосуточно), (495)&nbsp;917-31-52, (495)&nbsp;916-20-03<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Дежурный по вокзалу:</b> (499)&nbsp;266-53-45<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Стол забытых вещей:</b> (499)&nbsp;266-54-70<br /><br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Багажное отделение:</b> (499)&nbsp;266-52-43, (499)&nbsp;266-57-79, (499)&nbsp;266-44-09<br /><br />-->","train.scheme.05.railway_name":"Курского вокзала","train.scheme.05.direction_name":"Курское направление","train.scheme.05.from_railway_name":"Расписание поездов с Курского вокзала","train.scheme.05.railway_name3":"Курский","train.scheme.05.railway_name2":"Курского","train.scheme.05.direction_name2":"Курское","train.scheme.05.":"","train.wizard_errors.1-noOrder":"Произошла внутренняя ошибка","train.wizard_errors.1-noTickets":"Не удалось подтвердить наличие мест. Попробуйте повторить запрос позднее или выберите другой поезд.","train.wizard_errors.1-notCheckSeats":"Не удалось подтвердить наличие мест. Попробуйте выбрать другой поезд или повторить запрос позднее.","train.wizard_errors.1-noValidTickets":"В выбранном поезде остались только места для инвалилидов. Такие билеты можно купить только в специальных кассах ж/д вокзалов","train.wizard_errors.1-notAllSeats":"Вам необходимо либо выбрать все места на схеме вагона, либо не указывать на схеме вагона ни одного места","train.wizard_errors.1-wrongAcmd":"Выбранное размещение не соответствует выбранному вагону","train.wizard_errors.1-cantOrderLaundry":"У выбранного типа вагона нельзя заказать билет с постельным бельем","train.wizard_errors.1-cantOrderWithoutLaundry":"У выбранного типа вагона нельзя заказать билет без постельного белья","train.wizard_errors.1-noSeatsWithSelectedFilters":"По указанным вами требованиям мест нет. Попробуйте смягчить условия поиска —\n\t\t\t\t\t\t\t\t\t\tуказать другую комбинацию верхних и нижних мест, убрать галочку «в одном купе» или «не у туалета».\n\t\t\t\t\t\t\t\t\t\tТакже вы можете выбрать места на схеме вагона.","train.wizard_errors.1-noSeatsWithSelectedFiltersNoJS":"По указанным вами требованиям мест нет. Попробуйте смягчить условия поиска.","train.wizard_errors.1-noSeatsWithReason":"По указанным вами требованиям мест нет — в этом вагоне остались только ","train.wizard_errors.1-seatsWereTaken":"К сожалению, свободные места удовлетворяющие вашему выбору, закончились","train.wizard_errors.1-plazsectionAndWcFilter":"Нельзя выбрать места в одной секции плацкарта с включенным фильтром «не у туалета»","train.wizard_errors.1-tooMuchSeatsInPlazsection":"В одной секции плацкарта не может быть больше 6 мест","train.wizard_errors.1-tooMuchSeatsInCoupe":"В купе нельзя выбрать больше 4 мест","train.wizard_errors.1-notEnoughSeatsInCoupe":'Для одного пассажира нельзя выбирать расположение "в одном купе"',"train.wizard_errors.1-tooMuchSeatsInLuxCoupe":"В купе мягкого вагона всего 2 места","train.wizard_errors.1-tooMuchBottomSeats":"В выбранном вагоне нельзя заказать %acmd% в одном заказе. Попробуйте сделать несколько отдельных заказов.","train.wizard_errors.1-noJsSeatsWithSelectedData":'По указанным вами требованиям мест нет. Попробуйте смягчить условия поиска —\n\t\t\t\t\t\t\t\t\t\tуказать другую комбинацию верхних и нижних мест, выбрать другой вагон или <a href="%url%">другую категорию</a>.',"train.wizard_errors.2-notBirth":"Пожалуйста, проверьте год рождения ребенка","train.wizard_errors.2-notChild":'Вы указали, что %fio% (билет №%ticket%) старше 9 лет.\n\t\t\t\t\t\t\t\t\t\tПо правилам РЖД детский билет можно купить только для ребенка 9 лет или младше.\n\t\t\t\t\t\t\t\t\t\tВозраст ребенка определяется на момент отправления поезда.\n\t\t\t\t\t\t\t\t\t\tВыберите для этого пассажира тип билета "взрослый".',"train.wizard_errors.2-notBaby":"Вы указали, что %fio% (детский билет №%ticket%) старше 5 лет.\n\t\t\t\t\t\t\t\t\t\tПо правилам РЖД бесплатный детский билет можно заказать только для ребенка 5 лет или младше.\n\t\t\t\t\t\t\t\t\t\tВозраст ребенка определяется на момент отправления поезда.","train.wizard_errors.2-notChildShort":"Возраст ребенка определяется на момент отравления поезда. %routeDate% ребенку все еще должно быть меньше 9 лет.","train.wizard_errors.2-notBabyShort":"Возраст ребенка определяется на момент отравления поезда. %routeDate% ребенку все еще должно быть меньше 5 лет.","train.wizard_errors.2-emptyField":"Поля фамилии, имени и отчества (билет №%ticket%) обязательны для заполнения","train.wizard_errors.2-birthDate":"Дата рождения для детского билета (билет №%ticket%) обязательна и должна быть в формате ДД.ММ.ГГГГ","train.wizard_errors.2-fullBirthDate":"Дата рождения в билете №%ticket% обязательна и должна быть в формате ДД.ММ.ГГГГ","train.wizard_errors.2-sex":"Пол пассажира в билете №%ticket% обязателен","train.wizard_errors.2-citizenship":"Гражданство пассажира в билете №%ticket% обязателен","train.wizard_errors.2-cyrilicOnly":"В билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы русского алфавита.","train.wizard_errors.2-badSymbol":"В билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы русского или английского алфавитов.","train.wizard_errors.2-badForeignSymbol":"В билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы английского алфавитов.","train.wizard_errors.2-onlyDigits":"В билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы русского или английского алфавитов.","train.wizard_errors.2-baby-emptyField":"Поля фамилии, имени и отчества (детский билет  №%ticket%) обязательны для заполнения","train.wizard_errors.2-baby-cyrilicOnly":"Пожалуйста, укажите ФИО пассажира (детский билет  №%ticket%) кириллицей","train.wizard_errors.2-baby-badSymbol":"В детском билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы русского или английского алфавитов.","train.wizard_errors.2-baby-badForeignSymbol":"В детском билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы английского алфавитов.","train.wizard_errors.2-baby-onlyDigits":"В детском билете №%ticket% для указания ФИО, пожалуйста, используйте только буквы русского или английского алфавитов.","train.wizard_errors.2-baby-birthDate":"Дата рождения для бесплатного билета ребенка до 5 лет(детский билет №%ticket%) обязательна и должна быть в формате ДД.ММ.ГГГГ","train.wizard_errors.errorDocNum":"Вы ошиблись при вводе номера документа (билет №%ticket%). ","train.wizard_errors.2-baby-errorDocNum":"Вы ошиблись при вводе номера документа (детский билет №%ticket%). ","train.wizard_errors.errorDocType":"Для покупки детского билета необходим один из документов ребенка: свидетельство о рождении, загранпаспорт, иностранный документ.\n\t\t\t\t\t\t\t\t\t\tПожалуйста, введите данные подходящего документа или выберите билет для взрослых. (билет №%ticket%). ","train.wizard_errors.2-baby-errorDocType":"Для покупки детского билета необходим один из документов ребенка: свидетельство о рождении, загранпаспорт, иностранный документ.\n\t\t\t\t\t\t\t\t\t\tПожалуйста, введите данные подходящего документа. (детский билет №%ticket%). ","train.wizard_errors.2-too-much-babies-1":"По правилам РЖД, с одним взрослым может ехать только один ребенок до 5 лет.","train.wizard_errors.2-too-much-babies-2":"По правилам РЖД, с %adultNumber% взрослыми может ехать не более %babyNumber% детей до 5 лет.","train.wizard_errors.processingError":"К сожалению, нашей системе не удалось оформить заказ. Пожалуйста, повторите запрос еще раз. Если ошибка не исчезает, пожалуйста, сообщите администраторам сервиса.","train.wizard_errors.3-wrongCallTime":"Некорректное время звонка","train.wizard_errors.3-childrenWarningOld":"По правилам РЖД, стоимость детских билетов определяется изменяющимися коэффициентами. Поэтому точная стоимость с учетом коэффициентов указывается непосредственно перед оплатой билета.<br/>\n\t\t\t\t\t\t\t\t\t\tУказанная на сайте сумма и фактическая сумма к оплате могут отличаться.","train.wizard_errors.3-childrenWarning":"<p>РЖД рассчитывает точную стоимость детских билетов непосредственно перед оплатой.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Сумма на этой странице и сумма к оплате могут незначительно отличаться.</p>","train.wizard_errors.3-noCourier":"В день отправки поезда невозможно осуществить доставку билета курьером в Санкт-Петербурге.","train.wizard_errors.3-departureTooSoon":"До отправки поезда осталось менее трех суток, невозможно осуществить доставку билета курьером в Санкт-Петербурге.","train.wizard_errors.4-rejectAgreement":"Для оформления заказа вам нужно согласиться с&nbsp;условиями использования сервиса","train.wizard_errors.4-seatDiffer":'Вместо запрошенного места %requested%, система бронирования РЖД зарезервировала место %ordered% в вагоне %carNumber%. Вы можете продолжить заказ, если оно вас устраивает, или вернуться на <A href="%backUrl%">страницу выбора мест</A>.',"train.wizard_errors.4-seatDiffers":'Вместо запрошенных мест %requested%, система бронирования РЖД зарезервировала места %ordered% в вагоне %carNumber%.\tВы можете продолжить заказ, если они вас устраивают, или вернуться на <A href="%backUrl%">страницу выбора мест</A>.',"train.wizard_errors.4-seatNearWC":'Система бронирования РЖД зарезервировала место %ordered% (оно находится <strong>рядом с туалетом</strong>) в вагоне %carNumber%. Вы можете продолжить заказ, если оно вас устраивает, или вернуться на <A href="%backUrl%">страницу выбора мест</A>.',"train.wizard_errors.4-seatsNearWC":'Система бронирования РЖД зарезервировала места %ordered% (они находятся <strong>рядом с туалетом</strong>) в вагоне %carNumber%. Вы можете продолжить заказ, если они вас устраивают, или вернуться на <A href="%backUrl%">страницу выбора мест</A>.',"train.wizard_errors.warning_foreign_no_ereg":"Электронная регистрация недоступна, для&nbsp;посадки в&nbsp;поезд<br/>необходимо заранее получить билет на&nbsp;территории&nbsp;России.","train.wizard_errors.warning_foreign_with_ereg":"Для&nbsp;посадки в&nbsp;поезд необходимо заранее получить билет на&nbsp;территории&nbsp;России, либо пройти электронную регистрацию.","train.wizard_errors.noSeats":"К сожалению, выбранные вами места только что закончились.<br/>Пожалуйста, выберите другие.","train.wizard_errors.5-documentError":'Пожалуйста, <a href="%url%">проверьте указанные вами паспортные данные</a>',"train.wizard_errors.5-unknownError":'К сожалению, нашей системе не удалось оформить заказ.<br/>\n\t\t\t\t\t\t\t\t\t\tПожалуйста, <a href="%url%">повторите</a> запрос еще раз.<br/>\n\t\t\t\t\t\t\t\t\t\tЕсли ошибка не исчезает, пожалуйста, сообщите администраторам сервиса.<br/>',"train.wizard_errors.5-russian-phone-needed":"Для данного способа оплаты обязательно нужно указать российский номер телефона в формате 7 xxx xxx xx xx","train.wizard_errors.noBlankOnStation":"Для посадки в поезд вам необходимо получить билет на бланке или пройти электронную регистрацию.<br/>\n\t\t\t\t\t\t\t\t\t\tЭлектронную регистрацию можно будет пройти сразу после оплаты или в любой момент до %time%.<br/>\n\t\t\t\t\t\t\t\t\t\tРаспечатать билет на бланке можно <b>только на территории России</b>, в любое время до выезда из РФ.","train.wizard_errors.noEregOnStation":"Необходимо <b>до выезда за пределы России</b> распечатать билет на вокзале! (в кассе или терминале)<br/>\n\t\t\t\t\t\t\t\t\t\tВ %station% распечатать билет будет невозможно.<br/>\n\t\t\t\t\t\t\t\t\t\tЭлектронная регистрация по заказу также будет недоступна!","train.wizard_errors.noEregOnStationNotCity":"Необходимо <b>до выезда за пределы России</b> распечатать билет на вокзале! (в кассе или терминале)<br/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tНа станции %station% распечатать билет будет невозможно.<br/>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tЭлектронная регистрация по заказу также будет недоступна!","train.wizard_errors.nearestStations":"Ближайшие: %stationList%","train.wizard_errors.common-emptyFields":"Вы заполнили не все необходимые поля либо заполнили их с ошибками","train.wizard_errors.common-wrongData":"Неверные данные","train.wizard_errors.eveningOrder":"При заказе на сегодня после 18-00 по московскому времени возможно приобрести только электронный жд билет.","train.wizard_errors.trainLeft":"Поезд ушел.","train.wizard_errors.trainLeftSoon":"Поезд отправляется меньше чем через час. Продажа билетов закрыта.","train.wizard_errors.pastDateOrder":"Нельзя сделать заказ билетов на прошедшую дату","train.wizard_errors.processedOrder":"Этот заказ уже обрабатывается. Пожалуйста, оформите новый заказ или свяжитесь с оператором для изменения отправленного. Телефон службы поддержки: %phone%","train.wizard_errors.order_missing":"Прошло больше 10 дней с момента запроса и данные по этой ссылке уже устарели. Пожалуйста, начните новый поиск.","train.wizard_errors.order_train_left":"Поезд уже ушел. Для заказа билетов выберите другую дату.","train.wizard_errors.order_less_than_hour_left":"Информация о заказе билетов на этот поезд закрыта, т.к. до его отправления осталось меньше часа.","train.wizard_errors.eticket_tooMuchTickets":"В одном заказе электронных билетов не может быть больше 4 пассажиров, включая взрослых и детей.","train.wizard_errors.eticket_orderRestrictedByTrain":"<p>К сожалению, продажа электронных билетов на выбранный поезд недоступна.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Вы можете заказать билеты на бланке.</p>","train.wizard_errors.eticket_orderRestrictedByTrainAvia":'<p>К сожалению, продажа электронных билетов на выбранный поезд недоступна.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Вы можете заказать билеты на бланке, либо <a class="pseudoBlue" href="%aviaUrl%">выбрать авиабилеты</a>.</p>',"train.wizard_errors.eticket_internalError":'Покупка электронного билета временно недоступна.\n\t\t\t\t\t\t\t\t\t\tEсли вам нужен именно электронный билет, попробуйте <a href="%link%">обновить</a> страницу',"train.wizard_errors.eticket_noProvider":"К сожалению, продажа электронных билетов временно остановлена.<br/>\n\t\t\t\t\t\t\t\t\t\tПожалуйста, закажите обычный билет на бланке.</br>\n\t\t\t\t\t\t\t\t\t\tДоставка и получение билетов на бланке возможны в Москве и Санкт-Петербурге.","train.wizard_errors.eticket_nodata_warning":"Детские билеты на&nbsp;выбранный поезд могут продаваться со&nbsp;специальными скидками.\n\t\t\t\t\t\t\t\t\t\tПоэтому точная стоимость с&nbsp;учетом скидок указывается в&nbsp;момент оплаты.","train.wizard_errors.blank_eveningOrder":"При заказе на сегодня после 18-00 по московскому времени возможно приобрести только электронный жд билет.","train.wizard_errors.blank_noProvider":"Из-за особенностей работы систем бронирования вы можете купить только электронный билет на этот поезд.","train.wizard_errors.blank_orderRestrictedByTrain":"Из-за особенностей работы систем бронирования вы можете купить только электронный билет на этот поезд.","train.wizard_errors.blank_orderRestrictedByTrainDavs":"Билет на бланке на этот поезд можно купить только в Москве.<br>\nЕсли вы находитесь в другом городе, выберите электронный билет и распечатайте его в кассе или в терминале на вокзале.","train.wizard_errors.blank_orderRestrictedByTrainVip":"Билет на бланке на этот поезд можно купить только в Санкт-Петербурге.<br>\nЕсли вы находитесь в другом городе, выберите электронный билет и распечатайте его в кассе или в терминале на вокзале.","train.wizard_errors.blank_moscow_noProvider":"Продажи в&nbsp;Москве будут возобновлены в&nbsp;ближайшее время.","train.wizard_errors.blank_spb_noProvider":"Продажи в&nbsp;Санкт-Петербурге будут возобновлены в&nbsp;ближайшее время.","train.wizard_errors.blank_moscow_noProvider_custom":"К сожалению, заказ билетов на бланке в Москве отключен до 14:00.","train.wizard_errors.blank_departureDelayOld":"К сожалению, %todayDate% билет на бланке в Москве можно купить только на поезда, отправляющиеся не раньше %departureDate%.","train.wizard_errors.blank_departureDelayOld2":"В Москве продажа на этот поезд уже прекращена.","train.wizard_errors.blank_departureDelay":"Московские офисы Tutu.ru закончили оформление билетов на поезда, отправляющиеся %departureDate%.","train.wizard_errors.webmoneyFail":"К сожалению, системе заказа не удалось провести оплату через Webmoney.<br/><br/>Пожалуйста, попробуйте еще раз или выберите другой способ оплаты.","train.wizard_errors.bookExpired":"К сожалению, 15 минут, отведенные на оплату заказа, прошли. Пожалуйста, попробуйте снова.","train.rules.mobiticket":"Покупка электронных ж/д билетов через Tutu.ru возможна только при согласии с Условиями использования сервиса, выраженного путем совершения конклюдентных действий.\n\nЕсли Вы не принимаете в полном объеме Условия использования сервиса, покупка электронных ж/д билетов через Tutu.ru не допускается.\n\n\n\nУсловия использования сервиса по покупке электронных ж/д билетов через Tutu.ru\n\n\n1. ОБЯЗАННОСТИ КЛИЕНТОВ TUTU.RU\n\n1.1. Клиент Tutu.ru обязан:\n\n1.1.1. самостоятельно ознакомиться с правилами и инструкциями по покупке электронных ж/д билетов на сайте www.tutu.ru;\n\n1.1.2. соблюдать все правила и инструкции Tutu.ru и партнеров, в том числе, но не ограничиваясь этим, договор-оферту партнеров (http://railroad.mobiticket.ru/page.php?page=railroad_oferta);\n\n1.1.3. оплачивать электронные ж/д билеты в соответствии с тарифами и сервисными сборами РЖД и партнеров Tutu.ru по продаже электронных билетов, а также сервисными сборами Tutu.ru, указанными на сайте www.tutu.ru в виде единой цены за билет;\n\n\n2. ПРАВА TUTU.RU\n\n2.1. Tutu.ru имеет право:\n\n2.1.1. в одностороннем порядке отказать Клиенту в приобретении электронного билета через сайт www.tutu.ru, в том числе в случае нарушения Клиентом правил и инструкций по покупке электронных билетов, но не ограничиваясь этим;\n\n2.2. изменять условия использования сервиса без предварительного уведомления.\n\n\n3. КОНФИДЕНЦИАЛЬНОСТЬ ЛИЧНЫХ ДАННЫХ\n\n3.1. Tutu.ru обязуется заботиться о конфиденциальности личной информации, предоставленной пользователем при покупке билетов.\n\n3.2. Факт пользования услугами Tutu.ru подтверждает согласие Клиента на использование номера его мобильного телефона и адреса его электронной почты в сети Интернет (E-mail) для направления ему информации по электронной почте или SMS, признаваемой Tutu.ru ценной для Клиента.\n\n3.3. За предоставление Клиентом неверных номеров телефонов Tutu.ru ответственности не несет.\n\n\n4. ФИНАНСОВЫЕ УСЛОВИЯ\n\n4.1. Покупая билеты через Tutu.ru, Клиент соглашается с ценами, указанными на сайте. Цены включают стоимость билетов согласно тарифам и сервисным сборам РЖД и партнеров Tutu.ru по продаже электронных билетов, сервисные сборы Tutu.ru.\n\n4.2. Tutu.ru вправе изменять по своему усмотрению стоимость собственного сервисного сбора за предоставляемые услуги.\n\n4.3. Tutu.ru не несет ответственности за изменения тарифов и сервисных сборов со стороны РЖД и партнеров.\n\n\n5. ОТВЕТСТВЕННОСТЬ\n\n5.1. Tutu.ru  не несет ответственности за надлежащее функционирование сотовой сети и доступность отдельных сегментов сети Интернет в ходе покупки электронных билетов.\n\n5.2. Tutu.ru не несет ответственности за надлежащую работу компаний-партнеров.\n\n5.3. Клиент принимает на себя полную ответственность и риски, связанные с покупкой электронных билетов.\n\n5.4. Tutu.ru не несет ответственности за любые убытки и моральный вред, понесенные Клиентом в результате ошибочного понимания или непонимания Клиентом информации о порядке получения и использования электронных  билетов.\n\t","train.rules.travelmart":"Покупка электронных ж/д билетов через Tutu.ru возможна только при согласии с Условиями использования сервиса, выраженного путем совершения конклюдентных действий.\n\nЕсли Вы не принимаете в полном объеме Условия использования сервиса, покупка электронных ж/д билетов через Tutu.ru не допускается.\n\nПользователь дает согласие на хранение, обработку и передачу своих персональных данных в Tutu.ru.\n\nУсловия использования сервиса по покупке электронных ж/д билетов через Tutu.ru\n\n\n1. ОБЯЗАННОСТИ КЛИЕНТОВ TUTU.RU\n\n1.1. Клиент Tutu.ru обязан:\n\n1.1.1. самостоятельно ознакомиться с правилами и инструкциями по покупке электронных ж/д билетов на сайте www.tutu.ru;\n\n1.1.2. соблюдать все правила и инструкции Tutu.ru и партнеров, в том числе, но не ограничиваясь этим, договор-оферту партнеров (http://www.railwayticket.ru/doc/oferta.html);\n\n1.1.3. оплачивать электронные ж/д билеты в соответствии с тарифами и сервисными сборами РЖД и партнеров Tutu.ru по продаже электронных билетов, а также сервисными сборами Tutu.ru, указанными на сайте www.tutu.ru в виде единой цены за билет;\n\n\n2. ПРАВА TUTU.RU\n\n2.1. Tutu.ru имеет право:\n\n2.1.1. в одностороннем порядке отказать Клиенту в приобретении электронного билета через сайт www.tutu.ru, в том числе в случае нарушения Клиентом правил и инструкций по покупке электронных билетов, но не ограничиваясь этим;\n\n2.2. изменять условия использования сервиса без предварительного уведомления.\n\n\n3. КОНФИДЕНЦИАЛЬНОСТЬ ЛИЧНЫХ ДАННЫХ\n\n3.1. Tutu.ru обязуется заботиться о конфиденциальности личной информации, предоставленной пользователем при покупке билетов.\n\n3.2. Факт пользования услугами Tutu.ru подтверждает согласие Клиента на использование номера его мобильного телефона и адреса его электронной почты в сети Интернет (E-mail) для направления ему информации по электронной почте или SMS, признаваемой Tutu.ru ценной для Клиента.\n\n3.3. За предоставление Клиентом неверных номеров телефонов Tutu.ru ответственности не несет.\n\n\n4. ФИНАНСОВЫЕ УСЛОВИЯ\n\n4.1. Покупая билеты через Tutu.ru, Клиент соглашается с ценами, указанными на сайте. Цены включают стоимость билетов согласно тарифам и сервисным сборам РЖД и партнеров Tutu.ru по продаже электронных билетов, сервисные сборы Tutu.ru.\n\n4.2. Tutu.ru вправе изменять по своему усмотрению стоимость собственного сервисного сбора за предоставляемые услуги.\n\n4.3. Tutu.ru не несет ответственности за изменения тарифов и сервисных сборов со стороны РЖД и партнеров.\n\n\n5. ОТВЕТСТВЕННОСТЬ\n\n5.1. Tutu.ru  не несет ответственности за надлежащее функционирование сотовой сети и доступность отдельных сегментов сети Интернет в ходе покупки электронных билетов.\n\n5.2. Tutu.ru не несет ответственности за надлежащую работу компаний-партнеров.\n\n5.3. Клиент принимает на себя полную ответственность и риски, связанные с покупкой электронных билетов.\n\n5.4. Tutu.ru не несет ответственности за любые убытки и моральный вред, понесенные Клиентом в результате ошибочного понимания или непонимания Клиентом информации о порядке получения и использования электронных  билетов.\n\t","train.rules.ufs":"Покупка электронных ж/д билетов через Tutu.ru возможна только при согласии с Условиями использования сервиса, выраженного путем совершения конклюдентных действий.\n\nЕсли Вы не принимаете в полном объеме Условия использования сервиса, покупка электронных ж/д билетов через Tutu.ru не допускается.\n\nСоглашаясь с настоящими Условиями, Пользователь выражают свое письменное согласие на обработку персональных данных, к которым относятся: фамилия, имя, отчество, дата и место рождения, пол, гражданство и национальность; серия, номер паспорта, лица вписанные в паспорт, иные паспортные данные; адрес проживания и регистрации, домашний и мобильный телефон, адрес электронной почты; семейное, социальное, имущественное положение (в том числе сведения о недвижимом имуществе, о наличии автомобиля); профессия; информация (включая адрес, рабочий телефон, должность, сроки работы) о текущем месте работы и о предыдущих местах работы; о состоянии здоровья, любые иные данные, которые Пользователь сообщил при использовании настоящего сервиса.\n\nОбработка персональных данных осуществляется партнерами Tutu.ru в целях оформления железнодорожных билетов.\n\nПартнерами Tutu.ru используется смешанный способ обработки персональных данных, включающий в себя сочетание автоматизированного (с использованием средств вычислительной техники) и неавтоматизированного способа обработки.\n\nНастоящее согласие действует в течение одного года после указанной в железнодорожном билете даты отправления. Действие согласия прекращается на основании письменного заявления, которое подписывается Пользователем и вручается либо направляется заказным письмом с уведомлением о вручении соответствующим компаниям-партнерам Tutu.ru.\n\nУсловия использования сервиса по покупке электронных ж/д билетов через Tutu.ru\n\n\n1. ОБЯЗАННОСТИ КЛИЕНТОВ TUTU.RU\n\n1.1. Клиент Tutu.ru обязан:\n\n1.1.1. самостоятельно ознакомиться с правилами и инструкциями по покупке электронных ж/д билетов на сайте www.tutu.ru;\n\n1.1.2. соблюдать все правила и инструкции Tutu.ru и партнеров, в том числе, но не ограничиваясь этим, договор-оферту партнеров (%tutu_oferta%);\n\n1.1.3. оплачивать электронные ж/д билеты в соответствии с тарифами и сервисными сборами РЖД и партнеров Tutu.ru по продаже электронных билетов, а также сервисными сборами Tutu.ru, указанными на сайте www.tutu.ru в виде единой цены за билет;\n\n\n2. ПРАВА TUTU.RU\n\n2.1. Tutu.ru имеет право:\n\n2.1.1. в одностороннем порядке отказать Клиенту в приобретении электронного билета через сайт www.tutu.ru, в том числе в случае нарушения Клиентом правил и инструкций по покупке электронных билетов, но не ограничиваясь этим;\n\n2.2. изменять условия использования сервиса без предварительного уведомления.\n\n\n3. КОНФИДЕНЦИАЛЬНОСТЬ ЛИЧНЫХ ДАННЫХ\n\n3.1. Tutu.ru обязуется заботиться о конфиденциальности личной информации, предоставленной пользователем при покупке билетов.\n\n3.2. Факт пользования услугами Tutu.ru подтверждает согласие Клиента на использование номера его мобильного телефона и адреса его электронной почты в сети Интернет (E-mail) для направления ему информации по электронной почте или SMS, признаваемой Tutu.ru ценной для Клиента.\n\n3.3. За предоставление Клиентом неверных номеров телефонов Tutu.ru ответственности не несет.\n\n\n4. ФИНАНСОВЫЕ УСЛОВИЯ\n\n4.1. Покупая билеты через Tutu.ru, Клиент соглашается с ценами, указанными на сайте. Цены включают стоимость билетов согласно тарифам и сервисным сборам РЖД и партнеров Tutu.ru по продаже электронных билетов, сервисные сборы Tutu.ru.\n\n4.2. Tutu.ru вправе изменять по своему усмотрению стоимость собственного сервисного сбора за предоставляемые услуги.\n\n4.3. Tutu.ru не несет ответственности за изменения тарифов и сервисных сборов со стороны РЖД и партнеров.\n\n\n5. ОТВЕТСТВЕННОСТЬ\n\n5.1. Tutu.ru  не несет ответственности за надлежащее функционирование сотовой сети и доступность отдельных сегментов сети Интернет в ходе покупки электронных билетов.\n\n5.2. Tutu.ru не несет ответственности за надлежащую работу компаний-партнеров.\n\n5.3. Клиент принимает на себя полную ответственность и риски, связанные с покупкой электронных билетов.\n\n5.4. Tutu.ru не несет ответственности за любые убытки и моральный вред, понесенные Клиентом в результате ошибочного понимания или непонимания Клиентом информации о порядке получения и использования электронных  билетов.\n\t","train.sapsan.meta_title":"Расписание поездов «Сапсан», купить электронный билет на поезд Сапсан онлайн, цена билета на Сапсан","train.sapsan.title":"Билет на САПСАН за 4 минуты","train.sapsan.meta_description":"Билеты на Сапсан - цены, наличие мест, возможность онлайн покупки. Расписание поездов Сапсан, маршруты движения, остановки, время прибытия и отправления со всех станций.","train.sapsan.meta_keywords":"расписание поездов сапсан, цена билета на сапсан, купить электронный билет на поезд сапсан, сапсан стоимость билета","train.sapsan.meta_description_sheme":"Схемы вагонов Сапсана. Схемы вагонов бизнес- и эконом-класса. Информация о поезде Сапсан – wifi в Сапсане, вагон-бистро, место для курения, чем кормят в Сапсане.","train.sapsan.meta_keywords_sheme":"схема сапсана, вагоны сапсан, места в сапсане, сапсан схема мест, расположение мест в сапсане","train.sapsan.meta_description_rasp":"Расписание движения поездов по маршруту %departure% – %arrival%. Время отправления и прибытия, время стоянки, цена билетов и возможность онлайн-бронирования.","train.sapsan.meta_keywords_rasp":"сапсан %departure% %arrival%, расписание сапсан %departure% %arrival%, билеты %departure% %arrival% сапсан, поезд сапсан %departure% %arrival%","train.sapsan.meta_description_station":"Расписание движения поездов Сапсан через %station4%. Время отправления и прибытия, время стоянки, график движения поездов через %station4%.","train.sapsan.meta_keywords_station":"сапсан %station%, цены на сапсан до %station2%, расписание сапсанов из %station2%, купить билет на сапсан до %station2%","train.sapsan.meta_title_sheme":"Схема вагонов поезда Сапсан, расположение мест в вагонах бизнес и эконом классов в Сапсане - ответы на все вопросы о поезде","train.sapsan.breadcrumbs":"Билеты на поезд Сапсан","train.sapsan.poezda":"Поезда","train.sapsan.breadcrumbs_sapsan":"Сапсаны","train.sapsan.breadcrumbs_sheme":"Схема вагонов Сапсана","train.sapsan.logo_whole":"Билет на Сапсан за 4 минуты","train.sapsan.logo_left":"Билет на","train.sapsan.logo_right":"за 4 минуты","train.sapsan.annotation":"Сапсан за это время проезжает 12 километров","train.sapsan.payway_train_title":"Способы оплаты билета:","train.sapsan.sapsan_about_title":"&laquo;Сапсан&raquo; назван в&nbsp;честь самой быстрой птицы в&nbsp;мире&nbsp;&mdash; сокола-сапсана.","train.sapsan.sapsan_about_text":"<p>Расписание поездов &laquo;Сапсан&raquo; составлено с&nbsp;учетом их&nbsp;скорости до&nbsp;250&nbsp;км/ч. В&nbsp;поезде <i>&laquo;Сапсан&raquo;</i> может ехать <b>538</b>&nbsp;пассажиров.</p>\n<p>Цены на&nbsp;билеты в&nbsp;&laquo;Сапсан&raquo;, как правило, выше средних.</p>","train.sapsan.s_info_wifi":"В&nbsp;вагонах есть доступ к&nbsp;интернет","train.sapsan.s_info_nosmoke":"В&nbsp;поезде нельзя&nbsp;курить","train.sapsan.sapsan_buy_ticket":"Покупать билеты на&nbsp;Туту.ру так&nbsp;же быстро и&nbsp;комфортно, как путешествовать на&nbsp;&laquo;Сапсане&raquo;.<br /> \nУзнайте расписание поездов &laquo;Сапсан&raquo;, уточните цены билетов, проверьте наличие мест и&nbsp;купите онлайн электронные билеты на&nbsp;&laquo;Сапсан&raquo; всего за&nbsp;4&nbsp;минуты.","train.sapsan.title_cost":"Стоимость&nbsp;билетов&nbsp;на&nbsp;поезда&nbsp;Сапсан по&nbsp;всем&nbsp;доступным&nbsp;направлениям:","train.sapsan.title_trace":"Маршруты движения и&nbsp;остановки поезда Сапсан","train.sapsan.title_where":"Куда прибывает Сапсан","train.sapsan.shedule_time":"Это займет 4 минуты","train.sapsan.shedule_places_label":"место|места|мест","train.sapsan.shedule_place":"Осталось %seats%&nbsp;%label%","train.sapsan.trace_click":"Чтобы узнать время прибытия и&nbsp;отправления &laquo;Сапсана&raquo;, кликните по&nbsp;нужной станции на&nbsp;схеме.<br />\nПоезда &laquo;Сапсан&raquo; совершают 7&nbsp;рейсов в&nbsp;день по&nbsp;маршруту Санкт-Петербург&nbsp;&mdash; Москва и&nbsp;обратно.","train.sapsan.trace_mn_twice":"Из&nbsp;Москвы в&nbsp;Нижний Новгород и&nbsp;обратно высокоскоростные поезда ходят дважды в&nbsp;день&nbsp;&mdash; утром и&nbsp;вечером.","train.sapsan.trace_km":"&nbsp;км","train.sapsan.station_v_len":"Ленинградский вокзал","train.sapsan.station_v_mos":"Московский вокзал","train.sapsan.station_v_kur":"Курский вокзал","train.sapsan.station_lm_tver":"Тверь","train.sapsan.station_lm_vvolochek":"Вышний Волочек","train.sapsan.station_lm_bologoe":"Бологое","train.sapsan.station_lm_okulovka":"Окуловка","train.sapsan.station_lm_chudovo":"Чудово","train.sapsan.station_mn_vladimir":"Владимир","train.sapsan.station_mn_djerjinsk":"Дзержинск","train.sapsan.text_where":'<p>Высокоскоростные поезда &laquo;Сапсан&raquo; отправляются из&nbsp;Москвы в&nbsp;Санкт-Петербург с&nbsp;Ленинградского вокзала. \nВ&nbsp;Петербурге они прибывают на&nbsp;Московский вокзал. В&nbsp;Нижний Новгород из&nbsp;Москвы &laquo;Сапсаны&raquo; отходят с&nbsp;Курского вокзала. </p>\n<p>В&nbsp;Москву &laquo;Сапсаны&raquo; из&nbsp;Санкт-Петербурга прибывают на&nbsp;Ленинградский вокзал, а&nbsp;из&nbsp;Нижнего Новгорода&nbsp;&mdash; на&nbsp;Курский. <a href="http://www.tutu.ru/poezda/station_d.php?nnst=2000000&sapsan=yes">Узнайте</a> точное время отправления &laquo;Сапсана&raquo; из&nbsp;Москвы и&nbsp;время прибытия &laquo;Сапсана&raquo; в&nbsp;Москву.</p>',"train.sapsan.text_where_left":"У&nbsp;поездов, выходящих из&nbsp;Петербурга, нумерация вагонов начинается с&nbsp;хвоста поезда, а&nbsp;у&nbsp;выходящих из&nbsp;Москвы&nbsp;&mdash; с&nbsp;головы поезда.","train.sapsan.vagon_econom":"&nbsp;эконом","train.sapsan.vagon_bar":"&nbsp;бар","train.sapsan.vagon_business":"&nbsp;бизнес","train.sapsan.reclam_place":"Рекламное место <b>свободно</b>","train.sapsan.sapsan_schedule":"Расписание поездов Сапсан","train.sapsan.title_msk_to_spb":"Москва &rarr; Санкт-Петербург","train.sapsan.title_msk_to_nnov":"Москва &rarr; Нижний Новгород","train.sapsan.from_msk":"Из Москвы","train.sapsan.from_spb":"Из Санкт-Петербурга","train.sapsan.from_nnov":"Из Нижнего Новгорода","train.sapsan.other_trains_spb":"Билеты на другие поезда в Санкт-Петербург","train.sapsan.other_trains_nnov":"Билеты на другие поезда в Нижний Новгород","train.sapsan.sell_text_first":"Каждые 7&nbsp;минут мы&nbsp;продаем билет на&nbsp;&laquo;Сапсан&raquo;. Узнайте, сколько мест осталось на&nbsp;нужный вам поезд!","train.sapsan.sell_text_second":"Мы&nbsp;продаем билеты на&nbsp;&laquo;Сапсан&raquo; с&nbsp;2009&nbsp;года, когда первый высокоскоростной поезд отправился из&nbsp;Санкт-Петербурга в&nbsp;Москву.","train.sapsan.sapsan_about_text_first":"Пока вы&nbsp;доберетесь до&nbsp;кассы на&nbsp;вокзале, ваш билет купит кто-то другой. На&nbsp;сайте Туту.ру покупка билетов займет 4&nbsp;минуты, а&nbsp;оплатить их&nbsp;можно практически любым способом.","train.sapsan.sapsan_about_text_second":"Каждый второй покупатель ж/д билетов на&nbsp;нашем сайте становится постоянным клиентом. Покупать билеты на&nbsp;Туту.ру так&nbsp;же комфортно и&nbsp;быстро, как путешествовать на&nbsp;&laquo;Сапсане&raquo;.","train.sapsan.feedback":"Обратная связь","train.sapsan.tickets_today":"Сегодня&nbsp;открыта продажа&nbsp;билетов <b>на</b>&nbsp;","train.sapsan.tickets_sale":"Продажа билетов на&nbsp;","train.sapsan.return":"Вернуться на&nbsp;главную &laquo;Сапсан&raquo;","train.sapsan.sheme_title_places":"Схема расположения мест в&nbsp;вагонах поезда Сапсан","train.sapsan.sheme_title_business":"Вагон бизнес-класса в&nbsp;Сапсане","train.sapsan.sheme_title_econom":"Вагон эконом-класса в&nbsp;Сапсане","train.sapsan.sheme_title_bistro":"Вагон-бистро в&nbsp;поезде Сапсан","train.sapsan.sheme_description_places":"<p>В&nbsp;каждом &laquo;Сапсане&raquo; есть 2&nbsp;вагона бизнес-класса и&nbsp;7&nbsp;вагонов класса &laquo;эконом&raquo;.</p>\n<p>Все кресла&nbsp;&mdash; как в&nbsp;салонах бизнес-класса, так и&nbsp;эконом-класса&nbsp;&mdash; рассчитаны на&nbsp;длительное путешествие. Они оборудованы регулируемыми спинками и&nbsp;откидными опорами для ног. У&nbsp;каждой пары кресел есть индивидуальное освещение, электрическая розетка и&nbsp;столик.</p>\n<p>В&nbsp;пассажирских салонах всех вагонов предусмотрено место для крупного багажа. Небольшие сумки можно размещать на&nbsp;полках над креслами в&nbsp;салоне. Температура в&nbsp;салонах &laquo;Сапсана&raquo; в&nbsp;любое время года поддерживается на&nbsp;уровне 22 &ordm;С.</p>\n<p>Проводники &laquo;Сапсанов&raquo; не&nbsp;разносят еду и&nbsp;напитки, как в&nbsp;обычных поездах. Питание пассажиров &laquo;Сапсана&raquo;&nbsp;&mdash; это работа стюардов. В&nbsp;обязанности проводников &laquo;Сапсана&raquo; входит обеспечение безопасности людей, создание для них комфортной атмосферы и&nbsp;решение проблем, которые могут возникнуть в&nbsp;путешествии.</p>","train.sapsan.sheme_description_business":"<p>В&nbsp;вагонах бизнес-класса кресла имеют кожаную обивку и&nbsp;оборудованы встроенными аудиовидеомодулями. В&nbsp;стоимость билета входит горячее питание, чай, кофе, прохладительные и&nbsp;алкогольные напитки. Все пассажиры бизнес-класса получают дорожные наборы и&nbsp;свежую прессу, а&nbsp;пассажиры с&nbsp;детьми&nbsp;&mdash; детские наборы.</p>","train.sapsan.sheme_description_econom":"<p>Пассажиры, путешествующие в&nbsp;вагонах эконом-класса, могут за&nbsp;дополнительную плату получать свежую прессу, еду и&nbsp;напитки из&nbsp;бистро. Всем пассажирам доступен wifi на&nbsp;протяжении всего пути поезда. В&nbsp;салоне поезда есть розетки для подзарядки мобильных устройств. Также пассажиры &laquo;Сапсана&raquo; могут бесплатно заказать такси.</p>","train.sapsan.sheme_description_bistro":"<p>В&nbsp;вагоне-бистро можно перекусить за&nbsp;барной стойкой, или посидеть за&nbsp;одним из&nbsp;10&nbsp;столиков. Здесь&nbsp;же находится единственная в&nbsp;поезде зона для курения. Курить в&nbsp;других вагонах &laquo;Сапсана&raquo; запрещают правила. В&nbsp;баре продают алкоголь и&nbsp;прохладительные напитки.</p>","train.sapsan.vagon_1":"1-й вагон","train.sapsan.vagon_2":"2-й вагон","train.sapsan.vagon_3":"3-й вагон","train.sapsan.vagon_4":"4-й вагон","train.sapsan.vagon_5":"5-й вагон","train.sapsan.vagon_6":"6-й вагон","train.sapsan.vagon_7":"7-й вагон","train.sapsan.vagon_8":"8-й вагон","train.sapsan.vagon_9":"9-й вагон","train.sapsan.vagon_10":"10-й вагон","train.main.meta_title":"Туту.ру","train.main.meta_keywords":"Туту.ру","train.main.meta_description":"Туту.ру","train.main.city_on_site":"%city_nom% на Туту.ру","train.main.train_navi_title":"Поезда","train.main.station_search_example":"Красноярск","train.main.payways":"Способы%tag%оплаты","train.main.faq_title":"Частые вопросы","train.main.station_schedule":"Расписание вокзала","train.main.stations_and_routes":"Станции и маршруты отмечены на картах","train.main.all2read":"Все вопросы","train.main.ask2read":"Задать вопрос","train.main.paper_ticket_notice":"<p><b>Открыта продажа билетов на&nbsp;%date%</b> на&nbsp;поезда дальнего следования</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Узнайте об открытии продаж билетов на&nbsp;ваш поезд первым:</p>","train.main.digital_ticket_notice":'<p><b>Электронные билеты на поезд</b></p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p><a href="%benefitsUrl%">Преимущества</a> электронного билета перед&nbsp;бумажным очевидны:\n\t\t\t\t\t\t\t\t\t\t\t\tего можно купить из&nbsp;любой точки планеты, удобно оплатив <a href="%paymentUrl%">карточками</a>. </p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p></p>',"train.main.digital_ticket_notice_many":'<p><b>Электронные билеты на поезд</b></p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p><a href="%benefitsUrl%">Преимущества</a> электронного билета перед&nbsp;бумажным очевидны:\n\t\t\t\t\t\t\t\t\t\t\t\tего можно купить из&nbsp;любой точки планеты, оплатив любым из&nbsp;<a href="%paymentUrl%">многочисленных способов</a>. </p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p></p>',"train.main.subscribe_link":"Подписаться на рассылку","train.main.rss_link":"PCC-лента","train.main.incity_schedule":"%city%: расписание поездов","train.main.footer_menu_feedback":"<b>Обратная связь</b>","train.main.footer_menu_faq":"Часто задаваемые вопросы","train.main.footer_menu_subscribe":"Подписка на рассылку","train.main.footer_menu_rss":"РСС-лента","train.main.footer_menu_ryorder":"Заказ жд билетов","train.main.footer_menu_rules":"Правила работы сервиса","train.main.footer_menu_payways":"Способы оплаты заказа","train.main.footer_menu_advert":"<b>Реклама на Туту.ру</b>","train.main.footer_menu_informer":"Информер Туту.ру","train.main.footer_copyright":'При использовании материалов ссылка на&nbsp;сайт <a href="http://tutu.ru">Туту.ру</a> обязательна.',"train.main.left_avia":"Авиабилеты","train.main.left_avia_description":"расписание самолетов, аэропорты, авиакомпании","train.main.left_etrain":"Электрички","train.main.left_etrain_description":"расписание электричек, экспрессов, аэроэкспрессов","train.main.left_hotels":"Гостиницы","train.main.left_hotels_description":"Бронирование отелей за&nbsp;рубежом и&nbsp;гостиниц в&nbsp;России и&nbsp;СНГ","train.main.left_informer":"Информер","train.main.left_informer_description":"Разместите расписание поездов на вашем сайте","train.main.left_promo":"Тонкости туризма","train.main.left_promo_description_1":"Обо всех","train.main.left_promo_description_2":"городах и&nbsp;курортах России","train.main.left_promo_description_3":"&nbsp;&mdash; на&nbsp;&laquo;Тонкостях туризма&raquo;","train.main.right_popular_ways":"<strong>Едем на море!</strong><br />Узнайте расписание поездов дальнего следования перед покупкой билетов.","train.main.right_popular_ways_winter":"<strong>Лыжню!</strong><br />Узнайте расписание поездов дальнего следования перед покупкой билетов.","train.main.center_popular_ways":"Билеты на поезд по выгодным ценам <noindex>на %popularDate%</noindex>","train.main.center_popular_ways_dir":"Направление","train.main.center_popular_ways_oneway":"В одну сторону","train.main.center_popular_ways_return":"Туда и обратно","train.main.center_popular_ways_description":"Расписание поездов на&nbsp;Tutu.ru &mdash; это не&nbsp;только информация о&nbsp;прибытии и&nbsp;отправлении. В&nbsp;расписании указаны еще и&nbsp;цены на&nbsp;билеты на&nbsp;поезд, лучшие из&nbsp;которых мы поместили в&nbsp;этот&nbsp;блок.","train.main.train":"Поезд","train.main.train_schedule":"Годовой график","train.main.train_route":"Маршрут поезда","train.main.train_reviews":"Отзывы пассажиров","train.main.train_departure_station":"<span>Даты отправления</span> поезда со станции %stationName%","train.main.moscow_time":"Московское время","train.main.local_time":"Местное время","train.main.train_route2":"Маршрут","train.main.ticket_order":"Заказ билетов","train.main.to_order":"Заказать","train.main.search_train_title":"Поиск поезда","train.main.search_train_meta_title":"Поиск поезда по номеру или названию","train.main.search_train_meta_keywords":"Поиск поезда по номеру или названию","train.main.search_train_meta_description":"Поиск поезда по номеру или названию","train.main.schedule":"Расписание поездов","train.main.trains_schedule_meta_title":"Расписание поездов: %departureCityName% - %arrivalCityName%, стоимость билета, заказ железнодорожных билетов на поезд. Купить жд билеты %departureStationName% - %arrivalStationName%","train.main.trains_schedule_meta_keywords":"Расписание поездов, %departureCityName%, %arrivalCityName%, расписание, движения, поезда, дальнего, следования, заказ, жд билеты, железнодорожные, %departureStationName%, %arrivalStationName%, стоимость, цена, ж/д билетов","train.main.trains_schedule_meta_description":"Расписание поездов %departureCityName% - %arrivalCityName%. Стоимость билета и заказ жд билетов %departureStationName% - %arrivalStationName%","train.main.trains_schedule_meta_title_sapsan":"Расписание поездов Сапсан: %departureCityName% - %arrivalCityName%, цена электронного билета на Сапсан от %price% р.","train.main.trains_schedule_meta_title_sapsan_date":"Расписание поездов Сапсан: %departureCityName% - %arrivalCityName%, купить электронный билет на Сапсан за 4 минуты","train.main.trains_schedule_station_meta_title":"Расписание поездов - %stationName%. Как доехать до %stationName2% на поезде","train.main.trains_schedule_station_meta_title_sapsan":"Расписание поезда Сапсан - %stationName%, узнать цены и купить билеты на Сапсан в %stationName2%","train.main.trains_schedule_station_meta_keywords":"Расписание поездов, %stationName%","train.main.trains_schedule_station_meta_description":"Расписание поездов: %stationName%","train.main.trains_schedule_station_meta2_title":"Жд билеты %stationName%. Расписание поездов - %stationName%. Как доехать до %stationName2% на поезде. Купить билет на поезд до %stationName2%","train.main.trains_schedule_station_meta2_keywords":"жд билеты %stationName%, купить билет на поезд до %stationName2%, расписание поездов %stationName%, как добраться до %stationName2%, как доехать до %stationName2%","train.main.trains_schedule_station_meta2_description":"Жд билеты в %stationName3% и из %stationName2%. Расписание поездов через %stationName3%, возможность покупки билета на поезд до города онлайн.","train.main.trains_meta_title":"Расписание поездов по России, купить билеты на поезд онлайн, цена билетов, расписание движения поездов дальнего следования, Москва, Санкт-Петербург %year%","train.main.trains_meta_keywords":"Расписание,поездов,дальнего,следования,Москвы,вокзалов,%year%","train.main.trains_meta_description":"Расписание поездов всех вокзалов Москвы, России, СНГ. Расписание поездов дальнего следования %year% гг.","train.main.schedule2":"Расписание поездов дальнего следования, билеты на поезд","train.main.sapsan_about":"\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p>&laquo;Сапсан&raquo; назван в&nbsp;честь самой быстрой птицы в&nbsp;мире&nbsp;&mdash; сокола-сапсана. Расписание поездов «Сапсан» составлено с учетом их скорости до 250 км/ч.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p>В поезде может ехать <b>538</b> пассажиров. Цены на билеты в «Сапсан», как правило, выше средних.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t","train.main.sapsan_title":"Расписание движения поездов <i>«Сапсан»</i> по всем доступным направлениям","train.main.sapsan_msk":"Москва","train.main.sapsan_spb":"Санкт-Петербург","train.main.sapsan_nov":"Нижний Новгород","train.main.warning_input_date":'Пожалуйста, уточните <a href="javascript: void(0)" rel="calendarTriggernavigation-date%hash%" nojs="hide" style="display:none;">дату поездки</a><span nojs="show">дату поездки</span>%additional%, чтобы мы смогли найти для вас билеты.%additional%',"train.main.main_phones":"<b>Телефон единого информационно-сервисного центра:</b><br />8&nbsp;(800)&nbsp;775-00-00&nbsp;(круглосуточно, звонок бесплатный)","train.main.msk_main_phones":"<b>Единая справочная служба железнодорожных вокзалов Москвы</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t(цены на жд билеты, жд расписание, наличие жд билетов, расписание поездов дальнего следования):<br/>8&nbsp;800&nbsp;775-00-00&nbsp;(круглосуточно, звонок бесплатный)","train.main.msk_region_name":"москва","train.main.msk_region_name2":"Москвы","train.main.spb_main_phones":"<b>Единая справочная служба железнодорожных вокзалов Санкт-Петербурга</b><br />\n\t\t\t\t\t\t\t\t\t\t\t\t(цены на жд билеты, жд расписание, наличие жд билетов, расписание поездов дальнего следования): (812)&nbsp;762-33-44&nbsp;(круглосуточно, платно)","train.main.spb_region_name":"санкт-петербург","train.main.spb_region_name2":"Санкт-Петербурга","train.main.train_scheme_meta_title":"Расписание поездов %railwayName2% вокзала %year% | TUTU.RU - поезда дальнего следования","train.main.train_scheme_meta_keywords":"Расписание,движения,поездов,дальнего,следования,%regionName2%,%regionName%,%railwayName%,вокзал,%railwayName2%,вокзала,%directionName%,направление,телефон,справочная","train.main.train_scheme_meta_description":"Расписание движения поездов %railwayName2% вокзала %regionName2% на %year%, %directionName% направление. Телефон справочной %railwayName2% вокзала. Расписание поездов дальнего следования.","train.main.train_digit_meta_title":"Электронный билет на поезд. Электронные ж/д билеты с онлайн оплатой.","train.main.train_digit_meta_keywords":"Электронный, ж/д билет, на поезд, Онлайн, оплата, Заказ, электронных жд билетов с получением на вокзале. Online оплата. Электронные ж/д билеты на поезда дальнего следования.","train.main.train_digit_meta_description":"Заказ электронных билетов на поезд. Онлайн оплата. Заказ электронных жд билетов с получением на вокзале. Электронные ж/д билеты на поезда дальнего следования.","train.main.train_digit_path_title":"Электронный ж/д билет","train.main.train_blank_meta_title":"Электронные железнодорожные билеты. Продажа жд билетов с доставкой. Заказ железнодорожных билетов на поезда дальнего следования","train.main.train_blank_meta_keywords":"Заказ железнодорожных билетов. Доставка по Москве. Заказ ж/д билетов с доставкой. Заказ электронных ж/д билетов на поезда дальнего следования","train.main.train_blank_meta_description":"Заказ железнодорожных билетов. Доставка по Москве. Заказ ж/д билетов с доставкой. Заказ электронных ж/д билетов на поезда дальнего следования","train.main.train_blank_path_title":"Заказ железнодорожных билетов","train.main.ticket_description":'\n\t\t\t\t\t\t\t\t\t\t\t\t<h1>Электронные билеты на поезд на сайте Tutu.ru</h1>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tПокупка электронных билетов &mdash; одна из самых привлекательных возможностей интернета.\n\t\t\t\t\t\t\t\t\t\t\t\t\tВы выбираете нужный поезд и оформляете на него подходящий билeт &mdash; быстро, на домашнем\n\t\t\t\t\t\t\t\t\t\t\t\t\tили офисном компьютере.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tЧтобы заказать электронный билет на поезд, просто укажите дату поездки и маршрут. После этого\n\t\t\t\t\t\t\t\t\t\t\t\t\tпоявится расписание поeздов дальнего следования. В получившемся списке будут показаны пoезда, на\n\t\t\t\t\t\t\t\t\t\t\t\t\tкоторые можно купить билeты. Достаточно будет выбрать удобные места в вагоне.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tКроме того вы можете посмотреть список поездов, следующих по нужному направлению, включая те, на\n\t\t\t\t\t\t\t\t\t\t\t\t\tкоторые закончились свободные места. В таблице с данными есть сортировка по различным столбцам.\n\t\t\t\t\t\t\t\t\t\t\t\t\tНапример, по времени отправления, времени прибытия или по общему времени в пути.\n\t\t\t\t\t\t\t\t\t\t\t\t\tПри необходимости есть возможность перейти к просмотру подробного маршрута поезда, в котором\n\t\t\t\t\t\t\t\t\t\t\t\t\tуказаны все остановочные пункты по пути следования, либо ознакомиться с годовым графиком\n\t\t\t\t\t\t\t\t\t\t\t\t\tвыбранного состава.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p><a href="%trainMainUrl%">Перейти к расписанию поездов дальнего следования</a></p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tОплата электронных билетов на поезд осуществляется онлайн и оффлайн &mdash; по банковской карте,\n\t\t\t\t\t\t\t\t\t\t\t\t\tэлектронными деньгами, наличными в платежных терминалах и салонах сотовой связи.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tИ, что самое важное, заказ и продажа электронных билетов на поезда дальнего следования\n\t\t\t\t\t\t\t\t\t\t\t\t\tпроизводится в любое время суток, без перерывов на обед и выходных.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t\tПосле того, как вы приобрели электронный ж/д билет, на указанный вами номер телефона придет SMS\n\t\t\t\t\t\t\t\t\t\t\t\t\tсо специальным 14-значным кодом. Этот же код электронного ж/д билета вы получите по электронной\n\t\t\t\t\t\t\t\t\t\t\t\t\tпочте.\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--/noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tТеперь, чтобы сесть в поезд, вам надо будет приехать на вокзал только в день отправления.\n\t\t\t\t\t\t\t\t\t\t\t\t\tС собой нужно обязательно иметь 14-значный код ж/д билета и документ, указанный при заказе.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="%trainRulesUrl%" target="_blank">Подробнее про покупку электронного билета на поезд</a>\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t\tПолучить электронный билет на поезд можно не только в кассах вокзала, но и\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="%terminalUrl%" target="_blank">в терминалах самообслуживания (ТТС)</a>.\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--/noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p><a href="%trainMainUrl%">Купить электронный ж/д билет > > ></a></p>\n\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t<h2>Покупка обычных ж/д билетов на Tutu.ru (на бланке РЖД)</h2>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tЕсли вы хотите купить онлайн не электронные жд билеты, а обычные, выбирайте соответствующие\n\t\t\t\t\t\t\t\t\t\t\t\t\tспособы оплаты заказа ж/д билетов на бланке РЖД.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tДля покупки достаточно сделать заказ на сайте. По вашему желанию мы доставляем билeты на поeзд в\n\t\t\t\t\t\t\t\t\t\t\t\t\tквартиры и офисы. В этом случае деньги вы отдаете курьеру, который привезет ваши жд билeты.\n\t\t\t\t\t\t\t\t\t\t\t\t\tТакже вы можете произвести оплату и забрать покупку самостоятельно, из наших офисов.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tЗаказ и доставку билетов на поезда мы производим по Москве и Санкт-Петербургу. В отличие от\n\t\t\t\t\t\t\t\t\t\t\t\t\tбилeтов на бланках РЖД, электронные билеты на поезд можно получить в любой кассе РЖД на\n\t\t\t\t\t\t\t\t\t\t\t\t\tтерритории России (на вокзале), оборудованной терминалом АСУ "Экспресс-3".\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="%trainRulesUrl%" target="_blank">\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tПодробнее про покупку билeтов на поезда (традиционный бланк РЖД)\n\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="%blankOrderUrl%">Купить ж/д билет на бланке > > ></a>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<!--/noindex-->\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tВ любом случае мы выдадим все необходимые бухгалтерские документы на приобретенные у нас билеты\n\t\t\t\t\t\t\t\t\t\t\t\t\tна поезд, будь то электронный билет или на бланке РЖД &mdash; мы знаем, как это бывает важно.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tКроме того, делая покупку на сайте Tutu.ru, вы можете воспользоваться нашей справочной\n\t\t\t\t\t\t\t\t\t\t\t\t\tинформацией по <a href="%trainCarsUrl%" target="_blank">поездам дальнего следования</a>.\n\t\t\t\t\t\t\t\t\t\t\t\t\tМы постарались максимально подробно ответить на наиболее частые вопросы, возникающие при заказе\n\t\t\t\t\t\t\t\t\t\t\t\t\tи покупке жд билетов: как восстановить потерянный билет, возврат билетов на поезда, правила\n\t\t\t\t\t\t\t\t\t\t\t\t\tпересечения границы на поезде и т.д. Для большей наглядности мы\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a href="%trainEticketUrl%" target="_blank">сравниваем оба типа железнодорожных билетов</a>:\n\t\t\t\t\t\t\t\t\t\t\t\t\tэлектронный билет на поезд и бумажный (бланк РЖД).\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p><a href="%trainCarsUrl%">Перейти к справочнику по поездам дальнего следования > > ></a></p>\n\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t<h2>Электронный билет на&nbsp;поезд и&nbsp;ж/д билет на&nbsp;бланке&nbsp;РЖД</h2>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tНа Tutu.ru можно сделать как заказ электронных ж/д билетов, так и заказ ж/д билетов\n\t\t\t\t\t\t\t\t\t\t\t\t\tна&nbsp;бланке «РЖД».\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>1. Выберите маршрут следования и дату.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t2. На&nbsp;открывшейся после этого странице со&nbsp;списком поездов нажмите на&nbsp;ссылку\n\t\t\t\t\t\t\t\t\t\t\t\t\t<b class="red">«купить»</b> рядом с&nbsp;выбранным поездом. Введите информацию, необходимую\n\t\t\t\t\t\t\t\t\t\t\t\t\tдля оформления билетов.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t3. Оплатите билет на поезд любым удобным способом.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tЭлектронный ж/д билет: кредитной картой, наличными в&nbsp;платежных терминалах, и салонах\n\t\t\t\t\t\t\t\t\t\t\t\t\tЕвросети, наличными в&nbsp;отделениях системы Контакт, со счета мобильного телефона «Билайн»,\n\t\t\t\t\t\t\t\t\t\t\t\t\tWebmoney, Яндекс.Деньгами, по системе Money Mail или RBK-Money. После оплаты получите\n\t\t\t\t\t\t\t\t\t\t\t\t\t14-значный код, который нужно предъявить на&nbsp;вокзале.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tБилет на бланке: с&nbsp;вами по&nbsp;телефону свяжется оператор для уточнения заказа\n\t\t\t\t\t\t\t\t\t\t\t\t\tи&nbsp;условий получения билетов.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\tОформление и&nbsp;продажа осуществляется <b>только в&nbsp;Москве и&nbsp;Санкт-Петербурге</b>.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>4. Продажа ж/д билетов в&nbsp;дальнее зарубежье (за&nbsp;пределы СНГ) не&nbsp;производится.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t',"train.main.eticket_description":"\n\t\t\t\t\t\t\t\t\t\t\t\t<h1>Электронный железнодорожный билет и&nbsp;ж/д билет на&nbsp;бланке&nbsp;РЖД</h1>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\t\tПортал Tutu.ru предлагает вам сделать заказ железнодорожных билетов — электронных или\n\t\t\t\t\t\t\t\t\t\t\t\t\tна бланке &laquo;РЖД&raquo;.\n\t\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<h2>Для оформления заказа:</h2>\n\t\t\t\t\t\t\t\t\t\t\t\t<ol>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите маршрут и дату отправления</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tНа открывшейся странице выберите из списка поездов подходящий вам вариант и нажмите\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t&laquo;купить&raquo; на выбранной строке. Укажите информацию о пассажирах для оформления\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tжд билетов.\n\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tПроизведите оплату соответственно выбранному типу билета.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tОплата электронного билета производится:<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t- наличными (в салонах Евросети и платежных терминалах)<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t- по банковской карте<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t- электронными деньгами систем Яндекс-деньги и Webmoney.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tПосле оплаты вам выдается 14-значный код для предъявления на вокзале. Также вы можете\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tпройти электронную регистрацию на сайте.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tВ случае заказа жд билета на бланке вам позвонит оператор и уточнит условия\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tполучения билетов.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<b>Внимание!</b> Оформление и продажа железнодорожных билетов возможны только в Москве\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tи Санкт-Петербурге.<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<li>Оформление и продажа билетов за пределы СНГ не производится.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t</ol>\n\t\t\t\t\t\t\t\t\t\t\t\t","train.check.can_not_order":"К сожалению на данный поезд уже нельзя сделать заказ билетов.&nbsp;","train.check.no_train":"На выбранный поезд по указанному маршруту в данную дату свободных мест не найдено. Возможно, поезд в эту дату не ходит.&nbsp;","train.check.error":"Произошла внутренняя ошибка. Попробуйте повторить все еще раз. Если ошибка будет повторяться, обратитесь к администратору.&nbsp;","train.check.is_restricted_arrival":"Билеты на данное направление оформляются в специализированных кассах РЖД на вокзале.&nbsp;","train.check.not_check_seats":"Не удалось подтвердить наличие мест. Попробуйте выбрать другой поезд.","train.check.same_departure_arrival_stations":"Пункты отправления и прибытия совпадают. Пожалуйста, выберите разные.","train.order.expired.contacts_spb_Davs":'Телефон службы поддержки: +7&nbsp;(812)&nbsp;493-59-60 <span class="gray">(с 9:00 до 20:00)</span>',"train.order.expired.contacts_moscow_VipService":'Телефон службы поддержки: +7&nbsp;(495)&nbsp;626-41-42 <span class="gray">(круглосуточно)</span>',"train.order.expired.contacts_Travelmart":'Телефон службы поддержки: +7&nbsp;(495)&nbsp;787-01-05 <span class="gray">(с 9:00 до 21:00)</span>',"train.order.expired.contacts_Ufs":'Телефон службы поддержки: +7&nbsp;(495)&nbsp;787-01-05 <span class="gray">(с 9:00 до 21:00)</span>',"train.order.expired.info_docs_text":'Для получения отчетных документов на&nbsp;сервисный сбор, пожалуйста, отправьте нам запрос на&nbsp;почту <a href="mailto:documents@tutu.ru">documents@tutu.ru</a> и&nbsp;укажите номер вашего заказа: <b>%orderNumber%</b>.\n\t\t\t\t\t\t\t\t\t\tВаше письмо будет обработано в&nbsp;течение 5&nbsp;дней.',"train.order.popup_docs.pass_name":"Кому","train.order.popup_docs.pass_where":"Куда","train.order.popup_docs.fio":"ФИО и название организации","train.order.popup_docs.city":"Город","train.order.popup_docs.region":"Область","train.order.popup_docs.exact_address":"Точный адрес","train.order.popup_docs.index":"Индекс места назначения","train.order.popup_docs.send_docs":"Отправить отчетные документы","train.order.payment.contacts.contactInfo":"Оставьте контактную информацию","train.order.payment.contacts.personalInfo":"Персональные данные","train.order.payment.contacts.firstName":"Имя","train.order.payment.contacts.lastName":"Фамилия","train.order.payment.contacts.email":"Электронная почта","train.order.payment.contacts.mobilePhone":"Мобильный телефон","train.order.payment.contacts.comment":"Комментарий к заказу","train.order.payment.contacts.deliveryAddress":"Адрес доставки","train.order.payment.contacts.metroStation":"Станция метро","train.order.payment.contacts.streetName":"Улица","train.order.payment.contacts.houseNumber":"Дом","train.order.payment.contacts.blockNumber":"Блок","train.order.payment.contacts.flatNumber":"Квартира","train.order.payment.contacts.officeNumber":"Офис","train.order.payment.contacts.onlyForCourierDelivery":"Только для билета на бланке РЖД с оплатой курьеру","train.order.payment.contacts.error_name":"Ошибка в имени","train.order.payment.contacts.error_surname":"Ошибка в фамилии","train.order.payment.contacts.error_email":"Ошибка в адресе электронной почты","train.order.payment.contacts.error_mobile":"Ошибка в номере мобильного телефона","train.order.payment.contacts.error_calltime":"Ошибка во времени звонка","train.order.payment.contacts.error_delivery_address":"Ошибка в адресе доставки","train.order.payment.contacts.phone_title":"Телефон для справок:","train.order.payment.contacts.phone_number":"+&nbsp;7&nbsp;<b>(495)&nbsp;787-01-05</b>","train.order.payment.contacts.phone_calltime":"с 9:00 до 21:00","train.order.payment.contacts.phone_title2":"Наш консультант поможет вам купить билет.","train.order.payment.contacts.skype_title":"Звонок на Skype","train.order.payment.contacts.skype_login":"skype.tutu.ru","train.order.payment.contacts.insurance":"Электронная почта и&nbsp;телефон нужны нам для того, чтобы отправить вам информацию о&nbsp;заказе.","train.order.payment.eticket.ticket_title":"Электронный билет","train.order.payment.eticket.rzd_rule":"По правилам РЖД, на оплату заказа отведено 15&nbsp;минут.","train.order.payment.eticket.qiwi_rule":'<p class="qiwi_rule_text">Обратите внимание, что через 15&nbsp;минут резерв снимется.</p>',"train.order.payment.eticket.tip-card":'<p class="small">К оплате принимаются банковские карты, выпущенные в России, странах СНГ и большинстве стран Европы.</p>',"train.order.payment.eticket.tip-card-nourl":'<p class="small">К оплате принимаются банковские карты, выпущенные в России, странах СНГ и большинстве стран Европы.</p>',"train.order.payment.eticket.tip-platron":'<p class="small" >Через 15&nbsp;минут резерв снимется, но данные сохранятся на&nbsp;24&nbsp;часа. При&nbsp;попытке оплаты будет произведено повторное резервирование. Если нужных билетов не&nbsp;окажется, вы не сможете оплатить заказ.</p>\n\t\t\t\t\t\t<p class="small" >Лучше выбрать этот способ, если билетов много. Или успеть оплатить за&nbsp;15&nbsp;минут.</p>\n\t\t\t\t\t\t<a href="%url%" class="small" target="_blank">Подробнее про оплату</a>',"train.order.payment.eticket.tip-osmp":'<p class="small" >Через 15&nbsp;минут резерв снимется, но данные сохранятся на&nbsp;24&nbsp;часа. При&nbsp;попытке оплаты будет произведено повторное резервирование. Если нужных билетов не&nbsp;окажется, вы не сможете оплатить заказ.</p>\n\t\t\t\t\t\t<p class="small" >Лучше выбрать этот способ, если билетов много. Или успеть оплатить за&nbsp;15&nbsp;минут.</p>\n\t\t\t\t\t\t<a href="%url%" class="small" target="_blank">Подробнее про оплату</a>',"train.order.payment.eticket.tip-yandex":"","train.order.payment.eticket.tip-webmoney":"","train.order.payment.eticket.tip-qiwi":'<p class="small">QIWI кошелек позволяет моментально оплатить заказ через ваш интернет-банк, карточкой, денежным переводом и т.п.</p>\n\t\t\t\t\t\t<a href="%url%" class="small" target="_blank">Подробнее</a>',"train.order.payment.blank.ticket_title":"Билет на бланке в","train.order.payment.blank.ticket_title_short":"Билет на бланке","train.order.payment.blank.office_moscow_VipService":'Офис в Москве — в районе метро <a href="%url%" target="_blank">Бауманская</a>.',"train.order.payment.blank.office_spb_Davs":'Офис в Санкт-Петербурге — у метро <a href="%url%" target="_blank">Василеостровская</a>.',"train.order.payment.blank.tip-moscow-VipService":'<p>Билет оформляется только после разговора с&nbsp;оператором.</p>\n\t\t\t\t\t\t\t\t\t<p class="small">При заказе билета на&nbsp;бланке места не&nbsp;бронируются, но&nbsp;учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t<p class="small">Он свяжется с&nbsp;вами в&nbsp;течение 1&nbsp;часа после оформления заказа на&nbsp;сайте.</p>\n\t\t\t\t\t\t\t\t\t<a href="%url%" class="small" target="_blank">Подробнее про оплату</a>',"train.order.payment.blank.tip-spb-Davs":'<p>Билет оформляется только после разговора с&nbsp;оператором.</p>\n\t\t\t\t\t\t\t\t\t<p class="small">При заказе билета на&nbsp;бланке места не&nbsp;бронируются, но&nbsp;учитываются оператором как пожелание.</p>\n\t\t\t\t\t\t\t\t\t<p class="small">Он свяжется с&nbsp;вами в&nbsp;течение 1&nbsp;часа после оформления заказа на&nbsp;сайте.</p>\n\t\t\t\t\t\t\t\t\t<p class="small">Операторы работают с&nbsp;9:00 до&nbsp;20:00, без&nbsp;выходных.</p>\n\t\t\t\t\t\t\t\t\t<a href="%url%" class="small" target="_blank">Подробнее про&nbsp;оплату</a>',"train.order.payment.blank.blankError":'Вы можете выбрать билеты на <a class="pseudoBlue" href="javascript: void(0)" rel="calendarTriggernavigation-dateanotherdatechoose"  onclick="ShowCalendarAnother(\'choose_another_date\');" id="choose_another_date">другую дату</a>, или <a class="pseudoBlue" href="%aviaUrl%">заказать авиабилеты</a>.',"train.order.payment.blank.blankErrorNoAvia":'Вы можете выбрать билеты на <a class="pseudoBlue" href="javascript: void(0)" rel="calendarTriggernavigation-dateanotherdatechoose"  onclick="ShowCalendarAnother(\'choose_another_date\');" id="choose_another_date">другую дату</a>.',"train.order.payment.blank.hint-moscow1-spb1":"Доставка курьером по Москве и Санкт-Петербургу на дом и в офис, либо cамовывоз из офиса Туту.ру.","train.order.payment.blank.hint-moscow0-spb1":"Доставка курьером по Санкт-Петербургу на дом и в офис, либо cамовывоз из офиса Туту.ру.","train.order.payment.blank.hint-moscow1-spb0":"Доставка курьером по Москве на дом и в офис, либо cамовывоз из офиса Туту.ру.","train.order.payment.blank.hint-moscow0-spb0":"","train.order.payment.blank.hint-moscow1-spb2":'Самовывоз из офисов Туту.ру в Москве <span class="red">или</span> Санкт-Петербурге.<br/> Доставка курьером возможна только по Москве.',"train.order.payment.blank.hint-moscow0-spb2":"Самовывоз из офиса Туту.ру в Санкт-Петербурге.","train.order.weekdays.1_from":"понедельника","train.order.weekdays.2_from":"вторника","train.order.weekdays.3_from":"среды","train.order.weekdays.4_from":"четверга","train.order.weekdays.5_from":"пятницы","train.order.weekdays.6_from":"субботы","train.order.weekdays.7_from":"воскресенья","train.order.weekdays.1_to":"понедельник","train.order.weekdays.2_to":"вторник","train.order.weekdays.3_to":"среду","train.order.weekdays.4_to":"четверг","train.order.weekdays.5_to":"пятницу","train.order.weekdays.6_to":"субботу","train.order.weekdays.7_to":"воскресенье","train.order.weekdays.night_common":"(в ночь с %from% на %to%)","train.order.weekdays.night_wednesday":"(в ночь со %from% на %to%)","train.order.payment.onlineGroupTitle":"Оплата онлайн","train.order.payment.cashGroupTitle":"","train.order.payment.onlyRussia":'По правилам РЖД, получение<br/>электронных билетов возможно <span class="red">только на территории России</span>',"train.order.payment.paymentLimit_old":"Бронь действительна 15 минут. Пожалуйста, постарайтесь оплатить заказ за это время.","train.order.payment.paymentLimit":"Резерв действителен 15 минут. Пожалуйста, постарайтесь оплатить заказ за это время. Места выкупаются сразу, в момент оплаты.","train.order.payment.orderAndPayment_old":"Получить билеты можно только в ","train.order.payment.orderAndPaymentEnd_old":"Выберите город в заголовке.","train.order.payment.orderAndPayment":"Оформление билетов происходит в ","train.order.payment.orderAndPaymentEnd":" после звонка оператора. Выберите город в заголовке.","train.order.payment.foreignWarningTitle":"Электронный билет можно получить только в России","train.order.payment.foreignWarningTextNoEreg":"<p>По правилам РЖД, получение электронных билетов возможно только на территории России. \n\t\t\t\t\tЭлектронная регистрация на данный поезд невозможна.</p>","train.order.payment.foreignWarningTextWithEreg":"<p>По правилам РЖД, получение электронных билетов возможно только на территории России. \n\t\t\t\t\tДля данного поезда доступна электронная регистрация.</p>","train.order.payment.paymentFailure_ufs":"К&nbsp;сожалению, платежный&nbsp;сервис не&nbsp;разрешил транзакцию. Попробуйте ввести номер&nbsp;карты еще&nbsp;раз.<br/>\n\t\tВы также можете оплатить заказ другой картой или другим способом.","train.order.payment.paymentFailure_travelmart":"","train.order.payment.backFromFinal":"Заказ отменен. Места опять доступны для бронирования. Вы можете попробовать зарезервировать их еще раз, выбрать другой способ оплаты или другие места.","train.order.payment.paymentWarningApproximatePrice":"<b>Для поездов из Украины</b> информация о стоимости может быть неточной.<br/>Выберите способ оплаты и мы сообщим вам точную стоимость на следующем шаге.<br/>Если итоговая цена вас не устроит, вы всегда сможете вернуться на этот шаг.","train.order.payment.blank_ukrain_no_price":"В связи с особенностью украинской системы бронирования, сейчас для вашего заказа доступен только электронный билет.","train.order.payment.smsQiwiTerminal":"Zakaz sformirovan, summa %amount% rub. V terminale QIWI v razdele QIWI-koshelek oplatite aktivacionnyi platezh 5 rub i dozhdites scheta na polnuju summu zakaza. Tel. +7(495)787-01-05.","train.order.payment.smsOtherTerminal":'Zakaz sformirovan, summa %amount% rub. Pri oplate v Evroseti skazhite "ZAKAZ PLATRON CHEREZ F2". V Svyaznom "ZAKAZ INTERNET-MAGAZINA (ROBOKASSA)". Tel. +7(495)787-01-05.',"train.order.payment.smsOtherTerminalNumber":'Zakaz sformirovan, summa %amount% rub. Pri oplate v Evroseti skazhite "ZAKAZ PLATRON CHEREZ F2". V Svyaznom "ZAKAZ INTERNET-MAGAZINA (ROBOKASSA)". Tel. +7(495)787-01-05.',"train.order.payment.smsCheckFailed":"K sozhaleniju, podtverzhdenie zakaza ne udalos'. Poprobujte oformit' novyj zakaz. Tel. +7(495)787-01-05.","train.order.payment.smsQiwiCheckSucceed":"Aktivacionnyi platezh po zakazu uspeshno prinyat. Cherez neskol'ko minut budet vystavlen schet na polnuyu summu zakaza. Dozhdites' i oplatite ego! Tel. +7(495)787-01-05.","train.order.car_notice.common":"Чтобы выбрать это место, пожалуйста, снимите ограничения выше.\n\t\t\t\t\t\t\t\t\t\t\tРазрешите выбор любых мест, в том числе: ","train.order.car_notice.acmdSeats":"верхних и нижних","train.order.car_notice.acmdCoupe":"мест в разных купе","train.order.car_notice.acmdAllCoupe":"мест в разных купе или измените соотношение верхних/нижних","train.order.car_notice.acmdPlazcoupe":"боковых","train.order.car_notice.acmdPlazsection":"мест в разных секциях плацкарта","train.order.car_notice.nearWC":"у туалета","train.order.car_notice.sequence":"По правилам системы бронирования, номера выбранных вами свободных мест должны идти подряд.<br/>\n\t\t\t\t\t\t\t\t\t\t\tНапример, если в вагон еще не было продано ни одного билета, вы не сможете выбрать сразу 1 и 5 место.","train.order.car_notice.sex":"В вагоне с мужскими/женскими купе нельзя выбрать места для разных полов одновременно","train.order.car_notice.no_map":"В поездах из Украины места распределяются автоматически, самостоятельный выбор невозможен.","train.order.error.pageTitle":"Ошибка","train.order.error.pageText":'К сожалению, нашей системе не удалось получить нужные данные от сервис-провайдера.\n\t\t\t\t\t\t\t\t\t\t\tПожалуйста, <a href="%link%">повторите запрос</a> еще раз.\n\t\t\t\t\t\t\t\t\t\t\tЕсли ошибка не исчезает, пожалуйста, <a href="%reportLink%">сообщите</a> об этом нам.',"train.order.error.unsuccess_page_title":"Билеты не оформлены","train.order.error.unsuccess_title":"К сожалению, билеты не оформлены","train.order.error.unsuccess_text_travelmart":'<p class="warning_ico" >По правилам РЖД, заказ необходимо было оплатить в течение 15 минут. К сожалению, указанный интервал оказался превышен.</p>\n\t\t<p>Платежной системой с вашей карточки было снято %price%, но система бронирования к тому времени уже отменила ваш заказ как устаревший.</p>\n\t\t<p class="roundPink round" >Сумма %price% будет возвращена на вашу карточку в течение 2-3 дней.</p>\n\t\t<div class="both"><!--  --></div>\n\t\t<p>В зависимости от конкретного банка период возврата может составить до одного месяца.</p>\n\t\t<p>Телефон для справок: +7 (495) 787-01-05 (с 9:00 до 21:00).<br>Приносим извинения за возникшие неудобства.</p>',"train.order.error.fullError":'<p>К сожалению, продажа билетов на выбранный поезд недоступна.</p>\n\t\t\t\t\t\t\t<p>Вы можете <a href="%url%">заказать авиабилеты</a>.<br />Либо попробовать повторить заказ позже.</p>',"train.order.error.fullErrorNoAvia":"<p>К сожалению, продажа билетов на выбранный поезд недоступна.</p>\n\t\t\t\t\t\t\t<p>Пожалуйста, повторите заказ позже.</p>","train.order.error.fail_title_brauser":"Не удалось выписать билет","train.order.error.title_auto_confirm_failed":"Отправляется запрос на&nbsp;выписку билета","train.order.error.title_auto_confirm_failed-sv":"Билет пока не выписан. Пожалуйста, не уходите с этой страницы и дождитесь завершения заказа!","train.order.error.auto_confirm_failed":'<p><b>Пожалуйста, не&nbsp;уходите с&nbsp;этой страницы и&nbsp;дождитесь завершения заказа!</b></p>\n\t\t\t\t\t\t\t\t\t\t<p>Система резервирования мест временно не&nbsp;отвечает, поэтому мы&nbsp;продолжаем отправку повторных запросов. \n\t\t\t\t\t\t\t\t\t\tЭто может занять ещё несколько минут.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Как только обработка заказа будет завершена, эта страница автоматически обновится и&nbsp;вы&nbsp;увидите на&nbsp;экране сообщение о&nbsp;результате.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Если в&nbsp;течение 15&nbsp;минут статус заказа не&nbsp;изменится, пожалуйста, позвоните нам по&nbsp;телефону <span class="nowrap">+7 (495) 787-01-05</span>.</p>\n\t\t\t\t\t\t\t\t\t\t<p>Операторы работают ежедневно <span class="nowrap">с 9:00 до 21:00</span>.</p>',"train.order.error.title_manual_confirm_failed":"К сожалению, выписать билеты не удалось","train.order.error.manual_confirm_failed":"<p>Возможно, с момента создания бронирования прошло более 15 минут или система бронирования ответила ошибкой.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Пожалуйста, позвоните нам по телефону +7 (495) 787-01-05. Операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Возможно, билеты ещё удастся оформить при ручной обработке заказа оператором.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Приносим извинения.</p>","train.order.error.title_manual_unblock_failed":"К сожалению, выписать билеты не удалось","train.order.error.manual_unblock_failed":"<p>Возможно, с момента создания бронирования прошло более 15 минут или система бронирования ответила ошибкой.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>В ближайшее время с вами свяжется оператор. Наши операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Приносим свои извинения, мы приложим все силы, чтобы ваши деньги вернулись как можно быстрее.</p>","train.order.error.title_ticket_failed":"К сожалению, выписать билет не удалось. ","train.order.error.ticket_failed":'<p>Возможно, потеряна связь с системой резервирования мест.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Деньги должны остаться на вашем счете. Вы можете уточнить это, проверив баланс средств на карте.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Иногда, из-за особенностей проведения платежей, сумма может быть зарезервирована банком и временно недоступна.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Как правило, банки не присылают SMS о разблокировании средств, \n\t\t\t\t\t\t\t\t\t\t\tпоэтому информацию о состоянии счета нужно будет уточнять в банке дополнительно.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Другие вопросы можно задать специалистам контакт-центра Туту.ру по телефону +7 (495) 787-01-05. \n\t\t\t\t\t\t\t\t\t\t\tОператоры работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Приносим извинения, пожалуйста, попробуйте сделать повторный <a href="%link%">заказ</a>.</p>',"train.order.error.title_manual_ticket_failed":"К сожалению, выписать билеты не удалось.","train.order.error.manual_ticket_failed":'<p>Возможно, с момента создания бронирования прошло более 15 минут или система бронирования ответила ошибкой.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Перед попыткой выписать билеты сумма заказа на вашем счету была временно заблокирована, но не списана. \n\t\t\t\t\t\t\t\t\t\t\tСейчас в банк отправлен запрос на ее разблокировку.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Как правило, разблокирование средств проходит в течение часа. Но при этом банки обычно не отправляют SMS, \n\t\t\t\t\t\t\t\t\t\t\tпоэтому информацию о состоянии счета нужно будет уточнять в вашем банке дополнительно.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Другие вопросы можно задать специалистам контакт-центра Туту.ру по телефону +7 (495) 787-01-05.<br />\n\t\t\t\t\t\t\t\t\t\t\tОператоры работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Приносим извинения, пожалуйста, попробуйте сделать повторный <a href="%link%">заказ</a>.</p>',"train.order.error.title_manual_payment_canceled":"К сожалению, выписать билет не удалось. ","train.order.error.manual_payment_canceled":'<p>Возможно, потеряна связь с системой резервирования мест.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Деньги должны остаться на вашем счете. Вы можете уточнить это, проверив баланс средств на карте.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Иногда, из-за особенностей проведения платежей, сумма может быть зарезервирована банком и временно недоступна.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Как правило, банки не присылают SMS о разблокировании средств, \n\t\t\t\t\t\t\t\t\t\t\tпоэтому информацию о состоянии счета нужно будет уточнять в банке дополнительно.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Другие вопросы можно задать специалистам контакт-центра Туту.ру по телефону +7 (495) 787-01-05. \n\t\t\t\t\t\t\t\t\t\t\tОператоры работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Приносим извинения, пожалуйста, попробуйте сделать повторный <a href="%link%">заказ</a>.</p>',"train.order.error.title_manual_authorized_not_ticketed":"К сожалению, выписать билеты не удалось","train.order.error.manual_authorized_not_ticketed":"<p>При обработке вашего заказа произошла ошибка.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>В ближайшее время с вами свяжется оператор. Наши операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Приносим свои извинения, мы приложим все силы, чтобы ваши деньги вернулись как можно быстрее.</p>","train.order.error.title_manual_need_refund":"Заказ аннулирован.","train.order.error.manual_need_refund":'<p>Вы сделали запрос на возврат средств. Деньги будут зачислены на вашу банковскую карту.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>К сожалению, Туту.ру не может повлиять на сроки возврата. Вы можете обратиться в справочную службу вашего банка за дополнительной информацией.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Для того, чтобы сделать новый заказ, перейдите на страницу выбора <a href="%link%">поезда</a>.</p>',"train.order.error.title_manual_authorized_sum_mismatch":"К сожалению, выписать билеты не удалось","train.order.error.manual_authorized_sum_mismatch":"<p>При обработке вашего заказа произошла ошибка.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p>В ближайшее время с вами свяжется оператор. Наши операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Приносим свои извинения, мы приложим все силы, чтобы ваши деньги вернулись как можно быстрее.</p>","train.order.error.title_manual_processing_timeout":"Возникли сложности при обработке заказа","train.order.error.manual_processing_timeout":"<p>При обработке вашего заказа что-то пошло не так.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Пожалуйста, свяжитесь с нами, чтобы уточнить, удалось ли выписать ваш билет и принят ли платеж.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05. Операторы работают ежедневно с 9:00 до 21:00.</p>","train.order.error.title_manual_payment_price_differ":"К сожалению, выписать билеты не удалось","train.order.error.manual_payment_price_differ":"<p>При обработке вашего заказа произошла ошибка.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>В ближайшее время с вами свяжется оператор. Наши операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Приносим свои извинения.</p>","train.order.error.title_manual_stop_list":"Билет пока не выписан","train.order.error.manual_stop_list":"<p>Для выписки билетов по вашему заказу номер %orderId% требуется участие оператора.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>В ближайшее время мы с вами свяжемся. Наши операторы работают ежедневно с 9:00 до 21:00.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05.</p>","train.order.error.title_unknown_error":"Возникли сложности при обработке заказа","train.order.error.unknown_error":"<p>При обработке вашего заказа что-то пошло не так.</p>\n\t\t\t\t\t\t\t\t<p>Пожалуйста, свяжитесь с нами, чтобы уточнить, удалось ли выписать ваш билет и принят ли платеж.</p>\n\t\t\t\t\t\t\t\t<p>Телефон контакт-центра Туту.ру +7 (495) 787-01-05. Операторы работают ежедневно с 9:00 до 21:00.</p>","train.order.error.price_to_match_for_this_paysystem":"Электронный билет на сумму свыше 15&nbsp;000 руб. можно оплатить только банковской картой.","train.order.success.cashTitle":"Заказ успешно совершен, Вам выставлен счет на оплату!","train.order.success.blankTitle":"Поздравляем с успешным заказом","train.order.success.blankTitlePage":"Поздравляем с успешным заказом билетов <strong>%departureStation% &rarr; %arrivalStation%</strong>","train.order.success.spbText":'<p style="margin-top: 15px;">\n\t\t\t\t\t\t\t\t\t%backTicketUrl%\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\tВаш заказ ж/д билетов с получением <span class="red">в Санкт-Петербурге</span> поступил в обработку.\n\t\t\t\t\t\t\t\t\tНаш сотрудник свяжется с вами в ближайшее время для уточнения деталей и оформления заказа.\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<div style="font-size: 1.5em;margin:30px 0">\n\t\t\t\t\t\t\t\t\t<div class="b-pling">\n\t\t\t\t\t\t\t\t\t\tПожалуйста,\n\t\t\t\t\t\t\t\t\t\tсохраните номер заказа\n\t\t\t\t\t\t\t\t\t\tили распечатайте\n\t\t\t\t\t\t\t\t\t\tбланк.\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t\t<b>Заказ №%orderNumber% <span class="nowrap">от %dateOrder% г.</span></b>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\tНаши операторы работают с понедельника по пятницу с 10:00 до 19:00, в субботу-воскресенье с 10:00 до 16:30.\n\t\t\t\t\t\t\t\t\tЗаявки на сайте принимаются круглосуточно.\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<div class="info-ico" style="margin-top: 17px">\n\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\tЕсли в течение 1 часа вам не перезвонили, то для уточнения статуса заявки вы можете позвонить по телефону\n\t\t\t\t\t\t\t\t\t\t(812) 380-56-00 (наш партнер в Санкт-Петербурге, ООО "ВИП Сервис Корпорейтед"). При этом сообщите номер заказа,\n\t\t\t\t\t\t\t\t\t\tа также что вы делали заказ ж/д билетов на сайте Tutu.ru — это поможет быстрее найти заявку.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-top: 17px">Если вы выбрали вариант без доставки, то для получения билетов вы можете обратиться в наш офис по этому адресу:</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-left: 33px; margin-top: 17px">\n\t\t\t\t\t\t\t\t\t\t<span style="font-style: italic">ул. Киевская, дом 6</span>.\n\t\t\t\t\t\t\t\t\t\t<br />Телефон: +7 (812) 380-56-00 (с 10:00 до 16:30).\n\t\t\t\t\t\t\t\t\t\t<br ><a href="%addressUrl%" style="line-height: 2em">Как проехать</a>\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<p style="margin-top: 22px;">\n\t\t\t\t\t\t\t\t\tБлагодарим вас за то, что вы воспользовались нашей услугой заказа билетов.<br/>\n\t\t\t\t\t\t\t\t\tМы всегда рады видеть вас в числе посетителей Туту.ру.\n\t\t\t\t\t\t\t\t</p>',"train.order.success.spbDavsText":'<p style="margin-top: 15px;">\n\t\t\t\t\t\t\t\t\t%backTicketUrl%\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\tВаш заказ ж/д билетов с получением <span class="red">в Санкт-Петербурге</span> поступил в обработку.\n\t\t\t\t\t\t\t\t\tНаш сотрудник свяжется с вами в ближайшее время для уточнения деталей и оформления заказа.\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<div style="font-size: 1.5em;margin:30px 0">\n\t\t\t\t\t\t\t\t\t<div class="b-pling">\n\t\t\t\t\t\t\t\t\t\tПожалуйста,\n\t\t\t\t\t\t\t\t\t\tсохраните номер заказа\n\t\t\t\t\t\t\t\t\t\tили распечатайте\n\t\t\t\t\t\t\t\t\t\tбланк.\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t\t<b>Заказ №%orderNumber% <span class="nowrap">от %dateOrder% г.</span></b>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\tНаши операторы работают с 9:00 до 20:00 без выходных.\n\t\t\t\t\t\t\t\t\tЗаявки на сайте принимаются круглосуточно.\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<div class="info-ico" style="margin-top: 17px">\n\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\tЕсли в течение 1 часа вам не перезвонили, то для уточнения статуса заявки вы можете позвонить по телефону\n\t\t\t\t\t\t\t\t\t\t(812) 493-59-60 (наш партнер в Санкт-Петербурге, ЗАО "Агентство ДАВС"). При этом сообщите номер заказа,\n\t\t\t\t\t\t\t\t\t\tа также что вы делали заказ ж/д билетов на сайте Tutu.ru — это поможет быстрее найти заявку.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-top: 17px">Если вы выбрали вариант без доставки, то для получения билетов вы можете обратиться в наш офис по адресу:</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-left: 33px; margin-top: 17px">\n\t\t\t\t\t\t\t\t\t\t<span style="font-style: italic">9-я Линия Васильевского Острова, д. 34, офис 101</span>.\n\t\t\t\t\t\t\t\t\t\t<br />Телефон: +7 (812) 493-59-60 (с 9:00 до 20:00).\n\t\t\t\t\t\t\t\t\t\t<br ><a href="%addressUrl%" style="line-height: 2em">Как проехать</a>\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<p style="margin-top: 22px;">\n\t\t\t\t\t\t\t\t\tБлагодарим вас за то, что вы воспользовались нашей услугой заказа билетов.<br/>\n\t\t\t\t\t\t\t\t\tМы всегда рады видеть вас в числе посетителей Туту.ру.\n\t\t\t\t\t\t\t\t</p>',"train.order.success.moscowText":'<p style="margin-top: 15px;">\n\t\t\t\t\t\t\t\t\t%backTicketUrl%\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\tВаш заказ ж/д билетов с получением <span class="red">в Москве</span> оформлен.\n\t\t\t\t\t\t\t\t\tНаш сотрудник свяжется с вами в ближайшее время для подтверждения заказа и уточнения деталей.\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<div style="font-size: 1.5em;margin:30px 0">\n\t\t\t\t\t\t\t\t\t<div class="b-pling">\n\t\t\t\t\t\t\t\t\t\tПожалуйста,\n\t\t\t\t\t\t\t\t\t\tсохраните номер заказа\n\t\t\t\t\t\t\t\t\t\tили распечатайте\n\t\t\t\t\t\t\t\t\t\tбланк.\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t\t<b>Заказ №%orderNumber% <span class="nowrap">от %dateOrder% г.</span></b>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<div class="info-ico">\n\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\tЕсли в течение 1 часа вам не перезвонили,\n\t\t\t\t\t\t\t\t\t\tто для уточнения статуса заявки вы можете позвонить по телефону (495) 626-41-42\n\t\t\t\t\t\t\t\t\t\t(наш партнер в Москве, ООО «АвиаБизнесКорпорэйт»). При этом сообщите номер заказа,\n\t\t\t\t\t\t\t\t\t\tа также что вы делали заказ ж/д билетов на сайте Tutu.ru — это поможет быстрее найти заявку.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-top: 17px">Если вы выбрали вариант без доставки, то для получения билетов вы можете обратиться в наш офис по этому адресу:</p>\n\t\t\t\t\t\t\t\t\t<p style="margin-left: 33px; margin-top: 17px">\n\t\t\t\t\t\t\t\t\t\t<span style="font-style: italic">Переведеновский пер., д.17, кор. 1</span> (с 8:00 до 19:30).\n\t\t\t\t\t\t\t\t\t\t<br />Телефон: +7 (495) 626-41-42, круглосуточно.\n\t\t\t\t\t\t\t\t\t\t<br ><a href="%addressUrl%" style="line-height: 2em">Как проехать</a>\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t\t<p style="margin-top: 22px;">\n\t\t\t\t\t\t\t\t\tБлагодарим вас за то, что вы воспользовались нашей услугой заказа билетов.<br/>\n\t\t\t\t\t\t\t\t\tМы всегда рады видеть вас в числе посетителей Туту.ру.\n\t\t\t\t\t\t\t\t</p>',"train.order.success.successPaidTitleThanks":"Спасибо за покупку билетов на Туту.ру!","train.order.success.successPaidTitle":"Поздравляем с успешной покупкой билетов","train.order.success.successPaidTextTitle":"Поздравляем с успешной покупкой!","train.order.success.successTitle":"Поздравляем с успешным заказом билетов","train.order.success.successTextTitle":"Поздравляем с успешным заказом!","train.order.success.errorTitle":"Некорректное завершение заказа","train.order.success.taxi_from_railway":"Заказать такси с вокзала в Москве","train.order.success.taxi_to_railway":"Заказать такси на вокзал в Москве","train.order.success.backTicketUrlTitle":"Заказать обратные билеты","train.order.success.actionGotBlank":"<h2>Вы получили бланк билета на станции.</h2> <p>Теперь вы можете сесть в поезд, предъявив билет и удостоверение личности.</p>","train.order.success.actionNeedBlank":'<strong>Для посадки в поезд</strong> вам <span class="red">необходимо получить билет на&nbsp;бланке</span> на&nbsp;станции: в&nbsp;кассе или&nbsp;терминалах регистрации.',"train.order.success.actionNeedBlankForeign":'<p>Ваша станция отправления находится не&nbsp;на&nbsp;территории России, поэтому на&nbsp;ней вы не&nbsp;сможете получить бланк электронного билета!\n\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t<p><strong>Для посадки в&nbsp;поезд</strong> вам <span class="red">необходимо заранее получить билет</span> на&nbsp;бланке на&nbsp;станции <span class="red">на&nbsp;территории России!</span>\n\t\t\t\t\t\t\t\t</p>',"train.order.success.actionLessHourEregDone":"<strong>Вы прошли электронную регистрацию</strong> и теперь можете сесть в поезд, предъявив только удостоверение личности. Также рекомендуем распечатать посадочный купон.","train.order.success.actionLessHourEregNotdone":'<strong>Для посадки в поезд</strong> вам <span class="red">необходимо получить билет</span> на станции: в кассе или терминалах регистрации.\n\t\tДля получения билета вам понадобится удостоверение личности и 14-значный номер заказа (<em>%orderNumber%</em>). Также рекомендуем распечатать <a class="pseudoBlue" href="#blank" id="linktoblank">контрольный купон</a>.',"train.order.success.actionCriticalError":'<span class="red"><strong>Ошибка связи с системой!</strong></span> Приносим извинения, при проверке статуса электронной регистрации по вашему заказу произошла ошибка.\n\t\tСообщение об этом уже отправлено разработчикам. Для уточнения информации вы можете обратиться в службу поддержки по телефону %supportPhone%.',"train.order.success.actionTryAgain":"<strong>Ошибка связи с системой!</strong> К&nbsp;сожалению, система&nbsp;бронирования&nbsp;РЖД не&nbsp;ответила на&nbsp;наш&nbsp;запрос. Попробуйте обновить эту&nbsp;страницу позднее, либо свяжитесь со&nbsp;службой&nbsp;поддержки по&nbsp;телефону&nbsp;%supportPhone%.","train.order.success.actionListTitle":"<strong>Для посадки в поезд</strong> вам необходимо совершить одно из&nbsp;двух действий на&nbsp;выбор:","train.order.success.actionListTitleNotPaid":"<strong>Для посадки в поезд</strong> вам необходимо <strong>оплатить билет</strong> и затем совершить одно из&nbsp;двух действий на&nbsp;выбор:","train.order.success.actionList":"<strong>Для посадки в поезд</strong> с полученным 14-значным кодом (<em>%orderNumber%</em>) и&nbsp;удостоверением личности вам необходимо совершить одно из&nbsp;трех действий на&nbsp;выбор:","train.order.success.actionListWithoutReg":"<strong>Для посадки в поезд</strong> с полученным 14-значным кодом (<em>%orderNumber%</em>) и&nbsp;удостоверением личности вам необходимо совершить одно из&nbsp;действий на&nbsp;выбор.","train.order.success.actionNeedDocs":'Для получения билета вам понадобится удостоверение личности и&nbsp;14-значный номер заказа (<em>%orderNumber%</em>).\n\t\t\t\t\t\t\t\tТакже рекомендуем распечатать <a class="pseudoBlue" href="#blank" id="linktoblank">контрольный купон</a>.',"train.order.success.action1":"Получить билет на&nbsp;бланке на&nbsp;вокзале: в&nbsp;кассе или&nbsp;терминалах регистрации.","train.order.success.action2":'Пройти электронную регистрацию. Сейчас она <span class="red">не&nbsp;пройдена</span>;',"train.order.success.action3":'Получить билет на бланке в <a href="%link%" target="_blank">терминалах регистрации</a> перед посадкой в&nbsp;поезд.',"train.order.success.action4":'Пройти электронную регистрацию. <span class="red">Уточните текущий статус</span> электронной регистрации в&nbsp;<a class="pseudoBlue" href="#blank" id="linktoblank">бланке заказа</a>;',"train.order.success.action_ereg_done":'<p>Вы прошли электронную регистрацию и&nbsp;теперь можете сесть в&nbsp;поезд, предъявив только удостоверение личности. Также рекомендуем распечатать <a class="pseudoBlue" href="#blank" id="linktoblank">посадочный купон</a>.</p>\n\t\t\t\t\t\t\t\t<p>Если вам потребуется бланк билета, например, для отчета перед бухгалтерией, то&nbsp;вы можете отменить электронную регистрацию \n\t\t\t\t\t\t\t\t(не&nbsp;позднее, чем за&nbsp;час до&nbsp;отправления поезда с&nbsp;начальной станции) и&nbsp;получить билет на&nbsp;бланке в&nbsp;кассе или специальном терминале на&nbsp;вокзале.\n\t\t\t\t\t\t\t\t</p>',"train.order.success.inTrainUrlTitle":"Подробнее про посадку в поезд","train.order.success.orderState":"Статус заказа:","train.order.success.eregState":"Электронная регистрация:","train.order.success.eregStateClear":"Электронная регистрация","train.order.success.eregNo":"Невозможна.","train.order.success.eregNolow":"недоступна","train.order.success.eregOn":"Электронная регистрация по этому заказу пройдена.","train.order.success.eregOff":"Не пройдена.","train.order.success.eregOfflow":"не пройдена","train.order.success.eregOnlow":"пройдена","train.order.success.eregError":"Электронная регистрация по выбранному маршруту на этот поезд недоступна.","train.order.success.eregImpossible":"На этот заказ уже выдан билет на бланке. По правилам РЖД, нельзя оформить электронную регистрацию на билеты на бланке.","train.order.success.eregImpossibleAlready":'Изменение статуса электронной регистрации уже невозможно. Это значит, что&nbsp;либо вы уже получили бланк билета, либо до&nbsp;отправления поезда с&nbsp;начальной станции осталось меньше 1&nbsp;часа. Уточнить, пройдена&nbsp;ли электронная регистрация, вы можете в&nbsp;<a class="pseudoBlue" href="#blank" id="linktoblank">бланке заказа</a>.',"train.order.success.eregErrorOn":"К сожалению, мы не получили ответ от системы бронирования на запрос прохождения электронной регистрации. Для уточнения текущего статуса электронной регистрации или повтора запроса попробуйте обновить эту страницу чуть позже.","train.order.success.eregErrorOff":"К сожалению, мы не получили ответ от системы бронирования на запрос отмены электронной регистрации. Для уточнения текущего статуса электронной регистрации или повтора запроса попробуйте обновить эту страницу чуть позже.","train.order.success.eregErrorRefresh":"К сожалению, мы не получили ответ от системы бронирования на запрос статуса электронной регистрации. Для уточнения текущего статуса электронной регистрации или повтора запроса попробуйте обновить эту страницу чуть позже.","train.order.success.lessHourEregImpossible":"До отправления поезда с начальной станции осталось меньше 1&nbsp;часа, поэтому изменение статуса электронной регистрации уже невозможно.","train.order.success.navy_title":"Успешная покупка","train.order.success.order_paid":"оплачен","train.order.success.order_overdue":"просрочен","train.order.success.order_notpaid":"ожидает оплаты","train.order.success.order_canceled":"отменен","train.order.success.order_notprocessed":"необработан","train.order.success.order_processed":"ожидает оплаты","train.order.success.order_deleted":"удален","train.order.success.order_failed":"ошибка","train.order.success.order_created":"необработан","train.order.success.order_error":"ошибка","train.order.success.contacts":'Телефон службы поддержки: %supportPhone% <span class="gray">(с 9:00 до 21:00)</span>',"train.order.success.orderBlank":"Бланк заказа","train.order.success.noBlank":"Бланк заказа отсутствует","train.order.success.printOrderBlank":"Напечатать бланк заказа","train.order.success.orderTitle":"Заказ","train.order.success.orderDate":"от","train.order.success.getATicketUrlTitle":"Как получить билет?","train.order.success.aboutEregUrlTitle":"Что такое электронная регистрация?","train.order.success.aboutEregUrlTitleMore":"Подробнее про электронную регистрацию","train.order.success.cashText":"<p>Выбранные места гарантированы в течение 15 минут с момента заказа. В этот период никто другой не сможет их выкупить.</p>\n\t\t\t\t\t\t\t\t<p>Заказ можно будет оплатить и позже (в течение 24 часов, но не позднее, чем за два часа до отправления поезда), \n\t\t\t\t\t\t\t\tно только если к моменту оплаты выбранные места не будут выкуплены другими пассажирами.</p>\n\t\t\t\t\t\t\t\t<p>Обращаем Ваше внимание, что через 15 минут места, указанные в заказе, станут доступны другим покупателям.</p>\n\t\t\t\t\t\t\t\t<p>Для оплаты наличными в любой точке используйте Ваш номер телефона,\n\t\t\t\t\t\t\t\tуказанный при заказе.</p>","train.order.success.cashNotice":"Если билетов на выбранные места в момент оплаты не будет, покупка не удастся.<br/>\n\t\t\t\t\t\t\t\tВыбранным вами способом лучше платить тогда, когда билетов на нужный поезд много.\n\t\t\t\t\t\t\t\tИли нужно успеть оплатить заказ в течение 15 минут.","train.order.success.cashInstruction":"","train.order.success.cashActionList":"После оплаты вы получите по СМС и электронной почте  специальный 14-значный код.\n\t\t\t\t\t\t\t\tС&nbsp;этим кодом и&nbsp;удостоверяющим личность документом вы&nbsp;можете совершить одно из&nbsp;двух действий на&nbsp;выбор:","train.order.success.cashActionListNoEreg":'После оплаты вы получите по СМС и электронной почте специальный 14-значный код.\n\t\t\t\t\t\t\t\tС&nbsp;этим кодом и&nbsp;удостоверяющим личность документом вам&nbsp;необходимо получить билет на&nbsp;бланке на&nbsp;вокзале –\n\t\t\t\t\t\t\t\tв&nbsp;кассе или <a href="%ttsLink%" target="_blank">терминале самообслуживания</a>',"train.order.success.mobile":'Оплатите выставленный вам счет в течение 15 минут с помощью\n\t\t\t\t\t\t\t\tЛичного кабинета QIWI на сайте <a href="www.qiwi.ru" target="_blank">www.qiwi.ru</a>\n\t\t\t\t\t\t\t\tили приложения в телефоне "Мобильный кошелек"',"train.order.success.qiwiText":'Для оплаты через интернет или наличными в любой точке используйте Ваш номер телефона,\n\t\t\t\t\t\t\t\tуказанный при заказе.\n\t\t\t\t\t\t\t\tВозможна оплата со счета банковской карты в банкоматах или через интернет-сервис Qiwi.\n\t\t\t\t\t\t\t\tСуммы свыше 15 000 руб. принимаются только в \n\t\t\t\t\t\t\t\t<a href="%bankomatsLink%" target="_blank">банкоматах</a>.',"train.order.success.contacts_blank":"Служба поддержки: %supportPhone% (с 9:00 до 21:00)","train.order.success.contacts_blank_title":"Служба поддержки: +7 (495) 787-01-05 (с 9:00 до 21:00)","train.order.success.eregPopupTitle":"Электронная регистрация","train.order.success.eregPopupText":"На этот рейс доступна электронная регистрация — посадка без билетов, по&nbsp;удостоверению личности.","train.order.success.eregPopupMore":"Подробнее","train.order.success.eregButtonRegister":"Пройти электронную регистрацию","train.order.success.eregButtonRegisterDiff":"Пройти электронную регистрацию раздельно","train.order.success.eregButtonOn":"Зарегистрироваться","train.order.success.eregButtonOnGo":"Пройти электронную регистрацию","train.order.success.eregButtonOff":"Отменить регистрацию","train.order.success.eregButtonRefresh":"Обновить","train.order.success.eregButtonShortOnGo":"Пройти","train.order.success.eregButtonShortOff":"Отменить","train.order.success.eregButtonShortRefresh":"Обновить","train.order.success.eregAfterPayment":"Электронная регистрация на этот поезд станет доступна после оплаты заказа.","train.order.success.ajaxOnError":"Ошибка включения электронной регистрации","train.order.success.ajaxOffError":"Ошибка отключения электронной регистрации","train.order.success.attentionBlank":"Пожалуйста,<br />сохраните номер заказа<br />или распечатайте контрольный купон.","train.order.success.attentionBlankEreg":"Пожалуйста,<br />сохраните номер заказа<br />или распечатайте посадочный купон.","train.order.success.attentionReg":"На этот рейс доступна<br />электронная регистрация<br />(только после оплаты).","train.order.success.payMethods":"Способы оплаты","train.order.success.mainTabTitle":"Получение билета","train.order.success.docsTabTitle":"Отчетные документы","train.order.success.docsTitle":"Документы","train.order.success.fieldDocTypePaper":"Бумажные копии","train.order.success.fieldDocTypeDigital":"Электронные версии","train.order.success.fieldDocTypes":"Формат","train.order.success.fieldCustomerTitle":"На кого выставить документы?","train.order.success.fieldFioTitle":"Ф.И.О.","train.order.success.fieldAddressTitle":"Юридический адрес","train.order.success.fieldInnTitle":"ИНН","train.order.success.fieldNameTitle":"Название","train.order.success.fieldKppTitle":"КПП","train.order.success.customer_person":"Физическое лицо","train.order.success.customer_businessmen":"Индивидуальный предприниматель","train.order.success.customer_legal":"Юридическое лицо","train.order.success.getDocsButton":"Получить документы","train.order.success.getOtherDocsButton":"Получить документы на другое имя","train.order.success.documentTitle_act":"Акт о выполненных работах","train.order.success.documentTitle_invoice":"Счет-фактура","train.order.success.documentsOk":"Мы получили Ваш запрос отчетных документов.\n\t\t\t\t\t\t\t\tОни будут отправлены на указанную электронную почту в течение двух суток.\n\t\t\t\t\t\t\t\tОригиналы документов будут отправлены по почте в течение 10 дней","train.order.success.ajaxDocsError":"Ошибка получения документов.","train.order.success.emailDocsTitle":"Отправка документов по e-mail","train.order.success.emailDocsField":"E-mail","train.order.success.emailDocsButton":"Отправить","train.order.success.emailDocsError":"Ошибка отправки документов","train.order.success.emailDocsCallButton":"Получить документы по email","train.order.success.emailDocsFileTitle":"Формат","train.order.success.emailDocsFile_pdf":"PDF (документ Adobe Acrobat Reader)","train.order.success.emailDocsFile_png":"PNG (изображение)","train.order.success.paperDocsTitle":"Запрос бумажных копий документов","train.order.success.paperDocsField":"Адрес<br/>(<small>страна, индекс, город, улица, дом, квартира</small>)","train.order.success.paperDocsButton":"Запросить","train.order.success.paperDocsError":"Ошибка отправки запроса бумажных копий","train.order.success.paperDocsCallButton":"Получить бумажные копии","train.order.success.cancelButton":"Отмена","train.order.success.sendDocsError":"Ошибка отправки запроса","train.order.success.orderError":"К сожалению, 15 минут, отведенные на оплату заказа, прошли. Пожалуйста, сделайте новый заказ.","train.order.success.orderYourTickets":"Ваш заказ","train.order.success.orderYourTicketsPaid":"успешно оплачен.","train.order.success.temporaryDocsRequest":'Для получения отчетных документов, пожалуйста, напишите нам<br/>\n\t\t\t\t\t\t\t\tна электронную почту <a href="mailto:documents@tutu.ru">documents@tutu.ru</a>.\n\t\t\t\t\t\t\t\tВаше письмо будет обработано в&nbsp;течение 5&nbsp;дней.',"train.order.success.wrong_user":'Этот заказ находится в личном кабинете, зарегистрированном на другую эл. почту.<br/><br/>\n\t\t\t\t\t\t\t\tВы можете перейти в <a href="%url%">свой личный кабинет</a> или войти как владелец этого личного кабинета.',"train.order.success.wrong_iser_title":"Ошибка авторизации","train.order.success.user_order_vipservice_moscow":'<span class="order-addr">Справка <span class="nowrap">(495) 626-41-42</span></span>',"train.order.success.user_order_vipservice_spb":'<span class="order-addr">Справка <span class="nowrap">(812) 380-56-00</span></span>',"train.order.success.user_order_davs_spb":'<span class="order-addr">Справка <span class="nowrap">(812) 493-59-60</span></span>',"train.order.success.user_order_travelmart":'<span class="order-addr">Справка <span class="nowrap">(495) 787-01-05</span></span>',"train.order.success.user_order_ufs":'<span class="order-addr">Справка <span class="nowrap">(495) 787-01-05</span></span>',"train.order.success.ufs_sms":"Oformlen bilet № %ticketNumber% %departureStation% - %arrivalStation% poezd %train%, vagon %car%, %seatsWord% %seats%, otpravlenie %departureDate% v %departureTime%, tutu.ru","train.order.success.seats1":"mesto","train.order.success.seats2":"mesta","train.order.success.coupon_fail_title":"К сожалению, не удалось получить контрольный купон.","train.order.success.coupon_fail_tryagain":"Пожалуйста, попробуйте сделать это позже.","train.order.success.send_docs.email_success":"Отчётные документы успешно отправлены на эл. почту, указанную вами при оформлении этого заказа.","train.order.success.send_docs.email_error":'При создании отчетных документов по вашему заказу произошла ошибка. Для получения документов, пожалуйста, напишите нам письмо на адрес <a href="mailto:documents@tutu.ru">documents@tutu.ru</a> с указанием номера заказа: %orderNumber%.',"train.order.success.send_docs.request_success":"Оригиналы отчетных документов будут высланы на указанный вами почтовый адрес в течение 5 рабочих дней.","train.order.success.send_docs.request_error":'При создании отчетных документов по вашему заказу произошла ошибка. Для получения документов, пожалуйста, напишите нам письмо на адрес <a href="mailto:documents@tutu.ru">documents@tutu.ru</a> с указанием номера заказа: %orderNumber%.',"train.order.success.send_docs.file_success":"-","train.order.success.send_docs.file_error":'При создании отчетных документов по вашему заказу произошла ошибка. Для получения документов, пожалуйста, напишите нам письмо на адрес <a href="mailto:documents@tutu.ru">documents@tutu.ru</a> с указанием номера заказа: %orderNumber%.',"train.order.success.send_docs.request_processing":"Ваш запрос обрабатывается","train.order.success.send_docs.will_be_later":'Если вам нужны копии отчетных документов, вернитесь на эту страницу немного позже. Для этого надо <a href="%url%" target="_self">обновить</a> страницу или заново зайти на нее из письма с подтверждением заказа.',"train.order.ticketing.page-title":"Tutu.ru: выписка билета","train.order.ticketing.order_number":"Идет оформление заказа","train.order.ticketing.wait_time":"Осталось подождать меньше 2-х минут","train.order.ticketing.title-redirect":"Завершение заказа","train.order.ticketing.title-redirect-error":"Возникли сложности","train.order.ticketing.phrase_1":"<p>Пожалуйста, не&nbsp;уходите с&nbsp;этой страницы.</p>\n<p>Как только билеты будут выписаны, мы&nbsp;перенаправим вас на&nbsp;страницу завершения заказа.</p>\n<p>Если будут вопросы, звоните нам по&nbsp;телефону: <nobr>(495) 787-01-05.</nobr></p>\n<p>Наши операторы работают ежедневно с&nbsp;9:00 до&nbsp;21:00.</p>","train.order.ticketing.phrase_2":"<p>Пожалуйста, не уходите с этой страницы.</p>\n<p>Система резервирования мест временно не&nbsp;отвечает, поэтому мы&nbsp;продолжаем отправку повторных запросов на&nbsp;выписку билетов. Это может занять до&nbsp;15&nbsp;минут.</p>\n<p>Как только билеты будут выписаны, мы&nbsp;перенаправим вас на&nbsp;страницу завершения заказа.</p>\n<p>Если будут вопросы, позвоните нам по&nbsp;телефону <nobr>(495) 787-01-05</nobr> и&nbsp;назовите код заказа: %orderCode%.</p>\n<p>Наши операторы работают ежедневно с&nbsp;9:00 до&nbsp;21:00.</p>","train.order.ticketing.phrase_3":'<p>Система резервирования мест не&nbsp;отвечает в&nbsp;течение длительного времени, но&nbsp;мы&nbsp;продолжаем отправку повторных запросов.</p>\n<p class="phone_info">Чтобы уточнить, удалось&nbsp;ли выписать ваши билеты, позвоните нам по&nbsp;телефону <nobr>(495) 787-01-05</nobr> и&nbsp;назовите код заказа: %orderCode%.</p>\n<p>Наши операторы работают ежедневно с&nbsp;9:00 до&nbsp;21:00.</p>',"train.order.ticketing.close_text":"Не закрывайте вкладку браузера. <br />Не нажимайте кнопку «Назад».","train.order.ticketing.redirect-ok":"<p>Билеты успешно выписаны!</p>\n\t\t<p>Через несколько секунд мы перенаправим вас на страницу с полной информацией о заказе.</p>","train.order.ticketing.redirect-error":"<p>К сожалению, при обработке вашего заказа что-то пошло не так.</p>\n\t\t<p>Сейчас мы перенаправим вас на страницу с информацией об ошибке.</p>","train.landing_page_ukr.fast_search":"Ж/д билеты на Украину и обратно – без очереди за 4 минуты","train.landing_page_ukr.today_open_sales":"Сегодня открыта продажа билетов","train.landing_page_ukr.fast_buy_ticket":"Ж/д билеты на&nbsp;Украину и&nbsp;обратно&nbsp;&mdash; без очереди за&nbsp;4&nbsp;минуты","train.landing_page_ukr.since_customers_pay":"Так наши клиенты оплатили больше 500 000 ж/д билетов","train.landing_page_ukr.time_to_buy":"4 минуты вашего<br /> времени на покупку.","train.landing_page_ukr.search_and_choose_train":"Поиск и выбор поезда","train.landing_page_ukr.enter_passangers":"Ввод информации о пассажирах","train.landing_page_ukr.payment":"Оплата","train.landing_page_ukr.min":"мин","train.landing_page_ukr.city_from":"из %city%","train.landing_page_ukr.city_to":"в %city%","train.landing_page_ukr.support":"Телефон для справок","train.landing_page_ukr.support_worktime":"с 9:00 до 21:00","train.landing_page_ukr.feedback_promise":"Мы обязательно ответим вам в&nbsp;течение 24&nbsp;часов","train.landing_page_ukr.landing_button":"&nbsp;&nbsp;Узнать цены&nbsp;&nbsp;","train.landing_page_ukr.pop_directions":"Доступные цены в&nbsp;один клик:","train.landing_page_ukr.faq_title":"Частые вопросы:","train.landing_page_ukr.faq_block_1_title":"Как купить ж/д&nbsp;билет?","train.landing_page_ukr.faq_block_1_text":"<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Укажите маршрут и&nbsp;дату. В&nbsp;ответ мы&nbsp;найдем информацию РЖД о&nbsp;наличии билетов и&nbsp;их&nbsp;стоимости.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите подходящий поезд и&nbsp;места.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Оплатите билет так, как вам удобно.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Информация об&nbsp;оплате будет моментально передана в&nbsp;РЖД и&nbsp;Ваш билет будет оформлен.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_ukr.faq_block_2_title":"Как оплатить электронный билет?","train.landing_page_ukr.faq_block_2_text_sv":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tБанковской картой\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ukr.faq_block_2_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tПодойдут и&nbsp;наличные, и&nbsp;карточки, и&nbsp;электронные деньги.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tНаличными можно заплатить через терминалы Qiwi, Элекснет, салоны Евросети и&nbsp;т.п.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ukr.faq_block_3_title":"Можно&nbsp;ли оплатить билет картой? А&nbsp;это безопасно?","train.landing_page_ukr.faq_block_3_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tДа, конечно. Оплата происходит через платежный шлюз процессингового центра Gateline.net. Все данные передаются по&nbsp;защищенному каналу SSL 3.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tШлюз Gateline.net был разработан в&nbsp;соответствии с&nbsp;учетом требований международного стандарта безопасности PCI&nbsp;DSS. Это первое в&nbsp;России процессинговое программное обеспечение, которое успешно прошло аудит по&nbsp;версии 2.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tСистема Gateline.net позволяет принимать оплату картами Visa и&nbsp;MasterCard, в&nbsp;том числе с&nbsp;использованием <span class="nowrap">3D-Secure</span>: Verified by&nbsp;Visa и&nbsp;MasterCard SecureCode.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПлатежная форма Gateline.net оптимизирована под различные браузеры и&nbsp;платформы, в&nbsp;том числе и&nbsp;для мобильных устройств.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПочти все ЖД&nbsp;агентства в&nbsp;интернете работают через данный шлюз.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page_ukr.faq_block_4_title":"Как получить электронный билет?","train.landing_page_ukr.faq_block_4_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронному билету не&nbsp;нужна доставка. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДостаточно пройти электронную регистрацию на&nbsp;сайте или&nbsp;получить обычный билет на&nbsp;бланке в&nbsp;вокзальной кассе или&nbsp;терминале регистрации.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ukr.faq_block_5_title":"Как попасть в&nbsp;поезд по&nbsp;электронному билету?","train.landing_page_ukr.faq_block_5_text":"<h5>1-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля многих маршрутов доступна электронная регистрация. Это просто кнопка на&nbsp;странице после оплаты. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНажмите на&nbsp;нее, чтобы ваше имя попало в&nbsp;список у&nbsp;проводника вагона.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПри посадке покажите проводнику паспорт.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tОн&nbsp;найдет ваше ФИО в&nbsp;списке и&nbsp;пропустит в&nbsp;вагон.\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<h5>2-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tТакже после оплаты вы&nbsp;можете получить обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tСразу после оплаты мы&nbsp;отправим вам <nobr>14-значный</nobr> код (на&nbsp;почту и&nbsp;по&nbsp;СМС).\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПокажите этот код и&nbsp;паспорт в&nbsp;кассе на&nbsp;вокзале. Это можно сделать и&nbsp;за&nbsp;15&nbsp;минут до&nbsp;отправления поезда.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tКассир выдаст вам обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_ukr.faq_block_6_title":"Какая у вас наценка на&nbsp;электронный билет?","train.landing_page_ukr.faq_block_6_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t392,7 рубля за&nbsp;билет в&nbsp;мягкий или&nbsp;СВ вагоны,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t274,7 рубля за&nbsp;билет в&nbsp;купе, плацкарт или сидячий вагоны.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;вокзале и&nbsp;во&nbsp;всех трансагенствах также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ukr.faq_block_7_title":"Вопросы про ж/д билеты  на&nbsp;бланке","train.landing_page_ukr.faq_block_7_text":"<h5>Сколько стоит доставка?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Доставка билета стоит 300&nbsp;рублей в&nbsp;Москве и&nbsp;250&nbsp;рублей в&nbsp;Санкт-Петербурге.</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Можно ли забрать билет самому?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Конечно!</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;всегда рады увидеть вас в&nbsp;московском офисе на&nbsp;Бауманской или в&nbsp;питерском офисе на&nbsp;<nobr>9-й</nobr> Линии Васильевского острова.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Какая у&nbsp;вас наценка на&nbsp;билет на&nbsp;бланке?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Мы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>295 рублей в Москве,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>260 рублей в Санкт-Петербурге.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>На&nbsp;вокзале также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ukr.commersant_text":'<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tКаждый месяц 5 000 000 человек заходят на&nbsp;сайт Туту.ру, чтобы купить билеты на&nbsp;самолеты и&nbsp;поезда, забронировать отели и&nbsp;узнать расписание электричек.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tПо данным comScore и&nbsp;газеты КоммерсантЪ, Туту.ру &mdash;&nbsp;это <a href="http://www.kommersant.ru/doc/1869944">самый популярный</a> у&nbsp;россиян туристический сайт.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page_skidki.sales_title":"Скидки на&nbsp;железнодорожные билеты","train.landing_page_skidki.sales_text":"<b>5% от&nbsp;стоимости ж/д билета за&nbsp;покупку в&nbsp;интернете</b>\n<br /><br />\nПри покупке билетов через интернет с&nbsp;16&nbsp;мая 2012 действует скидка&nbsp;5% на&nbsp;ж/д билеты в&nbsp;вагоны купе, СВ&nbsp;и&nbsp;люкс.\n<br /><br />\n<b>50% от&nbsp;стоимости ж/д билета за&nbsp;раннюю покупку</b>\n<br /><br />\nНа&nbsp;даты с&nbsp;1&nbsp;октября по&nbsp;26&nbsp;декабря 2012 билеты в&nbsp;купе можно купить со&nbsp;скидкой&nbsp;50%, если брать их&nbsp;за&nbsp;31&nbsp;и&nbsp;более суток до&nbsp;отправления поезда.\n<br /><br />\nСкидка распространяется на&nbsp;купейные вагоны поездов ОАО &laquo;ФПК&raquo; во&nbsp;внутригосударственном сообщении.\n<br /><br />\n<b>Цены на&nbsp;сайте Туту.ру указаны с&nbsp;учетом этих скидок.</b>","train.schedule.search.title":"Пожалуйста, уточните станции","train.schedule.search.header":"Уточнение станций","train.schedule.search.navy_title":"Уточнение станций","train.schedule.search.arrival_title":"Пункт прибытия","train.schedule.search.departure_title":"Пункт отправления","train.schedule.search.limit_warning":"Показаны первые %limit% результатов. Уточните запрос и повторите поиск при необходимости.","train.schedule.search.button":"Показать расписание и билеты","train.schedule.search.no_arrival_station":'По вашему запросу «<span class="red">%searchPhrase%</span>» станции прибытия не найдено.',"train.schedule.search.no_departure_station":'По вашему запросу «<span class="red">%searchPhrase%</span>» станции отправления не найдено.',"train.schedule.change.no_seats":"Не&nbsp;удалось подтвердить наличие мест","train.schedule.change.no_seats_1":'К&nbsp;сожалению, на&nbsp;<span class="nowrap">%date%</span> на&nbsp;поезд %tn% нет&nbsp;билетов',"train.schedule.change.no_seats_2_a":'К&nbsp;сожалению, на&nbsp;<span class="nowrap">%date%</span> на&nbsp;поезда %tn1% и&nbsp;%tn2% нет&nbsp;билетов',"train.schedule.change.no_seats_2_b":'К&nbsp;сожалению, на&nbsp;<span class="nowrap">%date1%</span> на&nbsp;поезд %tn1% и&nbsp;на&nbsp;<span class="nowrap">%date2%</span> на&nbsp;поезд %tn2% нет&nbsp;билетов',"train.schedule.change.check_failed":"Произошел сбой, попробуйте повторить запрос позже","train.schedule.change.buy_tickets":'<span class="buy_both_tickets">Купите оба билета</span>',"train.schedule.change.ticket_1":"1-й билет","train.schedule.change.ticket_2":"2-й билет","train.schedule.errors.is_restricted_arrival":"На данном маршруте поезд выходит за пределы РФ. Такие билеты оформляются в специализированных кассах РЖД на вокзалах.","train.schedule.errors.ukraine_popup":"Заказ билетов с&nbsp;Украины в&nbsp;Россию на&nbsp;нашем сайте недоступен.","train.schedule.errors.is_restricted_train":"К сожалению, из-за особенностей работы систем бронирования покупка билетов на этот поезд возможна только на вокзалах.","train.schedule.errors.no_sng_ticket_with_no_msk":"Заказ билетов в дальнее зарубежье с посадкой не в Москве (и обратно) невозможен.","train.schedule.errors.prigorod_train":"Данный поезд является пригородным, билет на него можно купить в специальных кассах РЖД.","train.schedule.landing.header_left_title_wrong":"Ближайший поезд — %date%","train.schedule.landing.header_left_text_wrong":"","train.schedule.landing.header_left_title_0":"Мест на&nbsp;%date% нет, но&nbsp;есть надежда","train.schedule.landing.header_left_text_0":"Места могут появиться, например, если кто-нибудь сдаст билет. Закажите уведомления об&nbsp;этом или выберите другую дату.","train.schedule.landing.header_left_title_1":"Всего один поезд","train.schedule.landing.header_left_text_1":"Столько&nbsp;же <strong>свободных мест</strong> видит сейчас кассир на&nbsp;вокзале. Оформите билет раньше него!","train.schedule.landing.header_left_title":"%trainsCount% на выбор","train.schedule.landing.header_left_text":"Столько&nbsp;же поездов и <strong>свободных мест</strong> видит сейчас кассир на&nbsp;вокзале. Оформите билет раньше него!","train.schedule.landing.header_middle_title":"10 способов оплаты","train.schedule.landing.header_middle_text":"От&nbsp;моментальной оплаты <strong>карточкой</strong> до&nbsp;<strong>наличных курьеру</strong> — все способы надежны и <strong>проверены</strong>.","train.schedule.landing.header_right_title":"9 лет работы сервиса","train.schedule.landing.header_right_text":"Мы обслужили больше <strong>500 000 клиентов</strong>. Теперь нам нужно 4 минуты,  чтобы оформить для&nbsp;вас <strong>билет РЖД</strong>.","train.schedule.landing.on_choice":"на выбор","train.schedule.landing.today":"сегодня","train.schedule.landing.tomorrow":"завтра","train.schedule.landing.day_after_tomorrow":"послезавтра","train.schedule.landing.different_date":"другой день","train.schedule.landing.on_route":"по&nbsp;маршруту %from% — %to%","train.schedule.landing.title_one_seat":"Одно место %route%","train.schedule.landing.title_no_seats":"%date% мест %route% нет, но&nbsp;есть надежда","train.schedule.landing.title_wrong_date":"Выбрана прошедшая дата, %date%","train.landing_page_ny.fast_buy_ticket":"Онлайн-касса. Ж/д билеты на Новый год","train.landing_page_ny.sales_text_sec":"<b>Открыта продажа билетов на новогодние праздники</b>\n\t\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\t\tСпешите – у вас есть шанс «поймать» хорошие места.\n\t\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\t\t<b>В ноябре – дешевле</b>\n\t\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\t\tНедорогие места на популярные направления «уходят» в первую очередь.\n\t\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\t\tЗа 10 дней до отправления билеты дорожают – перевозчик вводит наценку.\n\t\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\t\t<b>Успейте купить хорошие билеты по низким ценам!</b>","train.landing_page_ny.sales_text":"<b>Спешите&nbsp;&mdash; у&nbsp;вас есть шанс &laquo;поймать&raquo; хорошие места!</b>\n\t\t\t\t\t\t\t\t\t\t<br /><br />Планируйте поездку заранее&nbsp;&mdash; дешевые билеты на&nbsp;популярные направления заканчиваются быстро.\n\t\t\t\t\t\t\t\t\t\t<br /><br />За&nbsp;10&nbsp;дней до&nbsp;отправления все билеты дорожают&nbsp;&mdash; перевозчик вводит наценку.\n\t\t\t\t\t\t\t\t\t\t<br /><br /><b>Успейте взять удобные места по&nbsp;низким ценам</b>\n\t\t\t\t\t\t\t\t\t\t<br /><br />Пусть новогодние праздники дарят вам только хорошие эмоции!","train.example.train_number":"055","train.example.train_name":"Енисей","train.example.or":"или","train.example.example":"Например:","train.order_popup.main_title":"Укажите маршрут и&nbsp;дату поездки&nbsp;&mdash; мы&nbsp;подберем для вас все доступные для покупки предложения!","train.order_popup.from_title":"Откуда","train.order_popup.to_title":"Куда","train.order_popup.date_error":"Укажите дату отправления","train.schedule.firmTrainsFilter":"Фирменные","train.schedule.eregistration":"Доступна электронная регистрация","train.schedule.eregistration_none":"Электронная регистрация недоступна","train.schedule.eregistration_label":"Эл.рег.","train.schedule.eregistration_tooltip":"Доступна электронная регистрация. Пройдите ее&nbsp;&mdash; для посадки в&nbsp;вагон понадобится только удостоверение личности.","train.schedule.eregistration_tooltip_no":"Электронная регистрация недоступна. Для посадки в&nbsp;вагон распечатайте билет в&nbsp;терминале или в&nbsp;кассе на&nbsp;вокзале.","train.schedule.no_trains":"Ничего не найдено.","train.schedule.no_sapsan_trains":"Такого маршрута на поезде «Сапсан» не существует","train.schedule.no_trains_active_dates":"&nbsp;Есть поезда на ","train.schedule.no_train_by_date":"При&nbsp;поездке <nobr>%date%</nobr> от&nbsp;станции <nobr>%departureStation%</nobr> до&nbsp;станции <nobr>%arrivalStation%</nobr> необходимо сделать больше одной пересадки.\n\t\t\t\t\t\t\t\t\t\t\t<br/>Проверьте правильность выбора станций или упростите маршрут.","train.schedule.date_url":'<a href="%url%">%title%</a>',"train.schedule.no_trains_and":"&nbsp;и&nbsp;","train.schedule.any_seats":"Любые места","train.schedule.order_only":"Только заказ","train.schedule.order_only_off":"Любые поезда","train.schedule.tickets_order":"Заказ<br />билетов","train.schedule.price_from":"Цена&nbsp;от","train.schedule.price_from_about":"Примерные цены","train.schedule.prices":"Цены","train.schedule.approx":"ориентировочные","train.schedule.buy_tickets_online_text":"Купите ж/д&nbsp;билет онлайн за&nbsp;4&nbsp;минуты.","train.schedule.price_from_about_n_seats":"Примерные цены<br />и&nbsp;количество мест","train.schedule.price_from_about_comment":"(укажите дату для уточнения<br />&nbsp;количества мест)","train.schedule.seats_type":"тип","train.schedule.seats_number":"кол-во","train.schedule.seats":"Места","train.schedule.travelTime":"В пути","train.schedule.arrival":"Прибытие","train.schedule.departure":"Отправление","train.schedule.travelTime2":"Общее время","train.schedule.changeTime":"Пересадка","train.schedule.comments":"Отзывы","train.schedule.route":"Маршрут","train.schedule.train_schedule":"Годовой график","train.schedule.unknown_train":"Поезд не в базе","train.schedule.train_trailer":"прицепной вагон","train.schedule.order":"Заказать","train.schedule.prev_day":"Предыдущий день","train.schedule.next_day":"Следующий день","train.schedule.back_route":"Обратный маршрут","train.schedule.alternative_route":"Вылет и прилет в рядом расположенные города","train.schedule.alternative_departure_route":"Вылет из городов рядом с %cityName%","train.schedule.alternative_arival_route":"Прилет в города рядом с  %cityName%","train.schedule.air_route":"Самолетом","train.schedule.print_schedule":"Напечатать расписание","train.schedule.pagination_first":"Первая страница","train.schedule.pagination_last":"%pageNumber% страница","train.schedule.no_data_from_express":"Не удалось соединиться с системой «Экспресс»","train.schedule.no_data_from_provider_common":"К сожалению, заказ билетов временно недоступен.\n\t\t\t\t\t\t\t\t\t\t\tПожалуйста, зайдите к нам чуть позже — мы уже решаем эту проблему.","train.schedule.is_restricted_arrival":"Билеты в Калининград оформляются в специализированных кассах РЖД на вокзале","train.schedule.firmTrain":"Фирменный поезд","train.schedule.cat1_shortname":"Сид","train.schedule.cat2_shortname":"Общ","train.schedule.cat3_shortname":"Плац","train.schedule.cat4_shortname":"Купе","train.schedule.cat5_shortname":"Люкс","train.schedule.cat6_shortname":"Мягк","train.schedule.wordform_day1":"день","train.schedule.wordform_day2":"дня","train.schedule.wordform_day3":"дней","train.schedule.no_order_train_left":"Поезд ушел","train.schedule.no_order_no_sits":"Нет в продаже","train.schedule.no_order_hour_before_departure":"Осталось меньше двух часов","train.schedule.no_order_tooltip":"Скорее всего, на выбранную дату в этом поезде уже нет мест. Они могут появиться, если кто-нибудь, например, сдаст билеты или снимет бронь.<br/>Выберите тот поезд, на который есть билеты сейчас или выберите другую дату.","train.schedule.no_order_tooltip_hope":"Скорее всего, на выбранную дату в этом поезде уже нет мест. Они могут появиться, если кто-нибудь, например, сдаст билеты или снимет бронь.<br/>Выберите тот поезд, на который есть билеты сейчас или выберите другую дату.<br/>Если вы надеетесь, что билеты еще появятся, закажите уведомление об этом.","train.schedule.no_order_price":"Заказ билетов на этот поезд недоступен","train.schedule.no_order_from_internet":"На этот поезд покупка билета через интернет недоступна, но в Москве Вы можете заказать его по телефону <nobr>(495) 626-41-42</nobr>","train.schedule.warning_past_date":'Вы выбрали прошедшую дату %routeDate%. Попробуйте поискать билеты на&nbsp;<a class="pseudoBlue" href="javascript: void(0)" rel="calendarTriggernavigation-datenulldatechoose"  onclick="ShowCalendarNull(\'choose_from_null_date\');" nojs="hide" style="display:none;" id="choose_from_null_date">другой день</a><span nojs="show">другой день</span>.',"train.schedule.warning_will_be_soon_with_notice":'Продажи билетов на %routeDate% начнутся через %days% %word%. Но на <a rel="nofollow" href="%url%">%urlName%</a> вы можете сделать заказ прямо сейчас!<br/>Также вы можете заказать уведомление о начале продаж на %routeDate%.%additional%',"train.schedule.warning_will_be_soon":'Продажи билетов на %routeDate% начнутся через %days% %word%. Но на <a rel="nofollow" href="%url%">%urlName%</a> вы можете сделать заказ прямо сейчас!%additional%',"train.schedule.warning_will_be_soon_morning":"Продажи на %routeDate% должны начаться сегодня в 8:00 по московскому времени.<br/>Мы надеемся, что вы успеете купить нужный вам билет.","train.schedule.warning_input_date":'<!--noindex-->Для уточнения<!--/noindex--> цены билетов и наличия мест, <!--noindex-->пожалуйста, <a class="pseudoBlue" href="javascript: void(0)" rel="calendarTriggernavigation-datenulldatechoose"  onclick="ShowCalendarNull(\'choose_from_null_date\');" nojs="hide" style="display:none;">укажите дату поездки</a><span nojs="show">укажите дату поездки</span><!--/noindex-->.<span style="position: absolute" id="choose_from_null_date"></span>',"train.schedule.warning_no_trains_at_all":'Прямого сообщения между остановочными пунктами не найдено!<br/>\n\t\t\t\t\t\t\t\t\t\t\tВы&nbsp;можете узнать расписание поездов через станцию <a href="%departure_station_url%">%departure%</a>\n\t\t\t\t\t\t\t\t\t\t\tили через станцию <a href="%arrival_station_url%">%arrival%</a>',"train.schedule.warning_no_trains_but_cities":'Сообщение между указанными станциями не найдено. Предлагаем <a href="%cities_schedule_url%">результаты поиска между городами</a> этих станций',"train.schedule.warning_request_from_calendar_0":"К сожалению, на этот поезд билетов нет.","train.schedule.warning_request_from_calendar_1":"К сожалению, на этот поезд билетов нет. Мы нашли %count% %departure% - %arrival% на <nobr>%date%</nobr>","train.schedule.navy_title":"Расписание поездов %departure%  → %arrival%","train.schedule.navy_title2":"Расписание поездов дальнего следования, билеты на поезд %departure%  → %arrival%","train.schedule.navy_title2_sapsan":"Расписание поездов Сапсан %departure%  → %arrival%","train.schedule.navy_title3":"жд билеты %departure%  → %arrival%","train.schedule.navy_title3_sapsan":"билеты на Сапсан %departure% → %arrival%","train.schedule.arrive_after_day":"Через %phrase%","train.schedule.arrival_day1":"день","train.schedule.arrival_day2":"%days% дня","train.schedule.arrival_day3":"%days% дней","train.schedule.no_firm_trains":"Фирменных поездов нет.","train.schedule.buy_request":"Проверить доступность","train.schedule.buy_button":"Купить","train.schedule.buy_button_choose_date":'<a href="javascript: void(0)" rel="calendarTriggernavigation-date%hash%" class="pseudoBlue">Купить</a>%additional%',"train.schedule.discount_five":"&minus; 5%","train.schedule.discount_discount":"скидка","train.schedule.discount_discount_tooltip":"Цена уже со&nbsp;скидкой. Купе почти по&nbsp;цене плацкарта при&nbsp;покупке за&nbsp;31&nbsp;день и&nbsp;более!","train.schedule.discount_five_tooltip":"Цена со&nbsp;скидкой&nbsp;5% за&nbsp;покупку в&nbsp;интернете.","train.schedule.tickets_title":"Билеты","train.schedule.tickets_description":"Вы можете заказать электронный жд билет и железнодорожный билет на бланке РЖД.","train.schedule.tickets_description_sapsan":"Купите электронный ж/д билет на «Сапсан», чтобы не стоять в очереди на вокзале!","train.schedule.interests_train_title":"Поездом","train.schedule.interests_title":"Пригодится","train.schedule.interests_avia":"Авиабилеты <nobr>%from%</nobr> &rarr; <nobr>%to%</nobr>","train.schedule.interests_train":"жд билеты <nobr>%from%</nobr> &rarr; <nobr>%to%</nobr>","train.schedule.interests_hotels":"Гостиницы в городе <nobr>%city%</nobr>","train.schedule.interests_taxi":"Такси в городе <nobr>%city%</nobr>","train.schedule.interests_metro":"Метро в городе <nobr>%city%</nobr>","train.schedule.interests_train2":"Билеты на поезд до <nobr>%city%</nobr>","train.schedule.interests_train2_ico":'<span class="dtrain-status-icon" ></span>Билеты на поезд до <nobr>%city%</nobr>',"train.schedule.change-threshold":"Времени на пересадку немного","train.schedule.with_change":"с пересадками","train.schedule.station_change":"Станция пересадки","train.schedule.any_station":"Любая","train.schedule.change_name":"пересадка","train.schedule.related_stations":"Из %city_from% без пересадок можно доехать до&nbsp;%qty% %cities%","train.schedule.city_decline_none_1":"города","train.schedule.city_decline_none_2":"городов","train.schedule.city_decline_none_3":"городов","train.schedule.ukr_price_warning":"Из-за особенностей украинской системы продажи билетов для&nbsp;поездов, отправляющихся из&nbsp;Украины, информация о&nbsp;стоимости может быть неточной. Точная сумма будет указана на шаге подтверждения заказа перед оплатой","train.schedule.ukr_empty_price_warning":"Начните оформление и&nbsp;узнайте цену при подтверждении заказа перед оплатой. Из-за особенностей украинской системы бронирования для некоторых билетов изначально цена неизвестна.","train.schedule.train_schedule_dates":"Сейчас продаются билеты на эти даты","train.schedule.not_available_price":"Нет","train.schedule.fast_title":"Частые вопросы","train.schedule.fast_1_title":"Как купить ж/д&nbsp;билет?","train.schedule.fast_1_text":"<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Укажите маршрут и&nbsp;дату. В&nbsp;ответ мы&nbsp;найдем информацию РЖД о&nbsp;наличии билетов и&nbsp;их&nbsp;стоимости.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите подходящий поезд и&nbsp;места.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Оплатите билет так, как вам удобно.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Информация об&nbsp;оплате будет моментально передана в&nbsp;РЖД и&nbsp;Ваш билет будет оформлен.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.schedule.fast_2_title":'Как вернуть купленный <span class="nowrap">ж/д</span>&nbsp;билет?',"train.schedule.fast_2_text":'<p>Любой купленный на&nbsp;<a href="%url%">tutu.ru</a> <span class="nowrap">ж/д</span>&nbsp;билет можно сдать в&nbsp;соответствии с&nbsp;правилами&nbsp;РЖД.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Возврат осуществляется в&nbsp;железнодорожных кассах.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Если вы оплатили электронный <span class="nowrap">ж/д</span>&nbsp;билет банковской картой, деньги вернут на&nbsp;ту&nbsp;же карту. В&nbsp;остальных случаях деньги выдаются наличными в&nbsp;кассе в&nbsp;момент возврата.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>При сдаче купленного билета не&nbsp;возвращаются сервисные сборы и&nbsp;комиссии, дополнительно РЖД взимает рекламационный сбор.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Общие потери при&nbsp;сдаче билета зависят от&nbsp;суммы и&nbsp;способа оплаты. За один сданный билет в&nbsp;среднем удерживается около 500&nbsp;рублей.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>При возврате билета менее&nbsp;чем за&nbsp;8&nbsp;часов до&nbsp;отправления поезда штрафы РЖД существенно увеличиваются.</p>',"train.schedule.fast_3_title":"Можно&nbsp;ли оплатить билет картой? А&nbsp;это&nbsp;безопасно?","train.schedule.fast_3_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tДа, конечно. Оплата происходит через платежный шлюз процессингового центра Gateline.net. Все данные передаются по&nbsp;защищенному каналу SSL 3.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tШлюз Gateline.net был разработан в&nbsp;соответствии с&nbsp;учетом требований международного стандарта безопасности PCI&nbsp;DSS. Это первое в&nbsp;России процессинговое программное обеспечение, которое успешно прошло аудит по&nbsp;версии 2.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tСистема Gateline.net позволяет принимать оплату картами Visa и&nbsp;MasterCard, в&nbsp;том числе с&nbsp;использованием <span class="nowrap">3D-Secure</span>: Verified by&nbsp;Visa и&nbsp;MasterCard SecureCode.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПлатежная форма Gateline.net оптимизирована под различные браузеры и&nbsp;платформы, в&nbsp;том числе и&nbsp;для мобильных устройств.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПочти все ЖД&nbsp;агентства в&nbsp;интернете работают через данный шлюз.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.schedule.fast_4_title":"Что такое электронный билет и&nbsp;электронная регистрация?","train.schedule.fast_4_text":'<p>Покупка электронного билета на Tutu.ru&nbsp;&mdash; современный и&nbsp;быстрый способ оформления проездного документа без&nbsp;участия кассира или&nbsp;оператора.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>При покупке электронного <span class="nowrap">ж/д&nbsp;билета</span> места выкупаются сразу, в&nbsp;момент оплаты.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>После оплаты для&nbsp;посадки в&nbsp;поезд нужно:</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t<li>либо пройти электронную регистрацию;</li>\n\t\t\t\t\t\t\t\t\t\t\t<li>либо распечатать билет на&nbsp;вокзале.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p><b>Электронная регистрация</b> доступна не&nbsp;для&nbsp;всех заказов. \n\t\t\t\t\t\t\t\t\t\t\tЕсли регистрация доступна, ее&nbsp;можно пройти, нажав на&nbsp;нашем сайте соответствующую кнопку. Эту кнопку вы&nbsp;увидите сразу после оплаты.\n\t\t\t\t\t\t\t\t\t\t\tПосле этого для посадки в&nbsp;поезд достаточно иметь при&nbsp;себе только удостоверение личности.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p><b>Распечатать электронный билет</b> можно в&nbsp;любое время до&nbsp;отправления поезда в&nbsp;кассе на&nbsp;вокзале либо в&nbsp;терминале саморегистрации.\n\t\t\t\t\t\t\t\t\t\t\tДля этого нужен 14-значный код заказа (вы&nbsp;получите его по&nbsp;СМС после оплаты) и&nbsp;удостоверение личности.</p>',"train.eticket.cash_title":"Статус заявки","train.eticket.emoney_title":"Оформление заказа билетов закончено","train.eticket.get_tickets":"Получите проездные документы (билеты на бланке РЖД) на любом вокзале России.<br/>На территории России в любой кассе ОАО РЖД (оборудованной терминалами «Экспресс-3»), в терминалах саморегистрации.","train.landing_page.fast_search":"Купить железнодорожный билет за 4 минуты","train.landing_page.fast_search1":"ЖД билеты онлайн","train.landing_page.today_open_sales":"Сегодня открыта продажа билетов","train.landing_page.fast_buy_ticket":"Купить железнодорожный билет за 4 минуты","train.landing_page.fast_buy_ticket_1":"Выберите лучшие места в поезде из тех, что в наличии!","train.landing_page.fast_buy_ticket_2":"Билеты на поезд онлайн","train.landing_page.fast_buy_ticket_3":"Онлайн-касса. Покупка билетов на поезд","train.landing_page.since_customers_pay":"Так наши клиенты оплатили больше 500 000 ж/д билетов","train.landing_page.time_to_buy":"4 минуты вашего<br /> времени на покупку.","train.landing_page.search_and_choose_train":"Поиск и выбор поезда","train.landing_page.enter_passangers":"Ввод информации о пассажирах","train.landing_page.payment":"Оплата","train.landing_page.min":"мин","train.landing_page.city_from":"из %city%","train.landing_page.city_to":"в %city%","train.landing_page.support":"Помощь при покупке билетов","train.landing_page.support_worktime":"с 9:00 до 21:00","train.landing_page.feedback_promise":"Мы обязательно ответим вам в&nbsp;течение 24&nbsp;часов","train.landing_page.landing_button":"&nbsp;&nbsp;Узнать цены&nbsp;&nbsp;","train.landing_page.landing_button_buyticket":"&nbsp;&nbsp;Купить билет&nbsp;&nbsp;","train.landing_page.landing_button_orderticket":"&nbsp;&nbsp;Заказать билет&nbsp;&nbsp;","train.landing_page.landing_button_search":"&nbsp;&nbsp;Запустить поиск&nbsp;&nbsp;","train.landing_page.pop_directions":"Доступные цены в&nbsp;один клик:","train.landing_page.faq_title":"Частые вопросы:","train.landing_page.faq_title_new":"Знаете ли вы:","train.landing_page.faq_block_1_title":"Как купить ж/д&nbsp;билет?","train.landing_page.faq_block_1_text":"<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Укажите маршрут и&nbsp;дату. В&nbsp;ответ мы&nbsp;найдем информацию РЖД о&nbsp;наличии билетов и&nbsp;их&nbsp;стоимости.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите подходящий поезд и&nbsp;места.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Оплатите билет так, как вам удобно.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Информация об&nbsp;оплате будет моментально передана в&nbsp;РЖД и&nbsp;Ваш билет будет оформлен.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page.faq_block_2_title":"Как оплатить электронный билет?","train.landing_page.faq_block_2_text_sv":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tБанковской картой\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page.faq_block_2_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tПодойдут и&nbsp;наличные, и&nbsp;карточки, и&nbsp;электронные деньги.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tНаличными можно заплатить через терминалы Qiwi, салоны Евросети и&nbsp;т.п.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page.faq_block_3_title":"Можно&nbsp;ли оплатить билет картой? А&nbsp;это безопасно?","train.landing_page.faq_block_3_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tДа, конечно. Оплата происходит через платежный шлюз процессингового центра Gateline.net. Все данные передаются по&nbsp;защищенному каналу SSL 3.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tШлюз Gateline.net был разработан в&nbsp;соответствии с&nbsp;учетом требований международного стандарта безопасности PCI&nbsp;DSS. Это первое в&nbsp;России процессинговое программное обеспечение, которое успешно прошло аудит по&nbsp;версии 2.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tСистема Gateline.net позволяет принимать оплату картами Visa и&nbsp;MasterCard, в&nbsp;том числе с&nbsp;использованием <span class="nowrap">3D-Secure</span>: Verified by&nbsp;Visa и&nbsp;MasterCard SecureCode.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПлатежная форма Gateline.net оптимизирована под различные браузеры и&nbsp;платформы, в&nbsp;том числе и&nbsp;для мобильных устройств.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПочти все ЖД&nbsp;агентства в&nbsp;интернете работают через данный шлюз.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page.faq_block_4_title":"Как получить электронный билет?","train.landing_page.faq_block_4_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронному билету не&nbsp;нужна доставка. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДостаточно пройти электронную регистрацию на&nbsp;сайте или&nbsp;получить обычный билет на&nbsp;бланке в&nbsp;вокзальной кассе или&nbsp;терминале регистрации.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page.faq_block_5_title":"Как попасть в&nbsp;поезд по&nbsp;электронному билету?","train.landing_page.faq_block_5_text":"<h5>1-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля многих маршрутов доступна электронная регистрация. Это просто кнопка на&nbsp;странице после оплаты. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНажмите на&nbsp;нее, чтобы ваше имя попало в&nbsp;список у&nbsp;проводника вагона.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПри посадке покажите проводнику паспорт.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tОн&nbsp;найдет ваше ФИО в&nbsp;списке и&nbsp;пропустит в&nbsp;вагон.\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<h5>2-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tТакже после оплаты вы&nbsp;можете получить обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tСразу после оплаты мы&nbsp;отправим вам <nobr>14-значный</nobr> код (на&nbsp;почту и&nbsp;по&nbsp;СМС).\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПокажите этот код и&nbsp;паспорт в&nbsp;кассе на&nbsp;вокзале. Это можно сделать и&nbsp;за&nbsp;15&nbsp;минут до&nbsp;отправления поезда.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tКассир выдаст вам обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page.faq_block_6_title":"Какая у вас наценка на&nbsp;электронный билет?","train.landing_page.faq_block_6_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t392,7 рубля за&nbsp;билет в&nbsp;мягкий или&nbsp;СВ вагоны,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t274,7 рубля за&nbsp;билет в&nbsp;купе, плацкарт или сидячий вагоны.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;вокзале и&nbsp;во&nbsp;всех трансагенствах также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page.faq_block_7_title":"Вопросы про ж/д билеты на&nbsp;бланке","train.landing_page.faq_block_7_text":"<h5>Сколько стоит доставка?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Доставка билета стоит 300&nbsp;рублей в&nbsp;Москве и&nbsp;250&nbsp;рублей в&nbsp;Санкт-Петербурге.</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Можно ли забрать билет самому?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Конечно!</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;всегда рады увидеть вас в&nbsp;московском офисе на&nbsp;Бауманской или в&nbsp;питерском офисе на&nbsp;<nobr>9-й</nobr> Линии Васильевского острова.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Какая у&nbsp;вас наценка на&nbsp;билет на&nbsp;бланке?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Мы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>295 рублей в Москве,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>260 рублей в Санкт-Петербурге.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>На&nbsp;вокзале также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page.commersant_text":'<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tКаждый месяц 5 000 000 человек заходят на&nbsp;сайт Туту.ру, чтобы купить билеты на&nbsp;самолеты и&nbsp;поезда, забронировать отели и&nbsp;узнать расписание электричек.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tПо данным comScore и&nbsp;газеты КоммерсантЪ, Туту.ру &mdash;&nbsp;это <a href="http://www.kommersant.ru/doc/1869944">самый популярный</a> у&nbsp;россиян туристический сайт.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.remind.sale_start_notification":"Заказ уведомления","train.remind.schedule_button":"Есть надежда","train.remind.schedule_button_late":"Хочу","train.remind.schedule_title":"Есть надежда!","train.remind.schedule_title_late":"Хочу","train.remind.schedule_title_phone_confirm":"Подтверждение номера телефона","train.remind.stop_successfull":"Отправка уведомлений остановлена","train.remind.phone_confirm_text_sent":"На ваш мобильный телефон отправлен sms-ключ.","train.remind.phone_confirm_text_request":"Если сообщение не пришло в течение 3 минут,&nbsp;","train.remind.phone_confirm_text_request_link":"запросите ключ повторно","train.remind.phone_confirm_text_input":"Подтвердить","train.remind.phone_confirm_text_confirm":"Подтвердить","train.remind.form_text_begin":"Если кто-нибудь сдаст билеты или появятся дополнительные места","train.remind.form_text":"Сообщите мне, если кто-нибудь сдаст билеты или появятся дополнительные места.","train.remind.form_text_late":"Сообщите мне, когда начнется продажа билетов.","train.remind.form_text_remind_me":"Сообщите мне, если появятся места","train.remind.form_text_remind_me_late":"Сообщите мне, когда появятся места","train.remind.form_train_radio":"на поезд %train%","train.remind.form_schedule_radio":"на любой поезд по направлению %departure% → %arrival%","train.remind.form_text_end":"мы обязательно отправим вам электронное письмо.","train.remind.form_car_title":"В вагоне","train.remind.form_date_type_selector_interval":"Интервал","train.remind.form_time_selector_anytime":"В любое время","train.remind.form_time_selector_morning":"Утром (6:00 - 09:59)","train.remind.form_time_selector_day":"Днем (10:00 - 17:59)","train.remind.form_time_selector_evening":"Вечером (18:00 - 22:59)","train.remind.form_time_selector_night":"Ночью (23:00 - 05:59)","train.remind.form_date_type_selector_interval1":"Плюс день","train.remind.form_date_type_selector_interval2":"Плюс два дня","train.remind.form_date_type_selector_interval3":"Плюс три дня","train.remind.form_date_type_selector_exact":"Только в этот день","train.remind.form_email_title":"Эл. почта","train.remind.form_phone_title":"СМС на номер","train.remind.form_date_to_title":"Дата до","train.remind.form_date_from_title":"Дата от","train.remind.form_date_title":"Нужно уехать","train.remind.form_submit_title":"Подписаться","train.remind.error_date":"Введите&nbsp;корректную&nbsp;дату","train.remind.error_car":"Пожалуйста,&nbsp;выберите<br>хотя&nbsp;бы&nbsp;один&nbsp;тип&nbsp;вагона","train.remind.error_email":"Пожалуйста, укажите корректный адрес электронной почты","train.remind.error_email_sms_send":"Обозначьте&nbsp;галочкой&nbsp;выбранный&nbsp;способ&nbsp;оповещения","train.remind.error_phone":"Пожалуйста, укажите российский номер сотового телефона.<br>Например:<br>+7 (916) 111-11-11","train.remind.error_code":"Неверный ключ","train.remind.send_error_message":"При регистрации вашей заявки произошла ошибка. Пожалуйста, попробуйте еще раз.","train.remind.send_error_title":"Заявка не зарегистрирована","train.remind.send_error_flood_message":"Сервис «Есть надежда» будет доступен Вам через 24 часа.","train.remind.send_error_flood_title":"Превышен лимит заказанных уведомлений","train.remind.send_empty":"","train.remind.any_train":"любой поезд","train.remind.any_car":"любой вагон","train.remind.car":"вагон","train.remind.cars":"вагоны","train.remind.train_number":"поезд №","train.remind.send_ok_title":"Вы успешно заказали уведомление","train.remind.send_ok":"Спасибо за заявку!<br/><br/>\n\t\t\t\t\t\t\t\t\t\t\t\t\tЕсли появятся места на %train%\n\t\t\t\t\t\t\t\t\t\t\t\t\tпо направлению %departure% → %arrival%,\n\t\t\t\t\t\t\t\t\t\t\t\t\tв %car_filter%,\n\t\t\t\t\t\t\t\t\t\t\t\t\tотправление %time_filter%, %date%,\n\t\t\t\t\t\t\t\t\t\t\t\t\tмы обязательно пришлем вам письмо на почту %email%","train.remind.send_ok_train_email_sms":"<p>Мы обязательно пришлем вам письмо на почту %email% и sms на номер %phone%, если появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_email_sms_late":"<p>Мы обязательно пришлем вам письмо на почту %email% и sms на номер %phone%, когда появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_email":"<p>Мы обязательно пришлем вам письмо на почту %email%, если появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_email_late":"<p>Мы обязательно пришлем вам письмо на почту %email%, когда появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_sms":"<p>Мы обязательно пришлем вам sms на номер %phone%, если появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_sms_late":"<p>Мы обязательно пришлем вам sms на номер %phone%, когда появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train":"<p>Мы обязательно пришлем вам письмо на почту %email%, если появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_train_late":"<p>Мы обязательно пришлем вам письмо на почту %email%, когда появятся билеты на этот поезд.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали поезд № %train% по направлению %departure% → %arrival%, отправление %date%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_dublicate_schedule":"Вы уже заказали получение уведомлений на любой поезд по направлению %departure% → %arrival%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%car_filter%, отправление %time%, %date%.","train.remind.send_dublicate_train":"Вы уже заказали получение уведомлений на поезд № %train% по направлению %departure% → %arrival%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%car_filter%, отправление %date%.","train.remind.send_ok_schedule_email_sms":"<p>Мы обязательно пришлем вам письмо на почту %email% и sms на номер %phone%, \n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tесли появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_schedule_email_sms_late":"<p>Мы обязательно пришлем вам письмо на почту %email% и sms на номер %phone%, \n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tкогда появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_schedule_email":"<p>Мы обязательно пришлем вам письмо на почту %email%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tесли появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_schedule_email_late":"<p>Мы обязательно пришлем вам письмо на почту %email%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tкогда появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_schedule_sms":"<p>Мы обязательно пришлем вам sms на номер %phone%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tесли появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.send_ok_schedule_sms_late":"<p>Мы обязательно пришлем вам sms на номер %phone%,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tкогда появятся билеты на любой поезд по этому направлению.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Вы выбрали направление %departure% → %arrival%, отправление %date% %time%.\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tБилеты в %car_filter%.</p>","train.remind.error_wrong_from_fill":"Вы заполнили форму заявки с ошибками. Будьте внимательны: все поля должны быть заполнены,\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tдаты должны быть не раньше завтрашней и дата до не должна быть раньше даты от.","train.remind.index_title":"Сообщить о появлении билетов","train.remind.empty_car_tooltip":"<p>По&nbsp;нашей информации, места в&nbsp;этом&nbsp;вагоне уже&nbsp;закончились. \n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tОни могут появиться, если кто-нибудь сдаст билет или снимет бронь.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<p>Если вы надеетесь, что билеты в&nbsp;%car_name% еще&nbsp;появятся, кликните на&nbsp;«0» и \n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tзакажите уведомление об&nbsp;этом.</p>","train.station.search.title":"Поиск станции","train.station.search.header":"Поиск станции","train.station.search.navy_title":"Поиск станции","train.station.search.limit_warning":"Показаны первые %limit% результатов. Уточните запрос и повторите поиск при необходимости.","train.mobiticket_errors.Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ОДНОМ КУПЕ":'\n\t\t<p>К сожалению, в выбранном вагоне нет нужного количества мест в одном купе.</p>\n\t\t<p>Вы можете либо снять галку «в одном купе» и искать в разных купе, либо выбрать другой вагон (<a href="%step1_url%">шаг "Выбор мест"</a>).</p>\n\t',"train.mobiticket_errors.НЕТ В ОДНОМ КУПЕ":'\n\t\t<p>К сожалению, в выбранном вагоне нет нужного количества мест в одном купе.</p>\n\t\t<p>Вы можете либо снять галку «в одном купе» и искать в разных купе, либо выбрать другой вагон (<a href="%step1_url%">шаг "Выбор мест"</a>).</p>\n\t',"train.mobiticket_errors.НИЖНИХ НЕТ (ИЛИ У ОКНА)":'\n\t\t<p>К сожалению, все нижние места в этом вагоне только что закончились. Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, либо другой поезд по этому маршруту.</p>\n\t\t<p>В случае покупки сидячих мест это сообщение означает, что закончились «места у окна». Попробуйте <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>.</p>\n\t',"train.mobiticket_errors.Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ЗАДАННЫХ ГРАНИЦАХ МЕСТ":'\n\t\t<p>К сожалению, все места <не у туалета> закончились. Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, либо другой поезд по этому маршруту.</p>\n\t\t<p>В случае плацкартного вагона эта ошибка возможно означает, что остались только боковые места. Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, либо другой поезд по этому маршруту.</p>\n\t',"train.mobiticket_errors.НЕТ В ЗАДАННЫХ ГРАНИЦАХ МЕСТ":'\n\t\t<p>К сожалению, все места «не у туалета» закончились. <a href="%step1_url%">Вернитесь на шаг "Выбор мест" и снимите галочку "не у туалета"</a>.\n\t\t<p>Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, либо другой поезд по этому маршруту.</p>\n\t\t<p>В случае плацкартного вагона эта ошибка возможно означает, что остались только боковые места. Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, либо другой поезд по этому маршруту.</p>\n\t',"train.mobiticket_errors.Может быть не больше половины нижних мест от общего числа мест в заказе.":'\n\t\t<p>К сожалению, нижних мест может быть лишь на одно больше, чем верхних. К примеру, два нижних и одно верхнее. Это требование правил РЖД.</p>\n\t\t<p>Пожалуйста, <a href="%step1_url%">выберите нужное вам количество мест</a> с учетом этого правила.</p>\n\t',"train.mobiticket_errors.На заданном направлении (или поезде) мест нет":'\n\t\t<p>В выбранном вагоне свободных мест в нужном вам количестве уже нет.\n\t\t<p>Вы можете <a href="%step1_url%">выбрать другой вагон (шаг "Выбор мест")</a>,\n\t\tлибо <a href="%schedule_url%">другую дату</a> или\n\t\t<a href="%schedule_date_url%">другой поезд</a>.\n\t\t<p>\n\t\t<br>\n\t\tЭта ошибка могла также возникнуть в случае, если вы\n\t\t<br>еще не оплатили свою предыдущую заявку в этот же вагон.\n\t\t<br>В таком случае через 15 минут места могут вернуться в систему (если не будут выкуплены кем-то другим).\n\t',"train.mobiticket_errors.Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ДOK-TA УДOCTOBEPЯЮЩEГO ЛИЧHOCTЬ":'\n\t\t<p>Пожалуйста, проверьте данные документа, удостоверяющего личность (<a href="%step2_url%">шаг "Данные пассажиров"</a>). Вы должны правильно указать тип документа, серию и номер.</p>\n\t\t<p>При этом серия и номер должны соответствовать выбранному типу документов.</p>\n\t',"train.mobiticket_errors.Некорректный формат документа":'\n\t\t<p>Пожалуйста, проверьте данные документа, удостоверяющего личность (<a href="%step2_url%">шаг "Данные пассажиров"</a>). Вы должны правильно указать тип документа, серию и номер.</p>\n\t',"train.mobiticket_errors.Приобрести билет на данный поезд через Интернет-систему в настоящий момент не представляется возможным! Приносим Вам свои извинения!":'\n\t\t<p>К сожалению, купить электронный билет на этот поезд нельзя. Вы можете выбрать <a href="%schedule_date_url%">другой поезд</a> или <a href="%step3_url%">заказать билет на бланке РЖД</a>.</p>\n\t',"train.mobiticket_errors.Не получен URL Райфайзена":'\n\t\t<p>К сожалению, произошла ошибка в системе заказа.</p>\n\t\t<p>Пожалуйста, попробуйте еще раз. Если ошибка не исчезнет - <a href="mailto: info@tutu.ru">сообщите Администратору</a>.</p>\n\t',"train.mobiticket_errors.Операция завершилась неуспешно из-за некорректных входных данных: УКАЖИ ТРЕБОВАНИЯ М/Ж":'\n\t\tПожалуйста, укажите тип нужного вам купе — мужское, женское или смешанное (<a href="%step1_url%">шаг "Выбор мест"</a>).\n\t\tЕсли ошибка не исчезает, пожалуйста, выберите другой вагон (<a href="%step1_url%">шаг "Выбор мест"</a>).\n\t',"train.mobiticket_errors.Некорректные требования к мужскому/женскому купе - выберите противоположное!":'\n\t\t<p>Пожалуйста, проверьте тип выбранного вами купе — мужское, женское или смешанное (вернуться на <a href="%step1_url%">шаг "Выбор мест"</a>).</p>\n\t',"train.mobiticket_errors.Повторное резервирование с теми же параметрами невозможно в течение 60 минут (с момента первого заказа), либо до осуществления возврата на этот заказ":"\n\t\t<p>Повторное резервирование с теми же параметрами невозможно в течение 60 минут (с момента первого заказа), либо до осуществления возврата на этот заказ</p>\n\t\tЕсли оплатить сделанный ранее заказ не представляется возможным, то можно попробовать оформить новую заявку в другой вагон.\n\t","train.mobiticket_errors.Проезд в/из указанной страны за пределами РФ возможен только по загранпаспорту (ЛАТВИЯ)":'\n\t\t<p>Для проезда по выбранному маршруту за пределы РФ вам необходим загранпаспорт – пожалуйста, <a href="%step2_url%">укажите его реквизиты (шаг "Данные пассажиров")</a>.</p>\n\t',"train.mobiticket_errors.Невозможно оформить билет: либо некорректна дата отправления поезда (Должна быть не далее 45 суток), либо до отправления поезда осталось меньше 2 часов":'\n\t\t<p>Оформление билетов возможно на поезда, отправляющиеся не ранее 2 часов и не позднее 45 суток с момента заказа.</p>\n\t\t<p>Пожалуйста, <a href="%schedule_date_url%">выберите поезд, отправляющийся в течение этого промежутка времени</a>.</p>\n\t',"train.mobiticket_errors.Необходимо уточнить станцию - введите код станции для однозначной идентификации среди списка возможных станций":'\n\t\t<p>К сожалению, произошла ошибка в системе заказа.</p>\n\t\t<p>Пожалуйста, попробуйте еще раз. Если ошибка не исчезнет - <a href="mailto: info@tutu.ru">сообщите Администратору</a>.</p>\n\t',"train.mobiticket_errors.Некорректный формат названия станции":'\n\t\t<p>К сожалению, произошла ошибка в системе заказа.</p>\n\t\t<p>Пожалуйста, попробуйте еще раз. Если ошибка не исчезнет – <a href="mailto: info@tutu.ru">сообщите Администратору</a>.</p>\n\t',"train.mobiticket_errors.Операция завершилась неуспешно из-за некорректных входных данных: НЕТ ВАГОНА С ЗАДАННЫМ НОМЕРОМ":'\n\t\t<p>К сожалению, купить электронный билет в этот вагон нельзя. Вы можете выбрать <a href="%step1_url%">другой вагон (шаг "Выбор мест")</a>, <a href="%schedule_url%">другую дату</a>, <a href="%schedule_date_url%">другой поезд</a> или <a href="%step3_url%">заказать билет на бланке РЖД</a>.</p>\n\t',"train.blank.moscow_title":"Оформление заказа билетов закончено","train.blank.spb_title":"Оформление заказа билетов закончено","train.blank.message_agency_moscow":'ЗАО "V.I.P. Сервис',"train.blank.message_worktime_moscow":"с 10:00 до 19:00 в рабочий день (понедельник - пятница).","train.blank.message_phone_moscow":"(495)&nbsp;626-41-42","train.blank.message_email_moscow":"zd_bilet_msk@tutu.ru","train.blank.message_callback_moscow":"Вы можете воспользоваться на сайте услугой «Заказ обратного звонка» (http://www.tutu.ru/feedback_bilet.php).","train.blank.message_agency_spb":'"Тревел Сити - Авиа"',"train.blank.message_worktime_spb":"","train.blank.message_phone_spb":"(812)&nbsp;495-64-84","train.blank.message_email_spb":"","train.blank.message_callback_spb":"","train.blank.ereg_verify_title":"Tutu.ru - Идентификация клиента","train.blank.blank_verify_title":"Tutu.ru - Идентификация клиента","train.blank.go_back":"Вернуться назад","train.category.top1":"верхнее","train.category.top2":"верхних","train.category.top3":"верхних","train.category.bottom1":"нижнее","train.category.bottom2":"нижних","train.category.bottom3":"нижних","train.category.seats_from_to":"в промежутке от %from% до %to%","train.category.seat_form1":"место","train.category.seat_form2":"места","train.category.seat_form3":"мест","train.category.ticket_form1":"билет","train.category.ticket_form2":"билета","train.category.ticket_form3":"билетов","train.category.with_laundry":"с&nbsp;бельем","train.category.seats_notice_select1":"о","train.category.seats_notice_select2":"ы","train.category.seats_notice_seat1":"о","train.category.seats_notice_seat2":"а","train.category.seats_notice":"Выбран%end1% %seats% мест%end2% в %carNum% вагоне","train.category.top_block_car_seats":"Места: %seats%","train.category.top_block_car_oneseat":"Место: %seats%","train.category.car_info":"№%carNumber%, %carType%.","train.category.car_info_ebilet":"№%carNumber% (%carType%),","train.category.car_info_ebilet_new_variant":"№%carNumber% (%carType%)","train.route.arrival_time":"Прибытие","train.route.stopping_time":"Стоянка","train.route.departure_time":"Отправление","train.route.travel_time":"В пути","train.route.station":"Станция","train.route.milage":"Километраж","train.landing_page_ural.fast_search":"Купить железнодорожный билет без очереди за 4 минуты","train.landing_page_ural.today_open_sales":"Сегодня открыта продажа билетов","train.landing_page_ural.fast_buy_ticket":"Узнай цены на&nbsp;ж/д&nbsp;билеты на&nbsp;Урале","train.landing_page_ural.since_customers_pay":"Так наши клиенты оплатили больше 500 000 ж/д билетов","train.landing_page_ural.time_to_buy":"4 минуты вашего<br /> времени на покупку.","train.landing_page_ural.search_and_choose_train":"Поиск и выбор поезда","train.landing_page_ural.enter_passangers":"Ввод информации о пассажирах","train.landing_page_ural.payment":"Оплата","train.landing_page_ural.min":"мин","train.landing_page_ural.city_from":"из %city%","train.landing_page_ural.city_to":"в %city%","train.landing_page_ural.support":"Телефон для справок","train.landing_page_ural.support_worktime":"с 9:00 до 21:00","train.landing_page_ural.feedback_promise":"Мы обязательно ответим вам в&nbsp;течение 24&nbsp;часов","train.landing_page_ural.landing_button":"&nbsp;&nbsp;Узнать цены&nbsp;&nbsp;","train.landing_page_ural.pop_directions":"Доступные цены в&nbsp;один клик:","train.landing_page_ural.faq_title":"Частые вопросы:","train.landing_page_ural.faq_block_1_title":"Как купить ж/д&nbsp;билет?","train.landing_page_ural.faq_block_1_text":"<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Укажите маршрут и&nbsp;дату. В&nbsp;ответ мы&nbsp;найдем информацию РЖД о&nbsp;наличии билетов и&nbsp;их&nbsp;стоимости.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите подходящий поезд и&nbsp;места.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Оплатите билет так, как вам удобно.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Информация об&nbsp;оплате будет моментально передана в&nbsp;РЖД и&nbsp;Ваш билет будет оформлен.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_ural.faq_block_2_title":"Как оплатить электронный билет?","train.landing_page_ural.faq_block_2_text_sv":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tБанковской картой\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ural.faq_block_2_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tПодойдут и&nbsp;наличные, и&nbsp;карточки, и&nbsp;электронные деньги.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tНаличными можно заплатить через терминалы Qiwi, салоны Евросети и&nbsp;т.п.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ural.faq_block_3_title":"Можно&nbsp;ли оплатить билет картой? А&nbsp;это безопасно?","train.landing_page_ural.faq_block_3_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tДа, конечно. Оплата происходит через платежный шлюз процессингового центра Gateline.net. Все данные передаются по&nbsp;защищенному каналу SSL 3.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tШлюз Gateline.net был разработан в&nbsp;соответствии с&nbsp;учетом требований международного стандарта безопасности PCI&nbsp;DSS. Это первое в&nbsp;России процессинговое программное обеспечение, которое успешно прошло аудит по&nbsp;версии 2.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tСистема Gateline.net позволяет принимать оплату картами Visa и&nbsp;MasterCard, в&nbsp;том числе с&nbsp;использованием <span class="nowrap">3D-Secure</span>: Verified by&nbsp;Visa и&nbsp;MasterCard SecureCode.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПлатежная форма Gateline.net оптимизирована под различные браузеры и&nbsp;платформы, в&nbsp;том числе и&nbsp;для мобильных устройств.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПочти все ЖД&nbsp;агентства в&nbsp;интернете работают через данный шлюз.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page_ural.faq_block_4_title":"Как получить электронный билет?","train.landing_page_ural.faq_block_4_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронному билету не&nbsp;нужна доставка. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДостаточно пройти электронную регистрацию на&nbsp;сайте или&nbsp;получить обычный билет на&nbsp;бланке в&nbsp;вокзальной кассе или&nbsp;терминале регистрации.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ural.faq_block_5_title":"Как попасть в&nbsp;поезд по&nbsp;электронному билету?","train.landing_page_ural.faq_block_5_text":"<h5>1-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля многих маршрутов доступна электронная регистрация. Это просто кнопка на&nbsp;странице после оплаты. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНажмите на&nbsp;нее, чтобы ваше имя попало в&nbsp;список у&nbsp;проводника вагона.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПри посадке покажите проводнику паспорт.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tОн&nbsp;найдет ваше ФИО в&nbsp;списке и&nbsp;пропустит в&nbsp;вагон.\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<h5>2-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tТакже после оплаты вы&nbsp;можете получить обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tСразу после оплаты мы&nbsp;отправим вам <nobr>14-значный</nobr> код (на&nbsp;почту и&nbsp;по&nbsp;СМС).\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПокажите этот код и&nbsp;паспорт в&nbsp;кассе на&nbsp;вокзале. Это можно сделать и&nbsp;за&nbsp;15&nbsp;минут до&nbsp;отправления поезда.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tКассир выдаст вам обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_ural.faq_block_6_title":"Какая у вас наценка на&nbsp;электронный билет?","train.landing_page_ural.faq_block_6_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t392,7 рубля за&nbsp;билет в&nbsp;мягкий или&nbsp;СВ вагоны,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t274,7 рубля за&nbsp;билет в&nbsp;купе, плацкарт или сидячий вагоны.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;вокзале и&nbsp;во&nbsp;всех трансагенствах также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ural.faq_block_7_title":"Вопросы про ж/д билеты  на&nbsp;бланке","train.landing_page_ural.faq_block_7_text":"<h5>Сколько стоит доставка?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Доставка билета стоит 300&nbsp;рублей в&nbsp;Москве и&nbsp;250&nbsp;рублей в&nbsp;Санкт-Петербурге.</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Можно ли забрать билет самому?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Конечно!</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;всегда рады увидеть вас в&nbsp;московском офисе на&nbsp;Бауманской или в&nbsp;питерском офисе на&nbsp;<nobr>9-й</nobr> Линии Васильевского острова.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Какая у&nbsp;вас наценка на&nbsp;билет на&nbsp;бланке?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Мы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>295 рублей в Москве,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>260 рублей в Санкт-Петербурге.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>На&nbsp;вокзале также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_ural.commersant_text":'<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tКаждый месяц 5 000 000 человек заходят на&nbsp;сайт Туту.ру, чтобы купить билеты на&nbsp;самолеты и&nbsp;поезда, забронировать отели и&nbsp;узнать расписание электричек.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tПо данным comScore и&nbsp;газеты КоммерсантЪ, Туту.ру &mdash;&nbsp;это <a href="http://www.kommersant.ru/doc/1869944">самый популярный</a> у&nbsp;россиян туристический сайт.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page_baltika.fast_search":"Ж/д билеты в Прибалтику и обратно","train.landing_page_baltika.today_open_sales":"Сегодня открыта продажа билетов","train.landing_page_baltika.fast_buy_ticket":"Ж/д билеты в&nbsp;Прибалтику и&nbsp;обратно","train.landing_page_baltika.since_customers_pay":"Так наши клиенты оплатили больше 500 000 ж/д билетов","train.landing_page_baltika.time_to_buy":"4 минуты вашего<br /> времени на покупку.","train.landing_page_baltika.search_and_choose_train":"Поиск и выбор поезда","train.landing_page_baltika.enter_passangers":"Ввод информации о пассажирах","train.landing_page_baltika.payment":"Оплата","train.landing_page_baltika.min":"мин","train.landing_page_baltika.city_from":"из %city%","train.landing_page_baltika.city_to":"в %city%","train.landing_page_baltika.support":"Телефон для справок","train.landing_page_baltika.support_worktime":"с 9:00 до 21:00","train.landing_page_baltika.feedback_promise":"Мы обязательно ответим вам в&nbsp;течение 24&nbsp;часов","train.landing_page_baltika.landing_button":"&nbsp;&nbsp;Узнать цены&nbsp;&nbsp;","train.landing_page_baltika.pop_directions":"Доступные цены в&nbsp;один клик:","train.landing_page_baltika.faq_title":"Частые вопросы:","train.landing_page_baltika.faq_block_1_title":"Как купить ж/д&nbsp;билет?","train.landing_page_baltika.faq_block_1_text":"<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Укажите маршрут и&nbsp;дату. В&nbsp;ответ мы&nbsp;найдем информацию РЖД о&nbsp;наличии билетов и&nbsp;их&nbsp;стоимости.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Выберите подходящий поезд и&nbsp;места.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Оплатите билет так, как вам удобно.</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>Информация об&nbsp;оплате будет моментально передана в&nbsp;РЖД и&nbsp;Ваш билет будет оформлен.</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_baltika.faq_block_2_title":"Как оплатить электронный билет?","train.landing_page_baltika.faq_block_2_text_sv":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tБанковской картой\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_baltika.faq_block_2_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\t\tПодойдут и&nbsp;наличные, и&nbsp;карточки, и&nbsp;электронные деньги.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tНаличными можно заплатить через терминалы Qiwi, Элекснет, салоны Евросети и&nbsp;т.п.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_baltika.faq_block_3_title":"Можно&nbsp;ли оплатить билет картой? А&nbsp;это безопасно?","train.landing_page_baltika.faq_block_3_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tДа, конечно. Оплата происходит через платежный шлюз процессингового центра Gateline.net. Все данные передаются по&nbsp;защищенному каналу SSL 3.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tШлюз Gateline.net был разработан в&nbsp;соответствии с&nbsp;учетом требований международного стандарта безопасности PCI&nbsp;DSS. Это первое в&nbsp;России процессинговое программное обеспечение, которое успешно прошло аудит по&nbsp;версии 2.0.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tСистема Gateline.net позволяет принимать оплату картами Visa и&nbsp;MasterCard, в&nbsp;том числе с&nbsp;использованием <span class="nowrap">3D-Secure</span>: Verified by&nbsp;Visa и&nbsp;MasterCard SecureCode.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПлатежная форма Gateline.net оптимизирована под различные браузеры и&nbsp;платформы, в&nbsp;том числе и&nbsp;для мобильных устройств.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tПочти все ЖД&nbsp;агентства в&nbsp;интернете работают через данный шлюз.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"train.landing_page_baltika.faq_block_4_title":"Как получить электронный билет?","train.landing_page_baltika.faq_block_4_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронному билету не&nbsp;нужна доставка. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДостаточно пройти электронную регистрацию на&nbsp;сайте или&nbsp;получить обычный билет на&nbsp;бланке в&nbsp;вокзальной кассе или&nbsp;терминале регистрации.\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_baltika.faq_block_5_title":"Как попасть в&nbsp;поезд по&nbsp;электронному билету?","train.landing_page_baltika.faq_block_5_text":"<h5>1-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля многих маршрутов доступна электронная регистрация. Это просто кнопка на&nbsp;странице после оплаты. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНажмите на&nbsp;нее, чтобы ваше имя попало в&nbsp;список у&nbsp;проводника вагона.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПри посадке покажите проводнику паспорт.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tОн&nbsp;найдет ваше ФИО в&nbsp;списке и&nbsp;пропустит в&nbsp;вагон.\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<h5>2-й вариант</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tТакже после оплаты вы&nbsp;можете получить обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tСразу после оплаты мы&nbsp;отправим вам <nobr>14-значный</nobr> код (на&nbsp;почту и&nbsp;по&nbsp;СМС).\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tПокажите этот код и&nbsp;паспорт в&nbsp;кассе на&nbsp;вокзале. Это можно сделать и&nbsp;за&nbsp;15&nbsp;минут до&nbsp;отправления поезда.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tКассир выдаст вам обычный билет на&nbsp;бланке.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;всякий случай после оплаты распечатайте с&nbsp;сайта маршрутную квитанцию.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>","train.landing_page_baltika.faq_block_6_title":"Какая у вас наценка на&nbsp;электронный билет?","train.landing_page_baltika.faq_block_6_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t392,7 рубля за&nbsp;билет в&nbsp;мягкий или&nbsp;СВ вагоны,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\t274,7 рубля за&nbsp;билет в&nbsp;купе, плацкарт или сидячий вагоны.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tНа&nbsp;вокзале и&nbsp;во&nbsp;всех трансагенствах также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_baltika.faq_block_7_title":"Вопросы про ж/д билеты  на&nbsp;бланке","train.landing_page_baltika.faq_block_7_text":"<h5>Сколько стоит доставка?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Доставка билета стоит 300&nbsp;рублей в&nbsp;Москве и&nbsp;250&nbsp;рублей в&nbsp;Санкт-Петербурге.</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Можно ли забрать билет самому?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Конечно!</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;всегда рады увидеть вас в&nbsp;московском офисе на&nbsp;Бауманской или в&nbsp;питерском офисе на&nbsp;<nobr>9-й</nobr> Линии Васильевского острова.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\n\t\t\t\t\t\t\t\t\t\t\t<h5>Какая у&nbsp;вас наценка на&nbsp;билет на&nbsp;бланке?</h5>\n\t\t\t\t\t\t\t\t\t\t\t<p>Мы&nbsp;уверены, что ваше время бесценно. А&nbsp;наши услуги по&nbsp;удобной покупке билета стоят:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>295 рублей в Москве,\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>260 рублей в Санкт-Петербурге.\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>На&nbsp;вокзале также есть сервисный агентский сбор (точную сумму можно узнать в&nbsp;кассах РЖД).\n\t\t\t\t\t\t\t\t\t\t\t</p>","train.landing_page_baltika.commersant_text":'<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tКаждый месяц 5 000 000 человек заходят на&nbsp;сайт Туту.ру, чтобы купить билеты на&nbsp;самолеты и&nbsp;поезда, забронировать отели и&nbsp;узнать расписание электричек.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p class="text_par">\n\t\t\t\t\t\t\t\t\t\t\t\tПо данным comScore и&nbsp;газеты КоммерсантЪ, Туту.ру &mdash;&nbsp;это <a href="http://www.kommersant.ru/doc/1869944">самый популярный</a> у&nbsp;россиян туристический сайт.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"avia.form_main":"Заказ авиабилетов","avia.form_schedule":"Расписание авиарейсов","avia.menu_world":"Все страны","avia.menu_gus":"СНГ","avia.carrier_title":"Авиакомпании","avia.carrier_title_country":"Авиакомпании (%country%)","avia.carrier_single":"Авиакомпания","avia.carrier_single_title":"Авиакомпания %name%: расписание рейсов, заказ авиабилетов, тарифы, продажа авиабилетов, цены на билеты,доставка, описание компании %name%","avia.common":"Общая информация","avia.comment_meta_title":"Авиакомпания %airportTitle%: %commentTitle%","avia.carrier_comment_page_title":"Авиакомпания %carrierTitle% — %commentTitle%","avia.name":"Название англ","avia.rus_name":"Название рус","avia.city":"Город","avia.iata":"IATA","avia.gsga":"IATA рус","avia.url":"URL","avia.url2":"URL2","avia.timetable":"Онлайн табло","avia.icao":"ICAO","avia.icao_r":"ICAO рус","avia.international":"Межд","avia.descr":"Дополнительно","avia.departure":"Online табло вылета","avia.arrival":"Online табло прилета","avia.info_services":"Справочные службы","avia.info":"Справочные службы","avia.country":"Страна","avia.airport":"Аэропорт базирования","avia.site":"Сайт","avia.site2":"Сайт 2","avia.base":"Аэропорт базирования","avia.title":"Название","avia.add_info":"Дополнительно","avia.timeoffset":"Сдвиг времени","avia.SaveTime":"Летнее время","avia.latitude":"Широта","avia.longitude":"Долгота","avia.code":"Кодировка в авиа системах","avia.name_rus":"Название рус","avia.city_id":"Город","avia.producter":"Производитель","avia.category":"Категория","avia.equipment":"Оборудование","avia.engine":"Двигатели","avia.noise":"Уровень шума","avia.condition":"Состояние","avia.price":"Цена","avia.new_price":"Новая цена","avia.dimensions":"Размеры","avia.capacity":"Число мест","avia.cabin":"Размеры пассажирской кабины","avia.weights":"Массы и нагрузки","avia.flight":"Летные данные","avia.wings":"Размах крыла (м)","avia.length":"Длина самолета (м)","avia.height":"Высота самолета (м)","avia.wing_square":"Площадь крыла (м<sup>2</sup>)","avia.arrows":"Угол стреловидности крыла по линии 1/4 хорд (градусы)","avia.width":"Максимальная ширина фюзеляжа (с)","avia.diametr":"Диаметр фюзеляжа","avia.variants_synonyms":"Варианты написания (синонимы)","avia.crew":"Экипаж","avia.cabin3":"Пассажиров в кабине трех классов","avia.cabin2":"Пассажиров в кабине двух классов","avia.tourist":"Пассажиров в туристическом классе","avia.economy":"Пассажиров в экономическом классе","avia.business":"Пассажиров в бизнесс классе","avia.charter":"Пассажиров в чартерном варианте","avia.vip":"Пассажиров в VIP варианте","avia.maximum":"Максимальное","avia.cabin_length":"Длина (м)","avia.cabin_width":"Максимальная ширина (м)","avia.cabin_height":"Максимальная высота (м)","avia.cabin_volume":"Объем (м<sup>3</sup>)","avia.take_off":"Взлетная (т)","avia.equip":"Пустого снаряженного (т)","avia.no_fuel":"Самолета без топлива (т)","avia.load":"Платная нагрузка (т)","avia.landing":"Посадочная (т)","avia.fuel":"<b>Заправщик</b>","avia.speed":"Крейсерская скорость (км/ч)","avia.distance":"Дальность полета с максимальной платной нагрузкой (с резервами топлива) (км)","avia.dist_maxfuel":"Дальность полета с максимальным запасом топлива (км)","avia.dist_pass":"Дальность полета с пассажирами и багажом (с резервами топлива) (км)","avia.ceiling":"Эксплуатационный потолок (м)","avia.vpp":"Потребная длина ВПП (условия МСА, на уровне моря) (м)","avia.civil":"<b>Гражданский</b>","avia.passanger":"Пассажирский","avia.regional":"Региональный","avia.middle":"Среднемагистральный","avia.long":"Дальнемагистральный","avia.cargo":"Грузовой","avia.business_avia":"Деловая авиация","avia.special_avia":"Спецназначения","avia.military":"<b>Военный</b>","avia.battle":"Боевой","avia.training":"Учебный","avia.transport":"Транспортный","avia.tipe":"Виды перевозок","avia.regular":"Регулярные","avia.chart":"Чартерные","avia.busines":"Бизнес","avia.low_cost":"Low-cost","avia.avia_taxi":"Авиатакси","avia.gruz":"Грузовые","avia.spetial":"Специальные","avia.region":"Регион","avia.information":"Информация","avia.img_min":"маленькая схема:","avia.img":"полная схема:","avia.click":"Нажмите для просмотра полной схемы","avia.terminals":"Терминалы","avia.logo":"Логотип:","avia.get_code":"Получить HTML-код!","avia.news":'<div class="heading1">Закажите авиабилеты сейчас!</div>\n\t\t\t\t\t\t\t\t\t\t<p>В партнерстве с ведущими агентствами сайт tutu.ru продает авиабилеты по России и за рубеж на все рейсы всех авиакомпаний мира.</p>\n\t\t\t\t\t\t\t\t\t\t',"avia.put_favorite_link":"Поставь удобную ссылку на эту страницу!","avia.seo_text_on_avia":'\n\n<div class="heading1">Доставка</div>\n<p>Современные авиабилеты&nbsp;&mdash; электронные и&nbsp;их&nbsp;достаточно просто распечатать перед рейсом. Большая часть авиакомпаний, представленных в&nbsp;расписании авиарейсов, продает только такие билеты.</p>\n<p>Получить их&nbsp;вы&nbsp;сможете по&nbsp;эл. почте, находясь в&nbsp;любом городе, так как Tutu.ru позволяет удаленно произвести оплату банковской картой, а&nbsp;также электронными деньгами.</p>\n<p>Доставка бумажных билетов осуществляется по&nbsp;Москве в&nbsp;пределах МКАД. Также вы&nbsp;можете забрать их&nbsp;самостоятельно в&nbsp;офисах агентств.</p>\n<p>Некоторые билеты могут быть доставлены в&nbsp;Санкт-Петербурге и&nbsp;Новосибирске. Подробная информация о&nbsp;доставке в&nbsp;регионах указывается для каждого конкретного авиарейса.</p>',"avia.charter_reises":"Чартерные рейсы","avia.from_moscow":"из Москвы","avia.all_reises":"Все чартерные рейсы из Москвы","avia.buy_tickets_to":"Купить авиабилеты в %city%","avia.selected_old_dates":"Обращаем ваше внимание, что введены даты, которые уже прошли!","avia.info_about_avia":'Информацию %ticketLink% по&nbsp;выгодным ценам%contactLink% вы найдете в&nbsp;разделе <a href="%url%">Авиа</a>',"avia.info_about_avia_contacts":", контакты","avia.info_about_avia_carriers":"авиакомпаний","avia.info_about_avia_airports":"аэропортов","avia.info_about_avia_ticket":"об авиабилетах %preposition% %countryName%","avia.dates_autoset":"<noindex>Дата установлена автоматически. Ближайший вылет %date%</noindex>","avia.dates_autoset_short":"<noindex>Дата установлена автоматически.</noindex>","avia.next_dates_for_flight":'На указанную дату нет рейсов по выбранному маршруту. Ближайшие рейсы доступны <a href="%urlPast%">%datePast%</a> %and% <a href="%urlFuture%">%dateFuture%</a>',"avia.main_airports_msk_text":'Справочная информация по&nbsp;аэропортам Москвы: адреса и&nbsp;телефоны, как&nbsp;добраться, схема парковок, онлайн-табло аэропортов\n\t\t\t\t\t\t\t\t\t&mdash;&nbsp;<a href="http://avia.tutu.ru/airport/0eadeb/">Шереметьево</a>, <a href="http://avia.tutu.ru/airport/27db84/">Домодедово</a>, <a href="http://avia.tutu.ru/airport/e8f8ff/">Внуково</a>.',"avia.main_airports_spb_text":'Подробная информация про&nbsp;аэропорт <a href="http://avia.tutu.ru/airport/39845f/">Пулково</a> в Санкт-Петербурге.',"avia.main_airports_more":'А также информация по аэропортам в&nbsp;других городах <a href="http://avia.tutu.ru/airports/rossiya/">России</a>, <a href="http://avia.tutu.ru/airport/country/gus/">СНГ</a>, <a href="http://avia.tutu.ru/airport/country/world/">всего мира</a>.',"avia.main_avia_companies":'<p class="thinp both">\n\t\t\t\t\t\t\t\t\t\tТуту.ру предлагает авиабилеты более чем 550 авиакомпаний России и&nbsp;мира.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p class="thinp">\n\t\t\t\t\t\t\t\t\t\tДля всех авиакомпаний мы указываем необходимую контактную информацию &mdash;&nbsp;телефоны, электронную почту, адреса и&nbsp;т.п.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p class="thinp">\n\t\t\t\t\t\t\t\t\t\tНапример, у&nbsp;нас есть все необходимые данные для&nbsp;пассажиров российских авиакомпаний <a href="http://avia.tutu.ru/airline/aeroflot/">Аэрофлот</a>, <a href="http://avia.tutu.ru/airline/rossiya/">Россия</a>, <a href="http://avia.tutu.ru/airline/transaero/">Трансаэро</a>, <a href="http://avia.tutu.ru/airline/s7-sibir/">S7-Сибирь</a>, <a href="http://avia.tutu.ru/airline/uralskie_avialinii/">Уральские Авиалинии</a>, <a href="http://avia.tutu.ru/airline/yuteyr/">ЮТэйр</a>, <a href="http://avia.tutu.ru/airline/yakutiya/">Якутия</a> и&nbsp;многих других.\n\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t<p class="thinp">\n\t\t\t\t\t\t\t\t\t\tКонечно, мы не&nbsp;обошли вниманием и&nbsp;зарубежных перевозчиков &mdash;&nbsp;<a href="http://avia.tutu.ru/airline/iberia/">Иберия</a>, <a href="http://avia.tutu.ru/airline/scat_air/">СКАТ</a>, <a href="http://avia.tutu.ru/airline/lufthansa/">Люфтганза</a>, <a href="http://avia.tutu.ru/airline/alitalia/">Алиталия</a>, <a href="http://avia.tutu.ru/airline/aerosvit/">Аэросвит</a>, <a href="http://avia.tutu.ru/airline/delta_air_lines/">Дельта</a>, <a href="http://avia.tutu.ru/airline/austrian_airlines/">Австрийские Авиалинии</a>, <a href="http://avia.tutu.ru/airline/air_berlin/">Эйр Берлин</a> и&nbsp;т.п.</p>',"avia.main_avia_airplane":"А еще у нас есть подробное описание более 200&nbsp;моделей пассажирских самолетов &mdash;&nbsp;с&nbsp;указанием количества мест и&nbsp;схемами расположения кресел.","avia.popular_from_moscow":"Из Москвы","avia.popular_from_piter":"Из Санкт-Петербурга","avia.avia_tickets":"Авиабилеты","avia.avia_tickets_from_moscow":"Авиабилеты из Москвы","avia.schedule_request_order":"Заказ","pager.back":"Назад","pager.more":"Еще","pager.page":"Страница","pager.next":"след.","pager.of":"из","pager.first":"первая","pager.previous":"пред.","pager.last":"последняя","pager.all":"все","pager.paged":"постр.","pager.from":"c","pager.to":"по","list.month_s.1":"Янв","list.month_s.2":"Фев","list.month_s.3":"Мар","list.month_s.4":"Апр","list.month_s.5":"Май","list.month_s.6":"Июнь","list.month_s.7":"Июль","list.month_s.8":"Авг","list.month_s.9":"Сен","list.month_s.10":"Окт","list.month_s.11":"Нояб","list.month_s.12":"Дек","list.sex_person.m":"Мужчина","list.sex_person.f":"Женщина","list.taxi.points.airport":"Аэропорт","list.taxi.points.railway":"ЖД вокзал","list.taxi.points.home":"Дом/офис","list.taxi.cars.miniven.1":"Opel Zafira","list.taxi.cars.miniven.2":"Mazda MPV","list.taxi.cars.standart.1":"Ford Focus","list.taxi.cars.standart.2":"Renault Logan","list.taxi.cars.business.1":"Mercedes C-180K","list.taxi.cars.business.2":"Mercedes E-200K","list.taxi.cars.business.3":"Toyota Camry","list.taxi.cars.business.4":"Nissan Teana","list.taxi.cars.microbus.1":"Volkswagen Transporter","list.taxi.cars.universal.1":"Ford Focus Universal","list.taxi.cars.universal.2":"Chevrolet Lacetti Universal","list.currency.RUR":"р.","list.currency.RUB":"р.","list.currency.USD":"$","list.currency.EUR":"€","list.currency.GBP":"£","list.morphology.train.0":"поезд","list.morphology.train.1":"поезда","list.morphology.train.2":"поездов","list.morphology.day.0":'<span class="miniNbsp">&nbsp;</span>день',"list.morphology.day.1":'<span class="miniNbsp">&nbsp;</span>дня',"list.morphology.day.2":'<span class="miniNbsp">&nbsp;</span>дней',"list.morphology.train_in.0":"поезде","list.morphology.train_in.1":"поездах","list.morphology.train_in.2":"поездах","list.morphology.hotel.0":"отель","list.morphology.hotel.1":"отеля","list.morphology.hotel.2":"отелей","list.morphology.city6.0":"городе","list.morphology.city6.1":"городах","list.morphology.city6.2":"городах","list.morphology.direction3.0":"направлению","list.morphology.direction3.1":"направлениям","list.morphology.direction3.2":"направлениям","list.morphology.count2.1":"Один","list.morphology.count2.2":"Оба","list.morphology.star_adj.5.nom.male.0":"пятизвездочный","list.morphology.star_adj.5.nom.male.1":"пятизвездочных","list.morphology.star_adj.5.nom.male.2":"пятизвездочных","list.morphology.star_adj.5.nom.female.0":"пятизвездочная","list.morphology.star_adj.5.nom.female.1":"пятизвездочные","list.morphology.star_adj.5.nom.female.2":"пятизвездочных","list.morphology.star_adj.5.gen.female.0":"пятизвездочной","list.morphology.star_adj.5.gen.female.1":"пятизвездочных","list.morphology.star_adj.5.gen.female.2":"пятизвездочных","list.morphology.star_adj.5.acc.male.0":"пятизвездочный","list.morphology.star_adj.5.acc.male.1":"пятизвездочных","list.morphology.star_adj.5.acc.male.2":"пятизвездочных","list.morphology.star_adj.5.acc.female.0":"пятизвездочную","list.morphology.star_adj.5.acc.female.1":"пятизвездочные","list.morphology.star_adj.5.acc.female.2":"пятизвездочных","list.morphology.star_adj.4.nom.male.0":"четырехзвездочный","list.morphology.star_adj.4.nom.male.1":"четырехзвездочных","list.morphology.star_adj.4.nom.male.2":"четырехзвездочных","list.morphology.star_adj.4.nom.female.0":"четырехзвездочная","list.morphology.star_adj.4.nom.female.1":"четырехзвездочные","list.morphology.star_adj.4.nom.female.2":"четырехзвездочных","list.morphology.star_adj.4.gen.female.0":"четырехзвездочной","list.morphology.star_adj.4.gen.female.1":"четырехзвездочных","list.morphology.star_adj.4.gen.female.2":"четырехзвездочных","list.morphology.star_adj.4.acc.male.0":"четырехзвездочный","list.morphology.star_adj.4.acc.male.1":"четырехзвездочных","list.morphology.star_adj.4.acc.male.2":"четырехзвездочных","list.morphology.star_adj.4.acc.female.0":"четырехзвездочную","list.morphology.star_adj.4.acc.female.1":"четырехзвездочные","list.morphology.star_adj.4.acc.female.2":"четырехзвездочных","list.morphology.star_adj.2.nom.male.0":"двухзвездочный","list.morphology.star_adj.2.nom.male.1":"двухзвездочных","list.morphology.star_adj.2.nom.male.2":"двухзвездочных","list.morphology.star_adj.2.nom.female.0":"двухзвездочная","list.morphology.star_adj.2.nom.female.1":"двухзвездочные","list.morphology.star_adj.2.nom.female.2":"двухзвездочных","list.morphology.star_adj.2.gen.female.0":"двухзвездочной","list.morphology.star_adj.2.gen.female.1":"двухзвездочных","list.morphology.star_adj.2.gen.female.2":"двухзвездочных","list.morphology.star_adj.2.acc.male.0":"двухзвездочный","list.morphology.star_adj.2.acc.male.1":"двухзвездочных","list.morphology.star_adj.2.acc.male.2":"двухзвездочных","list.morphology.star_adj.2.acc.female.0":"двухзвездочную","list.morphology.star_adj.2.acc.female.1":"двухзвездочные","list.morphology.star_adj.2.acc.female.2":"двухзвездочных","list.morphology.star_adj.3.nom.male.0":"трехзвездочный","list.morphology.star_adj.3.nom.male.1":"трехзвездочных","list.morphology.star_adj.3.nom.male.2":"трехзвездочных","list.morphology.star_adj.3.nom.female.0":"трехзвездочная","list.morphology.star_adj.3.nom.female.1":"трехзвездочные","list.morphology.star_adj.3.nom.female.2":"трехзвездочных","list.morphology.star_adj.3.gen.female.0":"трехзвездочной","list.morphology.star_adj.3.gen.female.1":"трехзвездочных","list.morphology.star_adj.3.gen.female.2":"трехзвездочных","list.morphology.star_adj.3.acc.male.0":"трехзвездочный","list.morphology.star_adj.3.acc.male.1":"трехзвездочных","list.morphology.star_adj.3.acc.male.2":"трехзвездочных","list.morphology.star_adj.3.acc.female.0":"трехзвездочную","list.morphology.star_adj.3.acc.female.1":"трехзвездочные","list.morphology.star_adj.3.acc.female.2":"трехзвездочных","list.morphology.star_adj.1.nom.male.0":"однозвездочный","list.morphology.star_adj.1.nom.male.1":"однозвездочных","list.morphology.star_adj.1.nom.male.2":"однозвездочных","list.morphology.star_adj.1.nom.female.0":"однозвездочная","list.morphology.star_adj.1.nom.female.1":"однозвездочные","list.morphology.star_adj.1.nom.female.2":"однозвездочных","list.morphology.star_adj.1.gen.female.0":"однозвездочной","list.morphology.star_adj.1.gen.female.1":"однозвездочных","list.morphology.star_adj.1.gen.female.2":"однозвездочных","list.morphology.star_adj.1.acc.male.0":"однозвездочный","list.morphology.star_adj.1.acc.male.1":"однозвездочных","list.morphology.star_adj.1.acc.male.2":"однозвездочных","list.morphology.star_adj.1.acc.female.0":"однозвездочную","list.morphology.star_adj.1.acc.female.1":"однозвездочные","list.morphology.star_adj.1.acc.female.2":"однозвездочных","list.morphology.currency.0":"рубль","list.morphology.currency.1":"рубля","list.morphology.currency.2":"рублей","list.morphology.currency2.0":"рубля","list.morphology.currency2.1":"рублей","list.morphology.currency2.2":"рублей","list.morphology.star.0":"звезда","list.morphology.star.1":"звезды","list.morphology.star.2":"звезд","list.morphology.railroad_station.0":"вокзал","list.morphology.railroad_station.1":"вокзала","list.morphology.railroad_station.2":"вокзалов","list.morphology.find.0":"Найден","list.morphology.find.1":"Найдено","list.morphology.find.2":"Найдено","list.morphology.minute.0":'<span class="miniNbsp">&nbsp;</span>минута',"list.morphology.minute.1":'<span class="miniNbsp">&nbsp;</span>минуты',"list.morphology.minute.2":'<span class="miniNbsp">&nbsp;</span>минут',"list.morphology.station_type.patrol_1":"разъезд","list.morphology.station_type.patrol_2":"разъезда","list.morphology.station_type.patrol_3":"разъезду","list.morphology.station_type.patrol_4":"разъезд","list.morphology.station_type.patrol_5":"разъездом","list.morphology.station_type.patrol_6":"разъезде","list.morphology.station_type.platform_1":"платформа","list.morphology.station_type.platform_2":"платформы","list.morphology.station_type.platform_3":"платформе","list.morphology.station_type.platform_4":"платформу","list.morphology.station_type.platform_5":"платформой","list.morphology.station_type.platform_6":"платформе","list.morphology.station_type.stopping_point_1":"остановочный пункт","list.morphology.station_type.stopping_point_2":"остановочного пункта","list.morphology.station_type.stopping_point_3":"остановочному пункту","list.morphology.station_type.stopping_point_4":"остановочный пункт","list.morphology.station_type.stopping_point_5":"остановочным пунктом","list.morphology.station_type.stopping_point_6":"остановочном пункте","list.morphology.station_type.station_1":"станция","list.morphology.station_type.station_2":"станции","list.morphology.station_type.station_3":"станции","list.morphology.station_type.station_4":"станцию","list.morphology.station_type.station_5":"станцией","list.morphology.station_type.station_6":"станции","list.morphology.seats.0":"свободное место","list.morphology.seats.1":"свободных места","list.morphology.seats.2":"свободных мест","list.morphology.ready.0":"готовое","list.morphology.ready.1":"готовых","list.morphology.ready.2":"готовых","list.morphology.firm.0":"фирменный","list.morphology.firm.1":"фирменных","list.morphology.firm.2":"фирменных","list.morphology.country6.0":"стране","list.morphology.country6.1":"странах","list.morphology.country6.2":"странах","list.morphology.building.0":"здание","list.morphology.building.1":"здания","list.morphology.building.2":"зданий","list.morphology.count.1":"Одна","list.morphology.count.2":"Обе","list.morphology.tickets.0":"билет","list.morphology.tickets.1":"билета","list.morphology.tickets.2":"билетов","list.morphology.available.0":"Доступен","list.morphology.available.1":"Доступно","list.morphology.available.2":"Доступно","list.morphology.hour.0":'<span class="miniNbsp">&nbsp;</span>час',"list.morphology.hour.1":'<span class="miniNbsp">&nbsp;</span>часа',"list.morphology.hour.2":'<span class="miniNbsp">&nbsp;</span>часов',"list.morphology.minute2.0":'<span class="miniNbsp">&nbsp;</span>минуту',"list.morphology.minute2.1":'<span class="miniNbsp">&nbsp;</span>минуты',"list.morphology.minute2.2":'<span class="miniNbsp">&nbsp;</span>минут',"list.morphology.preposition.to.0":"в","list.morphology.preposition.to.1":"во","list.morphology.preposition.to.2":"на","list.morphology.preposition.to.3":"до","list.morphology.preposition.from.0":"из","list.morphology.preposition.from.1":"от","list.morphology.preposition.from.2":"с","list.morphology.milage.0":"километр","list.morphology.milage.1":"километра","list.morphology.milage.2":"километров","list.week_days.0":"Вс","list.week_days.1":"Пн","list.week_days.2":"Вт","list.week_days.3":"Ср","list.week_days.4":"Чт","list.week_days.5":"Пт","list.week_days.6":"Сб","list.weekdays.0":"воскресенье","list.weekdays.1":"понедельник","list.weekdays.2":"вторник","list.weekdays.3":"среда","list.weekdays.4":"четверг","list.weekdays.5":"пятница","list.weekdays.6":"суббота","list.etrain.train_type.genitive.sputnik":"спутника","list.etrain.train_type.genitive.concept":"концепта","list.etrain.train_type.genitive.express":"экспресса","list.etrain.train_type.genitive.accelerated":"ускоренной","list.etrain.train_type.genitive.aeroExpress":"аэроэкспресса","list.etrain.train_type.genitive.regionExpress":"РЭКС","list.etrain.train_type.nominative.sputnik":"спутник","list.etrain.train_type.nominative.concept":"концепт","list.etrain.train_type.nominative.express":"экспресс","list.etrain.train_type.nominative.accelerated":"ускоренная","list.etrain.train_type.nominative.aeroExpress":"аэроэкспресс","list.etrain.train_type.nominative.regionExpress":"РЭКС","list.etrain.region_name.msk":"Москва","list.etrain.region_name.spb":"Санкт-Петербург","list.etrain.region_name.irkutsk":"Иркутск","list.etrain.region_name.voronezh":"Центральная Россия","list.etrain.region_name.kazan":"Казань","list.etrain.region_name.ekburg":"Екатеринбург","list.etrain.price.abonement_5days":'<span class="two-digits">5</span> дней',"list.etrain.price.abonement_10days":'<span class="two-digits">10</span> дней',"list.etrain.price.abonement_15days":'<span class="two-digits">15</span> дней',"list.etrain.price.abonement_20days":'<span class="two-digits">20</span> дней',"list.etrain.price.abonement_25days":'<span class="two-digits">25</span> дней',"list.etrain.price.abonement_1month":'<span class="two-digits">1</span> месяц',"list.etrain.price.abonement_2months":'<span class="two-digits">2</span> месяца',"list.etrain.price.abonement_3months":'<span class="two-digits">3</span> месяца',"list.etrain.price.abonement_4months":'<span class="two-digits">4</span> месяца',"list.etrain.price.abonement_5months":'<span class="two-digits">5</span> месяцев',"list.etrain.price.abonement_6months":'<span class="two-digits">6</span> месяцев',"list.etrain.price.abonement_12months":'<span class="two-digits">12</span> месяцев',"list.etrain.price.abonement_5dates":'<span class="two-digits">5</span> дат',"list.etrain.price.abonement_6dates":'<span class="two-digits">6</span> дат',"list.etrain.price.abonement_7dates":'<span class="two-digits">7</span> дат',"list.etrain.price.abonement_8dates":'<span class="two-digits">8</span> дат',"list.etrain.price.abonement_9dates":'<span class="two-digits">9</span> дат',"list.etrain.price.abonement_10dates":'<span class="two-digits">10</span> дат',"list.etrain.price.abonement_11dates":'<span class="two-digits">11</span> дат',"list.etrain.price.abonement_12dates":'<span class="two-digits">12</span> дат',"list.etrain.price.abonement_13dates":'<span class="two-digits">13</span> дат',"list.etrain.price.abonement_14dates":'<span class="two-digits">14</span> дат',"list.etrain.price.abonement_15dates":'<span class="two-digits">15</span> дат',"list.etrain.price.abonement_16dates":'<span class="two-digits">16</span> дат',"list.etrain.schedule.seo.work.0":"рабочим","list.etrain.schedule.seo.work.1":"будним","list.etrain.schedule.seo.is.0":"равна","list.etrain.schedule.seo.is.1":"&mdash;","list.etrain.schedule.seo.five.0":"5","list.etrain.schedule.seo.five.1":"пяти","list.etrain.schedule.seo.twelve.0":"12","list.etrain.schedule.seo.twelve.1":"двенадцати","list.etrain.schedule.seo.change.0":"варьируется","list.etrain.schedule.seo.change.1":"изменяется","list.etrain.schedule.seo.usual.0":"обычную электричку","list.etrain.schedule.seo.usual.1":"обычный электропоезд","list.etrain.schedule.seo.usual.2":"обычный пригородный поезд","list.etrain.schedule.seo.price.0":"Стоимость","list.etrain.schedule.seo.price.1":"Цена","list.etrain.schedule.seo.from_to.0":"Также до %to% из %from%","list.etrain.schedule.seo.from_to.1":"Также из %from% до %to%","list.etrain.schedule.seo.from_to.2":"Из %from% до %to%","list.etrain.schedule.seo.from_to.3":"До %to% из %from%","list.etrain.schedule.seo.average.0":"Приблизительное","list.etrain.schedule.seo.average.1":"Примерное","list.etrain.schedule.station.seo.simple_train.0":"обычную электричку","list.etrain.schedule.station.seo.simple_train.1":"обычный электропоезд","list.etrain.schedule.station.seo.simple_train.2":"обычный пригородный поезд","list.etrain.schedule.station.seo.know.0":"сможете узнать","list.etrain.schedule.station.seo.know.1":"узнаете","list.etrain.schedule.station.seo.dep_and_arr.0":"отправления/прибытия","list.etrain.schedule.station.seo.dep_and_arr.1":"прибытия/отправления","list.etrain.schedule.station.seo.follow.0":"курсируют","list.etrain.schedule.station.seo.follow.1":"следуют","list.etrain.schedule.station.seo.see.0":"посмотреть","list.etrain.schedule.station.seo.see.1":"увидеть","list.etrain.schedule.station.seo.see.2":"узнать","list.etrain.schedule.station.seo.blue_and_green_train.0":"спутники и&nbsp;экспрессы","list.etrain.schedule.station.seo.blue_and_green_train.1":"экспрессы и&nbsp;спутники","list.etrain.schedule.station.seo.route.0":"направлениям","list.etrain.schedule.station.seo.route.1":"маршрутам","list.etrain.msk.direction.6.phones":'<p class="phone"><span class="small">(499)</span> 266-03-00</p><p class="phone"><span class="small">(495)</span> 251-60-93</p>',"list.etrain.msk.direction.3.phones":'<p class="phone"><span class="small">(495)</span> 950-37-00</p><p class="phone"><span class="small">(495)</span> 235-05-22</p>',"list.etrain.msk.direction.8.phones":'<p class="phone"><span class="small">(495)</span> 262-91-43</p>',"list.etrain.msk.direction.7.phones":'<p class="phone"><span class="small">(495)</span> 631-15-88</p><p class="phone"><span class="small">(499)</span> 266-85-00</p>',"list.etrain.msk.direction.4.phones":'<p class="phone"><span class="small">(499)</span> 266-53-10</p><p class="phone"><span class="small">(495)</span> 916-20-03</p>',"list.etrain.msk.direction.5.phones":'<p class="phone"><span class="small">(499)</span> 240-70-71</p>',"list.etrain.msk.direction.1.phones":'<p class="phone"><span class="small">(495)</span> 916-20-03</p><p class="phone"><span class="small">(499)</span> 266-53-10</p>',"list.etrain.msk.direction.10.phones":'<p class="phone"><span class="small">(499)</span> 266-63-00</p><p class="phone"><span class="small">(495)</span> 621-59-14</p>',"list.etrain.msk.direction.2.phones":'<p class="phone"><span class="small">(499)</span> 266-31-81</p><p class="phone"><span class="small">(499)</span> 266-23-00</p><p class="phone"><span class="small">(495)</span> 264-66-56</p>',"list.etrain.msk.direction.9.phones":'<p class="phone"><span class="small">(495)</span> 973-84-82</p><p class="phone"><span class="small">(499)</span> 266-81-00</p>',"list.etrain.msk.direction.11.phones":'<p class="phone">8 800 775-00-00</p>',"list.etrain.msk.price.once":"Разовый билет","list.etrain.msk.price.once_description":'Для&nbsp;однократной поездки по&nbsp;выбранному маршруту в&nbsp;выбранную дату, оформляется в&nbsp;день поездки или&nbsp;предварительно. Также возможно приобретение билета "туда-обратно" (с&nbsp;удвоенной стоимостью).',"list.etrain.msk.price.once_grace":"Разовый льготный","list.etrain.msk.price.once_grace_description":"Для&nbsp;студентов и&nbsp;школьников в&nbsp;период предоставления льготы (как&nbsp;правило, с&nbsp;1&nbsp;сентября по&nbsp;15&nbsp;июня) и&nbsp;для&nbsp;некоторых региональных льготников.","list.etrain.msk.price.10trips":"10 поездок","list.etrain.msk.price.10trips_description":"Действителен в&nbsp;течение 30&nbsp;дней.","list.etrain.msk.price.20trips":"20 поездок","list.etrain.msk.price.20trips_description":"Действителен в&nbsp;течение 30&nbsp;дней.","list.etrain.msk.price.60trips":"60 поездок","list.etrain.msk.price.60trips_description":"Действителен в&nbsp;течение 60&nbsp;дней.","list.etrain.msk.price.90trips":"90 поездок","list.etrain.msk.price.90trips_description":"Действителен в&nbsp;течение 60&nbsp;дней.","list.etrain.msk.price.once_aeroexpress":"1 поездка","list.etrain.msk.price.once_children_aeroexpress":"1 поездка детский","list.etrain.msk.price.once_family_aeroexpress":'1 поездка "Семейный"',"list.etrain.msk.price.once_business_aeroexpress":"1 поезда в бизнес-классе","list.etrain.msk.price.2trips_aeroexpress":"2 поездки (туда-обратно)","list.etrain.msk.price.abonement_aeroexpress":"Абонемент на 30 дней","list.etrain.msk.price.metro_aeroexpress":"Плюс метро","list.etrain.msk.price.cross_airport_aeroexpress":"Межаэропортовый","list.etrain.msk.price.travel_aeroexpress":"Командировочный","list.etrain.msk.price.two_ways_one_day":"Туда-обратно 1 день","list.etrain.msk.price.once_children":"Разовый детский","list.etrain.msk.price.once_children_description":"Для&nbsp;детей от&nbsp;5 до&nbsp;7&nbsp;лет.","list.etrain.msk.price.two_ways_children":"Туда-обратно детский","list.etrain.msk.price.once_pension":"Разовый пенсионный","list.etrain.msk.price.once_pension_description":"Действует только по&nbsp;выходным дням в&nbsp;дачный сезон для&nbsp;пенсионеров по&nbsp;возрасту (независимо от&nbsp;места проживания).","list.etrain.msk.price.big_moscow":'"Большая Москва" на месяц',"list.etrain.msk.price.big_moscow_description":"Дает право совершения неограниченного числа поездок по&nbsp;всем направлениям в&nbsp;пределах 25&nbsp;км от&nbsp;московских вокзалов (а&nbsp;также по&nbsp;маршрутам Москва&nbsp;-&nbsp;Балашиха, Москва&nbsp;-&nbsp;Бутово) на&nbsp;всех&nbsp;электричках, кроме&nbsp;спутников, концептов и&nbsp;экспрессов.","list.etrain.msk.price.animal_bike":"Живность/Велосипед","list.etrain.msk.price.baggage":"Ручная кладь","list.etrain.msk.price.abonement_weekend":"Абон. выходного дня","list.etrain.msk.price.abonement_weekend_description":"Дает право совершения неограниченного числа поездок по&nbsp;выбранному маршруту в&nbsp;течение месяца <b>по&nbsp;выходным дням (в&nbsp;том числе по&nbsp;праздникам), а&nbsp;также в&nbsp;день, предшествующий выходному, и&nbsp;в&nbsp;день, следующий за&nbsp;выходным</b>.","list.etrain.msk.price.abonement_weekend_children":"Абон. выходного дня детский","list.etrain.msk.price.free":'Абонемент "Свободный" на месяц',"list.etrain.msk.price.free_description":"Оформляется на все маршруты Тверской области, а также на маршрут Москва - Тверь","list.etrain.msk.station_railway.101":"Белорусский вокзал","list.etrain.msk.station_railway.56008":"Курский вокзал","list.etrain.msk.station_railway.7402":"Казанский вокзал","list.etrain.msk.station_railway.16503":"Киевский вокзал","list.etrain.msk.station_railway.79310":"Ленинградский вокзал","list.etrain.msk.station_railway.83511":"Павелецкий вокзал","list.etrain.msk.station_railway.35605":"Рижский вокзал","list.etrain.msk.station_railway.28604":"Савеловский вокзал","list.etrain.msk.station_railway.45807":"Ярославский вокзал","list.etrain.msk.direction.6":"Белорусское направление","list.etrain.msk.direction.1":"Горьковское направление","list.etrain.msk.direction.2":"Казанское направление","list.etrain.msk.direction.5":"Киевское направление","list.etrain.msk.direction.4":"Курское направление","list.etrain.msk.direction.8":"Ленинградское направление","list.etrain.msk.direction.3":"Павелецкое направление","list.etrain.msk.direction.7":"Рижское направление","list.etrain.msk.direction.9":"Савеловское направление","list.etrain.msk.direction.10":"Ярославское направление","list.etrain.msk.direction.11":"Кольцевое направление","list.etrain.msk.railway.6":"Белорусский вокзал","list.etrain.msk.railway.1":"Курский вокзал","list.etrain.msk.railway.2":"Казанский вокзал","list.etrain.msk.railway.5":"Киевский вокзал","list.etrain.msk.railway.4":"Курский вокзал","list.etrain.msk.railway.8":"Ленинградский вокзал","list.etrain.msk.railway.3":"Павелецкий вокзал","list.etrain.msk.railway.7":"Рижский вокзал","list.etrain.msk.railway.9":"Савеловский вокзал","list.etrain.msk.railway.10":"Ярославский вокзал","list.etrain.aeroexpress.airport_terminal.3":"Терминал 2 (F)","list.etrain.aeroexpress.railway.1":"Белорусский вокзал","list.etrain.aeroexpress.railway.2":"Савеловский вокзал","list.etrain.aeroexpress.railway.3":"Павелецкий вокзал","list.etrain.aeroexpress.railway.4":"Киевский вокзал","list.etrain.aeroexpress.airport.3":"Шереметьево","list.etrain.aeroexpress.airport.2":"Домодедово","list.etrain.aeroexpress.airport.1":"Внуково","list.etrain.spb.direction.3.phones":'<p class="phone"><span class="small">(812)</span> 436-53-10</p>',"list.etrain.spb.direction.4.phones":'<p class="phone"><span class="small">(812)</span> 457-44-28, <span class="small">(812)</span> 457-46-63</p>',"list.etrain.spb.direction.5.phones":'<p class="phone"><span class="small">(812)</span> 457-79-00, <span class="small">(812)</span> 436-69-00</p>',"list.etrain.spb.direction.1.phones":'<p class="phone"><span class="small">(812)</span> 457-28-59</p>',"list.etrain.spb.direction.2.phones":'<p class="phone"><span class="small">(812)</span> 457-79-00</p>',"list.etrain.spb.price.once":"Разовый билет","list.etrain.spb.price.once_description":'Для&nbsp;однократной поездки по&nbsp;выбранному маршруту в&nbsp;выбранную дату, оформляется <b>в&nbsp;билетных кассах или&nbsp;терминалах самообслуживания</b> в&nbsp;день поездки или&nbsp;предварительно. Также возможно приобретение билета "туда-обратно" (с&nbsp;удвоенной стоимостью).',"list.etrain.spb.price.once_train_description":"Для&nbsp;однократной поездки по&nbsp;выбранному маршруту в&nbsp;выбранную дату, оформляется в&nbsp;поезде кассиром-контролером в&nbsp;момент осуществления поездки.","list.etrain.spb.price.once_grace":"Школьный, студенческий","list.etrain.spb.price.once_grace_description":"Для&nbsp;студентов и&nbsp;школьников в&nbsp;период предоставления льготы (как&nbsp;правило, с&nbsp;1&nbsp;сентября по&nbsp;15&nbsp;июня)","list.etrain.spb.price.once_children":"Детский","list.etrain.spb.price.once_children_description":"Для&nbsp;детей от&nbsp;5 до&nbsp;7&nbsp;лет.","list.etrain.spb.price.10trips":"10 поездок","list.etrain.spb.price.10trips_description":"Действителен в&nbsp;течение 30&nbsp;дней.","list.etrain.spb.price.20trips":"20 поездок","list.etrain.spb.price.20trips_description":"Действителен в&nbsp;течение 30&nbsp;дней.","list.etrain.spb.price.60trips":"60 поездок","list.etrain.spb.price.60trips_description":"Действителен в&nbsp;течение 60&nbsp;дней.","list.etrain.spb.price.90trips":"90 поездок","list.etrain.spb.price.90trips_description":"Действителен в&nbsp;течение 60&nbsp;дней.","list.etrain.spb.price.once_grace_pension_spb":"Льготники, пенсионеры СПб","list.etrain.spb.price.once_grace_spb_area":"Льготники Лен. области","list.etrain.spb.price.animal_bike":"Живность/Велосипед","list.etrain.spb.price.baggage":"Ручная кладь","list.etrain.spb.price.once_pension_spb_area":"Пенсионеры Лен. области","list.etrain.spb.station_railway.101":"Балтийский вокзал","list.etrain.spb.station_railway.13302":"Витебский вокзал","list.etrain.spb.station_railway.25003":"Ладожский вокзал","list.etrain.spb.station_railway.35004":"Московский вокзал","list.etrain.spb.station_railway.40105":"Финляндский вокзал","list.etrain.spb.direction.1":"Балтийское направление","list.etrain.spb.direction.2":"Витебское направление","list.etrain.spb.direction.3":"Ладожское направление","list.etrain.spb.direction.4":"Московское направление","list.etrain.spb.direction.5":"Финляндское направление","list.etrain.spb.railway.1":"Балтийский вокзал","list.etrain.spb.railway.2":"Витебский вокзал","list.etrain.spb.railway.3":"Ладожский вокзал","list.etrain.spb.railway.4":"Московский вокзал","list.etrain.spb.railway.5":"Финляндский вокзал","list.sezon_name.winter":"зима %year%","list.sezon_name.winter_spring":"зима-весна %year%","list.sezon_name.spring":"весна %year%","list.sezon_name.summer":"лето %year%","list.sezon_name.summer_autumn":"лето-осень %year%","list.sezon_name.autumn":"осень %year%","list.sezon_name.autumn_winter":"осень-зима %year%","list.yesno.0":"Нет","list.yesno.1":"Да","list.date.timeday.позавчера":"-2d","list.date.timeday.вчера":"-1d","list.date.timeday.сегодня":"0d","list.date.timeday.завтра":"+1d","list.date.timeday.послезавтра":"+2d","list.date.timeday.today":"0d","list.date.timeday.tomorrow":"+1d","list.date.timeday.day_after_tomorrow":"+2d","list.date.month_gen.1":"января","list.date.month_gen.2":"февраля","list.date.month_gen.3":"марта","list.date.month_gen.4":"апреля","list.date.month_gen.5":"мая","list.date.month_gen.6":"июня","list.date.month_gen.7":"июля","list.date.month_gen.8":"августа","list.date.month_gen.9":"сентября","list.date.month_gen.10":"октября","list.date.month_gen.11":"ноября","list.date.month_gen.12":"декабря","list.date.month.accusative.1":"январь","list.date.month.accusative.2":"февраль","list.date.month.accusative.3":"март","list.date.month.accusative.4":"апрель","list.date.month.accusative.5":"май","list.date.month.accusative.6":"июнь","list.date.month.accusative.7":"июль","list.date.month.accusative.8":"август","list.date.month.accusative.9":"сентябрь","list.date.month.accusative.10":"октябрь","list.date.month.accusative.11":"ноябрь","list.date.month.accusative.12":"декабрь","list.date.month.instrumental.1":"январем","list.date.month.instrumental.2":"февралем","list.date.month.instrumental.3":"мартом","list.date.month.instrumental.4":"апрелем","list.date.month.instrumental.5":"маем","list.date.month.instrumental.6":"июнем","list.date.month.instrumental.7":"июлем","list.date.month.instrumental.8":"августом","list.date.month.instrumental.9":"сентябрем","list.date.month.instrumental.10":"октябрем","list.date.month.instrumental.11":"ноябрем","list.date.month.instrumental.12":"декабрем","list.date.month.short.1":"янв","list.date.month.short.2":"фев","list.date.month.short.3":"мар","list.date.month.short.4":"апр","list.date.month.short.5":"май","list.date.month.short.6":"июн","list.date.month.short.7":"июл","list.date.month.short.8":"авг","list.date.month.short.9":"сен","list.date.month.short.10":"окт","list.date.month.short.11":"ноя","list.date.month.short.12":"дек","list.date.month.prepositional.1":"январе","list.date.month.prepositional.2":"феврале","list.date.month.prepositional.3":"марте","list.date.month.prepositional.4":"апреле","list.date.month.prepositional.5":"мае","list.date.month.prepositional.6":"июне","list.date.month.prepositional.7":"июле","list.date.month.prepositional.8":"августе","list.date.month.prepositional.9":"сентябре","list.date.month.prepositional.10":"октябре","list.date.month.prepositional.11":"ноябре","list.date.month.prepositional.12":"декабре","list.date.month.dative.1":"январю","list.date.month.dative.2":"февралю","list.date.month.dative.3":"марту","list.date.month.dative.4":"апрелю","list.date.month.dative.5":"маю","list.date.month.dative.6":"июню","list.date.month.dative.7":"июлю","list.date.month.dative.8":"августу","list.date.month.dative.9":"сентябрю","list.date.month.dative.10":"октябрю","list.date.month.dative.11":"ноябрю","list.date.month.dative.12":"декабрю","list.date.month.genitive.1":"января","list.date.month.genitive.2":"февраля","list.date.month.genitive.3":"марта","list.date.month.genitive.4":"апреля","list.date.month.genitive.5":"мая","list.date.month.genitive.6":"июня","list.date.month.genitive.7":"июля","list.date.month.genitive.8":"августа","list.date.month.genitive.9":"сентября","list.date.month.genitive.10":"октября","list.date.month.genitive.11":"ноября","list.date.month.genitive.12":"декабря","list.date.month.nominative.1":"январь","list.date.month.nominative.2":"февраль","list.date.month.nominative.3":"март","list.date.month.nominative.4":"апрель","list.date.month.nominative.5":"май","list.date.month.nominative.6":"июнь","list.date.month.nominative.7":"июль","list.date.month.nominative.8":"август","list.date.month.nominative.9":"сентябрь","list.date.month.nominative.10":"октябрь","list.date.month.nominative.11":"ноябрь","list.date.month.nominative.12":"декабрь","list.date.weekday.accusative.0":"воскресенье","list.date.weekday.accusative.1":"понедельник","list.date.weekday.accusative.2":"вторник","list.date.weekday.accusative.3":"среду","list.date.weekday.accusative.4":"четверг","list.date.weekday.accusative.5":"пятницу","list.date.weekday.accusative.6":"субботу","list.date.weekday.instrumental.0":"воскресеньем","list.date.weekday.instrumental.1":"понедельником","list.date.weekday.instrumental.2":"вторником","list.date.weekday.instrumental.3":"средой","list.date.weekday.instrumental.4":"четвергом","list.date.weekday.instrumental.5":"пятницей","list.date.weekday.instrumental.6":"субботой","list.date.weekday.short.0":"вс","list.date.weekday.short.1":"пн","list.date.weekday.short.2":"вт","list.date.weekday.short.3":"ср","list.date.weekday.short.4":"чт","list.date.weekday.short.5":"пт","list.date.weekday.short.6":"сб","list.date.weekday.prepositional.0":"воскресенье","list.date.weekday.prepositional.1":"понедельнике","list.date.weekday.prepositional.2":"вторнике","list.date.weekday.prepositional.3":"среде","list.date.weekday.prepositional.4":"четверге","list.date.weekday.prepositional.5":"пятнице","list.date.weekday.prepositional.6":"субботе","list.date.weekday.dative.0":"воскресенью","list.date.weekday.dative.1":"понедельнику","list.date.weekday.dative.2":"вторнику","list.date.weekday.dative.3":"среде","list.date.weekday.dative.4":"четвергу","list.date.weekday.dative.5":"пятнице","list.date.weekday.dative.6":"субботе","list.date.weekday.genitive.0":"воскресенья","list.date.weekday.genitive.1":"понедельника","list.date.weekday.genitive.2":"вторника","list.date.weekday.genitive.3":"среды","list.date.weekday.genitive.4":"четверга","list.date.weekday.genitive.5":"пятницы","list.date.weekday.genitive.6":"субботы","list.date.weekday.nominative.0":"воскресенье","list.date.weekday.nominative.1":"понедельник","list.date.weekday.nominative.2":"вторник","list.date.weekday.nominative.3":"среда","list.date.weekday.nominative.4":"четверг","list.date.weekday.nominative.5":"пятница","list.date.weekday.nominative.6":"суббота","list.contact.phone_type.phone":"Телефон","list.contact.phone_type.fax":"Факс","list.contact.phone_type.telex":"Телекс","list.month_p.1":"Января","list.month_p.2":"Февраля","list.month_p.3":"Марта","list.month_p.4":"Апреля","list.month_p.5":"Мая","list.month_p.6":"Июня","list.month_p.7":"Июля","list.month_p.8":"Августа","list.month_p.9":"Сентября","list.month_p.10":"Октября","list.month_p.11":"Ноября","list.month_p.12":"Декабря","list.train.category.attribute.title_БМ":'<span class="small" style="display:block;">(без указания места)</span>',"list.train.category.attribute.title_И":'<span class="small" style="display:block;">Купе для лиц с ограниченными физическими возможностями<br/>(Билеты продаются в специализированных кассах.)</span>',"list.train.category.attribute.title_МЖ":'<span class="small" style="display:block;">(мужское/женское купе)</span>',"list.train.category.attribute.description_БМ":"без указания конкретного места в вагоне","list.train.category.attribute.description_И":"","list.train.category.attribute.description_МЖ":"продажа купе с мужскими/женскими местами","list.train.category.name.title_6":"Мягкий","list.train.category.name.title_5":"Люкс","list.train.category.name.title_4":"Купе","list.train.category.name.title_3":"Плацкарт","list.train.category.name.title_2":"Общий","list.train.category.name.title_1":"Сидячий","list.train.category.name.sedentary":"Сидячий","list.train.category.name.common":"Общий","list.train.category.name.plazcard":"Плацкарт","list.train.category.name.coupe":"Купе","list.train.category.name.lux":"Люкс","list.train.category.name.soft":"Мягкий","list.train.category.name.title_small_6":"мягкий","list.train.category.name.title_small_5":"люкс","list.train.category.name.title_small_4":"купе","list.train.category.name.title_small_3":"плацкарт","list.train.category.name.title_small_2":"общий","list.train.category.name.title_small_1":"сидячий","list.train.category.name.car_small_prepositional_6":"мягком","list.train.category.name.car_small_prepositional_5":"люксе","list.train.category.name.car_small_prepositional_4":"купе","list.train.category.name.car_small_prepositional_3":"плацкарте","list.train.category.name.car_small_prepositional_2":"общем","list.train.category.name.car_small_prepositional_1":"сидячем","list.train.category.name.title_short_6":"Мягк","list.train.category.name.title_short_5":"Люкс","list.train.category.name.title_short_4":"Купе","list.train.category.name.title_short_3":"Плац","list.train.category.name.title_short_2":"Общ","list.train.category.name.title_short_1":"Сид","list.train.category.name.car_title_small_6":"мягкий","list.train.category.name.car_title_small_5":"люкс","list.train.category.name.car_title_small_4":"купейный","list.train.category.name.car_title_small_3":"плацкартный","list.train.category.name.car_title_small_2":"общий","list.train.category.name.car_title_small_1":"сидячий","list.train.category.name.car_title_small_car_6":"мягкий вагон","list.train.category.name.car_title_small_car_5":"вагон люкс","list.train.category.name.car_title_small_car_4":"купейный вагон","list.train.category.name.car_title_small_car_3":"плацкартный вагон","list.train.category.name.car_title_small_car_2":"общий вагон","list.train.category.name.car_title_small_car_1":"сидячий вагон","list.train.category.service.title_1А":'VIP <span class="gray sm_type">(1А)</span><br/><span class="small gray wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером</span>',"list.train.category.service.title_1Б":'<span class="gray sm_type">(1Б)</span><br/><span class="small gray wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером</span>',"list.train.category.service.title_1Л":'<span class="gray sm_type">(1Л)</span><br><span class="small gray">с&nbsp;кондиционером</span>',"list.train.category.service.title_1М":'<span class="gray sm_type">(1М)</span>',"list.train.category.service.title_1Н":'Премиум-класс <span class="gray sm_type">(1Н)</span><br/><span class="small gray wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером, горячий&nbsp;завтрак</span>',"list.train.category.service.title_1У":'Первый класс <span class="gray sm_type">(1У)</span><br/><span class="small gray">без&nbsp;питания</span>',"list.train.category.service.title_1С":'Бизнес-класс <span class="gray sm_type">(1С)</span><br/><span class="small gray wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером</span>',"list.train.category.service.title_2Э":'Эконом-класс <span class="gray sm_type">(2Э)</span><br/><span class="small gray wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером</span>',"list.train.category.service.title_2У":'<span class="gray sm_type">(2У)</span><br/><span class="small gray">с&nbsp;услугами</span>',"list.train.category.service.title_2Л":'<span class="gray sm_type">(2Л)</span><br/><span class="small gray">с&nbsp;кондиционером</span>',"list.train.category.service.title_2К":'<span class="gray sm_type">(2К)</span>',"list.train.category.service.title_2Е":'Эконом-класс <span class="gray sm_type">(2Е</span><br/><span class="small wspace_norm">с&nbsp;услугами, с&nbsp;кондиционером</span>',"list.train.category.service.title_2В":'<span class="gray sm_type">(2В)</span><br/><span class="small">с&nbsp;кондиционером</span>',"list.train.category.service.title_2С":'<span class="gray sm_type">(2С)</span><br/><span class="small">с&nbsp;кондиционером</span>',"list.train.category.service.title_3Э":'<span class="gray sm_type">(3Э)</span><br/><span class="small">с&nbsp;кондиционером</span>',"list.train.category.service.title_3П":'<span class="gray sm_type">(3П)</span>',"list.train.category.service.title_3О":'<span class="gray sm_type">(3О)</span>',"list.train.category.service.title_3У":'<span class="gray sm_type">(3У)</span>',"list.train.category.service.title_3С":'<span class="gray sm_type">(3С)</span>',"list.train.category.service.title_2Р":'<span class="gray sm_type">(2Р)</span>',"list.train.category.service.title_1Г":'<span class="gray sm_type">(1Г)</span>',"list.train.category.service.title_2Т":'<span class="gray sm_type">(2Т)</span>',"list.train.category.service.title_1И":'<span class="gray sm_type">(1И)</span>',"list.train.category.service.description_1А":"VIP (с&nbsp;кондиционером)","list.train.category.service.description_1Б":"Бизнес-класс (вагон&nbsp;СВ с&nbsp;услугами, с&nbsp;кондиционером)","list.train.category.service.description_1Л":"(вагон&nbsp;СВ без&nbsp;услуг, с&nbsp;кондиционером)","list.train.category.service.description_1М":"Продается только целое купе (в&nbsp;купе возможно оформить проезд на&nbsp;одного или двух пассажиров)","list.train.category.service.description_1Н":"Премиум (От&nbsp;8 до&nbsp;9 двухместных купе в&nbsp;вагоне. В&nbsp;стоимость входит горячий завтрак)","list.train.category.service.description_1У":"Первый класс — стандарт ( Без&nbsp;питания)","list.train.category.service.description_1С":"Бизнес-класс (вагон с&nbsp;услугами, с&nbsp;кондиционером)","list.train.category.service.description_2Э":"Эконом-класс (вагон с&nbsp;услугами, с&nbsp;кондиционером)","list.train.category.service.description_2У":"(вагон с&nbsp;услугами)","list.train.category.service.description_2Л":"(вагон без&nbsp;услуг, с&nbsp;кондиционером)","list.train.category.service.description_2К":"(вагон без&nbsp;услуг)","list.train.category.service.description_2Е":"Эконом-класс (вагон с&nbsp;услугами, с&nbsp;кондиционером)","list.train.category.service.description_2В":"Вагон с&nbsp;услугами","list.train.category.service.description_2С":"Вагон без услуг (с&nbsp;кондиционером)","list.train.category.service.description_3Э":"(с&nbsp;кондиционером)","list.train.category.service.description_3П":"","list.train.category.service.description_3О":"Общий","list.train.category.service.title_type1_2У":"","list.train.category.service.title_type1_2К":'<span class="small gray">стандарт</span>',"list.train.category.service.title_type1_2Л":'<span class="small gray">с&nbsp;кондиционером</span>',"list.train.category.type.title_У":"повышенной комфортности","list.train.category.type.title_Б":"бизнес-класс","list.train.category.type.title_Э":"эконом-класс","list.train.category.type.title_Ф":"фирменный вагон","list.train.category.type.title_НФ":"нефирменный вагон фирменного поезда","list.train.category.type.description_У":"вагон повышенной комфортности (с дополнительными услугами)","list.train.category.type.description_Б":"вагон бизнес-класса","list.train.category.type.description_Э":"вагон эконом-класса","list.train.category.type.description_Ф":"фирменный вагон","list.train.category.type.description_НФ":"нефирменный вагон фирменного поезда","list.train.category.type.title_type1_У":"","list.train.order.status.eticket.overdue":"Просрочен","list.train.order.status.eticket.notpaid":"Ожидает оплаты","list.train.order.status.eticket.overduenotpaid":"Не оплачен","list.train.order.status.eticket.approved":"Оформлен","list.train.order.status.eticket.paid":"Оплачен","list.train.order.status.eticket.canceled":"Обрабатывается системой","list.train.order.status.eticket.notprocessed":"Обрабатывается системой","list.train.order.status.eticket.processed":"Обработан","list.train.order.status.eticket.deleted":"Удален оператором","list.train.order.status.eticket.process":"Обрабатывается системой","list.train.order.status.eticket.created":"Обрабатывается системой","list.train.order.status.eticket.failed":"Ошибка","list.train.order.status.eticket.sent":"Обрабатывается системой","list.train.order.status.eticket.error":"Ошибка при обработке","list.train.order.status.eticket.preprocessed":"Ожидает оплаты","list.train.order.status.eticket.not_issued":"Неоформлен","list.train.order.status.eticket.expired":"Просрочен","list.train.order.status.eticket.100":"Отменен","list.train.order.status.eticket.101":"Отменен","list.train.order.status.eticket.102":"Оператору не удалось дозвониться","list.train.order.status.eticket.103":"Отменен","list.train.order.status.eticket.104":"Отменен","list.train.order.status.eticket.105":"Отменен","list.train.order.status.eticket.106":"Отменен","list.train.order.status.eticket.107":"Отменен","list.train.order.status.eticket.108":"Отменен","list.train.order.status.eticket.109":"Отменен","list.train.order.status.eticket.110":"Ошибка при обработке","list.train.order.status.eticket.111":"Отменен","list.train.order.status.eticket.112":"Отменен","list.train.order.status.blank.overdue":"Просрочен","list.train.order.status.blank.notpaid":"Обрабатывается системой","list.train.order.status.blank.approved":"Оформлен","list.train.order.status.blank.paid":"Оплачен","list.train.order.status.blank.canceled":"Отменён","list.train.order.status.blank.notprocessed":"Обрабатывается системой","list.train.order.status.blank.processed":"Обработан","list.train.order.status.blank.deleted":"Удален оператором","list.train.order.status.blank.process":"Обрабатывается системой","list.train.order.status.blank.created":"Обрабатывается системой","list.train.order.status.blank.failed":"Ошибка","list.train.order.status.blank.sent":"Обрабатывается системой","list.train.order.status.blank.error":"Ошибка при обработке","list.train.order.status.blank.preprocessed":"Обрабатывается системой","list.train.order.status.blank.100":"Отменен","list.train.order.status.blank.101":"Отменен","list.train.order.status.blank.102":"Оператору не удалось дозвониться","list.train.order.status.blank.103":"Отменен","list.train.order.status.blank.104":"Отменен","list.train.order.status.blank.105":"Отменен","list.train.order.status.blank.106":"Отменен","list.train.order.status.blank.107":"Отменен","list.train.order.status.blank.108":"Отменен","list.train.order.status.blank.109":"Отменен","list.train.order.status.blank.110":"Ошибка при обработке","list.train.order.status.blank.111":"Отменен","list.train.order.status.blank.112":"Отменен","list.train.order.payway.TRANSCRED_title":"VISA, EuroCard/MasterCard","list.train.order.payway.TRANSCRED_description":'<img style="float: left;margin-right: 5px;" src="http://localhost.localdomain/images2/train/money/TRANSCRED.png" /> Электронный кошелек Platron с моментальным пополнением банковской картой',"list.train.order.payway.TRANSCRED_private_office":"Банковской картой онлайн","list.train.order.payway.RBKMONEY_title":"RBK-money","list.train.order.payway.RBKMONEY_description":"","list.train.order.payway.RBKMONEY_private_office":"RBK-money","list.train.order.payway.WEBMONEY_title":"Webmoney","list.train.order.payway.WEBMONEYR_title":"Webmoney","list.train.order.payway.WEBMONEYE_title":"Webmoney","list.train.order.payway.WEBMONEYZ_title":"Webmoney","list.train.order.payway.WEBMONEYR_short_title":"WMR","list.train.order.payway.WEBMONEYE_short_title":"WME","list.train.order.payway.WEBMONEYZ_short_title":"WMZ","list.train.order.payway.WEBMONEY_description":"","list.train.order.payway.WEBMONEY_private_office":"Webmoney","list.train.order.payway.YANDEXMONEY_title":"Яндекс.деньгами","list.train.order.payway.YANDEXMONEY_description":"","list.train.order.payway.YANDEXMONEY_private_office":"Яндекс.деньгами","list.train.order.payway.CASH_title":"Наличными в платежных терминалах, киосках, салонах связи:","list.train.order.payway.CASH_description":"В терминалах QIWI, Уникасса, салонах Евросеть и Связной, банковских отделениях CONTACT","list.train.order.payway.CASH_private_office":"Наличными в&nbsp;платежных&nbsp;терминалах и&nbsp;салонах&nbsp;связи","list.train.order.payway.MOBW_title":"Мобильным кошельком","list.train.order.payway.MOBW_description":"","list.train.order.payway.MOBW_private_office":"Мобильным кошельком","list.train.order.payway.BEELINEMK_title":"Со счета телефона Билайн","list.train.order.payway.BEELINEMK_description":"Для абонентов с предоплатной и постоплатной системой расчетов. Максимальная сумма оплаты - 10 000 руб","list.train.order.payway.MTSMK_title":"Со счета телефона МТС","list.train.order.payway.MTSMK_description":"Для абонентов Москвы и Московской области с предоплатной системой расчетов. Максимальная сумма оплаты - 5000 руб.","list.train.order.payway.MEGAFONMK_title":"Со счета телефона Мегафон","list.train.order.payway.MEGAFONMK_description":"Для абонентов с предоплатной и постоплатной системой расчетов.","list.train.order.payway.CONTACT_title":"В банковских отделениях системы денежных переводов CONTACT","list.train.order.payway.CONTACT_description":"","list.train.order.payway.moneymailru_title":"Деньги@Mail.ru","list.train.order.payway.moneymailru_description":"Для оплаты необходимо указать email, на который зарегистрирован кошелек.","list.train.order.payway.cash_courier_title":"<span>Наличными</span> курьеру","list.train.order.payway.cash_courier_description":"","list.train.order.payway.cash_courier_private_office":"Наличными курьеру","list.train.order.payway.cash_courier_office_title":"Наличными курьеру, доставка в офисы","list.train.order.payway.cash_courier_office_description":"","list.train.order.payway.cash_courier_office_private_office":"Наличными курьеру, доставка&nbsp;в&nbsp;офисы","list.train.order.payway.cash_courier_flat_title":"Наличными курьеру, доставка в квартиры","list.train.order.payway.cash_courier_flat_description":"","list.train.order.payway.cash_courier_flat_private_office":"Наличными курьеру, доставка&nbsp;в&nbsp;квартиры","list.train.order.payway.cash_office_title":"<span>Наличными</span> в офисе агентства","list.train.order.payway.cash_office_description":"","list.train.order.payway.cash_office_private_office":"Наличными в&nbsp;офисе&nbsp;агентства","list.train.order.payway.credit_card_title":"<span>Банковской</span> картой в офисе агентства ","list.train.order.payway.credit_card_description":"в офисе агентства","list.train.order.payway.credit_card_private_office":"Банковской&nbsp;картой в&nbsp;офисе&nbsp;агентства","list.train.order.payway.payway_city_moscow":"&ensp;в&nbsp;Москве","list.train.order.payway.payway_city_spb":"&ensp;в&nbsp;<nobr>Санкт-Петербурге</nobr>","list.train.order.payway.card_title":"<span>Банковской</span> картой","list.train.order.payway.card_description":'<img style="float: left;margin-right: 5px;" src="http://localhost.localdomain/images2/train/money/TRANSCRED.png" />',"list.train.order.payway.card_private_office":"Банковской картой&nbsp;онлайн","list.train.order.payway.platron_title":"<span>Наличными</span> в&nbsp;салонах &laquo;Евросеть&raquo; и&nbsp;&laquo;Связной&raquo;","list.train.order.payway.platron_description":"В терминалах QIWI, Уникасса, салонах Евросеть и Связной","list.train.order.payway.platron_private_office":"Наличными в&nbsp;салонах&nbsp;связи","list.train.order.payway.qiwi_title":"Online-оплата с QIWI кошелька","list.train.order.payway.qiwi_description":"В терминалах QIWI","list.train.order.payway.qiwi_private_office":"Со&nbsp;счета QIWI кошелька","list.train.order.payway.webmoney_title":"Webmoney","list.train.order.payway.webmoney_description":"","list.train.order.payway.webmoney_private_office":"Webmoney","list.train.order.payway.yandex_title":"Яндекс.деньгами","list.train.order.payway.yandex_description":"","list.train.order.payway.yandex_private_office":"Яндекс.деньгами","list.train.order.payway.mobilephone_title":"Mobile","list.train.order.payway.osmp_title":"Наличными в терминалах QIWI","list.train.order.payway.osmp_private_office":"Терминалы QIWI","list.train.order.payway.e_card_title":"VISA/MasterCard","list.train.order.payway.e_card_description":'<img style="float: left;margin-right: 5px;" src="http://localhost.localdomain/images2/train/money/TRANSCRED.png" />',"list.train.order.payway.e_card_private_office":"Банковской картой&nbsp;онлайн","list.train.order.payway.e_platron_title":"наличными в&nbsp;салонах&nbsp;связи","list.train.order.payway.e_platron_description":"в терминалах QIWI, Уникасса, салонах Евросеть и Связной","list.train.order.payway.e_platron_private_office":"наличными в&nbsp;салонах&nbsp;связи","list.train.order.payway.e_qiwi_title":"со&nbsp;счета QIWI кошелька","list.train.order.payway.e_qiwi_description":"в терминалах QIWI","list.train.order.payway.e_qiwi_private_office":"со&nbsp;счета QIWI кошелька","list.train.order.payway.e_webmoney_title":"Webmoney","list.train.order.payway.e_webmoney_description":"","list.train.order.payway.e_webmoney_private_office":"Webmoney","list.train.order.payway.e_yandex_title":"Яндекс.деньгами","list.train.order.payway.e_yandex_description":"","list.train.order.payway.e_yandex_private_office":"Яндекс.деньгами","list.train.order.payway.e_osmp_title":"в терминалах QIWI","list.train.order.payway.payway_train_title":"Способы оплаты ж/д билета:","list.train.order.payway.payway_train_title_sapsan_schedule":"Способы оплаты билета на поезд «Сапсан»:","list.train.order.payway.payway_train_title_sapsan_schedule_station":"Способы оплаты билета:","list.train.order.documents.invoice":"Счет","list.train.order.documents.act":"Акт приема-передачи проездных документов","list.train.order.documents.actsrv":"Акт об оказании услуги","list.train.order.documents.actsrvnds":"Акт об оказании услуги","list.train.order.documents.full":"Все документы","list.train.order.error.travelmart.out.35.OnlyForeignPassport":"<p>По правилам РЖД, проезд %countryName% возможен только по загранпаспорту.</p>\n\t\t<p>Пожалуйста, укажите данные загранпаспорта.</p>","list.train.order.error.travelmart.out.35.CanNotBuyAtThisMoment":"<p>К сожалению, система заказа не смогла забронировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.35.OnlyFullTariff":'<p>По правилам РЖД, в выбранный вагон нельзя купить детский билет.</p>\n\t\t<p>Пожалуйста, выберите для ребенка "взрослый" билет или выберите другой тип вагона.</p>',"list.train.order.error.travelmart.out.33.NoTrainNumber":"<p>К сожалению, система заказа не смогла забронировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.travelmart.out.11.ChildrenRestriction":"<p>Для поездов из Украины нельзя оформить на младенца электронный билет без места.<br/>К сожалению, таковы особенности системы бронирования.<br/>Но вы можете оформить на ребенка до 5 лет детский билет с местом, для этого вернитесь на предыдущий шаг и добавьте в заказ ещё одно место.</p>","list.train.order.error.travelmart.out.39.WrongTrainNumberFormat":"<p>К сожалению, система заказа не смогла забронировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.travelmart.out.39.GroupTravel":"<p>Сработало ограничение РЖД на максимальное количество покупок билетов в один вагон за час.</p>\n\t\t<p>Пожалуйста, выберите места в другом вагоне или повторите попытку позже.</p>","list.train.order.error.travelmart.out.42.TechnicalBreak":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв с 03:25 до 03:40.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.travelmart.out.42.TechnicalBreak2":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв продолжительностью 30 минут.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.travelmart.out.42.MonthlyBreak":"<p>По правилам РЖД, система заказа остановлена на ежемесячный технологический перерыв с 23:55 до 00:05.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.travelmart.out.12.Express3NoAnswer":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.travelmart.out.empty.Express3NotAvailable":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.travelmart.out.empty.ServerNotAvailable":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.travelmart.out.76.UnexpectedError":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.34.IncorrectDocsFormat":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.34.IncorrectSeatsRange":"<p>К сожалению, система заказа не смогла забронировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другие места или попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.34.OneTicketPerDiscount":"<p>По правилам РЖД, нельзя купить два билета по одной льготе (например, 2 места на одного ребенка).</p>\n\t\t<p>Пожалуйста, укажите корректное количество льготных билетов.</p>","list.train.order.error.travelmart.out.34.OneCoupeOnePassenger":"<p>К сожалению, система заказа не смогла забронировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другие места или попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.34.DiapasonTooSmall":"<p>К сожалению, система заказа не смогла забронировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другие места.</p>","list.train.order.error.travelmart.out.34.IncorrectSexOpposite":"<p>К сожалению, система заказа не смогла забронировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другое купе и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.34.MustBuyCoupe":"<p>По правилам РЖД, в поезде №%trainNumber% выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком (%seatsCount%).</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.travelmart.out.34.IncorrectTrainNumberFormat":"<p>К сожалению, система заказа не смогла забронировать места в выбранном поезде.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.travelmart.out.14.IncorrectDocs":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.IncorrectFIO":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.NoDigitsLatinLetters":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.NoSuchCarNumber":"<p>К сожалению, система заказа не смогла забронировать места в выбранном вагоне.</p>\n\t\t<p>Пожалуйста, выберите другой вагон и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.IncorrectSex":"<p>К сожалению, система заказа не смогла забронировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другое купе и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.NoTrainAtDate":"<p>К сожалению, система заказа не смогла забронировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.NoSeatsInOneCoupe":"<p>К сожалению, система заказа не смогла забронировать места в одном купе.</p>\n\t\t<p>Пожалуйста, выберите другие купе и попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.NoSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.out.14.NoSeatsAtTrain":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.out.14.NoBottomSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.out.14.NoTopSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.out.14.BadRequest":"<p>К сожалению, система заказа не смогла забронировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд или попробуйте купить билет еще раз.</p>","list.train.order.error.travelmart.out.14.OnlySide":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.out.14.NoSuchSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.travelmart.in.35.OnlyForeignPassport":"Проезд в\\/из указанной страны за пределами РФ возможен только по загранпаспорту \\((.*)\\)","list.train.order.error.travelmart.in.35.CanNotBuyAtThisMoment":"Приобрести билет на данный поезд через Интернет-систему в настоящий момент не представляется возможным! Приносим Вам свои извинения","list.train.order.error.travelmart.in.35.OnlyFullTariff":"Проезд в этом вагоне возможен только по Полному тарифу \\(льготы не предоставляются\\)","list.train.order.error.travelmart.in.33.NoTrainNumber":"Входной параметр не найден \\(train\\)","list.train.order.error.travelmart.in.11.ChildrenRestriction":"Оформление безденежных электронных билетов для проезда детей до 5 лет без занятия отдельного места НЕ ПРОИЗВОДИТСЯ со станций отправления, расположенных на территории Украины\\. Для их оформления необходимо обратиться в железнодорожную кассу","list.train.order.error.travelmart.in.39.WrongTrainNumberFormat":"для покупки поезд должен быть уже четко определён! формат: три цифры и одна буква - в отличие от результата в случае склейки нескольких логических поездовдля покупки поезд должен быть уже четко определён! формат: три цифры и одна буква - в отличие от результата в случае склейки нескольких логических поездов","list.train.order.error.travelmart.in.39.GroupTravel":"Для групповых поездок заказ билетов через Интернет невозможен","list.train.order.error.travelmart.in.42.TechnicalBreak":"Проведение платежей приостановлено на время технологического перерыва с 03:25 до 03:40","list.train.order.error.travelmart.in.42.MonthlyBreak":"Проведение платежей приостановлено на время перехода месяца с 23:55 до 00:05","list.train.order.error.travelmart.in.12.Express3NoAnswer":'Система "Экспресс-3" не отвечает\\.',"list.train.order.error.travelmart.in.empty.Express3NotAvailable":'Система "Экспресс-3" временно не доступна',"list.train.order.error.travelmart.in.empty.ServerNotAvailable":"Сервер временно не доступен","list.train.order.error.travelmart.in.76.UnexpectedError":"Непредвиденная ошибка\\. Обратитесь в службу поддержки для дополнительной информации","list.train.order.error.travelmart.in.34.IncorrectDocsFormat":"Некорректный формат документа","list.train.order.error.travelmart.in.34.IncorrectSeatsRange":"Неправильный формат желательного диапазона мест \\(д\\.б\\. например 001-015\\)","list.train.order.error.travelmart.in.34.OneTicketPerDiscount":"По одной льготе два проездных документа оформлять нельзя","list.train.order.error.travelmart.in.34.OneCoupeOnePassenger":'Требование "в одном купе" некорректно для одного пассажира',"list.train.order.error.travelmart.in.34.DiapasonTooSmall":"Заданный желательный диапазон не вмещает всех мест в заказе","list.train.order.error.travelmart.in.34.IncorrectSexOpposite":"Некорректные требования к мужскому\\/женскому купе - выберите противоположное","list.train.order.error.travelmart.in.34.MustBuyCoupe":"В поезде (.+) выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком \\(.*\\)","list.train.order.error.travelmart.in.34.IncorrectTrainNumberFormat":"Неккоректный формат номера поезда","list.train.order.error.travelmart.in.14.IncorrectDocs":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ДOK-TA УДOCTOBEPЯЮЩEГO ЛИЧHOCTЬ","list.train.order.error.travelmart.in.14.NoDigitsLatinLetters":"Операция завершилась неуспешно из-за некорректных входных данных: B ДOK-TE, УДOCT\\. ЛИЧHOCTЬ, ГДE HET ЦИФP, БУKBЫ Д\\.Б\\. ЛATИHCKИE\\(KPOME C\\)","list.train.order.error.travelmart.in.14.IncorrectFIO":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ФИO","list.train.order.error.travelmart.in.14.IncorrectSex":"Операция завершилась неуспешно из-за некорректных входных данных: УКАЖИ ТРЕБОВАНИЯ М\\/Ж","list.train.order.error.travelmart.in.14.BadRequest":"Ошибочный запрос","list.train.order.error.travelmart.in.14.NoTrainAtDate":"В указанную дату поезд не ходит","list.train.order.error.travelmart.in.14.NoSeatsInOneCoupe":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ОДНОМ КУПЕ","list.train.order.error.travelmart.in.14.NoSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ЗАДАННЫХ ГРАНИЦАХ МЕСТ","list.train.order.error.travelmart.in.14.NoSeatsAtTrain":"На заданном направлении \\(или поезде\\) мест нет","list.train.order.error.travelmart.in.14.NoBottomSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НИЖНИХ НЕТ \\(ИЛИ У ОКНА\\)","list.train.order.error.travelmart.in.14.NoTopSeats":"Операция завершилась неуспешно из-за некорректных входных данных: ВЕРХНИХ НЕТ","list.train.order.error.travelmart.in.14.NoSuchCarNumber":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ ВАГОНА С ЗАДАННЫМ НОМЕРОМ","list.train.order.error.travelmart.in.14.OnlySide":"Операция завершилась неуспешно из-за некорректных входных данных: ТОЛЬКО БОКОВЫЕ","list.train.order.error.travelmart.in.14.NoSuchSeats":"По данным требованиям мест нет, попробуйте изменить требования к местам","list.train.order.error.ufs.out.5060.NoSeatsAtTrain":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5023.IncorrectDocsFormat":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5038.CanNotBuyAtThisMoment":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5083.GroupTravel":"<p>Сработало ограничение РЖД на максимальное количество покупок билетов в один вагон за час.</p>\n\t\t<p>Пожалуйста, выберите места в другом вагоне или повторите попытку позже.</p>","list.train.order.error.ufs.out.5037.IncorrectRouteDate":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.5035.TooMuchBottomSeats":"<p>К сожалению, система заказа не смогла зарезервировать выбранные места.</p>\n\t\t<p>Пожалуйста, выберите другие места и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5020.IncorrectSeatsRange":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другие места или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5039.IncorrectSexOpposite":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другое купе и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5063.BadRequest":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5006.MonthlyBreak":"<p>По правилам РЖД, система заказа остановлена на ежемесячный технологический перерыв с 23:55 до 00:05.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.5044.OnlyFullTariff":'<p>По правилам РЖД, в выбранный вагон нельзя купить детский билет.</p>\n\t\t<p>Пожалуйста, выберите для ребенка "взрослый" билет или выберите другой тип вагона.</p>',"list.train.order.error.ufs.out.35.OnlyForeignPassport":"<p>По правилам РЖД, проезд %countryName% возможен только по загранпаспорту.</p>\n\t\t<p>Пожалуйста, укажите данные загранпаспорта.</p>","list.train.order.error.ufs.out.35.CanNotBuyAtThisMoment":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.35.OnlyFullTariff":'<p>По правилам РЖД, в выбранный вагон нельзя купить детский билет.</p>\n\t\t<p>Пожалуйста, выберите для ребенка "взрослый" билет или выберите другой тип вагона.</p>',"list.train.order.error.ufs.out.35.UnreachableStation":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5031.PassengersCountError":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5017.WrongBabyCount":"<p>По правилам РЖД, каждый ребенок до 5 лет должен ехать в сопровождении взрослого.</p>\n\t\t<p>Пожалуйста, проверьте количество детей и взрослых и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5027.OneTicketPerDiscount":"<p>По правилам РЖД, нельзя купить два билета по одной льготе (например, 2 места на одного ребенка).</p>\n\t\t<p>Пожалуйста, укажите корректное количество льготных билетов.</p>","list.train.order.error.ufs.out.33.NoTrainNumber":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.11.ChildrenRestriction":"<p>Для поездов из Украины нельзя оформить на младенца электронный билет без места.<br/>К сожалению, таковы особенности системы резервирования.<br/>Но вы можете оформить на ребенка до 5 лет детский билет с местом, для этого вернитесь на предыдущий шаг и добавьте в заказ ещё одно место.</p>","list.train.order.error.ufs.out.5070.IncorrectDocs":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.IncorrectFIO":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.NoDigitsLatinLetters":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.NoSuchCarNumber":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном вагоне.</p>\n\t\t<p>Пожалуйста, выберите другой вагон и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.IncorrectSex":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другое купе и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.NoTrainAtDate":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.NoSeatsInOneCoupe":"<p>К сожалению, система заказа не смогла зарезервировать места в одном купе.</p>\n\t\t<p>Пожалуйста, выберите другие купе и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.NoSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5070.NoBottomSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5070.NoTopSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5070.BadRequest":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.OnlySide":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5070.NoConnectionToRailway":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.5070.Express3OshPFile":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>В одном заказе электронных билетов при резервировании поездки из Украины может быть не больше 2 пассажиров, включая взрослых и детей.</p>","list.train.order.error.ufs.out.39.WrongTrainNumberFormat":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.39.GroupTravel":"<p>Сработало ограничение РЖД на максимальное количество покупок билетов в один вагон за час.</p>\n\t\t<p>Пожалуйста, выберите места в другом вагоне или повторите попытку позже.</p>","list.train.order.error.ufs.out.5018.MustBuyCoupe":"<p>По правилам РЖД, в поезде №%trainNumber% выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком %seatsCount%.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.5022.IncorrectTrainNumberFormat":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном поезде.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.5007.TechnicalBreak":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв с 03:25 до 03:40.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.5007.TechnicalBreak2":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв продолжительностью 30 минут.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.5055.DiapasonError":"<p>К сожалению, система заказа не смогла зарезервировать выбранные места.</p>\n\t\t<p>Пожалуйста, выберите другие места и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.42.TechnicalBreak":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв с 03:25 до 03:40.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.42.TechnicalBreak2":"<p>По правилам РЖД, система заказа остановлена на ежедневный технологический перерыв продолжительностью 30 минут.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.42.MonthlyBreak":"<p>По правилам РЖД, система заказа остановлена на ежемесячный технологический перерыв с 23:55 до 00:05.</p>\n\t\t<p>Пожалуйста, оставайтесь с нами и сделайте заказ чуть позже.</p>","list.train.order.error.ufs.out.12.Express3NoAnswer":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.ufs.out.empty.Express3NotAvailable":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.ufs.out.empty.ServerNotAvailable":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.ufs.out.5067.Express3NoAnswer":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте сделать заказ чуть позже.</p>","list.train.order.error.ufs.out.76.UnexpectedError":"<p>К сожалению, в системе заказа ОАО «РЖД» произошел технический сбой.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.34.IncorrectDocsFormat":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.34.IncorrectSeatsRange":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другие места или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.34.OneTicketPerDiscount":"<p>По правилам РЖД, нельзя купить два билета по одной льготе (например, 2 места на одного ребенка).</p>\n\t\t<p>Пожалуйста, укажите корректное количество льготных билетов.</p>","list.train.order.error.ufs.out.34.OneCoupeOnePassenger":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другие места или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.34.DiapasonTooSmall":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другие места.</p>","list.train.order.error.ufs.out.34.MustBuyCoupe":"<p>По правилам РЖД, в поезде №%trainNumber% выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком %seatsCount%.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.34.IncorrectTrainNumberFormat":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном поезде.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.5068.NoSuchSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.5041.DiapasonTooSmall":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другие места.</p>","list.train.order.error.ufs.out.5046.WrongTrainNumberFormat":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранный поезд.</p>\n\t\t<p>Пожалуйста, попробуйте купить билет еще раз или выберите другой поезд.</p>","list.train.order.error.ufs.out.5046.GroupTravel":"<p>Сработало ограничение РЖД на максимальное количество покупок билетов в один вагон за час.</p>\n\t\t<p>Пожалуйста, выберите места в другом вагоне или повторите попытку позже.</p>","list.train.order.error.ufs.out.14.IncorrectDocs":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.IncorrectFIO":"<p>К сожалению, система заказа сообщила об ошибке в данных пассажира.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.NoDigitsLatinLetters":"<p>К сожалению, система заказа сообщила об ошибке в паспортных данных.</p>\n\t\t<p>Пожалуйста, проверьте эти данные и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.NoSuchCarNumber":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном вагоне.</p>\n\t\t<p>Пожалуйста, выберите другой вагон и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.IncorrectSex":"<p>К сожалению, система заказа не смогла зарезервировать места в выбранном купе.</p>\n\t\t<p>Пожалуйста, выберите другое купе и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.NoTrainAtDate":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.NoSeatsInOneCoupe":"<p>К сожалению, система заказа не смогла зарезервировать места в одном купе.</p>\n\t\t<p>Пожалуйста, выберите другие купе и попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.NoSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.14.NoSeatsAtTrain":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.14.NoBottomSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.14.NoTopSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.14.BadRequest":"<p>К сожалению, система заказа не смогла зарезервировать места на выбранный поезд.</p>\n\t\t<p>Пожалуйста, выберите другой поезд или попробуйте купить билет еще раз.</p>","list.train.order.error.ufs.out.14.OnlySide":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.out.14.NoSuchSeats":"<p>К сожалению, выбранные вами места только что закончились.</p>\n\t\t<p>Пожалуйста, выберите другие.</p>","list.train.order.error.ufs.in.5060.NoSeatsAtTrain":"На заданном направлении \\(или поезде\\) мест нет","list.train.order.error.ufs.in.5023.IncorrectDocsFormat":"Некорректный формат документа","list.train.order.error.ufs.in.5038.CanNotBuyAtThisMoment":"Приобрести билет на данный поезд через Интернет-систему в настоящий момент не представляется возможным! Приносим Вам свои извинения","list.train.order.error.ufs.in.5083.GroupTravel":"Для групповых поездок заказ билетов через Интернет невозможен","list.train.order.error.ufs.in.5037.IncorrectRouteDate":"Невозможно оформить билет: либо некорректна дата отправления поезда (Должна быть не далее 45 суток), либо до отправления поезда осталось меньше 2 часов","list.train.order.error.ufs.in.5035.TooMuchBottomSeats":"Может быть не больше половины нижних мест от общего числа мест в заказе \\(при нечетном числе округление разрешено в большую сторону\\) Максимум - \\(2\\)","list.train.order.error.ufs.in.5020.IncorrectSeatsRange":"Неправильный формат желательного диапазона мест \\(д\\.б\\. например 001-015\\)","list.train.order.error.ufs.in.5039.IncorrectSexOpposite":"Некорректные требования к мужскому\\/женскому купе - выберите противоположное","list.train.order.error.ufs.in.5063.BadRequest":"Ошибочный запрос","list.train.order.error.ufs.in.5006.MonthlyBreak":"Проведение платежей приостановлено на время перехода месяца с 23:55 до 00:05","list.train.order.error.ufs.in.5044.OnlyFullTariff":"Проезд в этом вагоне возможен только по Полному тарифу \\(льготы не предоставляются\\)","list.train.order.error.ufs.in.35.OnlyForeignPassport":"Проезд в\\/из указанной страны за пределами РФ возможен только по загранпаспорту \\((.*)\\)","list.train.order.error.ufs.in.35.CanNotBuyAtThisMoment":"Приобрести билет на данный поезд через Интернет-систему в настоящий момент не представляется возможным! Приносим Вам свои извинения","list.train.order.error.ufs.in.35.OnlyFullTariff":"Проезд в этом вагоне возможен только по Полному тарифу \\(льготы не предоставляются\\)","list.train.order.error.ufs.in.35.UnreachableStation":"Нет возможности покупки ЖД билета до указанной станции","list.train.order.error.ufs.in.5031.PassengersCountError":"Превышено число разнородных пассажиров: невозможно уместить их на 4-х бланках по два однородных пассажира на каждом\\. Для текущего набора пассажиров необходимо по меньшей мере 5 бланков","list.train.order.error.ufs.in.5017.WrongBabyCount":"Каждый младенец \\(ребенок до 5-ти лет\\) должен ехать в сопровождении приставленного единолично к нему взрослого - младенцев в заказе не может быть больше чем взрослых","list.train.order.error.ufs.in.5027.OneTicketPerDiscount":"По одной льготе два проездных документа оформлять нельзя","list.train.order.error.ufs.in.33.NoTrainNumber":"Входной параметр не найден \\(train\\)","list.train.order.error.ufs.in.11.ChildrenRestriction":"Оформление безденежных электронных билетов для проезда детей до 5 лет без занятия отдельного места НЕ ПРОИЗВОДИТСЯ со станций отправления, расположенных на территории Украины\\. Для их оформления необходимо обратиться в железнодорожную кассу","list.train.order.error.ufs.in.5070.IncorrectDocs":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ДOK-TA УДOCTOBEPЯЮЩEГO ЛИЧHOCTЬ","list.train.order.error.ufs.in.5070.NoDigitsLatinLetters":"Операция завершилась неуспешно из-за некорректных входных данных: B ДOK-TE, УДOCT\\. ЛИЧHOCTЬ, ГДE HET ЦИФP, БУKBЫ Д\\.Б\\. ЛATИHCKИE\\(KPOME C\\)","list.train.order.error.ufs.in.5070.IncorrectFIO":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ФИO","list.train.order.error.ufs.in.5070.IncorrectSex":"Операция завершилась неуспешно из-за некорректных входных данных: УКАЖИ ТРЕБОВАНИЯ М\\/Ж","list.train.order.error.ufs.in.5070.BadRequest":"Ошибочный запрос","list.train.order.error.ufs.in.5070.NoTrainAtDate":"В указанную дату поезд не ходит","list.train.order.error.ufs.in.5070.NoSeatsInOneCoupe":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ОДНОМ КУПЕ","list.train.order.error.ufs.in.5070.NoSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ЗАДАННЫХ ГРАНИЦАХ МЕСТ","list.train.order.error.ufs.in.5070.NoBottomSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НИЖНИХ НЕТ \\(ИЛИ У ОКНА\\)","list.train.order.error.ufs.in.5070.NoTopSeats":"Операция завершилась неуспешно из-за некорректных входных данных: ВЕРХНИХ НЕТ","list.train.order.error.ufs.in.5070.NoSuchCarNumber":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ ВАГОНА С ЗАДАННЫМ НОМЕРОМ","list.train.order.error.ufs.in.5070.OnlySide":"Операция завершилась неуспешно из-за некорректных входных данных: ТОЛЬКО БОКОВЫЕ","list.train.order.error.ufs.in.5070.NoConnectionToRailway":"Операция завершилась неуспешно из-за некорректных входных данных: ЗАПРОС НЕ МОЖЕТ БЫТЬ ВЫПОЛНЕН   ИЗ-ЗА ОТСУТСТВИЯ ИНФОРМАЦИИ ОТ ДРУГОЙ ЖЕЛ\\.ДОРОГИ","list.train.order.error.ufs.in.5070.Express3OshPFile":"Операция завершилась неуспешно из-за некорректных входных данных: ОШ П-ФАЙЛ","list.train.order.error.ufs.in.39.WrongTrainNumberFormat":"для покупки поезд должен быть уже четко определён! формат: три цифры и одна буква - в отличие от результата в случае склейки нескольких логических поездов","list.train.order.error.ufs.in.39.GroupTravel":"Для групповых поездок заказ билетов через Интернет невозможен","list.train.order.error.ufs.in.5018.MustBuyCoupe":"В поезде (.+) выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком (.+)","list.train.order.error.ufs.in.5022.IncorrectTrainNumberFormat":"Неккоректный формат номера поезда","list.train.order.error.ufs.in.5007.TechnicalBreak":"Проведение платежей приостановлено на время технологического перерыва с 03:25 до 03:40","list.train.order.error.ufs.in.5055.DiapasonError":"Требование к номеру места \\(диапазон\\) несоответсвует требованиям яруса \\(верх-низ\\)","list.train.order.error.ufs.in.42.TechnicalBreak":"Проведение платежей приостановлено на время технологического перерыва с 03:25 до 03:40","list.train.order.error.ufs.in.42.MonthlyBreak":"Проведение платежей приостановлено на время перехода месяца с 23:55 до 00:05","list.train.order.error.ufs.in.12.Express3NoAnswer":'Система "Экспресс-3" не отвечает\\.',"list.train.order.error.ufs.in.empty.Express3NotAvailable":'Система "Экспресс-3" временно не доступна',"list.train.order.error.ufs.in.empty.ServerNotAvailable":"Сервер временно не доступен","list.train.order.error.ufs.in.5067.Express3NoAnswer":'Система "Экспресс-3" не отвечает\\. Повторите запрос',"list.train.order.error.ufs.in.76.UnexpectedError":"Непредвиденная ошибка\\. Обратитесь в службу поддержки для дополнительной информации","list.train.order.error.ufs.in.34.IncorrectDocsFormat":"Некорректный формат документа","list.train.order.error.ufs.in.34.IncorrectSeatsRange":"Неправильный формат желательного диапазона мест \\(д\\.б\\. например 001-015\\)","list.train.order.error.ufs.in.34.OneTicketPerDiscount":"По одной льготе два проездных документа оформлять нельзя","list.train.order.error.ufs.in.34.OneCoupeOnePassenger":'Требование "в одном купе" некорректно для одного пассажира',"list.train.order.error.ufs.in.34.DiapasonTooSmall":"Заданный желательный диапазон не вмещает всех мест в заказе","list.train.order.error.ufs.in.34.MustBuyCoupe":"В поезде (.+) выкуп билетов в мягких вагонах возможен только в случае выкупа купе целиком (.+)","list.train.order.error.ufs.in.34.IncorrectTrainNumberFormat":"Неккоректный формат номера поезда","list.train.order.error.ufs.in.5068.NoSuchSeats":"По данным требованиям мест нет, попробуйте изменить требования к местам","list.train.order.error.ufs.in.5041.DiapasonTooSmall":"Заданный желательный диапазон не вмещает всех мест в заказе","list.train.order.error.ufs.in.5046.WrongTrainNumberFormat":"для покупки поезд должен быть уже четко определён! формат: три цифры и одна буква - в отличие от результата в случае склейки нескольких логических поездов","list.train.order.error.ufs.in.5046.GroupTravel":"Для групповых поездок заказ билетов через Интернет невозможен","list.train.order.error.ufs.in.14.IncorrectDocs":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ДOK-TA УДOCTOBEPЯЮЩEГO ЛИЧHOCTЬ","list.train.order.error.ufs.in.14.NoDigitsLatinLetters":"Операция завершилась неуспешно из-за некорректных входных данных: B ДOK-TE, УДOCT\\. ЛИЧHOCTЬ, ГДE HET ЦИФP, БУKBЫ Д\\.Б\\. ЛATИHCKИE\\(KPOME C\\)","list.train.order.error.ufs.in.14.IncorrectFIO":"Операция завершилась неуспешно из-за некорректных входных данных: HEKOPPEKTHЫЙ HAБOP ФИO","list.train.order.error.ufs.in.14.IncorrectSex":"Операция завершилась неуспешно из-за некорректных входных данных: УКАЖИ ТРЕБОВАНИЯ М\\/Ж","list.train.order.error.ufs.in.14.BadRequest":"Ошибочный запрос","list.train.order.error.ufs.in.14.NoTrainAtDate":"В указанную дату поезд не ходит","list.train.order.error.ufs.in.14.NoSeatsInOneCoupe":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ОДНОМ КУПЕ","list.train.order.error.ufs.in.14.NoSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ В ЗАДАННЫХ ГРАНИЦАХ МЕСТ","list.train.order.error.ufs.in.14.NoSeatsAtTrain":"На заданном направлении \\(или поезде\\) мест нет","list.train.order.error.ufs.in.14.NoBottomSeats":"Операция завершилась неуспешно из-за некорректных входных данных: НИЖНИХ НЕТ \\(ИЛИ У ОКНА\\)","list.train.order.error.ufs.in.14.NoTopSeats":"Операция завершилась неуспешно из-за некорректных входных данных: ВЕРХНИХ НЕТ","list.train.order.error.ufs.in.14.NoSuchCarNumber":"Операция завершилась неуспешно из-за некорректных входных данных: НЕТ ВАГОНА С ЗАДАННЫМ НОМЕРОМ","list.train.order.error.ufs.in.14.OnlySide":"Операция завершилась неуспешно из-за некорректных входных данных: ТОЛЬКО БОКОВЫЕ","list.train.order.error.ufs.in.14.NoSuchSeats":"По данным требованиям мест нет, попробуйте изменить требования к местам","list.train.seo.is.0":"составляет","list.train.seo.is.1":"","list.train.seo.site.0":"сайте","list.train.seo.site.1":"Туту.ру","list.train.seo.buy.0":"купить","list.train.seo.buy.1":"заказать","list.train.seo.selected.0":"выбранному","list.train.seo.selected.1":"данному","list.train.seo.selected.2":"этому","list.train.seo.by_route.0":"по маршруту","list.train.seo.by_route.1":"","list.train.seo.carried_out.0":"осуществляется","list.train.seo.carried_out.1":"производится","list.train.seo.follow.0":"следуют","list.train.seo.follow.1":"проходят","list.train.seo.you_can.0":"На нашем сайте можно","list.train.seo.you_can.1":"Вы можете","list.train.seo.yet.0":"уже","list.train.seo.yet.1":"прямо","list.train.seo.station.indicate.0":"Обозначив","list.train.seo.station.indicate.1":"Указав","list.train.seo.station.follow.0":"следует","list.train.seo.station.follow.1":"проходит","list.train.seo.station.follow.2":"курсирует","list.train.seo.station.price.0":"стоимость","list.train.seo.station.price.1":"цену","list.train.seo.station.travel.0":"время в пути","list.train.seo.station.travel.1":"продолжительность пути","list.train.seo.station.see_schedule.0":"посмотреть расписание поездов","list.train.seo.station.see_schedule.1":"ознакомиться с расписанием поездов","list.train.seo.station.learn.0":"узнать","list.train.seo.station.learn.1":"посмотреть","list.train.seo.station.try.0":"Наш сервис позволяет","list.train.seo.station.try.1":"У вас есть возможность","list.train.seo.station.comfortable.0":"удобный","list.train.seo.station.comfortable.1":"подходящий","list.train.seo.station.place.0":"пункт","list.train.seo.station.place.1":"место","list.train.seo.station.in_city.0":"городе","list.train.seo.station.in_city.1":"","list.train.seo.average.0":"Среднее","list.train.seo.average.1":"Приблизительное","list.train.seo.average.2":"Примерное","list.train.seo.route.0":"маршруту","list.train.seo.route.1":"направлению","list.train.seo.try.0":"Вы можете","list.train.seo.try.1":"Наш сервис позволяет","list.train.seo.try.2":"Спешите","list.train.seo.try.3":"Попробуйте","list.train.seo.in_city.0":"В %city_6%","list.train.seo.in_city.1":"В городе %city_1%","list.train.schedule.daily":"Ежедневно","list.train.schedule.even":"По четным","list.train.schedule.odd":"По нечетным","list.train.schedule.except_one_day":"Кроме %date%","list.train.schedule.only_one_day":"Только %date%","list.train.schedule.canceled":"Отменен","list.train.schedule.special":"Особый","list.train.msk.railway.belorus":"Белорусский","list.train.msk.railway.kazan":"Казанский","list.train.msk.railway.kiev":"Киевский","list.train.msk.railway.kursk":"Курский","list.train.msk.railway.leningrad":"Ленинградский","list.train.msk.railway.pavel":"Павелецкий","list.train.msk.railway.pij":"Рижский","list.train.msk.railway.savel":"Савеловский","list.train.msk.railway.jaroslav":"Ярославский","list.train.spb.railway.baltisk":"Балтийский","list.train.spb.railway.vitebsk":"Витебский","list.train.spb.railway.ladojsk":"Ладожский","list.train.spb.railway.moscovsk":"Московский","list.train.spb.railway.finlyandsk":"Финляндский","list.month_p_s.1":"января","list.month_p_s.2":"февраля","list.month_p_s.3":"марта","list.month_p_s.4":"апреля","list.month_p_s.5":"мая","list.month_p_s.6":"июня","list.month_p_s.7":"июля","list.month_p_s.8":"августа","list.month_p_s.9":"сентября","list.month_p_s.10":"октября","list.month_p_s.11":"ноября","list.month_p_s.12":"декабря","list.class.1":"Экономический","list.class.2":"Бизнес","list.class.3":"Первый","list.class.4":"Любой","list.hotel.feedback.svoytravel.manager_name":"Иван Измайлов","list.hotel.feedback.svoytravel.phone_number":"+7 925 5171036","list.hotel.order_status.new":"Новый необработанный заказ","list.hotel.order_status.requested":"Заказ принят к исполнению","list.hotel.order_status.confirmed":"Заказ подтвержден, ожидается оплата","list.hotel.order_status.paid":"Заказ оплачен","list.hotel.order_status.completed":"Бронирование успешно завершено","list.hotel.order_status.rejected":"Заказ отклонен системой бронирования","list.hotel.order_status.cancelled":"Заказ отменен/аннулирован","list.hotel.order_status.expired":"Заказ устарел","list.hotel.replace.buffet breakfast":"шведский стол","list.hotel.replace.service charges":"сервисные сборы","list.hotel.replace.city tax":"такси","list.hotel.replace.american breakfast":"американский завтрак","list.hotel.replace.continental breakfast":"легкий завтрак","list.hotel.replace.breakfast":"завтрак","list.hotel.replace.General":"Общий","list.hotel.error.bookvario.100":"В доступе отказано","list.hotel.error.bookvario.101":"Неизвестный тип запроса","list.hotel.error.bookvario.102":"Нет такого города","list.hotel.error.bookvario.103":"Дата заезда должна быть меньше даты выезда","list.hotel.error.bookvario.104":"Тип комнаты не доступен","list.hotel.error.bookvario.105":"Бронь не может быть отменена","list.hotel.error.bookvario.106":"Указанная бронь не существует","list.hotel.error.bookvario.107":"Изменение брони не возможно","list.hotel.error.bookvario.999":"Ошибка XML запроса","list.hotel.error.svoytravel.100":"Нет свободных комнат за указанный период.","list.hotel.error.svoytravel.server_unavalable":"Сервер не отвечает. Попробуйте повторить запрос позже.","list.hotel.error.svoytravel.request_timedout":"Сервер не отвечает. Попробуйте повторить запрос позже.","list.hotel.error.svoytravel.TRANSLATE>>NO_CHAIN":"Нет свободных номеров.","list.hotel.error.booking.1001":"Внутренняя ошибка сервера.","list.hotel.error.booking.1002":"Заполните все обязательные поля.","list.hotel.error.booking.1003":"Один или более из указанных параметров в неправильном формате.","list.hotel.error.booking.1004":"Объект не найден.","list.hotel.error.booking.1005":"HTTPS (SSL) connection required for using this procedure.","list.hotel.error.booking.1006":"Invalid parameter combination.","list.hotel.error.booking.1007":"Too many requests per minute. Please don't use this function heavily (i.e. only for testing) during 8-23 GMT.","list.hotel.error.booking.1008":"Too many parallel requests. Please only call 1 instance of this function in parallel during 8-23 GMT or 3 instances in parallel during 23-8 GMT.","list.hotel.error.booking.1009":"Один или несколько параметров указаны неправильно.","list.hotel.error.booking.1010":"Недопустимая функция.","list.hotel.error.booking.1105":"Комната не найдена.","list.hotel.error.booking.1106":"Room is not part of the hotel.","list.hotel.error.booking.1107":"Нет свободных комнат за указанный период.","list.hotel.error.booking.1119":"Affiliate not found.","list.hotel.error.booking.1120":"Affiliate is closed.","list.hotel.error.booking.1122":"Guest_qty is not between 1 and it's maximum.","list.hotel.error.booking.server_unavalable":"Сервер не отвечает. Попробуйте повторить запрос позже.","list.hotel.error.booking.request_timedout":"Сервер не отвечает. Попробуйте повторить запрос позже.","list.hotel.error.booking.TRANSLATE>>departure date must be within 30 days after arrival date":"Срок пребывания должен быть не более 30 дней.","list.hotel.error.booking.TRANSLATE>>departure date must be within 360 days in the future":"Дата отъезда должна быть в пределах 360 дней от сегодняшнего числа.","list.hotel.error.booking.TRANSLATE>>Server unavailable":"Сервер недоступен","list.hotel.svoytravel_countries.1":"Россия","list.hotel.svoytravel_countries.36":"Беларусь","list.hotel.svoytravel_countries.250":"Казахстан","list.hotel.svoytravel_countries.252":"Молдавия","list.hotel.svoytravel_countries.35":"Украина","list.hotel.svoytravel_countries.83":"Австралия","list.hotel.svoytravel_countries.142":"Австрия","list.hotel.svoytravel_countries.249":"Азербайджан","list.hotel.svoytravel_countries.143":"Албания","list.hotel.svoytravel_countries.190":"Алжир","list.hotel.svoytravel_countries.226":"Ангола","list.hotel.svoytravel_countries.261":"Андорра","list.hotel.svoytravel_countries.237":"Антигуа и Барбуда","list.hotel.svoytravel_countries.84":"Аргентина","list.hotel.svoytravel_countries.8":"Армения","list.hotel.svoytravel_countries.133":"Афганистан","list.hotel.svoytravel_countries.216":"Бангладеш","list.hotel.svoytravel_countries.203":"Барбадос","list.hotel.svoytravel_countries.209":"Бахрейн","list.hotel.svoytravel_countries.236":"Белиз","list.hotel.svoytravel_countries.85":"Бельгия","list.hotel.svoytravel_countries.168":"Бенин","list.hotel.svoytravel_countries.139":"Бирма","list.hotel.svoytravel_countries.144":"Болгария","list.hotel.svoytravel_countries.86":"Боливия","list.hotel.svoytravel_countries.257":"Босния и Герцеговина","list.hotel.svoytravel_countries.201":"Ботсвана","list.hotel.svoytravel_countries.19":"Бразилия","list.hotel.svoytravel_countries.239":"Бруней-Даруссалам","list.hotel.svoytravel_countries.166":"Буркина-Фасо","list.hotel.svoytravel_countries.186":"Бурунди","list.hotel.svoytravel_countries.210":"Бутан","list.hotel.svoytravel_countries.235":"Вануату","list.hotel.svoytravel_countries.273":"Ватикан","list.hotel.svoytravel_countries.89":"Великобритания","list.hotel.svoytravel_countries.145":"Венгрия","list.hotel.svoytravel_countries.91":"Венесуэла","list.hotel.svoytravel_countries.271":"Восточный Тимор","list.hotel.svoytravel_countries.228":"Вьетнам","list.hotel.svoytravel_countries.167":"Габон","list.hotel.svoytravel_countries.92":"Гаити","list.hotel.svoytravel_countries.200":"Гайана","list.hotel.svoytravel_countries.197":"Гамбия","list.hotel.svoytravel_countries.162":"Гана","list.hotel.svoytravel_countries.93":"Гватемала","list.hotel.svoytravel_countries.164":"Гвинея","list.hotel.svoytravel_countries.217":"Гвинея-Бисау","list.hotel.svoytravel_countries.214":"Германия","list.hotel.svoytravel_countries.94":"Гондурас","list.hotel.svoytravel_countries.218":"Гренада","list.hotel.svoytravel_countries.96":"Греция","list.hotel.svoytravel_countries.10":"Грузия","list.hotel.svoytravel_countries.97":"Дания","list.hotel.svoytravel_countries.172":"Демократическая Республика Конго","list.hotel.svoytravel_countries.229":"Джибути","list.hotel.svoytravel_countries.231":"Доминика","list.hotel.svoytravel_countries.98":"Доминиканская Республика","list.hotel.svoytravel_countries.99":"Египет","list.hotel.svoytravel_countries.194":"Замбия","list.hotel.svoytravel_countries.233":"Зимбабве","list.hotel.svoytravel_countries.140":"Израиль","list.hotel.svoytravel_countries.100":"Индия","list.hotel.svoytravel_countries.141":"Индонезия","list.hotel.svoytravel_countries.146":"Иордания","list.hotel.svoytravel_countries.101":"Ирак","list.hotel.svoytravel_countries.102":"Иран","list.hotel.svoytravel_countries.147":"Ирландия","list.hotel.svoytravel_countries.134":"Исландия","list.hotel.svoytravel_countries.148":"Испания","list.hotel.svoytravel_countries.149":"Италия","list.hotel.svoytravel_countries.137":"Йеменская Арабская Республика","list.hotel.svoytravel_countries.219":"Кабо-Верде","list.hotel.svoytravel_countries.150":"Камбоджа","list.hotel.svoytravel_countries.169":"Камерун","list.hotel.svoytravel_countries.103":"Канада","list.hotel.svoytravel_countries.211":"Катар","list.hotel.svoytravel_countries.193":"Кения","list.hotel.svoytravel_countries.170":"Кипр","list.hotel.svoytravel_countries.251":"Киргизия","list.hotel.svoytravel_countries.265":"Кирибати","list.hotel.svoytravel_countries.104":"Китай","list.hotel.svoytravel_countries.105":"Колумбия","list.hotel.svoytravel_countries.223":"Коморские острова","list.hotel.svoytravel_countries.242":"Корейская Народно-Демократическая Республика","list.hotel.svoytravel_countries.106":"Коста-Рика","list.hotel.svoytravel_countries.165":"Кот-д’Ивуар","list.hotel.svoytravel_countries.107":"Куба","list.hotel.svoytravel_countries.192":"Кувейт","list.hotel.svoytravel_countries.151":"Лаос","list.hotel.svoytravel_countries.243":"Латвия","list.hotel.svoytravel_countries.202":"Лесото","list.hotel.svoytravel_countries.108":"Либерия","list.hotel.svoytravel_countries.109":"Ливан","list.hotel.svoytravel_countries.152":"Ливия","list.hotel.svoytravel_countries.244":"Литва","list.hotel.svoytravel_countries.241":"Лихтенштейн","list.hotel.svoytravel_countries.110":"Люксембург","list.hotel.svoytravel_countries.205":"Маврикий","list.hotel.svoytravel_countries.183":"Мавритания","list.hotel.svoytravel_countries.195":"Малави","list.hotel.svoytravel_countries.173":"Малагасийская Республика","list.hotel.svoytravel_countries.163":"Малайзия","list.hotel.svoytravel_countries.179":"Мали","list.hotel.svoytravel_countries.198":"Мальдивские острова","list.hotel.svoytravel_countries.196":"Мальта","list.hotel.svoytravel_countries.158":"Марокко","list.hotel.svoytravel_countries.245":"Маршалловы острова","list.hotel.svoytravel_countries.111":"Мексика","list.hotel.svoytravel_countries.220":"Мозамбик","list.hotel.svoytravel_countries.262":"Монако","list.hotel.svoytravel_countries.184":"Монголия","list.hotel.svoytravel_countries.240":"Намибия","list.hotel.svoytravel_countries.204":"Народная Демократическая Республика Йемен","list.hotel.svoytravel_countries.266":"Науру","list.hotel.svoytravel_countries.153":"Непал","list.hotel.svoytravel_countries.174":"Нигер","list.hotel.svoytravel_countries.181":"Нигерия","list.hotel.svoytravel_countries.112":"Нидерланды","list.hotel.svoytravel_countries.113":"Никарагуа","list.hotel.svoytravel_countries.114":"Новая Зеландия","list.hotel.svoytravel_countries.115":"Норвегия","list.hotel.svoytravel_countries.213":"ОАЭ","list.hotel.svoytravel_countries.212":"Оман","list.hotel.svoytravel_countries.138":"Пакистан","list.hotel.svoytravel_countries.264":"Палау","list.hotel.svoytravel_countries.116":"Панама","list.hotel.svoytravel_countries.222":"Папуа-Новая Гвинея","list.hotel.svoytravel_countries.117":"Парагвай","list.hotel.svoytravel_countries.118":"Перу","list.hotel.svoytravel_countries.95":"Польша","list.hotel.svoytravel_countries.154":"Португалия","list.hotel.svoytravel_countries.171":"Республика Конго","list.hotel.svoytravel_countries.247":"Республика Корея","list.hotel.svoytravel_countries.260":"Республика Македония","list.hotel.svoytravel_countries.187":"Руанда","list.hotel.svoytravel_countries.155":"Румыния","list.hotel.svoytravel_countries.122":"США","list.hotel.svoytravel_countries.119":"Сальвадор","list.hotel.svoytravel_countries.227":"Самоа","list.hotel.svoytravel_countries.253":"Сан-Марино","list.hotel.svoytravel_countries.221":"Сан-Томе и Принсипи","list.hotel.svoytravel_countries.120":"Саудовская Аравия","list.hotel.svoytravel_countries.206":"Свазиленд","list.hotel.svoytravel_countries.225":"Сейшельские острова","list.hotel.svoytravel_countries.180":"Сенегал","list.hotel.svoytravel_countries.234":"Сент-Винсент и Гренадины","list.hotel.svoytravel_countries.238":"Сент-Китс и Невис","list.hotel.svoytravel_countries.232":"Сент-Люсия","list.hotel.svoytravel_countries.269":"Сербия","list.hotel.svoytravel_countries.199":"Сингапур","list.hotel.svoytravel_countries.121":"Сирия","list.hotel.svoytravel_countries.128":"Словакия","list.hotel.svoytravel_countries.258":"Словения","list.hotel.svoytravel_countries.215":"Содружество Багамских островов","list.hotel.svoytravel_countries.230":"Соломоновы острова","list.hotel.svoytravel_countries.175":"Сомали","list.hotel.svoytravel_countries.159":"Судан","list.hotel.svoytravel_countries.224":"Суринам","list.hotel.svoytravel_countries.182":"Сьерра-Леоне","list.hotel.svoytravel_countries.254":"Таджикистан","list.hotel.svoytravel_countries.136":"Таиланд","list.hotel.svoytravel_countries.185":"Танзания","list.hotel.svoytravel_countries.176":"Того","list.hotel.svoytravel_countries.267":"Тонга","list.hotel.svoytravel_countries.188":"Тринидад и Тобаго","list.hotel.svoytravel_countries.268":"Тувалу","list.hotel.svoytravel_countries.160":"Тунис","list.hotel.svoytravel_countries.255":"Туркменистан","list.hotel.svoytravel_countries.123":"Турция","list.hotel.svoytravel_countries.191":"Уганда","list.hotel.svoytravel_countries.256":"Узбекистан","list.hotel.svoytravel_countries.124":"Уругвай","list.hotel.svoytravel_countries.246":"Федеративные Штаты Микронезии","list.hotel.svoytravel_countries.208":"Фиджи","list.hotel.svoytravel_countries.125":"Филиппины","list.hotel.svoytravel_countries.156":"Финляндия","list.hotel.svoytravel_countries.126":"Франция","list.hotel.svoytravel_countries.259":"Хорватия","list.hotel.svoytravel_countries.177":"Центральноафриканская Республика","list.hotel.svoytravel_countries.178":"Чад","list.hotel.svoytravel_countries.272":"Черногория","list.hotel.svoytravel_countries.127":"Чешская Республика","list.hotel.svoytravel_countries.129":"Чили","list.hotel.svoytravel_countries.270":"Швейцария","list.hotel.svoytravel_countries.135":"Швеция","list.hotel.svoytravel_countries.157":"Шри-Ланка","list.hotel.svoytravel_countries.130":"Эквадор","list.hotel.svoytravel_countries.207":"Экваториальная Гвинея","list.hotel.svoytravel_countries.263":"Эритрея","list.hotel.svoytravel_countries.248":"Эстония","list.hotel.svoytravel_countries.131":"Эфиопия","list.hotel.svoytravel_countries.132":"ЮАР","list.hotel.svoytravel_countries.189":"Ямайка","list.hotel.svoytravel_countries.274":"Япония","list.hotel.sort.name":"названию","list.hotel.sort.stars":"звездности","list.hotel.sort.price_single":"по стоимости одноместного номера","list.hotel.sort.price_double":"по стоимости двухместного номера","list.hotel.sort.rating":"популярности","list.hotel.category.1":"1*","list.hotel.category.2":"2*","list.hotel.category.3":"3*","list.hotel.category.4":"4*","list.hotel.category.5":"5*","list.hotel.payment_type.bookvario.card":"Оплата банковской картой (через систему UFS)","list.hotel.payment_type.bookvario.juristic_bank_transfer":"Оплата банковским переводом от юридического лица","list.hotel.payment_type.bookvario.cash_office":"Наличный расчет в офисе","list.hotel.payment_type.bookvario.natural_bank_transfer":"Оплата банковским переводом от физического лица","list.hotel.payment_type.svoytravel.card":"Оплата банковской картой","list.hotel.payment_type.vitus_bering.card":"Оплата банковской карточкой","list.hotel.payment_type.vitus_bering.cash_office":"Оплата наличными в офисе","list.currency_long.RUR":"руб.","list.currency_long.RUB":"руб.","list.currency_long.USD":"$","list.currency_long.EUR":"€","list.currency_long.GBP":"£","list.avia.ticket.city_count.0":"город","list.avia.ticket.city_count.1":"города","list.avia.ticket.city_count.2":"городов","list.avia.ticket.airport_count.0":"аэропорт","list.avia.ticket.airport_count.1":"аэропорта","list.avia.ticket.airport_count.2":"аэропортов","list.avia.ticket.carrier_count.0":"авиакомпания","list.avia.ticket.carrier_count.1":"авиакомпании","list.avia.ticket.carrier_count.2":"авиакомпаний","list.avia.ticket.based.0":"базирующийся","list.avia.ticket.based.1":"базирующиеся","list.avia.ticket.based.2":"базирующиеся","list.avia.ticket.city.regularly.0":"Регулярно","list.avia.ticket.city.regularly.1":"C постоянной периодичностью","list.avia.ticket.city.regularly.2":"Обычно","list.avia.ticket.city.plane_count.0":"самолет","list.avia.ticket.city.plane_count.1":"самолета","list.avia.ticket.city.plane_count.2":"самолетов","list.avia.ticket.city.change.0":"варьируются","list.avia.ticket.city.change.1":"изменяются","list.avia.ticket.city.our_site.0":"Наш сервис","list.avia.ticket.city.our_site.1":"Наш сайт","list.avia.ticket.city.our_site.2":"Туту.ру","list.avia.ticket.city.quickly.0":"быстро","list.avia.ticket.city.quickly.1":"оперативно","list.avia.ticket.city.send.0":"присылаются","list.avia.ticket.city.send.1":"отправляются","list.avia.ticket.city.system.0":"системой","list.avia.ticket.city.system.1":"сервисом","list.avia.ticket.city.some.0":"определенной","list.avia.ticket.city.some.1":"нужной","list.avia.ticket.city.select.0":"Обозначив","list.avia.ticket.city.select.1":"Указав","list.avia.ticket.city.select.2":"Выбрав","list.avia.ticket.country_count.0":"страны","list.avia.ticket.country_count.1":"стран","list.avia.ticket.country_count.2":"стран","list.avia.ticket.plane_category.3":"среднемагистральные (дальность полета от 2 500 км до 6 000 км)","list.avia.ticket.plane_category.4":"дальнемагистральные (свыше 6 000 км)","list.avia.ticket.plane_category.10":"а также:","list.avia.ticket.based2.0":"базирующаяся","list.avia.ticket.based2.1":"базирующиеся","list.avia.ticket.based2.2":"базирующиеся","list.avia.order.status.prepared":"Обрабатывается системой","list.avia.order.status.booked":"Обрабатывается системой","list.avia.order.status.canceled":"Неоформлен","list.avia.order.status.paid":"Оплачен","list.avia.order.status.refund":"Возврат средств","list.avia.order.status.rejected":"Неоформлен","list.avia.order.status.fo_created":"Незавершен","list.avia.order.status.fo_booked":"Незавершен","list.avia.order.status.fo_payment_pre_authorized":"Оплачен","list.avia.order.status.fo_payment_pre_authorized_notified":"Оплачен","list.avia.order.status.fo_partially_paid":"Необходима доплата","list.avia.order.status.fo_payment_authorized":"Оплачен","list.avia.order.status.fo_need_changes_confirmation":"Обрабатывается системой","list.avia.order.status.fo_need_manual_ticketing":"Обрабатывается системой","list.avia.order.status.fo_paid_but_not_issued":"Обрабатывается системой","list.avia.order.status.fo_ticket_issued":"Оплачен","list.avia.order.status.fo_notification_sent":"Оформлен","list.avia.order.status.fo_itinerary_notification_sent":"Оформлен","list.avia.order.status.fo_ticket_voided":"Бронирование отменено","list.avia.order.status.fo_booking_canceled":"Бронирование отменено","list.avia.order.status.fo_unknown":"Обрабатывается системой","list.avia.order.status.fo_error":"Обрабатывается системой","list.avia.order.status.fo_refunded":"Деньги возвращены","list.avia.order.status.fo_successful_autoticketing":"Оформлен","list.avia.order.status.fo_need_ticketing_check":"Оформлен","list.avia.order.document_type_short.passport":"Паспорт РФ","list.avia.order.document_type_short.international":"Загранпаспорт","list.avia.order.document_type_short.birthcert":"Св-во о рождении","list.avia.order.document_type_short.birthcert_long":"Свидет. о рождении","list.avia.order.document_type_short.foreign":"Иностранный док-т","list.avia.order.passenger.full":"взрослый взрослых взрослых","list.avia.order.passenger.childs":"ребенок ребенка детей","list.avia.order.passenger.babies":"малыш малыша малышей","list.avia.order.class.seats_in.Y":"эконом-классе","list.avia.order.class.seats_in.C":"бизнес-классе","list.avia.order.class.seats_in.F":"первом классе","list.avia.order.class.common.Y":"эконом","list.avia.order.class.common.C":"бизнес","list.avia.order.class.common.F":"первый","list.avia.order.document_type.passport":"Паспорт РФ","list.avia.order.document_type.international":"Загранпаспорт","list.avia.order.document_type.birthcert":"Свидетельство о рождении","list.avia.order.document_type.foreign":"Иностранный документ","list.avia.schedule.seo.fly_in.0":"приходится на","list.avia.schedule.seo.fly_in.1":"в","list.avia.schedule.seo.day.0":"день","list.avia.schedule.seo.day.1":"сутки","list.avia.schedule.seo.flights.0":"рейс","list.avia.schedule.seo.flights.1":"авиарейс","list.avia.schedule.seo.flights.2":"рейса","list.avia.schedule.seo.flights.3":"авиарейса","list.avia.schedule.seo.flights.4":"рейсов","list.avia.schedule.seo.flights.5":"авиарейсов","list.avia.schedule.seo.plane_types.0":"типами воздушных судов","list.avia.schedule.seo.plane_types.1":"типами самолетов","list.avia.schedule.seo.plane_types.2":"самолетами","list.avia.schedule.seo.fly.0":"происходит","list.avia.schedule.seo.fly.1":"выполняется","list.avia.schedule.seo.fly.2":"производится","list.avia.schedule.seo.local.0":"местному","list.avia.schedule.seo.local.1":"локальному","list.avia.schedule.seo.maximum.0":"максимальное","list.avia.schedule.seo.maximum.1":"самый продолжительный перелет","list.avia.schedule.plane_type.TRN":"Поездом","list.avia.schedule.plane_type.BUS":"Автобусом","list.avia.schedule.keywords.0":"расписание самолетов","list.avia.schedule.keywords.1":"расписание рейсов","list.avia.schedule.keywords.2":"расписание авиарейсов","list.avia.search.errors.0":"","list.avia.search.errors.1":"Прошло много времени и список рейсов мог измениться. <br> Сейчас мы покажем вам самую свежую информацию о рейсах и ценах","list.avia.search.errors.2":"Мест на выбранный рейс нет. Мы запустили новый поиск","list.avia.search.errors.3":"Прошло много времени и список рейсов мог измениться. <br> Сейчас мы покажем вам самую свежую информацию о рейсах и ценах","list.avia.search.popup_errors.0":"","list.avia.search.popup_errors.1":"Результаты поиска устарели. Мы обновили список рейсов - теперь в нем только актуальные предложения","list.avia.search.popup_errors.2":"К сожалению, мест по такому тарифу уже нет. Подберите удобный вариант из обновленного списка рейсов","list.avia.search.popup_errors.3":"Результаты поиска устарели. Мы обновили список рейсов - теперь в нем только актуальные предложения","list.month_when_small.1":"январе","list.month_when_small.2":"феврале","list.month_when_small.3":"марте","list.month_when_small.4":"апреле","list.month_when_small.5":"мае","list.month_when_small.6":"июне","list.month_when_small.7":"июле","list.month_when_small.8":"августе","list.month_when_small.9":"сентябре","list.month_when_small.10":"октябре","list.month_when_small.11":"ноябре","list.month_when_small.12":"декабре","list.numbers.1":"один","list.numbers.2":"два","list.numbers.3":"три","list.numbers.4":"четыре","list.numbers.5":"пять","list.numbers.6":"шесть","list.numbers.7":"семь","list.numbers.8":"восемь","list.numbers.9":"девять","list.numbers.10":"деcять","list.sex.m":"Мужской","list.sex.f":"Женский","list.month.1":"Январь","list.month.2":"Февраль","list.month.3":"Март","list.month.4":"Апрель","list.month.5":"Май","list.month.6":"Июнь","list.month.7":"Июль","list.month.8":"Август","list.month.9":"Сентябрь","list.month.10":"Октябрь","list.month.11":"Ноябрь","list.month.12":"Декабрь","list.flight_online_table.name.up":"Табло вылета","list.flight_online_table.name.down":"Табло прилета","hotel.service_conditions.svoytravel":"Заказ отелей и гостиниц через Tutu.ru возможен только при согласии с Условиями использования сервиса, выраженного путем совершения конклюдентных действий.\nЕсли Вы не принимаете в полном объеме Условия использования сервиса, заказ отелей и гостиниц  через Tutu.ru не допускается.\nУсловия использования сервиса по заказу отелей и гостиниц через Tutu.ru\n1. ОБЯЗАННОСТИ КЛИЕНТОВ TUTU.RU\n1.1. Клиент Tutu.ru обязан:\n1.1.1. самостоятельно ознакомиться с правилами и инструкциями по заказу отелей и гостиниц на сайте www.tutu.ru;\n1.1.2. соблюдать все правила и инструкции Tutu.ru и партнеров, в том числе, но не ограничиваясь этим, договор-оферту партнеров (http://reservation.ru/reg.php);\n1.1.3. оплачивать заказ отелей и гостиниц  в соответствии с тарифами и сервисными сборами партнеров Tutu.ru по заказу отелей и гостиниц, указанными на сайте www.tutu.ru в виде единой стоимости за проживание;\n2. ПРАВА TUTU.RU\n2.1. Tutu.ru имеет право:\n2.1.1. в одностороннем порядке отказать Клиенту в заказе отелей и гостиниц через сайт www.tutu.ru, в том числе в случае нарушения Клиентом правил и инструкций по заказу отелей и гостиниц, но не ограничиваясь ими;\n2.2. изменять условия использования сервиса без предварительного уведомления.\n3. КОНФИДЕНЦИАЛЬНОСТЬ ЛИЧНЫХ ДАННЫХ\n3.1. Tutu.ru обязуется заботиться о конфиденциальности личной информации, предоставленной пользователем при заказе отелей и гостиниц.\n3.2. Факт пользования услугами Tutu.ru подтверждает согласие Клиента на использование адреса его электронной почты в сети Интернет (E-mail) для направления ему информации по электронной почте, признаваемой Tutu.ru ценной для Клиента.\n3.3. За предоставление Клиентом неверных данных Tutu.ru ответственности не несет.\n4. ФИНАНСОВЫЕ УСЛОВИЯ\n4.1. Заказывая отели и гостиницы через Tutu.ru, Клиент соглашается с ценами, указанными на сайте. \n4.2. Tutu.ru не несет ответственности за изменения тарифов  со стороны партнеров по заказу отелей и гостиниц.\n\n\n5. ОТВЕТСТВЕННОСТЬ\n5.1. Tutu.ru  не несет ответственности за надлежащее функционирование и доступность отдельных сегментов сети Интернет в ходе покупки электронных билетов.\n5.2. Tutu.ru не несет ответственности за надлежащую работу компаний-партнеров.\n5.3. Клиент принимает на себя полную ответственность и риски, связанные с заказом отелей и гостиниц.\n5.4. Tutu.ru не несет ответственности за любые убытки и моральный вред, понесенные Клиентом в результате ошибочного понимания или непонимания Клиентом информации о порядке заказа отелей и гостиниц.","hotel.order.svoytravel.step-guests":"Контакты и информация о гостях","hotel.order.svoytravel.step-payment-choice":"Подтверждение","hotel.order.svoytravel.step-payment-action":"Оплата","hotel.order.svoytravel.step-payment-need-confirmation":"Подтверждение заказа","hotel.order.svoytravel.step-final":"Завершение бронирования","hotel.order.svoytravel.hotel_reservation_title":'Бронирование гостиницы "%hotel_title%".',"hotel.order.svoytravel.need_confirmation":"По Запросу: оплата производится после подтверждения, которое поступит на ваш E-mail.","hotel.order.svoytravel.need_confirmation_tip":"Обратите внимание, что это бронирование происходит «по запросу».<br/>\n\tПосле получения вашей заявки мы свяжемся с отелем, чтобы уточнить наличие свободных мест.<br/>\n\tПосле подтверждения информации отелем мы отправим вам письмо на электронную почту.","hotel.order.svoytravel.online":"Онлайн: оплата производится в режиме реального времени сразу после бронирования.","hotel.order.svoytravel.online_tip":"Это бронирование вы можете произвести в режиме Онлайн.","hotel.order.svoytravel.payment_card_tip_cards":'<p>\n\t<img src="http://localhost.localdomain/images2/bankcard/logo_visa.gif" alt="VISA" />\n\t<img src="http://localhost.localdomain/images2/bankcard/logo_mastercard.gif" alt="MasterCard" />\n\t<img src="http://localhost.localdomain/images2/bankcard/logo_dcl.jpg" alt="Diners Club" />\n\t<img src="http://localhost.localdomain/images2/bankcard/logo_jcb.jpg" alt="JCB" /><br/>\n\tОплата банковской картой VISA, MasterCard, Diners Club, JCB.</p>',"hotel.order.svoytravel.payment_card_tip":'После перехода по ссылке "Оплатить" вы попадете на защищенную страницу сервера Процессингового Центра системы электронных платежей, где необходимо указать сведения об используемой банковской карте.<br/>\nБронирование подтверждается автоматически, сразу после оплаты.',"hotel.order.svoytravel.payment_qiwi_tip":"Распечатайте Квитанцию и произведите оплату в ближайшем платежном терминале Qiwi.<br/>\nБронирование подтверждается автоматически после оплаты.","hotel.order.svoytravel.payment_euroset_tip":'Распечатайте Квитанцию и произведите оплату в ближайшем салоне связи "Евросеть".<br/>\nБронирование подтверждается автоматически после оплаты.',"hotel.order.svoytravel.payment_available_after_confirmation":"оплата будет возможна после подтверждения","hotel.order.svoytravel.thanks_for_booking_need_confirm":"Вы оформили бронирование, требующее подтверждения оператора.<br/><br/>\nВ ближайшее время он подтвердит ваш заказ по электронной почте. После этого вы сможете оплатить заказ, перейдя на эту страницу по ссылке в письме.<br/><br/>\nБронирование, принятое в нерабочее время, обслуживается на следующий рабочий день.<br/><br/>\nВремя работы операторов (мск.): с 10:00 до 19:00 по рабочим дням, с 11:00 до 16:00 по субботам. Воскресенье — выходной день.<br/><br/>","hotel.order.svoytravel.younger_than_18":"Это ребенок младше 18 лет","hotel.order.svoytravel.older_than_18":"Старше 18 лет","hotel.order.svoytravel.child_younger_than_18":"ребенок до 18 лет","hotel.order.svoytravel.awaiting_redirect":"Переход к процессингу заказа","hotel.order.svoytravel.assist_redirect":"Происходит резервирование билетов и<br/>перенаправление на сервис оплаты.<br/>Это может занять 1-2 минуты.","hotel.order.svoytravel.assist_redirect_press_button":'Если этого не произошло, нажмите на кнопку "Оплатить заказ".',"hotel.order.svoytravel.awaiting_payment_confirmation":"<p>Заказ № <strong><nobr>%order_number%</nobr></strong> от %created%</p>\n\t<p>Ваш заказ будет оформлен сразу после успешной обработки данных платежной системой в течение 20 минут.</p>\n\t<p>После этого вы получите письмо с извещением о бронировании и ваучером для заселения в отель.</p>\n\t<p>Для уточнения состояния заказа вы можете позвонить по телефону %telephone_number%.</p>","hotel.order.svoytravel.order_completed_print_voucher":'<p>Благодарим вас за бронирование отеля на Tutu.ru.</p>\n<p>Бронирование отеля "%hotel_title%" заказ № <strong><nobr>%order_number%</nobr></strong> успешно завершено.<br/>Пожалуйста, перейдите по ссылке и <b><a href=%voucher_url%>распечатайте ваучер</a></b> для заселения в отель.</p>',"hotel.order.svoytravel.annulation_tip":"При аннуляции или изменении Пользователем подтвержденного Бронирования применяются штрафные санкции равные стоимости заказанных услуг, приходящихся на первые сутки обслуживания.","hotel.order.vitus_bering.requested_success_message_title":"Ваш заказ зарегистрирован.","hotel.order.vitus_bering.requested":"Ваш заказ будет подтвержден отелем в течение 30 минут. В течение этого времени вы получите подтверждение по электронной почте. Пожалуйста, проверьте почту.","hotel.order.vitus_bering.confirmed_success_message_title":"Ваш заказ подтвержден.","hotel.order.vitus_bering.confirmed":"Ваш заказ подтвержден, резервирование прошло успешно. Пожалуйста, перейдите на страницу оплаты.","hotel.order.vitus_bering.prepared_success_message_title":"Ваш заказ готов к оплате.","hotel.order.vitus_bering.prepared":"Ваш заказ подтвержден, резервирование прошло успешно. Пожалуйста, перейдите на страницу оплаты.","hotel.order.vitus_bering.paid_success_message_title":"Ваш заказ отмечен как оплаченный.","hotel.order.vitus_bering.paid":"Ваш заказ отмечен как оплаченный. Ожидается подтверждение от системы оплаты, это может занять около 30 минут. После подтверждения оплаты вы сможете распечатать ваучер.","hotel.order.vitus_bering.completed_success_message_title":"Ваш заказ оплачен.","hotel.order.vitus_bering.completed":"Вы оплатили заказ. Распечатайте ваучер.","hotel.order.vitus_bering.payment_info":'<b>Оплата банковскими картами Visa, MasterCard, DCL, JСB</b>\n\t<div style="height: 10px;"></div>\n\t<a href="http://visa.com/" target="_blank"><img src="http://localhost.localdomain/images2/bankcard/logo_visa.gif" alt="" style="border-width: 0px;"></a> \n\t<a href="http://www.mastercard.com/" target="_blank"><img src="http://localhost.localdomain/images2/bankcard/logo_mastercard.gif" alt="" style="border-width: 0px;"></a>\n\t<a href="http://www.jcbinternational.com/" target="_blank"><img src="http://localhost.localdomain/images2/bankcard/logo_jcb.jpg" alt="" style="border-width: 0px;"></a>\n\t<a href="http://www.dinnersclub.com/" target="_blank"><img src="http://localhost.localdomain/images2/bankcard/logo_dcl.jpg" alt="" style="border-width: 0px;"></a>                             \n\t<div style="height: 10px;"></div>\n\t\n\t<p>Расчеты по банковским картам производятся путем перенаправления на сайт платежной системы ЗАО «Сирена-Трэвел». В системе Сирена-Трэвел безопасность платежей обеспечивается использованием SSL протокола для передачи конфиденциальной информации от клиента на сервер платежной системы для дальнейшей обработки. Дальнейшая передача информации осуществляется по закрытым банковским сетям высшей степени защиты. Сбор и обработка полученных конфиденциальных данных клиента (реквизиты карты, регистрационные данные и т.д.) производится в процессинговом центре. Таким образом, «MindBridge Group» не может получить персональные данные покупателя, данные банковской карты и прочую информацию, включая информацию о покупках клиента, сделанных в других магазинах.</p>',"hotel.order.tts_group.success_message_title":"Поздравляем с успешным заказом!","hotel.order.tts_group.success_message":"<p>Ваш заказ принят. Наш сотрудник свяжется с&nbsp;вами в&nbsp;ближайшее время для подтверждения заказа и&nbsp;уточнения деталей бронирования и оплаты.</p>\n<p>Наши операторы работают с&nbsp;понедельника по&nbsp;пятницу с&nbsp;10&nbsp;до&nbsp;19 часов. Заявки на&nbsp;сайте принимаются круглосуточно.</p>","hotel.order.tts_group.requested":'<table cellspacing="0" cellpadding="5" width="70%" align="center" class="blockCenter">\n<tr>\n\t<td>\n\t\t<div>\n\t\t\t<p align="left">Если в&nbsp;течение 30&nbsp;минут вам не&nbsp;перезвонили, то&nbsp;для уточнения вашей заявки можно позвонить по&nbsp;телефону (495) 788-53-83&nbsp;(наш партнер, компания TTS Group).</p>\n\t\t\t<p align="left">При этом <strong>сообщите номер заказа</strong>, а&nbsp;также что вы&nbsp;делали <strong>бронирование отеля</strong> на&nbsp;сайте ТУТУ.РУ&nbsp;&#8212; это поможет быстрее найти вашу заявку.</p>\n\t\t\t<p align="left">&nbsp;</p>\n\t\t</div>\n\t</td>\n</tr>\n</table>',"hotel.order.tts_group.address1":'\n\t<p>\n\t<strong>Адрес офиса для заключения договора и получения билетов</strong>: м. Беговая, Хорошевское шоссе, дом 32а, 3 подъезд, 3 этаж, офис 312.<br />\n\tНа проходной сказать, что Вы идете в компанию "Билет-он-лайн".\n\t</p>\n\t',"hotel.order.tts_group.address2":'\n\t<p>\n\t\tОт м. "Беговая" (первый вагон из центра, в подземном переходе направо, по лестнице - налево) идете чуть по диагонали правее в сторону дворов.\n\t\tПроходите мимо яркой и заметной желтой вывески "Стоматология" на стене дома и попадаете на неширокую улочку, которая упирается в красный дом с зеленой крышей.\n\t\tЕго прекрасно видно. Перед тем как попасть на территорию офисного центра необходимо миновать проходную со шлагбаумом, предъявив там паспорт и сказав, что идете в компанию "Билет Онлайн".\n\t\tПодъезд 3 находится правее от проходной.\n\t</p>\n\t<p align="left"> Благодарим вас за&nbsp;то,&nbsp;что вы&nbsp;воспользовались нашей услугой бронирования.</p>\n\t<p align="left">&nbsp;</p>\n\t<p align="left"><strong>Мы&nbsp;всегда рады видеть вас в&nbsp;числе клиентов  Туту.ру.</strong></p>\n\t',"hotel.distributions.0":"Многоместный","hotel.distributions.1":"Одноместный","hotel.distributions.2":"Двухместный","hotel.distributions.3":"Трехместный","hotel.distributions.4":"Четырехместный","hotel.distributions.5":"Пятиместный","hotel.distributions.6":"Шестиместный","hotel.distributions.7":"Семиместный","hotel.distributions.8":"Восьмиместный","hotel.distributions.9":"Девятиместный","hotel.distributions.10":"Десятиместный","hotel.distributions.11":"Одинадцатиместный","hotel.distributions.12":"Двенадцатиместный","hotel.index.breadcrumbs":"Гостиницы","hotel.index.russian_title":"Бронирование гостиниц онлайн","hotel.index.russian_description":"Бронирование гостиниц по&nbsp;России на&nbsp;Tutu.ru происходит в&nbsp;режиме реального времени, т.е. онлайн. Если указано, что в&nbsp;такие-то даты есть свободные номера, значит, они действительно есть. Чтобы забронировать гостиницу, не&nbsp;нужно ждать, пока менеджер отеля вручную обработает ваш заказ&nbsp;&mdash; все происходит автоматически.","hotel.index.foreign_title":"Бронирование отелей по всему миру","hotel.index.foreign_description":"Бронирование отелей онлайн существенно облегчает жизнь путешественников, но&nbsp;заставляет отели хорошо потрудиться. Только лучшие отели готовы постоянно актуализировать информацию о&nbsp;свободности номеров. В&nbsp;России таких отелей пока что меньше, чем в&nbsp;остальном мире.","hotel.index.text":'<h2 style="font-size: 14px;"><a href="%contactsUrl%">Режим работы</a></h2>\n\t<p>\n\tСервис по бронированию отелей работает круглосуточно и без выходных. Заявки принимаются в режиме 7/24/365.\n\t</p>',"hotel.index.not_found_title":"Пожалуйста, используйте поиск","hotel.index.not_found_text":"Скорее всего, содержание этой страницы было перемещено. Но&nbsp;про&nbsp;это еще мало&nbsp;кто знает.\n\t\t\t\t\t<br><br>Пока мы&nbsp;исправляем это&nbsp;недоразумение, пожалуйста, воспользуйтесь формой поиска. Так будет быстрее и&nbsp;надежнее.","blank.comepay_title":"Оплата в терминалах Comepay","blank.bankomats_title":"Банкоматы Мастер-Банк","blank.contact_title":"Банковские отделения","blank.elecsnet_title":"Оплата в терминалах Элекснет","blank.euroset_title":"Оплата в салонах Евросеть","blank.osmp_title":"Оплата в терминалах ОСМП (Qiwi)","blank.unikassa_title":"Оплата в терминалах Уникасса","blank.payment_title":"Правила оплаты электронного ж/д билета","blank.rules_title":"Правила покупки электронных железнодорожных билетов","blank.page_blank_moscow":"Контакты офиса по продаже ж/д билетов в Москве","blank.page_blank_spb":"Контакты офиса по продаже ж/д билетов в Санкт-Петербурге","blank.beeline_title":"Оплата с баланса Билайн","blank.beeline_avans_title":"Специальный авансовый счет","user.private_office":"Личный кабинет","user.my_orders":"Мои заказы","user.my_data":"Личные данные и&nbsp;настройки","user.feedback":"Обратная связь","user.settings":"Настройки сайта","user.ich_bin":"Я","user.entrance":"Вход","user.enter":"Войти","user.enter_profile":"Войти в&nbsp;личный кабинет","user.logout":"Выход","user.login":"Логин","user.id":"ID","user.password":"Пароль","user.remember_me":"Запомнить меня","user.forgot_password":"Восстановить пароль","user.remind_password":"Восстановить","user.create_password":"Создать пароль","user.clear_cookie":"Очистить Cookie","user.new_password":"Новый пароль","user.edit_data":"Редактировать данные","user.cancel_edit_data":"Отменить редактирование","user.change_login":"Изменить электронную почту","user.change_password":"Изменить пароль","user.change_photo":"Изменить фото","user.logged_as":"Залогинен как %name%","user.personal_data":"Личные данные","user.notification_settings":"Настройки оповещений","user.location_settings":"Мое местоположение","user.email":"Электронная почта","user.your_email":"Адрес вашей электронной почты","user.new_email":"Новая электронная почта","user.email_hint":"Адрес электронной почты иcпользуется для входа на&nbsp;сайт и&nbsp;для получения регистрационной информации.","user.email_registration_hint":"Для регистрации на&nbsp;сайте укажите свою электронную почту.","user.remind_password_hint":"Укажите адрес электронной почты, который вы&nbsp;использовали при регистрации на&nbsp;сайте.","user.password_hint":"Пароль должен быть не&nbsp;короче %min% и&nbsp;не&nbsp;длиннее %max% символов","user.password_confirm":"Повторите пароль","user.password_new":"&mdash; Придумайте пароль","user.password_new_confirm":"&mdash; Повторите его","user.new_password_confirm":"Повторите пароль","user.current_password":"Текущий пароль","user.current_password_hint":"Текущий пароль нужен для подтверждения действия.","user.first_name":"Имя","user.middle_name":"Отчество","user.last_name":"Фамилия","user.nick_name":"Никнейм","user.specify_first_name":"Укажите имя","user.specify_middle_name":"Укажите отчество","user.specify_last_name":"Укажите фамилию","user.relation":"Способ связи","user.specify_relation":"Укажите способ связи","user.nick":"Никнейм","user.nick_hint":"Ваше имя на&nbsp;сайте. От %min% до %max% символов.","user.sex":"Пол","user.age":"Возраст","user.mobile_phone":"Мобильный телефон","user.mobile_phone_hint":"Введите номер своего мобильно телефона в формате +7 999 999-99-99","user.home_phone":"Домашний телефон","user.phone":"Телефон","user.city":"Город","user.birthday":"Дата рождения","user.birthday_empty":"Укажите дату рождения","user.birthday_not_full":"Дата рождения указана не&nbsp;полностью.","user.wrong_birthday":"Дата рождения указана неправильно.","user.want_register":"Зарегистрироваться","user.register_reason_title":"Зачем мне нужна регистрация?","user.register_reason":'<p>Конечно, вы&nbsp;без всякой регистрации можете покупать билеты, узнавать расписания, бронировать отели и&nbsp;т.п.</p>\n\t\t\t\t\t\t\t<p>Но&nbsp;после регистрации все это станет удобнее и&nbsp;быстрее.</p>\n\t\t\t\t\t\t\tВ&nbsp;любой момент вы&nbsp;сможете\n\t\t\t\t\t\t\t<ul class="motivation-list">\n\t\t\t\t\t\t\t\t<li class="item">распечатать бланк заказа или маршрутной квитанции,</li>\n\t\t\t\t\t\t\t\t<li class="item">заказать звонок оператора и&nbsp;т.п.,</li>\n\t\t\t\t\t\t\t\t<li class="item">посмотреть историю заказов.</li>\n\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t<p>Личный кабинет мы&nbsp;сделали совсем недавно. Уже скоро его возможности ощутимо расширятся.</p>',"user.register":"Зарегистрировать","user.authorize":"Войти на&nbsp;сайт","user.registration":"Регистрация","user.need_register_for_action":"Для выполнения этого действия необходимо зарегистрироваться на&nbsp;сайте.","user.auto_registration":"Автоматически зарегистрировать меня на&nbsp;сайте.","user.auto_login_hint":"Если вы&nbsp;зарегистрированы на&nbsp;сайте, то&nbsp;введите в&nbsp;форму ниже свой пароль, тогда заказ будет отображаться в&nbsp;личном кабинете.","user.already_registered":'Если вы&nbsp;зарегистрированы на&nbsp;сайте, то&nbsp;введите в&nbsp;форму ниже свою электронную почту и&nbsp;пароль, или воспользуйтесь функцией &laquo;<a href="%remind_password_url%" arget="_blank">Восстановить пароль</a>&raquo;.',"user.sex_unknown":"Не указан","user.sex_male":"Мужской","user.sex_female":"Женский","user.settings_mailing_news":"Я согласен получать новости сайта (не чаще 1 раза в месяц)","user.auto_login_success":"Вы&nbsp;успешно вошли на&nbsp;сайт. После оформления заказ будет отображаться в&nbsp;личном кабинете.","user.registered_successfully":"Вы&nbsp;успешно зарегистрировались на&nbsp;сайте. На&nbsp;указанный вами адрес электронной почты отправлено письмо со&nbsp;ссылкой для подтверждения регистрации. Пройдите по&nbsp;ссылке и&nbsp;задайте свой пароль для доступа в&nbsp;личный кабинет.","user.repeat_activation_sent":"Вам отправлено письмо со&nbsp;ссылкой для подтверждения адреса электронной почты.","user.repeat_already_sent":"Письмо уже отправлено.","user.repeat_activation_error":"Ошибка","user.activated_successfully":"Вы&nbsp;успешно подтвердили свою регистрацию. Добро пожаловать в&nbsp;личный кабинет.","user.remind_password_email_sent":"На&nbsp;указанный вами адрес электронной почты отправлено письмо с&nbsp;ссылкой для изменения пароля.","user.change_login_notification_sent":"На&nbsp;указанный вами новый адрес электронной почты отправлено письмо со&nbsp;ссылкой для подтверждения. До&nbsp;подтверждения вход на&nbsp;сайт будет доступен по&nbsp;прежнему адресу %old_login%.","user.change_login_notification_sent2":"На&nbsp;вашу электронную почту отправлено повторное письмо со&nbsp;ссылкой для подтверждения. До&nbsp;подтверждения вход на&nbsp;сайт будет доступен по&nbsp;прежнему адресу %old_login%.","user.password_changed_successfully":"Новый пароль установлен","user.profile_edited_successfully":"Личные данные сохранены","user.new_login_confirmed":"Вы успешно подтвердили новый адрес электронной почты","user.fill_required_fields":"Заполните все обязательные поля","user.cannot_register":"Невозможно зарегистрировать","user.wrong_remind_password_login":"Пользователя с такой электронной почтой не существует!","user.new_login_not_confirmed_yet":"Вы не подтвердили новый адрес электронной почты. Пройдите по отправленной вам ссылке. До подтверждения вход на сайт будет доступен по старой электронной почте %old_login%. Если вы не получали письма, либо ссылка уже устарела, пожалуйста, отправьте письмо еще раз.","user.repeat_confirm_login_notification":"Повторить письмо","user.cancel_change_login":"Отменить изменение","user.first_name_empty":"Укажите имя","user.last_name_empty":"Укажите фамилию","user.wrong_login_attempt":"Неверные имя пользователя или пароль. Возможно, у&nbsp;вас нажата клавиша Caps Lock или надо переключить язык на&nbsp;клавиатуре.","user.email_empty":"Укажите электронную почту","user.wrong_email":"Вы&nbsp;указали электронную почту в&nbsp;неверном формате","user.email_exists":"Пользователь с&nbsp;таким адресом электронной почты уже зарегистрирован","user.email_exists_cannot_confirm":"Невозможно подтвердить новый адрес электронной почты, так как пользователь с&nbsp;таким адресом уже зарегистрирован.","user.user_exists":'Пользователь с&nbsp;такой электронной почтой уже зарегистрирован. Пожалуйста, авторизуйтесь на&nbsp;сайте, или воспользуйтесь функцией &laquo;<a href="%remind_password_url%" arget="_blank">Восстановить пароль</a>&raquo;.',"user.password_empty":"Укажите пароль","user.new_password_empty":"Укажите новый пароль","user.current_password_empty":"Укажите текущий пароль","user.password_confirm_empty":"Повторите пароль","user.wrong_current_password":"Неправильно указан текущий пароль","user.wrong_password_length":"Пароль должен быть не короче %min% и не длиннее %max% символов","user.wrong_new_password_length":"Новый пароль должен быть не&nbsp;короче %min% и&nbsp;не&nbsp;длиннее %max% символов","user.wrong_password_confirm":"Пароль не&nbsp;совпадает с&nbsp;повторением","user.wrong_new_password_confirm":"Новый пароль не&nbsp;совпадает с&nbsp;повторением","user.wrong_imagecaptcha_code":"Неправильно введен код проверки","user.wrong_sex":"Пожалуйста, укажите ваш&nbsp;пол","user.not_confirmed":'Вы зарегистрировались, но ещё не создали пароль. Для создания пароля пройдите по ссылке, которая была выслана вам на электронную почту. Для повторной отправки письма нажмите "Восстановить".',"user.not_confirmed_yet":"Пожалуйста, перейдите по&nbsp;ссылке из&nbsp;письма, полученного при&nbsp;регистрации.<br /><br />\n\tЕсли вы не&nbsp;получали письма, либо ссылка уже устарела, пожалуйста, отправьте письмо еще раз.","user.user_not_confirmed":'Вы уже зарегистрировались на&nbsp;сайте, но не&nbsp;подтвердили свою регистрацию. Для&nbsp;подтверждения регистрации пройдите по&nbsp;ссылке, которая была выслана вам на&nbsp;E-mail, либо воспользуйтесь функцией &laquo;<a href="%remind_password_url%" arget="_blank">Восстановить пароль</a>&raquo;.',"user.already_confirmed":"Вы уже подтвердили свою регистрацию на сайте.","user.not_active":"Пользователь отключен. Обратитесь в&nbsp;службу поддержки.","user.activation_expired":"Указанный код доступа не&nbsp;существует, либо устарел","user.wrong_access_action":"Неправильный адрес","user.mobile_phone_empty":"Укажите мобильный телефон","user.wrong_mobile_phone":"Мобильный телефон указан неправильно","user.home_phone_empty":"Укажите домашний телефон","user.wrong_home_phone":"Домашний телефон указан неправильно","user.phone_empty":"Укажите телефон","user.wrong_phone":"Телефон указан неправильно","user.new_password_mustbe_different":"Новый пароль должен отличаться от&nbsp;старого","user.no_user_such_id_login":"Нет пользователя с указанным SESSION ID","user.no_such_user":"Нет такого пользователя","user.cannot_login_stronger_user":"Нельзя залогиниться под пользователем с большими (или такими же) правами доступа.","user.specify_login_or_id":"Укажите электронную почту (Email) или уникальный ID пользователя","user.once_more_su_forbidden":"Вы уже залогинились под другим пользователем. Чтобы воспользоваться этой функцией повторно, сначала разлогиньтесь.","user.identified_as_search_engine":"Невозможно отобразить страницу.<br>USER_AGENT: %user_agent%","user.order_list":"Список заказов","user.order_list_type":"Тип","user.order_list_route":"Маршрут","user.order_list_route_way":"Маршрут проезда","user.order_list_date":"Дата","user.order_list_price":"Цена","user.order_list_status":"Статус заказа","user.order_list_arrival":"Прибытие","user.order_list_back":"Обратно","user.order_list_number":"Заказ №%number%","user.order_list_train_number":"Поезд №%train_number%","user.order_list_avia_race":"%iata% %race%","user.no_orders":'У Вас пока нет заказов, но это легко исправить!\n\t\t\t\t\t\t\t\t\t<br /><br />Закажите <a href="%avia_url%">авиабилет</a>, <a href="%trains_url%">билет на поезд</a> или <a href="%hotels_url%">забронируйте гостиницу</a>.',"user.order_number":"Заказ <strong>№ %number%</strong>","user.order_from":"Заказ от","user.money_format":"%price% %cur%","user.order_details":"Подробнее","user.title_registration":"Регистрация на&nbsp;сайте","user.title_private_office":"Личный кабинет","user.title_my_orders":"Мои заказы","user.title_feedback":"Обратная связь","user.title_settings":"Настройки сайта","user.title_ab_settings":"Настройка АБ-кампаний","user.title_config_settings":"Настройка конфига проекта","user.title_login":"Вход","user.title_remind_password":"Восстановить пароль","user.title_edit_profile":"Редактирование личных данных","user.title_edit_password":"Изменение пароля","user.title_edit_login":"Изменение электронной почты (логина)","user.title_not_confirmed":"Подтвердите электронную почту","user.title_su":"Зайти под другим пользователем","user.success_reg_page_title":"Спасибо, что присоединились к&nbsp;нашему сервису!","user.success_reg_page_message":"Проверьте, пожалуйста, электронную почту.","user.title_activation_profile":"Адрес вашей электронной почты успешно подтвержден.","user.text_activation_profile":"Пожалуйста, создайте пароль, по&nbsp;которому вы&nbsp;будете входить в&nbsp;личный кабинет.","user.title_new_password":"Задать новый пароль","user.text_new_password":"Введите новый пароль","user.title_confirm_login":"Подтверждение электронной почты","user.title_confirm_email":"Подтверждение адреса электронной почты","user.all_orders":"Все заказы","user.ticket_with_return":"Билет с возвратом","user.ticket_one_way":"Билет в одну сторону","user.last_orders":"Последние заказы","user.toread_how_pay":"Как оплатить авиабилеты","user.toread_how_get":"Как получить авиабилеты","user.toread_how_passreg":"Как пройти регистрацию в аэропорту","user.show_kvit":"Посмотреть маршрутную квитанцию","user.open_trace_blank":"Открыть маршрутную квитанцию","user.open_trace_blank_more":"Открыть маршрутную квитанцию с&nbsp;подробной информацией","user.fly_time_in":"Вылет <strong>%date%</strong> в <strong>%time%</strong>","user.fly_time_local":"вылет и прилет<br />по местному времени","user.fly_time_msk":"в расписании указано<br />московское время","user.fly_order":"Заказ","user.order_year":"от %date% года","user.order_print":"Распечатать страницу<br />и бланк заказа","user.mid_in_city":"Пересадка в г.","user.hide_details":"Скрыть подробности о пересадке","user.next_day":"На следующий день","user.b_day":"д.р.","user.b_year":"г.","user.actual_before":"действителен до","user.fly_race":"Рейс","user.fly_boeng":"Боинг 747","user.title_not_confirm_login":"Пожалуйста, проверьте почту","user.title_not_confirm_text":"К сожалению, вы пока не перешли по ссылке         из письма, которое мы вам отправляли.\n\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\tПока вы не откроете это письмо и не перейдете по ссылке, войти в личный кабинет не получится.","user.if_no_email":'<span class="gray">Если письмо не пришло, мы&nbsp;отправим новое на адрес</span>\n\t\t\t\t\t\t\t\t\t<br />\n\t\t\t\t\t\t\t\t\t%login% &mdash;',"user.title_know_login":"Эту почту мы уже знаем!","user.title_know_text":"Скорее всего, вы уже регистрировались на Tutu.ru и мы отправляли вам письмо об этом.\n\t\t\t\t\t\t\t\t\t<br /><br />\n\t\t\t\t\t\t\t\t\tПожалуйста, пройдите по ссылке в письме, чтобы завершить процесс регистрации.","user.mail_from":"Tutu.ru | Личный кабинет","user.add_to_favorites":"Добавить в закладки","user.reset_to_default":"Восстановить настройки по умолчанию","railway.train.at_list_one_route":"Укажите маршрут поезда.","railway.train.at_list_one_schedule":"Укажите годовой график поезда.","railway.train.at_list_two_station":"Маршрут поезда должен содержать минимум станцию отправления и станцию прибытия.","railway.train.negative_milage":"Килотраж между %departureStationName% и %arrivalStationName% отрицательный","railway.train.invalid_milage":"Килотраж между %departureStationName% и %arrivalStationName% сильно отличается от километража уже существующиего перегона","railway.train.unknown_station":"Станция с кодом %number% не найдена. Либо у Вас ошибка в коде, либо создайте станцию вручную.","railway.train.departure_time_empty":"Укажите время отправления со станции %stationName%.","railway.train.arrival_time_empty":"Укажите время прибытия на станцию %stationName%.","railway.train.wrong_times_at_station":"Неверно указано время отправления и/или прибытия на станции %stationName%.","railway.train.wrong_times_between_stations":"Неверно указано время отправления со станции %departureStationName% и/или время прибытия на станцию %arrivalStationName%.","railway.train.wrong_milage_between_stations":"Замечено уменьшение километража между станциями %departureStationName% и %arrivalStationName%.","railway.train.milage_not_equal_to_existing_stage":"Километраж (%milage%км) между станциями %departureStationName% и %arrivalStationName% сильно отличается от километража (%existsMilage%км) уже существующего перегона.","railway.train.only_one_station":"Маршрут должен состоять из 2-х и более станций.","railway.train.not_can_update_route":"Маршрут поезда №%number% %departureStationName% - %arrivalStationName% не обновлен, т.к. автоматическое обновление для него запрещено.","railway.train.not_can_update_schedule":"Годовой график поезда №%number% %departureStationName% - %arrivalStationName% не обновлен, т.к. автоматическое обновление для него запрещено.","railway.station.seo_variants.here.0":"Ниже","railway.station.seo_variants.here.1":"Здесь","railway.station.seo_variants.directions.0":"самым популярным маршрутам","railway.station.seo_variants.directions.1":"основным направлениям","railway.station.seo_variants.equals.0":"составляет","railway.station.seo_variants.equals.1":"равно","railway.station.seo_variants.info.0":"представлена информация","railway.station.seo_variants.info.1":"Вы найдете информацию","railway.station.seo_variants.info.2":"представлены сведения","railway.station.seo_variants.info.3":"Вы найдете сведения","railway.station.seo.1":'<h2>Как доехать до <span class="nowrap">%city%</span> на поезде</h2>',"railway.station.seo.21":'<p>Через <span class="nowrap">%city%</span> %follow% %count% %train%, из них %firmCount% %firm%.</p>',"railway.station.seo.22":'<p>Через <span class="nowrap">%city%</span> %follow% %count% %train%.</p>',"railway.station.seo.3":'<p>Вы можете %see_schedule%, с помощью которых можно добраться до <span class="nowrap">%city%</span>. Также есть возможность выбрать наиболее %comfortable% маршрут.</p>',"railway.station.seo.4":'<p>%indicate% %place% отправления, вы сможете %learn% %price% билета до <span class="nowrap">%city%</span>, расстояние и %travel%.</p>',"railway.station.seo.5":'<p>%try% заказать или <a href="%url%">купить билет на поезд в <span class="nowrap">%city%</span></a> на сайте прямо сейчас.</p>',"railway.station.seo.6":'<p>Доставка жд билетов осуществляется в %in_city% Москве и <span class="nowrap">Санкт-Петербурге</span>.</p>',"railway.station.seo.7":"<p>Также можно воспользоваться услугой заказа электронного ж/д билета.</p>","railway.station.seo.8":'<h2>ЖД вокзалы в городе <span class="nowrap">%city%</span></h2>',"railway.station.seo.9":"<p>%inCity% есть %number% жд %railroadStation%: %railroadStationsInCity%.</p>","railway.station.seo.10":'<p>%youCan% найти и <a href="%buyUrl%">%buyText% жд билет онлайн</a> до %stationList%.</p>',"railway.station.seo.sapsan":'<h2>На Сапсане – %preposition% <span class="nowrap">%city%</span> и из <span class="nowrap">%city2%</span></h2>\n\t\t<p>На Туту.ру можно узнать точное время отправления «Сапсана» из <span class="nowrap">%city2%</span> и время прибытия «Сапсана» %preposition% <span class="nowrap">%city%</span>.</p>\n\t\t<p>Посмотрите расписание движения, узнайте цену билета на «Сапсан» до <span class="nowrap">%city2%</span> и купите билет онлайн всего за 4 минуты!</p>',"railway.station.seo.synonym_header":'<h2><span class="nowrap">%city%</span> часто ищут как</h2>',"railway.station.seo.synonym_body":'Пользователи портала Туту.ру часто ищут <span class="nowrap">%city%</span> как: %synonymList%.',"railway.station.seo.near_station_title":'<h2>Расстояние до <span class="nowrap">%city%</span></h2>',"railway.station.seo.near_station_text":'<p>%part_1% %part_2% о расстоянии до <span class="nowrap">%city%</span> по %part_3%.</p>',"railway.station.seo.near_station_item":'<p>Расстояние до <a href="%url%"><span class="nowrap">%city_to%</span> от <span class="nowrap">%city_from%</span></a> %part_4% %milage% км.</p>',"railway.seo.1":'<h2>Про расписание <span class="nowrap">%departureStation%</span> &ndash; <span class="nowrap">%arrivalStation%</span></h2>',"railway.seo.2":'<p>Расстояние между <span class="nowrap">%departureStation%</span> и <span class="nowrap">%arrivalStation%</span> %milage% %milageMorphology%. %average% время в пути %is% %travelTime%.</p>',"railway.seo.2_sapsan":'<p>Расстояние между <span class="nowrap">%departureStation%</span> и <span class="nowrap">%arrivalStation%</span> %milage% %milageMorphology%. %average% время в пути на высокоскоростном поезде «Сапсан» %is% %travelTime%.</p>',"railway.seo.31":'<p>Поезда из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> %follow% через города: %cityList%.</p>',"railway.seo.31_sapsan":'<p>Поезда «Сапсан» из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> %follow% через города: %cityList%.</p>',"railway.seo.32":'<p>Поезда из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> %follow% через город %cityList%.</p>',"railway.seo.32_sapsan":'<p>Поезда «Сапсан» из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> %follow% через город %cityList%.</p>',"railway.seo.4":"<p>По %selected% %route% курсирует %trainCount% %trainMorphology%.</p>","railway.seo.4_sapsan":"<p>По %selected% %route% курсирует %trainCount% %trainMorphology% «Сапсан».</p>","railway.seo.5":'<p>В среднем цена билета на поезд из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> составляет <span class="nowrap">%price% %currency%</span>.</p>',"railway.seo.5_sapsan":'<p>В среднем цена билета на поезд «Сапсан» из <span class="nowrap">%departureStation%</span> в <span class="nowrap">%arrivalStation%</span> составляет <span class="nowrap">%price% %currency%</span>.</p>',"railway.seo.61":'<p>Стоимость билета в плацкартном вагоне от <span class="nowrap">%placPrice% %placCurrency%</span>,\n\t\tа от <span class="nowrap">%cupePrice% %cupeCurrency%</span> можно купить жд билеты <span class="nowrap">%departureStation%</span> &ndash; <span class="nowrap">%arrivalStation%</span> в купе.</p>',"railway.seo.62":'<p>Стоимость билета в плацкартном вагоне от <span class="nowrap">%placPrice% %placCurrency%</span>.</p>',"railway.seo.63":'<p>От <span class="nowrap">%cupePrice% %cupeCurrency%</span> можно купить жд билеты <span class="nowrap">%departureStation%</span> &ndash; <span class="nowrap">%arrivalStation%</span> в купе.</p>',"railway.seo.6_sapsan":'<p>Стоимость билета на «Сапсан» в вагоне эконом класса от <span class="nowrap">%economPrice% %economCurrency%</span>. Цены на билеты в вагоны бизнес класса выше в 1,5-2 раза.</p>',"railway.seo.7":'<p>Доставка ж/д билетов (кроме электронных) %carried_out% по Москве и <span class="nowrap">Санкт-Петербургу</span>.</p>',"railway.seo.7_sapsan":"<p>Вы можете купить электронный билет на «Сапсан» всего за 4 минуты.</p>","railway.seo.8":'<p>%try% заказать и купить железнодорожный билет %by_route% <span class="nowrap">%departureStation%</span> &ndash; <span class="nowrap">%arrivalStation%</span> через интернет %yet% сейчас.</p>',"railway.seo.8_sapsan":'<p>%try% заказать и купить билет на поезд %by_route% <span class="nowrap">%departureStation%</span> &ndash; <span class="nowrap">%arrivalStation%</span> через интернет %yet% сейчас.</p>',"railway.seo.9":'<p>Если вас интересует цена билета на поезд от <span class="nowrap">%departureStation%</span> до <span class="nowrap">%arrivalStation%</span>, то укажите дату поездки. При этом вы увидите стоимость билетов во всех доступных вагонах (плацкарт, купе и др.) и сможете купить жд билеты <span class="nowrap">%departureStation2%</span> – <span class="nowrap">%arrivalStation2%</span> онлайн.</p>',"productor.civil_crafts":"Пассажирские самолеты","productor.business_crafts":"Малая и бизнес авиация","productor.title":"Производитель","productor.common":"Общая информация","productor.name_rus":"Название рус","productor.country":"Страна","productor.":"","avia.errors.gateline.card_expired":"К сожалению, платежный сервис сообщил об окончании срока действия карты.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_unrecoginized":"К сожалению, платежный сервис не смог определить тип карты по указанным вами данным.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_invalid_number":"К сожалению, платежный сервис сообщил об ошибке в номере карты.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_type":"К сожалению, платежный сервис не смог определить тип карты по указанным вами данным.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.error":"К сожалению, платежный сервис сообщил об ошибке.<br /><br />Пожалуйста, выберите другой способ оплаты.</p>","avia.errors.gateline.card_stop":"К сожалению, платежный сервис не разрешил оплату по указанным вами данным.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_second_pay":"К сожалению, повторная оплата возможна только через 3 минуты после предыдущей.<br /><br />Пожалуйста, подождите немного и попробуйте еще раз.","avia.errors.gateline.card_third_pay":"По правилам платежного сервиса, 3-я попытка оплаты с указанием тех же реквизитов карты и электронной почты возможна только через час.<br /><br />Пожалуйста, подождите немного и попробуйте еще раз. Также вы можете оплатить другой картой, указав другую почту, или выбрать другой способ оплаты.","avia.errors.gateline.card_six_pay":"По правилам платежного сервиса, 7-я попытка оплаты с указанием той же электронной почты возможна только через сутки.<br /><br />Пожалуйста, подождите и попробуйте еще раз. Также вы можете указать другую почту, или выбрать другой способ оплаты.","avia.errors.gateline.error_tech":"К сожалению, по техническим причинам сервис не смог обработать платеж.<br /><br />Пожалуйста, попробуйте еще раз. Также вы можете оплатить заказ другим способом.","avia.errors.gateline.card_amount":"К сожалению, платежный сервис не разрешил транзакцию — сумма к оплате слишком велика или слишком мала.<br /><br />Пожалуйста, уточните у банка-эмитента ограничения по карте. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_forbidden":"К сожалению, платежный сервис не разрешил транзакцию.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_day_limit":"К сожалению, платежный сервис сообщил о превышении платежного лимита за день.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_holder_error":"К сожалению, платежный сервис сообщил о возможной ошибке в имени держателя карты.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_cvc2":"К сожалению, платежный сервис сообщил о неверно указанном CVC коде.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_blocked":"К сожалению, платежный сервис сообщил, что указанная карта заблокирована.<br /><br />Вы можете проверить вводимые данные карты и попробовать еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_data_incorrect":"К сожалению, платежный сервис сообщил об ошибке в указанных вами реквизитах карты.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_unable":"К сожалению, сервис не смог обработать платеж.<br /><br />Пожалуйста, попробуйте еще раз. Также вы можете оплатить заказ другим способом.","avia.errors.gateline.card_refused":"К сожалению, сервис отклонил платеж.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_insufficient":"К сожалению, платежный сервис сообщил о нехватке средств на указанной вами карте.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_limit":"К сожалению, платежный сервис сообщил, что по указанной вами карте превышен лимит расходования средств.<br /><br />Вы можете оплатить заказ другой картой или другим способом.","avia.errors.gateline.card_cvv2":"К сожалению, платежный сервис сообщил о неверно указанном CVV2 коде.<br /><br />Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_bank":"К сожалению, платежный сервис сообщил, что карты данного банка не обслуживаются.<br /><br />Вы можете оплатить другой картой или другим способом.","avia.errors.gateline.card_duplicate":"Платежный сервис сообщил, что вы уже оплатили этот заказ.<br /><br />Пожалуйста, проверьте электронную почту — там должно быть письмо об оплате.<br /><br />Если его нет, пожалуйста, напишите нам на info@tutu.ru","avia.order.carrier":"Авиакомпания","avia.order.departure":"Отправление","avia.order.arrival":"Прибытие","avia.order.inair":"В пути","avia.order.reis":"Рейс","avia.order.no_departure_city":"Пункт отправления &laquo;%searchPhrase%&raquo; не найден","avia.order.no_arrival_city":"Пункт прибытия &laquo;%searchPhrase%&raquo; не найден","avia.order.search_button":"Показать расписание и билеты","avia.order.buy_button":"Купить билеты","avia.order.select_payment_method":"Перейти к выбору способа оплаты","avia.order.back_offers":"Вернуться к выбору перелета","avia.order.back_passengers":"Вернуться к вводу информации о пассажирах","avia.order.back_payment":"Вернуться к выбору способа оплаты","avia.order.book":"Перейти к завершению заказа","avia.order.pay":"Перейти к оплате","avia.order.passengers":"Перейти к вводу информации о пассажирах","avia.order.finish_order":"Завершить оформление заказа","avia.order.ow":"в один конец","avia.order.rt":"туда-обратно","avia.order.pm_cash":"Наличными","avia.order.pm_cash_disabled":"Наличными","avia.order.pm_cash_full":"Наличными в&nbsp;офисе","avia.order.pm_cash_curier":"Наличными курьеру","avia.order.pm_cash_curier_disabled":"Наличными курьеру","avia.order.pm_cash_curier_full":"Наличными курьеру в&nbsp;офисе/дома","avia.order.pm_cardonline":"Картой онлайн&nbsp;","avia.order.pm_cardonline_disabled":"Картой онлайн&nbsp;","avia.order.pm_cardonline_full":'<img src="http://localhost.localdomain/images2/main/pay/card.gif" alt="" style="margin-right: 4px" /> Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa_disabled.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc_disabled.gif" alt="" /--> онлайн',"avia.order.pm_cardonlineforeign":'Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /--> иностранного банка онлайн',"avia.order.pm_cardonlineforeign_disabled":'Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa_disabled.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc_disabled.gif" alt="" /--> иностранного банка онлайн',"avia.order.pm_card":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.order.pm_card_disabled":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.order.pm_card_full":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.order.pm_yandex":"Яндекс.Деньгами","avia.order.pm_yandex_full":'<img src="http://localhost.localdomain/images2/main/pay/ya.gif" alt="" style="margin-top: -1px" onclick="javascript:document.getElementById(\'method|yandex\').click();"/> Яндекс.деньгами',"avia.order.pm_yandex_disabled":"Яндекс.Деньгами","avia.order.pm_webmoney_disabled":"Webmoney","avia.order.pm_invoice":"Банковским переводом","avia.order.pm_invoice_disabled":"Банковским переводом","avia.order.pm_beeline":'<img src="http://localhost.localdomain/images2/main/pay/bee.gif" alt="" /> С мобильного телефона абонентам Билайна',"avia.order.pm_beeline_disabled":"С мобильного телефона абонентам Билайна","avia.order.pm_qiwi":"В терминалах Qiwi&nbsp;","avia.order.pm_qiwi_full":'<img src="http://localhost.localdomain/images2/main/pay/q.gif" alt="" style="margin: -1px 0 -2px" onclick="javascript:document.getElementById(\'method|qiwi\').click();"/> Наличными в терминалах Qiwi',"avia.order.pm_qiwi_disabled":"В терминалах Qiwi","avia.order.pm_davs_cities":", Санкт-Петербурге, Новосибирске и&nbsp;Хабаровске","avia.order.pmpo_cash":"Наличными","avia.order.pmpo_cash_curier":"Наличными&nbsp;курьеру","avia.order.pmpo_cardonline":"Банковской&nbsp;картой&nbsp;онлайн","avia.order.pmpo_cardonlineforeign":"Банковской&nbsp;картой иностранного банка онлайн","avia.order.pmpo_card":"Банковской&nbsp;картой в&nbsp;офисе в&nbsp;Москве","avia.order.pmpo_yandex":"Яндекс.Деньгами","avia.order.pmpo_webmoney":"Webmoney","avia.order.pmpo_invoice":"Банковским&nbsp;переводом","avia.order.pmpo_beeline":"С&nbsp;мобильного телефона абонентам Билайна","avia.order.pmpo_qiwi":"В&nbsp;терминалах&nbsp;Qiwi","avia.order.tt_full":"Взрослый","avia.order.tt_child":"Детский","avia.order.tt_infant":"Для ребенка до 2 лет","avia.order.tt_confirm":"Подтвердите заказ","avia.order.tt_ticket":"Билет","avia.order.tt_detail":"Проверьте детали полета","avia.order.tt_payment_method":"Выберите способ оплаты","avia.order.tt_passengers":"Введите данные пассажиров","avia.order.tt_fares":"Правила применения тарифа","avia.order.tt_success":"Поздравляем с успешным заказом!","avia.order.tt_pay":"Оплатить бронь","avia.order.checking_wait_text":"Проверяется доступность мест","avia.order.checking_error_text":"Рейс недоступен","avia.order.change_search":"Изменить параметры авиарейса.","avia.order.change_search2":"Найти другие авиарейсы","avia.order.tip_enter_russian_mobile":"Введите номер мобильного телефона российского оператора по примеру (123)111-11-11","avia.order.tip_order_1":"Заказ одного билета на авиарейс","avia.order.tip_order_2":"Заказ двух билетов на авиарейс","avia.order.tip_order_3":"Заказ трех билетов на авиарейс","avia.order.tip_order_4":"Заказ четырех билетов на авиарейс","avia.order.tip_order_5":"Заказ пяти билетов на авиарейс","avia.order.tip_order_6":"Заказ шести билетов на авиарейс","avia.order.tip_order_max":"Заказ %number% билетов на авиарейс","avia.order.tip_outbound":"Вылет","avia.order.tip_inbound":"Возврат","avia.order.tip_local_time_notice":"В расписании указано <i>местное время</i>","avia.order.tip_fname":"Имя","avia.order.tip_sname":"Фамилия","avia.order.tip_phone":"Телефон","avia.order.tip_mobile":"Мобильный","avia.order.tip_address":"Адрес","avia.order.tip_email":"Электронная почта","avia.order.tip_sex":"Пол","avia.order.tip_birthday":"Дата рождения","avia.order.tip_doc_info":"Номер документа","avia.order.tip_doc_valid_till":"Срок действия документа","avia.order.tip_document":"Документ","avia.order.tip_doc_passport":"Паспорт","avia.order.tip_doc_international":"Загранпаспорт","avia.order.tip_doc_birthcert":"Свидетельство о рождении","avia.order.tip_doc_":"Неизвестный документ","avia.order.tip_use_latin":'Фамилия и имя заполняются на <img src="%flag_url%" alt="" /> английском языке',"avia.order.tip_sex_M":"Мужчина","avia.order.tip_sex_F":"Женщина","avia.order.tip_born":"Дата рождения","avia.order.tip_born_":"Родился","avia.order.tip_born_M":"Родился","avia.order.tip_born_F":"Родилась","avia.order.tip_select_RT":"Выберите рейсы <b>вылета</b> и <b>возврата</b>, чтобы приобрести билеты.","avia.order.tip_select_OW":"Выберите рейс, чтобы приобрести билеты.","avia.order.tip_departure_at":"вылет в","avia.order.tip_departure_atU":"Вылет в","avia.order.tip_departure_from":"из %city_name%","avia.order.tip_pay_in":"в ","avia.order.tip_just_city":"%city_name%","avia.order.tip_arrival_to":"в %city_name%","avia.order.tip_leave_contacts":"Оставьте контактную информацию","avia.order.tip_agreement":'Я согласен с <a href="%rules_url%" target="_blank">правилами использования сервиса</a> и <a href="%fares_url%" target="_blank">правилами применения тарифа</a>.',"avia.order.tip_rules":"Условия использования сервиса Туту.ру","avia.order.tip_currency_concise":"руб.","avia.order.tip_wo_changes":"Прямые рейсы","avia.order.tip_w_changes":"С пересадками","avia.order.tip_how_to_buy":"Справка о приобретении билетов","avia.order.tip_eticket_info":"Электронный авиабилет","avia.order.tip_+1_day":"Прилет на следующий календарный день (%concrete_date%)","avia.order.tip_+2_day":"Прилет через два календарных дня (%concrete_date%)","avia.order.tip_-1_day":"Прилет на предыдущий календарный день (%concrete_date%)","avia.order.tip_payment_method":"Способ оплаты","avia.order.tip_enter_locator":"Введите номер брони","avia.order.tip_payment_type_both":"Оплата наличными или онлайн","avia.order.tip_payment_type_offline":"Только за наличные в Москве","avia.order.tip_payment_type_online":"Только онлайн-оплата","avia.order.tip_currency_EUR":"евро","avia.order.tip_foreign_currency":'<p>Эта авиакомпания указала стоимость некоторых рейсов в валюте (<span class="red" >%original% евро</span>).</p><p>Деньги будут списаны с карточки по курсу вашего банка.</p>',"avia.order.tip_foreign_currency_warn":"\n\t\t\t<p>Этот&nbsp;тариф&nbsp;указан&nbsp;авиакомпанией&nbsp;в&nbsp;%currency%.</p>\n\t\t\t<p>Деньги будут списаны с карточки по внутреннему курсу вашего банка на день проведения платежа.</p>\n\t\t\t<p>Как правило, курс российских банков выше курса Центрального Банка России на 0,5% — 1%.</p>\n\t\t\t<p>Курс ЦБ на %date%  — %course%.</p>\n\t\t\t<p>Если деньги будут списаны с карты %date%, то сумма составит примерно %price%</p>\n\t\t\t<p>Если у вас есть счет в %currency%, вы можете оплатить билет без конвертации.</p>","avia.order.tip_country":"Страна","avia.order.tip_city":"Город","avia.order.tip_post_index":"Индекс","avia.order.tip_post_address":"Адрес","avia.order.different_carriers":"Разные авиакомпании","avia.order.different_planes":"","avia.order.class_econom":"Экономический класс","avia.order.class_business":"Бизнес класс","avia.order.class_first":"Первый класс","avia.order.class_Y":"Экономический","avia.order.class_C":"Бизнес","avia.order.class_F":"Первый","avia.order.tip_time_for_payment":"Если вы выбрали оплату курьеру или в офисе агентства, точное время оплаты сообщит позвонивший вам оператор. \n\t\t\t\t\t\t\t\t\tБилеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.","avia.order.tip_time_for_payment_cash":"Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.","avia.order.tip_time_for_payment_notcash":"Билеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.","avia.order.time_for_payment_d":"%number%&nbsp;суток&nbsp;","avia.order.time_for_payment_h_1":"%number%&nbsp;часа","avia.order.time_for_payment_h_2":"%number%&nbsp;часов","avia.order.time_for_payment_h_3":"%number%&nbsp;часов","avia.order.time_for_payment_m_1":"%number%&nbsp;минуты","avia.order.time_for_payment_m_2":"%number%&nbsp;минут","avia.order.time_for_payment_m_3":"%number%&nbsp;минут","avia.order.pay_ticket_number_1":"Один билет","avia.order.pay_ticket_number_2":"%number% билета","avia.order.pay_ticket_number_3":"%number% билетов","avia.order.price_ticket_number_1":"Стоимость одного билета","avia.order.price_ticket_number_2":"Стоимость двух билетов","avia.order.price_ticket_number_3":"Стоимость %number% билетов","avia.order.pay_ticket_amount":"на сумму %amount% руб. %change%","avia.order.pay_total":"Сумма к оплате: %amount% руб.","avia.order.pay_method_card":"банковской картой в офисе","avia.order.pay_method_cardonline":"банковской картой онлайн","avia.order.pay_method_cash":"наличными курьеру","avia.order.pay_method_webmoney":"Webmoney","avia.order.pay_method_yandex":"Яндекс.Деньгами","avia.order.pay_method_":"Неизвестный метод","avia.order.class_of_service_":"Любой класс обслуживания","avia.order.class_of_service_U":"Любой класс обслуживания","avia.order.class_of_service_none":"Любой класс обслуживания","avia.order.class_of_service_Y":"Экономический класс","avia.order.class_of_service_F":"Первый класс","avia.order.class_of_service_C":"Бизнес класс","avia.order.data_need_refresh":"Данные по перелетам устарели. Нажмите кнопку &laquo;Обновить данные&raquo;, чтобы получить новые данные","avia.order.data_need_refresh_button":"Обновить данные","avia.order.flight_railway":"В стоимость перелета включен трансфер на поезде от вокзала до аэропорта","avia.order.best_prices_for_today":"Лучшие цены на %today%","avia.order.best_prices":"Лучшие цены","avia.order.best_prices_coming":"Цены на ближайшие дни","avia.order.loading_pay_online":"Перенаправление на страницу оплаты","avia.order.empty_rules":"Пожалуйста, проконсультируйтесь с нашим оператором.","avia.order.payment_method_na":"недоступно","avia.order.pt_step1":"Tutu.ru — Авиарейсы","avia.order.pt_step2":"Tutu.ru — Пассажиры","avia.order.pt_step3":"Tutu.ru — Оплата","avia.order.pt_finish":"Tutu.ru — Завершение заказа","avia.order.pt_fares":"Tutu.ru — Описание тарифа","avia.order.pt_bad_request":"Tutu.ru — Некорректный запрос","avia.order.pt_pay_online":"Tutu.ru — Переход к оплате online","avia.order.pt_specify_city":"Tutu.ru — Укажите город","avia.order.order_number":"Заказ № <b>%locator%</b> от %date%","avia.order.more_about_itinerary":"Подробнее про маршрутную квитанцию","avia.order.how_to_get_a_ticket":"Как получить авиабилет","avia.order.how_to_register":"Как пройти регистрацию в аэропорту","avia.order.where_to_pay_and_go_sig23":'Оплата и получение билетов: <span class="red" ><b>в Москве</b></span>',"avia.order.where_to_pay_and_go_davs":'Оплата и получение билетов: <span class="red" ><b>в Москве, Санкт-Петербурге, Новосибирске и Хабаровске</b></span>',"avia.order.any_carrier":"Любая авиакомпания","avia.order.payment_location":"Город доставки/получения","avia.order.foreign_currency_notice":"Оплата в валюте","avia.order.lowcoster_notice":"Low-cost авиакомпания","avia.order.wizard_offers":"Авиарейсы","avia.order.wizard_passengers":"Пассажиры","avia.order.wizard_payment":"Оплата","avia.order.wizard_finish":"Финиш","avia.order.yandex_division_1":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платеж (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.order.yandex_division_2":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платежа (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.order.yandex_division_3":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платежей (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.order.tip_about_qiwi_payment":'<p>Выбранные билеты нужно будет оплатить в течение ограниченного времени.</p><p><a href="/2read/avia/avia_qiwi/" target="_blank">Подробнее про оплату в терминалах Qiwi</a></p>',"avia.order.tip_price_from":"от&nbsp;","avia.order.tip_pay_other_person_link":"Что делать если я оплачиваю билет для другого человека?","avia.order.tip_pay_other_person_text":'Если вы оплачиваете перелет за других пассажиров своей кредитной картой, но сами не летите, вам необходимо прислать на адрес <a href="mailto:info@tutu.ru">info@tutu.ru</a> отсканированную копию кредитной карты с двух сторон (<b>оставить первые 4 и последние 4 цифры</b>) и копию первой страницы вашего паспорта.',"avia.order.popular_section_russia":"По России","avia.order.popular_section_europe":"В Европу","avia.order.popular_section_happysun":"В теплые края","avia.order.popular_lowcost_tip":"Авиабилеты low-cost авиакомпаний &mdash; отличный способ экономии: минимум затрат, никакой переплаты за&nbsp;комфорт и&nbsp;дополнительные услуги.","avia.order.popular_title":"Популярные направления","avia.order.popular_lowcost_title":"Популярные направления low-cost авиакомпаний","avia.order.popular_from_mow":"Из Москвы","avia.order.popular_ow":"В одну сторону","avia.order.popular_ow_short":"Туда","avia.order.popular_rt":"Туда и обратно","avia.order.popular_good_prices":"Выгодные цены на авиабилеты","avia.order.popular_description":"Мы выбрали для&nbsp;вас наиболее выгодные предложения <strong>на&nbsp;%time%</strong> по&nbsp;самым популярным направлениям в&nbsp;России и&nbsp;мире.","avia.order.tip_redirect_to_payment":"После нажатия кнопки вы будете перенаправлены на страницу оплаты.","avia.order.waitscreen_hotel_offer":"А если в %city_name% есть<br /> гостиница вашей мечты,<br /> мы найдем и ее.","avia.order.waitpage_maybe":"На следующей странице<br /> может быть рейс вашей мечты!","avia.order.addr_partner_address":"Адрес","avia.order.addr_onmap":"Посмотреть на&nbsp;карте","avia.order.or":"или","avia.order.addr_davs_name":"ЗАО&nbsp;«Агентство &laquo;ДАВС&raquo;","avia.order.addr_davs_KHV":"г.&nbsp;Хабаровск, Амурский&nbsp;бульвар,&nbsp;36","avia.order.addr_davs_OVB":"г.&nbsp;Новосибирск, ул.&nbsp;Октябрьская,&nbsp;45","avia.order.addr_davs_LED":"г.&nbsp;Санкт-Петербург, 9-я&nbsp;Линия Васильевского&nbsp;острова, д.34, Литер А, оф.101,&nbsp;212,&nbsp;233 (м.&nbsp;Василеостровская)","avia.order.addr_davs_MSK":"г.&nbsp;Москва, ул.&nbsp;Мясницкая, дом&nbsp;32 (м.&nbsp;Тургеневская или&nbsp;Чистые&nbsp;Пруды)","avia.order.addr_davs_MSK_or":"г.&nbsp;Москва, Ананьевский&nbsp;пер., дом&nbsp;5, корпус 9 (м.&nbsp;Сухаревская)","avia.order.addr_davs_sig":"г.&nbsp;Москва, 1-й&nbsp;Волконский&nbsp;пер., дом&nbsp;15 (м.&nbsp;Цветной&nbsp;бульвар)","avia.order.switcher_oneway":"В одну сторону","avia.order.switcher_roundt":"Туда-обратно","avia.order.add_backway":"Добавить перелет обратно","avia.order.route_in":"Рейс в","avia.order.route_anytime":"любое время","avia.order.route_in_airport":"в аэропорт","avia.order.route_in_a":"в","avia.order.route_any_airport":"любой аэропорт","avia.order.empty_result_sorry":"К сожалению, на выбранную дату рейсов в эти города нет. Пожалуйста, измените условия поиска.","avia.order.empty_result_check_schedule_date":'К сожалению, на выбранную дату рейсов в эти города нет. <br />В расписании ближайшие рейсы по этому маршруту есть <a href="%url_past%">%date_past%</a> %and% <a href="%url_future%">%date_future%</a>',"avia.order.empty_result_check_schedule_date_single":'К сожалению, на выбранную дату рейсов в эти города нет. <br />В расписании ближайшие рейсы по этому маршруту есть <a href="%url%">%date%</a>',"avia.order.empty_result_filtered":" К сожалению, рейсов с такими параметрами нет. Пожалуйста, измените требования к перелету.","avia.search.departureFrom":"Вылет из","avia.search.returnFrom":"Возврат из","avia.search.arrivalTo":"Прилет в","avia.search.departureFromShort":"Из","avia.search.arrivalToShort":"в","avia.search.roundTripHint":"Билеты «туда-обратно», обычно дешевле, чем два билета, купленные раздельно.","avia.search.addRoundTrip":"Добавить перелет обратно","avia.search.seatsIn":"Места в&nbsp;","avia.search.seatsInShort":"в&nbsp;","avia.search.allRaces":"Все рейсы","avia.search.directRaces":"Только прямые","avia.search.noDirectRaces":"Прямых рейсов нет","avia.search.directRacesNo":"Нет прямых рейсов","avia.search.transferOnly":"Только с пересадкой","avia.search.allCarriers":"Все авиакомпании","avia.search.from":"от","avia.search.changeParams":"Изменить параметры рейса","avia.search.changeParams_info":"даты и время, города, кол-во пассажиров","avia.search.refreshList":"Обновить список рейсов","avia.search.localTime":"Вылет и прилет <b><em>по местному</em></b> времени","avia.passenger.fWord":"Летит","avia.passenger.fWords":"Летят","avia.passenger.beforeTwo":"до 2-х лет","avia.passenger.beforeEleven":"от 2 до 11 лет","avia.passenger.adults":"Взрослые","avia.passenger.childs":"Дети 2&mdash;11 лет","avia.passenger.babies":"Малыши до 2 лет","avia.passenger.amountHint":"Суммарно в одном заказе может быть не больше 9-ти пассажиров. Каждого малыша до 2-х лет должен сопровождать взрослый.","avia.ticket.city.city_in_letters.2":"Из Санкт-Петербурга средняя стоимость — %ledAbsPrice% руб. в одну сторону для одного пассажира.<br />","avia.ticket.city.city_in_letters.3":"%selectText% конкретный пункт отправления, вы сможете узнать точную стоимость и время в пути.<br />","avia.ticket.city.city_in_letters.4":"%regularlyText% через %cityName_acc% летает %planeCount% %planeCountText%.<br />","avia.ticket.city.city_in_letters.5":"%ourSiteText% позволяет %quicklyText% забронировать и купить авиабилеты онлайн,\n\t\tвыбрав подходящий вариант %someText% авиакомпании.<br />","avia.ticket.city.city_in_letters.6":"Электронные билеты %sendText% %systemText% на электронную почту, их остается только распечатать перед вылетом.<br />","avia.ticket.city.city_in_letters.7":"Доставка бумажных билетов осуществляется в офисы Москвы, стоимость доставки — 250-300 рублей, в зависимости от агентства-партнера.\n\t\tНекоторые билеты на самолет могут быть доставлены в Санкт-Петербурге и&nbsp;Новосибирске, такая возможность указывается при заказе.","avia.ticket.city.city_in_letters.11":"Цены на авиабилеты в %arrivalCityName_acc% из %departureCityName_gen% %changeText% от %mowMinPrice% руб. до %mowMaxPrice% руб.\n\t\tВ среднем цена билета составляет %mowAbsPrice% руб.<br />","avia.ticket.city.city_in_letters.12":"Цена авиабилета в %arrivalCityName_acc% из %departureCityName_gen% составляет %mowAbsPrice% руб.<br />","avia.ticket.city.city_in_letters.13":'Так получилось, что аэропорта в %arrivalCityName_loc% нет.<br /><br />\nЕсли для вас принципиально лететь самолетом, вы можете воспользоваться рейсами до ближайшего аэропорта <a href="%altCityAviaUrl%">в %altCityName_loc%</a>%altCityDistance%.',"avia.ticket.city.city_in_letters.14":'&nbsp;Если же нет, то как вариант подойдет <a href="%altCityTrainUrl%">поезд</a> до этого города.<br /><br />',"avia.ticket.city.city_in_letters.15":'Можно посетить и 2 города сразу — прилететь в %altCityName_acc% и оттуда <a href="%arrivalCityTrainUrl%">поездом до %arrivalCityName_gen%</a>.',"avia.ticket.city.city_in_letters.16":"<br /><br />Другой ближайший аэропорт - %cList%.","avia.ticket.city.city_in_letters.17":"<br /><br />Другие ближайшие аэропорты - %cList%.","avia.ticket.city.city_in_letters.18":"(%d% км)","avia.ticket.itinerary_receipt.it_receipt":"Маршрутная квитанция","avia.ticket.itinerary_receipt.el_ticket":"Электронный билет","avia.ticket.itinerary_receipt.pnr":"Номер бронирования","avia.ticket.itinerary_receipt.ticket":"Билет","avia.ticket.itinerary_receipt.purchase_date":"Дата покупки","avia.ticket.itinerary_receipt.passengers":"Пассажиры","avia.ticket.itinerary_receipt.name_last_name":"Имя, фамилия","avia.ticket.itinerary_receipt.passport":"Паспорт","avia.ticket.itinerary_receipt.valid_till":"Действителен до","avia.ticket.itinerary_receipt.passenger_type":"Тип пассажира","avia.ticket.itinerary_receipt.adult":"Взрослый","avia.ticket.itinerary_receipt.child":"Ребенок","avia.ticket.itinerary_receipt.infant":"Младенец","avia.ticket.itinerary_receipt.flight_information":"Данные полета","avia.ticket.itinerary_receipt.outbound_flight":"Отправление","avia.ticket.itinerary_receipt.flight_time":"Время полета","avia.ticket.itinerary_receipt.luggage":"Багаж","avia.ticket.itinerary_receipt.inbound_flight":"Обратно","avia.ticket.itinerary_receipt.information_about_fare":"Информация об оплате","avia.ticket.itinerary_receipt.paid_by":"Кем оплачено","avia.ticket.itinerary_receipt.rate":"Тариф","avia.ticket.itinerary_receipt.rub":"р.","avia.ticket.itinerary_receipt.surcharges":"Сборы","avia.ticket.itinerary_receipt.total":"Итого","avia.ticket.itinerary_receipt.pay_status":"Статус оплаты","avia.ticket.itinerary_receipt.bill_paid":"Счет оплачен","avia.ticket.itinerary_receipt.agency":"Агенство","avia.ticket.itinerary_receipt.ticket_issued_by":"Выписан на бланке","avia.ticket.itinerary_receipt.operated_by_rus":"перелет осуществляется","avia.ticket.itinerary_receipt.operated_by_eng":"operate by","avia.ticket.itinerary_receipt.agency_name":"Эс Ай Турс энд&nbsp;Трэвел","avia.ticket.itinerary_receipt.agency_address":"Адрес агенства","avia.ticket.itinerary_receipt.agency_address_name":"Россия, г. Москва, 1-й Волконский переулок, д. 15","avia.ticket.itinerary_receipt.agency_id":"Код агенства","avia.ticket.itinerary_receipt.class_Y":"Economy","avia.ticket.itinerary_receipt.class_C":"Business","avia.ticket.itinerary_receipt.class_F":"First","avia.ticket.itinerary_receipt.phone":"Телефон","avia.ticket.itinerary_receipt.phones":"Телефоны","avia.ticket.itinerary_receipt.help":"Помощь","avia.ticket.itinerary_receipt.phone_comment":"Контакт-центр Туту.ру работает в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.","avia.ticket.itinerary_receipt.phone_cost":"Стоимость звонка","avia.ticket.itinerary_receipt.landline_phone":"стационарный телефон","avia.ticket.itinerary_receipt.mobile_phone":"мобильный телефон","avia.ticket.itinerary_receipt.tichets_return":"Возврат билетов","avia.ticket.itinerary_receipt.tichets_return_text":"Возврат авиабилетов осуществляется по правилам авиакомпании. Напишите нам на info@tutu.ru для получения подробной информации.","avia.ticket.itinerary_receipt.baggage_pieces_1":"%num% место багажа","avia.ticket.itinerary_receipt.baggage_pieces_2":"%num% места багажа","avia.ticket.itinerary_receipt.baggage_pieces_3":"%num% мест багажа","avia.order.error.customer_phone.not_empty":"Пожалуйста, укажите телефон","avia.order.error.customer_phone.phone":"Возможно, указан неверный номер телефона","avia.order.error.customer_zipcode.not_empty":"Пожалуйста, укажите цифры индекса.","avia.order.error.fname.not_empty_trim":"Пожалуйста, укажите имя пассажира","avia.order.error.fname.latin_and_spaces":"Пожалуйста, используйте только латинские буквы","avia.order.error.fname.latin_and_spaces_empty":"Пожалуйста, используйте только латинские буквы","avia.order.error.expiredate.not_empty":"Пожалуйста, укажите дату окончания действия документа","avia.order.error.expiredate.future":"Срок действия документа истек. Пожалуйста, проверьте, правильно ли вы ввели дату","avia.order.error.expiredate.unmasked_not_empty":"Пожалуйста, укажите дату окончания действия документа","avia.order.error.expiredate.unmasked_date":"Пожалуйста, проверьте, правильно ли вы ввели дату","avia.order.error.expiredate.unmasked_date_after":"Срок действия документа истечет до прибытия","avia.order.error.customer_fname.not_empty_reg":"Пожалуйста, укажите свое имя","avia.order.error.customer_fname.not_empty":"Пожалуйста, укажите свое имя","avia.order.error.city.not_empty":"Пожалуйста, укажите город","avia.order.error.customer_lname.not_empty_reg":"Пожалуйста, укажите свою фамилию","avia.order.error.customer_lname.not_empty":"Пожалуйста, укажите свою фамилию","avia.order.error.phone.not_empty":"Пожалуйста, укажите номер телефона","avia.order.error.phone.phone":"Пожалуйста, укажите корректный номер телефона","avia.order.error.comment.not_empty":"","avia.order.error.customer_country.not_empty":"Пожалуйста, укажите вашу страну","avia.order.error.customer_email.not_empty":"Пожалуйста, укажите электронную почту","avia.order.error.customer_email.email":"Возможно, указан неверный адрес электронной почты","avia.order.error.customer_city.not_empty":"Пожалуйста, уточните город.","avia.order.error.customer_address.not_empty":"Укажите адрес — это юридическая формальность, необходимая для оплаты картой. Лучше ввести тот адрес, который вы указывали в банке при оформлении карты","avia.order.error.birthday.not_empty":"Пожалуйста, укажите возраст","avia.order.error.birthday.unmasked_date":"Проверьте, пожалуйста, дату","avia.order.error.birthday.birthday":"По правилам авиакомпании %date_str% пассажиру должно быть не более %type_str%","avia.order.error.birthday.not_future":"Проверьте, пожалуйста, дату","avia.order.error.birthday.unmasked_date_not_empty":"Проверьте, пожалуйста, дату","avia.order.error.document_number.not_empty":"Пожалуйста, укажите номер документа, с которым вы полетите","avia.order.error.document_number.unmasked_not_empty":"Пожалуйста, укажите номер документа, с которым вы полетите","avia.order.error.document_number.doc_format":"Проверьте, пожалуйста, номер или выберите другой тип документа","avia.order.error.address.not_empty":"Укажите, куда привезти билеты","avia.order.error.address.not_empty_a":"Пожалуйста, укажите адрес","avia.order.error.sex.not_empty":"Пожалуйста, укажите пол пассажира","avia.order.error.lname.not_empty":"Пожалуйста, укажите фамилию пассажира","avia.order.error.lname.not_empty_trim":"Пожалуйста, укажите фамилию пассажира","avia.order.error.lname.latin_and_spaces":"Пожалуйста, используйте только латинские буквы","avia.order.error.lname.latin_and_spaces_empty":"Пожалуйста, используйте только латинские буквы","avia.order.tooltip.sex":"","avia.order.tooltip.fname":"Заполните поле латинскими буквами","avia.order.tooltip.lname":"Заполните поле латинскими буквами","avia.order.tooltip.birthday":"дд.мм.гггг","avia.order.tooltip.expiredate":"Дата окончания действия документа","avia.order.tooltip.document_number":"Введите номер документа, с которым вы полетите","avia.order.tooltip.city":"","avia.order.tooltip.phone":"Пожалуйста, укажите ваш номер телефона","avia.order.tooltip.address":"Пожалуйста, укажите ваш адрес","avia.order.tooltip.comment":"Здесь вы можете уточнить желаемое время доставки и/или сообщить то, что поможет курьеру найти вас","avia.order.tooltip.customer_fname":"","avia.order.tooltip.customer_lname":"","avia.order.tooltip.customer_phone":"Укажите номер мобильного телефона или стационарный телефон с кодом города","avia.order.tooltip.customer_email":"Укажите актуальный адрес электронной почты — на него придет маршрутная квитанция","avia.order.tooltip.customer_address":"Укажите адрес — это юридическая формальность, необходимая для оплаты картой. Лучше ввести тот адрес, который вы указывали в банке при оформлении карты","avia.order.tooltip.customer_country":"Пожалуйста, укажите вашу страну","avia.order.tooltip.customer_zipcode":"Пожалуйста, укажите цифры индекса.","avia.order.tooltip.customer_city":"Пожалуйста, уточните город.","avia.order.page.ticket_price":"Стоимость билета","avia.order.page.fees_and_charges":"c учетом всех сборов и комиссий.","avia.order.page.rules_agree":'Нажимая &laquo;<span id="btntxt">Оплатить заказ</span>&raquo;, вы подтверждаете, что ознакомлены и согласны с <a href="%url%" target="_blanlk">условиями использования сайта</a> и <a href="%fares_url%" target="_blanlk">правилами применения выбранного тарифа</a>.',"avia.order.page.checking_availability":"Проверяется доступность мест","avia.order.page.price_changed":"Авиакомпания подтвердила запрос на бронирование, но изменила цену. Вы можете согласиться с новой ценой или вернуться к поиску.","avia.order.page.city_short":"г.","avia.order.page.delivery_price_davs":"Стоимость доставки <em>300 рублей</em>.","avia.order.page.delivery_price_si":"Стоимость доставки <em>250 рублей</em>.","avia.order.tooltip.document_number.passport":"Введите номер документа, с которым вы полетите","avia.order.tooltip.document_number.foreign":"Введите номер документа, с которым вы полетите","avia.order.tooltip.document_number.international":"Введите номер документа, с которым вы полетите","avia.order.tooltip.document_number.birthcert":"Укажите номера документа в формате VIII-ЫП-123456. Римские цифры вводите латиницей","avia.ticket.index_meta_title":"Авиабилеты, цены, расписание рейсов из Москвы, из Санкт-Петербурга","avia.ticket.index_meta_keywords":"Авиабилеты, цены, расписание рейсов из Москвы, из Санкт-Петербурга","avia.ticket.index_meta_description":"Авиабилеты, цены, расписание рейсов из Москвы, из Санкт-Петербурга","avia.ticket.country_meta_title":"Авиабилеты %preposition% %country% - цены, расписание рейсов из Москвы, из Санкт-Петербурга","avia.ticket.city_meta_title":"Авиабилеты %preposition% %city% - цены, расписание рейсов из Москвы, из Санкт-Петербурга","avia.schedule.seo.1":'<h2>Про авиабилеты <span class="nowrap">%departureCity%</span> &ndash; <span class="nowrap">%arrivalCity%</span></h2>',"avia.schedule.seo.21":'<p>Вы можете приобрести авиабилеты из <span class="nowrap">%departureCity%</span> в <span class="nowrap">%arrivalCity%</span> на рейсы %carrierCount% авиакомпаний: %carrierList%.</p>',"avia.schedule.seo.22":'<p>Вы можете приобрести авиабилеты из <span class="nowrap">%departureCity%</span> в <span class="nowrap">%arrivalCity%</span> на рейсы 1 авиакомпании - %airline%.</p>',"avia.schedule.seo.3":'<p>Авиапутешествия из <span class="nowrap">%departureCity%</span> в <span class="nowrap">%arrivalCity%</span> осуществляются следующими %planeTypesText%: %planeList%.</p>',"avia.schedule.seo.4":'<p>Расстояние между <span class="nowrap">%departureCity%</span> и <span class="nowrap">%arrivalCity%</span> <span class="nowrap">%milage%</span> %milageText%.</p>',"avia.schedule.seo.51":'<p>Средняя продолжительность перелета из <span class="nowrap">%departureCity%</span> в <span class="nowrap">%arrivalCity%</span> составляет %travelTime%. Минимальное время в пути - %minTravelTime%, %maximumText% — %maxTravelTime%.</p>',"avia.schedule.seo.52":'<p>Средняя продолжительность перелета из <span class="nowrap">%departureCity%</span> в <span class="nowrap">%arrivalCity%</span> составляет %travelTime%.</p>',"avia.schedule.seo.61":'<p>В среднем в %dayText% по маршруту <a href="%departureCityUrl%" class="nowrap">%departureCity%</a> - <a href="%arrivalCityUrl%" class="nowrap">%arrivalCity%</a> %flyText% %flightCount% %flightsText%. По %localText% времени самый ранний вылет осуществляется в %minDepartureTime%, самый поздний %flyInText% %maxDepartureTime%.</p>',"avia.schedule.seo.62":'<p>В среднем в %dayText% по маршруту <a href="%departureCityUrl%" class="nowrap">%departureCity%</a> - <a href="%arrivalCityUrl%" class="nowrap">%arrivalCity%</a> %flyText% %flightCount% %flightsText%.</p>',"avia.schedule.seo.7":"<p>Доставка билетов на самолет осуществляется в Москве. Также мы можем доставить билет в Санкт-Петербурге и некоторых других городах.</p>","avia.common.charter_to":'<a href="%link%">Чартерный рейс %city%</a> всего за',"avia.common.title_index":"Авиа","avia.common.tickets":"Билеты","avia.common.form_main":"Заказ авиабилета","avia.common.form_schedule":"Расписание авиарейсов","avia.common.form_schedule2":"Расписание рейсов","avia.common.from_city":"Пункт отправления","avia.common.to_city":"Пункт прибытия","avia.common.specify_title":"Пожалуйста, уточните города отправления и назначения","avia.common.menu_world":"Все страны","avia.common.menu_gus":"СНГ","avia.common.carrier_title":"Авиакомпании","avia.common.carrier_title_country":"Авиакомпании (%country%)","avia.common.plane_title":"Самолеты","avia.common.carrier_single":"Авиакомпания","avia.common.carrier_single_title":"Авиакомпания %name%: расписание рейсов, заказ авиабилетов, тарифы, продажа авиабилетов, цены на билеты,доставка, описание компании %name%","avia.common.common":"Общая информация","avia.common.comment_meta_title":"Авиакомпания %airportTitle%: %commentTitle%","avia.common.carrier_comment_page_title":"Авиакомпания %carrierTitle% — %commentTitle%","avia.common.name":"Название англ","avia.common.rus_name":"Название рус","avia.common.city":"Город","avia.common.iata":"IATA","avia.common.gsga":"IATA рус","avia.common.url":"URL","avia.common.url2":"URL2","avia.common.timetable":"Онлайн табло","avia.common.icao":"ICAO","avia.common.icao_r":"ICAO рус","avia.common.international":"Межд","avia.common.descr":"Дополнительно","avia.common.departure":"Online табло вылета","avia.common.arrival":"Online табло прилета","avia.common.info_services":"Справочные службы","avia.common.info":"Справочные службы","avia.common.country":"Страна","avia.common.airport":"Аэропорт базирования","avia.common.site":"Сайт","avia.common.site2":"Сайт 2","avia.common.base":"Аэропорт базирования","avia.common.title":"Название","avia.common.add_info":"Дополнительно","avia.common.timeoffset":"Сдвиг времени","avia.common.SaveTime":"Летнее время","avia.common.latitude":"Широта","avia.common.longitude":"Долгота","avia.common.code":"Кодировка в авиа системах","avia.common.name_rus":"Название рус","avia.common.city_id":"Город","avia.common.producter":"Производитель","avia.common.category":"Категория","avia.common.equipment":"Оборудование","avia.common.engine":"Двигатели","avia.common.noise":"Уровень шума","avia.common.condition":"Состояние","avia.common.price":"Цена","avia.common.dimensions":"Размеры","avia.common.capacity":"Число мест","avia.common.cabin":"Размеры пассажирской кабины","avia.common.weights":"Массы и нагрузки","avia.common.flight":"Летные данные","avia.common.wings":"Размах крыла (м)","avia.common.length":"Длина самолета (м)","avia.common.height":"Высота самолета (м)","avia.common.wing_square":"Площадь крыла (м<sup>2</sup>)","avia.common.arrows":"Угол стреловидности крыла по линии 1/4 хорд (градусы)","avia.common.width":"Максимальная ширина фюзеляжа (с)","avia.common.diametr":"Диаметр фюзеляжа","avia.common.variants_synonyms":"Варианты написания (синонимы)","avia.common.crew":"Экипаж","avia.common.cabin3":"Пассажиров в кабине трех классов","avia.common.cabin2":"Пассажиров в кабине двух классов","avia.common.tourist":"Пассажиров в туристическом классе","avia.common.economy":"Пассажиров в экономическом классе","avia.common.business":"Пассажиров в бизнесс классе","avia.common.charter":"Пассажиров в чартерном варианте","avia.common.vip":"Пассажиров в VIP варианте","avia.common.maximum":"Максимальное","avia.common.cabin_length":"Длина (м)","avia.common.cabin_width":"Максимальная ширина (м)","avia.common.cabin_height":"Максимальная высота (м)","avia.common.cabin_volume":"Объем (м<sup>3</sup>)","avia.common.take_off":"Взлетная (т)","avia.common.equip":"Пустого снаряженного (т)","avia.common.no_fuel":"Самолета без топлива (т)","avia.common.load":"Платная нагрузка (т)","avia.common.landing":"Посадочная (т)","avia.common.fuel":"<b>Заправщик</b>","avia.common.speed":"Крейсерская скорость (км/ч)","avia.common.distance":"Дальность полета с максимальной платной нагрузкой (с резервами топлива) (км)","avia.common.dist_maxfuel":"Дальность полета с максимальным запасом топлива (км)","avia.common.dist_pass":"Дальность полета с пассажирами и багажом (с резервами топлива) (км)","avia.common.ceiling":"Эксплуатационный потолок (м)","avia.common.vpp":"Потребная длина ВПП (условия МСА, на уровне моря) (м)","avia.common.civil":"<b>Гражданский</b>","avia.common.passanger":"Пассажирский","avia.common.regional":"Региональный","avia.common.middle":"Среднемагистральный","avia.common.long":"Дальнемагистральный","avia.common.cargo":"Грузовой","avia.common.business_avia":"Деловая авиация","avia.common.special_avia":"Спецназначения","avia.common.military":"<b>Военный</b>","avia.common.battle":"Боевой","avia.common.training":"Учебный","avia.common.transport":"Транспортный","avia.common.tipe":"Виды перевозок","avia.common.regular":"Регулярные","avia.common.chart":"Чартерные","avia.common.busines":"Бизнес","avia.common.low_cost":"Low-cost","avia.common.avia_taxi":"Авиатакси","avia.common.gruz":"Грузовые","avia.common.spetial":"Специальные","avia.common.region":"Регион","avia.common.information":"Информация","avia.common.img_min":"маленькая схема:","avia.common.img":"полная схема:","avia.common.click":"Нажмите для просмотра полной схемы","avia.common.logo":"Логотип:","avia.common.get_code":"Получить HTML-код!","avia.common.news":"","avia.common.put_favorite_link":"Поставь удобную ссылку на эту страницу!","avia.common.seo_text_on_avia":"","avia.common.charter_reises":"Чартерные рейсы","avia.common.from_moscow":"из Москвы","avia.common.all_reises":"Все чартерные рейсы из Москвы","avia.common.cities":"Города","avia.common.titles":"Названия","avia.common.names_ru":"русские","avia.common.names_en":"английские","avia.common.showas_city":"по названиям","avia.common.showas_airport":"по аэропортам","avia.common.where_fly_from":"Популярные авиарейсы из","avia.common.popular_country_tickets1":"Популярные города: авиабилеты","avia.common.popular_country_tickets2":"по выгодным ценам на","avia.common.popular_companies1":"Цены на авиабилеты","avia.common.popular_companies2":"от популярных авиакомпаний","avia.common.rules_link":'<p class="left_more_menu"><a href="%link%avia_rules/avia_rules/">Правила заказа авиабилетов</a></p>',"avia.common.city_hotels":"Проживание в гостиницах","avia.common.city_hotels_info":'<a href="%url%">Гостиницы %city%</a> &mdash; это %number% %buildings%, %ready% стать вашим домом на время поездки.',"avia.common.this_flight_variant":"Выбрать этот вариант","avia.common.no_tickets":"Билетов на <strong>29 сентября в Краснодар</strong> нет.","avia.common.near_city_to":"Попробуйте поискать на другую дату или выберите город прилета неподалеку.","avia.common.near_city_from":"Попробуйте поискать на другую дату или выберите город вылета неподалеку.","avia.error.incorrect_request":"Некорректный запрос","avia.error.field_sname":"Фамилия","avia.error.field_fname":"Имя","avia.error.field_birthday":"Дата рождения","avia.error.field_contact_fname":"Имя контактного лица","avia.error.field_contact_sname":"Фамилия контактного лица","avia.error.field_contact_phone":"Телефон контактного лица","avia.error.field_doc_info":"Данные документа пассажира","avia.error.field_doc_type":"Не указан тип документа","avia.error.check_latin":"%field_name% должно быть написано латиницей","avia.error.check_rus":"%field_name% должно быть написано кириллицей","avia.error.payment":"Выберите способ оплаты","avia.error.agreement":"Для продолжения вы должны подтвердить, что согласны с правилами tutu.ru","avia.error.unknown_doc_type":"Неверный тип документа","avia.error.expired_passport":"Пожалуйста, проверьте срок действия загранпаспорта. Он заканчивается раньше даты вылета","avia.error.timeout_error":"Время отведенное на выполнение заказа истекло. Начните заново.","avia.error.data_obsolete":"Данные по выбранному перелету устарели.","avia.error.internal":'К сожалению, система бронирования сообщила об ошибке. Пожалуйста, попробуйте еще раз. <br />Если ошибка не исчезает, пожалуйста, <a href="/feedback.php">сообщите нам об этом</a>',"avia.error.bad_request_date_date_future":"Пожалуйста проверьте дату полета и повторите поиск.","avia.error.bad_request_point_not_empty":"Уточните пункты назначения.","avia.error.bad_request_full_not_empty":"Вы должны указать хотя бы одного взрослого пассажира.","avia.error.bad_request_full_not_greater":"Количество мест для маленьких детей не может быть больше количества мест для взрослых.","avia.error.no_seats":"Извините, но на данном перелете все места закончились.","avia.error.bad_request_max_not_greater":"Правила авиакомпаний не допускают бронирования более 9 мест в одном заказе. Пожалуйста, уменьшите количество пассажиров.","avia.error.specify_departure_city":"Пожалуйста, укажите город вылета","avia.error.specify_arrival_city":"Пожалуйста, укажите город прилета","avia.error.specify_departure_date":"Пожалуйста, укажите дату вылета","avia.error.specify_arrival_date":"Пожалуйста, укажите дату прилета","avia.error.payment_error_card_expired":"Невозможно произвести транзакцию с вашей карты, так как срок действия ее истек.","avia.error.payment_error_cardonline":"Невозможно произвести транзакцию с вашей карты. Выберите другой метод оплаты или другую карту.","avia.error.payment_error_yandex":"Невозможно произвести транзакцию используя кошелек Яндекс.Деньги. Выберите другой метод оплаты.","avia.error.payment_canceled":"Платеж отменен.","avia.error.pnr_not_found":"Бронь не найдена.","avia.error.missed_locator":"Пожалуйста, укажите номер брони.","avia.error.price_changed":'К сожалению, указанная цена не подтверждена авиакомпанией.<br />Мы получили уведомление об этом и уже разбираемся с ситуацией.<br />Наш оператор перезвонит вам и поможет выбрать подходящие билеты в ближайшее время. <a href="/2read/avia/avia_msk/" target="_blank">График работы операторов</a>.',"avia.error.price_changed_softly":'По обновленной информации систем бронирования цена была изменена с %oldPrice% до %newPrice% Вы можете продолжить заказ или <a href="%offers_url%">выбрать другое предложение</a>.',"avia.error.flight_not_found_in_gds":"Данный перелет не найден в системе бронирования. Возможно места на него закончились.","avia.error.wrong_date_for_carrier":"Для выбранной даты рейсы данной авиакомпании недоступны.","avia.error.gds_not_detailed_flight":"К сожалению система бронирования не подтвердила этот перелет. Выберите другой.","avia.error.empty_response":'К сожалению, нам не удалось получить нужные данные от систем бронирования.<br />Пожалуйста, выберите другой рейс.<br />Если ошибка не исчезает, пожалуйста, <a href="/feedback.php">сообщите нам об этом</a>',"avia.error.cc_insufficient_funds":"По данным платежной системы, на вашей карте недостаточно средств.<br />Пожалуйста, выберите другой способ оплаты или другую карту.","avia.error.missed_city":"Не указан город","avia.error.missed_country":"Не указана страна","avia.error.show_order_detail":"К сожалению, по данному заказу невозможно отобразить подробную информацию.","avia.error.no_flight_for_detail":"Не удается отобразить подробную информацию о PNR id=%orderId% из-за отсутствия объекта Flight","avia.error.no_flights_selected_route":"Нет рейсов по выбранному маршруту","avia.error.infant_more_2years":"По правилам авиакомпании %arrivalDate% пассажиру должно быть менее 2-х лет","avia.error.infant_must_born":"Некорректная дата рождения пассажира. Проверьте, пожалуйста, и укажите правильную дату","avia.error.pay_add_unavailable":"Страница платежа недоступна","avia.error.pay_add_contact":"Пожалуйста, свяжитесь с оператором по телефону %support_tel%, чтобы узнать подробности.","avia.error.pay_add_tell_number":"Сообщите ему номер вашего заказа","avia.error.payent_failed":"<p>К сожалению, платежный сервис не разрешил оплату по указанным вами данным.</p><p>Пожалуйста, введите данные еще раз. Также вы можете оплатить другой картой или другим способом.</p>","avia.avia_landing_page.meta_title":"Авиабилеты в Австралию","avia.avia_landing_page.meta_description":"Авиабилеты в Австралию - цены, расписание рейсов","avia.avia_landing_page.meta_keywords":"Авиабилеты в Австралию - цены, расписание рейсов","avia.avia_landing_page.hand_text":"<span>Наличными</span> курьеру","avia.avia_landing_page.main_title_popular":"Популярные города: авиабилеты в&nbsp;Австралию по&nbsp;выгодным ценам на&nbsp;15&nbsp;сентября","avia.avia_landing_page.phone_title":"Наш консультант поможет купить авиабилет.","avia.avia_landing_page.faq_title":"Знаете ли вы,","avia.avia_landing_page.faq_block_1_title":"как купить авиабилет, не&nbsp;выходя из&nbsp;дома?","avia.avia_landing_page.faq_block_1_text":"<p>На&nbsp;сайте Туту.ру укажите в&nbsp;нужных полях маршрут, даты поездки и&nbsp;количество пассажиров.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Система подберет подходящие варианты из&nbsp;предложений нескольких сотен авиакомпаний.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Из&nbsp;списка рейсов выберите удобный для вас.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Введите личные данные&nbsp;&mdash; они необходимы для оформления билетов. Туту.ру не&nbsp;хранит их&nbsp;и&nbsp;передает по&nbsp;защищенному каналу.</p>\n\t\t\t\t\t\t\t\t\t\t\t\t<p>Оплатите билеты удобным вам способом.</p>","avia.avia_landing_page.faq_block_2_title":"как оплатить авиабилет при покупке в&nbsp;интернете?","avia.avia_landing_page.faq_block_2_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tОплатить билет на&nbsp;сайте Туту.ру быстрее и&nbsp;удобнее всего банковской картой.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;принимаем карты международных платежных систем Visa и&nbsp;MasterCard всех видов&nbsp;&mdash; дебетовые, кредитные, виртуальные (например, QIWI Visa Virtual).\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\t\tТакже на&nbsp;Туту.ру можно платить Яндекс.Деньгами, с&nbsp;QIWI Кошелька или <b>наличными</b>&nbsp;&mdash; в&nbsp;офисе агентства, курьеру или в&nbsp;терминалах QIWI.\n\t\t\t\t\t\t\t\t\t\t\t</p>","avia.avia_landing_page.faq_block_3_title":"почему на&nbsp;сайте Туту.ру можно без опасений указывать данные банковской карты?","avia.avia_landing_page.faq_block_3_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tВвод данных происходит на&nbsp;защищенных страницах. Мы&nbsp;не&nbsp;храним никакой информации о&nbsp;банковских картах, только передаем их&nbsp;в&nbsp;банк для проведения платежа.\t\t\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\tВесь процесс происходит автоматически, без участия человека.\t\t\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДанные передаются по&nbsp;защищенному (шифрованному) каналу.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tМы&nbsp;гарантируем, что никакая информация не&nbsp;будет передана третьим лицам или использована в&nbsp;иных, кроме оформления билетов, целях.\n\t\t\t\t\t\t\t\t\t\t\t</p>","avia.avia_landing_page.faq_block_4_title":"как выглядит электронный билет и&nbsp;где его получить?","avia.avia_landing_page.faq_block_4_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tПосле оплаты в&nbsp;базе данных авиакомпании появляется новая запись&nbsp;&mdash; это и&nbsp;есть электронный билет. Теперь вся информация о&nbsp;вашем перелете будет храниться у&nbsp;авиакомпании-перевозчика. \n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронные билеты на&nbsp;самолет не&nbsp;выпускаются в&nbsp;бумажной форме и&nbsp;посмотреть на&nbsp;них нельзя.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tУвидеть, распечатать и&nbsp;взять с&nbsp;собой в&nbsp;аэропорт можно не&nbsp;сам билет, а&nbsp;маршрутную квитанцию. В&nbsp;ней есть номер билета и&nbsp;все сведения о&nbsp;вашем полете. Мы&nbsp;пришлем квитанцию по&nbsp;электронной почте.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tМаршрутная квитанция не&nbsp;понадобится при регистрации на&nbsp;рейс&nbsp;&mdash; все сведения хранятся в&nbsp;компьютере и&nbsp;в&nbsp;аэропорту вам будет нужен только паспорт.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tТем не&nbsp;менее, советуем распечатать квитанцию и&nbsp;взять с&nbsp;собой. Ее&nbsp;могут попросить на&nbsp;паспортном контроле за&nbsp;границей, как подтверждение того, что у&nbsp;вас есть обратный билет или что вы&nbsp;следуете далее по&nbsp;маршруту.\n\t\t\t\t\t\t\t\t\t\t\t</p>","avia.avia_landing_page.faq_block_5_title":"как попасть в&nbsp;самолет по&nbsp;электронному билету?","avia.avia_landing_page.faq_block_5_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tЭлектронный билет на&nbsp;самолет является официальным документом, подтверждающими заключение договора о&nbsp;воздушной перевозке. </p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Чтобы использовать билет, необходимо только вовремя прибыть в&nbsp;аэропорт и&nbsp;пройти регистрацию.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля регистрации вам понадобятся:\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<ul>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tудостоверение личности, указанное в&nbsp;заказе;\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t\t<li>\n\t\t\t\t\t\t\t\t\t\t\t\tсвидетельство о&nbsp;рождении (при перелете с&nbsp;детьми).\n\t\t\t\t\t\t\t\t\t\t\t\t</li>\n\t\t\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tМаршрутная квитанция не&nbsp;является обязательным документом при прохождении регистрации. Тем не&nbsp;менее, Туту.ру рекомендует распечатать квитанцию и&nbsp;взять ее&nbsp;с&nbsp;собой. </p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Она может понадобиться на&nbsp;паспортном контроле за&nbsp;границей, как подтверждение того, что у&nbsp;вас есть обратный билет или что вы&nbsp;следуете далее по&nbsp;маршруту.\n\t\t\t\t\t\t\t\t\t\t\t</p>","avia.avia_landing_page.faq_block_6_title":"как вернуть авиабилет?","avia.avia_landing_page.faq_block_6_text":'<p>\n\t\t\t\t\t\t\t\t\t\t\tВернуть электронный авиабилет, независимо от&nbsp;того, каким образом он&nbsp;был забронирован и&nbsp;оплачен, можно только в&nbsp;соответствии с&nbsp;правилами авиакомпании.\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tЧтобы сдать билет, надо как можно раньше связаться с&nbsp;оператором.\t\t\t\t\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t\t\t</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tДля этого надо ответить на&nbsp;письмо, которое вы&nbsp;получите после заказа билетов на&nbsp;сайте Туту.ру. </p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Укажите в&nbsp;теме сообщения &laquo;Возврат билетов&raquo; и&nbsp;кратко опишите свою ситуацию. С&nbsp;вами свяжутся наши специалисты. \nЕсли вы&nbsp;не&nbsp;получили письма, напишите на&nbsp;<a href="mailto:info@tutu.ru">info@tutu.ru</a>.</p>\n\t\t\t\t\t\t\t\t\t\t\t<p>\n\t\t\t\t\t\t\t\t\t\t\tВ&nbsp;информационном письме, которое вы&nbsp;получаете после заказа, есть также контакты агентства-партнера, через которое был оформлен ваш билет. Вы&nbsp;можете связаться с&nbsp;ним напрямую.\n\t\t\t\t\t\t\t\t\t\t\t</p>',"avia.avia_landing_page.faq_block_7_title":"как изменить дату рождения и&nbsp;номер паспорта в&nbsp;авиабилете?","avia.avia_landing_page.faq_block_7_text":"<p>\n\t\t\t\t\t\t\t\t\t\t\tТакие изменения чаще всего можно внести в&nbsp;уже оформленный билет. </p>\n\t\t\t\t\t\t\t\t\t\t\t<p>Для этого надо как можно скорее связаться с&nbsp;оператором. Его контакты будут в&nbsp;письме, которое вы&nbsp;получите после заказа билетов на&nbsp;сайте Туту.ру.\n\t\t\t\t\t\t\t\t\t\t\t</p>","avia.finish.msg_davs_cardonline_MOW":'<p>Способ оплаты: банковской картой <img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /> онлайн</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва),</nobr> <nobr>8-800-700-99-09 (регионы) &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_yandex_MOW":'<p>Способ оплаты: <img src="http://localhost.localdomain/images2/main/pay/ya.gif" alt="" /> Яндекс.деньгами</p>\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва),</nobr> <nobr>8-800-700-99-09 (регионы) &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_MOW":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают круглосуточно, без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09</nobr> (наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_LED":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Санкт-Петербурге</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают c 9:00 до 20:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (812) 493-59-60,</nobr> <nobr>8-800-700-99-08 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_OVB":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Новосибирске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 20:00, в выходные с 10:00 до 19:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (383) 35-40-400,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_KHV":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Хабаровске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают с 09:00 до 19:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (4212) 620-875,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_curier_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09</nobr> (наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_curier_LED":'<p>Оплата и получение билетов: <span class="red" ><b>в Санкт-Петербурге</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают c 9:00 до 20:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (812) 493-59-60,</nobr> <nobr>8-800-700-99-08 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_curier_OVB":'<p>Оплата и получение билетов: <span class="red" ><b>в Новосибирске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 20:00, в выходные с 10:00 до 19:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (383) 35-40-400,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_cash_curier_KHV":'<p>Оплата и получение билетов: <span class="red" ><b>в Хабаровске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\t\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают с 09:00 до 19:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (4212) 620-875,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davs_qiwi_MOW":'<p>Авиабилеты будут оформлены сразу после оплаты.</p>\n\t\t\t\t\t\t\t\t\t<p>Билеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.</p>\n\t\t\t\t\t\t\t\t\t<p>Для оплаты наличными в терминалах Qiwi используйте номер мобильного телефона, указанный при оформлении билетов.</p>\n\t\t\t\t\t\t\t\t\t<p>В течении часа после оплаты вы получите на электронную почту письмо с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_qiwi/">Подробнее про оплату в терминалах Qiwi</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва),</nobr> <nobr>8-800-700-99-09 (регионы) &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t<p>Наши операторы работают без выходных круглосуточно.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_sig23_cash_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Оплатить заказ необходимо в течение <span class="red" ><b>%lifetime%</b></span></p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 921-01-17</nobr> (наш партнер, SI Tours&Travel).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_sig23_cash_curier_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Оплатить заказ необходимо в течение <span class="red" ><b>%lifetime%</b></span></p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 921-01-17</nobr> (наш партнер, SI Tours&Travel).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_sig23_cardonline_MOW":'<p>Способ оплаты: банковской картой <img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /> онлайн</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 987-21-05, в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</nobr>.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_galileo_cash_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 921-01-17</nobr> (наш партнер, SI Tours&Travel).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_galileo_cash_curier_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 921-01-17</nobr> (наш партнер, SI Tours&Travel).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_galileo_cardonline_MOW":'<p>Способ оплаты: банковской картой <img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /> онлайн</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 987-21-05, в будние дни с 9:00 до 21:00, в субботу с 10:00 до 20:00, в воскресенье с 10:00 до 18:00.</nobr></p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cardonline_MOW":'<p>Способ оплаты: банковской картой <img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /> онлайн</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва)</nobr>, <nobr>8-800-700-99-09 (регионы)</nobr> &mdash; наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_yandex_MOW":'<p>Способ оплаты: <img src="http://localhost.localdomain/images2/main/pay/ya.gif" alt="" /> Яндекс.деньгами</p>\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_itinerary_receipt/">Подробнее про маршрутную квитанцию</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва),</nobr> <nobr>8-800-700-99-09 (регионы) &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_MOW":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают круглосуточно, без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09</nobr> (наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_LED":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Санкт-Петербурге</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают c 9:00 до 20:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (812) 493-59-60,</nobr> <nobr>8-800-700-99-08 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_OVB":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Новосибирске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 20:00, в выходные с 10:00 до 19:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (383) 35-40-400,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_KHV":'\t<p>Оплата и получение билетов: <span class="red" ><b>в Хабаровске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают с 09:00 до 19:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (4212) 620-875,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_curier_MOW":'<p>Оплата и получение билетов: <span class="red" ><b>в Москве</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после успешной обработки данных нашей системой в течение 4-х часов.</p><p>После этого Вы получите письмо с извещением о покупке и с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09</nobr> (наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;).</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_curier_LED":'<p>Оплата и получение билетов: <span class="red" ><b>в Санкт-Петербурге</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают c 9:00 до 20:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (812) 493-59-60,</nobr> <nobr>8-800-700-99-08 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_curier_OVB":'<p>Оплата и получение билетов: <span class="red" ><b>в Новосибирске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают в будние дни с 9:00 до 20:00, в выходные с 10:00 до 19:00.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (383) 35-40-400,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_cash_curier_KHV":'<p>Оплата и получение билетов: <span class="red" ><b>в Хабаровске</b></span></p>\n\t\t\t\t\t\t\t\t\t<p>Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.</p><br /><br />\t\n\t\t\t\t\t\t\t\t\t<p>Ваши билеты будут оформлены сразу после подтверждения по телефону. </p><p>Операторы Tutu.ru позвонят вам для подтверждения в течение ближайших 4 часов. Они работают с 09:00 до 19:00 без выходных.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (4212) 620-875,</nobr> <nobr>8-800-700-99-09 &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.msg_davsx_qiwi_MOW":'<p>Авиабилеты будут оформлены сразу после оплаты.</p>\n\t\t\t\t\t\t\t\t\t<p>Билеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.</p>\n\t\t\t\t\t\t\t\t\t<p>Для оплаты наличными в терминалах Qiwi используйте номер мобильного телефона, указанный при оформлении билетов.</p>\n\t\t\t\t\t\t\t\t\t<p>В течении часа после оплаты вы получите на электронную почту письмо с маршрутной квитанцией.</p>\n\t\t\t\t\t\t\t\t\t<ul class="list-nostyle" >\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_qiwi/">Подробнее про оплату в терминалах Qiwi</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_receiving/">Как получить авиабилет</a></li>\n\t\t\t\t\t\t\t\t\t\t<li><a href="/2read/avia/avia_registration/">Как пройти регистрацию в аэропорту</a></li>\n\t\t\t\t\t\t\t\t\t</ul>\n\t\t\t\t\t\t\t\t\t<p>Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 287-99-09 (Москва),</nobr> <nobr>8-800-700-99-09 (регионы) &mdash;</nobr> наш партнер, ЗАО &laquo;Агентство &laquo;ДАВС&raquo;.</p>\n\t\t\t\t\t\t\t\t\t<p>Наши операторы работают без выходных круглосуточно.</p>\n\t\t\t\t\t\t\t\t\t',"avia.finish.user_order_davs":'<span class="order-addr">Справка <span class="nowrap">(495) 287-99-09</span> (Москва),</span><br/><span class="order-addr"><span class="nowrap">8-800-700-99-09</span> (регионы)</span>',"avia.finish.user_order_sig23":'<span class="order-addr">Справка <span class="nowrap">(495) 987-21-05</span></span>',"avia.finish.user_order_sig23_cardonline":'<span class="order-addr">Справка <span class="nowrap">(495) 987-21-05</span></span>',"avia.finish.user_order_europe":'<span class="order-addr">Справка <span class="nowrap">(495) 795-09-60</span></span>',"avia.finish.user_order_davsx":'<span class="order-addr">Справка <span class="nowrap">(495) 287-99-09</span> (Москва),</span><br/><span class="order-addr"><span class="nowrap">8-800-700-99-09</span> (регионы)</span>',"avia.finish.user_order_galileo":'<span class="order-addr">Справка <span class="nowrap">(495) 987-21-05</span></span>',"avia.finish.user_order_galileo_cardonline":'<span class="order-addr">Справка <span class="nowrap">(495) 987-21-05</span></span>',"avia.gds.carrier":"Авиакомпания","avia.gds.departure_flight":"Вылет","avia.gds.arrival_flight":"Прилет","avia.gds.inair":"В пути","avia.gds.inairs":"в пути","avia.gds.reis":"Рейс","avia.gds.no_departure_city":"Пункт отправления &laquo;%searchPhrase%&raquo; не найден","avia.gds.no_arrival_city":"Пункт прибытия &laquo;%searchPhrase%&raquo; не найден","avia.gds.search_button":"Показать расписание и билеты","avia.gds.buy_button":"Купить билеты","avia.gds.select_payment_method":"Перейти к выбору способа оплаты","avia.gds.back_offers":"Вернуться к выбору перелета","avia.gds.back_passengers":"Вернуться к вводу информации о пассажирах","avia.gds.back_payment":"Вернуться к выбору способа оплаты","avia.gds.book":"Перейти к завершению заказа","avia.gds.pay":"Перейти к оплате","avia.gds.pay_additional":"Доплатить","avia.gds.pay_additional_new":"Оплатить","avia.gds.passengers":"Перейти к вводу информации о пассажирах","avia.gds.finish_order":"Завершить оформление заказа","avia.gds.ow":"в один конец","avia.gds.rt":"туда-обратно","avia.gds.departure":"Отправление","avia.gds.arrival":"Прибытие","avia.gds.flight_performed_by":"Перелет выполняет авиакомпания","avia.gds.flight_performed_by_multi":"Перелеты выполняют авиакомпании","avia.gds.flight_performed_by_multi_one":"Перелеты выполняет авиакомпания","avia.gds.pm_cash":"Наличными","avia.gds.pm_cash_disabled":"Наличными","avia.gds.pm_cash_full":"Наличными в&nbsp;офисе агентства","avia.gds.pm_cash_sig23_full":"Наличными в&nbsp;офисе агентства в Москве","avia.gds.pm_cash_galileo_full":"Наличными в&nbsp;офисе агентства в Москве","avia.gds.pm_cash_curier":"Наличными курьеру","avia.gds.pm_cash_curier_disabled":"Наличными курьеру","avia.gds.pm_cash_curier_full":"Наличными курьеру с&nbsp;доставкой в&nbsp;ваш офис","avia.gds.pm_cash_curier_sig23_full":"Наличными курьеру с&nbsp;доставкой в&nbsp;ваш офис в Москве","avia.gds.pm_cash_curier_galileo_full":"Наличными курьеру с&nbsp;доставкой в&nbsp;ваш офис в Москве","avia.gds.pm_cardonline":"Картой онлайн&nbsp;","avia.gds.pm_cardonline_disabled":"Картой онлайн&nbsp;","avia.gds.pm_cardonline_full":'<img src="http://localhost.localdomain/images2/main/pay/card.gif" alt="" style="margin-right: 4px" /> Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa_disabled.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc_disabled.gif" alt="" /--> онлайн',"avia.gds.pm_cardonline_davsx_full":'<img src="http://localhost.localdomain/images2/main/pay/card.gif" alt="" style="margin-right: 4px" /> Банковской картой онлайн',"avia.gds.pm_cardonlineforeign":'Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc.gif" alt="" /--> иностранного банка онлайн',"avia.gds.pm_cardonlineforeign_disabled":'Банковской картой <!--img src="http://localhost.localdomain/images2/main/pay/visa_disabled.gif" alt="" /><img src="http://localhost.localdomain/images2/main/pay/mc_disabled.gif" alt="" /--> иностранного банка онлайн',"avia.gds.pm_card":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.gds.pm_card_disabled":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.gds.pm_card_full":"Банковской картой в&nbsp;офисе в&nbsp;Москве","avia.gds.pm_yandex":"Яндекс.Деньгами","avia.gds.pm_yandex_full":'<img src="http://localhost.localdomain/images2/main/pay/ya.gif" alt="" style="margin-top: -1px" onclick="javascript:document.getElementById(\'method|yandex\').click();"/> Яндекс.деньгами',"avia.gds.pm_yandex_disabled":"Яндекс.Деньгами","avia.gds.pm_webmoney_disabled":"Webmoney","avia.gds.pm_invoice":"Банковским переводом","avia.gds.pm_invoice_disabled":"Банковским переводом","avia.gds.pm_beeline":'<img src="http://localhost.localdomain/images2/main/pay/bee.gif" alt="" /> С мобильного телефона абонентам Билайна',"avia.gds.pm_beeline_disabled":"С мобильного телефона абонентам Билайна","avia.gds.pm_qiwi":"В терминалах Qiwi&nbsp;","avia.gds.pm_qiwi_full":'<img src="http://localhost.localdomain/images2/main/pay/q.gif" alt="" style="margin: -1px 0 -2px" onclick="javascript:document.getElementById(\'method|qiwi\').click();"/> Наличными в терминалах Qiwi',"avia.gds.pm_qiwi_disabled":"В терминалах Qiwi","avia.gds.pm_davs_cities":", Санкт-Петербурге и&nbsp;Новосибирске","avia.gds.pmpo_cash":"Наличными","avia.gds.pmpo_cash_curier":"Наличными&nbsp;курьеру","avia.gds.pmpo_cardonline":"Банковской&nbsp;картой&nbsp;онлайн","avia.gds.pmpo_cardonlineforeign":"Банковской&nbsp;картой иностранного банка онлайн","avia.gds.pmpo_card":"Банковской&nbsp;картой в&nbsp;офисе в&nbsp;Москве","avia.gds.pmpo_yandex":"Яндекс.Деньгами","avia.gds.pmpo_webmoney":"Webmoney","avia.gds.pmpo_invoice":"Банковским&nbsp;переводом","avia.gds.pmpo_beeline":"С&nbsp;мобильного телефона абонентам Билайна","avia.gds.pmpo_qiwi":"В&nbsp;терминалах&nbsp;Qiwi","avia.gds.tt_full":"Взрослый","avia.gds.tt_child":"Детский","avia.gds.tt_infant":"Для ребенка до 2 лет","avia.gds.tt_confirm":"Подтвердите заказ","avia.gds.tt_ticket":"Билет","avia.gds.tt_detail":"Проверьте детали полета","avia.gds.tt_payment_method":"Выберите способ оплаты","avia.gds.tt_passengers":"Введите данные пассажиров","avia.gds.tt_fares":"Правила применения тарифа","avia.gds.tt_success":"Поздравляем с успешным заказом!","avia.gds.tt_pay":"Оплатить бронь","avia.gds.order_customer_i_am_psgr":"Я пассажир","avia.gds.order_customer_info":"Покупатель","avia.gds.order_customer_title":"Войдите в систему под своим паролем, чтобы не заполнять все поля каждый раз.","avia.gds.order_customer_first_name":"Имя","avia.gds.order_customer_last_name":"Фамилия","avia.gds.order_customer_phone":"Телефон для связи","avia.gds.order_customer_email":"Электронная почта","avia.gds.order_customer_clarification":'<p class="data_comment_text">Мы отправим купленный билет на указанную вами почту.</p><p class="data_comment_text">И обязательно позвоним, если что-то пойдет не так.</p>',"avia.gds.order_passenger_1":"Пассажир","avia.gds.order_passenger_n":"Пассажиры","avia.gds.order_psgr_type_full":"Взрослый","avia.gds.order_psgr_type_child":"Ребенок <br />до 12-ти лет","avia.gds.order_psgr_type_infant":"Малыш <br />до 2-х лет","avia.gds.order_psgr_first_man":"Мужчина","avia.gds.order_psgr_first_woman":"Женщина","avia.gds.order_psgr_first_boy":"Мальчик","avia.gds.order_psgr_first_girl":"Девочка","avia.gds.order_psgr_first_name":"имя","avia.gds.order_psgr_last_name":"фамилия","avia.gds.order_psgr_birthday":"дата рождения","avia.gds.order_psgr_document_number":"номер документа","avia.gds.order_psgr_expire_date":"срок действия","avia.gds.order_psgr_type_short_adult":"-","avia.gds.order_psgr_type_short_children":"12-ти лет","avia.gds.order_psgr_type_short_infants":"2-х лет","avia.gds.order_payment_method_n":"Выберите способ оплаты","avia.gds.order_payment_method_1":"Способ оплаты","avia.gds.change_search":"Изменить параметры авиарейса.","avia.gds.change_search2":"Найти другие авиарейсы","avia.gds.tip_enter_russian_mobile":"Введите номер мобильного телефона российского оператора по примеру (123)111-11-11","avia.gds.tip_order_1":"Заказ одного билета на авиарейс","avia.gds.tip_order_2":"Заказ двух билетов на авиарейс","avia.gds.tip_order_3":"Заказ трех билетов на авиарейс","avia.gds.tip_order_4":"Заказ четырех билетов на авиарейс","avia.gds.tip_order_5":"Заказ пяти билетов на авиарейс","avia.gds.tip_order_6":"Заказ шести билетов на авиарейс","avia.gds.tip_order_max":"Заказ %number% билетов на авиарейс","avia.gds.tip_outbound":"Вылет","avia.gds.tip_inbound":"Возврат","avia.gds.tip_local_time_notice":"В расписании указано <i>местное время</i>","avia.gds.tip_fname":"Имя","avia.gds.tip_sname":"Фамилия","avia.gds.tip_phone":"Телефон","avia.gds.tip_mobile":"Мобильный","avia.gds.tip_address":"Адрес","avia.gds.tip_email":"Электронная почта","avia.gds.tip_sex":"Пол","avia.gds.tip_birthday":"Дата рождения","avia.gds.tip_doc_info":"Номер документа","avia.gds.tip_doc_valid_till":"Срок действия документа","avia.gds.tip_document":"Документ","avia.gds.tip_doc_passport":"Паспорт","avia.gds.tip_doc_international":"Загранпаспорт","avia.gds.tip_doc_birthcert":"Свидетельство о рождении","avia.gds.tip_doc_":"Неизвестный документ","avia.gds.tip_use_latin":'Фамилия и имя заполняются на <img src="%flag_url%" alt="" /> английском языке',"avia.gds.tip_sex_M":"Мужчина","avia.gds.tip_sex_F":"Женщина","avia.gds.tip_born":"Дата рождения","avia.gds.tip_born_":"Родился","avia.gds.tip_born_M":"Родился","avia.gds.tip_born_F":"Родилась","avia.gds.tip_select_RT":"Выберите рейсы <b>вылета</b> и <b>возврата</b>, чтобы приобрести билеты.","avia.gds.tip_select_OW":"Выберите рейс, чтобы приобрести билеты.","avia.gds.tip_departure_at":"вылет в","avia.gds.tip_departure_atU":"Вылет в","avia.gds.tip_departure_from":"из %city_name%","avia.gds.tip_pay_in":"в ","avia.gds.tip_just_city":"%city_name%","avia.gds.tip_arrival_to":"в %city_name%","avia.gds.tip_leave_contacts":"Оставьте контактную информацию","avia.gds.tip_agreement":'Я согласен с <a href="%rules_url%" target="_blank">правилами использования сервиса</a> и <a href="%fares_url%" target="_blank">правилами применения тарифа</a>.',"avia.gds.tip_rules":"Условия использования сервиса Туту.ру","avia.gds.tip_currency_concise":"руб.","avia.gds.tip_wo_changes":"Прямые рейсы","avia.gds.tip_w_changes":"С пересадками","avia.gds.tip_how_to_buy":"Справка о приобретении билетов","avia.gds.tip_eticket_info":"Электронный авиабилет","avia.gds.tip_+1_day":"Прилет на следующий календарный день (%concrete_date%)","avia.gds.tip_+2_day":"Прилет через два календарных дня (%concrete_date%)","avia.gds.tip_-1_day":"Прилет на предыдущий календарный день (%concrete_date%)","avia.gds.tip_payment_method":"Способ оплаты","avia.gds.tip_enter_locator":"Введите номер брони","avia.gds.tip_payment_type_both":"Оплата наличными или онлайн","avia.gds.tip_payment_type_offline":"Только за наличные в Москве","avia.gds.tip_payment_type_online":"Только онлайн-оплата","avia.gds.tip_currency_EUR":"евро","avia.gds.tip_foreign_currency":'<p>Эта авиакомпания указала стоимость некоторых рейсов в валюте (<span class="red" >%original% евро</span>).</p><p>Деньги будут списаны с карточки по курсу вашего банка.</p>',"avia.gds.tip_foreign_currency_warn":"\n\t\t\t<p>Этот&nbsp;тариф&nbsp;указан&nbsp;авиакомпанией&nbsp;в&nbsp;%currency%.</p>\n\t\t\t<p>Деньги будут списаны с карточки по внутреннему курсу вашего банка на день проведения платежа.</p>\n\t\t\t<p>Как правило, курс российских банков выше курса Центрального Банка России на 0,5% — 1%.</p>\n\t\t\t<p>Курс ЦБ на %date%  — %course%.</p>\n\t\t\t<p>Если деньги будут списаны с карты %date%, то сумма составит примерно %price%</p>\n\t\t\t<p>Если у вас есть счет в %currency%, вы можете оплатить билет без конвертации.</p>","avia.gds.tip_country":"Страна","avia.gds.tip_city":"Город","avia.gds.tip_post_index":"Индекс","avia.gds.tip_post_address":"Адрес","avia.gds.tip_post_address_ext":"Улица, дом и квартира (офис)","avia.gds.different_carriers":"Разные авиакомпании","avia.gds.different_planes":"","avia.gds.class_econom":"Экономический класс","avia.gds.class_business":"Бизнес класс","avia.gds.class_first":"Первый класс","avia.gds.class_Y":"Экономический","avia.gds.class_C":"Бизнес","avia.gds.class_F":"Первый","avia.gds.tip_time_for_payment":"Если вы выбрали оплату курьеру или в офисе агентства, точное время оплаты сообщит позвонивший вам оператор. \n\t\t\t\t\t\t\t\t\tБилеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.","avia.gds.tip_time_for_payment_cash":"Точный срок оплаты сообщит оператор. Он позвонит вам в ближайшее время после заказа на сайте.","avia.gds.tip_time_for_payment_notcash":"Билеты по некоторым тарифам нужно оплатить в течение 30 минут. Пожалуйста, оплатите заказ как можно скорее.","avia.gds.time_for_payment_d":"%number%&nbsp;суток&nbsp;","avia.gds.time_for_payment_h_1":"%number%&nbsp;часа","avia.gds.time_for_payment_h_2":"%number%&nbsp;часов","avia.gds.time_for_payment_h_3":"%number%&nbsp;часов","avia.gds.time_for_payment_m_1":"%number%&nbsp;минуты","avia.gds.time_for_payment_m_2":"%number%&nbsp;минут","avia.gds.time_for_payment_m_3":"%number%&nbsp;минут","avia.gds.pay_ticket_number_1":"Один билет","avia.gds.pay_ticket_number_2":"%number% билета","avia.gds.pay_ticket_number_3":"%number% билетов","avia.gds.price_ticket_number_1":"Стоимость одного билета","avia.gds.price_ticket_number_2":"Стоимость двух билетов","avia.gds.price_ticket_number_3":"Стоимость %number% билетов","avia.gds.pay_ticket_amount":"на сумму %amount% руб. %change%","avia.gds.pay_total":"Сумма к оплате: %amount% руб.","avia.gds.pay_method_card":"банковской картой в офисе","avia.gds.pay_method_cardonline":"банковской картой онлайн","avia.gds.pay_method_cash":"наличными курьеру","avia.gds.pay_method_webmoney":"Webmoney","avia.gds.pay_method_yandex":"Яндекс.Деньгами","avia.gds.pay_method_":"Неизвестный метод","avia.gds.payment_type":"Способы оплаты","avia.gds.payment_method_cardonline":"Банковской картой","avia.gds.payment_method_yandex":"Яндекс Деньгами","avia.gds.payment_method_qiwi":"В терминалах Qiwi","avia.gds.payment_method_cash":"Наличными в офисе","avia.gds.payment_method_cash_curier":"Наличными курьеру","avia.gds.class_of_service_":"Любой класс обслуживания","avia.gds.class_of_service_U":"Любой класс обслуживания","avia.gds.class_of_service_none":"Любой класс обслуживания","avia.gds.class_of_service_na":"Любой класс обслуживания","avia.gds.class_of_service_Y":"Экономический класс","avia.gds.class_of_service_F":"Первый класс","avia.gds.class_of_service_C":"Бизнес класс","avia.gds.data_need_refresh":"Данные по перелетам устарели. Нажмите кнопку &laquo;Обновить данные&raquo;, чтобы получить новые данные","avia.gds.data_need_refresh_button":"Обновить данные","avia.gds.flight_railway":"В стоимость перелета включен трансфер на поезде от вокзала до аэропорта","avia.gds.best_prices_for_today":"Лучшие цены на %today%","avia.gds.best_prices":"Лучшие цены","avia.gds.best_prices_coming":"Цены на ближайшие дни","avia.gds.loading_pay_online":"Перенаправление на страницу оплаты","avia.gds.empty_rules":"Пожалуйста, проконсультируйтесь с нашим оператором.","avia.gds.empty_rules_tche":'Пожалуйста, уточните правила применения данного тарифа в <a href="%carrier_url%">%carrier_name%</a>.',"avia.gds.payment_method_na":"недоступно","avia.gds.pt_step1":"Tutu.ru — Авиарейсы","avia.gds.pt_step2":"Tutu.ru — Пассажиры","avia.gds.pt_step3":"Tutu.ru — Оплата","avia.gds.pt_finish":"Tutu.ru — Завершение заказа","avia.gds.pt_fares":"Tutu.ru — Описание тарифа","avia.gds.pt_bad_request":"Tutu.ru — Некорректный запрос","avia.gds.pt_pay_online":"Tutu.ru — Переход к оплате online","avia.gds.pt_specify_city":"Tutu.ru — Укажите город","avia.gds.order_number":"Заказ № <b>%locator%</b> от %date%","avia.gds.more_about_itinerary":"Подробнее про маршрутную квитанцию","avia.gds.how_to_get_a_ticket":"Как получить авиабилет","avia.gds.how_to_register":"Как пройти регистрацию в аэропорту","avia.gds.where_to_pay_and_go_sig23":'Оплата и получение билетов: <span class="red" ><b>в Москве</b></span>',"avia.gds.where_to_pay_and_go_davs":'Оплата и получение билетов: <span class="red" ><b>в Москве, Санкт-Петербурге и Новосибирске</b></span>',"avia.gds.any_carrier":"Любая авиакомпания","avia.gds.payment_location":"Город доставки/получения","avia.gds.foreign_currency_notice":"Оплата в валюте","avia.gds.lowcoster_notice":"Low-cost авиакомпания","avia.gds.wizard_offers":"Авиарейсы","avia.gds.wizard_passengers":"Пассажиры","avia.gds.wizard_payment":"Оплата","avia.gds.wizard_finish":"Финиш","avia.gds.wizard_order":"Заказ","avia.gds.yandex_division_1":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платеж (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.gds.yandex_division_2":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платежа (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.gds.yandex_division_3":"<p>По правилам работы платежных систем, разовый платеж в данной ситуации не может превышать 15&nbsp;000 рублей.</p> <p>Для оплаты заказа вам понадобится совершить %number% платежей (%pay_sequence%)</p> <p>После перехода к оплате система сама перенаправит вас на нужные страницы.</p>","avia.gds.tip_about_qiwi_payment":'<p>Выбранные билеты нужно будет оплатить в течение ограниченного времени.</p><p><a href="/2read/avia/avia_qiwi/" target="_blank">Подробнее про оплату в терминалах Qiwi</a></p>',"avia.gds.tip_price_from":"от&nbsp;","avia.gds.tip_pay_other_person_link":"Что делать если я оплачиваю билет для другого человека?","avia.gds.tip_pay_other_person_text":'Если вы оплачиваете перелет за других пассажиров своей кредитной картой, но сами не летите, вам необходимо прислать на адрес <a href="mailto:info@tutu.ru">info@tutu.ru</a> отсканированную копию кредитной карты с двух сторон (<b>оставить первые 4 и последние 4 цифры</b>) и копию первой страницы вашего паспорта.',"avia.gds.popular_section_russia":"По России","avia.gds.popular_section_europe":"В Европу","avia.gds.popular_section_happysun":"В теплые края","avia.gds.popular_lowcost_tip":"Авиабилеты low-cost авиакомпаний &mdash; отличный способ экономии: минимум затрат, никакой переплаты за&nbsp;комфорт и&nbsp;дополнительные услуги.","avia.gds.popular_title":"Популярные направления","avia.gds.popular_lowcost_title":"Популярные направления low-cost авиакомпаний","avia.gds.popular_from_mow":"Из Москвы","avia.gds.popular_ow":"В одну сторону","avia.gds.popular_ow_short":"Туда","avia.gds.popular_rt":"Туда и обратно","avia.gds.popular_good_prices":"Выгодные цены на авиабилеты","avia.gds.popular_description":"Мы выбрали для&nbsp;вас наиболее выгодные предложения <strong>на&nbsp;%time%</strong> по&nbsp;самым популярным направлениям в&nbsp;России и&nbsp;мире.","avia.gds.tip_redirect_to_payment":"После нажатия кнопки вы будете перенаправлены на страницу оплаты.","avia.gds.waitscreen_hotel_offer":"А если в %city_name% есть<br /> гостиница вашей мечты,<br /> мы найдем и ее.","avia.gds.waitpage_maybe":"На следующей странице<br /> может быть рейс вашей мечты!","avia.gds.addr_partner_address":"Адрес","avia.gds.addr_onmap":"Посмотреть на&nbsp;карте","avia.gds.or":"или","avia.gds.addr_davs_name":"ЗАО&nbsp;«Агентство &laquo;ДАВС&raquo;","avia.gds.addr_davs_KHV":"г.&nbsp;Хабаровск, Амурский&nbsp;бульвар,&nbsp;36","avia.gds.addr_davs_OVB":"г.&nbsp;Новосибирск, ул.&nbsp;Октябрьская,&nbsp;45","avia.gds.addr_davs_LED":"г.&nbsp;Санкт-Петербург, 9-я&nbsp;Линия Васильевского&nbsp;острова, д.34, Литер А, оф.101,&nbsp;212,&nbsp;233 (м.&nbsp;Василеостровская)","avia.gds.addr_davs_MSK":"г.&nbsp;Москва, ул.&nbsp;Мясницкая, дом&nbsp;32 (м.&nbsp;Тургеневская или&nbsp;Чистые&nbsp;Пруды)","avia.gds.addr_davs_MSK_or":"г.&nbsp;Москва, Ананьевский&nbsp;пер., дом&nbsp;5, корпус 9 (м.&nbsp;Сухаревская)","avia.gds.addr_davs_sig":"г.&nbsp;Москва, 1-й&nbsp;Волконский&nbsp;пер., дом&nbsp;15 (м.&nbsp;Цветной&nbsp;бульвар)","avia.gds.hide_changes_details":"Скрыть подробности о пересадке","avia.gds.change_in":"Пересадка в","avia.gds.changes_duration":"пересадки общей длительностью","avia.gds.duration":"длительностью","avia.gds.other_reises":"Все рейсы по этой цене:","avia.gds.payment_canceled":"Платеж успешно отменен.","avia.gds.several_airlines":"Несколько авиакомпаний","avia.gds.on_next_day":"На следующий день","avia.gds.with_changes_1":"с одной пересадкой","avia.gds.with_changes_2":"с двумя пересадками","avia.gds.with_changes_3":"с тремя пересадками","avia.gds.with_changes_4":"с четырьмя пересадками","avia.gds.checkout":"Оформление билета","avia.gds.back":"Обратно","avia.gds.flight_carrier":"Перелёт осуществляет авиакомпания","avia.gds.flight_carriers":"Перелёт осуществляют авиакомпании","avia.gds.pay_method_cash_curier_title":"Адрес доставки курьером","avia.gds.pay_method_cash_want_office":"Хочу получить и оплатить билеты в офисе города","avia.gds.pay_method_cash_select_city":"Город доставки","avia.gds.pay_method_cash_address":"Улица, дом, квартира или офис","avia.gds.pay_method_cash_office_address":"Адрес офиса","avia.gds.pay_method_cash_comment":"комментарий к заказу","avia.gds.pay_method_cash_only_cities":"Офисы расположены на&nbsp;территории\n\t\t\t\t\t\t\t\t\t\t\tРоссии в&nbsp;<strong>Москве, Санкт-Петербурге и&nbsp;Новосибирске</strong>.","avia.gds.pay_method_cash_only_cities2":"Офисы расположены на&nbsp;территории России в&nbsp;<strong>Москве</strong>.","avia.gds.pay_method_cash_cities_list":"Курьеры работают только \n\t\t\t\t\t\t\t\t\t\t\tв России на территории <strong>Москвы, Санкт-Петербурга и Новосибирска</strong>.","avia.gds.pay_method_cash_cities_msk":"Курьеры работают только \n\t\t\t\t\t\t\t\t\t\t\tв России на территории <strong>Москвы</strong>. ","avia.gds.pay_method_cash_cities_list_davsx":"Курьерская доставка возможна только по <strong>Москве, Санкт-Петербургу и Новосибирску</strong>.","avia.gds.pay_method_cash_cities_msk_sig23":"Доставка только в офисы в пределах <strong>Москвы</strong>. ","avia.gds.pay_method_terminal_your_phone":"Ваш номер телефона","avia.gds.pay_method_terminal_phone":"Номер мобильного телефона нужен, чтобы идентифицировать ваш заказ для&nbsp;оплаты через терминал.","avia.gds.pay_method_terminal_time":"У вас будет 10&nbsp;часов для&nbsp;оплаты.<br />  По истечении этого времени бронь с&nbsp;билетов снимется. ","avia.gds.pay_with_cardonline":"Оплатить заказ картой","avia.gds.pay_with_yandex":"Оплатить Яндекс.Деньгами","avia.gds.pay_with_qiwi":"Оплатить в терминале Qiwi","avia.gds.pay_with_cash":"Оплатить в офисе","avia.gds.pay_with_cash_curier":"Заказать доставку курьером","avia.gds.order_error_flight_not_confirmed":"Рейс недоступен","avia.gds.order_error_flight_not_confirmed_info":'<b>Тариф не подтвержден авиакомпанией.</b><br />К сожалению, мест по этому тарифу уже нет. <br /><a href="%url%">Попробуйте вернуться к поиску</a>',"avia.gds.order_error_validator_info":"Данные введены с ошибкой. Проверьте ","avia.gds.order_error_validator_contact_phone":"телефон для связи","avia.gds.order_error_validator_contact_email":"электронную почту","avia.gds.order_error_validator_doc_info":"номер документа","avia.gds.order_error_no_seats":"Нет мест","avia.gds.order_error_no_seats_info":'<b>Нет мест на рейс.</b><br />А также на часть других рейсов.<br />Вы можете выбрать рейсы в другое время, <br />места на которые еще есть.<br /><br /><a href="%url%">Посмотреть другие рейсы</a>',"avia.gds.order_price_increased_info":"<b>Стоимость перелета увеличилась на %new_price% руб.</b><br />Тарифы авиакомпаний могут варьироваться в зависимости от многих факторов, например, от времени оставшегося до рейса или кол-ва оставшихся мест.","avia.gds.order_price_decreased_info":"<b>Стоимость перелета уменьшилась на %new_price% руб.</b><br />Тарифы авиакомпаний могут варьироваться в зависимости от многих факторов, например, от времени оставшегося до рейса или кол-ва оставшихся мест.","avia.gds.need_additional_payment":"Внесите, пожалуйста, дополнительный платеж","avia.gds.need_payment":"Оплатите, пожалуйста, ваши авиабилеты","avia.gds.already_paid":"Вы внесли","avia.gds.additional_payment_sum":"Доплата","avia.gds.tickets_confirmed":"Авиакомпания подтвердила бронирование авиабилетов по уточненной стоимости","avia.gds.please_make_payment":"Пожалуйста, доплатите","avia.gds.galileo_support_tel":"+7 (495) 987-21-05","avia.gds.supprot_phone_davs":'<span class="order-addr">Телефоны операторов <span class="nowrap">(495) 287-99-09</span> (Москва),</span> <span class="order-addr"><span class="nowrap">8-800-700-99-09</span> (регионы)</span>',"avia.gds.supprot_phone_davsx":'<span class="order-addr">Телефоны операторов <span class="nowrap">(495) 287-99-09</span> (Москва),</span> <span class="order-addr"><span class="nowrap">8-800-700-99-09</span> (регионы)</span>',"avia.gds.supprot_phone_sig23":'<span class="order-addr">Телефон оператора <span class="nowrap">(495) 921-01-17</span></span>',"avia.gds.supprot_phone_galileo":'<span class="order-addr">Телефон оператора <span class="nowrap">(495) 921-01-17</span></span>',"avia.gds.supprot_phone_europe":'<span class="order-addr">Телефон оператора <span class="nowrap">(495) 795-09-60</span>. Страница авиакомпании: %carrier%</span>',"avia.charter.contact_name":"ФИО","avia.charter.contact_email":"Электронная почта","avia.charter.contact_phone":"Телефоны для связи","avia.charter.contact_phone2":"","avia.charter.descr":"Пожелания к заказу","avia.charter.passenger_sname":"Фамилия","avia.charter.passenger_fname":"Имя","avia.charter.passenger_document_number":"№ документа","avia.charter.error_not_empty":'Заполните поле "%fieldName%" для %number%-го пассажира.',"avia.charter.error_latin":'Пожалуйста, используйте только буквы латинского алфавита для заполнения поля "%fieldName%" для %number%-го пассажира.',"avia.charter.error_latin2":"Пожалуйста, используйте только буквы латинского алфавита","avia.charter.error_foreign_passport":'Неверно заполнен номер документа в поле "%fieldName%" для %number%-го пассажира.',"avia.charter.about_price":"Цены указаны за перелет туда и обратно.","avia.charter.about_charter":'\n\t\t<div class="logic-block">\n\t\t\t<p>\n\t\t\t\tЧартерные рейсы — нерегулярные рейсы авиакомпаний, выполняемые для определенного заказчика (например, для турфирмы).\n\t\t\t\tЧартеры летают вне штатного расписания авиарейсов, по специально утвержденному графику.\n\t\t\t</p>\n\t\t\t<p>\n\t\t\t\tСтоимость чартерных авиабилетов и расписание обновляются регулярно. Информация о ценах на чартеры,\n\t\t\t\tвремя вылета и прилета верны на момент публикации.\n\t\t\t</p>\n\t\t</div>\n\t\t<div class="logic-block">\n\t\t\t<p><h3>Плюсы чартерных рейсов</h3></p>\n\t\t\t<p><ul><li>Низкая цена билета на чартерный рейс.</li></ul></p>\n\t\t\t<p>\n\t\t\t\tСтоимость чартерных авиабилетов, как правило, намного меньше, чем на обычные (регулярные) рейсы.\n\t\t\t\tЭто вызвано тем, что авиакомпания распродает все билеты на рейс сразу и без остатка.\n\t\t\t</p>\n\t\t\t<p><ul><li>Экономия времени</li></ul></p>\n\t\t\t<p>\n\t\t\t\tЧартерные рейсы обслуживают такие направления, куда на регулярных без пересадки не доберешься.\n\t\t\t\tК тому же, на ряд популярных «отпускных» направлений регулярных рейсов вовсе нет, как следствие, нет и авиабилетов.\n\t\t\t\tВ данной ситуации заказ чартера может быть единственным выходом.\n\t\t\t</p>\n\t\t</div>\n\t\t<div class="logic-block">\n\t\t\t<p><h3>Минусы чартерных рейсов</h3></p>\n\t\t\t<p>\n\t\t\t\tОсновным недостатком являются частые изменения в расписании чартерных рейсов.\n\t\t\t\tВремя вылета и прилета чартеров может меняться, сами рейсы могут задерживаться.\n\t\t\t\tЭто может быть критично для стыковочных маршрутов, когда особенно важно успеть в транзитный аэропорт вовремя.\n\t\t\t</p>\n\t\t</div>\n\t\t<div class="logic-block">\n\t\t\t<p><h3>В отстой!</h3></p>\n\t\t\t<p>\n\t\t\t\tОтдельным видом чартеров являются рейсы «отстойные». После прибытия такого рейса в пункт назначения ваш самолет\n\t\t\t\tбудет ждать вас  в аэропорту весь период отдыха. Чаще всего такие чартерные рейсы организуются в праздничные дни\n\t\t\t\tи предназначены для участников краткосрочных туров.\n\t\t\t</p>\n\t\t</div>\n\t',"avia.charter.special_offer":"Специальное предложение — выгодная цена!","avia.charter.special_offer2":"Специальное предложение&nbsp;—<br />выгодная цена!","avia.charter.reis":"Чартерный рейс","avia.charter.forward_and_back":"Москва → %city% и обратно","avia.charter.forward_date":"Дата вылета","avia.charter.back_date":"Возможные даты возврата","avia.charter.without_back_date":"Без обратного рейса","avia.charter.choose_back_date":"Выберите дату возврата для заказа билетов!","avia.charter.order_ticket":"Заказать<br />билеты","avia.charter.order_ticket2":"Заказать билеты","avia.charter.no_reises":"По выбранному направлению не найдено ни одного рейса","avia.charter.go_to_schedule":"Посмотреть расписание всех рейсов","avia.charter.go_to_order":"Перейти к заказу чартера в %city%","avia.charter.forward":"Вылет","avia.charter.back":"Возврат","avia.charter.about_local_time":"В расписании указано <i>местное время</i>.","avia.charter.can_not_buy_ticket":"Продажа билетов<br />на этот рейс закрыта.<br /><br />По ссылке вы узнаете<br />детали перелета<br />в выбранные дни.","avia.charter.charter":"Чартер","avia.charter.charters":"Чартеры","avia.charter.in_way":"в пути","avia.charter.about_price_by_curier":"Стоимость одного билета «%direction%»: от <b>%price%</b> наличными курьеру или в офисе агентства","avia.charter.two_way":"туда — обратно","avia.charter.one_way":"туда","avia.charter.about_price_change":"\n\t\tОбратите внимание, что цены на чартерные авиарейсы могут измениться.\n\t\tНаш оператор обязательно позвонит вам и сообщит самую оперативную\n\t\tинформацию о ценах и наличии мест.\n\t","avia.charter.passengers":"Пассажиров","avia.charter.confirm_pasengers":"Подтвердить выбор пассажиров","avia.charter.agreement":"Я согласен с <span>правилами использования сервиса</span>","avia.charter.adult_ticket":"Взрослый билет","avia.charter.foreign_passport":"Заграничный паспорт","avia.charter.valid_till":"Действует до","avia.charter.order_number":"Заказ № <b>%number%</b> от %date%","avia.charter.get_ticket":'Оплата и получение билетов на чартер: <b class="red"><u>в Москве</u></b>',"avia.charter.about_operator_work":"Наши операторы свяжутся с вами в ближайшее время для подтверждения заказа и уточнения деталей оформления.","avia.charter.about_operator_schedule":"Операторы работают с понедельника по пятницу, с 10 до 19 часов. Заявки на сайте принимаются круглосуточно.","avia.charter.office_address":"Адрес офиса  по оформлению чартерных авиабилетов (Хорошевское шоссе, дом 32а)","avia.charter.about_order_status":"Для уточнения состояния заказа вы можете позвонить по телефону <nobr>+7 (495) 788-53-83 (наш партнер, компания «Билет-он-лайн»).</nobr>","avia.charter.index_meta_title":"Чартерные рейсы, расписание. Цены на чартерные авиабилеты, заказ и бронирование билетов онлайн.","avia.charter.order_ticket_from_to":"Заказ чартерных авиабилетов Москва - %city%","avia.charter.schedule_from_to":"Расписание чартеров Москва - %city%","railway.hour":"час","railway.hour2":"часа","railway.hour3":"часов","railway.minute":"минута","railway.minute2":"минуты","railway.minute3":"минут","railway.second":"секунда","railway.second2":"секунды","railway.second3":"секунд","numbers.1-m-1":"один одного одному одного одним одном","numbers.1-m-2":"один одного одному один одним одном","numbers.1-d":"одно одного одному одно одним одном","numbers.1-f":"одна одной одной одну одной одной","numbers.2-m-1":"два двух двум двух двумя двух","numbers.2-m-2":"два двух двум два двумя двух","numbers.2-d":"два двух двум два двумя двух","numbers.2-f":"две двух двум двух двумя двух","numbers.3-m-1":"три трех трем трех тремя трех","numbers.3-m-2":"три трех трем три тремя трех","numbers.3-d":"три трех трем три тремя трех","numbers.3-f":"три трех трем трех тремя трех","numbers.4-m-1":"четыре четырех четырем четырех четырьмя четырех","numbers.4-m-2":"четыре четырех четырем четыре четырьмя четырех","numbers.4-d":"четыре четырех четырем четыре четырьмя четырех","numbers.4-f":"четыре четырех четырем четырех четырьмя четырех","numbers.5":"пять пяти пяти пять пятью пяти","numbers.6":"шесть шести шести шесть шестью шести","numbers.7":"семь семи семи семь семью семи","numbers.8":"восемь восьми восьми восемь восемью восьми","numbers.9":"девять девяти девяти девять девятью девяти","numbers.10":"деcять деcяти деcяти деcять деcятью деcяти","airport.meta_title":"Аэропорты%country%%airports%","airport.title_small":"аэропорты","airport.gus":"СНГ","airport.world":"Все страны","airport.title":"Аэропорты%country%","airport.item_meta_title":"Аэропорт %airportTitle%: расписание рейсов, прилет, вылет, табло %airportTitleWithCity%, расписание авиарейсов, телефоны справочной службы","airport.item_title":"Аэропорт","airport.common":"Общая информация","airport.logo_title":"Логотип: %airportTitle%","airport.comment_meta_title":"Аэропорт %airportTitle%: %commentTitle%","airport.comment_page_title":"Аэропорт %airportTitle% — %commentTitle%","airport.name_rus":"Название рус","airport.name_eng":"Название англ","airport.city":"Город","airport.airport":"Аэропорт","airport.iata":"IATA","airport.iata_rus":"IATA рус","airport.icao":"ICAO","airport.icao_rus":"ICAO рус","airport.url":"URL","airport.online_table_departure":"Online табло вылета","airport.online_table_arrival":"Online табло прилета","airport.additional":"Дополнительно","airport.reference_services":"Справочные службы","airport.":"","plane.meta_title":"Самолеты%country%","plane.title_small":"самолеты","plane.title":"Самолет","plane.item_meta_title":"Самолет %planeTitleRus%: технические характеристики, схема самолета, фотографии, описание самолета %planeTitleRus%, %planeTitleRus%, %planeTitleEng%","plane.item_schema_meta_title":"Самолет %planeTitleRus%: Схема самолета, расположение мест в салоне самолета %planeTitleRus%","plane.item_foto_meta_title":"Самолет %planeTitleRus%: Фото","plane.common":"Общая информация","plane.price_unknown":"Нет данных","plane.logo_title":"Логотип: %planeTitleRus%","plane.scheme_title":"схема самолета %planeTitleRus%, расположение мест в салоне","plane.foto_title":"Cамолет %planeTitleRus% (%planeTitleEng%)","plane.name_rus":"Название рус","plane.name_eng":"Название англ","plane.iata":"IATA","plane.icao":"ICAO","plane.productor":"Производитель","plane.country":"Страна","plane.category":"Категория","plane.additional":"Дополнительно","plane.synonyms":"Варианты написания (синонимы)","plane.engine":"Двигатели","plane.dimensions":"Размеры","plane.seats":"Число мест","plane.weights_loads":"Массы и нагрузки","plane.flight_data":"Летные данные","plane.price":"Цена","plane.civil":"Гражданский","plane.passanger":"Пассажирский","plane.regional":"Региональный","plane.middle":"Среднемагистральный","plane.long":"Дальнемагистральный","plane.cargo":"Грузовой","plane.business_avia":"Деловая авиация","plane.special_avia":"Спецназначения","plane.military":"Военный","plane.battle":"Боевой","plane.training":"Учебный","plane.transport":"Транспортный","plane.fuel":"Заправщик","plane.":""};
RM.StaticData.urlLabels={main:["/","/index.php",null,"http"],"static":["/","/index.php",null,"current"],"404":["/404/","/404.php"],cookie:["/cookie/","/cookie.php"],geoip:["/geoip/","/geoip.php"],referrer:["/referrer/","/referrer/track.php"],"referrer.sub":["/referer/$host/","/referrer/host.php?host=$host"],file:["/file/$id/","/file.php?mode=file&id=$id"],file_md5:["/file_secure/$md5id/","/file.php?mode=file&md5id=$md5id"],"file.mime":["/mimeimage/$id/","/file/php?mode=mime&id=$id"],"file.source":["/file/$fid/$file/","/file.php?mode=file&fid=$fid&file=$file"],"file.secure.source":["/file/$fid/$file/","/file.php?mode=file&fid=$fid&file=$file",null,"https"],sitemap:["/sitemap/","/sitemap.php",null,"http"],vacancy:["http://tutu.ru/2read/catalog/vacancy/item/vacancy/"],browser_upgrade:["/browser_upgrade/","/browser_upgrade.php",null,"http"],"tutu.gate":["/gate/","/gate.php"],"train.gate":["/train/gate/","/train/gate.php"],main_news:["/news/","/news/main_news.php",null,"http"],mobile:["/mobile/","/mobile/index.php",null,"http"],sapsan:["/poezda/sapsan/","/train/sapsan.php",null,"http"],shema_vagonov:["/poezda/sapsan/shema_vagonov/","/train/shema_vagonov.php",null,"http"],advert:["/advert/index.php"],"advert.clients":["/advert/clients.php"],"advert.requirement":["/advert/requirement.php"],"advert.presentation":["/advert/tutu_ru_presentation.ppt"],"advert.price":["/advert/2010_tutu_ru_advert_price.xls"],"advert.468_60_m":["http://ad4.tutu.ru/468_60_m.php"],"advert.250_90_m":["http://ad4.tutu.ru/250_90_m.php"],"advert.253_90_m":["http://ad4.tutu.ru/253_90_m.php"],"advert.758_90_1_m":["http://ad4.tutu.ru/758_90_1_m.php"],"advert.758_90.train":["http://ad4.tutu.ru/poezda/758_90_1.php"],"advert.758_90.avia":["http://ad4.tutu.ru/avia/758_90_1.php"],"advert.758_90.avia.synchron":["http://ad4.tutu.ru/avia/758_90_1.php?p=synchron"],"advert.1024x60":["http://ad4.tutu.ru/prigorod/1024_60.php"],"advert.1024x60.synchron":["http://ad4.tutu.ru/prigorod/1024_60.php?p=synchron"],"advert.1024_60.main":["http://ad4.tutu.ru/mainpage/1024_60.php"],"advert.1024_60.avia":["http://ad4.tutu.ru/avia/1024_60.php"],"advert.1024_60.hotel":["http://ad4.tutu.ru/hotels/1024_60.php"],"advert.1024_60.train":["http://ad4.tutu.ru/poezda/1024_60.php"],"advert.1024x60.iphone":["http://ad4.tutu.ru/1024_60_iphone.php"],"advert.1024_60.iphone":["http://ad4.tutu.ru/1024_60_iphone.php"],"advert.240_400_m":["http://ad4.tutu.ru/240_400_m.php"],"advert.240_400.train":["http://ad4.tutu.ru/poezda/240_400.php"],"advert.240_400.avia":["http://ad4.tutu.ru/avia/240_400.php"],"advert.240_400.avia.synchron":["http://ad4.tutu.ru/avia/240_400.php?p=synchron"],"advert.240_400.2read":["http://ad4.tutu.ru/2read/240_400.php"],"advert.240_45":["http://ad4.tutu.ru/prigorod/240_45.php"],"advert.200x300.synchron":["http://ad4.tutu.ru/prigorod/200_300.php"],"advert.200x300.poezda":["http://ad4.tutu.ru/prigorod/200_300.php"],"advert.200_300_m":["http://ad4.tutu.ru/200_300_m.php"],"advert.200_300.train":["http://ad4.tutu.ru/poezda/200_300.php"],"advert.200_300.avia":["http://ad4.tutu.ru/avia/200_300.php"],"advert.200_300.avia.synchron":["http://ad4.tutu.ru/avia/200_300.php?p=synchron"],"advert.200_300.2read":["http://ad4.tutu.ru/2read/200_300.php"],"advert.252_90_left.avia":["http://ad4.tutu.ru/avia/252_90_left.php"],"advert.252_90_right.avia":["http://ad4.tutu.ru/avia/252_90_right.php"],"advert.252_90_left.hotel":["http://ad4.tutu.ru/hotels/252_90_left.php"],"advert.252_90_right.hotel":["http://ad4.tutu.ru/hotels/252_90_right.php"],"advert.252_90_left.train":["http://ad4.tutu.ru/poezda/252_90_left.php"],"advert.252_90_right.train":["http://ad4.tutu.ru/poezda/252_90_right.php"],"advert.252_90_left.main":["http://ad4.tutu.ru/mainpage/252_90_left.php"],"advert.252_90_right.main":["http://ad4.tutu.ru/mainpage/252_90_right.php"],"advert.252_90_center.avia":["http://ad4.tutu.ru/avia/252_90_center.php"],"advert.252_90_center.hotel":["http://ad4.tutu.ru/hotels/252_90_center.php"],"advert.252_90_center.train":["http://ad4.tutu.ru/poezda/252_90_center.php"],"advert.252_90_center.main":["http://ad4.tutu.ru/mainpage/252_90_center.php"],"advert.nokia_ovi_maps":["http://ad-emea.doubleclick.net/clk;237719055;61064756;n"],"advert.150_180_m":["http://ad4.tutu.ru/mainpage/150_180.php"],"advert.tonkosti_moscow":["http://tonkosti.ru/%D0%A0%D0%BE%D1%81%D1%81%D0%B8%D1%8F"],"advert.fenistil":["/summer2012/","/advert/fenistil.php"],"advert.1024_60_lp.main":["http://ad4.tutu.ru/poezda/mini/main.php"],"advert.1024_60_lp.ukr":["http://ad4.tutu.ru/poezda/mini/ukr.php"],"advert.1024_60_lp.ural":["http://ad4.tutu.ru/poezda/mini/ural.php"],avia:["/","/avia/index.php?setMenu=avia_index","avia","http"],"avia.main":["/","","avia"],"avia.agapi":["/agapi/","/avia/agapi.php","avia","http"],"avia.gate":["/gate/","/avia/gate.php","avia","http"],"avia.avi.pnr":["/aVi26/pnr/$id/$action/","/avia/online/aVi/pnr.php?id=$id&action=$action","avia","http"],"avia.avi.flight":["/aVi26/flight/$sid/$id/","/avia/online/aVi/flight.php?sid=$sid&id=$id","avia","http"],"avia.order":["/ws/","/avia/online/waitscreen.php","avia"],"avia.order.results":["/offers/","/avia/online/offers.php","avia"],"avia.order.pay":["/online/pay/$locator/","/avia/online/pay.php?locator=$locator","avia"],"avia.wizard.step":["/online/$step_id/","/avia/online/index.php?step_id=$step_id","avia","http"],"avia.wizard.step.https":["/avia/online/$step_id/","/avia/online/index.php?step_id=$step_id",null,"https"],"avia.wizard":["/online/","/avia/online/index.php","avia"],"avia.order.basket":["/basket/","/ajax/index.php?Action=avia_basket","avia"],"avia.order.bestprices":["/best_prices/","/ajax/index.php?Action=avia_best_prices","avia"],"avia.finish":["/finish/","/avia/online/finish.php?hash=$hash","avia"],"avia.order.print":["/print/$hash/","/avia/online/print.php?hash=$hash","avia"],"avia.fare_rules":["/fares/$id/","/avia/online/fares.php?id=$id","avia","http"],"avia.pnr_fare_rules":["/pnrfares/$id/","/avia/online/pnrfares.php?id=$id","avia","http"],"avia.schedule":["/flights/","/avia/flights.php?setMenu=schedule","avia"],"avia.query":["/query/","/avia/search_query.php","avia"],"avia.popular.section":["/popularsection/","/ajax/index.php?Action=avia_popularsection","avia"],"avia.seoexport":["/4UxfGA43DoBm.xml","/avia/seoexport.php","avia"],"avia.city.suggest":["/avia/city/suggest/","/ajax/index.php?Action=avia_city_suggest","avia","current"],"avia.additional_payment":["/avia/online/pay/additional/$id/$pid/$hash/","/avia/online/additional_payment.php?id=$id&pid=$pid&hash=$hash",null,"https"],"payment.creaditcard":["/creditcard/$hash/","","payment","https"],"payment.qiwi":["/qiwi/$hash/","","payment","https"],"payment.invoice.register":["/invoice/register/","","payment","https"],"payment.invoice.get":["/invoice/get/","","payment","https"],"payment.invoice.proceed":["/invoice/proceed/","","payment","https"],"paymentgate.notify":["/paymentgate/notify/$engine/","/paymentgate/notify.php?engine=$engine",null,"https"],"paymentgate.check":["/paymentgate/check/$engine/","/paymentgate/notify.php?engine=$engine&notifyType=check",null,"https"],"paymentgate.notify.withname":["/paymentgate/notify/$engine/index.php","/paymentgate/notify.php?engine=$engine",null,"https"],"paymentgate.check.withname":["/paymentgate/check/$engine/index.php","/paymentgate/notify.php?engine=$engine&notifyType=check",null,"https"],"avia.plane":["/plane/","/avia/productor/index.php","avia"],"avia.plane.item":["/plane/$hash/","/avia/plane/item.php?hash=$hash","avia"],"avia.plane.country":["/country/$hash/","/avia/productor/index.php?country_hash=$hash","avia"],"avia.plane.country2":["/planes/country/$countryId/","/avia/productor/index.php?country_id=$countryId","avia"],"avia.productor.item":["/productor/$hash/","/avia/productor/item.php?setMenu=productor&hash=$hash","avia"],"avia.carriers_gus_old":["/carriers/gus/","/301.php?url_label=avia.carriers_gus","avia"],"avia.carriers_gus":["/airline/gus/","/avia/carrier/index.php?gus=1","avia"],"avia.carriers_world_old":["/carriers/world/","/301.php?url_label=avia.carriers_world","avia"],"avia.carriers_world":["/airline/world/","/avia/carrier/index.php?all=1","avia"],"avia.carriers_by_country_old2":["/airline/item/$id/","/avia/carrier/carriers.php?country_id=$id","avia"],"avia.carriers_by_country_old":["/carriers/country/$id/","/avia/carrier/carriers.php?country_id=$id","avia"],"avia.carriers_by_country_hash":["/airlines/$alias/","/avia/carrier/carriers.php?countryAlias=$alias","avia"],"avia.carrier.item":["/airline/$alias/","/avia/carrier/item.php?alias=$alias","avia"],"avia.carriers":["/airline/","/avia/carrier/carriers.php?countryAlias=rossiya","avia"],"avia.airport":["/airport/","/avia/airport/index.php","avia"],"avia.airport.sheremetyevo":["/airport/0eadeb/","/avia/airport/item.php?hash=0eadeb","avia"],"avia.airport.sheremetyevo.scheme":["/details/19d2aa/","/avia/details.php?hash=19d2aa","avia"],"avia.airport.sheremetyevo.contacts":["/details/f345c4/","/avia/details.php?hash=f345c4","avia"],"avia.airport.sheremetyevo.table_arrival":["/airport/0eadeb/timetable/arrival/","/avia/airport/timetable.php?hash=0eadeb&type=arrival","avia"],"avia.airport.sheremetyevo.table_departure":["/airport/0eadeb/timetable/departure/","/avia/airport/timetable.php?hash=0eadeb&type=departure","avia"],"avia.airport.sheremetyevo2":["/airport/1aa20f/","/301.php?url_label=avia.airport.sheremetyevo","avia"],"avia.airport.sheremetyevo2.scheme":["/details/d37dc7/","/301.php?url_label=avia.airport.sheremetyevo.scheme","avia"],"avia.airport.sheremetyevo2.contacts":["/details/44bc61/","/301.php?url_label=avia.airport.sheremetyevo.contacts","avia"],"avia.airport.sheremetyevo2.table_arrival":["/airport/1aa20f/timetable/arrival/","/301.php?url_label=avia.airport.sheremetyevo.table_arrival","avia"],"avia.airport.sheremetyevo2.table_departure":["/airport/1aa20f/timetable/departure/","/301.php?url_label=avia.airport.sheremetyevo.table_departure","avia"],"avia.airport.item":["/airport/$hash/","/avia/airport/item.php?hash=$hash","avia"],"avia.airport.country.gus":["/airport/country/gus/","/avia/airport/index.php?region=gus","avia"],"avia.airport.country.world":["/airport/country/world/","/avia/airport/index.php?region=world","avia"],"avia.airport.country_hash":["/airport/country/$hash/","/avia/airport/index.php?country_hash=$hash","avia"],"avia.airport.country2":["/airports/country/$countryId/","/avia/airport/index.php?country_id=$countryId","avia"],"avia.airport.country":["/airports/$alias/","/avia/airport/index.php?country_alias=$alias","avia"],"avia.airport.timetable":["/airport/$hash/timetable/$type/","/avia/airport/timetable.php?hash=$hash&type=$type","avia"],"avia.details":["/details/$hash/","/avia/details.php?hash=$hash","avia"],"avia.ticket":["/aviabilety/","/avia/ticket/index.php","avia"],"avia.ticket.city.flightslist":["/aviabilety/flightslist/","/ajax/index.php?Action=ticket_flights_list","avia"],"avia.ticket.nav_block":["/aviabilety/nav_block/","/ajax/index.php?Action=avia_nav_block","avia"],"avia.ticket.nav_block_citylist":["/aviabilety/nav_block_citylist/","/ajax/index.php?Action=avia_nav_block_citylist","avia"],"avia.ticket.letter":["/aviabilety/?letter=$letter","/avia/ticket/index.php?letter=$letter","avia"],"avia.ticket.longlist":["/aviabilety/$alias/longlist/$charcode/","/avia/ticket/longlist.php?countryAlias=$alias&char=$charcode","avia"],"avia.ticket.country":["/aviabilety/$alias/","/avia/ticket/country.php?countryAlias=$alias","avia"],"avia.ticket.city":["/aviabilety/$country_alias/$city_alias/","/avia/ticket/city.php?countryAlias=$country_alias&cityAlias=$city_alias","avia"],metro:["/metro/","/metro/index.php",null,"http"],"metro.main":["/metro/","",null,"http"],"metro.by_region":["/metro/#$region","/metro/#$region"],"metro.by_city":["/metro/item/$hash/","/metro/item.php?hash=$hash"],"metro.moscow_wrong":["/metro/msk/","/301.php?url_label=metro.moscow"],"metro.by_alias":["/metro/$alias/","/metro/item.php?alias=$alias"],"metro.show":["/metro/show/view_$id/$schema/","/metro/show.php?schema=$schema&id=$id"],"metro.moscow":["/metro/msk/map.php","/metro/msk/map.php"],"metro.msk":["/metro/moscow/",""],"metro.spb":["/metro/spb/",""],"main.google_map":["/google_map.txt","/sitemap/google_map.txt","avia"],"main.google_to_1":["/google_to_1.txt","/sitemap/google_to_1.txt","avia"],"main.google_to_2":["/google_to_2.txt","/sitemap/google_to_2.txt","avia"],"main.google_to_3":["/google_to_3.txt","/sitemap/google_to_3.txt","avia"],"main.google_from_1":["/google_from_1.txt","/sitemap/google_from_1.txt","avia"],"main.google_from_2":["/google_from_2.txt","/sitemap/google_from_2.txt","avia"],"main.google_from_3":["/google_from_3.txt","/sitemap/google_from_3.txt","avia"],train:["/poezda/","/train/index.php",null,"http"],"train.main":["/poezda/","",null,"http"],"train.export":["/poezda/","/train/index.php?export","frame"],"train.sapsan":["/poezda/sapsan/"],"train.order.clear":["/poezda/order/?dep_st=$departure&arr_st=$arrival&tn=$trainNumber&from=$from","/train/order/index.php"],"train.order":["/poezda/order/?dep_st=$departure&arr_st=$arrival&tn=$trainNumber&date=$date","/train/order/index.php"],"train.order_no_param":["/poezda/order/","/train/order/index.php"],"train.order_changed":["/poezda/order/?dep_st=$departure&arr_st=$arrival&tn=$trainNumber&date=$date&changed=1","/train/order/index.php"],"train.digit_order":["/poezda/e-zakaz/","/train/seo_index.php?ticket_type=digit"],"train.blank_order":["/poezda/zakaz/","/train/seo_index.php?ticket_type=blank"],"train.oferta":["/poezda/oferta.html","/train/oferta.php"],"train.order.success_old":["/poezda/order/successed/$orderHash/","/train/order/message/success.php?order_hash=$orderHash",null,"http"],"train.order.success":["/poezda/order/successed/?order_hash=$orderHash","/train/order/message/success.php",null,"https"],"train.order.unsuccess":["/poezda/order/unsuccess/?order_hash=$orderHash","/train/order/message/unsuccess.php",null,"https"],"train.order.blank":["/poezda/order/blank/?order_hash=$orderHash","/train/order/message/show_blank.php?order_hash=$orderHash",null,"https"],"train.order.ereg":["/poezda/order/ereg/$orderHash/","/train/order/eregistration.php?order_hash=$orderHash",null,"https"],"train.order.docs":["/poezda/order/docs/$orderHash/","/train/order/documents.php?order_hash=$orderHash"],"train.order.docs_travelmart":["/poezda/order/docs_request/$orderHash/","/train/order/documents_travelmart.php?order_hash=$orderHash"],"train.order.docs_paper":["/poezda/order/docs_paper/$orderHash/","/train/order/documents_send.php?order_hash=$orderHash&type=paper"],"train.order.docs_email":["/poezda/order/docs_email/$orderHash/","/train/order/documents_send.php?order_hash=$orderHash&type=email"],"train.order.docs_paper.ajax":["/ajax/order/docs_paper/","/ajax/index.php?Action=send_order_documents_paper"],"train.order.docs_email.ajax":["/ajax/order/docs_email/","/ajax/index.php?Action=send_order_documents_email"],"train.order.docs.ajax":["/ajax/order/docs/","/ajax/index.php?Action=order_documents"],"train.order.docs.get_file":["/poezda/order/getdocs/$md5id/","/train/order/get_docs.php?md5id=$md5id"],"train.order.ereg.ajax":["/ajax/order/ereg/","/ajax/index.php?Action=order_eregistration",null,"https"],"train.order.documents":["/poezda/order/documents/$orderHash/","/train/order/get_documents.php?order_hash=$orderHash",null,"https"],"train.order.failure":["/poezda/order/failed/$orderHash/$result_id/","/train/order/index.php?step_id=final&result_id=$result_id&order_hash=$orderHash"],"train.order.process":["/poezda/order/process/$action/$orderHash/$result_id/","/train/order/enterpoint.php?result_id=$result_id&order_hash=$orderHash&action=$action",null,"https"],"train.order.travelmart":["/poezda/order/travelmart/gate/$key_hash/","/train/order/travelmart.php?keyHash=$key_hash"],"train.order.ticketing":["/poezda/order/ticketing/$orderHash/","/train/order/ticketing.php?order_hash=$orderHash",null,"https"],"misc.loader":["/loader/","/train/loader.php"],"train.order.barcode":["/poezda/blank/barcode/?number=$number","/train/order/message/barcode.php?number=$number",null,"https"],"train.order.check":["/poezda/order/check/","/train/order/check.php"],"train.order.error":["/poezda/order/error/$wizard_id/$step_id/","/train/order/message/error.php?wizard_id=$wizard_id&step_id=$step_id"],"train.order.wizard.step":["/poezda/order/$step_id/","/train/order/index.php?step_id=$step_id"],"train.blank.by_number":["http://el.tutu.ru/blank.php?order_number=$orderNumber",""],"train.blank.by_transaction":["http://el.tutu.ru/blank.php?pg_transaction_id=$transactionId",""],"train.order.instructions":["/poezda/cash/instructions/","/train/show_text.php?template=instructions"],"train.order.get_documents":["http://tutu.ru/poezda/e-zakaz/get_docs.php",""],"train.order.pdf":["/files/instruction.pdf",""],"train.schedule.form":["/poezda/rasp_d.php","/train/schedule.php",null,"http"],"train.schedule.form.export":["/poezda/rasp_d.php","/train/schedule.php?export","frame","http"],"train.schedule":["/poezda/rasp_d.php?nnst1=$departure&nnst2=$arrival","/train/schedule.php",null,"http"],"train.schedule.export":["/poezda/rasp_d.php?nnst1=$departure&nnst2=$arrival","/train/schedule.php?export","frame","http"],"train.schedule.yml":["/poezda/rasp_d.php?nnst1=$departure&amp;nnst2=$arrival","/train/schedule.php",null,"http"],"train.schedule.lp":["/poezda/rasp_lp.php?nnst1=$departure&nnst2=$arrival","/train/schedule.php?lp=1",null,"http"],"train.schedule.form.lp":["/poezda/rasp_lp.php","/train/schedule.php?lp=1",null,"http"],"train.schedule.print":["/poezda/schedule/print/?nnst1=$departure&nnst2=$arrival","/train/schedule.php?printView=1",null,"http"],"train.schedule.search":["/poezda/schedule/search/?departureStation=$departure&arrivalStation=$arrival","/train/schedule/search.php"],"train.schedule.search.export":["/poezda/schedule/search/?departureStation=$departure&arrivalStation=$arrival","/train/schedule/search.php?export","frame"],"train.schedule.search_old":["/poezda/search.php","/train/schedule/search.php?oldparams=1"],"train.schedule.change.check":["/poezda/schedule/change/check/","/ajax/index.php?Action=railway_schedule_change_check",null,"http"],"train.station":["/poezda/station_d.php?nnst=$station","/train/station/trainlist.php",null,"http"],"train.station.export":["/poezda/station_d.php?nnst=$station","/train/station/trainlist.php?export","frame","http"],"train.station.form":["/poezda/station_d.php","/train/station/trainlist.php"],"train.station.form.export":["/poezda/station_d.php","/train/station/trainlist.php?export","frame"],"train.station.search":["/poezda/station/search/?station=$station","/train/station/search.php"],"train.station.search.export":["/poezda/station/search/?station=$station","/train/station/search.php?export","frame"],"train.station.map":["/poezda/station/map/$station/","/train/station/map.php?stationNumber=$station"],"train.station.form_map":["/poezda/station/map/","/train/station/map.php"],"train.station.review":["/poezda/station/review/$station/","/train/station/review.php?stationNumber=$station"],"train.station.form_review":["/poezda/station/review/","/train/station/review.php"],"train.schedule.agent":["/poezda/rasp_d.php?nnst1=$departure&nnst2=$arrival&dagent=$dagent","/train/schedule.php",null,"http"],"train.order.agent":["/poezda/order/?dep_st=$departure&arr_st=$arrival&tn=$trainNumber&date=$date&dagent=$dagent","/train/order/index.php"],"train.suggest":["/suggest/railway/","/ajax/index.php?Action=railway_station_suggest","_current_","current"],"train.suggest.by_train_number":["/suggest/railway_by_train/","/ajax/index.php?Action=railway_station_by_train_suggest","_current_","current"],"train.train_route":["/poezda/view_d.php?np=$hash","/train/train/route.php",null,"http"],"train.train_route.export":["/poezda/view_d.php?np=$hash","/train/train/route.php?export","frame","http"],"train.train_route.print":["/poezda/print/view_d.php?np=$hash","/train/train/route.php?printView=1",null,"http"],"train.train_route.print_start":["/poezda/print/view_d.php?np=$hash&needPrint=1","/train/train/route.php?printView=1&needPrint=1",null,"http"],"train.train_schedule":["/poezda/view_times.php?np=$hash","/train/train/schedule.php",null,"http"],"train.train_schedule.export":["/poezda/view_times.php?np=$hash","/train/train/schedule.php?export","frame","http"],"train.train_review":["/poezda/review/$hash/","/train/train/review.php?np=$hash",null,"http"],"train.search":["/poezda/search_train.php","/train/search.php"],"train.search.export":["/poezda/search_train.php","/train/search.php?export","frame"],"train.inquiry":["/2read/catalog/poezda_faq/","",null,"http"],"train.instruction":["/2read/catalog/poezda_faq/item/trains_instruction/","",null,"http"],"train.payment":["/2read/catalog/poezda_faq/item/trains_payment/","",null,"http"],"train.service_rules":["/2read/catalog/poezda_faq/item/trains_rules/","",null,"http"],"train.benefits":["/2read/catalog/poezda_faq/item/ebilet/","",null,"http"],"train.cheap_train":["/2read/poezda/cheap_train/","",null,"http"],"train.remind.ajax_add":["/poezda/remind/ajax-add/","/ajax/index.php?Action=train_user_remind"],"train.remind.add":["/poezda/remind/add/","/train/remind/index.php"],"train.remind.stop":["/poezda/remind/stop/?group_id=$groupId","/train/remind/stop.php"],"train.landing_page":["/poezda/mini/","/train/landing_page.php",null,"http"],"train.landing_page_ukr":["/poezda/mini_ukr/","/train/landing_page_ukr.php",null,"http"],"train.landing_page_ural":["/poezda/mini_ural/","/train/landing_page_ural.php",null,"http"],"train.landing_page_skidki":["/poezda/mini_skidki/","/train/landing_page_skidki.php",null,"http"],"train.landing_page_baltika":["/poezda/mini_baltika/","/train/landing_page_baltika.php",null,"http"],"train.scheme.msk.belorus":["/poezda/vokzal_06.php","/train/scheme.php?schemeId=01"],"train.scheme.msk.kazan":["/poezda/vokzal_02.php","/train/scheme.php?schemeId=03"],"train.scheme.msk.kiev":["/poezda/vokzal_05.php","/train/scheme.php?schemeId=04"],"train.scheme.msk.kursk":["/poezda/vokzal_04.php","/train/scheme.php?schemeId=05"],"train.scheme.msk.leningrad":["/poezda/vokzal_08.php","/train/scheme.php?schemeId=06"],"train.scheme.msk.pavel":["/poezda/vokzal_03.php","/train/scheme.php?schemeId=07"],"train.scheme.msk.pij":["/poezda/vokzal_07.php","/train/scheme.php?schemeId=08"],"train.scheme.msk.savel":["/poezda/vokzal_09.php","/train/scheme.php?schemeId=09"],"train.scheme.msk.jaroslav":["/poezda/vokzal_10.php","/train/scheme.php?schemeId=10"],"train.scheme.spb.baltisk":["/poezda/vokzal_spb_01.php","/train/scheme.php?schemeId=21"],"train.scheme.spb.vitebsk":["/poezda/vokzal_spb_02.php","/train/scheme.php?schemeId=22"],"train.scheme.spb.ladojsk":["/poezda/vokzal_spb_03.php","/train/scheme.php?schemeId=23"],"train.scheme.spb.moscovsk":["/poezda/vokzal_spb_04.php","/train/scheme.php?schemeId=24"],"train.scheme.spb.finlyandsk":["/poezda/vokzal_spb_05.php","/train/scheme.php?schemeId=25"],"train.schedule.digit.old":["/poezda/rasp_e.php?nnst1=$departure&nnst2=$arrival&date=$date","/301.php?url_label=train.schedule.form"],"train.schedule.blank.old":["/poezda/rasp_z.php?nnst1=$departure&nnst2=$arrival&date=$date","/301.php?url_label=train.schedule.form"],"train.yml_price":["/poezda/price.xml","/train/yml_price.php"],"etrain.main.export":["/prigorod/","etrain/index.php?export","frame"],prigorod:["/prigorod/","",null,"http"],"prigorod.search":["/prigorod/search.php"],surprise:["/surprise.php","/surprise.php",null,"http"],"msk.shema":["/$0.php"],"spb.shema":["/spb/$0.php"],ajax:["/ajax/","/ajax/index.php","_current_","current"],ajax2:["/ajax2/","/ajax/index.php","_current_"],"ajax.https":["/ajax/","/ajax/index.php","_current_","https"],sms_schedule:["/sms.php"],partners:["/partners.php","/partners.php",null,"http"],"partners.pages":["/pages/partners.php?category=$categoryId","/partners.php"],"partners.get_link":["/partners_get_link.php","/avia/partners_get_link.php","avia","http"],etrain:["/prigorod/","",null,"http"],"etrain.msk":["/msk/"],"etrain.spb":["/spb/"],"etrain.belgorod.sms":["http://belgorod.tutu.ru/sms.php"],"etrain.bryansk.sms":["http://bryansk.tutu.ru/sms.php"],"etrain.voronezh.sms":["http://voronezh.tutu.ru/sms.php"],"etrain.kazan.sms":["http://kazan.tutu.ru/sms.php"],"etrain.kaluga.sms":["http://kaluga.tutu.ru/sms.php"],"etrain.kursk.sms":["http://kursk.tutu.ru/sms.php"],"etrain.irkutsk.sms":["http://irkutsk.tutu.ru/sms.php"],"etrain.lipetsk.sms":["http://lipetsk.tutu.ru/sms.php"],"etrain.orel.sms":["http://orel.tutu.ru/sms.php"],"etrain.ryazan.sms":["http://ryazan.tutu.ru/sms.php"],"etrain.smolensk.sms":["http://smolensk.tutu.ru/sms.php"],"etrain.tambov.sms":["http://tambov.tutu.ru/sms.php"],"etrain.tula.sms":["http://tula.tutu.ru/sms.php"],"etrain.msk.schedule_station":["/station.php?nnst=$station","etrain/msk/station.php","_current_"],"etrain.spb.schedule_station":["/spb/station.php?nnst=$station","etrain/spb/station.php","_current_"],"etrain.irkutsk.schedule_station":["http://irkutsk.tutu.ru/station.php?nnst=$station"],"etrain.voronezh.schedule_station":["http://voronezh.tutu.ru/station.php?nnst=$station"],"etrain.kazan.schedule_station":["http://kazan.tutu.ru/station.php?nnst=$station"],"etrain.msk.smsbanner":["/etrain/banner/","etrain/banner.php"],"etrain.spb.smsbanner":["/etrain/banner/?region=spb","etrain/banner.php"],"etrain.info":["/2read/catalog/suburban_faq/item/suburban_express_cost/"],"etrain.info.sputnik":["/2read/catalog/suburban_faq/item/suburban_express_cost/#sputnik"],"etrain.info.express":["/2read/catalog/suburban_faq/item/suburban_express_cost/#express"],"etrain.info.concept":["/2read/catalog/suburban_faq/item/suburban_express_cost/#concept"],"etrain.main":["/prigorod/","etrain/index.php","_current_"],msk:["/msk/","etrain/msk/index.php","_current_"],msk2:["/00.php","etrain/msk/index.php","_current_"],"moscow.belorus":["/06.php","etrain/msk/scheme.php?id=6","_current_"],"moscow.gorkii":["/01.php","etrain/msk/scheme.php?id=1","_current_"],"moscow.kazan":["/02.php","etrain/msk/scheme.php?id=2","_current_"],"moscow.kiev":["/05.php","etrain/msk/scheme.php?id=5","_current_"],"moscow.kursk":["/04.php","etrain/msk/scheme.php?id=4","_current_"],"moscow.leningrad":["/08.php","etrain/msk/scheme.php?id=8","_current_"],"moscow.pavel":["/03.php","etrain/msk/scheme.php?id=3","_current_"],"moscow.pij":["/07.php","etrain/msk/scheme.php?id=7","_current_"],"moscow.savel":["/09.php","etrain/msk/scheme.php?id=9","_current_"],"moscow.jaroslav":["/10.php","etrain/msk/scheme.php?id=10","_current_"],"moscow.kolico":["/11.php","etrain/msk/11.php","_current_"],"msk.export":["/msk/","etrain/msk/index.php?export","frame"],"moscow.belorus.export":["/06.php","etrain/msk/scheme.php?id=6&export","frame"],"moscow.gorkii.export":["/01.php","etrain/msk/scheme.php?id=1&export","frame"],"moscow.kazan.export":["/02.php","etrain/msk/scheme.php?id=2&export","frame"],"moscow.kiev.export":["/05.php","etrain/msk/scheme.php?id=5&export","frame"],"moscow.kursk.export":["/04.php","etrain/msk/scheme.php?id=4&export","frame"],"moscow.leningrad.export":["/08.php","etrain/msk/scheme.php?id=8&export","frame"],"moscow.pavel.export":["/03.php","etrain/msk/scheme.php?id=3&export","frame"],"moscow.pij.export":["/07.php","etrain/msk/scheme.php?id=7&export","frame"],"moscow.savel.export":["/09.php","etrain/msk/scheme.php?id=9&export","frame"],"moscow.jaroslav.export":["/10.php","etrain/msk/scheme.php?id=10&export","frame"],"moscow.kolico.export":["/11.php","etrain/msk/11.php?export","frame"],spb:["/spb/","etrain/spb/index.php","_current_"],spb2:["/spb/00.php","etrain/spb/index.php","_current_"],"spb.baltisk":["/spb/01.php","etrain/spb/scheme.php?id=1","_current_"],"spb.vitebsk":["/spb/02.php","etrain/spb/scheme.php?id=2","_current_"],"spb.ladojsk":["/spb/03.php","etrain/spb/scheme.php?id=3","_current_"],"spb.moscovsk":["/spb/04.php","etrain/spb/scheme.php?id=4","_current_"],"spb.finlyandsk":["/spb/05.php","etrain/spb/scheme.php?id=5","_current_"],"spb.finlyandsk2":["/spb/06.php","etrain/spb/scheme.php?id=6","_current_"],"spb.finlyandsk3":["/spb/07.php","etrain/spb/scheme.php?id=7","_current_"],"spb.export":["/spb/","etrain/spb/index.php?export","frame"],"spb.baltisk.export":["/spb/01.php","etrain/spb/scheme.php?id=1&export","frame"],"spb.vitebsk.export":["/spb/02.php","etrain/spb/scheme.php?id=2&export","frame"],"spb.ladojsk.export":["/spb/03.php","etrain/spb/scheme.php?id=3&export","frame"],"spb.moscovsk.export":["/spb/04.php","etrain/spb/scheme.php?id=4&export","frame"],"spb.finlyandsk.export":["/spb/05.php","etrain/spb/scheme.php?id=5&export","frame"],"spb.finlyandsk2.export":["/spb/06.php","etrain/spb/scheme.php?id=6&export","frame"],"spb.finlyandsk3.export":["/spb/07.php","etrain/spb/scheme.php?id=7&export","frame"],"region.news":["http://$region.tutu.ru/news.php"],belgorod:["http://belgorod.tutu.ru/"],"belgorod.belgorod":["http://belgorod.tutu.ru/01.php"],"belgorod.valuiki":["http://belgorod.tutu.ru/02.php"],bryansk:["http://bryansk.tutu.ru/"],"bryansk.fayansk":["http://bryansk.tutu.ru/01.php"],"bryansk.orel":["http://bryansk.tutu.ru/02.php"],"bryansk.suzemk":["http://bryansk.tutu.ru/03.php"],voronezh:["http://voronezh.tutu.ru/"],"voronezh.liski":["http://voronezh.tutu.ru/01.php"],"voronezh.grafsk":["http://voronezh.tutu.ru/02.php"],"voronezh.kursk":["http://voronezh.tutu.ru/03.php"],ekaterinburg:["http://ekburg.tutu.ru/"],irkutsk:["http://irkutsk.tutu.ru/"],"irkutsk.west":["http://irkutsk.tutu.ru/01.php"],"irkutsk.east":["http://irkutsk.tutu.ru/02.php"],kazan:["http://kazan.tutu.ru/"],"kazan.kanash":["http://kazan.tutu.ru/01.php"],"kazan.apshsk":["http://kazan.tutu.ru/02.php"],kaluga:["http://kaluga.tutu.ru/"],kursk:["http://kursk.tutu.ru/"],lipetsk:["http://lipetsk.tutu.ru/"],"lipetsk.lipetsk":["http://lipetsk.tutu.ru/01.php"],"lipetsk.elec":["http://lipetsk.tutu.ru/02.php"],orel:["http://orel.tutu.ru/"],"orel.bryansk":["http://orel.tutu.ru/01.php"],ryazan:["http://ryazan.tutu.ru/"],smolensk:["http://smolensk.tutu.ru/"],tambov:["http://tambov.tutu.ru/"],"tambov.tambov":["http://tambov.tutu.ru/01.php"],sochi:["http://sochi.tutu.ru/"],"sochi.sochi":["http://sochi.tutu.ru/01.php"],tula:["http://tula.tutu.ru/"],"etrain.suggest":["/station/suggest.php"],"etrain.search":["/prigorod/search.php","etrain/search.php","_current_"],"etrain.search.export":["/prigorod/search.php","etrain/search.php?export","frame"],"etrain.msk.schedule":["/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp.php","_current_"],"etrain.msk.schedule_print":["/print/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp.php?print=yes"],"etrain.msk.schedule.xml":["/xml/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp.php?xml&version=1"],"etrain.msk.schedule.xml2":["/xml/v$version/msk/route_schedule.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp.php?xml&version=$version"],"etrain.msk.schedule.export":["/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp.php?export","frame"],"etrain.msk.schedule_date":["/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date","etrain/msk/rasp.php","_current_"],"etrain.msk.schedule_date_print":["/print/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.msk.schedule_date.xml":["/xml/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.msk.schedule_blog":["/surprise.php"],"etrain.msk.schedule_change":["/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp_change.php","_current_"],"etrain.msk.schedule_change_print":["/print/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp_change.php?print=yes"],"etrain.msk.schedule_change.xml":["/xml/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp_change.php?xml&version=1"],"etrain.msk.schedule_change.export":["/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/msk/rasp_change.php?export","frame"],"etrain.msk.schedule_change_date":["/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.msk.schedule_change_date_print":["/print/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.msk.schedule_change_date.xml":["/xml/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.msk.schedule_change_blog":["/surprise.php"],"etrain.msk.schedule_station_print":["/print/station.php?nnst=$station","etrain/msk/station.php?print=yes"],"etrain.msk.schedule_station.xml":["/xml/station.php?nnst=$station","etrain/msk/station.php?xml&version=1"],"etrain.msk.schedule_station.xml2":["/xml/v$version/msk/station_schedule.php?nnst=$station","etrain/msk/station.php?xml&version=$version"],"etrain.msk.schedule_station.export":["/station.php?nnst=$station","etrain/msk/station.php?export","frame"],"etrain.msk.schedule_station_blog":["/surprise.php"],"etrain.msk.route":["/view.php?np=$hash","etrain/msk/view.php","_current_"],"etrain.msk.route_print":["/print/view.php?np=$hash","etrain/msk/view.php?print=yes"],"etrain.msk.route.xml":["/xml/view.php?np=$hash","etrain/msk/view.php?xml&version=1"],"etrain.msk.route.xml2":["/xml/v$version/msk/train_route.php?np=$hash","etrain/msk/view.php?xml&version=$version"],"etrain.msk.route.export":["/view.php?np=$hash","etrain/msk/view.php?export","frame"],"etrain.msk.route_date":["/view.php?np=$hash&date=$date","etrain/msk/view.php","_current_"],"etrain.msk.route_date_print":["/print/view.php?np=$hash&date=$date"],"etrain.msk.route_date.xml":["/xml/view.php?np=$hash&date=$date"],"etrain.msk.sms":["/sms.php","/etrain/sms.php?region=msk"],"etrain.msk.price":["/2read/catalog/suburban_faq/item/suburban_express_cost/"],"etrain.msk.news":["/news.php","etrain/news.php?region=msk","_current_"],"etrain.msk.news.export":["/news.php","etrain/news.php?region=msk&export","frame"],"etrain.spb.schedule":["/spb/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp.php","_current_"],"etrain.spb.schedule_print":["/print/spb/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp.php?print=yes"],"etrain.spb.schedule.xml":["/spb/xml/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp.php?xml&version=1"],"etrain.spb.schedule.xml2":["/xml/v$version/spb/route_schedule.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp.php?xml&version=$version"],"etrain.spb.schedule.export":["/spb/rasp.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp.php?export=1","frame"],"etrain.spb.schedule_date":["/spb/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date","etrain/spb/rasp.php","_current_"],"etrain.spb.schedule_date_print":["/print/spb/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.spb.schedule_date.xml":["/spb/xml/rasp.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.spb.schedule_blog":["/surprise.php"],"etrain.spb.schedule_change":["/spb/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp_change.php","_current_"],"etrain.spb.schedule_change_print":["/print/spb/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp_change.php?print=yes"],"etrain.spb.schedule_change.xml":["/spb/xml/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp_change.php?xml&version=1"],"etrain.spb.schedule_change.export":["/spb/rasp_change.php?st1=$departureStation&st2=$arrivalStation","etrain/spb/rasp_change.php?export","frame"],"etrain.spb.schedule_change_date":["/spb/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.spb.schedule_change_date_print":["/print/spb/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.spb.schedule_change_date.xml":["/spb/xml/rasp_change.php?st1=$departureStation&st2=$arrivalStation&date=$date"],"etrain.spb.schedule_change_blog":["/surprise.php"],"etrain.spb.schedule_station_print":["/print/spb/station.php?nnst=$station","etrain/spb/station.php?print=yes"],"etrain.spb.schedule_station.xml":["/spb/xml/station.php?nnst=$station","etrain/spb/station.php?xml&version=1"],"etrain.spb.schedule_station.xml2":["/xml/v$version/spb/station_schedule.php?nnst=$station","etrain/spb/station.php?xml&version=$version"],"etrain.spb.schedule_station.export":["/spb/station.php?nnst=$station","etrain/spb/station.php?export","frame"],"etrain.spb.schedule_station_blog":["/surprise.php"],"etrain.spb.route":["/spb/view.php?np=$hash","etrain/spb/view.php?","_current_"],"etrain.spb.route_print":["/print/spb/view.php?np=$hash","etrain/spb/view.php?print=yes"],"etrain.spb.route.xml":["/spb/xml/view.php?np=$hash","etrain/spb/view.php?xml&version=1"],"etrain.spb.route.xml2":["/xml/v$version/spb/train_route.php?np=$hash","etrain/spb/view.php?xml&version=$version"],"etrain.spb.route.export":["/spb/view.php?np=$hash","etrain/spb/view.php?export","frame"],"etrain.spb.route_date":["/spb/view.php?np=$hash&date=$date","etrain/spb/view.php?","_current_"],"etrain.spb.route_date_print":["/print/spb/view.php?np=$hash&date=$date"],"etrain.spb.route_date.xml":["/spb/xml/view.php?np=$hash&date=$date"],"etrain.spb.sms":["/spb/sms.php","/etrain/sms.php?region=spb"],"etrain.spb.price":["/2read/catalog/suburban_faq/item/suburban_express_cost/"],"etrain.spb.news":["/spb/news.php","etrain/news.php?region=spb","_current_"],"etrain.spb.news.export":["/spb/news.php","etrain/news.php?region=spb&export","frame"],"aeroexpress.schedule":["/aeroexpress/schedule/","aeroexpress/schedule.php"],"aeroexpress.schedule.airport":["/aeroexpress/schedule/$airportId/","aeroexpress/schedule.php?airport=$airportId"],"aeroexpress.schedule.sheremetevo":["/aeroexpress/schedule/"],"aeroexpress.schedule.domodedovo":["/aeroexpress/schedule/2/"],"aeroexpress.schedule.vnukovo":["/aeroexpress/schedule/1/"],"gate.schedule":["/schedule/gate/","etrain/gate/schedule.php"],"etrain.admin.make_info":["/tutu_admin/ajax/make_info/","/ajax3/index.php?Action=etrainAdminMakeInfo"],"etrain.admin.make_info.check":["/tutu_admin/ajax/make_info/check/","/ajax3/index.php?Action=checkProcess"],"user.registration":["/user/registration/","/user/registration/index.php",null,"https"],"user.remind_password":["/user/remind-password/","/user/remind_password.php",null,"https"],"user.login":["/user/login/","/user/login/index.php",null,"https"],"user.login.not_confirmed":["/user/login/not-confirmed/","/user/login/not_confirmed.php",null,"https"],"user.logout":["/user/logout/","/user/login/logout.php",null,"https"],"user.clearcookie":["/user/clearcookie/","/user/clearcookie.php",null,"https"],"user.action":["/user/action/","/user/action.php",null,"https"],"user.profile.edit_data":["/user/profile/edit-data/","/user/profile/edit/data.php",null,"https"],"user.profile.my_orders":["/user/profile/my_orders/","/user/profile/my_orders.php",null,"https"],"user.profile.order":["/user/profile/my_orders/$hash/","/user/profile/order.php?hash=$hash",null,"https"],"user.profile.feedback":["/user/profile/feedback/","/user/profile/feedback.php",null,"https"],"user.profile.welcome":["/user/profile/welcome/","/user/profile/welcome.php",null,"https"],"user.profile.su":["/user/profile/su/","/user/profile/su.php",null,"https"],"user.profile.settings":["/user/profile/settings/","/user/profile/settings.php",null,"https"],"user.profile.ab_settings":["/user/profile/ab_settings/","/user/profile/settings.php?mode=ab",null,"https"],"user.profile.config_settings":["/user/profile/config_settings/","/user/profile/settings.php?mode=config",null,"https"],"user.profile":["/user/profile/","/user/profile/index.php",null,"https"],taxi:["/taxi/","/taxi/index.php",null,"http"],"taxi.success":["/taxi/success/$number/","/taxi/success.php?number=$number"],"taxi.get_order":["/taxi/get_order/","/taxi/get_order.php"],feedback:["/feedback.php","/feedback.php",null,"http"],"feedback.bilet":["/feedback_bilet.php","/feedback.php?section=bilet"],"feedback.site":["/feedback_site.php","/feedback.php?section=other"],"feedback.new":["/feedback_new.php","/feedback.php?section=other&topic=Предложения+по+новой+версии+сайта"],sonyerricson:["/Sonyericssonw995/","/static/Sonyericssonw995.htm"],maks2009:["/maks-2009/","/static/maks-2009.htm"],no_js:["/no_js/$type/","/no_js.php?type=$type"],popup_image:["/popup_image/$image_type/$image_id/","/popup_image.php?image_type=$image_type&image_id=$image_id"],"hotel.order.booking":["/order/booking/","/hotel/order/booking.php",null,"https"],"hotel.order.booking.local":["/order/booking/local/","/hotel/order/booking.php",null,"https"],"hotel.order.booking.frame":["/order/booking/frame/","/hotel/order/booking_frame.php",null,"https"],"hotel.order.svoytravel":["/hotel/order/svtr/","/hotel/order/svoytravel.php",null,"https"],"hotel.order.svoytravel.step":["/hotel/order/svtr/$step_id/","/hotel/order/svoytravel.php?step_id=$step_id","hotels"],"hotel.order.svoytravel.step.https":["/hotel/order/svtr/$step_id/","/hotel/order/svoytravel.php?step_id=$step_id",null,"https"],"hotel.order.return":["/order/return/","/hotel/order/process.php?action=return","hotels"],"hotel.order.return.https":["/hotel/order/return/","/hotel/order/process.php?action=return",null,"https"],"hotel.order.pay":["/order/pay/$hash/","/hotel/order/process.php?action=pay&h=$hash","hotels"],"hotel.order.voucher":["/order/voucher/$hash/","/hotel/order/process.php?action=voucher&h=$hash","hotels"],"hotel.country_all":["/country/","/hotel/country_all.php","hotels"],"hotel.country":["/country/$country_name/$country_id/","/hotel/country.php?country_name=$country_name&country_id=$country_id","hotels"],"hotel.city":["/city/$city_id/$city_name/","/hotel/city.php?city_id=$city_id&city_name=$city_name","hotels"],"hotel.city_id":["/city/$city_id/","/hotel/city.php?city_id=$city_id","hotels"],"hotel.yml.country.xml":["/yml/country/$country_id/price.xml","/hotel/yml/country.php?country_id=$country_id","hotels","http"],"hotel.yml.city.xml":["/yml/city/$city_id/price.xml","/hotel/yml/city.php?city_id=$city_id","hotels","http"],"hotel.special_offers":["/special_offers/","/hotel/special_offers.php","hotels"],"hotel.banner":["/banner/","/hotel/banner.php","hotels"],"hotel.hotel":["/hotel/$hotel_id/$hotel_name/","/hotel/hotel.php?hotel_id=$hotel_id&hotel_name=$hotel_name","hotels"],"hotel.hotel_gallery":["/hotel/$hotel_id/$hotel_name/gallery/","/hotel/hotel.php?hotel_id=$hotel_id&hotel_name=$hotel_name&gallery","hotels"],"hotel.reviews":["/hotel/$hotel_id/$hotel_name/reviews/","/hotel/reviews/list.php?hotel_id=$hotel_id&hotel_name=$hotel_name&setMenu=reviewsList","hotels"],"hotel.reviews.add":["/hotel/$hotel_id/$hotel_name/reviews/add/","/hotel/reviews/add.php?hotel_id=$hotel_id&hotel_name=$hotel_name&setMenu=reviewsAdd","hotels"],"hotel.ajax":["/ajax/","/ajax/index.php","hotels"],hotel:["/","/hotel/index.php","hotels"],"hotel.main":["/","","hotels"],"hotel.contacts":["/contacts/","/hotel/contacts.php","hotels"],"city.suggest":["/suggest/city/","/ajax/index.php?Action=city_suggest","_current_"],"avia.suggest_state":["/suggest/aviastate/","/ajax/index.php?Action=avia_state","_current_"],"dTrain.suggest":["/railway/suggest.php"],"eTrain.suggest":["/station/suggest.php"],"gtfs.main":["/gtfs/$filetype/","/google/gtfs.php?filetype=$filetype"],"survey.index":["/opros/","/survey/index.php",null,"http"],"survey.history":["/opros/history/$id/","/survey/show.php?id=$id"],"survey.vote":["/opros/vote/$id/","/ajax/index.php?Action=survey&survey_id=$id","_current_"],captcha:["/captcha/$namespace/","/captcha.php?namespace=$namespace"],antiflood_test:["/antiflood-test/","/antiflood_test.php"],no_flood:["/no-flood/","/no_flood.php"],flood_denied:["/flood-denied/","/no_flood.php?denied=1"],service:["/service/","/service.php"],xcache:["/xcache/$server/","/xcache/index.php"],robots:["/robots.txt","/robots_www.txt"],"robots.hotel":["/robots.txt","/robots_hotels.txt","hotels"],"robots.avia":["/robots.txt","/robots_avia.txt","avia"],"robots.frame":["/robots.txt","/robots_frame.txt","frame"],"seo.google":["/ebaa8ab8dc833dfbb28f5a05ac439864/for_google.txt","/seo/for_google.txt"],"seo.google2":["/google0fb849498a4016ce.html","/seo/google2.html","_current_"],"seo.Bing":["/LiveSearchSiteAuth.xml","/seo/bing.xml"],"seo.map.station_msk":["/sitemap_station_msk.txt","/seo/site_map/msk.txt"],"seo.map.station_spb":["/sitemap_station_spb.txt","/seo/site_map/spb.txt"],"seo.yandex":["/yandex_5a86ecac2004c991.txt","/seo/fake.php"],"seo.yandex.hotel":["/yandex_4b005041ffea5e1b.txt","/seo/fake.php","hotels"],"seo.vkontakte":["/crossdomain.xml","/seo/vkontakte.xml"],"seo.external_css":["/style_external.css","/seo/style_external.css"],"seo.all_from_to_rasp_d":["/all_from_to_rasp_d.txt","/seo/all_from_to_rasp_d.txt"],"seo.head_logo":["/head_tutu_logo.gif","/seo/head_tutu_logo.gif"],"seo.old_logo":["/head.gif","/seo/head.gif"],"hack.MSOffice":["/MSOffice/cltreq.asp","/seo/fake.php"],"hack.vti_inf":["/_vti_inf.html","/seo/fake.php"],"hack.vti1":["/_vti_bin/","/seo/fake.php"],"hack.vti2":["/_vti_bin/owssvr.dll","/seo/fake.php"],"hack.vti3":["/_vti_bin/shtml.exe","/seo/fake.php"],"hack.vti4":["/_vti_bin/shtml.exe/_vti_rpc","/seo/fake.php"],"2read.index":["/2read/","/2read/index.php",null,"http"],"2read.tag":["/2read/tag/$tag/","/2read/tag.php?tag=$tag",null,"http"],"2read.publication.old":["/2read/catalog/$catalog/item/$item/","/301.php?url_label=2read.publication&params[catalog]=$catalog&params[publication]=$item",null,"http"],"2read.catalog.old":["/2read/catalog/$catalog/","/301.php?url_label=2read.catalog&params[catalog]=$catalog",null,"http"],"2read.publication":["/2read/$catalog/$publication/","/2read/publication.php?catalog=$catalog&publication=$publication",null,"http"],"2read.catalog":["/2read/$catalog/","/2read/catalog.php?catalog=$catalog",null,"http"],"service.getorders":["/orders/","/getorders.php","avia"],"ajax.statistics":["/ajax_statistics/","/ajax/index.php?Action=statistics"],"avia.davs.oplata":["/davs/oplata/$hash/","/avia/davs/oplata.php?hash=$hash","avia","http"],"avia.davs.oplata.external":["http://www.davs.ru/oplata1/index.php"],"avia.davs.extarchargeinfo":[null],"monitor.sensor":["/monitor/sensor/$sensor/","/monitor/sensor.php?sensor=$sensor","_current_"],"log.main":["/logtail/","/rrd/logtail.php"],"log.project":["/logtail/$project/","/rrd/logtail.php?project=$project"],"log.server":["/logtail/$project/$server/","/rrd/logtail.php?project=$project&server=$server"],"log.tail":["/logtail/$project/$server/$file/","/rrd/logtail.php?project=$project&server=$server&file=$file"],"gearman.remote.controller":["/gearman/remote_ctrl/","/gearman/gearmctrl.php","_current_"],abtest:["/abtest/","/abtest/index.php"],"sitemap.avia_ticket":["/avia_ticket.txt","/sitemap_generator.php?name=avia_ticket","avia"],"sitemap.sitemap_avia_ticket":["/sitemap_avia_ticket.txt","/sitemap_generator.php?name=avia_ticket","avia"],"sitemap.avia_ticket_in_city":["/avia_ticket_in_city.txt","/sitemap_generator.php?name=avia_ticket_in_city","avia"],"sitemap.sitemap_avia_ticket_in_city":["/sitemap_avia_ticket_in_city.txt","/sitemap_generator.php?name=avia_ticket_in_city","avia"],"sitemap.airline":["/sitemap_airline.txt","/sitemap_generator.php?name=airline","avia"],"sitemap.airport":["/sitemap_airport.txt","/sitemap_generator.php?name=airport","avia"],"sitemap.plane":["/sitemap_plane.txt","/sitemap_generator.php?name=plane","avia"],"sitemap.schedule_from_rus":["/sitemap_schedule_from_rus.txt","/sitemap_generator.php?name=schedule_from_rus","avia"],"sitemap.schedule_no_rus":["/sitemap_schedule_no_rus.txt","/sitemap_generator.php?name=schedule_no_rus","avia"],"sitemap.schedule_rus_rus":["/sitemap_schedule_rus_rus.txt","/sitemap_generator.php?name=schedule_rus_rus","avia"],"sitemap.schedule_to_rus":["/sitemap_schedule_to_rus.txt","/sitemap_generator.php?name=schedule_to_rus","avia"],"sitemap.hotel_countries_urls":["/hotel_countries_urls.txt","/sitemap_generator.php?name=hotel_countries_urls","hotels"],"sitemap.hotels_city":["/sitemap_hotels_city.txt","/sitemap_generator.php?name=hotels_city","hotels"],"sitemap.hotels_city_star_1":["/sitemap_city_1_zvezda.txt","/sitemap_generator.php?name=hotels_city&star=1","hotels"],"sitemap.hotels_city_star_2":["/sitemap_city_2_zvezdy.txt","/sitemap_generator.php?name=hotels_city&star=2","hotels"],"sitemap.hotels_city_star_3":["/sitemap_city_3_zvezdy.txt","/sitemap_generator.php?name=hotels_city&star=3","hotels"],"sitemap.hotels_city_star_4":["/sitemap_city_4_zvezdy.txt","/sitemap_generator.php?name=hotels_city&star=4","hotels"],"sitemap.hotels_city_star_5":["/sitemap_city_5_zvezd.txt","/sitemap_generator.php?name=hotels_city&star=5","hotels"],"sitemap.hotels_1":["/sitemap_hotels_1.txt","/sitemap_generator.php?name=hotels&offset=0","hotels"],"sitemap.hotels_2":["/sitemap_hotels_2.txt","/sitemap_generator.php?name=hotels&offset=49000","hotels"],"sitemap.hotels_3":["/sitemap_hotels_3.txt","/sitemap_generator.php?name=hotels&offset=98000","hotels"],"sitemap.hotels_4":["/sitemap_hotels_4.txt","/sitemap_generator.php?name=hotels&offset=147000","hotels"],"sitemap.railway_schedule":["/poezda/sitemap_poezda_rasp_d.txt","/sitemap_generator.php?name=railway_schedule"],"sitemap.railway_schedule_station":["/poezda/sitemap_poezda_station_d.txt","/sitemap_generator.php?name=railway_schedule_station"],"sitemap.railway_route":["/poezda/sitemap_poezda_view.txt","/sitemap_generator.php?name=railway_route"],"fenistil.msk":["/summer2012/msk/","/summer2012/msk/index.html"],"fenistil.spb":["/summer2012/spb/","/summer2012/spb/index.html"],"image.main":["/image/main/$fid/$file/","/show.php?fid=$fid&file=$file&mode=main","images","current"],"image.metro":["/image/metro/$fid/$file/","/show.php?fid=$fid&file=$file&mode=metro","images","current"],"image.hotel_list":["/image/hotel_list/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_list","images","current"],"image.hotel_list_animate":["/image/hotel_list_animate/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_list_animate","images","current"],"image.hotel_logo":["/image/hotel_logo/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_logo","images","current"],"image.hotel_room":["/image/hotel_room/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_room","images","current"],"image.hotel_country":["/image/hotel_country/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_country","images","current"],"image.hotel_scheme":["/image/hotel_scheme/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_scheme","images","current"],"image.hotel_gallery_small":["/image/hotel_gallery_small/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_gallery_small","images","current"],"image.hotel_gallery":["/image/hotel_gallery/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_gallery","images","current"],"image.hotel_reviews":["/image/hotel_reviews/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_reviews","images","current"],"image.hotel_banner":["/image/hotel_banner/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_banner","images","current"],"image.hotel_fscr_big":["/image/hotel_fscr_big/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_fscr_big","images","current"],"image.hotel_fscr_middle":["/image/hotel_fscr_middle/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_fscr_middle","images","current"],"image.hotel_fscr_small":["/image/hotel_fscr_small/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_fscr_small","images","current"],"image.tempajax":["/image/tempajax/$fid/$file/","/show.php?fid=$fid&file=$file&mode=tempajax","images","current"],"image.survey":["/image/survey/$fid/$file/","/show.php?fid=$fid&file=$file&mode=survey","images","current"],"image.source":["/image/source/$fid/$file/","/show.php?fid=$fid&file=$file&mode=source","images","current"],"image.hotel_gallery_thumb":["/image/hotel_gallery_thumb/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_gallery_thumb","images","current"],"image.hotel_gallery_big":["/image/hotel_gallery_big/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_gallery_big","images","current"],"image.hotel_gallery_big_room":["/image/hotel_gallery_big_room/$fid/$file/","/show.php?fid=$fid&file=$file&mode=hotel_gallery_big_room","images","current"],"image.avia_offers_carriers":["/image/avia_offers_carriers/$fid/$file/","/show.php?fid=$fid&file=$file&mode=avia_offers_carriers","images","current"],"image.avia_offers_carriers_small":["/image/avia_offers_carriers_small/$fid/$file/","/show.php?fid=$fid&file=$file&mode=avia_offers_carriers_small","images","current"],"image.avia_standard_carriers":["/image/avia_standard_carriers/$fid/$file/","/show.php?fid=$fid&file=$file&mode=avia_standard_carriers","images","current"],"image.city_special":["/image/city_special/$fid/$file/","/show.php?fid=$fid&file=$file&mode=city_special","images","current"],"image.preview":["/image/preview/$fid/$file/","/show.php?fid=$fid&file=$file&mode=preview","images","current"],"image.avia_plane_list":["/image/avia_plane_list/$fid/$file/","/show.php?fid=$fid&file=$file&mode=avia_plane_list","images","current"],"image.avia_plane_main":["/image/avia_plane_main/$fid/$file/","/show.php?fid=$fid&file=$file&mode=avia_plane_main","images","current"],"image.carrier_small_logo":["/image/carrier_small_logo/$fid/$file/","/show.php?fid=$fid&file=$file&mode=carrier_small_logo","images","current"],"image.partner_button":["/image/partner_button/$fid/$file/","/show.php?fid=$fid&file=$file&mode=partner_button","images","current"],"image.elfinder_tmb":["/image/elfinder_tmb/$fid/$file/","/show.php?fid=$fid&file=$file&mode=elfinder_tmb","images","current"]};
var RM_Browser=RM.Class.extend({map:{msie:false,opera:false,firefox:false,chrome:false,safari:false},init:function(){var idx;var agent=window.navigator.userAgent.toLowerCase();for(idx in this.map){this.map[idx]=agent.indexOf(idx)>=0}},is:function(browser){return this.map[browser.toLowerCase()]},isIe:function(){return this.is("msie")},isOpera:function(){return this.is("opera")},isFirefox:function(){return this.is("firefox")},isChrome:function(){return this.is("chrome")},isSafari:function(){return this.is("safari")}});RM.Browser=new RM_Browser();var RM_LocalStorage=RM.Class.extend({name:"",localCache:{},forceUseLocalCache:false,init:function(name){this.name=name},useLocalCache:function(){this.forceUseLocalCache=true},clearAll:function(){if(this.supported()){localStorage.clear()}else{this.localCache={}}},clearItem:function(item){var fullItemName=this.name+"."+item;if(this.supported()){localStorage.removeItem(fullItemName)}else{this.localCache[fullItemName]=null}},setItem:function(item,data){if(this.supported()){this._saveInLocalStorage(item,data)}else{this._saveInLocalCache(item,data)}},getItem:function(item){var data=null;if(this.supported()){data=$.evalJSON(localStorage.getItem(this.name+"."+item))}else{data=this.localCache[this.name+"."+item]?$.evalJSON(this.localCache[this.name+"."+item]):null}return data},_saveInLocalStorage:function(item,data){try{localStorage.setItem(this.name+"."+item,$.toJSON(data));this._addKeyToLocalStorageHistory(item)}catch(e){var oldestItem=this._getOldestKeyInLocalStorageHistory();if(oldestItem){this.clearItem(oldestItem);this._saveInLocalStorage(item,data)}else{this.useLocalCache();this._saveInLocalCache(item,data)}}},_addKeyToLocalStorageHistory:function(item){var keys=$.evalJSON(localStorage.getItem(this.name));if(!keys||!$.isArray(keys)){keys=[]}keys.push(item);localStorage.setItem(this.name,$.toJSON(keys))},_getOldestKeyInLocalStorageHistory:function(){var keys=$.evalJSON(localStorage.getItem(this.name));if(!keys||!$.isArray(keys)){keys=[]}var oldestKey=keys.shift();localStorage.setItem(this.name,$.toJSON(keys));return oldestKey},_saveInLocalCache:function(item,data){this.localCache[this.name+"."+item]=$.toJSON(data)},supported:function(){try{if(this.forceUseLocalCache){return false}return"localStorage" in window&&window.localStorage!==null&&this._isOrthodoxBrowser()}catch(e){return false}},_isOrthodoxBrowser:function(){return RM.Browser.isFirefox()||RM.Browser.isChrome()}});RM.LocalStorage=new RM_LocalStorage("default");var RM_Tutu_Ajax_DataList=RM.Class.extend({name:null,url:null,params:null,settings:{delay:0,onStart:function(){},onSuccess:function(list,data){},onError:function(error,data){}},storage:null,page:null,xhr:null,isDataLoading:false,init:function(name,url,params,settings){this.name=name;this.storage=new RM_LocalStorage(this.name);this.url=url;this.params=params;this.settings=$.extend({},this.settings,settings)},show:function(page){var obSelf=this;this.page=this.normalizePage(page);this.settings.onStart();this.request(this.page,function(data,page){if(obSelf.settings.onSuccess){obSelf.settings.onSuccess.call(obSelf,data.list[page]?data.list[page]:[],data)}},function(errorThrown,data){if(obSelf.settings.onError){obSelf.settings.onError.call(obSelf,errorThrown,data)}})},flush:function(page){this.storage.clearItem(this.ns(this.callback(this.url),this.callback(this.params)))},normalizePage:function(page){page=parseInt(page);if(isNaN(page)||page<1){page=1}return page},request:function(page,success,error){var obSelf=this;var url=this.callback(this.url);var params=this.callback(this.params);var ns=this.ns(url,params);if(this.requestChanged(ns,page)){if(this.settings.delay){$(document).stopTime(this.name).oneTime(this.settings.delay,this.name,function(){obSelf.requestSend(url,params,page,success,error)})}else{obSelf.requestSend(url,params,page,success,error)}}else{obSelf.requestComplete(ns,page,success,error)}},requestSend:function(url,params,page,success,error){var obSelf=this;var ns=this.ns(url,params);if(this.xhr){this.xhr.abort()}this.isDataLoading=true;this.xhr=$.ajax({url:url,data:params+"&page="+page,dataType:"json",type:"GET",success:function(data,textStatus,jqXHR){if(jqXHR.readyState==4){if(data!=null){obSelf.requestSave(ns,data);obSelf.requestComplete(ns,page,success,error)}else{error("Ошибка поиска рейсов. Обновите страницу или попробуйте еще раз.")}}},error:function(jqXHR,textStatus,errorThrown){error(errorThrown)},complete:function(jqXHR,textStatus){obSelf.isDataLoading=false}})},ns:function(url,params){return url+params},requestComplete:function(ns,page,success,error){var data=this.getData(ns);if(!data.list){error(data.error?data.error:"",data)}else{success(data,page)}},requestSave:function(ns,data){if(!data.pages){data.pages=data.list&&data.list.length>0?1:0}var oldData=this.getData(ns);if(oldData&&oldData.list){for(var i=1;i<=data.pages;i++){if(!data.list[i]&&oldData.list[i]){data.list[i]=oldData.list[i]}}}this.setData(ns,data)},requestChanged:function(ns,page){var data=this.getData(ns);
return(!data||!data.list||!data.list[page])},setData:function(ns,data){data.time=new Date();if(!data.timelimit){data.timelimit=60}this.storage.setItem(ns,data)},getData:function(ns,filter){var data=this.storage.getItem(ns);if(!data){return null}data.time=new Date(data.time);var now=new Date();if((now.getTime()-data.time.getTime())>data.timelimit*1000){this.storage.clearItem(ns);return null}return data},callback:function(variable){if(variable&&(variable instanceof Object)&&variable.constructor.toString().match(/^\s*function/)){return variable()}else{return variable}}});var RM_Tutu_Avia_Offers_BuyButton=RM.Class.extend({buttonContainer:null,searchParams:{},offerHash:"",events:{onStart:function(){},onSuccess:function(order,searchParams){},onError:function(needReload){}},xhr:null,init:function(buttonContainer,searchParams,events){var obSelf=this;this.buttonContainer=buttonContainer;this.searchParams=searchParams;this.events=$.extend({},this.events,events);this.buttonContainer.find(".rm-offer-button").bind("click",function(){obSelf._createOrder()})},_createOrder:function(){this._setButtonState("wait");this.events.onStart();if(this.xhr){this.xhr.abort()}this.xhr=$.ajax({url:RM.Url.get("ajax",{},{Action:"avia_order"}),data:this.searchParams,dataType:"json",type:"GET",context:this,success:function(data,textStatus,jqXHR){if(!data||data.error||!data.order){this._setButtonState("error");this.events.onError(data.error&&data.error=="offer_not_confirmed"?false:true)}else{this.events.onSuccess(data.order,this.searchParams)}},error:function(jqXHR,textStatus,errorThrown){this._setButtonState("error");this.events.onError(true)}})},cancel:function(){if(this.xhr){this.xhr.abort()}},hide:function(){this.buttonContainer.hide()},_setButtonState:function(state){if(!this.buttonContainer){return}var buttonToEnable=null;this.buttonContainer.find(".rm-offer-button-switch").addClass("dNone");if(state=="error"){buttonToEnable=this.buttonContainer.find(".rm-button-error")}else{if(state=="wait"){buttonToEnable=this.buttonContainer.find(".rm-button-wait");this.buttonContainer.find(".wait-indicator.js_indicator").activity({segments:12,align:"left",valign:"top",steps:3,width:2,space:1,length:3,color:"#030303",speed:1.5,padding:0})}else{if(type=="offer"){buttonToEnable=this.buttonContainer.find(".rm-offer-button")}}}if(buttonToEnable){buttonToEnable.removeClass("dNone")}}});var RM_Tutu_Avia_Offers_Route=RM.Class.extend({offer:null,carriersList:null,data:{},domBlock:null,active:true,selected:false,init:function(offer,data,carriersList){this.offer=offer;this.carriersList=carriersList;this.data=$.extend({},data);this.data.segments=this._segments();$.extend(this.data,{departure_time_human:this._firstSegment().departure_time_human,departure_airport_name:this._firstSegment().departure_airport_name,arrival_time_human:this._lastSegment().arrival_time_human,arrival_airport_name:this._lastSegment().arrival_airport_name,shift_of_date:this._calculateDaysBetweenDepartureAndArrival(),carriers_differ:this._isMarketingAndOperatingCarriersDiffer(),operating_carriers_names:this._operatingCarriersNames().join(", "),operating_carriers_count:this._operatingCarriersNames().length,carriers:this.carriers()})},compareDepartureTime:function(route){var departureTime=new Date(this._firstSegment().departure_time);var departureTimeOfOtherRoute=new Date(route._firstSegment().departure_time);if(departureTime.getTime()<departureTimeOfOtherRoute.getTime()){return -1}else{if(departureTime.getTime()>departureTimeOfOtherRoute.getTime()){return 1}else{return 0}}},_segments:function(){var segments=[];for(var i=0;i<this.data.segments.length;i++){var segment=$.extend({},this.data.segments[i]);var operatingCarrier=this.carriersList.get(this.data.segments[i].operating_carrier_id);var marketingCarrier=this.carriersList.get(this.data.segments[i].marketing_carrier_id);segment.operating_carrier_name=operatingCarrier?operatingCarrier.name:"";segment.marketing_carrier_name=marketingCarrier?marketingCarrier.name:"";segment.flight_number=(marketingCarrier?marketingCarrier.code+"&nbsp;":"")+this.data.segments[i].flight_num;segments.push(segment)}return segments},_firstSegment:function(){return this.data.segments[0]},_lastSegment:function(){return this.data.segments[this.data.segments.length-1]},_routeNumber:function(){return this._firstSegment().flight_number},_calculateDaysBetweenDepartureAndArrival:function(){var departureDate=new Date(this._firstSegment().departure_time);var arrivalDate=new Date(this._lastSegment().arrival_time);var msInDay=1000*60*60*24;var days=parseInt(arrivalDate.getTime()/msInDay)-parseInt(departureDate.getTime()/msInDay);return days==0?"":(days>0?"+":"-")+days},_isMarketingAndOperatingCarriersDiffer:function(){var isDiffer=false;for(var i=0;i<this.data.segments.length;i++){if(this.data.segments.marketing_carrier_id!=this.data.segments.operating_carrier_id){isDiffer=true;break}}return isDiffer},_operatingCarriersNames:function(){var names=[];var loaded={};for(var i=0;i<this.data.segments.length;
i++){if(loaded[this.data.segments[i].operating_carrier_id]){continue}var carrier=this.carriersList.get(this.data.segments[i].operating_carrier_id);if(carrier){names.push(carrier.name)}loaded[this.data.segments[i].operating_carrier_id]=true}return names},carriers:function(){var carriers=[];var loaded={};for(var i=0;i<this.data.segments.length;i++){if(loaded[this.data.segments[i].marketing_carrier_id]){continue}var carrier=this.carriersList.get(this.data.segments[i].marketing_carrier_id);if(carrier){carriers.push($.extend({},carrier))}loaded[this.data.segments[i].marketing_carrier_id]=true}return carriers},show:function(){var obSelf=this;this.domBlock=$(RM.tmpl("avia_order_offer_pricegroup_route",this.data));this.offer.domBlock.find(".rm-routes-"+this.data.direction).append(this.domBlock);this.shutup()},hide:function(){if(this.domBlock){this.domBlock.remove()}},hover:function(){this.domBlock.addClass("rm-route-hovered")},unhover:function(){this.domBlock.removeClass("rm-route-hovered")},isSelected:function(){return this.selected},select:function(){for(var i=0;i<this.offer.routes[this.data.direction].length;i++){this.offer.routes[this.data.direction][i].unselect()}this.selected=true;$(this.domBlock).addClass("rm-route-selected")},unselect:function(){this.selected=false;$(this.domBlock).removeClass("rm-route-selected")},block:function(){this.active=false;$(this.domBlock).addClass("rm-route-disabled");this.shutdown();this.unselect()},unblock:function(){this.active=true;$(this.domBlock).removeClass("rm-route-disabled");this.shutup()},isBlocked:function(){return !this.active},shutdown:function(){$(this.domBlock).unbind("click mouseover mouseout")},shutup:function(){var obSelf=this;$(this.domBlock).bind("click",function(){obSelf.offer.selectRoute(obSelf,true)}).bind("mouseover",function(){obSelf.hover();obSelf.offer.hoverCompatibleRoutes(obSelf)}).bind("mouseout",function(){obSelf.unhover();obSelf.offer.unhoverCompatibleRoutes(obSelf)})}});var RM_Tutu_Avia_Offers_OfferGroup=RM.Class.extend({data:{},offers:{},searchParams:"",directions:0,domBlock:null,routes:{},selectedRoutes:{},container:null,carriers:null,minimalUnscrolledHeight:400,_haveChanges:false,_needScrollEvent:null,init:function(data,container,carriers,searchParams){this.data=data.slice(0);this.container=container;this.carriers=$.extend({},carriers,{get:function(id){return id in this&&this[id]?this[id]:null}});this.searchParams=searchParams;this.directions=data[0]["flight"]["routes"].length;this.offers=this._initOffers();this._initSelection();this.routes=this._initRoutes()},_initOffers:function(){var offers={};for(var i=0;i<this.data.length;i++){var offer=this.data[i];var routesHash=[];for(var d=0;d<offer.flight.routes.length;d++){routesHash.push(offer.flight.routes[d]["hash"])}offers[routesHash.join("_")]=offer}return offers},show:function(){this._initDomContainer();for(var direction=1;direction<=this.directions;direction++){for(var j=0;j<this.routes[direction].length;j++){this.routes[direction][j].show()}}this._initBlockScroll();this._setBaseSelection();this.showOffer()},hide:function(){$(window).unbind("scroll",this._modifyBlockPosition);for(var direction=1;direction<=this.directions;direction++){for(var j=0;j<this.routes[direction].length;j++){this.routes[direction][j].hide()}}if(this.domBlock){this.domBlock.remove()}},haveChanges:function(){return this._haveChanges},haveCarriers:function(carriers){var filter={};for(var i=0;i<carriers.length;i++){filter[carriers[i]]=true}for(var direction=1;direction<=this.directions;direction++){for(var i=0;i<this.routes[direction].length;i++){var routeCarriers=this.routes[direction][i].carriers();for(var j=0;j<routeCarriers.length;j++){if(!(routeCarriers[j].id in filter)){return false}}}}return true},_initBlockScroll:function(){if(this._needScrollEvent==null){for(var direction=1;direction<=this.directions;direction++){if(this.routes[direction]&&this.routes[direction].length>8){this._needScrollEvent=true;break}}if(this._needScrollEvent==null){this._needScrollEvent=false}}if(this._needScrollEvent){$(window).bind("scroll",{offer:this},this._modifyBlockPosition)}},_modifyBlockPosition:function(event){var obSelf=event.data.offer;var topFormHeight=parseInt($(".b-avia_top_filters").height());if(isNaN(topFormHeight)||topFormHeight<0){topFormHeight=0}var margin=($(window).scrollTop()+topFormHeight)-obSelf.domBlock.position().top;var padding=parseInt(obSelf.domBlock.css("padding-bottom"));if(isNaN(padding)){padding=0}var maxMargin=obSelf.domBlock.find(".b-relevant_fly").height()-obSelf.domBlock.find(".rm-offer").height()-padding-35;if(margin>maxMargin){margin=maxMargin}if(margin<0){margin=0}$(document).stopTime(obSelf.data.hash).oneTime(100,obSelf.data.hash,function(){obSelf.domBlock.find(".rm-offer").clearQueue().animate({"margin-top":margin+"px"},"fast")})},_initSelection:function(){this.selectedRoutes={};for(var direction=1;direction<=this.directions;direction++){this.selectedRoutes[direction]=null}},_initDomContainer:function(){this.domBlock=$(RM.tmpl("avia_order_offer_pricegroup",{directions:this.directions}));
$(this.container).append(this.domBlock)},_initRoutes:function(){var routes={};var cache={};for(var direction=1;direction<=this.directions;direction++){routes[direction]=[];cache[direction]={}}for(var i=0;i<this.data.length;i++){var offer=this.data[i];for(var direction=1;direction<=this.directions;direction++){var route=offer.flight.routes[direction-1];if(cache[direction][route.hash]){continue}routes[direction].push(new RM_Tutu_Avia_Offers_Route(this,$.extend({},route,{direction:direction}),this.carriers));if(route.segments.length>1){this._haveChanges=true}cache[direction][route.hash]=true}}for(var direction=1;direction<=this.directions;direction++){routes[direction].sort(function(a,b){return a.compareDepartureTime(b)})}return routes},_setBaseSelection:function(){this.selectRoute(this.routes[1][0]);for(var direction=2;direction<=this.directions;direction++){this.selectFirstCompatibleRoute(direction)}},isRouteSelected:function(route){return(this.selectedRoutes[route.data.direction]&&(this.selectedRoutes[route.data.direction].data.hash==route.data.hash))},selectRoute:function(route,animate){if(this.isRouteSelected(route)){route.select();return}if(route.data.direction==1){this._selectRoute(route);for(var direction=2;direction<=this.directions;direction++){for(var i=0;i<this.routes[direction].length;i++){var nextRoute=this.routes[direction][i];if(!this._routesComptible([route,nextRoute])){nextRoute.block();if(this.isRouteSelected(nextRoute)){this.selectedRoutes[direction]=null}}else{nextRoute.unblock()}}if(!this.selectedRoutes[direction]){this.selectFirstCompatibleRoute(direction)}}}else{if(!route.isBlocked()){this._selectRoute(route)}}this.showOffer();if(animate){this.animateOffer()}},hoverCompatibleRoutes:function(route){for(var direction=1;direction<=this.directions;direction++){if(route.data.direction==direction){continue}for(var i=0;i<this.routes[direction].length;i++){var cRoute=this.routes[direction][i];if(this._routesComptible([route,cRoute])){cRoute.hover()}else{cRoute.unhover()}}}},_routesComptible:function(routes){var hash=[];for(var i=0;i<routes.length;i++){hash.push(routes[i].data.hash)}hash=hash.join("_");return this.offers[hash]?true:false},unhoverCompatibleRoutes:function(route){for(var direction=1;direction<=this.directions;direction++){if(route.data.direction==direction){continue}for(var i=0;i<this.routes[direction].length;i++){this.routes[direction][i].unhover()}}},selectFirstCompatibleRoute:function(direction){for(var i=0;i<this.routes[direction].length;i++){if(!this.routes[direction][i].isBlocked()){this._selectRoute(this.routes[direction][i]);break}}},_selectRoute:function(route){this.selectedRoutes[route.data.direction]=route;route.select()},showOffer:function(){var obSelf=this;this.domBlock.find(".rm-offer").empty();var offer=this._getSelectedOffer();if(offer!=null){var blockOffer=$(RM.tmpl("avia_order_offer_pricegroup_offer",offer));this.domBlock.find(".rm-offer").append(blockOffer);this.buyButton=new RM_Tutu_Avia_Offers_BuyButton(blockOffer.find(".rm-offer-button-block"),$.extend({},this.searchParams,{offer_hash:offer.hash}),{onStart:function(){},onSuccess:function(order,searchParams){},onError:function(needReload){if(needReload){}else{}}});blockOffer.filter(".extend").each(function(){obSelf._addEventsForSegment(this)})}},_getSelectedOffer:function(){var offer=null;var hash=[];for(var i=1;i<=this.directions;i++){if(!this.selectedRoutes[i]){return null}hash.push(this.selectedRoutes[i].data.hash)}hash=hash.join("_");if(this.offers[hash]){offer=this.offers[hash];offer.routes=[];offer.payment_methods_string="";var hasOnline=false;var hasOffline=false;for(var p=0;p<offer.payment_methods.length;p++){if(offer.payment_methods[p]=="cardonline"||offer.payment_methods[p]=="yandex"){hasOnline=true}if(offer.payment_methods[p]=="cash"||offer.payment_methods[p]=="cash_curier"){hasOffline=true}}if(hasOnline&&hasOffline){offer.payment_methods_string=RM.L("avia.gds.tip_payment_type_both")}else{offer.payment_methods_string=hasOffline?RM.L("avia.gds.tip_payment_type_offline"):RM.L("avia.gds.tip_payment_type_online")}for(var i=1;i<=this.directions;i++){offer.routes.push(this.selectedRoutes[i])}}return offer},animateOffer:function(){var obSelf=this;this._getAnimatedElements().clearQueue().animate({opacity:0.4},250).animate({opacity:1},250).animate({opacity:0.5},250).animate({opacity:1},250)},_getAnimatedElements:function(){return this.domBlock.find(".rm-offer")},_addEventsForSegment:function(blockSegment){$(blockSegment).find(".hide_extended").click(function(){$(blockSegment).find(".details-extended").fadeOut(200,function(){$(blockSegment).find(".details-link").show()})});$(blockSegment).find(".show_extended").click(function(){$(blockSegment).find(".details-link").hide();$(blockSegment).find(".details-extended").fadeIn(200)})}});var RM_Tutu_Avia_SearchResult_Url=RM.Class.extend({_withDefaultValues:{"class":"Y",carriers:[],no_changes:"0"},update:function(params,filters,errorCode){if(!errorCode){errorCode=0}if(history.pushState){this._setUrl(params,filters,errorCode)
}else{this._setHash(params,filters,errorCode)}},fix:function(){if(!location.toString().match(/#/)){return}var onFlyChangeableValues=["carriers\\[\\]","no_changes"];var needRedirect=false;var queryParams=location.search.replace("?","").split("&");var hashParams=location.hash.replace("#","").split("&");var urlData=[];var i,j,copy;for(i in queryParams){try{queryParams[i]=decodeURI(queryParams[i])}catch(e){}copy=true;for(j in onFlyChangeableValues){if(queryParams[i].match(new RegExp("^"+onFlyChangeableValues[j]+"="))){copy=false}}if(copy){urlData.push(queryParams[i])}}for(i in hashParams){try{hashParams[i]=decodeURI(hashParams[i])}catch(e){}if(hashParams[i]==""){continue}urlData.push(hashParams[i]);needRedirect=true}var uniqueHash={};i=urlData.length;while(i--){uniqueHash[urlData[i]]=i}urlData=[];for(i in uniqueHash){urlData.unshift(i)}if(needRedirect){location.assign(location.pathname+"?"+urlData.join("&"))}},_setUrl:function(params,filters,errorCode){var newUrlData={};var newHashData={};var queryParams=this._getParams(location.search.replace("?",""));queryParams=this._normalizeDates(queryParams);params=this._normalizeDates(params);if("act" in queryParams){newUrlData.act=queryParams.act}if("error_code" in queryParams){if(queryParams.error_code&&errorCode){newUrlData.error_code=queryParams.error_code}}for(var i in params){if(!this._withDefaultValues[i]||(this._withDefaultValues[i]&&this._withDefaultValues[i]!=params[i])){newUrlData[i]=params[i]}}for(var i in filters){if(!this._withDefaultValues[i]||(this._withDefaultValues[i]&&this._withDefaultValues[i]!=filters[i])){newUrlData[i]=filters[i]}}var oldUrl=location.pathname+location.search;var newUrl=location.pathname+"?"+$.param(newUrlData);if(newUrl!=oldUrl){history.replaceState({},"",newUrl)}},_setHash:function(params,filters,errorCode){var newHashData={};var queryParams=this._getParams(location.search.replace("?",""));queryParams=this._normalizeDates(queryParams);var hashParams=this._getParams(location.hash.replace("#",""));hashParams=this._normalizeDates(hashParams);params=this._normalizeDates(params);for(var i in params){if(i=="date_back"){if(queryParams.direction==1&&this._dateEmpty(queryParams.date_back)){params.date_back=queryParams.date_back}}if((!queryParams[i]&&this._withDefaultValues[i]&&this._withDefaultValues[i]!=params[i])||(queryParams[i]&&queryParams[i]!=params[i])){newHashData[i]=params[i]}}for(var i in filters){if((!hashParams[i]&&this._withDefaultValues[i]&&this._withDefaultValues[i]!=filters[i])||(hashParams[i]&&hashParams[i]!=filters[i])){newHashData[i]=filters[i]}}if(!errorCode&&"error_code" in queryParams&&queryParams.error_code){newHashData.error_code=""}var newHashString=$.param(newHashData);location.hash=newHashString?"#"+decodeURI(newHashString):""},_getParams:function(paramsString){var params={};if(paramsString){var paramsPairs=paramsString.split("&");for(var i=0;i<paramsPairs.length;i++){if(!paramsPairs[i]){continue}var pair=paramsPairs[i].split("=");params[pair[0]]=pair[1]?pair[1]:""}}return params},_normalizeDates:function(params){var dateHelper=new RM_Date();var fields=["date_forward","date_back"];for(var i in fields){if(this._dateEmpty(params[fields[i]])){continue}var date=dateHelper.getObject(params[fields[i]]);params[fields[i]]=date.getDate()+"."+(date.getMonth()+1)+"."+date.getFullYear()}return params},_dateEmpty:function(date){return(date==RM.L("common.date_format")||date==encodeURI(RM.L("common.date_format"))||!date)}});var RM_Tutu_Avia_Offers_List=RM.Class.extend({dataList:null,resultContainer:null,errorContainer:null,params:{getParams:function(){},onData:function(data){},onError:function(error){}},offers:[],filteredOffers:[],urlHelper:null,relatedparams:[],init:function(params){var obSelf=this;this.params=$.extend({},this.params,params);this.resultContainer=$(".l-avia_result").get(0);this.errorContainer=$(".rm-error-holder").get(0);this.urlHelper=new RM_Tutu_Avia_SearchResult_Url();this.dataList=new RM_Tutu_Ajax_DataList("flights",url.get("ajax",{},{Action:"avia_offer",act:"get_offers"}),function(){return $.param(obSelf.params.getParams())},{onSuccess:function(list,data){obSelf._updateUrl();obSelf._processOffers(list,data,obSelf.params.getParams())},onError:function(error,data){obSelf.params.onError(error);obSelf.offers=[];obSelf._showError(error)}});obSelf.checkBottomPadding();$(window).bind("resize",function(){obSelf.checkBottomPadding()})},_updateUrl:function(errorCode){this.urlHelper.update(this.params.getParams(),this.params.getFilters(),errorCode)},update:function(force){this._hideError();$(this.resultContainer).empty();this._updateUrl(false);if(force){this.dataList.flush(1)}this.dataList.show(1)},show:function(){this._updateUrl();this._hideError();this._addPlaceHolder();this._hideOffers();this._filterOffers();this._renderPage();this._removePlaceHolder()},_addPlaceHolder:function(){var height=$(this.resultContainer).height();$(this.resultContainer).append($("<div>",{"class":"rm-placeholder"}).css("height",height+"px"))
},_removePlaceHolder:function(){$(this.resultContainer).find(".rm-placeholder").remove()},_hideError:function(){$(this.errorContainer).hide()},_showError:function(text){$(this.errorContainer).show();$(this.errorContainer).find(".result_text").html(text)},_filterOffers:function(){this.filteredOffers=[];for(var i=0;i<this.offers.length;i++){if(this._matchFilters(this.offers[i])){this.filteredOffers[this.filteredOffers.length]=this.offers[i]}}},_hideOffers:function(){for(var i=0;i<this.filteredOffers.length;i++){this.filteredOffers[i].hide()}},_renderPage:function(){if(!this.filteredOffers.length){if(!this.offers.length){this._showError(RM.L("avia.order.empty_result_sorry"))}else{this._showError(RM.L("avia.order.empty_result_filtered"))}}else{for(var i=0;i<this.filteredOffers.length;i++){this.filteredOffers[i].show()}}},_matchFilters:function(offer){var filters=this.params.getFilters();if(filters.no_changes&&offer.haveChanges()){return false}if(filters.carriers.length==0){return true}return offer.haveCarriers(filters.carriers)},_processOffers:function(list,data,searchParams){var obSelf=this;for(var j=0;j<this.offers.length;j++){this.offers[j].hide()}this.offers=[];for(var i=0;i<list.length;i++){this.offers[this.offers.length]=new RM_Tutu_Avia_Offers_OfferGroup(list[i],this.resultContainer,data.carriers_list,searchParams)}this.params.onData(data);this.show()},checkBottomPadding:function(){var windowWidth=parseInt($(window).width());if(windowWidth<1150){$(".rm-foot_spacer").addClass("compact")}else{$(".rm-foot_spacer").removeClass("compact")}}});var RM_Date=RM.Class.extend({monthList:[],weekDayList:[],caseList:["nominative","genitive","dative","accusative","instrumental","prepositional","short"],re:null,minYear:null,maxYear:null,init:function(){this.re={dmy:/^(\d{1,2}).(\d{1,2}).(\d{4})$/,ymd:/^(\d{4})-(\d{1,2})-(\d{1,2})$/,ymdHis:/^(\d{4})-(\d{1,2})-(\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2})$/};this.minYear=1900;this.maxYear=2900;this._initMonthList();this._initWeekDayList()},_parseDate:function(dateValue){var re=this.re;var result={};var parsedDate=null;for(var idx in re){if(parsedDate=dateValue.match(re[idx])){for(var i=0;i<idx.length;i++){result[idx.charAt(i)]=parsedDate[i+1]}}}return result},check:function(dateValue){if(dateValue==""){return false}var regs=this._parseDate(dateValue);if(!regs.d||!regs.y||(regs.d<1||regs.d>31)||(regs.m<1||regs.m>12)||(regs.y<this.minYear||regs.y>this.maxYear)){return false}return true},getObject:function(dateValue){var dateArray=this._parseDate(dateValue);return new Date(dateArray.y,(dateArray.m-1),dateArray.d)},future:function(dateArg){var formatDate=(typeof dateArg=="string")?new Date(this.getObject(dateArg)):dateArg;var formatToday=new Date();return this.compare(new Date(formatToday.getFullYear(),formatToday.getMonth(),formatToday.getDate()),formatDate)},compare:function(dateArg1,dateArg2){var formatDate1=(typeof dateArg1=="string")?new Date(this.getObject(dateArg1)):dateArg1;var formatDate2=(typeof dateArg2=="string")?new Date(this.getObject(dateArg2)):dateArg2;if(formatDate1.getTime()>formatDate2.getTime()){return false}return true},_initMonthList:function(){for(var n=0;n<12;n++){this.monthList[n]=[];for(var i in this.caseList){this.monthList[n][this.caseList[i]]=lang.get("list.date.month."+this.caseList[i]+"."+(n-(-1)))}}},_initWeekDayList:function(){for(var n=0;n<7;n++){this.weekDayList[n]=[];for(var i in this.caseList){this.weekDayList[n][this.caseList[i]]=lang.get("list.date.weekday."+this.caseList[i]+"."+n)}}},getMonthName:function(n,wordCase){return this.monthList[n][wordCase]},getWeekDayName:function(n,wordCase){return this.weekDayList[n][wordCase]},format:function(date,format){date=(typeof date=="string"?this.getObject(date):date);var day=date.getDate();var dayZ=this._addLeadingZero(day);var month=date.getMonth();var monthZ=this._addLeadingZero(month);var year=date.getFullYear();var weekDay=date.getDay();if(format=="$ms"){return this.getMonthName(month,"short")}if(format=="$wd"){return this.getWeekDayName(weekDay,"nominative")}if(format=="DD $m"){return day+" "+this.getMonthName(month,"genitive")}if(format=="DD $ms"){return day+" "+this.getMonthName(month,"short")}if(format=="date"){return dayZ+"."+this._addLeadingZero(month-(-1))+"."+year}throw"Format "+format+" not implemented"},_addLeadingZero:function(num){return(num<10?"0":"")+num},add:function(date,shift){var newDate=(typeof date=="string"?this.getObject(date):date);newDate.setDate(newDate.getDate()-(-shift));return newDate},dayAfter:function(date){return this.add(date,1)},dayBefore:function(date){return this.add(date,-1)},checkAge:function(birthDay,checkDay,minAge,maxAge){var birthDate=this.getObject(birthDay);var checkTime=this.getObject(checkDay).getTime();var minDate=new Date(birthDate.getFullYear()-(-minAge),birthDate.getMonth()-1,birthDate.getDate());var maxDate=new Date(birthDate.getFullYear()-(-maxAge),birthDate.getMonth()-1,birthDate.getDate());return minDate.getTime()<checkTime&&maxDate.getTime()>checkTime
}});RM.Date=new RM_Date();var RM_Text=RM.Class.extend({init:function(){},ltrim:function(str,charlist){charlist=!charlist?" s\xA0":charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g,"$1");var re=new RegExp("^["+charlist+"]+","g");return str.replace(re,"")},rtrim:function(str,charlist){charlist=!charlist?" s\xA0":charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g,"$1");var re=new RegExp("["+charlist+"]+$","g");return str.replace(re,"")},trim:function(str,charlist){return this.rtrim(this.ltrim(str,charlist),charlist)},declineNouns:function(value,names){var value=parseInt(Math.abs(value));var remainder10=(value<10)?value:value%10;var remainder100=(value<100)?value:value%100;if(remainder10==1&&remainder100!=11){result=names[0]}else{if($.inArray(remainder10,[2,3,4])!=-1&&$.inArray(remainder100,[12,13,14])==-1){result=names[1]}else{result=names[2]}}return result}});RM.Text=new RM_Text();var RM_Tutu_Avia_Order_Block=RM.Class.extend({parent:null,obValidator:null,fields:{},blocks:{sub:[]},name:null,settings:{data:{}},coreSettings:{},init:function(parent,obValidator,settings){var obSelf=this;this.parent=parent;this.fields={};this.blocks={sub:[]};this.obValidator=obValidator;settings=$.extend({},this.coreSettings,settings);this.settings=$.extend({},this.settings,settings);this.initForm()},initForm:function(){},addField:function(field){this.fields[field.name]=field},getField:function(name){return this.fields[name]},addBlock:function(block){if(block.name){this.blocks[block.name]=block}else{this.blocks.sub.push(block)}},validateField:function(field,first,ruleType){if(!field){return true}var fieldCheck=field.validate(this.obValidator,ruleType);if(!fieldCheck[0]){field.error(first,fieldCheck[1],ruleType)}else{field.ok(ruleType)}return fieldCheck[0]},validateBlock:function(block,first){return block.validate(first)},validate:function(first){var fields=this.fields;var blocks=this.blocks;var field=null;var block=null;var i,j,l;var fieldCheck=null;var blockCheck=null;var ok=first;var firstToFocus=null;for(i in fields){field=fields[i];if(!field.active){continue}fieldCheck=this.validateField(field,ok,"form");if(!fieldCheck){if(ok){firstToFocus=field}ok=false}}for(i in blocks){block=blocks[i];if(i=="sub"){l=block.length;for(j=0;j<l;j++){blockCheck=block[j].validate(ok);if(!blockCheck){ok=false}}}else{blockCheck=blocks[i].validate(ok);if(!blockCheck){ok=false}}}if(firstToFocus){this._scrollToTop();firstToFocus.focus()}return ok},_scrollToTop:function(){var pos=$(this.parent).position().top-$(window).height()/4;$("html,body").animate({scrollTop:pos},300)},getData:function(){var result={};var fields=this.fields;var field=null;var i;for(i in fields){field=fields[i];result[field.name]=field.getData()}return result}});var RM_Translit=RM.Class.extend({table:{rus_latin:[{rus:"а",latin:"a"},{rus:"б",latin:"b"},{rus:"в",latin:"v"},{rus:"г",latin:"g"},{rus:"д",latin:"d"},{rus:"е",latin:"e"},{rus:"ё",latin:"yo"},{rus:"ж",latin:"zh"},{rus:"з",latin:"z"},{rus:"и",latin:"i"},{rus:"й",latin:"y"},{rus:"к",latin:"k"},{rus:"л",latin:"l"},{rus:"м",latin:"m"},{rus:"н",latin:"n"},{rus:"о",latin:"o"},{rus:"п",latin:"p"},{rus:"р",latin:"r"},{rus:"с",latin:"s"},{rus:"т",latin:"t"},{rus:"у",latin:"u"},{rus:"ф",latin:"f"},{rus:"х",latin:"kh"},{rus:"ц",latin:"ts"},{rus:"ч",latin:"ch"},{rus:"ш",latin:"sh"},{rus:"щ",latin:"shch"},{rus:"ъ",latin:'"'},{rus:"ы",latin:"y"},{rus:"ь",latin:"'"},{rus:"э",latin:"e"},{rus:"ю",latin:"yu"},{rus:"я",latin:"ya"},{rus:"А",latin:"A"},{rus:"Б",latin:"B"},{rus:"В",latin:"V"},{rus:"Г",latin:"G"},{rus:"Д",latin:"D"},{rus:"Е",latin:"E"},{rus:"Ё",latin:"Yo"},{rus:"Ж",latin:"Zh"},{rus:"З",latin:"Z"},{rus:"И",latin:"I"},{rus:"Й",latin:"Y"},{rus:"К",latin:"K"},{rus:"Л",latin:"L"},{rus:"М",latin:"M"},{rus:"Н",latin:"N"},{rus:"О",latin:"O"},{rus:"П",latin:"P"},{rus:"Р",latin:"R"},{rus:"С",latin:"S"},{rus:"Т",latin:"T"},{rus:"У",latin:"U"},{rus:"Ф",latin:"F"},{rus:"Х",latin:"Kh"},{rus:"Ц",latin:"Ts"},{rus:"Ч",latin:"Ch"},{rus:"Ш",latin:"Sh"},{rus:"Щ",latin:"Shch"},{rus:"Ъ",latin:'"'},{rus:"Ы",latin:"Y"},{rus:"Ь",latin:"'"},{rus:"Э",latin:"E"},{rus:"Ю",latin:"Yu"},{rus:"Я",latin:"Ya"}],latin_rus:[{latin:"tion",rus:"шн"},{latin:"sion",rus:"шн"},{latin:"ee",rus:"и"},{latin:"оо",rus:"у"},{latin:"ia",rus:"ия"},{latin:"ca",rus:"ка"},{latin:"co",rus:"ко"},{latin:"ci",rus:"ци"},{latin:"ce",rus:"це"},{latin:"cu",rus:"кью"},{latin:"cy",rus:"ци"},{latin:"ph",rus:"ф"},{latin:"qu",rus:"кв"},{latin:"ck",rus:"к"},{latin:"ch",rus:"ч"},{latin:"ei",rus:"и"},{latin:"sh",rus:"ш"},{latin:"th",rus:"с"},{latin:"gi",rus:"джи"},{latin:"ge",rus:"дж"},{latin:"a",rus:"а"},{latin:"b",rus:"б"},{latin:"c",rus:"с"},{latin:"d",rus:"д"},{latin:"e",rus:"е"},{latin:"f",rus:"ф"},{latin:"g",rus:"г"},{latin:"h",rus:"х"},{latin:"i",rus:"ай"},{latin:"j",rus:"дж"},{latin:"k",rus:"к"},{latin:"l",rus:"л"},{latin:"m",rus:"м"},{latin:"n",rus:"н"},{latin:"o",rus:"о"},{latin:"p",rus:"п"},{latin:"q",rus:"кю"},{latin:"r",rus:"р"},{latin:"s",rus:"с"},{latin:"t",rus:"т"},{latin:"u",rus:"ю"},{latin:"v",rus:"в"},{latin:"w",rus:"в"},{latin:"x",rus:"кс"},{latin:"y",rus:"и"},{latin:"z",rus:"з"},{latin:"j",rus:"дж"},{latin:"x",rus:"кс"},{latin:"w",rus:"в"},{latin:"x",rus:"кс"},{latin:"TION",rus:"ШН"},{latin:"SION",rus:"ШН"},{latin:"EE",rus:"И"},{latin:"OO",rus:"У"},{latin:"IA",rus:"ИЯ"},{latin:"CA",rus:"КА"},{latin:"CO",rus:"КО"},{latin:"CI",rus:"ЦИ"},{latin:"CE",rus:"ЦЕ"},{latin:"CU",rus:"КЬЮ"},{latin:"CY",rus:"ЦИ"},{latin:"PH",rus:"Ф"},{latin:"QU",rus:"КВ"},{latin:"CK",rus:"К"},{latin:"CH",rus:"Ч"},{latin:"EI",rus:"И"},{latin:"SH",rus:"Ш"},{latin:"TH",rus:"С"},{latin:"GI",rus:"ДЖИ"},{latin:"GE",rus:"ДЖ"},{latin:"A",rus:"А"},{latin:"B",rus:"Б"},{latin:"C",rus:"С"},{latin:"D",rus:"Д"},{latin:"E",rus:"Е"},{latin:"F",rus:"Ф"},{latin:"G",rus:"Г"},{latin:"H",rus:"Х"},{latin:"I",rus:"АЙ"},{latin:"J",rus:"ДЖ"},{latin:"K",rus:"К"},{latin:"L",rus:"Л"},{latin:"M",rus:"М"},{latin:"N",rus:"Н"},{latin:"O",rus:"О"},{latin:"P",rus:"П"},{latin:"Q",rus:"КЮ"},{latin:"R",rus:"Р"},{latin:"S",rus:"С"},{latin:"T",rus:"Т"},{latin:"U",rus:"Ю"},{latin:"V",rus:"В"},{latin:"W",rus:"В"},{latin:"X",rus:"КС"},{latin:"Y",rus:"И"},{latin:"Z",rus:"З"},{latin:"J",rus:"ДЖ"},{latin:"X",rus:"КС"},{latin:"W",rus:"В"},{latin:"X",rus:"КС"}]},init:function(){},_table:function(from,to){var result=[];
var collector=new Array([],[],[],[],[],[]);$(this.table[from+"_"+to]).each(function(){collector[this[from].length][collector[this[from].length].length]=this});for(var i=collector.length-1;i>=0;i--){for(var j=0;j<collector[i].length;j++){result[result.length]=collector[i][j]}}return result},rusToLatin:function(text){$(this._table("rus","latin")).each(function(){text=text.replace(new RegExp(this.rus,"g"),this.latin)});return text},latinToRus:function(text){$(this._table("latin","rus")).each(function(){text=text.replace(new RegExp(this.latin,"g"),this.rus)});return text}});RM.Translit=new RM_Translit();var RM_Tutu_Avia_Order_Form_Field=RM.Class.extend({name:null,langName:null,parent:null,element:null,state:"ok",focused:false,errorCode:null,errorParams:null,active:true,settings:{rules:[],deactivate:function(){},activate:function(){},onBlur:function(){},onKeyUp:function(){},showTooltip:true},coreSettings:{},popupSeed:null,init:function(name,langName,parent,settings){this.name=name;this.langName=langName;this.parent=parent;settings=$.extend({},this.coreSettings,settings);this.settings=$.extend({},this.settings,settings);this.element=this.getElement();this._initField()},getElement:function(){throw"abstract method getElement has to be implemented"},getData:function(){return this.getPreparedValue()},_initField:function(){this._initEvents()},_initEvents:function(){var obSelf=this;if(this.element){$(this.element).focus(function(){obSelf.onFocus()}).blur(function(){obSelf.onBlur()}).keyup(function(){obSelf.settings.onKeyUp.apply(obSelf)})}},onFocus:function(){this.focused=true;this.showPopup();this.setState("ok")},onBlur:function(){this.focused=false;this.hidePopup();this.settings.onBlur.apply(this)},hidePopup:function(){$(this.parent).find(".rm-field-popup-position").empty()},showPopup:function(){if(this.state!="error"&&!this.settings.showTooltip){return}var obSelf=this;var popupSeed=null;this.hidePopup();var contentBlock=this.getPopupContent();$(this.parent).find(".rm-field-popup-position").append(contentBlock);$(contentBlock).show();if(this.state=="error"){var showTime=5000}else{var showTime=3000}popupSeed=Math.random();this.popupSeed=popupSeed;setTimeout(function(){if(obSelf.popupSeed!=popupSeed){return}obSelf.hidePopup();if(obSelf.state=="error"&&obSelf.focused){obSelf.setState("ok");obSelf.showPopup()}},showTime)},setState:function(state,modifyClass){this.state=state;if(modifyClass!==false){if(this.state=="error"){$(this.parent).addClass("error")}else{$(this.parent).removeClass("error")}}},getPopupContent:function(){var block=RM.tmpl(this._getTemplateName(),{message:this._getMessage()});return block},_getTemplateName:function(){if(this.state=="error"){return"avia_order_order_form_field_popup_attention"}else{return"avia_order_order_form_field_popup_tooltip"}},_getMessage:function(){if(this.state=="error"){return this._getErrorMessage(this.errorCode,this.errorParams)}else{return this._getTooltipMessage()}},getValue:function(){return $(this.element).val()},getPreparedValue:function(){return this.getValue()},setValue:function(value){if(this.element){$(this.element).val(value)}},error:function(first,errorCode,ruleType){var i,rules=this.getRules(ruleType);this.errorCode=errorCode;for(i=0;i<rules.length;i++){if(rules[i][0]==errorCode){this.errorParams=rules[i][1]}}this.setState("error");if(ruleType=="form"){if(first){this.showPopup()}}else{this.showPopup();this.setState("ok",false)}},ok:function(ruleType){this.setState("ok");this.hidePopup();if(this.focused){this.showPopup()}},deactivate:function(clean){this.active=false;if(clean===true){this.setValue("")}this.settings.deactivate.apply(this)},activate:function(){this.active=true;this.settings.activate.apply(this)},_getErrorMessage:function(error,params){return RM.L("avia.order.error."+this.langName+"."+error,params)},_getTooltipMessage:function(){return RM.L("avia.order.tooltip."+this.langName)},getRules:function(type){return this.settings.rules[type]},focus:function(){if(this.element){this.element.get(0).focus()}},validate:function(obValidator,ruleType){return obValidator.check(this.getValue(),this.getRules(ruleType))}});var RM_Tutu_Avia_Order_Form_FieldName=RM_Tutu_Avia_Order_Form_Field.extend({getElement:function(){return $(this.parent).find(".rm-data-input")}});var RM_Tutu_Avia_Order_Form_FieldPhone=RM_Tutu_Avia_Order_Form_FieldName.extend({getPreparedValue:function(){var value=this.getValue();var newVal=value.replace(/-/g,"").replace(/_/g,"").replace(/\(/g,"").replace(/\)/g,"").replace(/\s/g,"");return newVal}});var RM_Tutu_Avia_Order_Form_FieldSelect=RM_Tutu_Avia_Order_Form_Field.extend({coreSettings:{showTooltip:false},_initEvents:function(){var obSelf=this;this._super();$(this.element).change(function(){obSelf.onBlur()})},getElement:function(){return $(this.parent).find(".rm-data-select")}});var RM_Tutu_Avia_Order_Customer=RM_Tutu_Avia_Order_Block.extend({name:"customer",settings:{onDataTransfer:function(data){}},init:function(parent,obValidator,settings){var obSelf=this;
this._super(parent,obValidator,settings);this.obValidator.addRule("not_empty_reg",function(value,params){console.log(value);if(!value){return false}return/^[a-zA-Zа-яА-Я]*$/.test(value.replace(/\s/g,"").replace(/-/g,""))}).addRule("phone",function(value,params){if(!value){return true}return/^\+?\d?\-?\(?\d\d\d\)?\-?\d\d\d\-?\d\d-?\d\d$/.test(value.replace(/\s/g,""))}).addRule("email",function(value,params){if(!value){return true}return/^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.(aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|travel|mobi|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i.test(value)})},initForm:function(){var obSelf=this;$(this.parent).find(".addme_link").click(function(){obSelf.settings.onDataTransfer(obSelf.getTransferData())});this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_sname","customer_lname",$(this.parent).find(".rm-field-lname").get(0),{rules:{form:[["not_empty_reg",{regUrl:url.get("user.registration")}]],blur:[["not_empty",""],["not_empty_reg",{regUrl:url.get("user.registration")}]]},onBlur:function(){obSelf.validateField(this,true,"blur")},showTooltip:false}));this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_fname","customer_fname",$(this.parent).find(".rm-field-fname").get(0),{rules:{form:[["not_empty_reg",{regUrl:url.get("user.registration")}]],blur:[["not_empty",""],["not_empty_reg",{regUrl:url.get("user.registration")}]]},onBlur:function(){obSelf.validateField(this,true,"blur")},showTooltip:false}));this.addField(new RM_Tutu_Avia_Order_Form_FieldPhone("contact_phone","customer_phone",$(this.parent).find(".rm-field-phone").get(0),{rules:{form:[["phone",""],["not_empty",""]],blur:[["phone",""],["not_empty",""]]},onBlur:function(){obSelf.validateField(this,true,"blur")}}));this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_email","customer_email",$(this.parent).find(".rm-field-email").get(0),{rules:{form:[["email",""],["not_empty",""]],blur:[["email",""],["not_empty",""]]},onBlur:function(){obSelf.validateField(this,true,"blur")}}));if($(this.parent).find(".rm-field-address").length){this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_zipcode","customer_zipcode",$(this.parent).find(".rm-field-zipcode").get(0),{rules:{form:[["not_empty",""]]}}));this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_city","customer_city",$(this.parent).find(".rm-field-addrcity").get(0),{rules:{form:[["not_empty",""]]}}));this.addField(new RM_Tutu_Avia_Order_Form_FieldName("contact_address","customer_address",$(this.parent).find(".rm-field-address").get(0),{rules:{form:[["not_empty",""]]}}));this.addField(new RM_Tutu_Avia_Order_Form_FieldSelect("contact_country","customer_country",$(this.parent).find(".rm-field-country").get(0),{rules:{form:[["not_empty",""]]}}))}},processAddMe:function(data){var required=["fname","sname"];var canShow=true;var transferData=this.getTransferData();for(var i in data){if(data[i].length>0&&((transferData[i]!==undefined&&transferData[i].length>0)||($.inArray(i,required)!=-1))){canShow=false}}if(canShow){this.showAddMe()}else{this.hideAddMe()}},hideAddMe:function(){$(this.parent).find(".addme_link").addClass("dNone")},showAddMe:function(){$(this.parent).find(".addme_link").removeClass("dNone")},isFullAddMe:function(){var a=$(this.parent).find('input[name="fname"]').val()==$(this.parent).find('input[name="init_fname"]').val();var b=$(this.parent).find('input[name="sname"]').val()==$(this.parent).find('input[name="init_sname"]').val();return a&&b},getTransferData:function(){var fullInfo=this.isFullAddMe();var result={fname:this._sanitizeName(RM.Translit.rusToLatin($(this.parent).find('input[name="fname"]').val())),sname:this._sanitizeName(RM.Translit.rusToLatin($(this.parent).find('input[name="sname"]').val())),birthday:fullInfo?$(this.parent).find('input[name="birthday"]').val():"",sex:fullInfo?$(this.parent).find('input[name="sex"]').val():""};return result},_sanitizeName:function(str){return str.replace(/'/g,"").replace(/"/g,"")}});var RM_Tutu_Avia_Order_Form_FieldDate=RM_Tutu_Avia_Order_Form_Field.extend({getElement:function(){return $(this.parent).find("input.rm-data-input")},_initField:function(){var obSelf=this;this._initEvents();$(this.element).mask("99.99.9999",{placeholder:"_"});$(this.element).blur(function(){obSelf.settings.onKeyUp.apply(obSelf)})},getPreparedValue:function(){var value=this.getValue();var newVal=value.replace(/\./g,"").replace(/_/g,"");if(!newVal){return newVal}return value}});var RM_Tutu_Avia_Order_Form_FieldDocumentNumber=RM_Tutu_Avia_Order_Form_FieldName.extend({coreSettings:{obTypeField:null},_maskList:{passport:"9999-999999",international:"99-9999999"},_initField:function(){var obSelf=this;this._initEvents();$(this.element).blur(function(){obSelf.settings.onKeyUp.apply(obSelf)})},setMask:function(type){$(this.element).unmask();if(this._maskList[type]){$(this.element).mask(this._maskList[type],{placeholder:"_",allowCleanInvalid:false,hideMaskOnBlur:false})
}},getPreparedValue:function(){var value=this.getValue();return newVal=value.replace(/-/g,"").replace(/_/g,"")},_getTooltipMessage:function(){return RM.L("avia.order.tooltip."+this.langName+"."+this.settings.obTypeField.getValue())}});var RM_Tutu_Avia_Order_Form_FieldDocumentType=RM_Tutu_Avia_Order_Form_Field.extend({type:null,coreSettings:{onChange:function(){},onHandlerClick:function(){},"default":null,typeList:[]},_initField:function(){var obSelf=this;$(this.parent).find(".rm-field-document-type-handler").click(function(event){obSelf.settings.onHandlerClick();if(!$(obSelf.parent).find(".rm-field-popup-position .rm-field-popup").length){obSelf._showTypePopup();obSelf._unBubble(event)}else{obSelf.hidePopup()}}).mouseup(function(){$(this).removeClass("pressed")}).mouseleave(function(){$(this).removeClass("pressed")}).mousedown(function(){$(this).addClass("pressed")});$("body").click(function(){obSelf.hidePopup()});this.type=this.settings["default"];this._selectType(this.type)},_showTypePopup:function(){var obSelf=this;this.hidePopup();var obPopup=$(this.parent).find(".rm-field-popup-position");var contentBlock=RM.tmpl("avia_order_order_form_field_popup_document_type",this._getTypes());obPopup.append(contentBlock);$(obPopup).click(function(event){obSelf._unBubble(event)});$(obPopup).find(".rm-document-type-option").click(function(event){var newType=$(this).attr("rel");if(obSelf.type!=newType){obSelf._selectType(newType);obSelf.hidePopup()}obSelf._unBubble(event)})},_selectType:function(value){var obSelf=this;this.type=value;$(this.parent).find(".rm-field-document-type-handler-text").html(obSelf._getTypeLabel(value));this.settings.onChange(value)},_getTypes:function(){var obSelf=this;var i;var data=[];var types=this.settings.typeList;for(i=0;i<types.length;i++){data.push({name:types[i],label:obSelf._getTypeLabel(types[i]),"class":obSelf.type==types[i]?"inactive":""})}return{typesLength:data.length,types:data}},_getTypeLabel:function(name){return RM.L("list.avia.order.document_type_short."+name)},getElement:function(){return null},getValue:function(){return this.type},_unBubble:function(event){event=event||window.event;event.cancelBubble=true;if(event.stopPropagation){event.stopPropagation()}}});var RM_Tutu_Avia_Order_Form_FieldDocumentTypeSimple=RM_Tutu_Avia_Order_Form_Field.extend({type:null,coreSettings:{onChange:function(){},onHandlerClick:function(){},"default":null,typeList:[]},_initField:function(){var obSelf=this;$(this.parent).find("select").click(function(event){obSelf.settings.onHandlerClick()}).change(function(){obSelf.settings.onChange(obSelf.getValue())}).mouseup(function(){$(this).removeClass("pressed")}).mouseleave(function(){$(this).removeClass("pressed")}).mousedown(function(){$(this).addClass("pressed")});this.type=this.settings["default"];this.settings.onChange(this.type)},getElement:function(){return null},getValue:function(){return $(this.parent).find("select").val()}});var RM_Tutu_Avia_Order_Form_FieldHidden=RM_Tutu_Avia_Order_Form_Field.extend({getElement:function(){return $(this.parent)}});var RM_Tutu_Avia_Order_Form_FieldSex=RM_Tutu_Avia_Order_Form_Field.extend({value:null,coreSettings:{onChange:function(){},"default":""},_initField:function(){var obSelf=this;this.value=(this.settings["default"]=="M"?"man":(this.settings["default"]=="F"?"woman":""));$(this.parent).find(".sex_item").click(function(){obSelf._selectSex(this)})},_selectSex:function(item){var newSex=$(item).attr("rel");var oldSex=this.getValue();if(newSex!=oldSex){this.setSex(newSex)}},setSex:function(value){this.setValue(value);this.settings.onChange(this)},getValue:function(){return this.value},getPreparedValue:function(){if(!this.value){return""}return this.value=="man"?"M":"F"},setValue:function(value){this.value=value},getElement:function(){return null}});var RM_Tutu_Avia_Order_Passenger=RM_Tutu_Avia_Order_Block.extend({docFormats:{passport:"^\\d{10}$",international:"^\\d{9}$",birthcert:"^[IVXLCDM]*[ABCEHKMOPTXYА-Яа-я]{2}\\d{6}$",foreign:"^.+$"},coreSettings:{onDataEntered:function(data){},onDataCleared:function(){},data:{}},init:function(parent,obValidator,settings){var obSelf=this;this._super(parent,obValidator,settings);this.obValidator.addRule("not_spaces",function(value,params){return RM.Text.trim(value," -")?true:false});this.obValidator.addRule("not_empty_trim",function(value,params){return RM.Text.trim(value," -")?true:false});this.obValidator.addRule("latin_not_spaces",function(value,params){return/^[a-zA-Z]*$/.test(RM.Text.trim(value," -"))});this.obValidator.addRule("latin_and_spaces",function(value,params){return/^[a-zA-Z]+$/.test(value.replace(/\s/g,"").replace(/-/g,""))});this.obValidator.addRule("latin_and_spaces_empty",function(value,params){return/^[a-zA-Z]*$/.test(value.replace(/\s/g,"").replace(/-/g,""))});this.obValidator.addRule("unmasked_date",function(value,params){value=obSelf._unmaskDate(value);return !value||RM.Date.check(value)});this.obValidator.addRule("unmasked_date_not_empty",function(value,params){value=obSelf._unmaskDate(value);
return value&&RM.Date.check(value)});this.obValidator.addRule("unmasked_not_empty",function(value,params){value=value.replace(/\s/g,"").replace(/-/g,"").replace(/_/g,"").replace(/\./g,"");return value&&1});this.obValidator.addRule("unmasked_date_after",function(value,params){value=obSelf._unmaskDate(value);return !value||RM.Date.compare(params.date,value)});this.obValidator.addRule("not_spaces_inside",function(value,params){value=RM.Text.trim(value," -");return value.indexOf(" ")==-1&&value.indexOf("-")==-1});this.obValidator.addRule("doc_format",function(value,params){value=value.replace(/\s/g,"").replace(/-/g,"").replace(/_/g,"");if(!value){return true}var docType=params.field.getValue();var reg=new RegExp(obSelf.docFormats[docType]);return reg.test(value)});this.obValidator.addRule("birthday",function(value,params){value=obSelf._unmaskDate(value);if(!value){return true}if(params.type=="adult"){return true}if(params.type=="children"){return RM.Date.checkAge(value,params.date,0,12)}else{return RM.Date.checkAge(value,params.date,0,2)}});this.obValidator.addRule("not_future",function(value,params){value=obSelf._unmaskDate(value);return !value||!RM.Date.future(value)})},initForm:function(){var obSelf=this;var passengerItem=$(this.parent);obSelf.addField(new RM_Tutu_Avia_Order_Form_FieldHidden("class","type",$(passengerItem).find(".rm-passenger-type").get(0),{}));$(passengerItem).find(".rm-sex-type").each(function(){obSelf.addField(obSelf.initSexField("sex","sex",this,{rules:{form:[["not_empty",[]]]},onChange:function(object){$(obSelf.parent).removeClass("man woman").addClass(object.getValue());obSelf.validateField(object,true);obSelf._onFieldKeyUp()},"default":obSelf.settings.data.sex?obSelf.settings.data.sex:""}))});$(passengerItem).find(".rm-field-lname").each(function(){obSelf.addField(obSelf.initNameField("sname","lname",this,{rules:{form:[["not_empty_trim",[]],["latin_and_spaces",[]]],blur:[["not_empty_trim",[]],["latin_and_spaces_empty",[]]]},onBlur:function(){obSelf.validateField(this,true,"blur")},onKeyUp:function(){obSelf._onFieldKeyUp()}}))});$(passengerItem).find(".rm-field-fname").each(function(){obSelf.addField(obSelf.initNameField("fname","fname",this,{rules:{form:[["not_empty_trim",[]],["latin_and_spaces",[]]],blur:[["not_empty_trim",[]],["latin_and_spaces_empty",[]]]},onBlur:function(){obSelf.validateField(this,true,"blur")},onKeyUp:function(){obSelf._onFieldKeyUp()}}))});var birthdayData=["birthday",{type:obSelf.settings.type,date:obSelf.settings.arrivalDate,type_str:RM.L("avia.gds.order_psgr_type_short_"+obSelf.settings.type),date_str:RM.Date.format(obSelf.settings.arrivalDate,"DD $m")}];$(passengerItem).find(".rm-field-birthday").each(function(){obSelf.addField(obSelf.initDateField("birthday","birthday",this,{rules:{form:[["not_future",[]],["unmasked_date_not_empty",[]],birthdayData],blur:[["not_future",[]],["unmasked_date_not_empty",[]],birthdayData]},onBlur:function(){obSelf.validateField(this,true,"blur")},onKeyUp:function(){obSelf._onFieldKeyUp()}}))});this.initDocumentFields(passengerItem);this.settings.onDataEntered.apply(this,[this._getFilledData()])},initSexField:function(name,langName,domElement,settings){return new RM_Tutu_Avia_Order_Form_FieldSex(name,langName,domElement,settings)},initNameField:function(name,langName,domElement,settings){return new RM_Tutu_Avia_Order_Form_FieldName(name,langName,domElement,settings)},initDateField:function(name,langName,domElement,settings){return new RM_Tutu_Avia_Order_Form_FieldDate(name,langName,domElement,settings)},initDocumentTypeField:function(name,langName,domElement,settings){return new RM_Tutu_Avia_Order_Form_FieldDocumentType(name,langName,domElement,settings)},initDocumentTypeFieldSimple:function(name,langName,domElement,settings){return new RM_Tutu_Avia_Order_Form_FieldDocumentTypeSimple(name,langName,domElement,settings)},_unmaskDate:function(value){var newVal=value.replace(/\./g,"").replace(/_/g,"");if(!newVal){return newVal}return value},initDocumentFields:function(parentDomElement){var obSelf=this;var passengerType=$(parentDomElement).hasClass("adult")?"adult":($(parentDomElement).hasClass("child")?"children":"infants");var obExpireElement=$(parentDomElement).find(".rm-field-expiredate").get(0);var obExpireField=obSelf.initDateField("document_expiredate","expiredate",obExpireElement,{rules:{form:[["unmasked_not_empty"],["unmasked_date",[]],["unmasked_date_after",{date:obSelf.settings.arrivalDate}]],blur:[["unmasked_not_empty"],["unmasked_date",[]],["unmasked_date_after",{date:obSelf.settings.arrivalDate}]]},deactivate:function(){$(parentDomElement).find("li.rm-expire-date").hide()},activate:function(){$(parentDomElement).find("li.rm-expire-date").show()},onBlur:function(){obSelf.validateField(this,true,"blur")},onKeyUp:function(){obSelf._onFieldKeyUp()}});var obDocumentType=$(parentDomElement).find(".rm-field-document-type").get(0);if($(obDocumentType).find("select").length){var obDocumentTypeField=obSelf.initDocumentTypeFieldSimple("document_type","document_type",obDocumentType,{rules:{},onChange:function(value){var obDocNumber=obSelf.getField("document_number");
if(value=="international"){obExpireField.activate()}else{obExpireField.deactivate(true)}if(obDocNumber){obDocNumber.setValue(obDocNumber.getPreparedValue());obSelf.validateField(obDocNumber,true,"blur");obDocNumber.setMask(value)}},onHandlerClick:function(){obSelf.settings.onDocumentTypeHandler()},"default":obSelf.settings.data.document_type?obSelf.settings.data.document_type:obSelf._getDefaultDocumentType(passengerType),typeList:obSelf._getDocumentTypeList(passengerType)})}else{var obDocumentTypeField=obSelf.initDocumentTypeField("document_type","document_type",obDocumentType,{rules:{},onChange:function(value){var obDocNumber=obSelf.getField("document_number");if(value=="international"){obExpireField.activate()}else{obExpireField.deactivate(true)}if(obDocNumber){obDocNumber.setValue(obDocNumber.getPreparedValue());obSelf.validateField(obDocNumber,true,"blur");obDocNumber.setMask(value)}},onHandlerClick:function(){obSelf.settings.onDocumentTypeHandler()},"default":obSelf.settings.data.document_type?obSelf.settings.data.document_type:obSelf._getDefaultDocumentType(passengerType),typeList:obSelf._getDocumentTypeList(passengerType)})}var obDocumentNumber=$(parentDomElement).find(".rm-field-document-number").get(0);var obDocumentNumberField=new RM_Tutu_Avia_Order_Form_FieldDocumentNumber("document_number","document_number",obDocumentNumber,{rules:{form:[["unmasked_not_empty"],["doc_format",{field:obDocumentTypeField}]],blur:[["unmasked_not_empty"],["doc_format",{field:obDocumentTypeField}]]},onBlur:function(){obSelf.validateField(this,true,"blur")},onKeyUp:function(){obSelf._onFieldKeyUp()},obTypeField:obDocumentTypeField});this.addField(obDocumentNumberField);this.addField(obDocumentTypeField);this.addField(obExpireField);obDocumentNumberField.setMask(obDocumentTypeField.getValue())},_onFieldKeyUp:function(){var exclude=["class","document_type"];if(this._isEmpty(exclude)){this.settings.onDataCleared.apply(this)}else{this.settings.onDataEntered.apply(this,[this._getFilledData(exclude)])}},_isEmpty:function(ignore){var data=this._getFilledData(ignore);for(var i in data){return false}return true},_getFilledData:function(ignore){var fields=this.fields;var i,field=null;if(!ignore){ignore=[]}var result={};var val;for(i in fields){if($.inArray(i,ignore)!=-1){continue}field=fields[i];val=field.getPreparedValue();if(val){result[field.name]=val}}return result},_getDocumentTypeList:function(){return this.settings.documentList},_getDefaultDocumentType:function(){return this.settings.defaultDocument},setPassengerData:function(data){var exclude=["class","document_type"];var newData={};if(!data.sex){exclude.push("sex")}if(!data.birthday){exclude.push("birthday")}if(this._isEmpty(exclude)){this.fields.fname.setValue(data.fname);this.validateField(this.fields.fname,true,"blur");if(data.fname){newData.fname=data.fname}this.fields.sname.setValue(data.sname);this.validateField(this.fields.sname,true,"blur");if(data.sname){newData.sname=data.sname}if(data.birthday){this.fields.birthday.setValue(RM.Date.format(data.birthday,"date"));this.validateField(this.fields.birthday,true,"blur");newData.birthday=data.birthday}if(data.sex){this.fields.sex.setSex(data.sex=="m"?"man":"woman");this.validateField(this.fields.sex,true,"blur");newData.sex=data.sex}}this.settings.onDataEntered.apply(this,[newData])}});var RM_Tutu_Avia_Order_Passengers=RM_Tutu_Avia_Order_Block.extend({name:"passengers",coreSettings:{onDataEntered:function(data){},onDataCleared:function(){},storedData:[]},initForm:function(){var obSelf=this;var passengerItem=null;$(this.parent).find(".passenger_item").each(function(index){passengerItem=this;obSelf.addBlock(obSelf.initPassengerBlock(passengerItem,obSelf._getPassengerSettings(passengerItem,index)))})},_getPassengerData:function(passengerItem){var hash=$(passengerItem).find(".rm-passenger-id").val();if(!hash){return{}}var idx,storedData=this.settings.storedData;var l=storedData.length;for(idx in storedData){if(hash==storedData[idx]["id"]){return storedData[idx]}}return{}},_getPassengerSettings:function(passengerItem,index){var obSelf=this;var passengerType=this._getPassengerType(passengerItem);var result={documentList:obSelf.settings.data[passengerType].documentList,defaultDocument:obSelf.settings.data[passengerType].defaultDocument,type:passengerType,arrivalDate:obSelf.settings.arrivalDate,onDocumentTypeHandler:function(){$(obSelf.parent).find(".rm-field-document-type .rm-field-popup").empty()},index:index,data:this._getPassengerData(passengerItem)};if(index==0){result=$.extend({},result,{onDataEntered:function(data){obSelf.settings.onDataEntered.apply(obSelf,[data])},onDataCleared:function(){obSelf.settings.onDataCleared.apply(obSelf)}})}return result},_getPassengerType:function(domElement){return $(domElement).hasClass("adult")?"adult":($(domElement).hasClass("child")?"children":"infants")},initPassengerBlock:function(domElement,settings){return new RM_Tutu_Avia_Order_Passenger(domElement,this.obValidator,settings)},setPassengerData:function(index,data){this.blocks.sub[index].setPassengerData(data)
},getData:function(){var blocks=this.blocks.sub;var i,l=blocks.length;var result=[];for(i=0;i<l;i++){result.push(blocks[i].getData())}return result}});var RM_Tutu_Avia_Order_Payment=RM_Tutu_Avia_Order_Block.extend({name:"payment",currentType:"",settings:{onUpdate:function(type,price,priceFormatted){}},_payMethods:{},_cityIdx:0,init:function(parent,obValidator,settings){this._super(parent,obValidator,settings);this._initTypes();this.obValidator.addRule("phone",function(value,params){if(!value){return true}return/^\+?\d?\(?\d\d\d\)?\d\d\d\-?\d\d-?\d\d$/.test(value.replace(/\s/g,""))})},_initTypes:function(){var obSelf=this;$(this.parent).find(".methods_list").find(".pay_method").each(function(){$(this).click(function(){obSelf.selectType($(this).attr("rel"))});obSelf._initTypeFields($(this).attr("rel"))});this._selectBestType()},_initTypeFields:function(paytype){var obSelf=this;var obField=null;var methodElement=this._getForm(paytype);obSelf._payMethods[paytype]=[];$(methodElement).find(".rm-field-city").each(function(){obField=new RM_Tutu_Avia_Order_Form_FieldSelect("city"+obSelf._cityIdx,"city",this,{rules:{form:[["not_empty",""]]}});obSelf._cityIdx++;obSelf.addField(obField);obSelf._payMethods[paytype].push(obField)});$(methodElement).find(".rm-field-phone").each(function(){obField=new RM_Tutu_Avia_Order_Form_FieldPhone("phone","phone",this,{rules:{form:[["not_empty",""],["phone",""]],blur:[["not_empty",""],["phone",""]]},onBlur:function(){obSelf.validateField(this,true,"blur")}});obSelf.addField(obField);obSelf._payMethods[paytype].push(obField)});$(methodElement).find(".rm-field-comment").each(function(){obField=new RM_Tutu_Avia_Order_Form_FieldName("comment","comment",this,{rules:{}});obSelf.addField(obField);obSelf._payMethods[paytype].push(obField)})},_selectBestType:function(){var payMethodsList=$(this.parent).find(".methods_list");if(payMethodsList.find(".pay_method[rel=cardonline]").length>0){this.selectType("cardonline")}else{if(payMethodsList.find(".pay_method[rel=cash_curier]").length>0){this.selectType("cash_curier")}else{if(payMethodsList.find(".pay_method").length>0){this.selectType($(payMethodsList.find(".pay_method").get(0)).attr("rel"))}}}},selectType:function(type){this.currentType=type;$(this.parent).find(".methods_list").find(".pay_method").removeClass("selected");$(this.parent).find(".methods_list").find(".pay_method[rel="+type+"]").addClass("selected");$(this.parent).find(".methods_details > div").removeClass("active").addClass("inactive");$(this.parent).find(".methods_details > div.pay_method_"+type).removeClass("inactive").addClass("active");this.settings.onUpdate(type,this._getForm(type).find("input[name=price]").val(),this._getForm(type).find("input[name=price_format]").val());this.activateMethod(type)},activateMethod:function(type){var name,i,l;var payMethods=this._payMethods;var method=null;for(name in payMethods){method=payMethods[name];l=method.length;for(i=0;i<l;i++){method[i].deactivate()}}method=payMethods[type];l=method.length;for(i=0;i<l;i++){method[i].activate()}},updatePrices:function(newPrices){var obSelf=this;$(this.parent).find(".methods_list").find(".pay_method").each(function(){var method=$(this).attr("rel");if(newPrices[method]){obSelf._getForm(method).find("input[name=price]").val(newPrices[method]["value"]);obSelf._getForm(method).find("input[name=price_format]").val(newPrices[method]["value_format"]);$(this).find(".pay_price").html(newPrices[method]["value_format"]+" "+RM.L("avia.gds.tip_currency_concise"))}})},getCurrentMethod:function(){return this.currentType},getPriceForMethod:function(method){return this._getForm(method).find("input[name=price]").val()},_getForm:function(type){return $(this.parent).find(".methods_details > div.pay_method_"+type).find("form")},getData:function(){var data={};$(this._getForm(this.currentType).serializeArray()).each(function(){data[this.name]=this.value});return data}});var RM_Validator=RM.Class.extend({rules:{not_empty:function(value,params){return value?true:false},not_zero:function(value,params){return value!=0},date:function(value,params){return RM.Date.check(value)},future:function(value,params){return RM.Date.future(value)},not_future:function(value,params){return !RM.Date.future(value)},latin:function(value,params){return/^[a-zA-Z]*$/.test(value)}},init:function(){},addRule:function(alias,rule){this.rules[alias]=rule;return this},check:function(value,rules){if(rules!=undefined){var i,l=rules.length;for(i=0;i<l;i++){if(!this.checkRule(value,rules[i])){return[false,rules[i][0]]}}}return[true,null]},checkRule:function(value,rule){if(!this.rules[rule[0]]){throw"RM_Validator error: rule "+rule[0]+" is not implemented!"}return this.rules[rule[0]](value,rule[1])}});var RM_Tutu_Avia_Order_Object=RM.Class.extend({data:null,form:null,resultId:null,payment:null,customer:null,passengers:null,obValidator:null,inProcess:false,finishUrl:null,init:function(form,data,resultId,finishUrl){var obSelf=this;this.form=form;this.data=data;this.resultId=resultId;
this.finishUrl=finishUrl;this.obValidator=new RM_Validator();$(document).ready(function(){obSelf.payment=new RM_Tutu_Avia_Order_Payment($(obSelf.form).find(".b-wiz_paymethods").get(0),obSelf.obValidator,{onUpdate:function(type,price,price_format){var i,curAr=[];for(i=0;i<3;i++){curAr.push(RM.L("list.morphology.currency."+i))}$(obSelf.form).find(".rm-flight-price").html(price_format);$(obSelf.form).find(".rm-flight-price-currency").html(RM.Text.declineNouns(price,curAr));$(obSelf.form).find(".rm-button-block").find("span[id$=title]").html(RM.L("avia.gds.pay_with_"+type));$(obSelf.form).find("#btntxt").html(RM.L("avia.gds.pay_with_"+type))}});obSelf.customer=new RM_Tutu_Avia_Order_Customer($(obSelf.form).find(".buyer_data").get(0),obSelf.obValidator,{onDataTransfer:function(data){obSelf.passengers.setPassengerData(0,data)}});obSelf.passengers=new RM_Tutu_Avia_Order_Passengers($(obSelf.form).find(".passengers_data").get(0),obSelf.obValidator,{data:data.passengers,arrivalDate:RM.Date.format(data.arrivalDate,"date"),onDataEntered:function(data){obSelf.customer.processAddMe(data)},onDataCleared:function(){obSelf.customer.processAddMe({})},storedData:data.data?data.data["psgr"]:{}});$(obSelf.form).find("#idorderBuyButton").click(function(){obSelf.process();return false});$(obSelf.form).find(".price-changed").each(function(){var element=this;$(element).find(".line_below").click(function(){$(element).find(".popup_position").toggleClass("dNone")})})})},process:function(){var ok=true;if(!this.customer.validate(ok)){ok=false}if(!this.passengers.validate(ok)){ok=false}if(!this.payment.validate(ok)){ok=false}if(ok){this._createPnr()}},_createPnr:function(){var obSelf=this;if(this.inProcess){return}var data=this.getData();data.result_id=this.resultId;this._startProcess();var xhr=$.ajax({url:url.get("ajax",{},{Action:"avia_order"}),data:data,dataType:"json",type:"POST",success:function(data,textStatus,jqXHR){obSelf._endProcess();if(!data||data.error){obSelf._processError(data)}else{if(data.new_price){obSelf._processPriceChanged(data.new_price)}else{obSelf._processSuccess()}}},error:function(jqXHR,textStatus,errorThrown){obSelf._endProcess();obSelf._processError({error:"flight_not_confirmed"})}})},_processError:function(response){if(response.error=="validator"){$(this.form).find(".rm-wait-block").hide();$(this.form).find(".rm-button-block").show();var placesMessage=new Array();for(i in response.places){placesMessage.push(RM.L("avia.gds.order_error_"+response.error+"_"+response.places[i]))}this._showPopup(RM.L("avia.gds.order_error_"+response.error+"_info")+placesMessage.join(", ")+".")}else{$(this.form).find(".rm-wait-block").hide();$(this.form).find(".rm-error-block").html(RM.L("avia.gds.order_error_"+response.error)).show();this._showPopup(RM.L("avia.gds.order_error_flight_not_confirmed_info",{url:$("#offersLink").attr("href")}))}},_processPriceChanged:function(newPrice){$(this.form).find(".rm-wait-block").hide();$(this.form).find(".rm-button-block").show();var currentPrice=this.payment.getPriceForMethod(this.payment.getCurrentMethod());var diff=Math.ceil(newPrice.prices[this.payment.getCurrentMethod()]["value"]-this.payment.getPriceForMethod(this.payment.getCurrentMethod()));this.payment.updatePrices(newPrice.prices);this.payment.selectType(this.payment.getCurrentMethod());$(".wiz_route").find(".order_price").html(newPrice.prices["cash"]["value"]+" "+RM.L("avia.gds.tip_currency_concise"));if(diff>0){$(".wiz_route").find(".price-changed .sign").html("+")}else{$(".wiz_route").find(".price-changed .sign").html("-")}$(".wiz_route").find(".price-changed .line_below").html(Math.abs(diff)+" "+RM.L("avia.gds.tip_currency_concise"));$(".wiz_route").find(".price-changed").removeClass("dNone");if(diff>0){$(this.form).find(".rm-price-increased").show();this._showPopup(RM.L("avia.gds.order_price_increased_info",{new_price:diff}))}else{$(this.form).find(".rm-price-decreased").show();this._showPopup(RM.L("avia.gds.order_price_decreased_info",{new_price:Math.abs(diff)}))}},_processSuccess:function(){location.assign(this.finishUrl)},_startProcess:function(){this.inProcess=true;$(this.form).find(".rm-button-block").hide();$(this.form).find(".rm-error-block").html("").hide();$(this.form).find(".rm-wait-block").show()},_endProcess:function(error){this.inProcess=false},_hidePopup:function(){$(this.form).find(".rm-process-block").find(".rm-field-popup-position").empty()},_showPopup:function(content){var obSelf=this;this._hidePopup();var contentBlock=RM.tmpl("avia_order_order_form_field_popup_process_error",{message:content});$(this.form).find(".rm-process-block").find(".rm-field-popup-position").append(contentBlock);$(contentBlock).show()},getData:function(){return{payment:this.payment.getData(),passengers:this.passengers.getData(),customer:this.customer.getData()}}});var RM_Tutu_Avia_Order_Page=RM.Class.extend({orderObject:null,init:function(data,resultId,finishUrl){var obSelf=this;$(document).ready(function(){var formElement=$("#wrapper").get(0);
obSelf.orderObject=new RM_Tutu_Avia_Order_Object(formElement,data,resultId,finishUrl)})}});var RM_Tutu_Train_Order_FinalPage=RM.Class.extend({_checkBookingInterval:10,_countdownTimeBooking:15*60,_countdownBookingInterval:0,init:function(params){this._initConfirmButton();if(params&&params.bookingTimeCountdown){this._bookingCountdown(params.bookingTimeCountdown)}},_initConfirmButton:function(){$("#check1").change(function(){if($(this).attr("checked")){$("#errorBlock").hide()}});$("#step4form").submit(function(){var checkboxAgreement=$("#check1");var errorBlock=$("#errorBlock");if(!checkboxAgreement.attr("checked")){errorBlock.show();submit_button_step4.reset();return false}errorBlock.hide();return true})},_bookingCountdown:function(countdown){var obSelf=this;this._countdownTimeBooking=countdown||this._countdownTimeBooking;$(".minutes_count").hover(function(){$(".reminder_block_tooltip_text").removeClass("dNone").addClass("dBlock")},function(){$(".reminder_block_tooltip_text").removeClass("dBlock").addClass("dNone")});this._countdownTimeBooking+=this._checkBookingInterval;this._checkCountdown();this._countdownBookingInterval=setInterval(function(){obSelf._checkCountdown()},this._checkBookingInterval*1000)},_checkCountdown:function(){this._countdownTimeBooking-=this._checkBookingInterval;if(this._countdownTimeBooking<0){$(".confirm_order_reminder_block .reserve-time-info").hide();$(".confirm_order_reminder_block .reserve-timeout").fadeIn(700);clearInterval(this._countdownBookingInterval);return}var minutes=Math.ceil(this._countdownTimeBooking/60);if(minutes==0){minutes=1}var label=RM.Text.declineNouns(minutes,RM.L("train.order.reminder_block_minutes").split("|"));if(minutes<7){$(".minutes_count").removeClass("pseudoBlack").addClass("pseudoCrimson")}$(".confirm_order_reminder_block .reserve-time-info").fadeIn(700);$(".minutes_count").text(RM.L("train.order.reminder_block_timeout",{minutes:minutes,label:label}))}});var RM_Bubble=RM.Class.extend({parent:null,element:null,settings:{closeOtherBubbles:false,bubbleClass:"rm-bubble",resetOnShow:false},init:function(parent,settings){this.settings=$.extend({},this.settings,settings);this.parent=parent;$(this.parent).click(this._unBubble)},toggle:function(){if(!this.element||!$(this.element).is(":visible")){this.show()}else{$(this.element).hide()}},show:function(){var obSelf=this;if(this.settings.closeOtherBubbles){$("."+this.settings.bubbleClass).hide()}if(this.settings.resetOnShow){this.reset()}if(!this.element){this.element=this.getContent()}$(this.element).show().click(this._unBubble);$("body").click(function(){obSelf.hide()})},hide:function(){var obSelf=this;$("body").unbind("click",function(){obSelf.hide()});$(this.element).hide()},_unBubble:function(event){event=event||window.event;event.cancelBubble=true;if(event.stopPropagation){event.stopPropagation()}},reset:function(){},getContent:function(){throw"abstract method getContent has to be implemented"}});var RM_Tutu_Avia_Bubble_Class=RM_Bubble.extend({params:{onSelect:function(){}},data:{active:null},init:function(parent,settings,params,data){this._super(parent,settings);this.params=$.extend({},this.params,params);this.data=$.extend({},this.data,data)},getContent:function(){var obSelf=this;var bubbleBlock=$(RM.tmpl("avia_order_search_result_form_class",this.data));$(this.parent).find(".popup_position").append(bubbleBlock);$(bubbleBlock).find(".class-handler").click(function(){obSelf.selectClass(this)});this.redraw();return bubbleBlock},selectClass:function(element){var active=$(element).attr("rel");this.data.active=active;this.redraw();this.params.onSelect(active);this.element.hide()},redraw:function(){$(".class-handler").removeClass("selected");$('.class-handler[rel="'+this.data.active+'"]').addClass("selected")}});var RM_Tutu_Avia_Bubble_Passengers=RM_Bubble.extend({params:{onSelect:function(){}},data:{full:null,childs:null,babies:null},passTypes:{full:[],childs:[],babies:[]},init:function(parent,settings,params,data){this._super(parent,settings);this.params=$.extend({},this.params,params);this.data=$.extend({},this.data,data);for(var i in this.passTypes){this.passTypes[i]=RM.L("list.avia.order.passenger."+i).split(" ")}},getContent:function(){var obSelf=this;var data=this.data;var bubbleBlock=$(RM.tmpl("avia_order_search_result_form_passengers",{full:data.full,childs:data.childs,babies:data.babies}));$(this.parent).find(".popup_position").append(bubbleBlock);$(bubbleBlock).find(".control").mouseup(function(){obSelf.processAmount(this,true)});this.redraw();return bubbleBlock},processAmount:function(element,force){var data=this.data;var testData=$.extend({},data);var obElem=$(element);var shift=obElem.hasClass("plus")?1:-1;var name=obElem.parent().parent().attr("rel");testData[name]=testData[name]-(-shift);if(force==true){var newData=this.checkAmountRule(testData,name=="full");if(newData!=false){this.data=$.extend({},newData);this.redraw();this.params.onSelect(this.data)}}else{if(this.checkAmountRule(testData,name=="full")!=false){obElem.removeClass("inactive")
}else{obElem.addClass("inactive")}}},checkAmountRule:function(data,force){var sum=0;for(var idx in data){if(data[idx]<0){return false}sum+=data[idx]}if(data.full<1){return false}if(data.babies>data.full&&force){data.babies=data.full}if(sum>9){return false}if(sum<1){return false}if(data.babies>data.full){return false}return data},redraw:function(){var data=this.data;var obSelf=this;for(var idx in data){$(this.element).find('.item[rel="'+idx+'"]').find(".passengers_input").html(data[idx])}$(".control").each(function(){obSelf.processAmount(this,false)});$(this.parent).find(".filter_link").html(this.getDescription(data));$(this.parent).parent().find(".rm-passenger-fly").html(this.getFlyWord(data))},reset:function(){this.redraw()},getFlyWord:function(data){var sum=0;for(var idx in data){sum+=data[idx]}return RM.L("avia.passenger.fWord"+(sum>1?"s":""))},getDescription:function(data){var result="";var parts=[];parts.push(data.full+" "+this.getPassType(data,"full"));if(data.childs){parts.push(this.getTextForm(data.childs)+this.getPassType(data,"childs")+" "+RM.L("avia.passenger.beforeEleven"))}if(data.babies){parts.push(this.getTextForm(data.babies)+this.getPassType(data,"babies")+" "+RM.L("avia.passenger.beforeTwo"))}if(parts.length==1){result=parts[0]}else{var lastPart=parts.pop();result=parts.join(", ")+" "+RM.L("common.and")+" "+lastPart}return result},getPassType:function(data,type){var amount=data[type];var passType=this.passTypes[type];return amount==1?passType[0]:(amount<5?passType[1]:passType[2])},getTextForm:function(number){if(number>1){return RM.L("list.numbers."+number)+" "}return""},getHash:function(){var data=this.data;return data.full+"|"+data.childs+"|"+data.babies}});var RM_Tutu_Avia_Bubble_Suggest=RM_Bubble.extend({suggestSettings:{url:url.get("avia.city.suggest")},init:function(parent,settings,suggestSettings){this._super(parent,settings);this.suggestSettings=$.extend({},this.suggestSettings,suggestSettings)},getContent:function(){var bubbleBlock=$(RM.tmpl("avia_order_search_result_form_city",{name:this.suggestSettings.cityName,inputName:this.suggestSettings.nameName,inputId:this.suggestSettings.nameId}));$(this.parent).find(".popup_position").append(bubbleBlock);var suggestInput=$(bubbleBlock).find(".input_city_text");var obPluginSuggest=new RM_Plugin_EasySuggest(suggestInput);var obSelf=this;obPluginSuggest.init({name:this.suggestSettings.inputName,id:this.suggestSettings.inputId,inputName:this.suggestSettings.nameName,inputId:this.suggestSettings.nameId,data:this.suggestSettings.cityId,value:this.suggestSettings.cityName,url:this.suggestSettings.url,saveNames:true,noticeText:true,selectFirst:false,fireOnSelect:function(res){obSelf.onSelect(res)}});$(suggestInput).data("autocomplete")._renderItem=function(ul,item){return $('<li class="city-item"></li>').data("item.autocomplete",item).append(obSelf._getAutocompleteLine(item)).appendTo(ul)};$(bubbleBlock).find(".clear_text_button").click(function(){$(suggestInput).val("");obSelf.focus()});return bubbleBlock},_getAutocompleteLine:function(item){return'<a><span class="city_main">'+item.label+",</span>"+(item.country_name?('<span class="more_info">'+item.country_name+"</span>"):"")+"</a>"},focus:function(){$(this.element).find(".input_city_text").focus().select()},reset:function(){$(this.element).find('input[name="'+this.suggestSettings.nameId+'"]').val(this.suggestSettings.cityName)},onSelect:function(res){var cityNameForParent=((this.suggestSettings.type=="to"&&!this.suggestSettings.roundTrip)?res.name:res.name2);$(this.parent).find(".filter_link").html(cityNameForParent);$(this.parent).find(".route_country").html(res.country_name);this.suggestSettings.cityName=res.label;this.suggestSettings.cityId=res.value;$(this.element).find('input[name="'+this.suggestSettings.formCityId+'"]').val(res.value);if(this.suggestSettings.onSelect){res.type=this.suggestSettings.type;this.suggestSettings.onSelect(res)}this.hide()}});var RM_SlidePanel=RM.Class.extend({parent:null,element:null,settings:{slideEffect:"linear",slideDelay:100,holderClass:"rm-slidepanel-holder",itemClass:"rm-slidepanel-item",controlClass:"rm-slidepanel-control",slideObject:"window"},leftIdx:0,leftMargin:0,inSlide:false,left:"left",right:"right",init:function(parent,settings){this.parent=parent;this.settings=$.extend({},this.settings,settings);if(this.settings.slideObject=="window"){this.left="right";this.right="left"}},rewind:function(){this.leftIdx=0;this.leftMargin=0},reset:function(){$(this.parent).empty();this.element=null;this.inSlide=false;this.rewind()},draw:function(){var obSelf=this;var settings=this.settings;if(!this.element){this.element=this.getContent()}$(this.element).find("."+settings.controlClass).click(function(){obSelf.makeSlide($(this).attr("rel"))}).dblclick(function(){return false});this.redrawArrows();$(window).resize(function(){obSelf.redrawArrows()})},getContent:function(){throw"abstract method getContent has to be implemented"},redrawArrows:function(){var obSelf=this;
$(this.element).find("."+this.settings.controlClass).each(function(){if(obSelf.canSlide($(this).attr("rel"))){$(this).addClass("active")}else{$(this).removeClass("active")}})},canSlide:function(direction){if(direction==this.right){return(this.leftMargin<0)}var obElement=$(this.element);var rightPos=obElement.find("."+this.settings.controlClass+'[rel="right"]').position();var leftControl=obElement.find("."+this.settings.controlClass+'[rel="left"]');var leftPos=leftControl.position();var holderWidth=obElement.find("."+this.settings.holderClass).width();return(holderWidth-(-this.leftMargin)>(rightPos.left-leftPos.left-leftControl.width()))},makeSlide:function(direction){if(!this.canSlide(direction)||this.inSlide){return}this.inSlide=true;var obElement=$(this.element);var obSelf=this;var settings=this.settings;var shift=this.getSlideShift(direction);obElement.find("."+settings.holderClass).animate({"margin-left":"-="+shift},settings.slideDelay,settings.slideEffect,function(){obSelf.inSlide=false});this.leftMargin-=shift;this.leftIdx-=(direction==this.left?-1:1);this.redrawArrows()},getSlideShift:function(direction){var idx=(direction==this.left?this.leftIdx:this.leftIdx-1);var shiftElement=$(this.element).find("."+this.settings.holderClass).find(".item").eq(idx);var afterShiftElement=$(this.element).find("."+this.settings.holderClass).find(".item").eq(idx-(-1));var shiftPos=shiftElement.position();var afterShiftPos=afterShiftElement.position();var shift=afterShiftPos.left-shiftPos.left;return(direction==this.left?shift:-shift)}});var RM_Tutu_Avia_Filter_Carriers=RM_SlidePanel.extend({params:{onSelect:function(res){}},data:[],minPrice:null,minPriceStr:null,selected:[],init:function(parent,params,data){this._super(parent,params);this.params=$.extend({},this.params,params);this.initFilter(data,[])},initFilter:function(data,selected){this.data=this._prepareData(data.data);this.minPrice=data.minPrice;this.minPriceStr=data.minPriceStr;this.selected=selected;this.reset();this.draw();this.drawSelection();if(this.data.length>=1){this.enable()}},_prepareData:function(inputData){var sortAr=function(a,b){return a.price-b.price};var res=[];for(var i in inputData){res.push(inputData[i])}res.sort(sortAr);return res},show:function(){$(this.parent).removeClass("dNoneTmp")},hide:function(){$(this.parent).addClass("dNoneTmp")},isAllSelected:function(){return !this.selected.length},drawSelection:function(){var obElement=$(this.element);if(this.data.length<1){obElement.find(".item").addClass("selected")}else{obElement.find(".item").removeClass("selected");var selected=this.selected;var selectedLength=selected.length;for(var i=0;i<selectedLength;i++){obElement.find('.item[rel="carrier_'+selected[i]+'"]').addClass("selected")}if(this.isAllSelected()){obElement.find('.item[rel="carrier_all"]').addClass("selected")}}},getContent:function(){var data=this.data;if(!data){return null}var obSelf=this;var contentBlock=$(RM.tmpl("avia_order_search_result_filter_carriers",{carriers:data,carriersLength:data.length,minOverallPrice:obSelf.minPriceStr}));$(this.parent).append(contentBlock);return contentBlock},enable:function(){var obSelf=this;$(this.element).find(".item").click(function(){obSelf.selectCarrier(this)})},disable:function(){$(this.element).find(".item").unbind("click")},selectCarrier:function(element){var obElement=$(element);var carrierId=obElement.attr("rel").replace("carrier_","");if(carrierId=="all"){this.selected=[]}else{var selected=this.selected;var selectedLength=selected.length;var poped=false;for(var i=0;i<selectedLength;i++){if(selected[i]==carrierId){this.selected.splice(i,1);poped=true;break}}if(!poped){this.selected.push(carrierId)}}this.drawSelection();this.params.onSelect(this.getSelected())},getSelected:function(){if(this.data.length<1){return[]}return this.selected}});var RM_Tutu_Avia_Filter_Direct=RM.Class.extend({parent:null,enabled:true,params:{onSelect:function(){}},data:{active:null},init:function(parent,params,data){this.parent=parent;this.params=$.extend({},this.params,params);this.data.active=data.active?"direct":"all";var obSelf=this;this.shutup();this.draw()},shutup:function(){var obSelf=this;$(this.parent).find(".switch_label").click(function(){obSelf.onSelectCase(this)});$(this.parent).find(".filter_switcher").click(function(){obSelf.toggleCase()})},shutdown:function(){$(this.parent).find(".switch_label").unbind("click");$(this.parent).find(".filter_switcher").unbind("click")},toggleCase:function(){if(!this.enabled){return}var nextValue=$(this.parent).find('.switch_label[rel!="'+this.data.active+'"]').eq(0).attr("rel");this.setCase(nextValue)},setCase:function(val){if(this.data.active==val){return}this.data.active=val;this.draw();this.params.onSelect(val=="all"?0:1)},onSelectCase:function(element){if(!this.enabled){return}this.setCase($(element).attr("rel"))},draw:function(){var active=this.data.active;var obElement=$(this.parent).find('.switch_label[rel="'+active+'"]');if(obElement.hasClass("first")){obElement.parent().removeClass("active")
}else{obElement.parent().addClass("active")}if(this.enabled){$(this.parent).find('.switch_label[rel="direct"]').html(RM.L("avia.search.directRaces"));obElement.parent().removeClass("disabled")}else{$(this.parent).find('.switch_label[rel="direct"]').html(RM.L("avia.search.noDirectRaces"));obElement.parent().addClass("disabled")}},enable:function(){this.enabled=true;this.draw()},disable:function(){this.enabled=false;this.data.active="all";this.draw()}});var RM_Tutu_Avia_Form_Waitscreen=RM.Class.extend({element:null,inProgress:false,startTime:null,minimalShowTime:null,maximumShowTime:2*60*1000,animationParams:[{name:".animation",distance:13,duration:1000},{name:".clouds",distance:"-1219",duration:20000},{name:".air-path",distance:"-789",duration:1000}],settings:{onShow:function(){},onHide:function(){}},init:function(minimalShowTime,settings){this.minimalShowTime=minimalShowTime;this.settings=$.extend(this.settings,settings)},getContent:function(errorCode){var waitscreenBlock=null;if($(".rm-waitscreen").length){waitscreenBlock=$(".rm-waitscreen").eq(0)}else{waitscreenBlock=$(RM.tmpl("avia_order_search_result_form_waitscreen",{top_message:errorCode?RM.L("list.avia.search.errors."+errorCode):RM.L("avia.gds.waitpage_maybe")}));$("body").prepend(waitscreenBlock)}if(!($.browser.msie&&(parseInt($.browser.version)<7))){$(waitscreenBlock).find(".src2rel").each(function(){var newSRC=$(this).attr("rel");$(this).attr("src",newSRC)})}return waitscreenBlock},show:function(cityName,errorCode){var obSelf=this;this.startTime=new Date();var message=RM.L("avia.gds.waitscreen_hotel_offer",{city_name:cityName});if(!this.element){this.element=this.getContent(errorCode)}$(this.element).find(".key-message").html(message);if(errorCode){$(this.element).find(".key-message").addClass("dNone")}else{$(this.element).find(".key-message").removeClass("dNone")}this.inProgress=true;this.play();setTimeout(function(){obSelf.hide()},obSelf.maximumShowTime);this.settings.onShow()},hide:function(){var now=new Date();var delay=0;if(this.startTime){var elapsed=now.getTime()-this.startTime.getTime();if(elapsed<this.minimalShowTime){delay=this.minimalShowTime-elapsed}}if(delay){var obSelf=this;setTimeout(function(){obSelf._hide()},delay)}else{this._hide()}},_hide:function(){this.inProgress=false;$(this.element).remove();this.element=null;this.startTime=null;this.settings.onHide()},play:function(){var obSelf=this;var params=this.animationParams;var paramsLength=params.length;for(var i=0;i<paramsLength;i++){this.animateElement(params[i])}},animateElement:function(params){if(!this.inProgress){return}var obSelf=this;var obElement=$(this.element).find(params.name).eq(0);obElement.css("backgroundPosition","0px 0px");obElement.animate({backgroundPosition:params.distance+"px 0px"},params.duration,"linear",function(){obSelf.animateElement(params)})}});var RM_Tutu_Avia_SearchForm=RM.Class.extend({params:{direction:null,from:null,to:null,date_forward:null,date_back:null,full:null,childs:null,babies:null,"class":null},filters:{no_changes:0,carriers:[]},waitscreen:null,error_code:0,searchResult:null,form:null,rmDate:null,initialParamsHash:null,carriersData:{data:[],minPrice:null,minPriceStr:null},carriersFilter:null,classFilter:null,directFilter:null,passFilter:null,needResetCarriers:true,viewType:"main",waitScreenCounter:0,minWaitScreenShowTime:500,searchFormTemplates:{main:{"one-way":"avia_order_search_result_form_main_ow","round-trip":"avia_order_search_result_form_main_rt"},sticky:{"one-way":"avia_order_search_result_form_sticky_ow","round-trip":"avia_order_search_result_form_sticky_rt"}},init:function(form,params,filters){this.params=$.extend({},this.params,params);this.filters=$.extend({},this.filters,filters);this.form=form;this.searchResult=this.params.searchResult;this.rmDate=new RM_Date();this.initialParamsHash=this.getParamsHash(this.params);this.error_code=params.error_code;var obSelf=this;$(document).ready(function(){obSelf.initForm();obSelf.initFormTemplate(false);obSelf.updateFormData();obSelf.updateFilterData();$(window).scroll(function(){obSelf.checkStickyHeader()});obSelf.updateSearchError();obSelf.showWaitscreen()})},initForm:function(){var obSelf=this;$(".b-filter_switcher").each(function(){obSelf.initDirectFilter(this)});$(".rm-filter-carriers").each(function(){obSelf.initCarriersFilter(this)});$(".rm-search-button").click(function(){obSelf.onNewSearch()});$(".rm-search-error-popup").each(function(){var popup=this;$(this).find(".rm-handler-close").click(function(){$(popup).addClass("dNone")})})},initFormTemplate:function(needAnimate){var obSelf=this;$(".rm-suggest").each(function(){obSelf.initSuggestBubble(this)});$(".rm-calendar").each(function(){obSelf.initCalendar(this)});$(".rm-toggle-roundtrip").each(function(){obSelf.initRoundtripToggle(this)});$(".rm-passengers").each(function(){obSelf.initPassengersBubble(this)});$(".rm-class-filter").each(function(){obSelf.initClassBubble(this)});$(".rm-link-go-top").click(function(){obSelf.scrollToTop()
});$(".rm-search-sticky-button").click(function(){obSelf.onNewSearch()});this.checkSearchButton();if(needAnimate){this.animateBlock()}this.updateSearchError()},initRoundtripToggle:function(element){var obSelf=this;$(element).click(function(){obSelf.toggleRoundTrip()}).mousedown(function(){$(this).addClass("pressed")}).mouseup(function(){$(this).removeClass("pressed")}).mouseleave(function(){$(this).removeClass("pressed")})},animateBlock:function(){if(this.viewType!="main"||RM.Browser.isIe()){return}$(".rm-search-form .route_point").eq(1).clearQueue().animate({opacity:0},250).animate({opacity:1},250);$(".rm-search-form .point_date").eq(1).clearQueue().animate({opacity:0},250).animate({opacity:1},250)},scrollToTop:function(){$("html,body").animate({scrollTop:0},this._getScrollSpeed())},_getScrollSpeed:function(){return Math.floor($(window).scrollTop()/5)},hideWaitscreen:function(){if(this.waitscreen){this.waitscreen.hide();delete this.waitscreen;this.waitscreen=null}},showWaitscreen:function(){if(this.waitscreen){this.hideWaitscreen()}this.waitscreen=new RM_Tutu_Avia_Form_Waitscreen(this.waitScreenCounter>0||this.error_code?this.minWaitScreenShowTime:0,{onShow:function(){$("#footer").addClass("dNone");$("#wrapper").addClass("dNone");$("body").addClass("wait_screen")},onHide:function(){$("#footer").removeClass("dNone");$("#wrapper").removeClass("dNone");$("body").removeClass("wait_screen")}});this.waitscreen.show(this.params.to.name6,this.error_code);this.waitScreenCounter++;this.error_code=0},updateSearchError:function(){var errorBlock=$(".rm-search-error-popup");var errorCode=this.error_code;if(errorCode){errorBlock.removeClass("dNone").find(".rm-content").html(RM.L("list.avia.search.popup_errors."+errorCode))}else{errorBlock.addClass("dNone")}},checkStickyHeader:function(){var newViewType="";if($(window).scrollTop()>=125){newViewType="sticky"}else{newViewType="main"}if(newViewType!=this.viewType){this.viewType=newViewType;this.reloadSearchForm(true)}},reloadSearchForm:function(changedViewType){var blockSearchForm=$(RM.tmpl(this.getSearchFormTemplateName(),this.getSearchFormTemplateParams()));$(".rm-search-form").html("").append(blockSearchForm);this.initFormTemplate(!changedViewType)},getSearchFormTemplateName:function(){return this.searchFormTemplates[this.viewType][this.params.direction==1?"one-way":"round-trip"]},getSearchFormTemplateParams:function(){var params=this.params;var rmDate=this.rmDate;if(!params.date_back&&(params.direction==2)){params.date_back=params.date_forward}var forwardDate=params.date_forward;var backDate=params.date_back;var from=params.from;var to=params.to;var result={from:{id:from.id,name:from.name,name2:from.name2,country_name:from.country_name},to:{id:to.id,name:to.name,name2:to.name2,country_name:to.country_name},date_forward:{date:forwardDate,str:rmDate.format(forwardDate,"DD $m"),weekday:rmDate.format(forwardDate,"$wd"),prevday:rmDate.format(rmDate.dayBefore(forwardDate),"DD $ms"),nextday:rmDate.format(rmDate.dayAfter(forwardDate),"DD $ms")},date_back:{date:backDate,str:rmDate.format(backDate,"DD $m"),weekday:rmDate.format(backDate,"$wd"),prevday:rmDate.format(rmDate.dayBefore(backDate),"DD $ms"),nextday:rmDate.format(rmDate.dayAfter(backDate),"DD $ms")}};return result},onNewSearch:function(){this.scrollToTop();this.initialParamsHash=this.getParamsHash(this.params);this.hideBubbles();this.showWaitscreen();this.filters.carriers=[];this.needResetCarriers=true;this.updateFilterData();this.updateFormData();this.checkSearchButton();this.searchResult.update();this.updateSearchCookie()},updateSearchCookie:function(){var i;var params=this.params;var searchData={avia_form_from_city_id:params.from.id,avia_form_from_city_name:params.from.label,avia_form_to_city_id:params.to.id,avia_form_to_city_name:params.to.label,avia_form_date_forward:RM.Date.format(params.date_forward,"date"),avia_form_date_back:params.direction==2?RM.Date.format(params.date_back,"date"):null,avia_form_fulls:params.full,avia_form_children:params.childs,avia_form_infants:params.babies};for(i in searchData){$.cookie(i,searchData[i],{path:"/",domain:this.params.domain})}},onFilterUpdate:function(){this.updateSearchError();this.updateFilterData();this.searchResult.show();this.checkStickyHeader()},onSearchResultUpdate:function(data){this.hideWaitscreen();if(data.has_no_changes){this.directFilter.enable()}else{this.directFilter.disable();if(this.filters.no_changes){this.filters.no_changes=0;this.updateFilterData()}}if(this.needResetCarriers){if(!data.carriers){this.carriersData=[];this.carriersFilter.initFilter(this.carriersFilterData(),this.filters.carriers);this.carriersFilter.show();this.needResetCarriers=true}else{this.carriersData=data.carriers;this.carriersFilter.initFilter(this.carriersFilterData(),this.filters.carriers);this.carriersFilter.show();this.needResetCarriers=false}}this.checkStickyHeader()},onSearchResultError:function(error){this.hideWaitscreen();this.carriersData=[];this.filters.carriers=[];this.carriersFilter.initFilter(this.carriersFilterData(),this.filters.carriers);
this.carriersFilter.hide();this.needResetCarriers=true},checkSearchButton:function(){var obHolder=$(".rm-search-button-holder");obHolder.addClass("dNone");if(this.checkIfParamsChanged()){$(".rm-search-button-holder-"+this.viewType).removeClass("dNone");this.updateSearchError()}},checkIfParamsChanged:function(){return this.getParamsHash(this.getRequestParams())!=this.initialParamsHash},toggleRoundTrip:function(){this.params.direction=3-this.params.direction;this.reloadSearchForm(false);this.checkSearchButton()},onBuyButton:function(){this.directFilter.shutdown();this.carriersFilter.disable()},onBuyFail:function(){this.directFilter.shutup();this.carriersFilter.enable()},onBuyError:function(){this.error_code=2;this.updateSearchError();this.showWaitscreen()},updateFormData:function(){var params=this.params;var filters=this.filters;var formElement=$(this.form);var val=null;for(var i in params){if(i=="from"||i=="to"){val=params[i].id}else{val=params[i]}formElement.find('[name="'+i+'"]').val(val)}},updateFilterData:function(){var formElement=$(this.form);var filters=this.filters;formElement.find('input[name="no_changes"]').val(filters.no_changes);var carriers=filters.carriers;var carriersLength=carriers.length;formElement.find('input[name="carriers[]"]').remove();for(var i=0;i<carriersLength;i++){var checkElement=$("<input/>").attr("name","carriers[]").attr("value",carriers[i]).attr("type","checkbox").attr("checked","checked").hide();formElement.append(checkElement)}},hideBubbles:function(){$(".rm-bubble").hide()},initCalendar:function(parent){var obSelf=this;var dateType=$(parent).attr("rel");var prefix=dateType;var dateInput=$("<input/>").attr("name",prefix+"_fake").attr("id",prefix+"_fake").val(this.params[dateType]).css({visibility:"hidden",width:"2px","float":"left"});dateInput.datepicker(obSelf.calendarParams(dateType,parent));$(parent).append(dateInput).click(function(){$(dateInput).datepicker("show")});$(parent).parent().parent().find('.ico_calendar[rel="'+dateType+'"]').click(function(){$(dateInput).datepicker("show")});$('.rm-prev-date[rel="'+dateType+'"]').click(function(){obSelf.selectPrevDate(dateType)});$('.rm-next-date[rel="'+dateType+'"]').click(function(){obSelf.selectNextDate(dateType)});this.checkNeighborDateLinks()},calendarParams:function(dateType,parent){var obSelf=this;var currentDate=new Date(this.params[dateType]);if(currentDate==null){currentDate=new Date()}return{constrainInput:"true",numberOfMonths:2,firstDay:1,duration:0,navigationAsDateFormat:true,nextText:"MM",prevText:"MM",minDate:"+0d",currentText:"Сегодня",showButtonPanel:true,serverDate:{year:currentDate.getFullYear(),month:currentDate.getMonth(),day:currentDate.getDate()},onChangeMonthYear:function(year,month,inst){inst.settings.prevText=ucfirst(obSelf.rmDate.getMonthName((month-2+12)%12,"nominative"));inst.settings.nextText=ucfirst(obSelf.rmDate.getMonthName((month+1+12)%12,"nominative"))},beforeShow:function(input,inst){var dpDate=$(input).datepicker("getDate");if(dpDate==null){dpDate=new Date()}var month=dpDate.getMonth();inst.settings.prevText=ucfirst(obSelf.rmDate.getMonthName((month-1+12)%12,"nominative"));inst.settings.nextText=ucfirst(obSelf.rmDate.getMonthName((month+2+12)%12,"nominative"))},onSelect:function(dateText,inst){obSelf.processNewDate(dateType,dateText)}}},processNewDate:function(dateType,dateText){var nowDate=this.rmDate.getObject(this.rmDate.format(new Date(),"date"));if(this.rmDate.getObject(dateText).getTime()<nowDate.getTime()){return}this.checkDates(dateType,dateText)},checkDates:function(dateType,dateText){var fromDate=this.rmDate.getObject(dateType=="date_forward"?dateText:this.params.date_forward);var toDate=this.rmDate.getObject(dateType=="date_back"?dateText:this.params.date_back);if(dateType=="date_forward"){if(fromDate.getTime()>=toDate.getTime()){toDate=this.rmDate.dayAfter(fromDate);this.selectNewDate("date_back",this.rmDate.format(toDate,"date"))}}else{if(fromDate.getTime()>toDate.getTime()){fromDate.setTime(toDate.getTime());this.selectNewDate("date_forward",this.rmDate.format(fromDate,"date"))}}this.selectNewDate(dateType,dateText)},selectNewDate:function(dateType,dateText){var dateInput=$("#"+dateType+"_fake");var selectedDate=this.rmDate.getObject(dateText);$('.rm-calendar[rel="'+dateType+'"]').find(".filter_link").html(this.rmDate.format(selectedDate,"DD $m"));$('.week_day[rel="'+dateType+'"]').html(this.rmDate.format(selectedDate,"$wd"));var dayBeforeDate=this.rmDate.dayBefore(dateText);$('.rm-prev-date[rel="'+dateType+'"]').find(".rm-prev-day").html(this.rmDate.format(dayBeforeDate,"DD $ms"));var dayAfterDate=this.rmDate.dayAfter(dateText);$('.rm-next-date[rel="'+dateType+'"]').find(".rm-next-day").html(this.rmDate.format(dayAfterDate,"DD $ms"));$(dateInput).datepicker("setDate",selectedDate);this.params[dateType]=dateText;this.checkNeighborDateLinks();this.checkSearchButton()},selectNextDate:function(dateType){var newDate=this.rmDate.dayAfter(this.params[dateType]);this.processNewDate(dateType,this.rmDate.format(newDate,"date"))
},selectPrevDate:function(dateType){var newDate=this.rmDate.dayBefore(this.params[dateType]);this.processNewDate(dateType,this.rmDate.format(newDate,"date"))},checkNeighborDateLinks:function(){var obSelf=this;var nowDate=new Date();$(".rm-prev-date").each(function(){var dateType=$(this).attr("rel");var selectedDate=obSelf.rmDate.getObject(obSelf.params[dateType]);if(selectedDate.getTime()<=nowDate.getTime()){$(this).addClass("inactive")}else{$(this).removeClass("inactive")}})},initCarriersFilter:function(parent){var obSelf=this;this.carriersFilter=new RM_Tutu_Avia_Filter_Carriers(parent,{onSelect:function(res){obSelf.onCarrierSelect(res)}},this.carriersFilterData())},carriersFilterData:function(){return this.carriersData},onCarrierSelect:function(result){this.filters.carriers=result;this.onFilterUpdate()},initDirectFilter:function(parent){var obSelf=this;this.directFilter=new RM_Tutu_Avia_Filter_Direct(parent,{onSelect:function(res){obSelf.onDirectSelect(res)}},this.directFilterData())},directFilterData:function(){return{active:this.filters.no_changes}},onDirectSelect:function(result){this.updateSearchError();this.filters.no_changes=result;this.onFilterUpdate()},initClassBubble:function(parent){var obSelf=this;if(!this.classFilter){this.classFilter=new RM_Tutu_Avia_Bubble_Class(parent,{closeOtherBubbles:true},{onSelect:function(res){obSelf.onClassSelect(res)}},this.classBubbleData());$(parent).click(function(){obSelf.classFilter.show();obSelf.updateSearchError()})}},classBubbleData:function(){var params=this.params;return{active:this.params["class"]}},onClassSelect:function(result){this.params["class"]=result;$(".rm-class-filter").find(".rm-class-title").html(RM.L("list.avia.order.class.seats_in."+result));this.checkSearchButton()},initPassengersBubble:function(parent){var obSelf=this;if(!this.passFilter){this.passFilter=new RM_Tutu_Avia_Bubble_Passengers(parent,{closeOtherBubbles:true,resetOnShow:true},{onSelect:function(res){obSelf.onPassengerSelect(res)}},this.passengersBubbleData());$(parent).find(".filter_link").click(function(){obSelf.passFilter.toggle();obSelf.updateSearchError()})}},passengersBubbleData:function(){var obSelf=this;var params=this.params;return{full:params.full,childs:params.childs,babies:params.babies}},onPassengerSelect:function(result){this.params=$.extend({},this.params,result);this.checkSearchButton()},initSuggestBubble:function(parent){var obBubble=new RM_Tutu_Avia_Bubble_Suggest(parent,{closeOtherBubbles:true,resetOnShow:true},this.bubbleParams($(parent).attr("rel")));$(parent).click(function(){obBubble.show();obBubble.focus()})},onCitySuggestSelect:function(result){result.id=result.value;this.params[result.type]=result;this.checkSearchButton()},bubbleParams:function(type){var obSelf=this;var params=this.params;var prefix=type;return{type:type,inputName:prefix+"_city_id",inputId:prefix+"_city_id",nameName:prefix+"_name",nameId:prefix+"_name",cityId:params[type].id,cityName:params[type].label,formCityId:prefix+"_city_id",roundTrip:params.direction==2?1:0,onSelect:function(res){obSelf.onCitySuggestSelect(res)}}},getRequestParams:function(){return this.params},getSearchParams:function(){var val=null;var data={};var params=this.params;var mainFields=["from","to","date_forward","date_back","full","childs","babies","direction","class"];for(var i=0;i<mainFields.length;i++){var idx=mainFields[i];if(idx=="from"||idx=="to"){val=params[idx].id}else{val=params[idx]}data[idx]=val}return data},getSearchFilters:function(){return this.filters},getParamsHash:function(params){var hash=params.direction+"|"+params.from.id+"|"+params.to.id+"|"+params.date_forward+"|"+(params.direction==2?params.date_back:"")+"|"+params.full+"|"+params.childs+"|"+params.babies+"|"+params["class"];return hash}});var RM_Tutu_Avia_SearchResult_Route=RM.Class.extend({offer:null,data:{},domBlock:null,active:true,selected:false,init:function(offer,data){this.offer=offer;this.data=$.extend({},this.data,data,this.offer.getCarrierData(data.carrier));this.data.carriers=this.offer.expandCarriers(this.data.carriers);this._initSegments()},_initSegments:function(){for(var i=0;i<this.data.segments.length;i++){this.data.segments[i]=$.extend({},this.data.segments[i],this.offer.getCarrierData(this.data.segments[i]["carrier"]))}},destructor:function(){this.hide()},show:function(){var obSelf=this;this.domBlock=$(RM.tmpl("avia_order_search_result_pricegroup_route",this.data));this.domBlock.click(function(){obSelf.offer.selectRoute(obSelf,true)}).mouseover(function(){obSelf.hover();obSelf.offer.hoverCompatibleRoutes(obSelf)}).mouseout(function(){obSelf.unhover();obSelf.offer.unhoverCompatibleRoutes(obSelf)});this.offer.domBlock.find(".rm-routes-"+this.data.direction).append(this.domBlock)},hide:function(){if(this.domBlock){this.domBlock.remove()}},isCompatible:function(route){for(var i=0;i<this.data.compatible_routes.length;i++){if(this.data.compatible_routes[i]==route.data.hash){return true}}return false},isSelected:function(){return this.selected
},select:function(){for(var i=0;i<this.offer.routes[this.data.direction].length;i++){this.offer.routes[this.data.direction][i].unselect()}this.selected=true;$(this.domBlock).addClass("rm-route-selected")},unselect:function(){this.selected=false;$(this.domBlock).removeClass("rm-route-selected")},block:function(){this.active=false;$(this.domBlock).addClass("rm-route-disabled").unbind("click");this.unselect()},unblock:function(){var obSelf=this;this.active=true;$(this.domBlock).removeClass("rm-route-disabled").bind("click",function(){obSelf.offer.selectRoute(obSelf,true)})},shutdown:function(){$(this.domBlock).unbind("click")},shutup:function(){var obSelf=this;$(this.domBlock).bind("click",function(){obSelf.offer.selectRoute(obSelf,true)})},hover:function(){this.domBlock.addClass("rm-route-hovered")},unhover:function(){this.domBlock.removeClass("rm-route-hovered")},isBlocked:function(){return !this.active}});var RM_Tutu_Avia_SearchResult_Offer=RM.Class.extend({dataList:null,data:{},domBlock:null,routes:{},selectedRoutes:{},container:null,carriers:null,minimalUnscrolledHeight:400,_haveChanges:false,_routesCarriers:{},settings:{onBuyButton:function(){},onBuyFail:function(){},onBuyError:function(){},deniedOffers:{}},init:function(data,container,offerFormData,carriers,dataList,settings){this.data=$.extend({},this.data,data,offerFormData);this.container=container;this.dataList=dataList;this.carriers=carriers;this.settings=$.extend({},this.settings,settings);this._initSelection();this.routes=this._initRoutes(this.data.directions);this._initOfferCarriers()},destructor:function(){for(var direction=1;direction<=this.data.directions;direction++){for(var j=0;j<this.data.direction[direction].length;j++){this.routes[direction][j].destructor()}}},show:function(){this._initDomContainer();for(var direction=1;direction<=this.data.directions;direction++){for(var j=0;j<this.data.direction[direction].length;j++){this.routes[direction][j].show()}}this._initBlockScroll();this._setBaseSelection();this.showOffer()},hide:function(){$(window).unbind("scroll",this._modifyBlockPosition);for(var direction=1;direction<=this.data.directions;direction++){for(var j=0;j<this.data.direction[direction].length;j++){this.routes[direction][j].hide()}}if(this.domBlock){this.domBlock.remove()}},haveChanges:function(){return this._haveChanges},haveCarrier:function(carrierId){return carrierId in this.data.carriers&&this.data.carriers[carrierId]},_needScrollEvent:null,_initBlockScroll:function(){if(this._needScrollEvent==null){for(var direction=1;direction<=this.data.directions;direction++){if(this.routes[direction]&&this.routes[direction].length>8){this._needScrollEvent=true;break}}if(this._needScrollEvent==null){this._needScrollEvent=false}}if(this._needScrollEvent){$(window).bind("scroll",{offer:this},this._modifyBlockPosition)}},_modifyBlockPosition:function(event){var obSelf=event.data.offer;var topFormHeight=parseInt($(".b-avia_top_filters").height());if(isNaN(topFormHeight)||topFormHeight<0){topFormHeight=0}var margin=($(window).scrollTop()+topFormHeight)-obSelf.domBlock.position().top;var padding=parseInt(obSelf.domBlock.css("padding-bottom"));if(isNaN(padding)){padding=0}var maxMargin=obSelf.domBlock.find(".b-relevant_fly").height()-obSelf.domBlock.find(".rm-offer").height()-padding-35;if(margin>maxMargin){margin=maxMargin}if(margin<0){margin=0}$(document).stopTime(obSelf.data.hash).oneTime(100,obSelf.data.hash,function(){obSelf.domBlock.find(".rm-offer").clearQueue().animate({"margin-top":margin+"px"},"fast")})},_initSelection:function(){this.selectedRoutes={};for(var direction=1;direction<=this.data.directions;direction++){this.selectedRoutes[direction]=null}},getCarrierData:function(carrierId){var carrier={carrier_name:"",carrier_logo:"",carrier_logo_small:""};if(carrierId in this.carriers&&this.carriers[carrierId]){carrier={carrier_name:this.carriers[carrierId]["name"],carrier_logo:this.carriers[carrierId]["logo"],carrier_logo_small:this.carriers[carrierId]["logo_small"]}}return carrier},expandCarriers:function(carriers){var obSelf=this;var result=[];$(carriers).each(function(){result[result.length]=obSelf.carriers[this]});return result},_initDomContainer:function(){var obSelf=this;this.domBlock=$(RM.tmpl("avia_order_search_result_pricegroup",this.data));$(this.container).append(this.domBlock)},_initRoutes:function(directions){var routes={};for(var direction=1;direction<=directions;direction++){routes[direction]=[];for(var j=0;j<this.data.direction[direction].length;j++){routes[direction][j]=new RM_Tutu_Avia_SearchResult_Route(this,this.data.direction[direction][j]);if(routes[direction][j].data.changes>0){this._haveChanges=true}}}return routes},_initOfferCarriers:function(){this._routesCarriers={};for(var direction=1;direction<=this.data.directions;direction++){for(var j=0;j<this.data.direction[direction].length;j++){this._routesCarriers[this.routes[direction][j].data.carrier]=this.routes[direction][j].data.carrier}}},_setBaseSelection:function(){this.selectRoute(this.routes[1][0]);
for(var direction=2;direction<=this.data.directions;direction++){this.selectFirstCompatibleRoute(direction)}},isRouteSelected:function(route){return(this.selectedRoutes[route.data.direction]&&(this.selectedRoutes[route.data.direction]["hash"]==route.data.hash))},selectRoute:function(route,animate){if(this.isRouteSelected(route)){route.select();return}if(route.data.direction==1){this._selectRoute(route);for(var direction=2;direction<=this.data.directions;direction++){for(var i=0;i<this.routes[direction].length;i++){var nextRoute=this.routes[direction][i];if(!route.isCompatible(nextRoute)){nextRoute.block();if(this.isRouteSelected(nextRoute)){this.selectedRoutes[direction]=null}}else{nextRoute.unblock()}}if(!this.selectedRoutes[direction]){this.selectFirstCompatibleRoute(direction)}}}else{if(!route.isBlocked()){this._selectRoute(route)}}this.showOffer();if(animate){this.animateOffer()}},hoverCompatibleRoutes:function(route){for(var direction=1;direction<=this.data.directions;direction++){if(route.data.direction==direction){continue}for(var i=0;i<this.routes[direction].length;i++){var cRoute=this.routes[direction][i];if(route.isCompatible(cRoute)){cRoute.hover()}else{cRoute.unhover()}}}},unhoverCompatibleRoutes:function(route){for(var direction=1;direction<=this.data.directions;direction++){if(route.data.direction==direction){continue}for(var i=0;i<this.routes[direction].length;i++){this.routes[direction][i].unhover()}}},selectFirstCompatibleRoute:function(direction){for(var i=0;i<this.routes[direction].length;i++){if(!this.routes[direction][i].isBlocked()){this._selectRoute(this.routes[direction][i]);break}}},_selectRoute:function(route){this.selectedRoutes[route.data.direction]=route.data;route.select()},showOffer:function(){var obSelf=this;for(var i=1;i<=this.data.directions;i++){if(!this.selectedRoutes[i]){return}}var blockOffer=$(RM.tmpl("avia_order_search_result_pricegroup_offer",{offer:this.data,routes:this.selectedRoutes}));this.domBlock.find(".rm-offer").empty().append(blockOffer);blockOffer.filter(".extend").each(function(){obSelf._addEventsForSegment(this)});this.domBlock.find(".rm-offer-button").click(function(){obSelf._pushOfferButton();obSelf._checkOffer();return false});this._redrawButton()},shutdown:function(){this._setButton("hide");for(var direction=1;direction<=this.data.directions;direction++){for(var i=0;i<this.routes[direction].length;i++){this.routes[direction][i].shutdown()}}},shutup:function(){this._redrawButton();for(var direction=1;direction<=this.data.directions;direction++){for(var i=0;i<this.routes[direction].length;i++){this.routes[direction][i].shutup()}}},_redrawButton:function(){if(!this.domBlock){return}var i;var hashAr=[];for(i in this.selectedRoutes){hashAr.push(this.selectedRoutes[i]["hash"])}if(this.settings.deniedOffers[hashAr.join("_")]){this._setButton("error")}else{this._setButton("offer")}},_pushOfferButton:function(){this.settings.onBuyButton();this._setButton("wait")},_checkOffer:function(){var obSelf=this;var data=obSelf.domBlock.find("form").serialize();$.ajax({url:url.get("ajax",{},{Action:"avia_check_offer"}),data:data,dataType:"json",type:"POST",success:function(data,textStatus,jqXHR){if(!data||data.status=="search_fail"){obSelf._checkOfferError()}else{if(data.status=="offer_ok"){obSelf._checkOfferSuccess(data)}else{obSelf._checkOfferFail()}}},error:function(jqXHR,textStatus,errorThrown){obSelf._checkOfferError()}})},_checkOfferError:function(){this.settings.onBuyError()},_setButton:function(type){if(!this.domBlock){return}var buttonToEnable=null;this.domBlock.find(".rm-offer-button-switch").addClass("dNone");if(type=="error"){buttonToEnable=this.domBlock.find(".rm-button-error")}else{if(type=="wait"){buttonToEnable=this.domBlock.find(".rm-button-wait");this.domBlock.find(".wait-indicator.js_indicator").activity({segments:12,align:"left",valign:"top",steps:3,width:2,space:1,length:3,color:"#030303",speed:1.5,padding:0})}else{if(type=="offer"){buttonToEnable=this.domBlock.find(".rm-offer-button")}}}if(buttonToEnable){buttonToEnable.removeClass("dNone")}},_checkOfferFail:function(){var i,routesAr=[];for(i in this.selectedRoutes){routesAr.push(this.selectedRoutes[i]["hash"])}this.settings.deniedOffers[routesAr.join("_")]=1;this.settings.onBuyFail(this.data.hash,routesAr);this._setButton("error");this.dataList.flush(1)},_checkOfferSuccess:function(data){var obForm=this.domBlock.find("form");$("<input/>").attr("name","price_change").attr("type","hidden").val(data.priceChange).appendTo(obForm);$("<input/>").attr("name","new_session_id").attr("type","hidden").val(data.newSessionId).appendTo(obForm);if(data.priceChange!=0){this.dataList.flush(1)}obForm.submit()},animateOffer:function(){var obSelf=this;this._getAnimatedElements().clearQueue().animate({opacity:0.4},250).animate({opacity:1},250).animate({opacity:0.5},250).animate({opacity:1},250)},_getAnimatedElements:function(){return this.domBlock.find(".rm-offer")},_addEventsForSegment:function(blockSegment){$(blockSegment).find(".hide_extended").click(function(){$(blockSegment).find(".details-extended").fadeOut(200,function(){$(blockSegment).find(".details-link").show()
})});$(blockSegment).find(".show_extended").click(function(){$(blockSegment).find(".details-link").hide();$(blockSegment).find(".details-extended").fadeIn(200)})}});var RM_Tutu_Avia_SearchResult=RM.Class.extend({dataList:null,resultContainer:null,errorContainer:null,params:{getParams:function(){},onData:function(data){},onError:function(error){},onBuyButton:function(){},onBuyFail:function(){},onBuyError:function(){}},offers:[],filteredOffers:[],visibleOffers:0,rop:10,page:0,totalPages:0,urlHelper:null,relatedparams:[],deniedOffers:{},init:function(params){var obSelf=this;this.params=$.extend({},this.params,params);this.resultContainer=$(".l-avia_result").get(0);this.errorContainer=$(".rm-error-holder").get(0);this.urlHelper=new RM_Tutu_Avia_SearchResult_Url();this.dataList=new RM_Tutu_Ajax_DataList("flights",url.get("ajax",{},{Action:"avia_offer",act:"get_offers"}),function(){return $.param(obSelf.params.getParams())},{onSuccess:function(list,data){obSelf._updateUrl();obSelf._processOffers(list,data)},onError:function(error,data){obSelf.params.onError(error);obSelf.offers=[];obSelf._showError(error)}});$(document).ready(function(){obSelf.checkBottomPadding();$(window).bind("resize",function(){obSelf.checkBottomPadding()})})},_updateUrl:function(errorCode){this.urlHelper.update(this.params.getParams(),this.params.getFilters(),errorCode)},update:function(force){this._hideError();$(this.offers).each(function(){this.destructor()});this.offers=[];$(this.resultContainer).empty();this._updateUrl(false);if(force){this.dataList.flush(1)}this.dataList.show(1)},show:function(){this._updateUrl();this._hideError();this._addPlaceHolder();this._hideOffers();this._filterOffers();this._renderPage(1);this._removePlaceHolder()},_addPlaceHolder:function(){var height=$(this.resultContainer).height();$(this.resultContainer).append($("<div>",{"class":"rm-placeholder"}).css("height",height+"px"))},_removePlaceHolder:function(){$(this.resultContainer).find(".rm-placeholder").remove()},_hideError:function(){$(this.errorContainer).hide()},_showError:function(text){$(this.errorContainer).show();$(this.errorContainer).find(".result_text").html(text)},_filterOffers:function(){this.filteredOffers=[];for(var i=0;i<this.offers.length;i++){if(this._matchFilters(this.offers[i])){this.filteredOffers[this.filteredOffers.length]=this.offers[i]}}},_hideOffers:function(){for(var i=0;i<this.filteredOffers.length;i++){this.filteredOffers[i].hide()}this.visibleOffers=0},_renderPage:function(page){this.page=page;if(!this.filteredOffers.length){if(!this.offers.length){if(this.relatedparams.date_future&&this.relatedparams.date_past){this._showError(RM.L("avia.order.empty_result_check_schedule_date",{date_future:this.relatedparams.date_future,url_future:this.relatedparams.url_future,date_past:this.relatedparams.date_past,url_past:this.relatedparams.url_past,and:this.relatedparams.and}))}else{if(this.relatedparams.date_future){this._showError(RM.L("avia.order.empty_result_check_schedule_date_single",{date:this.relatedparams.date_future,url:this.relatedparams.url_future}))}else{if(this.relatedparams.date_past){this._showError(RM.L("avia.order.empty_result_check_schedule_date_single",{date:this.relatedparams.date_past,url:this.relatedparams.url_past}))}else{this._showError(RM.L("avia.order.empty_result_sorry"))}}}}else{this._showError(RM.L("avia.order.empty_result_filtered"))}}else{if(true){for(var i=0;i<this.filteredOffers.length;i++){this.filteredOffers[i].show()}}else{var rendered=0;for(var i=(page-1)*this.rop;(i<this.filteredOffers.length)&&(rendered<this.rop);i++){this.filteredOffers[i].show();rendered++}if(this.page<this.totalPages){$(window).bind("scroll",{result:this},this._loadNextPage)}}}},_loadNextPage:function(event){var obSelf=event.data.result;if(obSelf.dataList.isDataLoading){return}var footer=$("#footer");if($(window).scrollTop()+$(window).height()>footer.position().top-footer.height()){$(window).unbind("scroll",obSelf._loadNextPage);obSelf._renderPage(obSelf.page+1)}},_matchFilters:function(offer){var filters=this.params.getFilters();if(filters.no_changes&&offer.haveChanges()){return false}if(filters.carriers.length==0){return true}var matchedCarriers=0;for(var i=0;i<filters.carriers.length;i++){if(offer.haveCarrier(filters.carriers[i])){matchedCarriers++}}if(matchedCarriers<offer.data.carriers_count){return false}return true},_processOffers:function(list,data){var obSelf=this;for(var j=0;j<this.offers.length;j++){this.offers[j].destructor()}for(var i=0;i<list.length;i++){this.offers[this.offers.length]=new RM_Tutu_Avia_SearchResult_Offer(list[i],this.resultContainer,data.offer_form,data.all_carriers,this.dataList,{onBuyButton:function(){obSelf.onBuyButton()},onBuyFail:function(offer,routes){obSelf.onBuyFail(offer,routes)},onBuyError:function(){obSelf.params.onBuyError();obSelf.update(true)},deniedOffers:this._getDeniedOffers(list[i]["hash"])})}this.relatedparams=data.relatedparams;this.page=1;this.totalPages=parseInt((this.offers.length-1)/this.rop)+1;
this.params.onData(data);this.show()},onBuyButton:function(){var i,l,offers=this.offers;l=offers.length;for(i=0;i<l;i++){offers[i].shutdown()}$(window).unbind("scroll",this._loadNextPage);this.params.onBuyButton()},onBuyFail:function(offer,routes){var i,l,offers=this.offers;this._denyOffer(offer,routes);l=offers.length;for(i=0;i<l;i++){offers[i].shutup()}if(this.page<this.totalPages){$(window).bind("scroll",{result:this},this._loadNextPage)}this.params.onBuyFail()},_getDeniedOffers:function(hash){var paramsHash=$.toJSON(this.params.getParams());if(!this.deniedOffers[paramsHash]){return{}}return this.deniedOffers[paramsHash][hash]},_denyOffer:function(offer,routes){var paramsHash=$.toJSON(this.params.getParams());var i,hashAr=[];for(i in routes){hashAr.push(routes[i])}if(!this.deniedOffers[paramsHash]){this.deniedOffers[paramsHash]={}}if(!this.deniedOffers[paramsHash][offer]){this.deniedOffers[paramsHash][offer]={}}this.deniedOffers[paramsHash][offer][hashAr.join("_")]=1},checkBottomPadding:function(){var windowWidth=parseInt($(window).width());if(windowWidth<1150){$(".rm-foot_spacer").addClass("compact")}else{$(".rm-foot_spacer").removeClass("compact")}}});var RM_Tutu_Avia_SearchResultPage=RM.Class.extend({searchForm:null,searchResult:null,params:{},filters:{},init:function(params,filters,newBackend){var obSelf=this;this.params=$.extend({},this.params,params);this.filters=$.extend({},this.filters,filters);$(document).ready(function(){if(newBackend){obSelf.searchResult=new RM_Tutu_Avia_Offers_List({getParams:function(){return obSelf.searchForm.getSearchParams()},getFilters:function(){return obSelf.searchForm.getSearchFilters()},onData:function(data){obSelf.searchForm.onSearchResultUpdate(data)},onError:function(error){obSelf.searchForm.onSearchResultError(error)},onBuyButton:function(){obSelf.searchForm.onBuyButton()},onBuyError:function(){obSelf.searchForm.onBuyError()},onBuyFail:function(){obSelf.searchForm.onBuyFail()}})}else{obSelf.searchResult=new RM_Tutu_Avia_SearchResult({getParams:function(){return obSelf.searchForm.getSearchParams()},getFilters:function(){return obSelf.searchForm.getSearchFilters()},onData:function(data){obSelf.searchForm.onSearchResultUpdate(data)},onError:function(error){obSelf.searchForm.onSearchResultError(error)},onBuyButton:function(){obSelf.searchForm.onBuyButton()},onBuyError:function(){obSelf.searchForm.onBuyError()},onBuyFail:function(){obSelf.searchForm.onBuyFail()}})}if(params.ab_testing_short==1){RM.AbTesting_ShortForm=1}obSelf.params.searchResult=obSelf.searchResult;obSelf.searchForm=new RM_Tutu_Avia_SearchForm($("#search_form").get(0),obSelf.params,obSelf.filters);$(document).ready(function(){obSelf.searchResult.update(obSelf.params.error_code&&!isNaN(parseInt(obSelf.params.error_code))&&(parseInt(obSelf.params.error_code)>0))})})}});var RM_Tutu_Train_Schedule_Change=RM.Class.extend({checkTimeout:60000,tableId:null,changeList:{},trainList:{},trainHashFields:["from","to","date","train"],init:function(tableId,changeData){this.tableId=tableId;this.initLists(changeData);this.initHTML()},initLists:function(changeData){var l=changeData.length;var trainData,trainHash,currentChange;for(var i=0;i<l;i++){currentData=changeData[i];currentChange={done:0};trainData=currentData.departure;trainHash=this._pushTrain(trainData);currentChange.departure=trainHash;trainData=currentData.arrival;trainHash=this._pushTrain(trainData);currentChange.arrival=trainHash;this.changeList[currentData.id]=currentChange}},_pushTrain:function(trainData){var hash=this._getTrainHash(trainData);this.trainList[hash]=trainData;return hash},_getTrainHash:function(trainData){var res=[];for(var i in this.trainHashFields){res.push(trainData[this.trainHashFields[i]])}return res.join("|")},initHTML:function(){var obTable=this.getTable();obTable.find(".nojs-only").addClass("dNone");obTable.find(".js-only").removeClass("dNone")},getTable:function(){return $("#"+this.tableId)},check:function(changeId){var obSelf=this;var requestData=this.getRequestData(changeId);if(!requestData.length){this.refreshChangeView(changeId);return}this.startBtn(changeId);$.ajax({url:url.get("train.schedule.change.check"),type:"POST",timeout:this.checkTimeout,data:{train:requestData},dataType:"json",complete:function(jqXHR,textStatus){obSelf.stopBtn(changeId)},error:function(jqXHR,textStatus,errorThrown){obSelf.showError(changeId)},success:function(data,textStatus,jqXHR){if(data.train.length){obSelf.processCheckResult(changeId,data.train)}else{obSelf.showError(changeId)}}})},getRequestData:function(changeId){var changeData=this.changeList[changeId];var res=[];var trainData;trainData=this.getTrainRequestData(changeData.departure);if(trainData){res.push(trainData)}trainData=this.getTrainRequestData(changeData.arrival);if(trainData){res.push(trainData)}return res},getTrainRequestData:function(trainHash){var trainData=this.trainList[trainHash];if(trainData.loaded){return 0}return{from:trainData.from,to:trainData.to,train:trainData.train,date:trainData.date}
},startBtn:function(changeId){var obButton=window["checkTrainsButton"+changeId];obButton.push()},stopBtn:function(changeId){var obButton=window["checkTrainsButton"+changeId];obButton.reset()},processCheckResult:function(changeId,data){var hash,i;var l=data.length;for(i=0;i<l;i++){hash=this._pushTrain(data[i]);this.refreshTrainView(hash)}this.refreshView()},refreshTrainView:function(hash){if(!this.trainList[hash]["seats"]){return}var block;var listDep=[];var listArr=[];var l,i,j;for(i in this.changeList){if(this.changeList[i]["departure"]==hash){listDep.push(i)}if(this.changeList[i]["arrival"]==hash){listArr.push(i)}}l=listDep.length;for(j=0;j<l;j++){block=$(RM.tmpl("train_schedule_change_seats",this.getTrainSeatsData(hash)));$(this.getTable()).find("tr.group"+listDep[j]+" .rm_departure_seats").html(block)}l=listArr.length;for(j=0;j<l;j++){block=$(RM.tmpl("train_schedule_change_seats",this.getTrainSeatsData(hash)));$(this.getTable()).find("tr.group"+listArr[j]+" .rm_arrival_seats").html(block)}$("span[rel=ukr_empty_price_warning]").attr("use_tooltip",true).attr("title",RM.L("train.schedule.ukr_empty_price_warning"));$("span[rel=ukr_empty_price_warning]").tooltip({track:true,delay:0,fade:250,extraClass:"pretty"})},getTrainSeatsData:function(hash){var data;var res=[];for(var i in this.trainList[hash]["cars"]){data=this.trainList[hash]["cars"][i];res.push({name:RM.L("list.train.category.name.title_short_"+data.id),seats:data.seats,price:data.price})}return{seats:res,external:this.trainList[hash]["external"],seatsLength:res.length}},refreshView:function(){for(var i in this.changeList){if(!this.changeList[i]["done"]){this.refreshChangeView(i)}}tableHeight()},refreshChangeView:function(changeId){var changeData=this.changeList[changeId];var departureHash=changeData.departure;var departureTrain=this.trainList[departureHash];var arrivalHash=changeData.arrival;var arrivalTrain=this.trainList[arrivalHash];if(departureTrain.loaded&&!departureTrain.seats){this.showFail(changeId);this.changeList[changeId]["done"]=1}else{if(arrivalTrain.loaded&&!arrivalTrain.seats){this.showFail(changeId);this.changeList[changeId]["done"]=1}else{if(departureTrain.loaded&&arrivalTrain.loaded){if(departureTrain.seats&&arrivalTrain.seats){this.showSuccess(changeId);this.changeList[changeId]["done"]=1}}}}},showError:function(changeId){this.showChangeMessage(changeId,RM.L("train.schedule.change.check_failed"))},showFail:function(changeId){var failTrain=[];var message,l,d1,d2;var departureTrain=this.trainList[this.changeList[changeId]["departure"]];var arrivalTrain=this.trainList[this.changeList[changeId]["arrival"]];this.hideRequestButton(changeId);if(departureTrain.loaded&&!departureTrain.seats){failTrain.push(this.changeList[changeId]["departure"])}if(arrivalTrain.loaded&&!arrivalTrain.seats){failTrain.push(this.changeList[changeId]["arrival"])}l=failTrain.length;if(!l){message=RM.L("train.schedule.change.no_seats")}else{if(l==1){d1=RM.Date.getObject(this.trainList[failTrain[0]]["date"]);message=RM.L("train.schedule.change.no_seats_1",{tn:this.trainList[failTrain[0]]["train"],date:RM.Date.format(d1,"DD $m")})}else{d1=RM.Date.getObject(this.trainList[failTrain[0]]["date"]);d2=RM.Date.getObject(this.trainList[failTrain[1]]["date"]);if(d1.toString()==d2.toString()){message=RM.L("train.schedule.change.no_seats_2_a",{tn1:this.trainList[failTrain[0]]["train"],tn2:this.trainList[failTrain[1]]["train"],date:RM.Date.format(d1,"DD $m")})}else{message=RM.L("train.schedule.change.no_seats_2_b",{tn1:this.trainList[failTrain[0]]["train"],date1:RM.Date.format(d1,"DD $m"),tn2:this.trainList[failTrain[1]]["train"],date2:RM.Date.format(d2,"DD $m")})}}}this.showChangeMessage(changeId,message)},showSuccess:function(changeId){this.hideRequestButton(changeId);this.showBuyButtons(changeId);this.showChangeMessage(changeId,RM.L("train.schedule.change.buy_tickets",{tn1:this.trainList[this.changeList[changeId]["departure"]]["train"],tn2:this.trainList[this.changeList[changeId]["arrival"]]["train"]}))},hideRequestButton:function(changeId){$(this.getTable).find("#request_button_"+changeId).addClass("dNone")},showBuyButtons:function(changeId){$(this.getTable).find("#train_row_"+changeId+"_1").removeClass("dNone");$(this.getTable).find("#train_row_"+changeId+"_2").removeClass("dNone")},showChangeMessage:function(changeId,message){$(this.getTable).find(".group"+changeId+" .order_answer").removeClass("dNone").html(message)}});var RM_Ajax_DataList=RM.Class.extend({name:null,url:null,params:null,settings:{delay:0,onStart:function(){},onSuccess:function(list,data){},onError:function(error,data){}},storage:null,page:null,xhr:null,isDataLoading:false,init:function(name,url,params,settings){this.name=name;this.storage=new RM_LocalStorage(this.name);this.url=url;this.params=params;this.settings=$.extend({},this.settings,settings)},show:function(page){var obSelf=this;this.page=this.normalizePage(page);this.settings.onStart();this.request(this.page,function(data,page){if(obSelf.settings.onSuccess){obSelf.settings.onSuccess.call(obSelf,data.list[page]?data.list[page]:[],data)
}},function(errorThrown,data){if(obSelf.settings.onError){obSelf.settings.onError.call(obSelf,errorThrown,data)}})},flush:function(page){this.storage.clearItem(this.ns(this.callback(this.url),this.callback(this.params)))},normalizePage:function(page){page=parseInt(page);if(isNaN(page)||page<1){page=1}return page},request:function(page,success,error){var obSelf=this;var url=this.callback(this.url);var params=this.callback(this.params);var ns=this.ns(url,params);if(this.requestChanged(ns,page)){if(this.settings.delay){$(document).stopTime(this.name).oneTime(this.settings.delay,this.name,function(){obSelf.requestSend(url,params,page,success,error)})}else{obSelf.requestSend(url,params,page,success,error)}}else{obSelf.requestComplete(ns,page,success,error)}},requestSend:function(url,params,page,success,error){var obSelf=this;var ns=this.ns(url,params);if(this.xhr){this.xhr.abort()}this.isDataLoading=true;this.xhr=$.ajax({url:url,data:params+"&page="+page,dataType:"json",type:"POST",success:function(data,textStatus,jqXHR){if(jqXHR.readyState==4){if(data!=null){obSelf.requestSave(ns,data);obSelf.requestComplete(ns,page,success,error)}else{error("request error")}}},error:function(jqXHR,textStatus,errorThrown){error(errorThrown)},complete:function(jqXHR,textStatus){obSelf.isDataLoading=false}})},ns:function(url,params){return url+params},requestComplete:function(ns,page,success,error){var data=this.getData(ns);if(!data.list){error(data.error?data.error:"",data)}else{success(data,page)}},requestSave:function(ns,data){if(!data.pages){data.pages=data.list?data.list.length:0}var oldData=this.getData(ns);if(oldData&&oldData.list){for(var i=1;i<=data.pages;i++){if(!data.list[i]&&oldData.list[i]){data.list[i]=oldData.list[i]}}}this.setData(ns,data)},requestChanged:function(ns,page){var data=this.getData(ns);return(!data||!data.list||!data.list[page])},setData:function(ns,data){data.time=new Date();if(!data.timelimit){data.timelimit=60}this.storage.setItem(ns,data)},getData:function(ns,filter){var data=this.storage.getItem(ns);if(!data){return null}data.time=new Date(data.time);var now=new Date();if((now.getTime()-data.time.getTime())>data.timelimit*1000){this.storage.clearItem(ns);return null}return data},callback:function(variable){if(variable&&(variable instanceof Object)&&variable.constructor.toString().match(/^\s*function/)){return variable()}else{return variable}}});var RM_Ajax_MultiThread=RM.Class.extend({tasks:[],init:function(options){$.extend(this,options);for(i in this.tasks){this.tasks[i].pid=Math.floor(Math.random()*1000000)}this.processTasks();this.checkTasks()},processTasks:function(){for(i in this.tasks){var task=this.tasks[i];var get={rand:Math.random(),pid:task.pid};if(task.processFileData){$.ajaxFileUpload({url:url.url(get,null,task.processUrl),secureuri:false,fileElementId:task.processFileData.fileElementId,dataType:"json"})}else{$.ajax({url:url.url(get,null,task.processUrl),dataType:"json",type:"post",data:task.processPostData?task.processPostData:""})}}},checkTasks:function(){for(i in this.tasks){this.checkTask(i)}},checkTask:function(index){var obSelf=this;var task=this.tasks[index];var get={rand:Math.random(),pid:task.pid};$.ajax({url:url.url(get,null,task.checkUrl),dataType:"json",success:function(data,textStatus){switch(data.status){case"check":if(task.check){task.check(data)}return setTimeout(function(){obSelf.checkTask(index)},task.checkTimeout);case"error":if(task.error){task.error(data)}return;case"success":return task.success(data);case"undefined":return setTimeout(function(){obSelf.checkTask(index)},task.checkTimeout);default:alert("Unknown request status `"+data.status+"`")}},error:function(data,textError){data.error=textError;task.error(data)}})}});var RM_DatePicker=RM.Class.extend({init:function(objectId,settings,profile){var object=$("#"+objectId);var params=settings;if(profile){params=$.extend({},profile,params)}object.datepicker(params);$('[rel="calendarTrigger"'+objectId+"]").each(function(){$(this).click(function(){object.datepicker("show")})})}});RM.DatePicker={calendar:{},profile:{admin:{constrainInput:true,numberOfMonths:2,firstDay:1,useTomorrow:false,useAfterTomorrow:false,navigationAsDateFormat:true,currentText:"Сегодня",showButtonPanel:true,onChangeMonthYear:function(year,month,inst){$.datepicker.setNextPrevMonthNames(inst,month+1,month-2)},beforeShow:function(input,inst){var month=$.datepicker.time($(input).datepicker("getDate")).getMonth();$.datepicker.setNextPrevMonthNames(inst,month+2,month-1)},beforeShowDay:function(date){return[true,RM.DatePicker.isDayoff(date)?"ui-datepicker-week-end":"ui-datepicker-work-day"]}},trains:{buttonImage:url.S("/images2/blank.gif"),buttonImageOnly:true,buttonText:RM.L("common.calendar"),showOn:"both",constrainInput:true,numberOfMonths:2,firstDay:1,useTomorrow:false,useAfterTomorrow:false,duration:0,navigationAsDateFormat:true,currentText:"Сегодня",showButtonPanel:true,onChangeMonthYear:function(year,month,inst){$.datepicker.setNextPrevMonthNames(inst,month+1,month-2)
},beforeShow:function(input,inst){var month=$.datepicker.time($(input).datepicker("getDate")).getMonth();$.datepicker.setNextPrevMonthNames(inst,month+2,month-1)},beforeShowDay:function(date){var enabled=true;var style="";var ONE_DAY=1000*60*60*24;var difference=(date.getTime()-$.datepicker.now().getTime())/ONE_DAY;if(difference>0){difference=parseInt(difference)+1}else{difference=parseInt(difference)}if(difference<0||difference>44){style="ui-datepicker-unexpected"}return[enabled,style]}}},setCalendar:function(calendar){this.calendar=calendar},isDayoff:function(date){var dateStr=date.getFullYear()+"-"+this._leadzero(date.getMonth()+1)+"-"+this._leadzero(date.getDate());if(this.calendar&&(this.calendar[dateStr]===false||this.calendar[dateStr]===true)){return this.calendar[dateStr]}else{return(date.getDay()==0||date.getDay()==6)}},_leadzero:function(str){return parseInt(str)<10?"0"+str:str}};var RM_Tutu_Train_Sapsan=RM.Class.extend({parent:null,active:null,init:function(parent){var obSelf=this;this.parent=parent;$(parent).find(".sapsan-calendar").datepicker($.extend({},RM.DatePicker.profile.trains,{showOn:"focus",onSelect:function(dateText,inst,input){window.location.assign($('a[rel="'+inst.id+'"]').attr("href")+"&date="+dateText)},beforeShow:function(input,inst){RM.DatePicker.profile.trains.beforeShow(input,inst);obSelf._activateRow(input.id)},onClose:function(){obSelf._deactivateAll()}}));$(parent).not(".sapsan-landing").find(".sapsan-buy").each(function(){$(this).click(function(){$(this).next().children(".sapsan-calendar").datepicker("show");return false})});$(parent).find("tr").hover(function(){if(!obSelf.active){$(obSelf.parent).find("tr").removeClass("active");$(this).addClass("active")}},function(){if(!obSelf.active){$(this).removeClass("active")}});if($(".sapsan_vagon_sheme").length){obSelf._carScheme()}$(parent).find(".b-shedule_wrapper").each(function(){$(this).find("tbody tr:first").addClass("b_first-string").addClass("active")});$(parent).find(".b-shedule_directions").each(function(){$(this).find("tbody tr:last").addClass("b_last-string")});if($(parent).hasClass("sapsan-landing")){$(parent).find(".rm-shedule_directions").hover(function(){$(obSelf.parent).find(".b_first-string").removeClass("active")},function(){$(obSelf.parent).find(".b_first-string").addClass("active")})}$(".sapsan-title_ticket_sale a").datepicker($.extend({minDate:"+0d",maxDate:"+44d"},RM.DatePicker.profile.trains,{onSelect:function(dateText,inst,input){var aParams=window.location.search.replace(/^\?/,"").split("&");var oParams={};for(var i=0;i<aParams.length;i++){aParams[i]=aParams[i].split("=");oParams[aParams[i][0]]=aParams[i][1]}oParams.date=dateText;aParams=[];for(var key in oParams){aParams.push(key+"="+oParams[key])}window.location.assign(window.location.pathname+"?"+aParams.join("&"))},beforeShowDay:function(date){return[true,""]}}));$("#sapsan-datepicker").click(function(event){$(".sapsan-title_ticket_sale a").datepicker("show")})},_deactivateAll:function(){$(this.parent).find("tr").removeClass("active");this.active=null},_activateRow:function(id){$(this.parent).find('tr[rel="'+id+'"]').addClass("active");this.active=id},_carScheme:function(){$(".sheme_vagons_econom .pseudoBlue").click(function(){$(".sheme_vagons_econom .pseudoBlue").removeClass("active");$(this).addClass("active")});$(".sheme_vagons_business .pseudoBlue").click(function(){$(".sheme_vagons_business .pseudoBlue").removeClass("active");$(this).addClass("active")});$(".vagon_1").click(function(){$(".sheme_vagons_business .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-one").removeClass("dNone").addClass("dBlock")});$(".vagon_2").click(function(){$(".sheme_vagons_business .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-two").removeClass("dNone").addClass("dBlock")});$(".vagon_3").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-three").removeClass("dNone").addClass("dBlock")});$(".vagon_4").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-four").removeClass("dNone").addClass("dBlock")});$(".vagon_6").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-six").removeClass("dNone").addClass("dBlock")});$(".vagon_7").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-seven").removeClass("dNone").addClass("dBlock")});$(".vagon_8").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-eight").removeClass("dNone").addClass("dBlock")});$(".vagon_9").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-nine").removeClass("dNone").addClass("dBlock")});$(".vagon_10").click(function(){$(".sheme_vagons_econom .sapsan_map").removeClass("dBlock").addClass("dNone");$(".sapsan_map-ten").removeClass("dNone").addClass("dBlock")
});if(window.location.hash){var element=$(".vagon_"+window.location.hash.split("_")[1]);if(element.length){element.trigger("click")}}}});var RM_Tutu_Bootstrap=RM.Class.extend({init:function(){},blockIframe:function(mainUrl,allowedDomains,allowedFrameSrc){try{if(top===self){return}var regExp=new RegExp(allowedFrameSrc+"$","i");if(regExp.test(location.host)){return}for(var i=0;i<allowedDomains.length;i++){var regExp=new RegExp(allowedDomains[i]+"$","i");if(regExp.test(top.location.host)){return}}top.location.assign(mainUrl)}catch(e){var link="Tutu.ru";var message='<h1 align="center">Это сайт подделка<br><br>Он не имеет никакого отношения к '+link+".<br><br>Наберите в адресной строке браузера tutu.ru чтобы попасть на настоящий сайт.<br><br>Сейчас мы пытаемся связаться с соответствующими службами, чтобы прекратить это мошеничество.<br><br>С уважением,<br>администрация "+link+"</h1>";document.write(message);$(document).ready(function(){$(document.body).html(message)})}},initTick:function(){if(typeof window.tick!="function"){function tick(str){}}},initOpera:function(){try{if(window.opera){var headElement=document.getElementsByTagName("head")[0];if(headElement&&headElement.innerHTML){headElement.innerHTML+='<meta http-equiv="refresh" content="1">'}}}catch(e){}}});RM.TutuBootstrap=new RM_Tutu_Bootstrap();var RM_Tutu_Etrain_Schedule_GoneFilter=RM.Class.extend({init:function(options){this.tableId="schedule_table";this.trainListIteratorQuery="#"+this.tableId+">tbody>tr";this.visibleTrainListIteratorQuery="#"+this.tableId+">tbody>tr:visible";this.goneVisibleTrainListIteratorQuery="#"+this.tableId+">tbody>tr.indication_gone:visible";this.goneToggleId="goneToggle";$.extend(this,options)},initEvents:function(){var obSelf=this;$("#"+this.goneToggleId).show();$("#"+this.goneToggleId+" a").click(function(){if($(this).hasClass("clicked")){$(this).removeClass("clicked");$(this).html("Показать все ушедшие электрички");obSelf._hideGoneTrains()}else{$(this).addClass("clicked");$(this).html("Скрыть ушедшие электрички");obSelf._showGoneTrains()}return false});this._hideGoneTrains()},removeSeparatorLocation:function(){$(this.visibleTrainListIteratorQuery).each(function(){$(this).removeClass("indication_last_tooltip")})},changeSeparatorLocation:function(){var listStartByGoneTrain=null;var goneIntervalCount=0;var presentIntervalCount=0;var startGoneInterval=false;var startPresentInterval=false;var goneCount=0;$(this.visibleTrainListIteratorQuery).each(function(){if(listStartByGoneTrain===null){listStartByGoneTrain=$(this).hasClass("indication_gone")?true:false}if($(this).hasClass("indication_gone")){goneCount++;if(!startGoneInterval){startGoneInterval=true;goneIntervalCount++}if(startPresentInterval){startPresentInterval=false}}else{if(startGoneInterval){startGoneInterval=false}if(!startPresentInterval){startPresentInterval=true;presentIntervalCount++}}});var presentCount=$(this.visibleTrainListIteratorQuery).length-goneCount;var goneIteration=0;var iteration=0;this.removeSeparatorLocation();$(this.visibleTrainListIteratorQuery).each(function(){iteration++;if($(this).hasClass("indication_gone")){goneIteration++}if(goneIntervalCount==1&&presentIntervalCount<=1){if(listStartByGoneTrain){if($(this).hasClass("indication_gone")&&goneIteration==goneCount){$(this).addClass("indication_last_tooltip")}}else{if(!$(this).hasClass("indication_gone")&&iteration==presentCount){$(this).addClass("indication_last_tooltip")}}}})},_toggleGoneTrains:function(){this._showGoneTrains();if($(this.goneVisibleTrainListIteratorQuery).length>3){$("#"+this.goneToggleId).show();if(!$("#"+this.goneToggleId+" a").hasClass("clicked")){this._hideGoneTrains()}}else{$("#"+this.goneToggleId).hide()}},_showGoneTrains:function(){$(this.trainListIteratorQuery).removeClass("lasttrains_dontshow")},_hideGoneTrains:function(){var obSelf=this;var goneTrainTimes=[];$(this.visibleTrainListIteratorQuery).each(function(){if($(this).hasClass("indication_gone")){goneTrainTimes[goneTrainTimes.length]=obSelf._getTime(this)}});goneTrainTimes.sort();var goneTrainTimesToShow=[];$.extend(goneTrainTimesToShow,goneTrainTimes);var iteration=0;while(goneTrainTimesToShow.length>3){delete (goneTrainTimesToShow[iteration]);var newGoneTrainTimes=[];$.each(goneTrainTimesToShow,function(key,value){if(value){newGoneTrainTimes[newGoneTrainTimes.length]=value}});goneTrainTimesToShow=newGoneTrainTimes}$(this.visibleTrainListIteratorQuery).each(function(){if($(this).hasClass("indication_gone")){if($.inArray(obSelf._getTime(this),goneTrainTimesToShow)<0){$(this).addClass("lasttrains_dontshow")}}})},_getTime:function(rowDomObject){return parseInt($.trim($(rowDomObject).find(".departureIntTime").html()),10)}});var RM_Tutu_Etrain_Schedule_Filter=RM_Tutu_Etrain_Schedule_GoneFilter.extend({init:function(options){this._super(options);this.trainListIteratorQuery="#"+this.tableId+">tbody>tr";this.filterActive=null;$.extend(this,options)},initEvents:function(){var obSelf=this;if(this.filterList.length){$.each(this.filterList,function(key,filterType){if(obSelf.disableFilters[filterType]){return false
}$("#filter-"+filterType).addClass(obSelf.classes[filterType]).attr("href","javascript:void(0)").click(function(){obSelf.filter(this,filterType);return false})})}},filter:function(domObject,filterType){$(this.trainListIteratorQuery).css("display","none");if($(domObject).hasClass("clicked")){$(domObject).removeClass("clicked");this.filterActive=null;$(this.trainListIteratorQuery).css("display","")}else{$(domObject).addClass("clicked");if(this.filterActive){$("#filter-"+this.filterActive).removeClass("clicked")}this.filterActive=filterType;$(this.trainListIteratorQuery+".colorType-"+filterType).css("display","")}this._toggleGoneTrains();this.changeSeparatorLocation()},changeSeparatorLocation:function(){this._super()},_toggleGoneTrains:function(){this._super()}});var RM_Tutu_Etrain_Schedule_Price=RM.Class.extend({init:function(options){this.data={};$.extend(this,options)},initEvents:function(){var obSelf=this;var linkSwitchClass="opened";var blockSwitchClass="dNone";$(".priceLink").click(function(){if($(this).hasClass(linkSwitchClass)){var detailedBlockDomObject=$(this).parents(".priceBlock").find(".priceDetailedBlock");if($.browser.msie){$(detailedBlockDomObject).hide("fast")}else{$(detailedBlockDomObject).addClass(blockSwitchClass)}$(this).removeClass(linkSwitchClass)}else{$(".priceLink").each(function(){var detailedBlockDomObject=$(this).parents(".priceBlock").find(".priceDetailedBlock");if($.browser.msie){$(detailedBlockDomObject).hide("fast")}else{$(detailedBlockDomObject).addClass(blockSwitchClass)}$(".priceLink").removeClass(linkSwitchClass)});var popupDetailedBlockDomObject=$(this).parents(".priceBlock").find(".pricePopupDetailedBlock");if($.trim($(popupDetailedBlockDomObject).html())){obSelf._openDetailedBlock(this)}else{obSelf._loadDetailedBlock(this)}}return false});$("body").click(function(){$(".priceLink").each(function(){if($(this).hasClass(linkSwitchClass)){var detailedBlockDomObject=$(this).parents(".priceBlock").find(".priceDetailedBlock");if($.browser.msie){$(detailedBlockDomObject).hide("fast")}else{$(detailedBlockDomObject).addClass(blockSwitchClass)}$(this).removeClass(linkSwitchClass)}})})},_initTooltopEvents:function(linkDomObject){var popupDetailedBlockDomObject=$(linkDomObject).parents(".priceBlock").find(".pricePopupDetailedBlock");$(".help_hint, .attention_hint",$(popupDetailedBlockDomObject)).tooltip({track:true,delay:0,fade:250,extraClass:"pretty"});$(popupDetailedBlockDomObject).click(function(event){event=event||window.event;event.cancelBubble=true;if(event.stopPropagation){event.stopPropagation()}});var priceFirstColHeight=$(popupDetailedBlockDomObject).find(".content_etrain_price").eq(0).height();var priceSecondColHeight=$(popupDetailedBlockDomObject).find(".content_etrain_price-second_block").eq(0).height()-42;$(popupDetailedBlockDomObject).find(".content_etrain_price-second_block .first_part").height(priceSecondColHeight);if(priceFirstColHeight<priceSecondColHeight+29){$(".b-popup .content_etrain_price").height(priceSecondColHeight+29)}else{$(".b-popup .content_etrain_price-second_block .first_part").height(priceFirstColHeight-29)}},_openDetailedBlock:function(linkDomObject){var linkSwitchClass="opened";var blockSwitchClass="dNone";var detailedBlockDomObject=$(linkDomObject).parents(".priceBlock").find(".priceDetailedBlock");if($.browser.msie){$(detailedBlockDomObject).show("fast")}else{$(detailedBlockDomObject).removeClass(blockSwitchClass)}$(linkDomObject).addClass(linkSwitchClass)},_loadDetailedBlock:function(linkDomObject){var obSelf=this;var post={};var post=$.extend(post,this.data);var post=$.extend(post,$(linkDomObject).metadata());this._isStartedDetailedBlockLoading();$.ajax({type:"post",url:url.get("ajax",null,{Action:this.loadDetailedBlockAction,rand:Math.random()}),data:post,dataType:"json",success:function(data,textStatus){obSelf._isFinishedDetailedBlockLoading();var popupDetailedBlockDomObject=$(linkDomObject).parents(".priceBlock").find(".pricePopupDetailedBlock");$(popupDetailedBlockDomObject).html(data.html);obSelf._openDetailedBlock(linkDomObject);obSelf._initTooltopEvents(linkDomObject)}})},_isStartedDetailedBlockLoading:function(){obPopup.show("loader")},_isFinishedDetailedBlockLoading:function(){obPopup.hide("loader")}});var RM_Tutu_Etrain_SmsBanner=RM.Class.extend({_intervalId:null,_stepNumber:0,_prevStepClass:"",init:function(options){this.data={};$.extend(this,options)},initEvents:function(){var obSelf=this;$(".rm-submit_button").click(function(){obSelf._request()});$(".rm-reset_link").click(function(){$(".rm-submit_item").toggleClass("dnone")})},_request:function(){var obSelf=this;var data=$("#smsForm").serializeArray();data[data.length]={name:"rand",value:Math.random()};data=this._stripPrefix(data);this._isStarted();$.ajax({url:this.smsScheduleUrl,type:"get",data:data,dataType:"html",success:function(data){obSelf._isFinished();var text=null;if(data.substr(0,4)=="sms="){text=decodeURIComponent((data.substr(4)+"").replace(/\+/g,"%20"))}$("#smsAnswer").html(text)
}})},_stripPrefix:function(data){var obSelf=this;$.each(data,function(key,item){if(item.name=="txt"){var pattern=new RegExp(lang.get("etrain.common.banner_prefix_"+obSelf.region)+" ","i");item.value=item.value.replace(pattern,"");var pattern=new RegExp(lang.get("etrain.common.banner_prefix_"+obSelf.region+"_translit")+" ","i");item.value=item.value.replace(pattern,"");data[key]=item}});return data},_isStarted:function(){$(".rm-smart_status").addClass("status_wait");this._animateWaitIndicator()},_isFinished:function(){clearInterval(this._intervalId);$(".rm-smart_status").removeClass("status_wait");$(".rm-submit_item").toggleClass("dnone")},_animateWaitIndicator:function(){var obSelf=this;this._nextStep();this._intervalId=setInterval(function(){obSelf._nextStep.call(obSelf)},500)},_nextStep:function(){this._stepNumber++;var stepClass="show_"+this._stepNumber;$(".rm-wait").addClass(stepClass).removeClass(this._prevStepClass);this._prevStepClass=stepClass;if(this._stepNumber==3){this._stepNumber=0}}});var RM_Tutu_Infoblock=RM.Class.extend({objContainer:null,nestedContainerSelector:"#null",init:function(objContainer){this.objContainer=$(objContainer);if(this.objContainer.hasClass("rm-infoblock_nested")){this.nestedContainerSelector="."+this.objContainer.attr("rel")+" *"}this._initEvents()},_initEvents:function(){this._controlShowElement().bind("click",{context:this},function(event){event.data.context.show(this);return false});this._controlToggleElement().bind("click",{context:this},function(event){event.data.context.toggle(this);console.log(5);return false});this._controlHideElement().bind("click",{context:this},function(event){event.data.context.hide(this);return false});$(document).bind("click",{context:this},function(event){if($(event.target).closest(".rm-infoblock_popup").length){return}event.data.context._hidePopups();event.stopPropagation()})},_hideAll:function(){this._hidePopups();if(!this.objContainer.hasClass("rm-infoblock_multi")){this.objContainer.find(".st-active").not(this.nestedContainerSelector).removeClass("st-active")}},_hidePopups:function(){$(".rm-infoblock_popup.st-active").each(function(){var targetBlock=$(this).attr("rel");$('.st-active[rel="'+targetBlock+'"]').removeClass("st-active")})},show:function(obItem){this._hideAll();this.objContainer.find('*[rel="'+$(obItem).attr("rel")+'"]').not(this.nestedContainerSelector).addClass("st-active")},hide:function(obItem){this.objContainer.find('.st-active[rel="'+$(obItem).attr("rel")+'"]').not(this.nestedContainerSelector).removeClass("st-active");this._hideAll()},toggle:function(obItem){if(this._isVisible(obItem)){this.hide(obItem)}else{this.show(obItem)}},_isVisible:function(obItem){return $(obItem).hasClass("st-active")},_controlShowElement:function(){return this.objContainer.find(".rm-infoblock_show").not(this.nestedContainerSelector)},_controlToggleElement:function(){return this.objContainer.find(".rm-infoblock_toggle").not(this.nestedContainerSelector)},_controlHideElement:function(){return this.objContainer.find(".rm-infoblock_hide").not(this.nestedContainerSelector)}});var RM_Tutu_TabsList=RM.Class.extend({objContainer:null,init:function(objContainer){this.objContainer=objContainer;this.initEvents();this.initHTML()},initEvents:function(){var obSelf=this;this.objContainer.find(".rm-tabs_list-title").bind("click",function(){obSelf.onItemClick(this)});this.objContainer.find(".rm-tabs_list-close").bind("click",function(){obSelf.hideAll()})},initHTML:function(){this.objContainer.find(".rm-tabs_list-title:first").click()},hideAll:function(){this.objContainer.find(".rm-tabs_list-title").removeClass("selected");this.objContainer.find(".rm-tabs_list-text").removeClass("selected")},onItemClick:function(obItem){var targetText=$(obItem).attr("rel");var isCurrentSelected=this.objContainer.find('.rm-tabs_list-title[rel="'+targetText+'"]').hasClass("selected");this.hideAll();if(!isCurrentSelected){this.objContainer.find('.rm-tabs_list-title[rel="'+targetText+'"]').addClass("selected");this.objContainer.find(".rm-tabs_list-text."+targetText).addClass("selected")}}});var RM_Tutu_Train_Order_Success_Eticket_BlankVerify=RM.Class.extend({parent:null,init:function(){this.parent=$(".rm-verify-block").get(0);this._initEvents();this._refreshSendButtons()},_initEvents:function(){var obSelf=this;$(this.parent).find(".rm-input-field").keyup(function(){obSelf._refreshSendButtons()}).click(function(){obSelf._refreshSendButtons()}).blur(function(){obSelf._refreshSendButtons()})},_refreshSendButtons:function(){if($(this.parent).find('input[name="credentials"]').val()){this._enableSend()}else{this._disableSend()}},_disableSend:function(){$(this.parent).find(".rm-send-button").addClass("disabled").unbind("click").click(function(){return false})},_enableSend:function(){$(this.parent).find(".rm-send-button").removeClass("disabled").unbind("click").click(function(){})}});var RM_Tutu_Train_Order_Success_Eticket_SendDocs=RM.Class.extend({block:null,form:null,orderHash:null,orderNumber:null,requestTimeout:60000,sendButton:null,needWait:false,showWaitingTimeout:700,init:function(orderHash,orderNumber){this.block=$(".rm-send-docs-block").get(0);
if(!this.block){return}this.form=$(".rm-send-docs-form").get(0);if(!this.form){return}this.orderHash=orderHash;this.orderNumber=orderNumber;this.sendButton=this._getSendButton();this._initFormEvents();this._initBlockEvents();this._prepareForm();this._prepareBlock()},_prepareBlock:function(){$(this.block).find(".rm-send-docs-block-waiting").find(".js_indicator").activity({segments:12,align:"left",valign:"top",steps:3,width:2,space:1,length:3,color:"#030303",speed:1,padding:0})},_prepareForm:function(){this._updateSendFormButtonState()},_initFormEvents:function(){var obSelf=this;$(this.form).find("input").keyup(function(){obSelf._updateSendFormButtonState()}).blur(function(){obSelf._updateSendFormButtonState()});$(this.form).find(".info_docs_input").focus(function(){var el=$(this);if(el.val()==el.attr("title")){el.removeClass("info_docs_input_active").val("")}}).blur(function(){var el=$(this);if(el.val()==""){el.addClass("info_docs_input_active").val(el.attr("title"))}}).blur().each(function(){var el=$(this);if(el.val()==el.attr("title")){el.addClass("info_docs_input_active")}});this.sendButton.actions.click=function(){obSelf.sendButtonClick()}},_getSendButton:function(){return obTrainSendDocsRequestButton},_onEmailLink:function(){this._sendAjax("email")},_onFileLink:function(){this._sendAjax("file")},sendButtonClick:function(){this._hideForm();this._sendAjax("request")},_canSendForm:function(){var requiredFields=["client","city","address","index"];for(var i in requiredFields){if(!this._getFormInputValue("info_docs_"+requiredFields[i])){return false}}return true},_getFormData:function(){var fields=["client","city","address","index","region"];var result={};for(var i in fields){result[fields[i]]=this._getFormInputValue("info_docs_"+fields[i])}return result},_getFormInput:function(name){return $(this.form).find("input[name="+name+"]")},_getFormInputValue:function(name){var el=this._getFormInput(name);var val=el.val();var title=el.attr("title");if(title&&title==val){return""}return val},_getAjaxRequestParams:function(requestType){var params={order_hash:this.orderHash,action:requestType};if(requestType=="request"){params.formData=this._getFormData()}return params},_sendAjax:function(requestType){var obSelf=this;this.needWait=true;setTimeout(function(){obSelf._showWaiting()},this.showWaitingTimeout);$.ajax({url:url.get("ajax",{},{Action:"train_documents_control"}),type:"POST",timeout:this.requestTimeout,data:this._getAjaxRequestParams(requestType),dataType:"json",complete:function(jqXHR,textStatus){obSelf._hideForm()},error:function(jqXHR,textStatus,errorThrown){obSelf._processError(requestType,{})},success:function(data,textStatus,jqXHR){if(data.error){obSelf._processError(requestType,data)}else{obSelf._processSuccess(requestType,data)}}})},_processError:function(requestType,requestData){var obSelf=this;this._showStatus(RM.L("train.order.success.send_docs."+requestType+"_error",{orderNumber:obSelf.orderNumber}),"red");if(requestData.need_verification){window.location.assign(requestData.verification_url)}},_processSuccess:function(requestType,requestData){this._showStatus(RM.L("train.order.success.send_docs."+requestType+"_success"),"green");if(requestType=="file"){this._openFiles()}},_showWaiting:function(){if(!this.needWait){return}this.needWait=false;$(this.block).find(".rm-send-docs-block-waiting").removeClass("dNone");$(this.block).find(".rm-send-docs-block-text").addClass("dNone");$(this.block).find(".rm-send-docs-block-status").addClass("dNone")},_showStatus:function(text,className){this.needWait=false;$(this.block).find(".rm-send-docs-block-waiting").addClass("dNone");$(this.block).find(".rm-send-docs-block-text").removeClass("dNone");if(text&&text!="-"){$(this.block).find(".rm-send-docs-block-status").removeClass("dNone").html(text).removeClass("red green").addClass(className)}},_openFiles:function(){var openUrl=url.get("train.order.documents",{orderHash:this.orderHash});this._downloadURL(openUrl)},_downloadURL:function(url){var iframe;iframe=document.getElementById("hiddenDownloader");if(iframe===null){iframe=document.createElement("iframe");iframe.id="hiddenDownloader";iframe.style.visibility="hidden";document.body.appendChild(iframe)}iframe.src=url},_showForm:function(){$(this.form).show()},_hideForm:function(){$(this.form).fadeOut(300)},_updateSendFormButtonState:function(){var checkResult=this._canSendForm();if(checkResult){this.sendButton.enable()}else{this.sendButton.disable()}},_initBlockEvents:function(){var obSelf=this;$(this.block).find(".rm-send-docs-request-link").click(function(){obSelf._showForm();return false});$(this.block).find(".rm-send-docs-email-link").click(function(){obSelf._onEmailLink();return false});$(this.block).find(".rm-send-docs-file-link").click(function(){obSelf._onFileLink();return false});$(document).click(function(event){if($(event.target).closest(".info_docs_form").length){return}obSelf._hideForm();event.stopPropagation()})}});var RM_Tutu_Train_Order_WaitingPage=RM.Class.extend({parent:null,orderHash:null,paymentId:null,checkInterval:5000,checkRequestTimeout:30000,init:function(orderHash,paymentId,initAction){this.orderHash=orderHash;
this.paymentId=paymentId;this.parent=$(".rm-waiting-page").get(0);if(initAction=="wait"){this._initCheck()}},_initCheck:function(){var obSelf=this;setTimeout(function(){obSelf._checkStatus()},obSelf.checkInterval)},_checkStatus:function(){var obSelf=this;$.ajax({url:url.get("ajax",{},{Action:"waiting_page_status"}),type:"POST",timeout:obSelf.checkRequestTimeout,data:{order_hash:obSelf.orderHash,payment_id:obSelf.paymentId},dataType:"json",error:function(jqXHR,textStatus,errorThrown){obSelf._processError()},success:function(data,textStatus,jqXHR){if(data.error){obSelf._processError()}else{obSelf._processStatus(data)}}})},_setMessage:function(message){$(this.parent).find(".rm-waiting-message").html(message)},_setHeadline:function(message){$(this.parent).find(".rm-waiting-headline").html(message)},_setWaitTime:function(message){$(this.parent).find(".rm-wait-time-message").html(message)},_processStatus:function(statusInfo){this._setMessage(statusInfo.message);this._setHeadline(statusInfo.headline);this._setWaitTime(statusInfo.waitTime);if(statusInfo.action=="redirect"){window.location.href=statusInfo.url}else{this._initCheck()}},_processError:function(){this._initCheck()}});var RM_Tutu_Train_Remind_Form=RM.Class.extend({init:function(){this._initPhoneCheck()},_initPhoneCheck:function(){var obSelf=this;$('input[rel="phone-number"]').each(function(){var obInput=$(this);obInput.mask("+7 (999) 999-99-99",{placeholder:"_",completed:null,hideMaskOnBlur:false,allowCleanInvalid:false})})}});var RM_Tutu_User_Form=RM.Class.extend({form:null,obMessage:null,obLoader:null,isHTTPS:null,obValidator:null,ajaxAddress:null,popupPosition:null,formData:null,getElementId:function(elmName){return this.form.id+"_"+elmName},getElement:function(elmName){return $("#"+this.getElementId(elmName))},showLoader:function(){this.getElement("submit").attr("disabled",true);if(this.obLoader){this.obLoader.show()}},hideLoader:function(){if(this.obLoader){this.obLoader.hide()}this.getElement("submit").removeAttr("disabled")},showMessage:function(text){if(this.obMessage){this.obMessage.showMessage(text)}else{alert(text)}},showError:function(text){if(this.obMessage){this.obMessage.showError(text)}else{alert(text)}},hideMessage:function(){if(this.obMessage){this.obMessage.hide()}},getPosition:function(elmName){var obElm=this.getElement(elmName);if(obElm){if(!this.popupPosition[elmName]){elmName="default"}return[obElm.offset().left+this.popupPosition[elmName]["xCoord"],obElm.offset().top+this.popupPosition[elmName]["yCoord"],this.popupPosition[elmName]["width"],this.popupPosition[elmName]["arrowX"],this.popupPosition[elmName]["arrow2X"]]}},reset:function(){var obSelf=this;if(obSelf.formData){for(id in obSelf.formData){if(obSelf.formData[id]["type"]=="checkbox"){$("#"+id).attr("checked",true)}else{$("#"+id).val(obSelf.formData[id]["value"])}}}else{this.form.reset()}},remember:function(){var obSelf=this;obSelf.formData={};$(obSelf.form).find("select,input").not("input[type=hidden,button,submit,reset,image]").each(function(){if(this.id){obSelf.formData[this.id]={name:this.name,type:this.type,value:this.value+""}}})},hidePopups:function(){if(this.obValidator){this.obValidator.hide()}},isHint:function(elmName){var obSelf=this;return obSelf.getElement(elmName).val()===obSelf.getElement(elmName).attr("default")},getValue:function(elmName){var obSelf=this;return(obSelf.isHint(elmName))?"":obSelf.getElement(elmName).val()},setValue:function(elmName,elmValue){var obSelf=this;var elm;if(elm=obSelf.getElement(elmName)){elm.trigger("focus");elm.val(elmValue)}},makeAjaxRequest:function(action,successFunction){var obSelf=this;this.showLoader();$.ajax({type:"post",url:url.get(this.ajaxAddress,{},{Action:action,rand:Math.random()}),data:$(this.form).serialize(),dataType:"json",success:function(data,textStatus){if(data.redirect){window.location.assign(data.redirect)}else{obSelf.hideLoader();if(data.status=="1"){successFunction(data)}else{if(data.error_place&&obSelf.getElement(data.error_place).length){var obPopup=obSelf.obValidator.add({message:function(){return data.error},position:function(){return obSelf.getPosition(data.error_place)}});obPopup.show(true)}else{obSelf.showError(data.error)}}}},error:function(data,textError){if(data.redirect){window.location.assign(data.redirect)}else{obSelf.hideLoader();obSelf.showError(textError)}}})}});var RM_Tutu_User_Form_Auth=RM_Tutu_User_Form.extend({loginCallback:null,logoutCallback:null,init:function(formId,obLoader,loginCallback,logoutCallback,isHTTPS){var obSelf=this;this.form=$("#"+formId).get(0);this.obLoader=obLoader;this.loginCallback=loginCallback;this.logoutCallback=logoutCallback;this.isHTTPS=isHTTPS;this.ajaxAddress=(isHTTPS)?"ajax.https":"ajax";this.popupPosition={login:{xCoord:0,yCoord:0,width:250,arrowX:10,arrow2X:0},password:{xCoord:0,yCoord:0,width:250,arrowX:10,arrow2X:0},"default":{xCoord:0,yCoord:0,width:250,arrowX:10,arrow2X:0}};var popups=[{message:function(){return lang.get("user.email_empty")},check:function(){return(!obSelf.getElement("login").val()||obSelf.isHint("login"))
},position:function(){return obSelf.getPosition("login")}},{message:function(){return lang.get("user.password_empty")},check:function(){return(!obSelf.getElement("password").val()||obSelf.isHint("password"))},position:function(){return obSelf.getPosition("password")}}];this.obValidator=new RM_Form_Popup_Validator(this.form,{submit:function(form,error){obSelf.hideMessage();if(error){return false}else{obSelf.login();return false}},fullCheck:[]},popups)},login:function(){var obSelf=this;if(!obSelf.isHTTPS){obSelf.form.submit();return false}obSelf.makeAjaxRequest("userLogin",function(data){obSelf.loginCallback(data.props);obSelf.reset()})},logout:function(){var obSelf=this;obSelf.makeAjaxRequest("userLogout",function(data){obSelf.logoutCallback()})}});var RM_Tutu_User_Form_Registration=RM_Tutu_User_Form.extend({regCallback:null,init:function(formId,obLoader,regCallback,isHTTPS){var obSelf=this;this.form=$("#"+formId).get(0);this.obLoader=obLoader;this.regCallback=regCallback;this.isHTTPS=isHTTPS;this.ajaxAddress=(isHTTPS)?"ajax.https":"ajax";this.popupPosition={login:{xCoord:0,yCoord:0,width:250,arrowX:10,arrow2X:0}};var popups=[{message:function(){return lang.get("user.email_empty")},check:function(){return(!obSelf.getElement("login").val()||obSelf.isHint("login"))},position:function(){return obSelf.getPosition("login")}}];this.obValidator=new RM_Form_Popup_Validator(this.form,{submit:function(form,error){obSelf.hideMessage();if(error){return false}else{obSelf.registration();return false}},fullCheck:[]},popups)},registration:function(){var obSelf=this;this.makeAjaxRequest("userRegistration",function(data){obSelf.regCallback(data.props);obSelf.reset()})}});var RM_Tutu_User_Form_RemindPassword=RM_Tutu_User_Form.extend({remindCallback:null,init:function(formId,obLoader,remindCallback,isHTTPS){var obSelf=this;this.form=$("#"+formId).get(0);this.obLoader=obLoader;this.remindCallback=remindCallback;this.isHTTPS=isHTTPS;this.ajaxAddress=(isHTTPS)?"ajax.https":"ajax";this.popupPosition={login:{xCoord:0,yCoord:0,width:250,arrowX:10,arrow2X:0}};var popups=[{message:function(){return lang.get("user.email_empty")},check:function(){return(!obSelf.getElement("login").val()||obSelf.isHint("login"))},position:function(){return obSelf.getPosition("login")}}];this.obValidator=new RM_Form_Popup_Validator(this.form,{submit:function(form,error){obSelf.hideMessage();if(error){return false}else{obSelf.remindPassword();return false}},fullCheck:[]},popups)},remindPassword:function(){var obSelf=this;this.makeAjaxRequest("userRemindPassword",function(data){obSelf.remindCallback(data.message);obSelf.reset()})}});var RM_Tutu_User_Badge=RM.Class.extend({ids:null,isProfile:null,isHTTPS:null,initJsCookie:null,formObjects:null,ajaxAddress:null,init:function(ids,isProfile,isHTTPS,initJsCookie){var obSelf=this;this.ids=ids;this.isProfile=isProfile;this.isHTTPS=isHTTPS;this.initJsCookie=initJsCookie;this.ajaxAddress=(isHTTPS)?"ajax.https":"ajax";$("#uFormBlock a.uFormLink").click(function(){if(this.rel){obSelf.showForm(this.rel)}return false});$("#uRegLink").attr("href","#"+obSelf.ids.regForm.divId).fancybox({showCloseButton:false,padding:0});if(!obSelf.isProfile){$("#uLogoutLink").click(function(){obSelf.initForms();obSelf.formObjects.authForm.logout();return false})}if(obSelf.initJsCookie){obSelf.initCookie(obSelf.initJsCookie)}},initCookie:function(initJsCookie){var obSelf=this;var username=getCookieValue(initJsCookie.cookieUserName);var userIdLogin=getCookieValue(initJsCookie.cookieLoginName);if(!userIdLogin){obSelf.showFormBlock();return}if(username){obSelf.showBadgeBlock(username)}else{$.get(url.get(obSelf.ajaxAddress,{},{Action:"userGetName",rand:Math.random()}),function(ajaxUsername){if(ajaxUsername){obSelf.showBadgeBlock(ajaxUsername)}else{obSelf.showFormBlock()}})}},changeUserName:function(username){$("#uName").html(username)},showBadgeBlock:function(username){var obSelf=this;$("#uFormBlock").hide();obSelf.changeUserName(username);$("#uBadgeBlock").show()},showUserProps:function(userProps){for(x in userProps){if(!$("input.userProp_"+x).val()){$("input.userProp_"+x).val(userProps[x])}}},showFormBlock:function(){var obSelf=this;$("#uBadgeBlock").hide();obSelf.changeUserName("");$("#uFormBlock").show()},showRegFormBlock:function(){$("#uRegSuccessBlock").hide();$("#uRegFormBlock").show()},showRegSuccessBlock:function(){$("#uRegFormBlock").hide();$("#uRegSuccessBlock").show()},showForm:function(block){var obSelf=this;obSelf.initForms();obSelf.hideElements();obSelf.unBindBody();if(block=="regForm"){obSelf.showRegFormBlock()}if(block!=="authForm"){var login=obSelf.formObjects.authForm.getValue("login");if(login){for(x in obSelf.formObjects){if(x!=="authForm"){obSelf.formObjects[x].setValue("login",login)}}}}$("#"+obSelf.ids[block].divId).show().addClass("show-ie-effects");obSelf.bindBody()},hidePopups:function(){$("div.overformPopup").hide()},hideForms:function(){$("div.uFormBlock").hide().removeClass("show-ie-effects")},hideFancybox:function(){$.fancybox.close()
},bindBody:function(username){var obSelf=this;$("#uFormBlock div").click(function(event){event=event||window.event;event.stopPropagation?event.stopPropagation():(event.cancelBubble=true)});$("body").bind("click.authform",function(){obSelf.clickOnBody(username)})},clickOnBody:function(username){var obSelf=this;if(username){obSelf.showBadgeBlock(username)}obSelf.hideElements();obSelf.unBindBody()},hideElements:function(){var obSelf=this;obSelf.hidePopups();obSelf.hideForms();obSelf.hideFancybox()},unBindBody:function(){var obSelf=this;$("body").unbind("click.authform")},initForms:function(){var obSelf=this;if(!obSelf.formObjects){obSelf.formObjects={authForm:new RM_Tutu_User_Form_Auth(obSelf.ids.authForm.formId,new RM_Ajax_Loader("loginLoader"),function(userProps){obSelf.hideElements();obSelf.unBindBody();obSelf.showBadgeBlock(userProps.username);obSelf.showUserProps(userProps)},function(){obSelf.showFormBlock()},obSelf.isHTTPS),regForm:new RM_Tutu_User_Form_Registration(obSelf.ids.regForm.formId,new RM_Ajax_Loader("regLoader"),function(userProps){obSelf.unBindBody();obSelf.showRegSuccessBlock();obSelf.bindBody(userProps.username);obSelf.showUserProps(userProps);$("#uRegSuccessBlock a.close-link").unbind("click.authform").bind("click",function(){obSelf.hideElements();obSelf.unBindBody();obSelf.showBadgeBlock(userProps.username);return false})},obSelf.isHTTPS),remindForm:new RM_Tutu_User_Form_RemindPassword(obSelf.ids.remindForm.formId,new RM_Ajax_Loader("remindLoader"),function(text){obSelf.hideElements();$("#uRemindOkText").html(text);$("#uRemindOkBlock").show()},obSelf.isHTTPS)};$("div.uFormBlock a.close-link").bind("click.authform",function(){obSelf.hideElements();obSelf.unBindBody();return false});$("input[rel=authformInput]").inputTitle()}}});var RM_Tutu_User_Form_ChangePassword=RM_Tutu_User_Form.extend({options:{},init:function(formId,obMessage,obLoader,options){var obSelf=this;this.form=$("#"+formId).get(0);this.obMessage=obMessage;this.obLoader=obLoader;this.ajaxAddress="ajax.https";this.popupPosition={"default":{xCoord:90,yCoord:-5,width:200,arrowX:10,arrow2X:0}};var popups=[{message:function(){return lang.get("user.current_password_empty")},check:function(){return(!obSelf.getElement("current_password").val())},position:function(){return obSelf.getPosition("current_password")}},{message:function(){return lang.get("user.new_password_empty")},check:function(){return(!obSelf.getElement("password").val())},position:function(){return obSelf.getPosition("password")}},{message:function(){return lang.get("user.password_confirm_empty")},check:function(){return(!obSelf.getElement("password_confirm").val())},position:function(){return obSelf.getPosition("password_confirm")}}];this.obValidator=new RM_Form_Popup_Validator(this.form,{submit:function(form,error){obSelf.hideMessage();if(error){return false}else{obSelf.changePassword();return false}},fullCheck:["input[type=text],input[type=password]"]},popups)},changePassword:function(){var obSelf=this;this.makeAjaxRequest("userChangePassword",function(data){obSelf.showMessage(data.message);obSelf.reset()})}});var RM_Tutu_User_Form_EditData=RM_Tutu_User_Form.extend({successCallback:null,options:{},init:function(formId,obMessage,obLoader,successCallback,options){var obSelf=this;this.form=$("#"+formId).get(0);this.obMessage=obMessage;this.obLoader=obLoader;this.successCallback=successCallback;this.options=$.extend(this.options,options);this.ajaxAddress="ajax.https";this.popupPosition={birthday_day:{xCoord:5,yCoord:-5,width:200,arrowX:10,arrow2X:0},birthday_month:{xCoord:50,yCoord:-5,width:200,arrowX:10,arrow2X:0},birthday_year:{xCoord:20,yCoord:-5,width:200,arrowX:10,arrow2X:0},"default":{xCoord:170,yCoord:-5,width:200,arrowX:10,arrow2X:0}};var popups=[{message:function(){return lang.get("user.birthday_not_full")},check:function(){return((obSelf.getElement("birthday_year").val()!=""||obSelf.getElement("birthday_month").val()!="")&&obSelf.getElement("birthday_day").val()=="")},position:function(){return obSelf.getPosition("birthday_day")}},{message:function(){return lang.get("user.birthday_not_full")},check:function(){return((obSelf.getElement("birthday_year").val()!=""||obSelf.getElement("birthday_day").val()!="")&&obSelf.getElement("birthday_month").val()=="")},position:function(){return obSelf.getPosition("birthday_month")}},{message:function(){return lang.get("user.birthday_not_full")},check:function(){return((obSelf.getElement("birthday_month").val()!=""||obSelf.getElement("birthday_day").val()!="")&&obSelf.getElement("birthday_year").val()=="")},position:function(){return obSelf.getPosition("birthday_year")}}];this.obValidator=new RM_Form_Popup_Validator(this.form,{submit:function(form,error){obSelf.hideMessage();if(error){return false}else{obSelf.editData();return false}},fullCheck:["select,input[type=text]"]},popups)},editData:function(){var obSelf=this;this.makeAjaxRequest("userEditData",function(data){obSelf.remember();obSelf.refreshUserProps(data.props);obSelf.showMessage(data.message);
obSelf.successCallback(data.props.username)})},refreshUserProps:function(props){this.options.userProps.each(function(){if(props[this.id]){$(this).html(props[this.id]).show()}else{$(this).html("").hide()}})}});